// * This code is licensed under:
// * JRunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de). 
// * All rights reserved.

package JRunMC.ui;


import JRunMC.util.*;

// Imports
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.util.StringTokenizer;
import java.util.Vector;

class EditorProcess
	extends 	JDialog  {


         public static final long serialVersionUID = 121;


	// Instance attributes used in this example
	private	JPanel		topPanel;
	private	JList		listbox;
	private	JButton		exButton;
	private	JButton		removeButton;
        private Vector<String>  listData; // list with the names
        private Vector<String>  listID; // list with ID of processes
        private JTextField      dataField;
	private static int MyProc=-1; 
	private	JScrollPane scrollPane;
        private Timer timerProc;  // to run
        private int delay = 0;   // delay for 5 sec.
        private int period = 2000;  // repeat every sec.


	// Constructor of main frame
	public EditorProcess()
	{

                super( Global.mainFrame );
                setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);

		// Set the frame characteristics
		setTitle( "Process monitor" );
		setSize( 420, 200 );
		setBackground( Color.gray );

		// Create a panel to hold all other components
		topPanel = new JPanel();
		topPanel.setLayout( new BorderLayout() );
		getContentPane().add( topPanel );

// Create the data model for this example
                listData = new Vector<String>();
		listID = new Vector<String>();

                // Create a new listbox control
                listbox = new JList( listData );
                listbox.addListSelectionListener(new ValueReporter());
		
		// Add the listbox to a scrolling pane
		scrollPane = new JScrollPane();
		scrollPane.getViewport().add( listbox );
		topPanel.add( scrollPane, BorderLayout.CENTER );

		CreateDataEntryPanel();

//   define timer for Log file
     timerProc = new Timer(period, taskCheckProc);
     timerProc.setInitialDelay(delay);
     timerProc.setRepeats(true);
     timerProc.start();

      pack();

	} // end main class 


	public void CreateDataEntryPanel()
	{
		// Create a panel to hold all other components
		JPanel dataPanel = new JPanel();
		dataPanel.setLayout( new BorderLayout() );
		topPanel.add( dataPanel, BorderLayout.SOUTH );

		// Create some function buttons
	 exButton = new JButton( "Exit" );
         dataPanel.add( exButton, BorderLayout.WEST );

	 
	 
         exButton.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
          JOptionPane dialog1 = new JOptionPane();
          int ask=dialog1.showConfirmDialog(dialog1, "Exit Process editor?",
          "Question", JOptionPane.YES_NO_OPTION,
           JOptionPane.QUESTION_MESSAGE, null );
           if (ask == JOptionPane.YES_OPTION) { timerProc.stop(); setVisible(false); dispose();}
        }  });


	 removeButton = new JButton( "Delete process" );
	 dataPanel.add( removeButton, BorderLayout.EAST );
          removeButton.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
                       int selection = MyProc;
                        if( selection >= 0 )
                        {
                                // Add this item to the list and refresh
                                listData.removeElementAt( selection );
                                listbox.setListData( listData );
                                scrollPane.revalidate();
                                scrollPane.repaint();
				
				// System.out.print(listID.elementAt( selection )); // print ID
				// kill this process 
				String sh = "bash"; String cop = "-c";
                                String cmd1 = "kill -9 "+(String)listID.elementAt( selection );
                                String[] exe1 = new String[] {sh, cop, cmd1};
                               try { Process p = Runtime.getRuntime().exec(exe1);
                                } catch (Exception err) {err.printStackTrace(); }
                                
				dataField.setText("");
                                // As a nice touch, select the next item
                                if( selection >= listData.size() )
                                        selection = listData.size() - 1;
                                listbox.setSelectedIndex( selection );
                        } 
         }  });

		
	 // Create a text field for data entry and display
                dataField = new JTextField();
                dataField.setPreferredSize(new java.awt.Dimension(160, 25));
                dataField.setMinimumSize(new java.awt.Dimension(50, 25));
                dataPanel.add( dataField, BorderLayout.CENTER );
	        dataField.setEditable(false);
		
		      
	}

// Handler for button presses
      public class ValueReporter implements ListSelectionListener {
      public void valueChanged(ListSelectionEvent event) {
      if (!event.getValueIsAdjusting() &&
          listbox.getSelectedIndex()>=0 &&
          listbox.getSelectedIndex()<=listData.size() ) { 
                       MyProc = listbox.getSelectedIndex();
	                dataField.setText(""); 
                        if  (listData.elementAt(MyProc)  != null ) { 
 			dataField.setText((String)listData.elementAt(MyProc) ); } 
				
                }
       } }
	      
	

	
	
	

// timer task
  ActionListener taskCheckProc = new ActionListener() {
            boolean alreadyDisposed = false;
            public void actionPerformed(ActionEvent eProc) {

 // get processes and clear
    listData.clear();
    listID.clear();
    try {

    String sh = "bash"; String cop = "-c";
    String cmd1 = "$RUNMC/main/scripts/show_process.sh";
    String[] exe1 = new String[] {sh, cop, cmd1};
    Process p = Runtime.getRuntime().exec(exe1); // invoke shell

    PrintWriter out = new PrintWriter(new BufferedWriter(
    new OutputStreamWriter(p.getOutputStream())));
    out.println("exit");
    out.flush();
    BufferedReader inp = new BufferedReader(
    new InputStreamReader(p.getInputStream()));
    // retrieve data from standard output stream
    String line;
    while ((line = inp.readLine()) != null) {
    // System.out.println(line);
    if (line.length()>1) {  
          // process this line
          StringTokenizer st = new StringTokenizer(line);
	   int ncount=st.countTokens(); // number of words 
	   String[] sword; sword = new String[ncount];
	   int m=0;
          // split this line
          while (st.hasMoreTokens()) { // make sure there is stuff to get
                 String tmp=""; tmp  = st.nextToken();
		  sword[m]=tmp;
                 for (int i=1; i<SetIni.exeMC.length;  i++) {   
                      if (tmp.equals(SetIni.exeMC[i]) || tmp.equals(SetIni.exeMC[i]+".exe")) {  
		                                       listData.addElement(tmp+" (ID="+sword[0]+")"); 
					               listID.addElement(sword[0]); }
					       }   // end loop over jobs
                   if (tmp.equals("ntupview") || tmp.equals("ntupview.exe")) { 
		                                       listData.addElement(tmp+" (ID="+sword[0]+")");
		                                       listID.addElement(sword[0]);} 
                   if (tmp.equals("histoview") || tmp.equals("histoview.exe")) {
		                                       listData.addElement(tmp+" (ID="+sword[0]+")"); 
		                                       listID.addElement(sword[0]);} 

		   
                  m++; // count number of words
		 } // end while over words   
      } // end if 
      } // end while	 
    inp.close(); 
    } catch (Exception err) {
     err.printStackTrace();
     };
     
          // set and repaint
          listbox.setListData( listData );
	  scrollPane.revalidate();
          scrollPane.repaint();

  };  };



// create about
   public void setInvisible() {
        setVisible(false);
   }


// create about
   public void setVisible() {

// store mainframe dimensions
    Dimension dim = Global.mainFrame.getSize();
    int w=dim.width;
    int h=dim.height;
 // Get the system resolution
    Dimension res = Toolkit.getDefaultToolkit().getScreenSize();

   // make sure the dialog is not too big
    Dimension size = new Dimension(Math.min( (int)(0.6*w),res.width),
                        Math.min((int)(0.7*h), res.height) );
    this.setSize(size);


//   Util.rightWithin ( Global.mainFrame, this );

    Util.centreWithin( Global.mainFrame, this );
    this.setVisible(true); 

   }




}
