// * This code is licensed under:
// * JRunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de). 
// * All rights reserved.

package JRunMC.ui;

import JRunMC.util.*;

import javax.swing.UIManager;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.io.*;
import javax.swing.text.*;


public class LogFileEditor{

  public static final long serialVersionUID = 117;


  boolean packFrame = false;

  private Timer timerLog;  // to run
  private int delay = 0;   // delay for 5 sec.
  private int period = 2000;  // repeat every sec.
  private static int  ReadNytes=0;
  final String  fileName=SetIni.MOutput+".log";

  //Construct the application
 public LogFileEditor() {
    EditFrame frame = new EditFrame();
    if (packFrame) {
      frame.pack();
    }
    else {
      frame.validate();
    }
    //Center the window
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = frame.getSize();
    if (frameSize.height > screenSize.height) {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width) {
      frameSize.width = screenSize.width;
    }
    frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    frame.setVisible(true);
  }

  //Main method
  public static void main(String[] args) {
    try {
      UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    new LogFileEditor();
  }


public class EditFrame extends JFrame {

   public static final long serialVersionUID = 118;

  JPanel contentPane;
  JMenuBar menuBar1 = new JMenuBar();
  JMenu menuFile = new JMenu();
  JMenuItem menuFileExit = new JMenuItem();
  ImageIcon image1;
  ImageIcon image2;
  ImageIcon image3;
  JLabel statusBar = new JLabel();
  BorderLayout borderLayout1 = new BorderLayout();
  JScrollPane jScrollPane1 = new JScrollPane();
  JTextArea jTextArea1 = new JTextArea();
  JMenuItem jMenuItem1 = new JMenuItem();
  JMenuItem jMenuItem2 = new JMenuItem();
  JMenuItem jMenuItem3 = new JMenuItem();
  JMenuItem jMenuItem4 = new JMenuItem();
  JMenu jMenu1 = new JMenu();
  JMenuItem jMenuItem6 = new JMenuItem();
  JMenuItem jMenuItem7 = new JMenuItem();
  JMenuItem jMenuItem8 = new JMenuItem();
  JFileChooser jFileChooser1 = new JFileChooser();
  String currFileName = null;  // Full path with filename. null means new/untitled.
  boolean dirty = false;
  Document document1;

  //Construct the frame
  public EditFrame() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
      updateCaption();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception  {
    contentPane = (JPanel) this.getContentPane();
    document1 = jTextArea1.getDocument();
    contentPane.setLayout(borderLayout1);
    this.setSize(new Dimension(600, 400));
    this.setTitle("Log File editor");
    statusBar.setText(" ");
    menuFile.setText("File");
    menuFileExit.setText("Exit");
    menuFileExit.addActionListener(new EditFrame_menuFileExit_ActionAdapter(this));
    jTextArea1.setLineWrap(true);
    jTextArea1.setWrapStyleWord(true);
    jTextArea1.setBackground(Color.white);
    jMenuItem1.setText("New");
    jMenuItem1.addActionListener(new EditFrame_jMenuItem1_actionAdapter(this));
    jMenuItem2.setText("Open");
    jMenuItem2.addActionListener(new EditFrame_jMenuItem2_actionAdapter(this));
    jMenuItem3.setText("Save");
    jMenuItem3.addActionListener(new EditFrame_jMenuItem3_actionAdapter(this));
    jMenuItem4.setText("Save As");
    jMenuItem4.addActionListener(new EditFrame_jMenuItem4_actionAdapter(this));
    jMenu1.setText("Edit");
    jMenuItem6.setText("Fonts");
    jMenuItem6.addActionListener(new EditFrame_jMenuItem6_actionAdapter(this));
    jMenuItem7.setText("Background color");
    jMenuItem7.addActionListener(new EditFrame_jMenuItem7_actionAdapter(this));
    jMenuItem8.setText("Foreground color");
    jMenuItem8.addActionListener(new EditFrame_jMenuItem8_actionAdapter(this));

    document1.addDocumentListener(new EditFrame_document1_documentAdapter(this));
    menuFile.add(jMenuItem1);
    menuFile.add(jMenuItem2);
    menuFile.add(jMenuItem3);
    menuFile.add(jMenuItem4);
    menuFile.addSeparator();
    menuFile.add(menuFileExit);
    menuBar1.add(menuFile);
    menuBar1.add(jMenu1);
    this.setJMenuBar(menuBar1);
    contentPane.add(statusBar, BorderLayout.SOUTH);
    contentPane.add(jScrollPane1, BorderLayout.CENTER);
    jScrollPane1.getViewport().add(jTextArea1, null);
    jMenu1.add(jMenuItem7);
    jMenu1.add(jMenuItem8);
    jMenu1.add(jMenuItem6);
    jTextArea1.setFont(SetEnv.FontBold);


//   define timer for Log file
     timerLog = new Timer(period, taskCheckLog);
     timerLog.setInitialDelay(delay);
     timerLog.setRepeats(true);
     timerLog.start();

/*
    // put log file
    try {
      File file = new File(fileName);
      int  size = (int)file.length();

      FileInputStream f0 = new FileInputStream(file);
      ReadNytes =f0.available(); // store initial bytes  
 
      // Set to zero a counter for counting the number of
      // characters that have been read from the file.
      int chars_read = 0;
      // Create an input reader based on the file, so we can read its data.
      // FileReader handles international character encoding conversions.
      FileReader in = new FileReader(file);
      // Create a character array of the size 
      char[] data = new char[size];
      // Read all available characters into the buffer.
      while(in.ready()) {
        // Increment the count for each character read,
        // and accumulate them in the data buffer.
        chars_read += in.read(data, chars_read, size - chars_read);
      }
      in.close();
      // Create a temporary string containing the data,
      // and set the string into the JTextArea.
      jTextArea1.setText(new String(data, 0, chars_read));

//   define timer for Log file 
     timerLog = new Timer(period, taskCheckLog);
     timerLog.setInitialDelay(delay);
     timerLog.setRepeats(true);
     timerLog.start(); 

     // close streem 
     f0.close();

    }
    catch (IOException e)
    {
      System.out.println("Error opening "+fileName);
    }
         
 */
   
    
  }



  // timer task
  ActionListener taskCheckLog = new ActionListener() {
            boolean alreadyDisposed = false;
            public void actionPerformed(ActionEvent eLog) {

            String thisLine;

            try {

             File f1 = new File(fileName);
             int  current_size = (int)f1.length();
             int delta=current_size-ReadNytes; 

// if incraese in the size 
      if (delta>0) {
//      System.out.println("current size "+current_size+ "  Old size="+ReadNytes);   
      FileReader inx = new FileReader(fileName); 
      char[] data = new char[delta];

      // Read all available characters into the buffer.
      int chars_read = 0;
      long nn=inx.skip(ReadNytes);
      chars_read = inx.read(data, 0, delta); 
      jTextArea1.append(new String(data, 0, delta));

      inx.close();
      ReadNytes=current_size; // put old  size
       }
// if a new file - read all 
      if (delta<-1) {
      FileReader inx = new FileReader(fileName);
      char[] data = new char[current_size];
      // Read all available characters into the buffer.
      int chars_read = 0;
     //  long nn=inx.skip(0);
      chars_read = inx.read(data, 0, current_size);
      jTextArea1.setText(new String(data, 0, current_size));
      inx.close();
      ReadNytes=current_size; // put old  size
      }



      }
      catch (IOException e1)
      {
//       System.out.println("Error opening "+fileName);
       }


  };  }; 









  // Handle the File|Open menu or button, invoking okToAbandon and openFile
  // as needed.
  void fileOpen() {
    if (!okToAbandon()) {
      return;
    }
    // Use the OPEN version of the dialog, test return for Approve/Cancel
    if (JFileChooser.APPROVE_OPTION == jFileChooser1.showOpenDialog(this)) {
      // Call openFile to attempt to load the text from file into TextArea
      openFile(jFileChooser1.getSelectedFile().getPath());
    }
    this.repaint();
  }

  // Open named file; read text from file into jTextArea1; report to statusBar.
  void openFile(String fileName)  {
    try
    {
      // Open a file of the given name.
      File file = new File(fileName);

      // Get the size of the opened file.
      int size = (int)file.length();

      // Set to zero a counter for counting the number of
      // characters that have been read from the file.
      int chars_read = 0;

      // Create an input reader based on the file, so we can read its data.
      // FileReader handles international character encoding conversions.
      FileReader in = new FileReader(file);

      // Create a character array of the size of the file,
      // to use as a data buffer, into which we will read
      // the text data.
      char[] data = new char[size];

      // Read all available characters into the buffer.
      while(in.ready()) {
        // Increment the count for each character read,
        // and accumulate them in the data buffer.
        chars_read += in.read(data, chars_read, size - chars_read);
      }
      in.close();

      // Create a temporary string containing the data,
      // and set the string into the JTextArea.
      jTextArea1.setText(new String(data, 0, chars_read));

      // Cache the currently opened filename for use at save time...
      this.currFileName = fileName;
      // ...and mark the edit session as being clean
      this.dirty = false;

      // Display the name of the opened directory+file in the statusBar.
      statusBar.setText("Opened "+fileName);
      updateCaption();
    }
    catch (IOException e)
    {
      statusBar.setText("Error opening "+fileName);
    }
  }

    // Save current file; handle not yet having a filename; report to statusBar.
  boolean saveFile() {

    // Handle the case where we don't have a file name yet.
    if (currFileName == null) {
      return saveAsFile();
    }

    try
    {
      // Open a file of the current name.
      File file = new File (currFileName);

      // Create an output writer that will write to that file.
      // FileWriter handles international characters encoding conversions.
      FileWriter out = new FileWriter(file);
      String text = jTextArea1.getText();
      out.write(text);
      out.close();
      this.dirty = false;

      // Display the name of the saved directory+file in the statusBar.
      statusBar.setText("Saved to " + currFileName);
      updateCaption();
      return true;
    }
    catch (IOException e) {
      statusBar.setText("Error saving " + currFileName);
    }
    return false;
  }

  // Save current file, asking user for new destination name.
  // Report to statuBar.
  boolean saveAsFile() {
    this.repaint();
    // Use the SAVE version of the dialog, test return for Approve/Cancel
    if (JFileChooser.APPROVE_OPTION == jFileChooser1.showSaveDialog(this)) {
      // Set the current file name to the user's selection,
      // then do a regular saveFile
      currFileName = jFileChooser1.getSelectedFile().getPath();
      //repaints menu after item is selected
      this.repaint();
      return saveFile();
    }
    else {
      this.repaint();
      return false;
    }
  }

  // Check if file is dirty.
  // If so get user to make a "Save? yes/no/cancel" decision.
  boolean okToAbandon() {
    if (!dirty) {
      return true;
    }
    int value =  JOptionPane.showConfirmDialog(this, "Save changes?",
                                         "Text Edit", JOptionPane.YES_NO_CANCEL_OPTION) ;

    switch (value) {
       case JOptionPane.YES_OPTION:
         // yes, please save changes
         return saveFile();
       case JOptionPane.NO_OPTION:
         // no, abandon edits
         // i.e. return true without saving
         return true;
       case JOptionPane.CANCEL_OPTION:
       default:
         // cancel
         return false;
    }
  }

    // Update the caption of the application to show the filename and its dirty state.
  void updateCaption() {
    String caption;

    if (currFileName == null) {
       // synthesize the "Untitled" name if no name yet.
       caption = "Untitled";
    }
    else {
      caption = currFileName;
    }

    // add a "*" in the caption if the file is dirty.
    if (dirty) {
      caption = "* " + caption;
    }
    caption = "Text Editor - " + caption;
    this.setTitle(caption);
  }


  //File | Exit action performed
  public void fileExit_actionPerformed(ActionEvent e) {
    if (okToAbandon()) {
       // stop timer  
       timerLog.stop();
     // System.exit(0);
      setVisible(false);
      dispose(); 

    }
  }


  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      fileExit_actionPerformed(null);
    }
  }


  void jMenuItem6_actionPerformed(ActionEvent e) {
    Font f = FontChooser.showDialog(EditFrame.this,
                                    "Choose font",
                                    jTextArea1.getFont());
    if (f != null) {
    jTextArea1.setFont(f);
    }
   //repaints menu after item is selected
    this.repaint();
  }

  void jMenuItem7_actionPerformed(ActionEvent e) {
    // Handle the "Background Color" menu item
    Color color = JColorChooser.showDialog(this,"Background color",jTextArea1.getBackground());
    if (color != null) {
     jTextArea1.setBackground(color);
    }
    //repaints menu after item is selected
    this.repaint();
  }


  void jMenuItem8_actionPerformed(ActionEvent e) {
    // Handle the "Background Color" menu item
    Color color = JColorChooser.showDialog(this,"Foreground  color",jTextArea1.getForeground());
    if (color != null) {
     jTextArea1.setForeground(color);
    }
    //repaints menu after item is selected
    this.repaint();
  }



  void jMenuItem1_actionPerformed(ActionEvent e) {
    // Handle the File|New menu item.
    if (okToAbandon()) {
      // clears the text of the TextArea
      jTextArea1.setText("");
      // clear the current filename and set the file as clean:
      currFileName = null;
      dirty = false;
      updateCaption();
    }
  }

  void jMenuItem2_actionPerformed(ActionEvent e) {
    //Handle the File|Open menu item.
    fileOpen();
  }

  void jMenuItem3_actionPerformed(ActionEvent e) {
    //Handle the File|Save menu item.
    saveFile();
  }

  void jMenuItem4_actionPerformed(ActionEvent e) {
    //Handle the File|Save As menu item.
    saveAsFile();
  }

  void document1_changedUpdate(DocumentEvent e) {
    if (!dirty) {
      dirty = true;
      updateCaption();
    }
  }

  void document1_insertUpdate(DocumentEvent e) {
    if (!dirty) {
      dirty = true;
      updateCaption();
    }
  }

  void document1_removeUpdate(DocumentEvent e) {
    if (!dirty) {
      dirty = true;
      updateCaption();
    }
  }
}

class EditFrame_menuFileExit_ActionAdapter implements ActionListener {
  EditFrame adaptee;

  EditFrame_menuFileExit_ActionAdapter(EditFrame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.fileExit_actionPerformed(e);
  }
}


class EditFrame_jMenuItem6_actionAdapter implements java.awt.event.ActionListener {
  EditFrame adaptee;

  EditFrame_jMenuItem6_actionAdapter(EditFrame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuItem6_actionPerformed(e);
  }
}

class EditFrame_jMenuItem7_actionAdapter implements java.awt.event.ActionListener {
  EditFrame adaptee;

  EditFrame_jMenuItem7_actionAdapter(EditFrame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuItem7_actionPerformed(e);
  }
}


class EditFrame_jMenuItem8_actionAdapter implements java.awt.event.ActionListener {
  EditFrame adaptee;

  EditFrame_jMenuItem8_actionAdapter(EditFrame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuItem8_actionPerformed(e);
  }
}






class EditFrame_jMenuItem1_actionAdapter implements java.awt.event.ActionListener {
  EditFrame adaptee;

  EditFrame_jMenuItem1_actionAdapter(EditFrame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuItem1_actionPerformed(e);
  }
}

class EditFrame_jMenuItem2_actionAdapter implements java.awt.event.ActionListener {
  EditFrame adaptee;

  EditFrame_jMenuItem2_actionAdapter(EditFrame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuItem2_actionPerformed(e);
  }
}

class EditFrame_jMenuItem3_actionAdapter implements java.awt.event.ActionListener {
  EditFrame adaptee;

  EditFrame_jMenuItem3_actionAdapter(EditFrame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuItem3_actionPerformed(e);
  }
}

class EditFrame_jMenuItem4_actionAdapter implements java.awt.event.ActionListener {
  EditFrame adaptee;

  EditFrame_jMenuItem4_actionAdapter(EditFrame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuItem4_actionPerformed(e);
  }
}

class EditFrame_document1_documentAdapter implements javax.swing.event.DocumentListener {
  EditFrame adaptee;

  EditFrame_document1_documentAdapter(EditFrame adaptee) {
    this.adaptee = adaptee;
  }

  public void changedUpdate(DocumentEvent e) {
    adaptee.document1_changedUpdate(e);
  }

  public void insertUpdate(DocumentEvent e) {
    adaptee.document1_insertUpdate(e);
  }

  public void removeUpdate(DocumentEvent e) {
    adaptee.document1_removeUpdate(e);
  }
}


} // end main class
