/* This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/




//(C)2000-2001 Mark Beynon
//mark@jpedit.co.uk
//http://www.jpedit.co.uk

package com.javac;


import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

import javax.swing.text.BadLocationException;

import com.jpe.*;
import com.jpe.Constants;
import com.filefilters.*;
import com.utils.*;

public class JavacDialog3 extends JDialog implements ActionListener, MouseListener, ItemListener, Constants
{
  // Constructor
  public JavacDialog3(jpe jpe)
  {
    super(jpe, "Java Options", false);

    this.jpe = jpe;
    this.setResizable(false);

    jFileChooser.addChoosableFileFilter(new filterTypeZip());
    jFileChooser.addChoosableFileFilter(new filterTypeJar());

    Utils = new Utils(jpe);

    Icon open = new ImageIcon("images" + fileSep + "open.gif");
    Icon clear = new ImageIcon("images" + fileSep + "del.gif");
		Icon close = new ImageIcon("images" + fileSep + "close.gif");

	  JPanel buttonPane = new JPanel();
		buttonPane.setLayout(new FlowLayout(FlowLayout.CENTER, 5, 5));
	  buttonPane.add(jbtOK = createButton("Ok", "OK"));
	  buttonPane.add(jbtClose = createButton("Cancel", "Cancel"));

		jtf = new JTextField(12);

		appPanel3 = new JPanel();
		appPanel3.setLayout(new BoxLayout(appPanel3, BoxLayout.X_AXIS));
		appPanel3.add(Path3 = new JTextField());
		appPanel3.add(Box.createGlue());
		appPanel3.add(br3 = createButton(open, "browse"));
		appPanel3.add(Box.createGlue());
		appPanel3.add(br4 = createButton(clear, "Clear"));
		Path3.setFont(SYSTEM_FONT);
		Path3.setEditable(false);
		Path3.setPreferredSize(new Dimension(200,18));

		appPanel4 = new JPanel();
		appPanel4.setLayout(new BoxLayout(appPanel4, BoxLayout.X_AXIS));
		appPanel4.add(useclass = createCheckBox("use classpath"));
		appPanel4.add(verbose  = createCheckBox("verbose"));
		appPanel4.add(javaw    = createCheckBox("javaw"));
		appPanel4.add(jar      = createCheckBox("-jar"));
		appPanel4.add(Box.createGlue());

		appPanel6 = new JPanel();
		appPanel6.setLayout(new BoxLayout(appPanel6, BoxLayout.X_AXIS));
		appPanel6.add(Path6 = new JTextField());
		appPanel6.add(Box.createGlue());
		Path6.setEditable(false);
		Path6.setFont(SYSTEM_FONT);
		Path6.setPreferredSize(new Dimension(200,18));

		Panel3 = new JPanel();
		Panel3.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(), "-directory", 1, 1, SYSTEM_FONT, Color.black));
		Panel3.setLayout(new BoxLayout(Panel3, BoxLayout.Y_AXIS));
		Panel3.add(Box.createGlue());
		Panel3.add(appPanel3);


		Panel6 = new JPanel();
		Panel6.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(), "ClassPath", 1, 1, SYSTEM_FONT, Color.black));
		Panel6.setLayout(new BoxLayout(Panel6, BoxLayout.Y_AXIS));
		Panel6.add(Box.createGlue());
		Panel6.add(appPanel6);




		JPanel southPane = new JPanel();
		southPane.setBorder(BorderFactory.createEtchedBorder());
		southPane.setLayout(new BoxLayout(southPane, BoxLayout.Y_AXIS));
		//southPane.add(jtfPane);
		southPane.add(Box.createGlue());

		JPanel topbutPanel = new JPanel();
		topbutPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
		topbutPanel.add(depcheck = createCheckBox("-deprecation"));
		topbutPanel.add(verbcheck = createCheckBox("-verbose"));
	  topbutPanel.add(gnonecheck = createCheckBox("g:none"));

    JPanel midbutPanel = new JPanel();
		midbutPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
		midbutPanel.add(nowarncheck = createCheckBox("-nowarn"));
		midbutPanel.add(gcheck = createCheckBox("-g"));
		midbutPanel.add(ocheck = createCheckBox("-O"));

		Panel5 = new JPanel();
		Panel5.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(), "javac options", 1, 1, SYSTEM_FONT, Color.black));
		Panel5.setLayout(new BoxLayout(Panel5, BoxLayout.Y_AXIS));
		Panel5.add(Box.createGlue());
		Panel5.add(topbutPanel);
		Panel5.add(Box.createGlue());
		Panel5.add(midbutPanel);

    Panel4 = new JPanel();
		Panel4.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(), "java options", 1, 1, SYSTEM_FONT, Color.black));
		Panel4.setLayout(new BoxLayout(Panel4, BoxLayout.Y_AXIS));

		Panel4.add(Box.createGlue());
		Panel4.add(appPanel4);
		Panel4.add(Box.createGlue());

		//Panel7 = new JPanel();
		//Panel7.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(), "System Parameters", 1, 1, SYSTEM_FONT, Color.black));
		//Panel7.setLayout(new BoxLayout(Panel7, BoxLayout.Y_AXIS));
		//Panel7.add(Box.createGlue());
		//Panel7.add(jtfSystemParam = new JTextField(""));
		//Panel7.add(Box.createGlue());
    //jtfSystemParam.setPreferredSize(new Dimension(200,18));


		southPane.add(Panel3);
		southPane.add(Box.createGlue());
		southPane.add(Panel6);
		southPane.add(Box.createGlue());
		southPane.add(Panel5);
		southPane.add(Box.createGlue());
		southPane.add(Panel4);
		//southPane.add(Box.createGlue());
		//southPane.add(Panel7);
		southPane.add(Box.createGlue());
		southPane.add(buttonPane);


    getContentPane().add(southPane, BorderLayout.SOUTH);

    // Code to create the data input panel...
    JPanel dataPane = new JPanel();
    dataPane.setBorder(BorderFactory.createCompoundBorder(
    BorderFactory.createLineBorder(Color.black),
    BorderFactory.createEmptyBorder(5, 5, 5, 5)));


    JLabel findlabel = new JLabel("Javac classpath");
    findlabel.setFont(SYSTEM_FONT);
    JPanel Labels = new JPanel();
    Labels.setLayout(new FlowLayout(FlowLayout.CENTER));
    Labels.add(findlabel);

    getContentPane().add(Labels, BorderLayout.NORTH);

    addMenu = new JMenu("add -classpath");
    addMenu.setFont(SYSTEM_FONT);
    addMenu.add(jmiAddClasspathArch = new JMenuItem("Add jar, zip"));
    addMenu.add(jmiAddClasspathDir  = new JMenuItem("Add dir path"));

		jmiAddClasspathArch.setFont(SYSTEM_FONT);
		jmiAddClasspathDir.setFont(SYSTEM_FONT);

		jmiAddClasspathArch.addActionListener(this);
		jmiAddClasspathDir.addActionListener(this);


		JMenu classpath = new JMenu("File");
		classpath.setFont(SYSTEM_FONT);
		classpath.add(addMenu);
		classpath.add(jmiRemoveClasspath = new JMenuItem("Remove -classpath"));

		jmiRemoveClasspath.setFont(SYSTEM_FONT);
		jmiRemoveClasspath.addActionListener(this);

    JMenuBar jmb = new JMenuBar();
		setJMenuBar(jmb);
		jmb.add(classpath);


    vector = new Vector();

	  jta = new mbJTextArea();

	  jta.setPreferredSize(new Dimension(250,75));
	  jta.getPainter().setFont(SYSTEM_FONT);
	  jta.setTokenMarker(null);
    jta.setCaretVisible(false);
    jta.getPainter().setCaretColor(Color.lightGray);
    jta.getPainter().setLineHighlightEnabled(true);
    jta.getPainter().setLineHighlightColor(Color.lightGray);
    jta.getPainter().setSelectionColor(Color.white);
    jta.getPainter().addMouseListener(this);
    jta.setRequestFocusEnabled(true);
    jta.setEditable(false);


    JavaList = new JPanel();
    JavaList.add(jta);
    dataPane.add(JavaList);

    getContentPane().add(dataPane, BorderLayout.CENTER);
    pack();
    setVisible(false);
    outString = new String("");

    Options = new String();
		gap = new String(" ");

		depCheck    = false;
		gCheck      = false;
		oCheck      = false;
		verbCheck   = false;
		gnoneCheck  = false;
		nowarnCheck = false;
		useClass    = false;
		verBose     = false;
		javaW       = false;
		jaR         = false;
  }

  private JButton createButton(String label, String tooltip)
  {
    JButton button = new JButton(label);
    button.setFont(SYSTEM_FONT);
    button.setToolTipText(tooltip);
    button.setPreferredSize(new Dimension(70,18));
    button.addActionListener(this);
    return button;
  }

	private JButton createButton(Icon icon, String tooltip)
	{
		JButton button = new JButton(icon);
		button.setFont(SYSTEM_FONT);
		button.setToolTipText(tooltip);
		button.addActionListener(this);
		button.setPreferredSize(new Dimension(20,18));
		return button;
	}

	JCheckBox createCheckBox(String label)
	{
		JCheckBox jcb = new JCheckBox(label);
		jcb.setFont(SYSTEM_FONT);
		jcb.addItemListener(this);
		return jcb;
	}


	public void mousePressed(MouseEvent e)  {}
	public void mouseReleased(MouseEvent e) {}
	public void mouseEntered(MouseEvent e)  {}
	public void mouseExited(MouseEvent e)   {}
	public void mouseClicked (MouseEvent e) {}




	public void itemStateChanged(ItemEvent e)
	{
		if(javaw.isSelected())
		{
			jar.setSelected (false);

		}


		if(jar.isSelected())
		{
			javaw.setSelected (false);
	  }


   }



	protected void processWindowEvent(WindowEvent e)
	{
		if(e.getID() == WindowEvent.WINDOW_CLOSING)
		{
			cancel();
		}
		super.processWindowEvent(e);
	}

	void cancel()
	{
		this.setVisible(false);
	}



	private void updateClasspath()
  {
		//Utils.userMessage("Vector size", Integer.toString(vector.size()), 1);

  	int i, count = vector.size();
		Object[] array = vector.toArray();
		Path6.setText("");
		jta.setText("");

    if (vector.size() < 1)
    {
			Path6.setText("");
		  jta.setText("");
		}
		else
		{
			for (i=0; i < count; ++i)
			{
				Path6.setText(Path6.getText() + array[i].toString() + ";");
				jta.append(array[i].toString() + ";\n");
			}

    }

    //Utils.userMessage("Setting Classpath", Path6.getText(), 1);

		jpe.setClasspath(Path6.getText());
  }


    public void setClassPath()
    {
			//Utils.userMessage("In setClasspath", jpe.getClasspath(), 1);

      String s = jpe.getClasspath();
      Path6.setText("");
      vector.clear();
      jta.setText("");


      if (s.length() > 0)
      {
      	StringTokenizer str = new StringTokenizer(s, ";", false);

			  while (str.hasMoreTokens())
			 	{
			 		String a = str.nextToken();
			 		vector.add(a);
			 		Path6.setText(Path6.getText() + a + ";");
			 		jta.append(a + ";\n");
			 		jta.setCaretPosition(0);
			  }

		  }
    }


    public void setJavaOptions()
		{
			//Utils.userMessage("In setJavaOptions", jpe.getJavaOptions(), 1);

			Vector vector = new Vector();

			String s = jpe.getJavaOptions();

			if (s.length() > 0)
			{
				StringTokenizer str = new StringTokenizer(s, " ", false);

				while (str.hasMoreTokens())
				{
					String a = str.nextToken();

					vector.addElement(a);
				}

			}


      for(int i = 0; i < vector.size(); i++)
		  {

				if (vector.elementAt(i).toString().trim().equalsIgnoreCase("javaw.exe"))
				{
					javaw.setSelected(true);
					jar.setSelected (false);
			  }
				else if (vector.elementAt(i).toString().trim().equalsIgnoreCase("java.exe"))
				{
					javaw.setSelected(false);
				}
				else if (vector.elementAt(i).toString().trim().equalsIgnoreCase("-jar"))
				{
					jar.setSelected(true);
					javaw.setSelected (false);
			  }
				else if (vector.elementAt(i).toString().trim().equalsIgnoreCase("-classpath"))
				{
					useclass.setSelected(true);
				}
				else if (vector.elementAt(i).toString().trim().equalsIgnoreCase("-verbose"))
				{
					verbose.setSelected(true);
				}

        else if (vector.elementAt(i).toString().trim().equalsIgnoreCase("-D"))
				{
					jtfSystemParam.setText(vector.elementAt(i + 1).toString().trim());
				}


		  }



    }



    public void setJavacOptions()
		{
			//Utils.userMessage("In setJavacOptions", jpe.getJavacOptions(), 1);

			Vector vector = new Vector();

			String s = jpe.getJavacOptions();

			if (s.length() > 0)
			{
				StringTokenizer str = new StringTokenizer(s, " ", false);

				while (str.hasMoreTokens())
				{
					String a = str.nextToken();

					vector.addElement(a);
				}

			}

      for(int i = 0; i < vector.size(); i++)
		  {

				if (vector.elementAt(i).toString().trim().equalsIgnoreCase("-d"))
				{
					Path3.setText((String)vector.elementAt(i + 1));
				}
				else if (vector.elementAt(i).toString().trim().equalsIgnoreCase("-deprecation"))
				{
					depcheck.setSelected(true);
				}
				else if (vector.elementAt(i).toString().trim().equalsIgnoreCase("-g"))
				{
					gcheck.setSelected(true);
				}
				else if (vector.elementAt(i).toString().trim().equalsIgnoreCase("-O"))
				{
					ocheck.setSelected(true);
				}
				else if (vector.elementAt(i).toString().trim().equalsIgnoreCase("-verbose"))
				{
					verbcheck.setSelected(true);
				}
				else if (vector.elementAt(i).toString().trim().equalsIgnoreCase("-g:none"))
				{
					gnonecheck.setSelected(true);
				}
				else if (vector.elementAt(i).toString().trim().equalsIgnoreCase("-nowarn"))
				{
					nowarncheck.setSelected(true);
				}

		  }



    }



	public void addjavaWords()
  {
  	jFileChooser.isFileSelectionEnabled();
		jFileChooser.setFileSelectionMode(2);
		jFileChooser.setMultiSelectionEnabled(true);

	  File f[] = new File[99];

			if (jFileChooser.showOpenDialog(this) == JFileChooser.APPROVE_OPTION)
			{
			    f = jFileChooser.getSelectedFiles();

			   if (f.length < 99)
			   {
				   for(int i = 0; i < f.length; i++)
				   {
				   	  vector.add(f[i].getPath().toString());

							jtf.setText("");
							Path6.setText(Path6.getText() + f[i].getPath().toString() + ";");
							jta.append(f[i].getPath().toString() + ";\n");
		       }
			   }

			}
		  this.repaint();

	 }

  public void addjavaWords2()
  {
  	jFileChooser.isDirectorySelectionEnabled();
	  jFileChooser.setFileSelectionMode(1);
	  jFileChooser.setMultiSelectionEnabled(true);

	  File f[] = new File[99];

			if (jFileChooser.showOpenDialog(this) == JFileChooser.APPROVE_OPTION)
			{
			    f = jFileChooser.getSelectedFiles();

			   if (f.length < 99)
			   {
				   for(int i = 0; i < f.length; i++)
				   {
				   	  vector.add(f[i].getPath().toString());

							jtf.setText("");
							Path6.setText(Path6.getText() + f[i].getPath().toString() + ";");
							jta.append(f[i].getPath().toString() + ";\n");
			     }

			   }
		    this.repaint();
      }
	}



	public void deljavaWords()
  {

     a = jta.getLineOfOffset(jta.getCaretPosition());

     //Utils.userMessage("Line offset", Integer.toString(a), 1);

	 	 String s = jta.getLineText(a);

	 	 String str = s.substring(0, s.length()-1);

		 int value =  JOptionPane.showConfirmDialog(this, "Delete " + str + " ?", "", JOptionPane.YES_NO_OPTION);

		 switch (value)
		 {
			 case JOptionPane.YES_OPTION:

		   vector.removeElementAt(a);

		   updateClasspath();

			case JOptionPane.NO_OPTION:
				return;
		 }

   }


   private void setDir()
   {
 	    jFileChooser.isDirectorySelectionEnabled();
	    jFileChooser.setFileSelectionMode(1);
			if (jFileChooser.showOpenDialog(this) == JFileChooser.APPROVE_OPTION)
			{
			   Path3.setText(jFileChooser.getSelectedFile().getPath());
			}
		  this.repaint();
   }

    private void close()
    {
      setVisible(false);
	  }


    public void actionPerformed(ActionEvent e)
    {
      Object source = e.getSource();


      if(source == jbtClose)
       {
        close();
       }

	     if((source == br1) || (source == jmiAddClasspathArch))
	     {
	        addjavaWords();
	     }

	     if((source == br2) || (source == jmiAddClasspathDir))
	     {
	        addjavaWords2();
	     }

	     if(source == br3)
	     {
	        setDir();
	     }

	     if(source == br4)
			 {
					Path3.setText("");
	     }

		   if((source == del) || (source == jmiRemoveClasspath))
	     {
	        deljavaWords();
	     }


	    else if(source == jbtOK)
		  {
				Options    = "";
			  runOptions = "";

				String t = Path3.getText();

				if(t.length() > 0)
				{
					Options = "-d" + gap + t;
				}

				if(depcheck.isSelected())
				{ Options = Options + gap + "-deprecation";}

				if(gcheck.isSelected())
				{ Options = Options + gap + "-g";}

				if(ocheck.isSelected())
				{ Options = Options + gap + "-O";}

				if(verbcheck.isSelected())
				{ Options = Options + gap + "-verbose";}

				if(gnonecheck.isSelected())
				{ Options = Options + gap + "-g:none";}

				if(nowarncheck.isSelected())
				{ Options = Options + gap + "-nowarn";}

				if(javaw.isSelected())
				{
					runOptions = "javaw.exe";
				}
				else
				{
					runOptions = "java.exe";
				}


				if(jar.isSelected())
				{runOptions = runOptions + gap + "-jar";}

				//if(jtfSystemParam.getText().length() > 0)
				//{
				//	runOptions = runOptions + gap + "-D" + gap + jtfSystemParam.getText();
				//}

				if(useclass.isSelected())
				{runOptions = runOptions + gap + "-classpath " + Path6.getText();}

				if(verbose.isSelected())
				{runOptions = runOptions + gap + "-verbose";}



	      jpe.setOptions(Options);
	      jpe.setClasspath(Path6.getText());
	      jpe.setJavaRunOptions(runOptions);

	      //Utils.userMessage("Options", Options, 1);
	      //Utils.userMessage("Classpath", Path6.getText(), 1);
	      //Utils.userMessage("RunOptions", runOptions, 1);

				setVisible(false);


		 }


	}

  private jpe jpe;
  private int a;
  private JButton Cancel, add, del;
  private JList javaList;
  private String outString;
  private String fileSep = System.getProperty("file.separator");
  private Vector vector;
  private JTextField jtf;
  private Utils Utils;
  private JPanel butpanel, mainPanel, Panel1, Panel2, Panel3, Panel4, Panel5, Panel6, Panel7, appPanel1, appPanel2,
		      appPanel3, appPanel4, appPanel5, appPanel6, JavaList;
	private JTextField Path1, Path2, Path3, Path4, Path5, Path6, jtfSystemParam;
	private mbJTextArea jta;
	private JScrollPane jsp, chooseJava;
	private JButton jbtOK, jbtClose, br1, br2, br3, br4, br5;
	private JFileChooser jFileChooser = new JFileChooser();
	private JCheckBox depcheck, gcheck, ocheck, verbcheck, gnonecheck, nowarncheck, useclass, verbose, javaw, jar;
  private String Options, gap, classpath, runOptions;
  private boolean depCheck, gCheck, oCheck, verbCheck, gnoneCheck, nowarnCheck, useClass, verBose, javaW, jaR;
  private Icon javac = new ImageIcon("images" + fileSep + "javac.gif");
  private JPopupMenu jpopupmenu;
  private JMenu addMenu;
  private JMenuItem jmiAddClasspathDir, jmiAddClasspathArch, jmiRemoveClasspath;

}

