/* This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/



//Clip1.java - displays the contents of the clipboards. This class is used by all the clipboards,
//the clipboard number and contents are passed to this class from the main class by the constructor.
//(C)2000-2001 Mark Beynon
//mark@jpedit.co.uk
//http://www.jpedit.co.uk



package com.misc;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.WindowEvent;

import java.awt.AWTEvent;
import java.awt.Insets;
import java.awt.FlowLayout;
import java.awt.Dimension;
import java.awt.BorderLayout;
import java.awt.Frame;

import javax.swing.JTextArea;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.Icon;
import javax.swing.ImageIcon;


import com.jpe.jpe;

public class Clip1 extends JDialog implements ActionListener {

    private JPanel jpanel;
    private JTextArea jtaClip1;
    private JScrollPane jsp;
    private JButton jbtClose, jbtPaste;
	private jpe win;
	private String fileSep = System.getProperty("file.separator");


    public Clip1(jpe win, String s, String t) {
    super(win, "", false);


    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try  {
      jbInit(win, s, t);
    }
    catch(Exception e) {
      e.printStackTrace();
    }

     pack();


  }


  private void jbInit(jpe win, String s, String t) throws Exception
  {

	  this.win = win;
    setTitle(t);
    setResizable(false);

    jtaClip1 = new JTextArea(s, 10, 35);

    Insets insets = new Insets(12, 8, 12, 8);
    jtaClip1.setMargin(insets);

    jtaClip1.setEditable(false);
    jtaClip1.setLineWrap(false);
    jtaClip1.setWrapStyleWord(false);

	jtaClip1.requestFocus();
	jtaClip1.setCaretPosition(0);

    jsp = new JScrollPane(jtaClip1);

	Icon Close = new ImageIcon("images" + fileSep + "close.gif");
	Icon Paste = new ImageIcon("images" + fileSep + "paste.gif");

    jpanel = new JPanel();
    jpanel.setLayout(new FlowLayout(FlowLayout.CENTER));
    jpanel.add(jbtClose = new JButton(Close));
	jpanel.add(jbtPaste = new JButton(Paste));


    jbtClose.setText("Close");
 
//    jbtClose.setPreferredSize(new Dimension(24,23));
//	jbtPaste.setPreferredSize(new Dimension(24,23));

	jbtClose.setToolTipText("Close");
	jbtPaste.setToolTipText("Paste into Document");
        jbtPaste.setText("Paster");

    getContentPane().setLayout(new BorderLayout());
    getContentPane().add(jsp, BorderLayout.CENTER);
    getContentPane().add(jpanel, BorderLayout.SOUTH);

    // Register listener
    jbtClose.addActionListener(this);
	jbtPaste.addActionListener(this);


 }



  protected void processWindowEvent(WindowEvent e) {
    if(e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }

  public void cancel() {
    dispose();
  }

  public void actionPerformed(ActionEvent e) {

	  if(e.getSource() == jbtPaste) {
		win.RequestFocus();
    win.insertString(jtaClip1.getText(), 0);
    }

    if(e.getSource() == jbtClose) {
      cancel();
    }
  }
}
