CDECK  ID>, HWH2HE.
*CMZ :-        -13/10/02  09.43.05  by  Peter Richardson
*-- Author :    Kosuke Odagiri and Stefano Moretti
C-----------------------------------------------------------------------
      SUBROUTINE HWH2HE(FIRST,GAUGE,IFL,IH,HFC,HBC,
     & E,S2W,TANB,AL,RMW,S,Q3, P3,P4,P5,
     & RM3,YM3,GAM3,RM4,YM4,GAM4,RM5,GAM5,
     & RML,GAML,RMH,GAMH,RMA,GAMA,
     & RMZ,GAMZ,CFAC,RES)
C-----------------------------------------------------------------------
C     MATRIX ELEMENT SQUARED FOR 
C     e-(1) e+(2) -> f(3) f(')bar(4) Higgs(5)
C     (SAME QUARK MASSES IN YUKAWA AND KINEMATICS)
C-----------------------------------------------------------------------
      IMPLICIT NONE
      LOGICAL FIRST,GAUGE
      DOUBLE PRECISION HFC,HBC
      DOUBLE PRECISION CFAC
      DOUBLE PRECISION E,S2W,TANB,AL,RMW,S,Q3,RES
      DOUBLE PRECISION P3(0:3),P4(0:3),P5(0:3)
      DOUBLE PRECISION RM3,YM3,GAM3,RM4,YM4,GAM4,RM5,GAM5,RMZ,GAMZ
      DOUBLE PRECISION RML,GAML,RMH,GAMH,RMA,GAMA,Q2
      DOUBLE PRECISION XW,GE(-1:1),G3(-1:1),G4(-1:1),G5(-1:1)
      DOUBLE PRECISION RM(-1:1),RN1(-1:1),RN2(-1:1),RN3
      DOUBLE PRECISION SQS,TWOSQS,HLFSQS,P34,M34,PREFAC
      DOUBLE PRECISION RLE,RLLE,EP3(-1:1),EP4(-1:1),ZERO,ONE,TWO,HLF
      DOUBLE PRECISION BE,DUMMY(0:3),SA,CA,SB,CB
      INTEGER I,LE,L,IFL,IH
      DOUBLE COMPLEX PROPZ,PROP3(-1:1),PROP4(-1:1),PROP5,PROP6
      DOUBLE COMPLEX PROP7(-1:1)
      DOUBLE COMPLEX PP(-1:1),MM(-1:1),QQ(-1:1),ZP3,ZP4,ZP5
      PARAMETER (ZERO=0.D0,ONE=1.D0,TWO=2.D0,HLF=.5D0)
      SAVE XW,GE,G3,G4,G5,RM,PREFAC
C QUANTITIES WHICH CAN BE COMPUTED ONLY ONCE
      IF(FIRST)THEN
C SOME COMMON INITIALISATIONS
        DO I=-1,1
          RM(I)=ZERO
          RN1(I)=ZERO
          RN2(I)=ZERO
        END DO
        DO I=0,3
          DUMMY(I)=ZERO
        END DO
        RN3=ZERO
        XW=TWO*S2W
        GE( 0)=-ONE
        GE(+1)=-GE(0)*XW
        GE(-1)=-ONE+GE(1)
        IF(IH.LE.3)THEN
          G3( 0)=Q3
          G3(+1)=-G3(0)*XW
          G3(-1)=-ONE*(-Q3/ABS(Q3))+G3(1)
          G4( 0)=G3( 0)
          G4(+1)=G3(+1)
          G4(-1)=G3(-1)      
          G5( 0)=ZERO
          G5(+1)=ONE
          G5(-1)=ONE 
C HIGGS ANGLES
          BE=ATAN(TANB)
          SA=SIN(AL)
          CA=COS(AL)
          SB=SIN(BE)
          CB=COS(BE)
C MSSM SCALING FACTORS FOR COUPLINGS
          IF(IH.LE.2)THEN 
            RM(-1)=+YM3/RMW*HFC
            RM(+1)=+YM4/RMW*HFC
          ELSE IF(IH.EQ.3)THEN 
            RM(-1)=+YM3/RMW*HFC
            RM(+1)=-YM4/RMW*HFC
          END IF
          IF(IH.LE.2)THEN 
            IF(IH.EQ.1)RN1(-1)=+YM3/RMW*((2-IFL)*TANB+(IFL-1)/TANB)
     &                        *(-SQRT(ABS(ONE-HBC**2)))
            IF(IH.EQ.1)RN1(+1)=-YM4/RMW*((2-IFL)*TANB+(IFL-1)/TANB)
     &                        *(-SQRT(ABS(ONE-HBC**2)))
            IF(IH.EQ.2)RN1(-1)=-YM3/RMW*((2-IFL)*TANB+(IFL-1)/TANB)
     &                        *(+SQRT(ABS(ONE-HBC**2)))
            IF(IH.EQ.2)RN1(+1)=+YM4/RMW*((2-IFL)*TANB+(IFL-1)/TANB)
     &                        *(+SQRT(ABS(ONE-HBC**2)))
            RN2(-1)=ZERO
            RN2(+1)=ZERO          
            IF(IH.EQ.0)RN3=1.D0
            IF(IH.EQ.1)RN3=HBC
            IF(IH.EQ.2)RN3=HBC
          ELSE IF(IH.EQ.3)THEN
            RN1(-1)=+YM3/RMW*((2-IFL)*(-SA/CB)+(IFL-1)*(+CA/SB))
     &                      *COS(BE-AL)
            RN1(+1)=+YM4/RMW*((2-IFL)*(-SA/CB)+(IFL-1)*(+CA/SB))
     &                      *COS(BE-AL)
            RN2(-1)=+YM3/RMW*((2-IFL)*(+CA/CB)+(IFL-1)*(+SA/SB))
     &                      *SIN(BE-AL)
            RN2(+1)=+YM4/RMW*((2-IFL)*(+CA/CB)+(IFL-1)*(+SA/SB))
     &                      *SIN(BE-AL) 
            RN3=ZERO
          END IF
          PREFAC=E**6/(XW*S)*CFAC/TWO
        ELSE
          G3( 0)=Q3
          G3(+1)=-G3(0)*XW
          G3(-1)=-ONE+G3(1)
          G4( 0)=ONE+G3(0)
          G4(+1)=-G4(0)*XW
          G4(-1)=ONE+G4(1)
          G5( 0)=ONE
          G5(+1)=ONE-XW
          G5(-1)=ONE-XW
          RM(-1)=YM3*TANB/RMW
          RM(+1)=YM4/TANB/RMW
          RN1(-1)=RM(-1)
          RN1(+1)=RM(+1)
          RN2(-1)=ZERO
          RN2(+1)=ZERO
          RN3=ZERO
          PREFAC=E**6/(XW*S)*CFAC
        END IF
        FIRST=.FALSE.
      END IF
C SOME ENERGY CONSTANTS
      SQS=DSQRT(S)
      TWOSQS=TWO*SQS
      HLFSQS=HLF*SQS
      PROPZ=S/(XW*(TWO-XW)*DCMPLX(S-RMZ**2,-RMZ*GAMZ))
C SOME KINEMATICS
      P34=P3(0)*P4(0)-P3(1)*P4(1)-P3(2)*P4(2)-P3(3)*P4(3)
      M34=RM3*RM4
      RES=ZERO
C FF(')-BAR PROPAGATOR
      Q2=RM3**2+RM4**2+TWO*P34
C CONSTRUCT AMPLITUDE
      DO LE=-1,1,2
        RLE=DFLOAT(LE)
        IF(IH.LE.2)THEN
          PROP5=(GE(0)*G5(0)+GE(LE)*G5(-1)*PROPZ)/
     &                 DCMPLX(Q2-RMA**2,-RMA*GAMA)
          PROP6=(0.D0,0.D0)
        ELSE IF(IH.EQ.3)THEN
          PROP5=(GE(0)*G5(0)+GE(LE)*G5(-1)*PROPZ)/
     &                 DCMPLX(Q2-RML**2,-RML*GAML)
          PROP6=(GE(0)*G5(0)+GE(LE)*G5(-1)*PROPZ)/
     &                 DCMPLX(Q2-RMH**2,-RMH*GAMH)
        ELSE
          PROP5=(GE(0)*G5(0)+GE(LE)*G5(-1)*PROPZ)/
     &                 DCMPLX(Q2-RM5**2,-RM5*GAM5)
        END IF
        ZP3=DCMPLX(P3(1),-RLE*P3(2))
        ZP4=DCMPLX(P4(1),-RLE*P4(2))
        ZP5=-ZP3-ZP4
        DO L=-1,1,2
          PROP3(L)=(GE(0)*G3(0)+GE(LE)*G3(L)*PROPZ)/
     &               DCMPLX(S-TWOSQS*P3(0),-RM3*GAM3)
          PROP4(L)=(GE(0)*G4(0)+GE(LE)*G4(L)*PROPZ)/
     &               DCMPLX(S-TWOSQS*P4(0),-RM4*GAM4)
          PROP7(L)=GE(LE)*G3(L)*PROPZ/DCMPLX(Q2-RMZ**2,-RMZ*GAMZ)
        END DO
        DO L=-1,1,2
          PP(L)=-RM(-L)*SQS*(PROP3(L)+PROP4(-L))
          MM(L)=RM3*RM(+L)*(PROP3(L)-PROP3(-L))
     &         +RM4*RM(-L)*(PROP4(L)-PROP4(-L))
     &         +TWO*RMZ**2/RMW*RN3*PROP7(L)
          IF(GAUGE)THEN
            ZP3=P3(0)-HLFSQS
            ZP4=P4(0)-HLFSQS
            ZP5=P5(0)-HLFSQS
            PP(L)=DCMPLX(ZERO,ZERO)
            MM(L)=MM(L)+PROPZ*GE(LE)*DFLOAT(L)/TWOSQS*
     &                           (RM3*RM(L)/ZP3-RM4*RM(-L)/ZP4)
          END IF
          QQ(L)=RM(L)*(PROP3(-L)*ZP3-PROP4(L)*ZP4)
     &         +RN1(L)*PROP5*ZP5
     &         -RN2(L)*PROP6*ZP5
     &         +RM3/RMW*RN3*(PROP7(L)-PROP7(-L))*ZP5
          RLLE=DFLOAT(L*LE)
          EP3(L)=P3(0)+RLLE*P3(3)
          EP4(L)=P4(0)+RLLE*P4(3)
        END DO
        DO L=-1,1,2
          RES=RES+DREAL(
     &      EP3(+L)*EP4(+L)*DCONJG(PP(+L))*PP(+L)+
     &      EP3(+L)*EP4(-L)*DCONJG(MM(+L))*MM(+L)-
     &      TWO*RM3*EP4(+L)*DCONJG(PP(+L))*MM(-L)-
     &      TWO*RM4*EP3(+L)*DCONJG(PP(+L))*MM(+L)+
     &      M34*(DCONJG(PP(-L))*PP(+L)+DCONJG(MM(-L))*MM(+L))
     &      +TWO*DCONJG(QQ(-L))
     &      *((RM3*MM(-L)-EP3(+L)*PP(+L))*ZP4-
     &        (RM4*MM(+L)-EP4(+L)*PP(+L))*ZP3+
     &        P34*QQ(-L)-M34*QQ(+L)))
        END DO
      END DO
      RES=PREFAC*RES
 999  END
CDECK  ID>, HWH2M0.
*CMZ :-        -14/03/01  09:03:25  by  Peter Richardson
*-- Author :    Peter Richardson
C-----------------------------------------------------------------------
      SUBROUTINE HWH2M0(IQ,IDZ,MG,MQ)
C-----------------------------------------------------------------------
C     Massless matrix elements for gg-->qqZ and qq-->qqZ
C     using the matrix elements given in Nucl. Phys. B262 (1985) 235-242
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      INTEGER IQ,I,J,OZ(2,2),IDZ,P1,P2,P3,P4,IQI,ID(2),K
      DOUBLE PRECISION MG(2),MQ(2,5),G(12,2),FLOW(3,3),CQFC,CQIFC,
     &     CGFC,CGIFC
      DOUBLE COMPLEX MQAMP(2),HWH2T1,HWH2T2,HWH2T3,HWH2T4,HWH2T5,
     &     HWH2T6,HWH2T7,HWH2T8,HWH2T9,HWH2T0,DCF(8),HWH2DD,
     &     MGAMP(2,2,2,2,2),TRPGL(2)
      EXTERNAL HWH2DD,HWH2T0,HWH2T1,HWH2T2,HWH2T3,HWH2T4,HWH2T5,HWH2T6,
     &         HWH2T7,HWH2T8,HWH2T9
      PARAMETER(CQFC=2.0D0,CQIFC=-2.0D0/3.0D0,CGFC=16.0D0/3.0D0,
     &          CGIFC=-2.0D0/3.0D0)
      COMMON /HWHZBC/G
      DATA OZ/6,5,5,6/
      DATA ID/1,2/
C--flavour of the final-state quark (1 is down-type and 2 is up-type)
      IQI  = MOD(IQ,2)
      IF(IQI.EQ.0) IQI=2
C--calculate qqbar---> q'q'barZ
      DCF(1) = HWH2DD(4,2,1,3,4,5,6)
      DCF(2) = HWH2DD(5,2,1,3,4,5,6)
      DCF(3) = HWH2DD(4,3,4,2,1,5,6)
      DCF(4) = HWH2DD(5,3,4,2,1,5,6)
      DCF(5) = HWH2DD(4,3,1,2,4,5,6)
      DCF(6) = HWH2DD(5,3,1,2,4,5,6)
      DCF(7) = HWH2DD(4,2,4,3,1,5,6)
      DCF(8) = HWH2DD(5,2,4,3,1,5,6)
      DO I=1,3
        DO J=1,3
          FLOW(I,J) = ZERO
        ENDDO
      ENDDO
      DO I=1,2
C--calculate the matrix element, N.B. two possibe colour flows
       DO P1=1,2
        DO P2=1,2
         DO P3=1,2
            MQAMP(1)= G(IDZ,P3)*(
     &      G(ID(I),P1)*(DCF(1)*HWH2T4(2,1,3,4,OZ(P3,1),OZ(P3,2),P1,P2)
     &                  +DCF(2)*HWH2T5(2,1,3,4,OZ(P3,1),OZ(P3,2),P1,P2))
     &       +G(IQ,P2)*(DCF(3)*HWH2T4(3,4,2,1,OZ(P3,1),OZ(P3,2),P2,P1)
     &                 +DCF(4)*HWH2T5(3,4,2,1,OZ(P3,1),OZ(P3,2),P2,P1)))
          IF(ID(I).NE.IQI) THEN
            MQAMP(2)=ZERO
          ELSE
            MQAMP(2)= G(IDZ,P3)*(
     &        G(IQ,P1)*(DCF(5)*HWH2T4(3,1,2,4,OZ(P3,1),OZ(P3,2),P1,P2)
     &                 +DCF(6)*HWH2T5(3,1,2,4,OZ(P3,1),OZ(P3,2),P1,P2))
     &       +G(IQ,P2)*(DCF(7)*HWH2T4(2,4,3,1,OZ(P3,1),OZ(P3,2),P2,P1)
     &                 +DCF(8)*HWH2T5(2,4,3,1,OZ(P3,1),OZ(P3,2),P2,P1)))
          ENDIF
          FLOW(I,1) = FLOW(I,1)+DBLE(MQAMP(1)*DCONJG(MQAMP(1)))
          FLOW(I,2) = ZERO
          FLOW(I,3) = ZERO
          IF(IQI.EQ.ID(I)) THEN
            FLOW(3,1) = FLOW(3,1)+DBLE(MQAMP(1)*DCONJG(MQAMP(1)))
            FLOW(3,2) = FLOW(3,2)+DBLE(MQAMP(2)*DCONJG(MQAMP(2)))
            IF(P1.EQ.P2) FLOW(3,3) = FLOW(3,3)
     &                         -TWO*DBLE(MQAMP(1)*DCONJG(MQAMP(2)))
          ENDIF
         ENDDO
        ENDDO
       ENDDO
      ENDDO
      DO I=1,3
        FLOW(I,1) =  CQFC*FLOW(I,1)
        FLOW(I,2) =  CQFC*FLOW(I,2)
        FLOW(I,3) = CQIFC*FLOW(I,3)
      ENDDO
C--now find the matrix elements
      DO I=1,5
        K = MOD(I,2)
        IF(K.EQ.0) K=2
        IF(I.EQ.IQ) K=3
        DO J=1,2
          IF(FLOW(K,J).NE.ZERO) MQ(J,I) = FLOW(K,J)*
     &                           (ONE+FLOW(K,3)/(FLOW(K,1)+FLOW(K,2)))
        ENDDO
      ENDDO
C--calculate gg---> bbbarZ
C--coefficients for the diagrams
      DCF(1) = HWH2DD( 6,3,4,1,2,5,6)
      DCF(2) = HWH2DD( 7,3,4,1,2,5,6)
      DCF(3) = HWH2DD( 8,3,4,1,2,5,6)
      DCF(4) = HWH2DD( 6,3,4,2,1,5,6)
      DCF(5) = HWH2DD( 7,3,4,2,1,5,6)
      DCF(6) = HWH2DD( 8,3,4,2,1,5,6)
      DCF(7) = HWH2DD( 9,3,4,1,2,5,6)
      DCF(8) = HWH2DD(10,3,4,1,2,5,6)
C--helicity amplitudes
      DO P1=1,2
       DO P2=1,2
         DO P3=1,2
          DO P4=1,2
           TRPGL(1)=
     &            DCF(7)*HWH2T9(3,4,1,2,OZ(P4,1),OZ(P4,2),P3,P1,P2)
     &           +DCF(8)*HWH2T0(3,4,1,2,OZ(P4,1),OZ(P4,2),P3,P1,P2)
           TRPGL(2)=
     &            DCF(7)*HWH2T9(3,4,1,2,OZ(P4,1),OZ(P4,2),P3,P2,P1)
     &           +DCF(8)*HWH2T0(3,4,1,2,OZ(P4,1),OZ(P4,2),P3,P2,P1)
           MGAMP(1,P1,P2,P3,P4) = G(IDZ,P4)*G(IQ,P3)*(
     &          TRPGL(1)
     &         +DCF(1)*HWH2T6(3,4,1,2,OZ(P4,1),OZ(P4,2),P3,P1,P2)
     &         +DCF(2)*HWH2T7(3,4,1,2,OZ(P4,1),OZ(P4,2),P3,P1,P2)
     &         +DCF(3)*HWH2T8(3,4,1,2,OZ(P4,1),OZ(P4,2),P3,P1,P2)
     &          )
           MGAMP(2,P2,P1,P3,P4) = G(IDZ,P4)*G(IQ,P3)*(-TRPGL(2)
     &         +DCF(4)*HWH2T6(3,4,2,1,OZ(P4,1),OZ(P4,2),P3,P1,P2)
     &         +DCF(5)*HWH2T7(3,4,2,1,OZ(P4,1),OZ(P4,2),P3,P1,P2)
     &         +DCF(6)*HWH2T8(3,4,2,1,OZ(P4,1),OZ(P4,2),P3,P1,P2))
         ENDDO
        ENDDO
       ENDDO
      ENDDO
C--square to obtain the matrix element
      DO I=1,3
        FLOW(1,I) = ZERO
      ENDDO
      DO P1=1,2
        DO P2=1,2
          DO P3=1,2
            DO P4=1,2
             FLOW(1,1) = FLOW(1,1)+DBLE(MGAMP(1,P1,P2,P3,P4)*
     &                              DCONJG(MGAMP(1,P1,P2,P3,P4)))
             FLOW(1,2) = FLOW(1,2)+DBLE(MGAMP(2,P1,P2,P3,P4)*
     &                              DCONJG(MGAMP(2,P1,P2,P3,P4)))
             FLOW(1,3) = FLOW(1,3)+TWO*DBLE(MGAMP(1,P1,P2,P3,P4)*
     &                              DCONJG(MGAMP(2,P1,P2,P3,P4)))
            ENDDO
          ENDDO
        ENDDO
      ENDDO
      FLOW(1,1) = CGFC*FLOW(1,1)
      FLOW(1,2) = CGFC*FLOW(1,2)
      FLOW(1,3) = CGIFC*FLOW(1,3)
      DO I=1,2
        MG(I) = FLOW(1,I)*(ONE+FLOW(1,3)/(FLOW(1,1)+FLOW(1,2)))
      ENDDO
      END
