CDECK  ID>, HWH2MQ.
*CMZ :-        -14/03/01  09:03:25  by  Peter Richardson
*-- Author :    Peter Richardson
C-----------------------------------------------------------------------
      SUBROUTINE HWH2MQ(IQ,IDZ,MG,MQ)
C-----------------------------------------------------------------------
C     Massive matrix elements for gg --> qqbarZ and qqbar --> qqbarZ
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      INTEGER IQ,I,IDZ,P1,P2,PL,PB,PBB,O(2),J,IQI
      DOUBLE PRECISION MG(2),MQ(2,5),G(12,2),CQFC,CQIFC,CGFC,CGIFC,
     &     PTMP(5,10),XMASS,PLAB,PRW,PCM,HWULDO,QBL,QBBL,Q2B,Q1B,Q2BB,
     &     Q1BB,QM2,FLOW(3,3),PG,PBQB,PBBQBB,QM,PQ,Q1L,Q2L,
     &     Q1LB,Q2LB,MQB(2,3),QBB
      DOUBLE COMPLEX S,D,FBB(2,2,8),FBBB(2,2,8),FBLL(2,2,8,8),MQP(2),
     &     FBBLL(2,2,8,8),F1B(2,2,8,8),F1BB(2,2,8,8),F2B(2,2,8,8),
     &     F2BB(2,2,8,8),DL(2,2),DCF(8),MGAMP(3),MQAMP(3,2,2,2,2),
     &     MQQAMP(2,2,2,2,2),F1LL(2,2,8,8),F2LL(2,2,8,8)
      DATA DL/(1.0D0,0.0D0),(0.0D0,0.0D0),(0.0D0,0.0D0),(1.0D0,0.0D0)/
      DATA O   /2,1/
      COMMON/HWHZBC/G
      COMMON/HWHEWS/S(8,8,2),D(8,8)
      COMMON/HWHEWP/XMASS(10),PLAB(5,10),PRW(5,2),PCM(5,10)
      PARAMETER(CQFC=2.0D0,CQIFC=-2.0D0/3.0D0,CGFC=16.0D0/3.0D0,
     &          CGIFC=-2.0D0/3.0D0)
      EXTERNAL HWULDO
C--mass of the final-state quark
      QM  = RMASS(IQ)
      QM2 = RMASS(IQ)**2
C--first calculate the F functions we will need
      DO I=1,4
        PTMP(I,1)  =  PCM(I,9)+PCM(I,5)+PCM(I,6)
        PTMP(I,2)  = -PCM(I,10)-PCM(I,5)-PCM(I,6)
        PTMP(I,3)  =  PCM(I,9)-PCM(I,1)
        PTMP(I,4)  =  PCM(I,1)-PCM(I,10)
        PTMP(I,5)  =  PCM(I,9)-PCM(I,2)
        PTMP(I,6)  =  PCM(I,2)-PCM(I,10)
        PTMP(I,7)  =  PCM(I,9)
        PTMP(I,8)  = -PCM(I,10)
        PTMP(I,9)  = PCM(I,1)-PCM(I,5)-PCM(I,6)
        PTMP(I,10) =-PCM(I,2)+PCM(I,5)+PCM(I,6)
      ENDDO
      CALL HWH2F3(8,FBLL ,  PTMP(1, 1),QM)
      CALL HWH2F3(8,FBBLL,  PTMP(1, 2),QM)
      CALL HWH2F3(8,F1B  ,  PTMP(1, 3),QM)
      CALL HWH2F3(8,F1BB ,  PTMP(1, 4),QM)
      CALL HWH2F3(8,F2B  ,  PTMP(1, 5),QM)
      CALL HWH2F3(8,F2BB ,  PTMP(1, 6),QM)
      CALL HWH2F1(8,FBB  ,3,PTMP(1, 7),QM)
      CALL HWH2F2(8,FBBB ,4,PTMP(1, 8),QM)
      CALL HWH2F3(8,F1LL ,  PTMP(1, 9),QM)
      CALL HWH2F3(8,F2LL ,  PTMP(1,10),QM)
C--calculate the momenta squared for the denominators
      QBB = HALF/(QM2+HWULDO(PCM(1,9),PCM(1,10)))
      QBL   = ONE/(HWULDO(PTMP(1,1),PTMP(1,1))-QM2)
      QBBL  = ONE/(HWULDO(PTMP(1,2),PTMP(1,2))-QM2)
      Q1B   = ONE/(HWULDO(PTMP(1,3),PTMP(1,3))-QM2)
      Q1BB  = ONE/(HWULDO(PTMP(1,4),PTMP(1,4))-QM2)
      Q2B   = ONE/(HWULDO(PTMP(1,5),PTMP(1,5))-QM2)
      Q2BB  = ONE/(HWULDO(PTMP(1,6),PTMP(1,6))-QM2)
      Q1L  = HWULDO(PTMP(1, 9),PTMP(1, 9))
      Q2L  = HWULDO(PTMP(1,10),PTMP(1,10))
      Q1LB = ONE/(Q1L-QM2)
      Q2LB = ONE/(Q2L-QM2)
      Q1L  = ONE/Q1L
      Q2L  = ONE/Q2L
C--first construct the massless momenta
      PBQB   = HWULDO(PCM(1,3),PCM(1,9))
      PBBQBB = HWULDO(PCM(1,4),PCM(1,10))
C--first gg  --> q qbar Z
C--calculate the denominators due gluon polaizations and massive quarks
      PG   = 0.25D0/PBQB/PBBQBB/D(1,2)/D(1,2)
C--and the denominators
      DCF(1) = FOUR*QBL*Q2BB
      DCF(2) = FOUR*QBL*Q1BB
      DCF(3) = FOUR*Q1B*Q2BB
      DCF(4) = FOUR*Q2B*Q1BB
      DCF(5) = FOUR*Q1B*QBBL
      DCF(6) = FOUR*Q2B*QBBL
      DCF(7) =  TWO*QBL/D(1,2)
      DCF(8) =  TWO*QBBL/D(1,2)
C--now calculate the matrix elements we need
      DO I=1,3
        FLOW(1,I) = ZERO
      ENDDO
      DO P1=1,2
      DO P2=1,2
      DO PL=1,2
      DO PB=1,2
      DO PBB=1,2
C--first amplitude from notes
        MGAMP(1) = DCF(1)*(
     &     ( G(IQ,O(PL))*FBB(PB,   PL,6)*FBLL(  PL ,P1,5,2)
     &      +G(IQ,  PL )*FBB(PB,O(PL),5)*FBLL(O(PL),P1,6,2))*
     &         (F2BB(  P1 ,  P2 ,1,1)*FBBB(  P2 ,PBB,2)+
     &          F2BB(  P1 ,O(P2),1,2)*FBBB(O(P2),PBB,1))
     &    +( G(IQ,O(PL))*FBB(PB,  PL ,6)*FBLL(   PL,O(P1),5,1)
     &      +G(IQ,  PL )*FBB(PB,O(PL),5)*FBLL(O(PL),O(P1),6,1))*
     &         (F2BB(O(P1),  P2 ,2,1)*FBBB(  P2 ,PBB,2)+
     &          F2BB(O(P1),O(P2),2,2)*FBBB(O(P2),PBB,1)))
C--second amplitude from notes (1st with gluons interchanged)
        MGAMP(2) = DCF(2)*(
     &     ( G(IQ,O(PL))*FBB(PB,  PL ,6)*FBLL(  PL ,  P2 ,5,1)
     &      +G(IQ,  PL )*FBB(PB,O(PL),5)*FBLL(O(PL),  P2 ,6,1))*
     &         (F1BB(  P2 ,  P1 ,2,2)*FBBB(  P1 ,PBB,1)+
     &          F1BB(  P2 ,O(P1),2,1)*FBBB(O(P1),PBB,2))
     &    +( G(IQ,O(PL))*FBB(PB,  PL ,6)*FBLL(  PL ,O(P2),5,2)
     &      +G(IQ,  PL )*FBB(PB,O(PL),5)*FBLL(O(PL),O(P2),6,2))*
     &         (F1BB(O(P2),  P1 ,1,2)*FBBB(  P1 ,PBB,1)+
     &          F1BB(O(P2),O(P1),1,1)*FBBB(O(P1),PBB,2)))
C--third amplitude from notes
        MGAMP(1) = MGAMP(1)+DCF(3)*(
     &     G(IQ,O(PL))*( FBB(PB,  P1 ,2)*F1B(  P1 ,  PL ,1,6)
     &                  +FBB(PB,O(P1),1)*F1B(O(P1),  PL ,2,6))*
     &         (F2BB(PL,  P2 ,5,1)*FBBB(  P2 ,PBB,2)+
     &          F2BB(PL,O(P2),5,2)*FBBB(O(P2),PBB,1))
     &    +G(IQ,  PL )*( FBB(PB,  P1 ,2)*F1B(  P1 ,O(PL),1,5)
     &                  +FBB(PB,O(P1),1)*F1B(O(P1),O(PL),2,5))*
     &         (F2BB(O(PL),  P2 ,6,1)*FBBB(  P2 ,PBB,2)+
     &          F2BB(O(PL),O(P2),6,2)*FBBB(O(P2),PBB,1)))
C--fourth amplitude from notes (3rd with gluons interchanged)
        MGAMP(2) = MGAMP(2)+DCF(4)*(
     &     G(IQ,O(PL))*( FBB(PB,  P2 ,1)*F2B(  P2 ,  PL ,2,6)
     &                  +FBB(PB,O(P2),2)*F2B(O(P2),  PL ,1,6))*
     &         (F1BB(  PL ,  P1 ,5,2)*FBBB(  P1 ,PBB,1)+
     &          F1BB(  PL ,O(P1),5,1)*FBBB(O(P1),PBB,2))
     &    +G(IQ,  PL )*( FBB(PB,  P2 ,1)*F2B(  P2 ,O(PL),2,5)
     &                  +FBB(PB,O(P2),2)*F2B(O(P2),O(PL),1,5))*
     &         ( F1BB(O(PL),  P1 ,6,2)*FBBB(  P1 ,PBB,1)
     &          +F1BB(O(PL),O(P1),6,1)*FBBB(O(P1),PBB,2)))
C--fifth amplitude from notes
        MGAMP(1) = MGAMP(1)+DCF(5)*(
     &     ( G(IQ,O(PL))*FBBLL(  P2 ,  PL ,2,6)*FBBB(  PL ,PBB,5)
     &      +G(IQ,  PL )*FBBLL(  P2 ,O(PL),2,5)*FBBB(O(PL),PBB,6))*
     &         ( FBB(PB,  P1 ,2)*F1B(  P1 ,  P2 ,1,1)
     &          +FBB(PB,O(P1),1)*F1B(O(P1),  P2 ,2,1))
     &    +( G(IQ,O(PL))*FBBLL(O(P2),  PL ,1,6)*FBBB(  PL ,PBB,5)
     &      +G(IQ,  PL )*FBBLL(O(P2),O(PL),1,5)*FBBB(O(PL),PBB,6))*
     &         ( FBB(PB,  P1 ,2)*F1B(  P1 ,O(P2),1,2)
     &          +FBB(PB,O(P1),1)*F1B(O(P1),O(P2),2,2)))
C--sixth amplitude from notes (5th with gluons interchanged)
        MGAMP(2) = MGAMP(2)+DCF(6)*(
     &     ( G(IQ,O(PL))*FBBLL(  P1 ,  PL ,1,6)*FBBB(  PL ,PBB,5)
     &      +G(IQ,  PL )*FBBLL(  P1 ,O(PL),1,5)*FBBB(O(PL),PBB,6))*
     &         ( FBB(PB,  P2 ,1)*F2B(  P2 ,  P1 ,2,2)
     &          +FBB(PB,O(P2),2)*F2B(O(P2),  P1 ,1,2))
     &    +( G(IQ,O(PL))*FBBLL(O(P1),  PL ,2,6)*FBBB(  PL ,PBB,5)
     &      +G(IQ,  PL )*FBBLL(O(P1),O(PL),2,5)*FBBB(O(PL),PBB,6))*
     &         ( FBB(PB,  P2 ,1)*F2B(  P2 ,O(P1),2,1)
     &          +FBB(PB,O(P2),2)*F2B(O(P2),O(P1),1,1)))
C--seventh amplitude from notes (first non-Abelian one)
        MGAMP(3) = DCF(7)*DL(P1,P2)*S(1,2,P1)*S(1,2,O(P1))*(
     &         G(IQ,O(PL))*FBB(PB,  PL ,6)*
     &                   ( FBLL(  PL ,1,5,1)*FBBB(1,PBB,1)
     &                    +FBLL(  PL ,2,5,1)*FBBB(2,PBB,1)
     &                    -FBLL(  PL ,1,5,2)*FBBB(1,PBB,2)
     &                    -FBLL(  PL ,2,5,2)*FBBB(2,PBB,2))
     &        +G(IQ,  PL )*FBB(PB,O(PL),5)*
     &                   ( FBLL(O(PL),1,6,1)*FBBB(1,PBB,1)
     &                    +FBLL(O(PL),2,6,1)*FBBB(2,PBB,1)
     &                    -FBLL(O(PL),1,6,2)*FBBB(1,PBB,2)
     &                    -FBLL(O(PL),2,6,2)*FBBB(2,PBB,2)))
C--eighth amplitude from notes (second non-Abelian one)
C--bug fix 12/7/03 by PR (too many continuations for NAG)
        MGAMP(3) = MGAMP(3)
     &        + DCF(8)*DL(P1,P2)*S(1,2,P1)*S(1,2,O(P1))*(
     &         G(IQ,O(PL))*FBBB(  PL ,PBB,5)*
     &                   ( FBB(PB,1,1)*FBBLL(1,PL,1,6)
     &                    +FBB(PB,2,1)*FBBLL(2,PL,1,6)
     &                    -FBB(PB,1,2)*FBBLL(1,PL,2,6)
     &                    -FBB(PB,2,2)*FBBLL(2,PL,2,6))
     &        +G(IQ,  PL )*FBBB(O(PL),PBB,6)*
     &                   ( FBB(PB,1,1)*FBBLL(1,O(PL),1,5)
     &                    +FBB(PB,2,1)*FBBLL(2,O(PL),1,5)
     &                    -FBB(PB,1,2)*FBBLL(1,O(PL),2,5)
     &                    -FBB(PB,2,2)*FBBLL(2,O(PL),2,5)))
        MGAMP(1) = G(IDZ,PL)*(MGAMP(1)+MGAMP(3))
        MGAMP(2) = G(IDZ,PL)*(MGAMP(2)-MGAMP(3))
C--now square them
        FLOW(1,1) = FLOW(1,1)+DBLE(MGAMP(1)*DCONJG(MGAMP(1)))
        FLOW(1,2) = FLOW(1,2)+DBLE(MGAMP(2)*DCONJG(MGAMP(2)))
        FLOW(1,3) = FLOW(1,3)+TWO*DBLE(MGAMP(1)*DCONJG(MGAMP(2)))
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
C--add up the diagrams to obtain the amplitudes for the two colour flows
      FLOW(1,1) = CGFC*FLOW(1,1)
      FLOW(1,2) = CGFC*FLOW(1,2)
      FLOW(1,3) = CGIFC*FLOW(1,3)
      DO I=1,2
        IF(FLOW(1,3).NE.ZERO) THEN
          MG(I) = PG*FLOW(1,I)*(ONE+FLOW(1,3)/(FLOW(1,1)+FLOW(1,2)))
        ELSE
          MG(I) = PG*FLOW(1,I)
        ENDIF
      ENDDO
C--now q qbar --> q qbar Z
C--calculate the denominators
      DCF(1) = -TWO*QBL/D(1,2)
      DCF(2) = -TWO*QBBL/D(1,2)
      DCF(3) = -TWO*Q1L*QBB
      DCF(4) = +TWO*Q2L*QBB
      DCF(5) =  TWO*Q1LB*Q2BB
      DCF(6) = -TWO*Q2LB*Q1B
      DCF(7) =  TWO*QBL*Q2BB
      DCF(8) = -TWO*QBBL*Q1B
      PQ = ONE/PBQB/PBBQBB
      DO P1=1,2
      DO PL=1,2
      DO PB=1,2
      DO PBB=1,2
C--first the amplitudes for q qbar --> q' q'bar Z
C--the first two amplitudes have Z off the final state and therefore
C--the flavour of the incoming quarks doesn't matter
C--first amplitude from notes
        MQAMP(3,P1,PL,PB,PBB) = G(IDZ,PL)*(
     &     DCF(1)*(G(IQ,O(PL))*FBB(O(PB),  PL ,6)*
     &                ( FBLL(  PL ,  P1 ,5,1)*FBBB(  P1 ,O(PBB),2)
     &                 +FBLL(  PL ,O(P1),5,2)*FBBB(O(P1),O(PBB),1))
     &            +G(IQ,  PL )*FBB(O(PB),O(PL),5)*
     &                ( FBLL(O(PL),  P1 ,6,1)*FBBB(  P1 ,O(PBB),2)
     &                 +FBLL(O(PL),O(P1),6,2)*FBBB(O(P1),O(PBB),1)))
C--second amplitide from notes
     &    +DCF(2)*(G(IQ,O(PL))*FBBB(  PL ,O(PBB),5)*
     &          ( FBB(O(PB),  P1 ,1)*FBBLL(  P1 ,  PL ,2,6)
     &           +FBB(O(PB),O(P1),2)*FBBLL(O(P1),  PL ,1,6))
     &    +G(IQ,  PL )*FBBB(O(PL),O(PBB),6)*
     &          ( FBB(O(PB),  P1 ,1)*FBBLL(  P1 ,O(PL),2,5)
     &           +FBB(O(PB),O(P1),2)*FBBLL(O(P1),O(PL),1,5))))
C--third amplitide from notes
        DO I=1,2
           MQAMP(I,P1,PL,PB,PBB) = 
     &     DCF(3)*(G(I,O(PL))*DL(P1,O(PL))*S(5,1,  PL )*(
     &          S(1,6,O(PL))*( FBB(O(PB),  P1 ,1)*FBBB(  P1 ,O(PBB),2)
     &                        +FBB(O(PB),O(P1),2)*FBBB(O(P1),O(PBB),1))
     &         -S(5,6,O(PL))*( FBB(O(PB),  P1 ,5)*FBBB(  P1 ,O(PBB),2)
     &                        +FBB(O(PB),O(P1),2)*FBBB(O(P1),O(PBB),5)))
     &    +G(I,  PL )*DL(P1,  PL )*S(6,1,O(PL))*(
     &          S(1,5,  PL )*( FBB(O(PB),  P1 ,1)*FBBB(  P1 ,O(PBB),2)
     &                        +FBB(O(PB),O(P1),2)*FBBB(O(P1),O(PBB),1))
     &      -S(6,5,  PL )*( FBB(O(PB),  P1 ,6)*FBBB(  P1 ,O(PBB),2)
     &                     +FBB(O(PB),O(P1),2)*FBBB(O(P1),O(PBB),6))))
C--fourth amplitude from notes
           MQAMP(I,P1,PL,PB,PBB) = MQAMP(I,P1,PL,PB,PBB)
     &    +DCF(4)*(G(I,O(PL))*DL(P1,O(PL))*S(2,6,  P1 )*(
     &          S(5,2,  PL )*( FBB(O(PB),  P1 ,1)*FBBB(  P1 ,O(PBB),2)
     &                        +FBB(O(PB),O(P1),2)*FBBB(O(P1),O(PBB),1))
     &         -S(5,6,  PL )*( FBB(O(PB),  P1 ,1)*FBBB(  P1 ,O(PBB),6)
     &                        +FBB(O(PB),O(P1),6)*FBBB(O(P1),O(PBB),1)))
     &    +G(I,  PL )*DL(P1,  PL )*S(2,5,  P1 )*(
     &          S(6,2,O(PL))*( FBB(O(PB),  P1 ,1)*FBBB(  P1 ,O(PBB),2)
     &                        +FBB(O(PB),O(P1),2)*FBBB(O(P1),O(PBB),1))
     &        -S(6,5,O(PL))*( FBB(O(PB),  P1 ,1)*FBBB(  P1 ,O(PBB),5)
     &                      +FBB(O(PB),O(P1),5)*FBBB(O(P1),O(PBB),1))))
           MQAMP(I,P1,PL,PB,PBB) = G(IDZ,PL)*MQAMP(I,P1,PL,PB,PBB)
        ENDDO
C--now the extra amplitudes for q qbar --> q qbar Z
        DO P2=1,2
C--first amplitude for notes
           MQQAMP(P1,P2,PL,PB,PBB) =
     &   DCF(5)*(DL(P2,PBB)*S(8,4,PBB)*(
     &          G(IQ,O(PL))*DL(P1,O(PL))*S(5,1,  PL )*
     &             ( FBB(O(PB),  PBB,8)*F1LL(  P2  ,  PL ,2,6)
     &              +FBB(O(PB),O(P2),2)*F1LL(O(PBB),  PL ,8,6))
     &         +G(IQ,  PL )*DL(P1,  PL )*S(6,1,O(PL))*
     &             ( FBB(O(PB),  PBB ,8)*F1LL(  P2  ,O(PL),2,5)
     &              +FBB(O(PB),O(P2) ,2)*F1LL(O(PBB),O(PL),8,5)))
     &      -QM*DL(P2,O(PBB))*(
     &          G(IQ,O(PL))*DL(P1,O(PL))*S(5,1,PL)*
     &             ( FBB(O(PB),O(PBB),8)*F1LL(  P2  ,  PL ,2,6)
     &              +FBB(O(PB),O(P2) ,2)*F1LL(  PBB ,  PL ,8,6))
     &         +G(IQ,  PL )*DL(P1,  PL )*S(6,1,O(PL))*
     &             ( FBB(O(PB),O(PBB),8)*F1LL(  P2  ,O(PL),2,5)
     &              +FBB(O(PB), O(P2),2)*F1LL(  PBB ,O(PL),8,5))))
C--second amplitude from notes
           MQQAMP(P1,P2,PL,PB,PBB) = MQQAMP(P1,P2,PL,PB,PBB)
     &  +DCF(6)*(DL(P1,PB)*S(3,7,O(PB))*(
     &          G(IQ,O(PL))*DL(P2,O(PL))*S(2,6,  P2 )*
     &             ( F2LL(  PL ,  P1 ,5,1)*FBBB(  PB ,O(PBB),7)
     &              +F2LL(  PL ,O(PB),5,7)*FBBB(O(P1),O(PBB),1))
     &         +G(IQ,  PL )*DL(P2,  PL )*S(2,5,  P2 )*
     &             ( F2LL(O(PL),  P1 ,6,1)*FBBB(  PB ,O(PBB),7)
     &              +F2LL(O(PL),O(PB),6,7)*FBBB(O(P1),O(PBB),1)))
     &     -QM*DL(P1,O(PB))*(
     &          G(IQ,O(PL))*DL(P2,O(PL))*S(2,6,  P2 )*
     &             ( F2LL(  PL ,  P1 ,5,1)*FBBB(O(PB),O(PBB),7)
     &              +F2LL(  PL ,  PB ,5,7)*FBBB(O(P1),O(PBB),1))
     &         +G(IQ,  PL )*DL(P2,  PL )*S(2,5,  P2 )*
     &             ( F2LL(O(PL),  P1 ,6,1)*FBBB(O(PB),O(PBB),7)
     &              +F2LL(O(PL),  PB ,6,7)*FBBB(O(P1),O(PBB),1))))
C--third  amplitude from notes
           MQQAMP(P1,P2,PL,PB,PBB) = MQQAMP(P1,P2,PL,PB,PBB)
     &  +DCF(7)*(DL(P2,PBB)*S(8,4,PBB)*(
     &          G(IQ,O(PL))*FBB(O(PB),  PL ,6)*
     &             ( DL(P2,O(P1) )*S(2,1,  P2  )*FBLL(  PL , PBB ,5,8)
     &              +DL(P1,PBB   )*S(8,1,O(PBB))*FBLL(  PL ,O(P2),5,2))
     &         +G(IQ,  PL )*FBB(O(PB),O(PL),5)*
     &             ( DL(P2,O(P1) )*S(2,1,  P2  )*FBLL(O(PL), PBB ,6,8)
     &              +DL(P1,PBB   )*S(8,1,O(PBB))*FBLL(O(PL),O(P2),6,2)))
     &      -QM*DL(P2,O(PBB))*(
     &          G(IQ,O(PL))*FBB(O(PB),PL,6)*
     &             ( DL(P2,O(P1) )*S(2,1,  P2  )*FBLL(  PL ,O(PBB),5,8)
     &              +DL(P1,O(PBB))*S(8,1,  PBB )*FBLL(  PL ,O(P2) ,5,2))
     &         +G(IQ,  PL )*FBB(O(PB),O(PB),5)*
     &           ( DL(P2,O(PL) )*S(2,1,  P2  )*FBLL(O(PL),O(PBB),6,8)
     &            +DL(P1,O(PBB))*S(8,1,  PBB )*FBLL(O(PL),O(P2) ,6,2))))
C--fourth amplitude from notes
           MQQAMP(P1,P2,PL,PB,PBB) = MQQAMP(P1,P2,PL,PB,PBB)
     &  +DCF(8)*(DL(P1,PB)*S(3,7,O(PB))*(
     &          DL(P1,O(P2))*S(2,1,P2)*
     &           ( G(IQ,O(PL))*FBBLL(PB,  PL ,7,6)*FBBB(  PL ,O(PBB),5)
     &            +G(IQ,  PL )*FBBLL(PB,O(PL),7,5)*FBBB(O(PL),O(PBB),6))
     &         +DL(P2,PB)*S(2,7,P2)*
     &     (G(IQ,O(PL))*FBBLL(O(P1),  PL ,1,6)*FBBB(  PL ,O(PBB),5)
     &     +G(IQ,   PL )*FBBLL(O(P1),O(PL),1,5)*FBBB(O(PL),O(PBB),6)))
     &       +QM*DL(P1,O(PB))*(
     &          DL(P2,O(P1))*S(2,1,P2)*
     &        ( G(IQ,O(PL))*FBBLL(O(PB),  PL ,3,6)*FBBB(  PL ,O(PBB),5)
     &         +G(IQ,  PL )*FBBLL(O(PB),O(PL),3,5)*FBBB(O(PL),O(PBB),6))
     &          +DL(P2,O(PB))*S(2,3,P2)*
     &      ( G(IQ,O(PL))*FBBLL(O(P1),  PL ,1,6)*FBBB(  PL ,O(PBB),5)
     &      +G(IQ,  PL )*FBBLL(O(P1),O(PL),1,5)*FBBB(O(PL),O(PBB),6))))
           MQQAMP(P1,P2,PL,PB,PBB) =  G(IDZ,PL)*MQQAMP(P1,P2,PL,PB,PBB)
        ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
C--now obtain the matrix elements squared for the quarks
      DO I=1,3
         DO J=1,3
            FLOW(I,J) = ZERO
         ENDDO
      ENDDO
      IF(MOD(IQ,2).EQ.1) THEN
        IQI = 1
      ELSE
        IQI = 2
      ENDIF
      DO P1=1,2
      DO PL=1,2
      DO PB=1,2
      DO PBB=1,2
C--different quarks in inital and final states
         DO I=1,2
            MQP(I) = MQAMP(I,P1,PL,PB,PBB)+MQAMP(3,P1,PL,PB,PBB)
            FLOW(I,1) = FLOW(I,1)+DCONJG(MQP(I))*MQP(I)
         ENDDO
C--same quark in inital and final state
         DO P2=1,2
            FLOW(3,2) = FLOW(3,2)+
     &           DCONJG(MQQAMP(P1,P2,PL,PB,PBB))*MQQAMP(P1,P2,PL,PB,PBB)
           IF(P1.EQ.P2) THEN
              FLOW(3,1) = FLOW(3,1)+
     &             DCONJG(MQP(IQI))*MQP(IQI)
              FLOW(3,3) = FLOW(3,3)-TWO*
     &           DCONJG(MQP(IQI))*MQQAMP(P1,P2,PL,PB,PBB)
           ENDIF
         ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
C--split up the non-planar pieces according to Kosuke's prescription
      DO I=1,3
      FLOW(I,1) =  CQFC*FLOW(I,1)
      FLOW(I,2) =  CQFC*FLOW(I,2)
      FLOW(I,3) = CQIFC*FLOW(I,3)
        DO J=1,2
          IF(FLOW(I,J).NE.ZERO) THEN
             MQB(J,I) = PQ*FLOW(I,J)*
     &                            (ONE+FLOW(I,3)/(FLOW(I,1)+FLOW(I,2)))
          ELSE
             MQB(J,I) = ZERO
          ENDIF
        ENDDO
      ENDDO
C--now set them
      DO I=1,5
        IF(I.EQ.IQ) THEN
          DO J=1,2
            MQ(J,I) = MQB(J,3)
          ENDDO
        ELSEIF(MOD(I,2).EQ.1) THEN
          DO J=1,2
            MQ(J,I) = MQB(J,1)
          ENDDO
        ELSE
          DO J=1,2
            MQ(J,I) = MQB(J,2)
          ENDDO
        ENDIF
      ENDDO
      END
