CDECK  ID>, HWHIBQ.
*CMZ :-        -30/06/01  18.40.33  by  Stefano Moretti
*-- Author :  Stefano Moretti
C-----------------------------------------------------------------------
C...Generate completely differential cross section (EVWGT) in the variables
C...X(I) with I=1,6 (see below) for the process IPROC=3500, as described
C...in the HERWIG 6 documentation file.
C...It includes interface to PDFs and takes into account color connections
C...among partons.
C
C...First release: 12-APR-2000 by Stefano Moretti
C
C-----------------------------------------------------------------------
      SUBROUTINE HWHIBQ
C-----------------------------------------------------------------------
C     PRODUCTION OF MSSM CHARGED HIGGSES FROM B-QUARK+LIGHT-QUARK FUSION
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      INTEGER I,J,K,L,M,N
      INTEGER II,JJ,ITMP
      INTEGER IFL,IRES
      DOUBLE PRECISION EMQ,ENQ,EMQH,EMB,EMH,EMHWT,EMT,EMW
      DOUBLE PRECISION EMH01,EMH02,EMH03
      DOUBLE PRECISION WCKM,CKM,GAMT
      DOUBLE PRECISION X(6),XL(6),XU(6)
      DOUBLE PRECISION Q3(0:3),Q35(0:3)
      DOUBLE PRECISION Q1(5),Q2(5),H(5)
      DOUBLE PRECISION CT4,ST4,CT3,ST3,CF3,SF3,RQ42,RQ4,RQ32,RQ3,PQ3
      DOUBLE PRECISION P1(0:3),P2(0:3),P3(0:3),P4(0:3),P5(0:3)
      DOUBLE PRECISION ECM_MAX,ECM,SHAT,S,TAU
      DOUBLE PRECISION XTMP
      DOUBLE PRECISION EMIN1,EMIN2,PCM2,PCM
      DOUBLE PRECISION M2B,M2BBAR
      DOUBLE PRECISION ALPHA,EMSC2
      DOUBLE PRECISION HWRGEN,HWUAEM
      DOUBLE PRECISION PHI,CPHI,SPHI,ROT(3,3)
      DOUBLE PRECISION QAUX(0:3)
      DOUBLE PRECISION EPS,HCS,RCS,FACT,DIST
      DOUBLE PRECISION WEIGHT
      SAVE HCS,M2B,M2BBAR,FACT,S,WCKM,P3,P4,P5
      LOGICAL HWRLOG
      EXTERNAL HWRGEN,HWUAEM,HWH2BH,HWEONE,HWRLOG,
     &         HWUMAS,HWULOB
      EQUIVALENCE (EMB,RMASS(5)),(EMT,RMASS(6))
      EQUIVALENCE (EMW,RMASS(198))
      EQUIVALENCE (EMH01,RMASS(204)),
     &            (EMH02,RMASS(203)),
     &            (EMH03,RMASS(205))
      EQUIVALENCE (CKM,VCKM(3,3))
      PARAMETER (EPS=1.D-9)
      IF(GENEV)THEN
        RCS=HCS*HWRGEN(0)
      ELSE
        HCS=0.
        EVWGT=0.
C...assign final state masses.
        EMQ=0.
        ENQ=0
        EMH=RMASS(206)
        EMHWT=1.
C...assign top width.
        GAMT=HBAR/RLTIM(6)
C...energy at hadron level.
        ECM_MAX=PBEAM1+PBEAM2
        S=ECM_MAX*ECM_MAX
C...phase space variables.
C...X(1)=(EMQH-EMQ-EMH)/(ECM-EMQ-ENQ-EMH),
C...X(2)=1/[-(P2-P3)^2+MW^2],X(3)=COS(THETA4_CM_35),X(4)=FI4_CM_35,
C...X(5)=(1./SHAT-1./ECM_MAX**2)/(1./(EMQ+ENQ+EMH)**2-1./ECM_MAX**2),
C...X(6)=(LOG(TAU)-LOG(X1))/LOG(TAU);
C...phase space borders.
        XL(1)=0.
        XU(1)=1.
c...for XL(2),XU(2) see below (non constant).
        XL(3)=-1.
        XU(3)=1.
        XL(4)=0.
        XU(4)=2.*PIFAC
        XL(5)=0.
        XU(5)=1.
        XL(6)=0.
        XU(6)=1.
C...single phase space point.
 100    CONTINUE
        WEIGHT=1.
        DO I=1,6
          IF(I.EQ.2)GOTO 125
          X(I)=XL(I)+(XU(I)-XL(I))*HWRGEN(0)
          WEIGHT=WEIGHT*ABS(XU(I)-XL(I))
 125      CONTINUE
        END DO
C...energy at parton level.
        ECM=SQRT(1./(X(5)*(1./(EMQ+ENQ+EMH)**2-1./ECM_MAX**2)
     &                                        +1./ECM_MAX**2))
        IF((EMH.LE.0.).OR.(EMH.GE.ECM))RETURN
        SHAT=ECM*ECM
        TAU=SHAT/S
C...momentum fractions X1 and X2.
        XX(1)=EXP(LOG(TAU)*(1.-X(6)))
        XX(2)=TAU/XX(1)
C...incoming partons massless.
        EMIN1=0.
        EMIN2=0.
C...initial state momenta in the partonic CM.
        PCM2=((SHAT-EMIN1*EMIN1-EMIN2*EMIN2)**2
     &         -(2.*EMIN1*EMIN2)**2)/(4.*SHAT)
        PCM=SQRT(PCM2)
C...three particle kinematics.
        EMQH=X(1)*(ECM-EMQ-ENQ-EMH)+EMQ+EMH
        RQ42=((ECM*ECM-ENQ*ENQ-EMQH*EMQH)**2-(2.*ENQ*EMQH)**2)/
     &       (4.*ECM*ECM)
        IF(RQ42.LT.0.)THEN
          GOTO 100
        ELSE
          RQ4=SQRT(RQ42)
        ENDIF
C...X(2): integrate over W propagator.
        XL(2)=1./(4.*SQRT(PCM2+EMIN2*EMIN2)*RQ4+EMW*EMW)
        XU(2)=1./(EMW*EMW)
        X(2)=XL(2)+(XU(2)-XL(2))*HWRGEN(0)
        WEIGHT=WEIGHT*ABS(XU(2)-XL(2))
        XTMP=1./X(2)
        XTMP=(XTMP-EMW*EMW)/2./SQRT(PCM2+EMIN2*EMIN2)
        CT4=1.-XTMP/((SHAT-EMQH*EMQH+2.*ENQ*ENQ)/(2.*ECM))
        IF(CT4.GT.+1.)CT4=+1.
        IF(CT4.LT.-1.)CT4=-1.
        IF(HWRLOG(HALF))THEN
          ST4=+SQRT(1.-CT4*CT4)
        ELSE
          ST4=-SQRT(1.-CT4*CT4)
        END IF
        CT3=X(3)
        ST3=SQRT(1.-CT3*CT3)
        CF3=COS(X(4))
        SF3=SIN(X(4))
        P4(1)=0.
        P4(2)=-RQ4*ST4
        P4(3)=-RQ4*CT4
        P4(0)=SQRT(RQ42+ENQ*ENQ)
        DO I=1,3
          Q35(I)=-P4(I)
        END DO
        Q35(0)=SQRT(RQ42+EMQH*EMQH)
        RQ32=((EMQH*EMQH-EMH*EMH-EMQ*EMQ)**2-(2.*EMH*EMQ)**2)/
     &      (4.*EMQH*EMQH)
        IF(RQ32.LT.0.)THEN
          GOTO 100
        ELSE
          RQ3=SQRT(RQ32)
        ENDIF
        Q3(1)=RQ3*ST3*CF3
        Q3(2)=RQ3*ST3*SF3
        Q3(3)=RQ3*CT3
        Q3(0)=SQRT(RQ32+EMQ*EMQ)
        PQ3=0.
        DO I=1,3
          PQ3=PQ3+Q35(I)*Q3(I)
        END DO
        P3(0)=(Q35(0)*Q3(0)+PQ3)/EMQH
        P5(0)=Q35(0)-P3(0)
        DO I=1,3
          P3(I)=Q3(I)+Q35(I)*(P3(0)+Q3(0))/(Q35(0)+EMQH)
          P5(I)=Q35(I)-P3(I)
        END DO
C...initial state.
        P1(0)=SQRT(PCM2+EMIN1*EMIN1)
        P1(1)=0.
        P1(2)=0.
        P1(3)=PCM
        P2(0)=SQRT(PCM2+EMIN2*EMIN2)
        P2(1)=0.
        P2(2)=0.
        P2(3)=-PCM
C...option: top diagram removed if can be resonant to avoid double counting.
        IRES=1
C        IF((EMT-EMB-EMH).GE.0.)IRES=0
C...color structured ME summed/averaged over final/initial spins and colors.
C...IFL=+1 selects b.
        IFL=+1
        CALL HWH2BH(P1,P2,P3,P4,P5,EMW,EMH,EMH01,EMH02,EMH03,EMB,EMT,
     &              IFL,IRES,CKM,GAMT,M2B)
C...IFL=-1 selects b-bar.
        IFL=-1
        CALL HWH2BH(P1,P2,P3,P4,P5,EMW,EMH,EMH01,EMH02,EMH03,EMB,EMT,
     &              IFL,IRES,CKM,GAMT,M2BBAR)
C...constant factors: phi along beam and conversion GeV^2->nb.
        FACT=2.*PIFAC*GEV2NB
C...Jacobians from X1,X2 to X(5),X(6)
        FACT=FACT/S*(-LOG(TAU))*(1./(EMQ+ENQ+EMH)**2-1./ECM_MAX**2)
C...phase space Jacobians, pi's and flux.
        FACT=FACT*RQ3*RQ4/PCM/32./(2.*PIFAC)**5
     &      *(ECM-EMQ-ENQ-EMH)
        FACT=FACT/2./P2(0)/P4(0)
        FACT=FACT*(2.*P2(0)*P4(0)*(1.-CT4)+EMW*EMW)**2
C...EW couplings.
        EMSCA=EMQ+ENQ+EMH
        EMSC2=EMSCA*EMSCA
        ALPHA=HWUAEM(EMSC2)
        FACT=FACT*64.*PIFAC**3*ALPHA**3/4./SWEIN/SWEIN/SWEIN/EMW/EMW
C...Higgs resonance.
        FACT=FACT*EMHWT
C...constant weight.
        FACT=FACT*WEIGHT
      END IF
C...set up PDFs.
      HCS=0.
      CALL HWSGEN(.FALSE.)
      DO I=1,12
        IF(DISF(I,1).LT.EPS)THEN
          GOTO 200
        END IF
        DO J=1,12
          IF(DISF(J,2).LT.EPS)THEN
            GOTO 175
          END IF
          IF((I.NE.5).AND.(I.NE.11).AND.
     &       (J.NE.5).AND.(J.NE.11))THEN
            GOTO 150
          END IF
          II=J
          IF((I.NE.5).AND.(I.NE.11))II=I
          IF(II.GT.6)II=II-6
          ITMP=II
          II=(II+1)/2
          DIST=0.
          DO JJ=1,3
            WCKM=VCKM(II,JJ)
            IF((ITMP.EQ.5).AND.(II.EQ.3).AND.(JJ.EQ.3))WCKM=0.
            DIST=DIST+DISF(I,1)*DISF(J,2)*WCKM*S
          END DO
          IF((I.LE.6).AND.(J.LE.6))THEN
            HCS=HCS+M2B*DIST*FACT
          ELSE IF((I.LE.6).AND.(J.GE.7))THEN
            IF(J.NE.11)HCS=HCS+M2B*DIST*FACT
            IF(J.EQ.11)HCS=HCS+M2BBAR*DIST*FACT
          ELSE IF((I.GE.7).AND.(J.LE.6))THEN
            IF(I.NE.11)HCS=HCS+M2B*DIST*FACT
            IF(I.EQ.11)HCS=HCS+M2BBAR*DIST*FACT
          ELSE IF((I.GE.7).AND.(J.GE.7))THEN
            HCS=HCS+M2BBAR*DIST*FACT
          END IF
          IF(GENEV.AND.HCS.GT.RCS)THEN
C...generate event.
            IDN(1)=I
            IDN(2)=J
            IF((I.EQ.5).OR.(I.EQ.11))THEN
              K=I
              L=J+(-1)**(J+1)
              IDN(3)=K
              IDN(4)=L
            ELSE
              L=I+(-1)**(J+1)
              K=J
              IDN(3)=L
              IDN(4)=K
            END IF
            IF(IDN(2).EQ.IDN(4))THEN
              IDN(5)=
     &        NINT(198.5-.1667*FLOAT(ICHRG(IDN(1))-ICHRG(IDN(3))))
          ELSE
              IDN(5)=
     &        NINT(198.5-.1667*FLOAT(ICHRG(IDN(2))-ICHRG(IDN(4))))
            END IF
            IDN(5)=IDN(5)+8
C...sets up incoming status and IDs only for 2->1: use HWEONE.
            IDCMF=15
            CALL HWEONE
            JDAHEP(1,NHEP)=NHEP+1
            JDAHEP(2,NHEP)=NHEP+3
            JMOHEP(1,NHEP+1)=NHEP
            JMOHEP(1,NHEP+2)=NHEP
            JMOHEP(1,NHEP+3)=NHEP
C...randomly rotate final state momenta around beam axis.
            PHI=2.*PIFAC*HWRGEN(0)
            CPHI=COS(PHI)
            SPHI=SIN(PHI)
            ROT(1,1)=+CPHI
            ROT(1,2)=+SPHI
            ROT(1,3)=0.
            ROT(2,1)=-SPHI
            ROT(2,2)=+CPHI
            ROT(2,3)=0.
            ROT(3,1)=0.
            ROT(3,2)=0.
            ROT(3,3)=1.
            DO L=1,3
              DO M=1,3
                QAUX(M)=0.
                DO N=1,3
                  IF(L.EQ.1)QAUX(M)=QAUX(M)+ROT(M,N)*P3(N)
                  IF(L.EQ.2)QAUX(M)=QAUX(M)+ROT(M,N)*P4(N)
                  IF(L.EQ.3)QAUX(M)=QAUX(M)+ROT(M,N)*P5(N)
                END DO
              END DO
              DO M=1,3
                IF(L.EQ.1)P3(M)=QAUX(M)
                IF(L.EQ.2)P4(M)=QAUX(M)
                IF(L.EQ.3)P5(M)=QAUX(M)
              END DO
            END DO
C...outgoing momenta (give quark masses non covariantly!)
            DO M=1,3
              Q1(M)=P3(M)
              Q2(M)=P4(M)
              H( M)=P5(M)
            END DO
            Q1(4)=P3(0)
            Q2(4)=P4(0)
            H( 4)=P5(0)
            Q1(5)=RMASS(IDN(3))
            Q1(4)=SQRT(Q1(4)**2+Q1(5)**2)
            Q2(5)=RMASS(IDN(4))
            Q2(4)=SQRT(Q2(4)**2+Q2(5)**2)
            H(4)=-Q1(4)-Q2(4)+PHEP(5,NHEP)
            CALL HWUMAS(H)
            CALL HWULOB(PHEP(1,NHEP),Q1,PHEP(1,NHEP+1))
            CALL HWULOB(PHEP(1,NHEP),Q2,PHEP(1,NHEP+2))
            CALL HWULOB(PHEP(1,NHEP),H ,PHEP(1,NHEP+3))
C...sets up outgoing status and IDs.
            ISTHEP(NHEP+1)=113
            ISTHEP(NHEP+2)=114
            ISTHEP(NHEP+3)=114
            IDHW(NHEP+1)=IDN(3)
            IDHEP(NHEP+1)=IDPDG(IDN(3))
            IDHW(NHEP+2)=IDN(4)
            IDHEP(NHEP+2)=IDPDG(IDN(4))
            IDHW(NHEP+3)=IDN(5)
            IDHEP(NHEP+3)=IDPDG(IDN(5))
C...sets up colour connections.
            JMOHEP(2,NHEP+1)=NHEP-2
            JMOHEP(2,NHEP+2)=NHEP-1
            JMOHEP(2,NHEP-1)=NHEP+2
            JMOHEP(2,NHEP-2)=NHEP+1
            JMOHEP(2,NHEP+3)=NHEP+3
            JDAHEP(2,NHEP+1)=NHEP-2
            JDAHEP(2,NHEP+2)=NHEP-1
            JDAHEP(2,NHEP-1)=NHEP+2
            JDAHEP(2,NHEP-2)=NHEP+1
            JDAHEP(2,NHEP+3)=NHEP+3
            NHEP=NHEP+3
            IF(AZSPIN)THEN
C...set to zero the coefficients of the spin density matrices.
              CALL HWVZRO(7,GCOEF)
            END IF
            RETURN
          END IF
 150      CONTINUE
 175      CONTINUE
        END DO
 200    CONTINUE
      END DO
      EVWGT=HCS
      RETURN
 999  END
CDECK  ID>, HWHIGA.
*CMZ :-        -23/08/94  13.22.29  by  Mike Seymour
*-- Author :    Ulrich Baur & Nigel Glover, adapted by Ian Knowles
C-----------------------------------------------------------------------
      SUBROUTINE HWHIGA(S,T,U,EMH2,WTQQ,WTQG,WTGQ,WTGG)
C-----------------------------------------------------------------------
C     Gives amplitudes squared for q-qbar, q(bar)-g and gg -> Higgs +jet
C     IAPHIG (set in HWIGIN)=0: zero mass approximation =1: exact result
C                           =2: infinite mass limit.
C     Only top loop included. A factor (alpha_s**3*alpha_W) is extracted
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      DOUBLE COMPLEX HWHIGB,HWHIGC,HWHIGD,HWHIG5,HWHIG1,HWHIG2,BI(4),
     & CI(7),DI(3),EPSI,TAMP(7)
      DOUBLE PRECISION S,T,U,EMH2,WTQQ,WTQG,WTGQ,WTGG,EMW2,RNGLU,RNQRK,
     & FLUXGG,FLUXGQ,FLUXQQ,EMQ2,TAMPI(7),TAMPR(7)
      INTEGER I
      LOGICAL NOMASS
      EXTERNAL HWHIGB,HWHIGC,HWHIGD,HWHIG5,HWHIG1,HWHIG2
      COMMON/SMALL/EPSI
      COMMON/CINTS/BI,CI,DI
      EPSI=DCMPLX(ZERO,-1.D-10)
      EMW2=RMASS(198)**2
C Spin and colour flux factors plus enhancement factor
      RNGLU=1./FLOAT(NCOLO**2-1)
      RNQRK=1./FLOAT(NCOLO)
      FLUXGG=.25*RNGLU**2*ENHANC(6)**2
      FLUXGQ=.25*RNGLU*RNQRK*ENHANC(6)**2
      FLUXQQ=.25*RNQRK**2*ENHANC(6)**2
      IF (IAPHIG.EQ.2) THEN
C Infinite mass limit in loops
         WTGG=(2./3.)**2*FLOAT(NCOLO*(NCOLO**2-1))
     &       *(EMH2**4+S**4+T**4+U**4)/(S*T*U*EMW2)*FLUXGG
         WTQQ= 16./9.*(U**2+T**2)/(S*EMW2)*FLUXQQ
         WTQG=-16./9.*(U**2+S**2)/(T*EMW2)*FLUXGQ
         WTGQ=-16./9.*(S**2+T**2)/(U*EMW2)*FLUXGQ
         RETURN
      ELSEIF (IAPHIG.EQ.1) THEN
C Exact result for loops
         NOMASS=.FALSE.
      ELSEIF (IAPHIG.EQ.0) THEN
C Small mass approximation in loops
         NOMASS=.TRUE.
      ELSE
         CALL HWWARN('HWHIGA',500,*999)
      ENDIF
C Include only top quark contribution
      EMQ2=RMASS(6)**2
      BI(1)=HWHIGB(NOMASS,S,ZERO,ZERO,EMQ2)
      BI(2)=HWHIGB(NOMASS,T,ZERO,ZERO,EMQ2)
      BI(3)=HWHIGB(NOMASS,U,ZERO,ZERO,EMQ2)
      BI(4)=HWHIGB(NOMASS,EMH2,ZERO,ZERO,EMQ2)
      BI(1)=BI(1)-BI(4)
      BI(2)=BI(2)-BI(4)
      BI(3)=BI(3)-BI(4)
      CI(1)=HWHIGC(NOMASS,S,ZERO,ZERO,EMQ2)
      CI(2)=HWHIGC(NOMASS,T,ZERO,ZERO,EMQ2)
      CI(3)=HWHIGC(NOMASS,U,ZERO,ZERO,EMQ2)
      CI(7)=HWHIGC(NOMASS,EMH2,ZERO,ZERO,EMQ2)
      CI(4)=(S*CI(1)-EMH2*CI(7))/(S-EMH2)
      CI(5)=(T*CI(2)-EMH2*CI(7))/(T-EMH2)
      CI(6)=(U*CI(3)-EMH2*CI(7))/(U-EMH2)
      DI(1)=HWHIGD(NOMASS,U,T,EMH2,EMQ2)
      DI(2)=HWHIGD(NOMASS,S,U,EMH2,EMQ2)
      DI(3)=HWHIGD(NOMASS,S,T,EMH2,EMQ2)
C Compute complex amplitudes
      TAMP(1)=HWHIG1(S,T,U,EMH2,EMQ2,1,2,3,4,5,6)
      TAMP(2)=HWHIG2(S,T,U,EMH2,EMQ2,1,2,3,0,0,0)
      TAMP(3)=HWHIG1(T,S,U,EMH2,EMQ2,2,1,3,5,4,6)
      TAMP(4)=HWHIG1(U,T,S,EMH2,EMQ2,3,2,1,6,5,4)
      TAMP(5)=HWHIG5(S,T,U,EMH2,EMQ2,1,0,4,0,0,0)
      TAMP(6)=HWHIG5(T,S,U,EMH2,EMQ2,2,0,5,0,0,0)
      TAMP(7)=HWHIG5(U,T,S,EMH2,EMQ2,3,0,6,0,0,0)
      DO 20 I=1,7
      TAMPI(I)= DREAL(TAMP(I))
  20  TAMPR(I)=-DIMAG(TAMP(I))
C Square and add prefactors
      WTGG=0.03125*FLOAT(NCOLO*(NCOLO**2-1))/EMW2
     &    *(TAMPR(1)**2+TAMPI(1)**2+TAMPR(2)**2+TAMPI(2)**2
     &     +TAMPR(3)**2+TAMPI(3)**2+TAMPR(4)**2+TAMPI(4)**2)*FLUXGG
      WTQQ= 16.*(U**2+T**2)/(U+T)**2*EMQ2**2/(S*EMW2)
     &     *(TAMPR(5)**2+TAMPI(5)**2)*FLUXQQ
      WTQG=-16.*(U**2+S**2)/(U+S)**2*EMQ2**2/(T*EMW2)
     &     *(TAMPR(6)**2+TAMPI(6)**2)*FLUXGQ
      WTGQ=-16.*(S**2+T**2)/(S+T)**2*EMQ2**2/(U*EMW2)
     &     *(TAMPR(7)**2+TAMPI(7)**2)*FLUXGQ
 999  RETURN
      END
