CDECK  ID>, HWHS27.
*CMZ :-        -08/04/02  11:54:39  by  Peter Richardson
*-- Author :    Peter Richardson
C-----------------------------------------------------------------------
      SUBROUTINE HWHS27(ID,ME)
C-----------------------------------------------------------------------
C  Subroutine to calculate the helicity amplitudes for the 2-to-2 cross
C  section  f f ---> f fbar via s-channel scalar exchange
C  This is diagram 7 from RPV notes
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      INTEGER NDIAHD
      PARAMETER(NDIAHD=10)
      DOUBLE COMPLEX ME(2,2,2,2),S,D,F3(2,2,8),F4(2,2,8),PRE
     &     ,F3M(2,2,8),F4M(2,2,8),FST(2,2,8),ZI,
     &     FTP(2,2,8,8),FTM(2,2,8,8),FUP(2,2,8,8),FUM(2,2,8,8)
      DOUBLE PRECISION A(2,NDIAHD),B(2,NDIAHD),MS(NDIAHD),MWD(NDIAHD),
     &     MA(4),MA2(4),MR(NDIAHD),SH,TH,UH
      INTEGER P1,P3,P4,ID,O(2),IDP(4+NDIAHD),DRTYPE(NDIAHD)
      COMMON/HWSPHC/F3,F4,F3M,F4M,FTP,FTM,FUP,FUM,FST,A,B,MS,MWD,MR,MA,
     &     MA2,SH,TH,UH,IDP,DRTYPE
      COMMON/HWHEWS/S(8,8,2),D(8,8)
      DATA O/2,1/
      PARAMETER(ZI=(0.0D0,1.0D0))
C--compute the propagator factor
      PRE =-HALF/(SH-MS(ID)+ZI*MWD(ID))
      DO 10 P1=1,2
      DO 10 P3=1,2
      DO 10 P4=1,2
      ME(P1,O(P1),P3,P4) = (0.0D0,0.0D0)
 10   ME(P1,  P1 ,P3,P4) = PRE*A(P1,ID)*S(1,2,O(P1))*
     &     ( B(  P4 ,ID)*F3(O(P3),  P4 ,4)*S(4,8,P4)
     &      -B(O(P4),ID)*F3(O(P3),O(P4),8)*MA(4))
      END
