      PROGRAM PHOJET
C**********************************************************************
C
C     example to call PHOJET 1.04/1.05 using input cards
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      SAVE
C
C  *********** hp compiler settings ******************************
*     ON DOUBLE PRECISION UNDERFLOW IGNORE
*     ON REAL UNDERFLOW IGNORE
C  **************************************************************
C
      LINP = 5
      CALL PHOINP(LINP,IREJ)
      IF(IREJ.NE.0) WRITE(6,'(/1X,A,I8)') 'PHOEX1: ERROR IN PHOINP',IREJ
C
      END
C
C
      SUBROUTINE POLUHI(IMODE,WEIGHT)
C**********************************************************************
C
C     example histrograms using LUND /HEPEVT/
C
C     input:  IMODE      -1  initialization
C                        -2  output of results
C                         1  take event statistics
C             WEIGHT     weight of event (if necessary)
C                        for final output: corresponding cross section
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      PARAMETER (ZERO   =  0.D0,
     &           IZERO  =  0,
     &           ONE    =  1.D0,
     &           TWO    =  2.D0,
     &           OHALF  =  0.5D0,
     &           PI     =  3.14159265359D0,
     &           TWOPI  =  6.28318530718D0,
     &           TINY   =  1.D-10,
     &           DEPS   =  1.D-10)
C
      COMMON /GLOCMS/ ECM,PCM,PMASS(2),PVIRT(2),IFPAP(2),IFPAB(2)
C
C...Note that HEPEVT is in double precision (JETSET 7.4)
      PARAMETER (NMXHEP=2000)
      COMMON/HEPEVT/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     &JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
      DOUBLE PRECISION PHEP,VHEP
C
      CHARACTER*72 TITLE
      DIMENSION XLIMB(40)
C
C  extract statistics
C
      IF(IMODE.EQ.1) THEN
C
C  copy particle to /HEPEVT/
        CALL LUHEPC(1)
C
C  main particle loop
        DO 100 I=1,NHEP
C  final particle
          IF(ISTHEP(I).EQ.1) THEN
C  particle charge
            ICHAR = KLU(I,6)
            PT2 = PHEP(1,I)**2+PHEP(2,I)**2
            IF(PT2.LT.1.D-8) GOTO 99
            PABS = SQRT(PT2+PHEP(3,I)**2)
            IF(PABS.LT.1.D-8) GOTO 99
            PT = SQRT(PT2)
            IF(ABS(PHEP(3,I)).GE.PABS) GOTO 99
            THETA = ACOS(PHEP(3,I)/PABS)
            IF((THETA.LT.1.D-8)
     &        .OR.(PI-THETA.LT.1.D-8)) GOTO 99
C  pseudorapidity
            ETA = -LOG(TAN(THETA/TWO))
C  transverse energy
            ET = PHEP(4,I)*SIN(THETA)
C  rapidity
            PPLUS  = PHEP(4,I)+PHEP(3,I)
            PMINUS = PHEP(4,I)-PHEP(3,I)
            YY = -99999.D0
            IF((PPLUS*PMINUS).GT.DEPS) YY = OHALF*LOG(PPLUS/PMINUS)
C  charged particles
            IF(ICHAR.NE.0) THEN
              IPARTC = IPARTC+1
C  pt distribution of all charged hadrons
              CALL FILHIS(PT,WEIGHT/PT,ICPTTO)
C  rapidity distribution of all charged hadrons
              CALL FILHIS(YY,WEIGHT,IRAPC)
            ENDIF
          ENDIF
 99       CONTINUE
 100    CONTINUE
C
C  event ready, calculate statistical errors
        CALL ADDHIS(ICPTTO)
        CALL ADDHIS(IRAPC)
C
C  initialization
C
      ELSE IF(IMODE.EQ.-1) THEN
        XLIM1 = -2.*LOG(ECM)
        XLIM2 = 2.*LOG(ECM)
        CALL NEWHIS(ZERO,5.D0,ZERO,XLIMB,50,ICPTTO)
        CALL NEWHIS(XLIM1,XLIM2,ZERO,XLIMB,48,IRAPC)
C
C  final output
C
      ELSE IF(IMODE.EQ.-2) THEN
        FACMC = 1.D0
        FAC = WEIGHT*1.D06
        TITLE = 'PT DIST. CHARGED HADRONS DSIG/PT*DPT (nb/GeV**2)'
        CALL OUTHIS(ICPTTO,1,TITLE,FAC,0)
        TITLE = 'RAPIDITY CHARGED HADRONS DN/DETA (LAB SYSTEM)'
        CALL OUTHIS(IRAPC,0,TITLE,FACMC,0)
      ENDIF
      END
C
C
      SUBROUTINE POHIST(IMODE,WEIGHT)
C**********************************************************************
C
C     example histrograms using PHOJET /HEPEVS/ and /HEPEVE/
C
C     input:  IMODE      -1  initialization
C                        -2  output of results
C                         1  take event statistics
C             WEIGHT     weight of event (if necessary)
C                        for final output: corresponding cross section
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      PARAMETER (ZERO   =  0.D0,
     &           IZERO  =  0,
     &           ONE    =  1.D0,
     &           TWO    =  2.D0,
     &           OHALF  =  0.5D0,
     &           PI     =  3.14159265359D0,
     &           TWOPI  =  6.28318530718D0,
     &           TINY   =  1.D-10,
     &           DEPS   =  1.D-10)
C
      COMMON /GLOCMS/ ECM,PCM,PMASS(2),PVIRT(2),IFPAP(2),IFPAB(2)
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
      COMMON /PROCES/ IPROCE,IDNODF,IDIFR1,IDIFR2,IDDPOM,IPRON(15,4)
C
C...Note that HEPEVS is in double precision
      PARAMETER (NMXHEP=2000)
      COMMON/HEPEVS/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     &JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
      COMMON/HEPEVE/IMPART(NMXHEP),IPHIST(2,NMXHEP),ICOLOR(2,NMXHEP)
C
      CHARACTER*72 TITLE
      DIMENSION XLIMB(40)
C
C  extract statistics
C
      IF(IMODE.EQ.1) THEN
C
C  example for generator dependent information
        IHARDR = 0
        IHARDD = 0
        DO 50 I=1,NHEP
C  number of hard interactions
          IF(ISTHEP(I).EQ.25) THEN
C  hard diffractive/non-diffractive scattering?
            IF((IPROCE.GE.3).OR.(IPROCE.GE.7)) THEN
              IHARDD = IHARDD+1
            ELSE
              IHARDR = IHARDR+1
            ENDIF
          ENDIF
 50     CONTINUE
        CALL FILHIS(DBLE(IHARDR)+0.5D0,ONE,IHPOM)
C
C  main particle loop
        DO 100 I=1,NHEP
C  final particle
          IF(ISTHEP(I).EQ.1) THEN



            write(6,*) 'events done=', I


C  particle charge
            ICHAR = IPOCH3(I,2)/3
            PT2 = PHEP(1,I)**2+PHEP(2,I)**2
            IF(PT2.LT.1.D-8) GOTO 99
            PABS = SQRT(PT2+PHEP(3,I)**2)
            IF(PABS.LT.1.D-8) GOTO 99
            PT = SQRT(PT2)
            IF(ABS(PHEP(3,I)).GE.PABS) GOTO 99
            THETA = ACOS(PHEP(3,I)/PABS)
            IF((THETA.LT.1.D-8)
     &        .OR.(PI-THETA.LT.1.D-8)) GOTO 99
C  pseudorapidity
            ETA = -LOG(TAN(THETA/TWO))
C  rapidity
            YY = -1.D+10
            PPLUS  = PHEP(4,I)+PHEP(3,I)
            PMINUS = PHEP(4,I)-PHEP(3,I)
            IF((PPLUS*PMINUS).GT.DEPS) YY = 0.5D0*LOG(PPLUS/PMINUS)
C  transverse energy
            ET = PHEP(4,I)*SIN(THETA)
C  transverse energy density
            CALL FILHIS(ETA,ET,IEETA)
C  charged particles
            IF(ICHAR.NE.0) THEN
              IPARTC = IPARTC+1
C  pt distribution of all charged hadrons
              CALL FILHIS(PT,WEIGHT,ICPTTO)
C  pseudorapidity distribution of all charged hadrons
              CALL FILHIS(ETA,WEIGHT,IPSECL)
C  rapidity distribution of pi-
              IF(IDHEP(I).EQ.-211) THEN
                CALL FILHIS(YY,WEIGHT,IRAPIM)
                FAC = PHEP(4,I)*WEIGHT
                IF(ABS(PHEP(3,I)).LT.0.15D0) 
     &            CALL FILHIS(PT2,FAC,IPIMPT)
              ENDIF
            ENDIF
          ENDIF
 99       CONTINUE
 100    CONTINUE
C
C  event ready, calculate statistical errors
        CALL ADDHIS(IHPOM)
        CALL ADDHIS(IEETA)
        CALL ADDHIS(ICPTTO)
        CALL ADDHIS(IPSECL)
        CALL ADDHIS(IRAPIM)
        CALL ADDHIS(IPIMPT)
C
C  initialization
C
      ELSE IF(IMODE.EQ.-1) THEN
        CALL NEWHIS(ZERO,10.D0,ZERO,XLIMB,10,IHPOM)
        XLIM1 = -2.*LOG(ECM)
        XLIM2 = 2.*LOG(ECM)
        CALL NEWHIS(XLIM1,XLIM2,ZERO,XLIMB,48,IEETA)
        CALL NEWHIS(ZERO,5.D0,ZERO,XLIMB,50,ICPTTO)
        CALL NEWHIS(XLIM1,XLIM2,ZERO,XLIMB,48,IPSECL)
        XLIM1 = -1.D0
        XLIM2 = 6.D0
        CALL NEWHIS(XLIM1,XLIM2,ZERO,XLIMB,40,IRAPIM)
        XLIM1 = 0.D0
        XLIM2 = 1.D0
        CALL NEWHIS(XLIM1,XLIM2,ZERO,XLIMB,50,IPIMPT)
C
C  final output
C
      ELSE IF(IMODE.EQ.-2) THEN
        FACMC = 1.D0
        TITLE = 'NORMALIZED NUMBER OF HARD SCATTERINGS'
        CALL OUTHIS(IHPOM,1,TITLE,FACMC,1)
        TITLE = 'TRANSVERSE ENERGY DET/DETA (GeV)'
        CALL OUTHIS(IEETA,0,TITLE,FACMC,0)
        FAC = WEIGHT*1.D06
        TITLE = 'PT DIST. CHARGED HADRONS DSIG/DPT (nb/GeV)'
        CALL OUTHIS(ICPTTO,1,TITLE,FAC,0)
        TITLE = 'PSEUDORAPIDITY CHARGED HADRONS DN/DETA (LAB SYSTEM)'
        CALL OUTHIS(IPSECL,0,TITLE,FACMC,0)
        FAC = WEIGHT*1.D03
        TITLE = 'RAPIDITY PI- DSIG/DY (LAB SYSTEM)'
        CALL OUTHIS(IRAPIM,0,TITLE,FAC,0)
        TITLE = 'DSIG/DPT**2 for -0.15<p-long<0.15GeV vs. PT**2'
        CALL OUTHIS(IPIMPT,1,TITLE,FAC,0)
      ENDIF
      END
