C
C
      SUBROUTINE ID2BAM(ID1,ID2,NOBAM,IBAM1,IBAM2,IBAM3,IBAM4)
C*********************************************************************
C
C     conversion of quark numbering scheme
C
C     input:   standard particle codes:
C                       ID1
C                       ID2
C
C     output:  NOBAM    BAMJET string code
C              BAMJET particle codes:
C                       IBAM1
C                       IBAM2
C                       IBAM3
C                       IBAM4
C
C*********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      IDA1 = ABS(ID1)
      IDA2 = ABS(ID2)
C  quark antiquark jet
      IF((IDA1.LE.6).AND.(IDA2.LE.6)) THEN
        IF((ID1*ID2).GE.0) THEN
          WRITE(6,'(/1X,A,2I5)') 'ID2BAM:ERROR: NO CHAIN POSSIBLE ',
     &         ID1,ID2
          CALL POABRT
        ENDIF
        IBAM1 = ICONV2(ID1,0)
        IBAM2 = ICONV2(ID2,0)
        IBAM3 = 0
        IBAM4 = 0
        NOBAM = 3
C  quark diquark jet
      ELSE IF((IDA2.GT.6).AND.(IDA1.LE.6)) THEN
        IF((ID1*ID2).LE.0) THEN
          WRITE(6,'(/1X,A,2I5)') 'ID2BAM:ERROR: NO CHAIN POSSIBLE ',
     &         ID1,ID2
          CALL POABRT
        ENDIF
        IBAM1 = ICONV2(ID1,0)
        IBAM2 = ICONV2(ID2,1)
        IBAM3 = ICONV2(ID2,2)
        IBAM4 = 0
        NOBAM = 4
C  diquark quark jet
      ELSE IF((IDA1.GT.6).AND.(IDA2.LE.6)) THEN
        IF((ID1*ID2).LE.0) THEN
          WRITE(6,'(/1X,A,2I5)') 'ID2BAM:ERROR: NO CHAIN POSSIBLE ',
     &         ID1,ID2
          CALL POABRT
        ENDIF
        IBAM1 = ICONV2(ID1,1)
        IBAM2 = ICONV2(ID1,2)
        IBAM3 = ICONV2(ID2,0)
        IBAM4 = 0
        NOBAM = 6
C  diquark antidiquark jet
      ELSE IF((IDA1.GT.6).AND.(IDA2.GT.6)) THEN
        IF((ID1*ID2).GE.0) THEN
          WRITE(6,'(/1X,A,2I5)') 'ID2BAM:ERROR: NO CHAIN POSSIBLE ',
     &         ID1,ID2
          CALL POABRT
        ENDIF
        IBAM1 = ICONV2(ID1,1)
        IBAM2 = ICONV2(ID1,2)
        IBAM3 = ICONV2(ID2,1)
        IBAM4 = ICONV2(ID2,2)
        NOBAM = 5
      ENDIF
      END
