C
C
      SUBROUTINE PRBDIS(IP,ECM,IE)
C*********************************************************************
C
C     calculation of multi interactions probabilities
C
C     input:  IP        particle combination to scatter
C             ECM       CMS energy
C             IE        index for weight storing
C             COMMON /PROBAB/
C             IMAX      max. number of soft pomeron interactions
C             KMAX      max. number of hard pomeron interactions
C             LMAX      max. number of triple/loop-Pomeron interactions
C             MMAX      max. number of double-Pomeron interactions
C
C     output: COMMON /PROBAB/
C             PROB      field of probabilities
C
C*********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      PARAMETER(ZERO=0.D0,
     &         IZERO=0,
     &          IONE=1,
     &          ITWO=2,
     &        ITHREE=3,
     &         IFOUR=4,
     &         OHALF=0.5D0,
     &           ONE=1.D0,
     &           TWO=2.D0,
     &         THREE=3.D0,
     &          FOUR=4.D0,
     &         THOUS=1.D3,
     &         DDEPS=1.D-40,
     &          DEPS=1.D-20,
     &           EPS=1.D-10)
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
C
      COMMON /REGGE/  ALPOM,ALPOMP,GP(2),B0POM(2),
     &                ALREG,ALREGP,GR(2),B0REG(2),
     &                GPPP,GPPR,B0PPP,B0PPR,
     &                VDMFAC(4),VDMQ2F(4),B0HAR,AKFAC
      COMMON /TWOCHA/ PHISUP(2),RMASS1,RMASS2,VAR
C
      PARAMETER ( MAXPRO = 16 )
      COMPLEX*16      SIGP,SIGR,SIGHD,SIGHR,SIGT1,SIGT2,SIGL,SIGDP,
     &                SIGD1,SIGD2,DSIGH
      COMMON /SIGMAS/ SIGP,SIGR,SIGHD,SIGHR,SIGT1(2),SIGT2(2),SIGL,
     &                SIGDP(4),SIGD1(2),SIGD2(2),DSIGH(0:MAXPRO)
C
      COMMON /XSECTP/ SIGTOT,SIGELA,SIGVM(0:4,0:4),SIGINE,SIGDIR,
     &                SIGLSD(2),SIGHSD(2),SIGLDD,SIGHDD,SIGCDF,
     &                SIGPOM,SIGREG,SIGHAR,SIGTR1,SIGTR2,SIGLOO,SIGDPO,
     &                SIG1SO,SIG1HA,SLOEL,SLOVM(4,4),SIGGEN(4),
     &                FSUP(2)
C
      PARAMETER(IEETAB=20,IIMAX=30,KKMAX=10,LLMAX=2,MMMAX=1)
      REAL PROB
      COMMON /PROBAB/ PROB(4,IEETAB,0:IIMAX,0:KKMAX),EPTAB(4,IEETAB),
     &                IEEMAX,IMAX,KMAX
      COMMON /XSETAB/ SIGTAB(4,70,IEETAB),SIGECM(4,IEETAB),ISIMAX
      COMMON /AVKLMN/ AVERI,AVERK,AVERL,AVERM,AVERN
      COMMON /HACONS/ PI,PI2,PI4,GEV2MB
      COMMON /HAGAUP/ NGAUP1,NGAUP2,NGAUET,NGAUIN,NGAUSO
      CHARACTER*8 MDLNA
      COMMON /MODELS/ MDLNA(50),ISWMDL(50),PARMDL(200),IPAMDL(200)
C
      PARAMETER(MDIM=5)
      COMMON /ZXEIKS/ XM(MDIM,MDIM),XOUT(MDIM,MDIM),
     &                XIN(MDIM),XOU(MDIM),
     &                ZXP(MDIM,MDIM),BXP(MDIM,MDIM),
     &                ZXR(MDIM,MDIM),BXR(MDIM,MDIM),
     &                ZXH(MDIM,MDIM),BXH(MDIM,MDIM),
     &                ZXD(MDIM,MDIM),BXD(MDIM,MDIM),
     &                ZXT1A(MDIM,MDIM),BXT1A(MDIM,MDIM),
     &                ZXT1B(MDIM,MDIM),BXT1B(MDIM,MDIM),
     &                ZXT2A(MDIM,MDIM),BXT2A(MDIM,MDIM),
     &                ZXT2B(MDIM,MDIM),BXT2B(MDIM,MDIM),
     &                ZXL(MDIM,MDIM),BXL(MDIM,MDIM),
     &                ZXDP(MDIM,MDIM),BXDP(MDIM,MDIM),
     &                ZXD1A(MDIM,MDIM),BXD1A(MDIM,MDIM),
     &                ZXD1B(MDIM,MDIM),BXD1B(MDIM,MDIM),
     &                ZXD2A(MDIM,MDIM),BXD2A(MDIM,MDIM),
     &                ZXD2B(MDIM,MDIM),BXD2B(MDIM,MDIM)
C  local variables
      DIMENSION  AB(4,4),CHI2(4),ABSUM2(4,4),ABSTMP(4),CHITMP(4)
      PARAMETER (ICHMAX=40)
      DIMENSION  CHIFAC(4,4),ELAFAC(4),PCHAIN(2,ICHMAX)
C
      DIMENSION AMPFAC(4),XPNT(96),WGHT(96)
      DIMENSION FACLOG(0:30),PSOFT(0:30),PHARD(0:20)
C  combinatorical factors
      DATA      CHIFAC / 1.D0, 1.D0,-1.D0,-1.D0,
     &                   1.D0,-1.D0, 1.D0,-1.D0,
     &                   1.D0,-1.D0,-1.D0, 1.D0,
     &                   1.D0, 1.D0, 1.D0, 1.D0 /
      DATA FACLOG /           .000000000000000D+00,
     &  .000000000000000D+00, .693147180559945D+00,
     &  .109861228866811D+01, .138629436111989D+01,
     &  .160943791243410D+01, .179175946922805D+01,
     &  .194591014905531D+01, .207944154167984D+01,
     &  .219722457733622D+01, .230258509299405D+01,
     &  .239789527279837D+01, .248490664978800D+01,
     &  .256494935746154D+01, .263905732961526D+01,
     &  .270805020110221D+01, .277258872223978D+01,
     &  .283321334405622D+01, .289037175789616D+01,
     &  .294443897916644D+01, .299573227355399D+01,
     &  .304452243772342D+01, .309104245335832D+01,
     &  .313549421592915D+01, .317805383034795D+01,
     &  .321887582486820D+01, .325809653802148D+01,
     &  .329583686600433D+01, .333220451017520D+01,
     &  .336729582998647D+01, .340119738166216D+01 /
C
      DATA  ELAST / 0.D0 /
C
C  test for redundant calculation: skip cs calculation
      IF(ECM.NE.ELAST) THEN
        ELAST = ECM
        CALL POXSEC(IP,ELAST)
        ISIMAX = IE
        SIGECM(IP,IE) = ECM
        SIGTAB(IP,1,IE) = SIGTOT
        SIGTAB(IP,2,IE) = SIGELA
        J = 2
        DO 5 I=0,4
          DO 6 K=0,4
            J = J+1
            SIGTAB(IP,J,IE) = SIGVM(I,K)
 6        CONTINUE
 5      CONTINUE
        SIGTAB(IP,28,IE) = SIGINE
        SIGTAB(IP,29,IE) = SIGDIR
        SIGTAB(IP,30,IE) = SIGLSD(1)
        SIGTAB(IP,31,IE) = SIGLSD(2)
        SIGTAB(IP,32,IE) = SIGHSD(1)
        SIGTAB(IP,33,IE) = SIGHSD(2)
        SIGTAB(IP,34,IE) = SIGLDD
        SIGTAB(IP,35,IE) = SIGHDD
        SIGTAB(IP,36,IE) = SIGCDF
        SIGTAB(IP,37,IE) = SIG1SO
        SIGTAB(IP,38,IE) = SIG1HA
        SIGTAB(IP,39,IE) = SLOEL
        J = 39
        DO 7 I=1,4
          DO 8 K=1,4
            J = J+1
            SIGTAB(IP,J,IE) = SLOVM(I,K)
 8        CONTINUE
 7      CONTINUE
        FAC = (VDMQ2F(1)+VDMQ2F(2))*(VDMQ2F(3)+VDMQ2F(4))
        SIGTAB(IP,56,IE) = SIGPOM*FAC
        SIGTAB(IP,57,IE) = SIGREG*FAC
        SIGTAB(IP,58,IE) = DREAL(DSIGH(9))
        SIGTAB(IP,59,IE) = DREAL(DSIGH(15))
        SIGTAB(IP,60,IE) = SIGTR1
        SIGTAB(IP,61,IE) = SIGTR2
        SIGTAB(IP,62,IE) = SIGLOO
        SIGTAB(IP,63,IE) = SIGDPO
      ENDIF
C
*     BMAX=5.D0*SQRT(DBLE(BPOM))
      BMAX=10.D0
      EPTAB(IP,IE) = ECM
C
      CALL GSET(ZERO,BMAX,NGAUSO,XPNT,WGHT)
      DO 160 K=0,KMAX
        DO 170 I=0,IMAX
          PROB(IP,IE,I,K) = ZERO
 170    CONTINUE
 160  CONTINUE
      DO 120 I=1,ICHMAX
        PCHAIN(1,I) = ZERO
        PCHAIN(2,I) = ZERO
 120  CONTINUE
C
      SIGRES = SIGTOT-SIGELA-SIGVM(0,0)-SIGCDF-SIGDIR
     &       - SIGLSD(1)-SIGLSD(2)-SIGLDD
      AUXFAC = PI2/SIGRES
      IF(ISWMDL(1).EQ.3) THEN
        AMPFAC(1) = SQRT(VDMQ2F(1)*VDMQ2F(3))
        AMPFAC(2) = SQRT(VDMQ2F(2)*VDMQ2F(3))
        AMPFAC(3) = SQRT(VDMQ2F(1)*VDMQ2F(4))
        AMPFAC(4) = SQRT(VDMQ2F(2)*VDMQ2F(4))
        ELAFAC(1) = (VDMQ2F(1)*VDMQ2F(3)+VDMQ2F(2)*VDMQ2F(3)
     &              +VDMQ2F(1)*VDMQ2F(4)+VDMQ2F(2)*VDMQ2F(4))/FOUR
        ELAFAC(2) = (AMPFAC(1)*AMPFAC(2)+AMPFAC(3)*AMPFAC(4))/TWO
        ELAFAC(3) = (AMPFAC(1)*AMPFAC(3)+AMPFAC(2)*AMPFAC(4))/TWO
        ELAFAC(4) = AMPFAC(1)*AMPFAC(4)
        DO 133 I=1,4
          AMPFAC(I) = ZERO
          DO 135 K=1,4
            AMPFAC(I) = AMPFAC(I) + ELAFAC(K)*CHIFAC(K,I)
 135      CONTINUE
          AMPFAC(I) = AMPFAC(I)*AUXFAC
 133    CONTINUE
      ENDIF
C
C  main cross section loop
C**********************************************************
      DO 5000 IB=1,NGAUSO
        B24=XPNT(IB)**2/FOUR
        FAC = XPNT(IB)*WGHT(IB)
C
        IF((ISWMDL(1).EQ.3).OR.(ISWMDL(1).EQ.4)) THEN
C
C  amplitude construction
          DO 525 I=1,4
            AB(1,I)=ZXP(1,I)*EXP(-B24/BXP(1,I))
     &              +ZXR(1,I)*EXP(-B24/BXR(1,I))
            AB(2,I)=ZXH(1,I)*EXP(-B24/BXH(1,I))
            AB(3,I)=-ZXT1A(1,I)*EXP(-B24/BXT1A(1,I))
     &              -ZXT1B(1,I)*EXP(-B24/BXT1B(1,I))
     &              -ZXT2A(1,I)*EXP(-B24/BXT2A(1,I))
     &              -ZXT2B(1,I)*EXP(-B24/BXT2B(1,I))
     &              -ZXL(1,I)*EXP(-B24/BXL(1,I))
            AB(4,I)=ZXDP(1,I)*EXP(-B24/BXDP(1,I))
*
*           CHKSUM = AB(2,I)/(AB(1,I)+AB(2,I))
            CHKSUM = 0.D0
            AB(1,I) = AB(1,I)+(AB(3,I)+AB(4,I))*(1.D0-CHKSUM)
            AB(2,I) = AB(2,I)+(AB(3,I)+AB(4,I))*CHKSUM
            AB(3,I) = ZERO
            AB(4,I) = ZERO
*
 525      CONTINUE
C
          DO 460 I=1,4
            DO 500 K=1,4
              ABSUM2(I,K) = ZERO
              DO 550 L=1,4
                ABSUM2(I,K) = ABSUM2(I,K) + CHIFAC(L,K)*AB(I,L)
 550          CONTINUE
              ABSUM2(I,K) = TWO*ABSUM2(I,K)
 500        CONTINUE
 460      CONTINUE
          DO 600 I=1,4
            CHI2(I) = ZERO
            DO 650 K=1,4
              CHI2(I) = CHI2(I) + ABSUM2(K,I)
 650        CONTINUE
 600      CONTINUE
C  sums instead of products
          DO 660 I=1,4
            DO 670 KD=1,4
              DTMP = ABS(ABSUM2(I,KD))
              IF(DTMP.LT.1.D-30) THEN
                ABSUM2(I,KD) = -50.D0
              ELSE
                ABSUM2(I,KD) = LOG(DTMP)
              ENDIF
 670        CONTINUE
 660      CONTINUE
C
          DO 700 KD=1,4
            DO 750 I=1,4
              ABSTMP(I) = ABSUM2(I,KD)
 750        CONTINUE
C  recursive sum
            CHITMP(1) = -ABSUM2(1,KD)
            DO 800 I=0,IMAX
              CHITMP(1) = CHITMP(1)+ABSTMP(1)-FACLOG(I)
              CHITMP(2) = -ABSTMP(2)
              DO 810 K=0,KMAX
                CHITMP(2) = CHITMP(2)+ABSTMP(2)-FACLOG(K)
C  calculation of elastic part
                DTMP = -CHI2(KD)+CHITMP(1)+CHITMP(2)
                IF(DTMP.LT.-30.D0) THEN
                  DTMP = ZERO
                ELSE
                  DTMP = EXP(DTMP)*FAC*AMPFAC(KD)
                ENDIF
                PROB(IP,IE,I,K) = PROB(IP,IE,I,K) + DTMP
 810          CONTINUE
 800        CONTINUE
 700      CONTINUE
          PROB(IP,IE,0,0) = ZERO
C
C**********************************************************
        ELSE
          WRITE(6,'(1X,A,I2,A)') 'PRBDIS: ERROR: model no ',ISWMDL(1),
     &                       ' not supported'
          STOP
        ENDIF
 5000 CONTINUE
C
C  debug output
      IF(IDEB(55).GE.15) THEN
        WRITE(6,'(/,1X,A,I3,E11.4)')
     &    'PRBDIS:DEBUG:LIST OF PROBABILITIES (UNCORRECTED),IP,ECM:',
     &    IP,ECM
        DO 905 I=0,MIN(IMAX,5)
          DO 915 K=0,MIN(KMAX,5)
            IF(ABS(PROB(IP,IE,I,K)).GT.1.D-10)
     &        WRITE(6,'(10X,2I3,5X,E12.3)') I,K,PROB(IP,IE,I,K)
 915      CONTINUE
 905    CONTINUE
      ENDIF
C  chain probability (uncorrected)
      IF(IDEB(55).GE.5) THEN
        DO 955 I=0,IMAX
          DO 965 K=0,KMAX
            INDX = 2*I+2*K
            IF((INDX.LE.ICHMAX).AND.(INDX.GT.0)) THEN
              PCHAIN(1,INDX) = PCHAIN(1,INDX) + PROB(IP,IE,I,K)
            ENDIF
 965      CONTINUE
 955    CONTINUE
        WRITE(6,'(/1X,A,E11.4)')
     &  'PRBDIS:DEBUG:LIST OF SELECTED PROBABILITIES (UNCORR),ECM',ECM
        WRITE(6,'(10X,A)') 'I,   0HPOM,   1HPOM,   2HPOM'
        DO 183 I=0,IIMAX
          IF(ABS(PROB(IP,IE,I,0)).GT.1.D-10)
     &      WRITE(6,'(5X,I4,3E12.4)') I,PROB(IP,IE,I,0),
     &      PROB(IP,IE,I,1),PROB(IP,IE,I,2)
 183    CONTINUE
      ENDIF
C
C  probability check
      CHKSUM = ZERO
      PRONEG = ZERO
      AVERI =  ZERO
      AVERK =  ZERO
      AVERL =  ZERO
      AVERM =  ZERO
      AVERN =  ZERO
      SIGMI =  ZERO
      SIGMK =  ZERO
      SIGML =  ZERO
      SIGMM =  ZERO
      DO 1001 I=0,IMAX
        PSOFT(I) = 0.D0
 1001 CONTINUE
      DO 1002 K=0,KMAX
        PHARD(K) = 0.D0
 1002 CONTINUE
      DO 1000 K=0,KMAX
        DO 1010 I=0,IMAX
          TMP = PROB(IP,IE,I,K)
          IF(TMP.LT.ZERO) THEN
            IF((IDEB(55).GE.0).AND.(TMP.LT.-EPS)) THEN
              WRITE(6,'(1X,A,4I4,E14.4)')
     &          'PRBDIS:WARNING: NEG.PROBABILITY ',
     &              IP,IE,I,K,PROB(IP,IE,I,K)
            ENDIF
            PRONEG = PRONEG+TMP
            TMP = ZERO
          ENDIF
          CHKSUM = CHKSUM+TMP
          AVERI = AVERI+DBLE(I)*TMP
          AVERK = AVERK+DBLE(K)*TMP
          SIGMI = SIGMI+DBLE(I**2)*TMP
          SIGMK = SIGMK+DBLE(K**2)*TMP
          PSOFT(I) = PSOFT(I)+PROB(IP,IE,I,K)
          PHARD(K) = PHARD(K)+PROB(IP,IE,I,K)
          PROB(IP,IE,I,K) = CHKSUM
 1010   CONTINUE
 1000 CONTINUE
C
      IF(IDEB(55).GE.1) WRITE(6,'(/,1X,A,2E15.6)')
     &  'PRBDIS:DEBUG:FIRST SUM OF PROBABILITIES',CHKSUM,PRONEG
C  chain probabilites output
      IF(IDEB(55).GE.5) THEN
        WRITE(6,'(/1X,A)') 'LIST OF CHAIN PROBABILITIES (UNCORR/CORR)'
        DO 185 I=1,ICHMAX
          IF(ABS(PCHAIN(1,I)).GT.1.D-10)
     &      WRITE(6,'(5X,I4,2E12.3)') I,PCHAIN(1,I),PCHAIN(1,I)/CHKSUM
 185    CONTINUE
      ENDIF
C  rescaling necessary
      IF(ABS(CHKSUM-ONE).GT.1.D-15) THEN
        FAC = ONE/CHKSUM
        IF(IDEB(55).GE.1) WRITE(6,'(/,1X,A,E15.6)')
     &    'PRBDIS:DEBUG:RESCALING OF PROBABILITIES WITH FACTOR',FAC
        DO 40 K=0,KMAX
          DO 50 I=0,IMAX
            PROB(IP,IE,I,K) = PROB(IP,IE,I,K)*FAC
  50      CONTINUE
  40    CONTINUE
        AVERI = AVERI*FAC
        AVERK = AVERK*FAC
        AVERL = AVERL*FAC
        AVERM = AVERM*FAC
        SIGMI = SIGMI*FAC**2
        SIGMK = SIGMK*FAC**2
        SIGML = SIGML*FAC**2
        SIGMM = SIGMM*FAC**2
      ENDIF
C
C  probability to find Reggeon/Pomeron
      PROB(IP,IE,0,0) = -SIGREG/(SIGPOM+SIGREG)
      AVERJ = -PROB(IP,IE,0,0)*AVERI
      AVERII = AVERI-AVERJ
C
      SIGTAB(IP,64,IE) = AVERII
      SIGTAB(IP,65,IE) = AVERK
      SIGTAB(IP,66,IE) = AVERJ
      SIGTAB(IP,67,IE) = AVERL
      SIGTAB(IP,68,IE) = AVERM
C
      SIGTAB(IP,69,IE) = PROB(IP,IE,IMAX,0)*SIGRES
      SIGTAB(IP,70,IE) = SIGRES-SIGTAB(IP,69,IE)
C
      IF(IDEB(55).GE.1) THEN
        WRITE(6,'(/1X,A,/1X,A)')
     &    'PRBDIS:DEBUG:EXPECTED INTERACTION STATISTICS:',
     &    '============================================='
        WRITE(6,'(1X,A,E12.4,2I3)')
     &    'ENERGY,IP,TABLE INDEX:',EPTAB(IP,IE),IP,IE
        WRITE(6,'(1X,A,2I4)') 'CURRENT LIMITATIONS (soft,hard):',
     &    IMAX,KMAX
        WRITE(6,'(1X,A,E12.4/,4X,A,/,1X,6E11.3)')
     &    'AVERAGED NUMBER OF CUTS PER EVENT (eff. cs):',SIGRES,
     &    ' (Pom / Pom-h / Reg / enh-tri-loop / enh-dble / sum):',
     &    AVERII,AVERK,AVERJ,AVERL,AVERM,
     &    AVERI+AVERK+AVERL+AVERM
        WRITE(6,'(1X,A,/,4X,A,/,1X,4E11.3)')
     &    'STANDARD DEVIATION ( SQRT(SIGMA) ):',
     &    ' (Pomeron / Pomeron-h / enh-tri-loop / enh-dble):',
     &    SQRT(ABS(SIGMI-AVERI**2)),SQRT(ABS(SIGMK-AVERK**2)),
     &    SQRT(ABS(SIGML-AVERL**2)),SQRT(ABS(SIGMM-AVERM**2))
        WRITE(6,'(1X,A)') 'CROSS SECTION / PROBABILITY  SOFT, HARD'
        DO 1003 I=0,MIN(IMAX,KMAX)
          WRITE(6,'(I5,2E12.4,3X,2E12.4)') 
     &      I,PSOFT(I)*SIGRES,PSOFT(I),PHARD(I)*SIGRES,PHARD(I)
 1003   CONTINUE
      ENDIF
      END
