C
C
      SUBROUTINE SDECY2(UMO,AM1,AM2,ISP)
C**********************************************************************
C
C     isotropic/anisotropic two particle decay in CM system,
C     (transversally polarized boson into two pseudo-scalar mesons)
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      SAVE
C
      PARAMETER (ZERO   = 0.D0,
     &           ONE    = 1.D0,
     &           TWO    = 2.D0 )
C
      COMMON /DECPHS/ ECM(3),PCM(3),COD(3),COF(3),SIF(3)
C
      UMO2=UMO*UMO
      AM11=AM1*AM1
      AM22=AM2*AM2
      ECM(1)=(UMO2+AM11-AM22)/(TWO*UMO)
      ECM(2)=UMO-ECM(1)
      WAU=ECM(1)*ECM(1)-AM11
      IF(WAU.LT.ZERO) THEN
        WRITE(6,'(/1X,A,E12.4)') 'SDECY2:ERROR:TOO SMALL MASS',WAU
        CALL POABRT
      ENDIF
      PCM(1)=SQRT(WAU)
      PCM(2)=PCM(1)
C
      CALL SFECFE(SIF(1),COF(1))
      IF(ISP.EQ.0) THEN
C  no polarization
        COD(1)  = TWO*RNDM(UMO)-ONE
      ELSE IF(ISP.EQ.1) THEN
C  transverse polarization
 400    CONTINUE
          COD(1)  = TWO*RNDM(AM22)-ONE
          SID12 = ONE-COD(1)*COD(1)
        IF(SID12.LT.RNDM(AM1)) GOTO 400
      ELSE IF(ISP.EQ.2) THEN
C  longitudinal polarization
 500    CONTINUE
          COD(1)  = TWO*RNDM(AM2)-ONE
          COD12 = COD(1)*COD(1)
        IF(COD12.LT.RNDM(AM11)) GOTO 500
      ELSE
        WRITE(6,'(/1X,A,I3)') 'SDECY2:ERROR:INVALID POLARIZATION',ISP
        CALL POABRT
      ENDIF
C
      COD(2) = -COD(1)
      COF(2) = -COF(1)
      SIF(2) = -SIF(1)
      END
