C
C
      SUBROUTINE XINP(FILENA)
C*********************************************************************
C
C     read cross section data to perform fit
C
C     input parameter: FILENA name of input file
C
C*********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
      CHARACTER*(*) FILENA
C
      PARAMETER(NECM=200,NPAR=30)
      CHARACTER*6 HINT
      COMMON /FITTYP/IFIT,NIST,ECMS(NECM),XTOT(NECM),XTOTE(NECM),
     &               XELA(NECM),XELAE(NECM),XINE(NECM),
     &               XINEE(NECM),XSDI(NECM),XSDIE(NECM),
     &               SLO(NECM),SLOE(NECM),XPRO(3,NECM),XPROE(3,NECM),
     &               XI(NPAR),XINC(NPAR),NFITP,HINT(NPAR),IFITF(NPAR)
      PARAMETER(MAXKK=20,MAXDS=20)
      COMMON /DSIGEL/ DSDT(MAXKK,3,MAXDS),DSIGI(3,MAXKK)
      PARAMETER(ZERO=0.D0,
     &          ONEM=-1.D0,
     &          IZERO=0,
     &          ONE  =1.D0,
     &          TWO  =2.D0,
     &          THREE=3.D0,
     &          FOUR =4.D0)
C
      CHARACTER*6 CNAME
      CHARACTER*76 NUMBER
C  initialization
      DO 200 I=1,NECM
         XTOT(I) = ONEM
         XELA(I) = ONEM
         XINE(I) = ONEM
         XSDI(I) = ONEM
         SLO(I)  = ONEM
         XPRO(1,I) = ONEM
         XPRO(2,I) = ONEM
         XPRO(3,I) = ONEM
 200  CONTINUE
      DO 205 I=1,MAXKK
         DSIGI(2,I)=ZERO
 205  CONTINUE
C  read input data cards
      OPEN(2,FILE=FILENA,STATUS='OLD',ERR=900)
 10   FORMAT(A6,A74)
C12   FORMAT(1X,A4,2X,9F10.3)
 12   FORMAT(1X,A6,2X,3F10.4)
      I  = IZERO
      K  = IZERO
      KK = IZERO
 100  CONTINUE
        READ(2,10) CNAME,NUMBER
        IF(CNAME.EQ.'STOP  ') GOTO 1000
        IF(CNAME.EQ.'ECMS  ') THEN
          IF(I.EQ.NECM) THEN
            WRITE(6,*)
     &      ' *** ERROR: input X sections excceed array size ***'
            WRITE(6,*)' following data cards ignored'
            GOTO 1000
          ENDIF
          I=I+1
          READ(NUMBER,*) ECMS(I)
          WRITE(6,*) 'ECMS  ',ECMS(I)
        ELSE IF(CNAME.EQ.'XTOT  ') THEN
          K=K+1
          READ(NUMBER,*) XTOT(I),XTOTE(I)
          WRITE(6,'(1X,A,2E15.3)') 'XTOT  ',XTOT(I),XTOTE(I)
        ELSE IF(CNAME.EQ.'XELA  ') THEN
          K=K+1
          READ(NUMBER,*) XELA(I),XELAE(I)
          WRITE(6,'(1X,A,2E15.3)') 'XELA  ',XELA(I),XELAE(I)
        ELSE IF(CNAME.EQ.'XINELA') THEN
          K=K+1
          READ(NUMBER,*) XINE(I),XINEE(I)
          WRITE(6,'(1X,A,2E15.3)') 'XINELA',XINE(I),XINEE(I)
        ELSE IF(CNAME.EQ.'XSDIFF') THEN
          K=K+1
          READ(NUMBER,*) XSDI(I),XSDIE(I)
          WRITE(6,'(1X,A,2E15.3)') 'XSDIFF',XSDI(I),XSDIE(I)
        ELSE IF(CNAME.EQ.'SLOPE ') THEN
          K=K+1
          READ(NUMBER,*) SLO(I),SLOE(I)
          WRITE(6,'(1X,A,2E15.3)') 'SLOPE ',SLO(I),SLOE(I)
        ELSE IF(CNAME.EQ.'DSDTGA') THEN
          KK=KK+1
          READ(NUMBER,*) EE,NDUM
          DSIGI(2,KK)=DBLE(NDUM)
          DSIGI(1,KK)=EE
          DSIGI(3,KK)=ONE
          WRITE(6,'(1X,A,E15.3,3X,I3)') 'DSDTGA ',EE,NDUM
          DO 105 II=1,NDUM
            READ(2,*) DSDT(KK,1,II),DSDT(KK,2,II),DSDT(KK,3,II)
            WRITE(6,'(6X,3E15.3)')
     &            DSDT(KK,1,II),DSDT(KK,2,II),DSDT(KK,3,II)
 105      CONTINUE
          K=K+NDUM
        ELSE IF(CNAME.EQ.'DSDTRH') THEN
          KK=KK+1
          READ(NUMBER,*) EE,NDUM
          DSIGI(2,KK)=DBLE(NDUM)
          DSIGI(1,KK)=EE
          DSIGI(3,KK)=TWO
          WRITE(6,'(1X,A,E15.3,3X,I3)') 'DSDTRH ',EE,NDUM
          DO 106 II=1,NDUM
            READ(2,*) DSDT(KK,1,II),DSDT(KK,2,II),DSDT(KK,3,II)
            WRITE(6,'(6X,3E15.3)')
     &            DSDT(KK,1,II),DSDT(KK,2,II),DSDT(KK,3,II)
 106      CONTINUE
          K=K+NDUM
        ELSE IF(CNAME.EQ.'DSDTOM') THEN
          KK=KK+1
          READ(NUMBER,*) EE,NDUM
          DSIGI(2,KK)=DBLE(NDUM)
          DSIGI(1,KK)=EE
          DSIGI(3,KK)=THREE
          WRITE(6,'(1X,A,E15.3,3X,I3)') 'DSDTOM ',EE,NDUM
          DO 107 II=1,NDUM
            READ(2,*) DSDT(KK,1,II),DSDT(KK,2,II),DSDT(KK,3,II)
            WRITE(6,'(6X,3E15.3)')
     &            DSDT(KK,1,II),DSDT(KK,2,II),DSDT(KK,3,II)
 107      CONTINUE
          K=K+NDUM
        ELSE IF(CNAME.EQ.'DSDTPH') THEN
          KK=KK+1
          READ(NUMBER,*) EE,NDUM
          DSIGI(2,KK)=DBLE(NDUM)
          DSIGI(1,KK)=EE
          DSIGI(3,KK)=FOUR
          WRITE(6,'(1X,A,E15.3,3X,I3)') 'DSDTPH ',EE,NDUM
          DO 108 II=1,NDUM
            READ(2,*) DSDT(KK,1,II),DSDT(KK,2,II),DSDT(KK,3,II)
            WRITE(6,'(6X,3E15.3)')
     &            DSDT(KK,1,II),DSDT(KK,2,II),DSDT(KK,3,II)
 108      CONTINUE
          K=K+NDUM
        ELSE IF(CNAME.EQ.'RHOPRO') THEN
          K=K+1
          READ(NUMBER,*) XPRO(1,I),XPROE(1,I)
          WRITE(6,'(1X,A,2E15.3)') 'RHOPRO',XPRO(1,I),XPROE(1,I)
        ELSE IF(CNAME.EQ.'OMEPRO') THEN
          K=K+1
          READ(NUMBER,*) XPRO(2,I),XPROE(2,I)
          WRITE(6,'(1X,A,2E15.3)') 'OMEPRO',XPRO(2,I),XPROE(2,I)
        ELSE IF(CNAME.EQ.'PHIPRO') THEN
          K=K+1
          READ(NUMBER,*) XPRO(3,I),XPROE(3,I)
          WRITE(6,'(1X,A,2E15.3)') 'PHIPRO',XPRO(3,I),XPROE(3,I)
        ELSE IF(CNAME.EQ.'COMM  ') THEN
          WRITE(6,'(1X,A6,A)') 'COMM  ',NUMBER
        ELSE
          WRITE(6,*) ' XINP: ERROR: unknown data card : ',CNAME
          STOP
        ENDIF
        GOTO 100
 1000 CONTINUE
C  set number of energy data items
      NIST=I
C  set number of total data items
      IFIT=K
      WRITE(6,'(2X,A)') ' ---------------------------------'
      WRITE(6,'(2X,A,I4)') ' Total number of entries to fit ',
     &                     IFIT
      CLOSE(2)
C  control data consistence
      IF(NIST.LE.0) THEN
        PRINT *,' *** Error: unexpected STOP, to few data cards ***'
        STOP
      ENDIF
      IF(IFIT.LT.NIST) THEN
        PRINT *,' *** Error: more energy then X section items ***'
        WRITE(6,*) ' energy items: ',NIST,
     &             ' cross sections: ',IFIT
        STOP
      ENDIF
      RETURN
C
 900  CONTINUE
      WRITE(6,*) ' XINP: ERROR: cannot open inputfile: ',
     &           FILENA,' ***'
C
      END
