
       SUBROUTINE runmcarlo(IRUN, ierr)

C from C++ interface 
C      IRUN=1 - initialize
C      IRUN=2 - run
C      IRUN=3 - terminate
C      ierr- no errors, event accepted 
C      written by S.Chekanov, May, 2003


C      include "../inc/pythia62.inc"
C      include "../inc/hepevt_pythia62.inc"
      include "../inc/getevkin.inc"
      include "../inc/getseeds.inc"
      include "rapgap31/include/rgfull.inc"
      include "rapgap31/include/rgdisdif.inc"
      include "rapgap31/include/rgluco.inc"
      include "rapgap31/include/rgludat1.inc"
      include "rapgap31/include/rgpara.inc"
      include "rapgap31/include/rgpypars.inc"
      include "rapgap31/include/rgdiffr.inc"
      include "rapgap31/include/rgscq2.inc"
      include "rapgap31/include/rglq2.inc"
      include "rapgap31/include/rghsunts.inc"
      include "rapgap31/include/rghsoptn.inc"  
      include "rapgap31/include/rghscuts.inc"
      include "rapgap31/include/rghsvglp.inc"

** RAPGAP initialisations 
      Integer IVM
      COMMON/VMESON/IVM
      Double Precision PYPAR,PYVAR
      Integer IPY
      COMMON /RGPYPARA/ IPY(80),PYPAR(80),PYVAR(80)
      Integer ICOLORA,IRESPRO,IRPA,IRPB,IRPC,IRPD,IRPE,IRPF,IRPG
      COMMON /COLCON/ ICOLORA,IRESPRO,IRPA,IRPB,IRPC,IRPD,IRPE,IRPF,IRPG
      Double Precision THEMIN,CTHMIN,CTHCON
      COMMON /HSTCUT/ THEMIN,CTHMIN,CTHCON

      Integer LPAR,LPARIN,IPART
      COMMON /HSPARL/ LPAR(20),LPARIN(12),IPART
      REAL*4 PAR111,PAR112,PARL11,PARL19
      INTEGER MST111,MST115
      COMMON /HSALFS/ PAR111,PAR112,PARL11,PARL19,MST111,MST115
      Integer Nevent
      Common/steer1/Nevent
      Integer N1,N2
 
      EXTERNAL pydata

      real timeleft
      Integer Minuts
      External Minuts
      Integer I,ISEED

** RUNMC initialisations 
      DOUBLE PRECISION  proton 
      Parameter (proton=0.938272)
      character*10 Pname1,Pname2

      Integer J, N, nev, iEP, IPOSI
      DOUBLE PRECISION  ECM, pbeam(4), sinv,ebeam(4)
      Integer IRUN, ierr,IPAR
      DOUBLE PRECISION  xQ2,xX,xY,xW
      Save nev,sinv,iEP 


      goto (1000, 2000, 3000) IRUN
      return


 1000   CONTINUE 

C internal seed from RUNMC
      ISEED = RUNMCseed1+RUNMCseed2 

      N1 = 0
      N2 = 0
      CALL RM48IN(ISEED,N1,N2)



      LUX = 4
      K1=0
      K2=0
      CALL RLUXGO(LUX,ISEED,K1,K2)

C---initialise RAPGAP parameters
      CALL GRAINI



C ----------- RunMC part -------------------------
C -take positron (default)
       nev=0
       ierr=1

        iEP=0
        if( (abs(PID1).le.17) .and. (abs(PID2).gt.2000) ) iEP=1
        if( (abs(PID2).le.17) .and. (abs(PID1).gt.2000) ) iEP=1

C show names: 
       Call GeTName(PID1,Pname1,0)
       Call GeTName(PID2,Pname2,0)

       write(6,*) "RunMC set RAPGAP: Beam 1", PID1, " ", Pname1
       write(6,*) "RunMC set RAPGAP: Beam 2", PID2, " ", Pname2


       CALL PYGIVE('PARJ(72)=1000') ! mm maximum distance from the origin at
                     ! a decay is allowed to take place
       CALL PYGIVE('MSTJ(22)=3')  ! particle is decayed only if the decay vertex is
                     ! within a distance PARJ(72) of the origin
       write(6,*)PARJ(72),'mm maximum distance a decay is allowed'

CC --------------- End RunMC part

*** initialisation 
* set parameters from GUI
       CALL RUNMCrapgapsteer

** read stearing card and overwrite some parameters
       Call steerRapgap("rapgap3.cards")


C - Continue with RAPGAP --------------------------- 
C-- change standard parameters of RAPGAP 
      CALL RAPCHA 

C-- change standard parameters of HERACLES
      Call HERCHA 

C-- change standard parameters of JETSET/PYTHIA
      CALL PYTCHA 

C Initialize ARIADNE
      CALL ARINIT('RAPGAP')

C-- change standard parameters of ARIADNE
      Call ARICHA 

C set user initialisation
C    Call setRAPGAP

C--- CALCULATE X SECTION
      CALL RAPGAP


C--- print x section
      CALL RAEND(1)

c ---------------- end cascade intitialization ------------- 

       write(6,*) ' FINISHING RAPGAP INITIALIZATION'

      RETURN

 2000  CONTINUE  ! RUN 

************* Physics study *************** 

c generate an event
       CALL EVENT
       nev=nev+1


C copy kinematic varaibles
        ierr=0        
          
C.. convert from JETSET common
       CALL PYHEPC(1)

      IF (iEP.eq.1) THEN ! not E+E-
        CALL GETKIN(xQ2,xX,xY,xW) ! get kinematics
C copy kinematic varaibles
        rQ2(1)=real(xQ2) 
        rXbj(1)=real(xX)
        rYbj(1)=real(xY)
        rW(1)=real(xW)
       ENDIF

CC       write(6,*) rQ2(1), PARI(105)

C...Call a user supplied analysis routine
        if (nev.le.5)  CALL PYLIST(1) 


 9999  Continue
* end of loop >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
      RETURN


 3000 CONTINUE

c Print out of generated events summary
c
      CALL RAEND(20)


      xCross=1000*AVGI
      eCross=1000*SD
      write(6,*) "RUNMC-RAPGAP: total cross section is (pb): ", xCross 
      write(6,*) 'RUNMC-RAPGAP: ALL done!'

      RETURN      
      END  



**************************************************

       Subroutine GeTName(ID, NameP, imod)

      INTEGER imod,ID
      Character* 10 NameP 

      NameP="undefined" 

      IF (ID.eq.11)   NameP="e-"
      IF (ID.eq.-11)  NameP="e+" 
      IF (ID.eq.13)   NameP="mu-"
      IF (ID.eq.-13)  NameP="mu+"
      IF (ID.eq.15)   NameP="tau-"
      IF (ID.eq.-15)  NameP="tau+"
      IF (ID.eq.22)   NameP="gamma"
      IF (ID.eq.2112) NameP="n0"
      IF (ID.eq.-2112) NameP="nbar0" 
      IF (ID.eq.2212)  NameP="p+"
      IF (ID.eq.-2212) NameP="pbar-"
 
 
      IF (imod.eq.1) THEN ! for PHP
       IF (ID.eq.11)   NameP="gamma/e-"
       IF (ID.eq.-11)  NameP="gamma/e+"
       IF (ID.eq.13)   NameP="gamma/mu-"
       IF (ID.eq.-13)  NameP="gamma/mu+"
       IF (ID.eq.15)   NameP="gamma/tau-"
       IF (ID.eq.-15)  NameP="gamma/tau+"
       IF (ID.eq.22)   NameP="gamma"
       IF (ID.eq.2112) NameP="n0"
       IF (ID.eq.-2112) NameP="nbar0"
       IF (ID.eq.2212)  NameP="p+"
       IF (ID.eq.-2212) NameP="pbar-"
      ENDIF
 
      END


************************************************
* get kinematics

        SUBROUTINE GETKIN(Q2,XBJ,YBJ,W)

        include "../inc/hepevt_pythia62.inc"
        DOUBLE PRECISION Q2,PQ,PK,XBJ,YBJ,W
        DOUBLE PRECISION PP(4),QQ(4)
        DOUBLE PRECISION sinv,MPROTON
        PARAMETER (MPROTON=0.938272)
        Integer M, I
        Save   PP


         XBJ=0.
         YBJ=0.
         Q2 =0.
         W  =0.

* get proton beam
        DO I=1,2
        IF (abs(IDHEP(I)).ge.2000) THEN
            DO M=1,4
            PP(M)=PHEP(M,I)
           ENDDO
        ENDIF
        ENDDO
        sinv = 4.*PHEP(4,1)*PHEP(4,2) + MPROTON**2
        Q2=0.

* get gamma/Z boson
        DO M=3,NHEP
        IF (abs(IDHEP(M)).le.24.and.abs(IDHEP(M)).ge.22) THEN
        DO I=1,4
          QQ(I)=PHEP(I,M)
          Q2=PHEP(5,M)**2
        ENDDO
        GOTO 8282
        ENDIF
        ENDDO

 8282    CONTINUE
* Other kinematical variables
         Pq=PP(4)*QQ(4) - PP(3)*QQ(3)
         XBJ=Q2/2./Pq
         YBJ=Q2/(XBJ*sinv)
         W=2.*Pq-Q2+MPROTON**2
         IF (W.GT.0.) THEN
           W=DSQRT(W)
         ELSE
           W=MPROTON
         ENDIF

      RETURN
      END








 
