#!/bin/bash
#
# make project for RunMC v3.0 
# created by S.Chekanov 
# 
MYDIR=`pwd`
args=$#           # Number of args passed.


CHECK=$RUNMC"/main/scripts/check_make"
# reset counters
$CHECK -1;

#reload check file



if [ $args == 0  ]
then
   echo "did not specify project file!"
   exit 1;
fi

echo "Loading RMC project file $1"

# get yera
    dname=`date '+%d'`
    mname=`date '+%m'`
    yname=`date '+%y'`
    h=`date '+%H'`
    m=`date '+%M'`
    s=`date '+%S'`
    fname="proj_"$mname"_"$dname"_"$h"_"$m"_"$s".tmp"

# note argument has absolute path  
GETFILE=$1
PROJ=$RUNMC"/proj"
PROJLOG=$RUNMC"/main/tmp/rmc_create.log"
PROJTMP=$RUNMC"/main/tmp/tmp.mc" 

# if exists - done
if [ -d "$PROJ" ]
then
    cd $RUNMC
    rm -f proj/*.log 
    rm -f proj/*.err
    rm -f proj/*.o
    rm -f proj/fort.*
    rm -f proj/ini/*.o
    rm -f proj/*.root
    rm -f proj/*~
    rm -f proj/ini/*~
    rm -f proj/*bak
    rm -f proj/ini/*bak
    # make bachuip 
    zip -rq $RUNMC"/main/tmp/"$fname proj  -x \*.o
    wait $!;
    echo "Saving previous RMC project in $RUNMC"/main/tmp/"$fname"
    # now remove all stuff
    rm -r proj/.*  2>/dev/null
    rm -r proj/*   2>/dev/null
    wait $!;
    cd $MYDIR
fi

# if exists - done
if [ -x "$PROJLOG" ]
then
    rm -f $PROJLOG;
fi

# if exists - done
if [ -x "$PROJTMP" ]
then
    rm -f $PROJTMP;
fi


# cp -f $GETFILE $RUNMC"/" 
# cd $RUNMC 
unzip -q -o $GETFILE -d $RUNMC
wait $!;  


# ###################################
# create link to be readed by RunMC
cd $PROJ;
GETFILE=`ls *.mc`
cp -f $PROJ"/"$GETFILE $PROJTMP


# remove binary files
rm -f $RUNMC/bin/runmc.*
# rm -f $RUNMC/bin/runmc_gui

#########################################
#### compile the project
cd $PROJ
# echo "compile project .."
make -f Makefile > $PROJLOG & 
wait $!;


cd $MYDIR
exit 0
