CDECK  ID>, HWUDAT.
*CMZ :-        -26/04/91  10.18.58  by  Bryan Webber
*-- Author :    Ian Knowles & Bryan Webber
C-----------------------------------------------------------------------
      BLOCK DATA HWUDAT
C-----------------------------------------------------------------------
C     Loads common blocks with particle properties data; for particle I:
C        RNAME(I) = Name
C        IDPDG(I) = PDG code
C        IFLAV(I) = HERWIG flavour code
C        ICHRG(I) = Electric charge (|e-|)          (*3 for (di-)quarks)
C        RMASS(I) = Mass (GeV/c^2)
C        RLTIM(I) = Proper life time (s)
C        RSPIN(I) = Spin
C       QORQQB(I) = .TRUE. if it is a quark or an antidiquark
C       QBORQQ(I) = .TRUE. if it is an antiquark or a diquark
C     And stores the particle decay tables: call HWUDPR to print them
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      INTEGER NLAST,NNEXT,NLEFT,NREST,I,J,MMWIDE,MMLONG,MMHOFF,MMVOFF
      COMMON/PAPER/MMWIDE,MMLONG,MMHOFF,MMVOFF
      PARAMETER (NLAST=458,NNEXT=458+1,NLEFT=NMXRES-458)
      PARAMETER (NREST=NMXRES-120)
      DATA NRES/458/
C Don't forget to change the three occurances above as well
      DATA MMWIDE,MMLONG,MMHOFF,MMVOFF/190,280,-39,-35/
      DATA (RNAME(I),IDPDG(I),IFLAV(I),ICHRG(I),RMASS(I),RLTIM(I),
     &      RSPIN(I),I=0,16)/
     & '        ',       0,   0, 0,0.0000D0,0.000D+00,0.0D0,
     & 'DQRK    ',       1,   0,-1,0.3200D0,0.000D+00,0.5D0,
     & 'UQRK    ',       2,   0,+2,0.3200D0,0.000D+00,0.5D0,
     & 'SQRK    ',       3,   0,-1,0.5000D0,0.000D+00,0.5D0,
     & 'CQRK    ',       4,   0,+2,1.5500D0,0.000D+00,0.5D0,
     & 'BQRK    ',       5,   0,-1,4.9500D0,0.000D+00,0.5D0,
     & 'TQRK    ',       6,   0,+2,174.30D0,4.000D-25,0.5D0,
     & 'DBAR    ',      -1,   0,+1,0.3200D0,0.000D+00,0.5D0,
     & 'UBAR    ',      -2,   0,-2,0.3200D0,0.000D+00,0.5D0,
     & 'SBAR    ',      -3,   0,+1,0.5000D0,0.000D+00,0.5D0,
     & 'CBAR    ',      -4,   0,-2,1.5500D0,0.000D+00,0.5D0,
     & 'BBAR    ',      -5,   0,+1,4.9500D0,0.000D+00,0.5D0,
     & 'TBAR    ',      -6,   0,-2,174.30D0,4.000D-25,0.5D0,
     & 'GLUON   ',      21,   0, 0,0.7500D0,0.000D+00,1.0D0,
     & 'CMF     ',       0,   0, 0,0.0000D0,0.000D+00,0.0D0,
     & 'HARD    ',       0,   0, 0,0.0000D0,0.000D+00,0.0D0,
     & 'SOFT    ',       0,   0, 0,0.0000D0,0.000D+00,0.0D0/
      DATA (RNAME(I),IDPDG(I),IFLAV(I),ICHRG(I),RMASS(I),RLTIM(I),
     &      RSPIN(I),I=17,32)/
     & 'CONE    ',       0,   0, 0,0.0000D0,0.000D+00,0.0D0,
     & 'HEAVY   ',       0,   0, 0,0.0000D0,0.000D+00,0.0D0,
     & 'CLUS    ',      91,   0, 0,0.0000D0,0.000D+00,0.0D0,
     & '****    ',       0,   0, 0,0.0000D0,0.000D+00,0.0D0,
     & 'PI0     ',     111,  11, 0,.13498D0,8.400D-17,0.0D0,
     & 'ETA     ',     221,  33, 0,.54730D0,0.000D+00,0.0D0,
     & 'RHO0    ',     113,  11, 0,.77000D0,0.000D+00,1.0D0,
     & 'OMEGA   ',     223,  33, 0,.78194D0,0.000D+00,1.0D0,
     & 'ETAP    ',     331,  33, 0,.95778D0,0.000D+00,0.0D0,
     & 'F_2     ',     225,  33, 0,1.2750D0,0.000D+00,2.0D0,
     & 'A_10    ',   20113,  11, 0,1.2300D0,0.000D+00,1.0D0,
     & 'FL_1    ',   20223,  33, 0,1.2819D0,0.000D+00,1.0D0,
     & 'A_20    ',     115,  11, 0,1.3181D0,0.000D+00,2.0D0,
     & 'PI-     ',    -211,  12,-1,.13957D0,2.603D-08,0.0D0,
     & 'RHO-    ',    -213,  12,-1,.77000D0,0.000D+00,1.0D0,
     & 'A_1-    ',  -20213,  12,-1,1.2300D0,0.000D+00,1.0D0/
      DATA (RNAME(I),IDPDG(I),IFLAV(I),ICHRG(I),RMASS(I),RLTIM(I),
     &      RSPIN(I),I=33,48)/
     & 'A_2-    ',    -215,  12,-1,1.3181D0,0.000D+00,2.0D0,
     & 'K-      ',    -321,  32,-1,.49368D0,1.237D-08,0.0D0,
     & 'K*-     ',    -323,  32,-1,.89166D0,0.000D+00,1.0D0,
     & 'KH_1-   ',  -20323,  32,-1,1.8500D0,0.000D+00,1.0D0,
     & 'K*_2-   ',    -325,  32,-1,1.4256D0,0.000D+00,2.0D0,
     & 'PI+     ',     211,  21,+1,.13957D0,2.603D-08,0.0D0,
     & 'RHO+    ',     213,  21,+1,.77000D0,0.000D+00,1.0D0,
     & 'A_1+    ',   20213,  21,+1,1.2300D0,0.000D+00,1.0D0,
     & 'A_2+    ',     215,  21,+1,1.3181D0,0.000D+00,2.0D0,
     & 'KBAR0   ',    -311,  31, 0,.49767D0,0.000D+00,0.0D0,
     & 'K*BAR0  ',    -313,  31, 0,.89610D0,0.000D+00,1.0D0,
     & 'KH_1BAR0',  -20313,  31, 0,1.8500D0,0.000D+00,1.0D0,
     & 'K*_2BAR0',    -315,  31, 0,1.4324D0,0.000D+00,2.0D0,
     & 'K+      ',     321,  23,+1,.49368D0,1.237D-08,0.0D0,
     & 'K*+     ',     323,  23,+1,.89166D0,0.000D+00,1.0D0,
     & 'KH_1+   ',   20323,  23,+1,1.8500D0,0.000D+00,1.0D0/
      DATA (RNAME(I),IDPDG(I),IFLAV(I),ICHRG(I),RMASS(I),RLTIM(I),
     &      RSPIN(I),I=49,64)/
     & 'K*_2+   ',     325,  23,+1,1.4256D0,0.000D+00,2.0D0,
     & 'K0      ',     311,  13, 0,.49767D0,0.000D+00,0.0D0,
     & 'K*0     ',     313,  13, 0,.89610D0,0.000D+00,1.0D0,
     & 'KH_10   ',   20313,  13, 0,1.8500D0,0.000D+00,1.0D0,
     & 'K*_20   ',     315,  13, 0,1.4324D0,0.000D+00,2.0D0,
     & '        ',       0,   0, 0,0.0000D0,0.000D+00,0.0D0,
     & '        ',       0,   0, 0,0.0000D0,0.000D+00,0.0D0,
     & 'PHI     ',     333,  33, 0,1.0194D0,0.000D+00,1.0D0,
     & 'FH_1    ',   20333,  33, 0,1.4262D0,0.000D+00,1.0D0,
     & 'FP_2    ',     335,  33, 0,1.5250D0,0.000D+00,2.0D0,
     & 'GAMMA   ',      22,   0, 0,0.0000D0,1.000D+30,1.0D0,
     & 'K_S0    ',     310,   0, 0,.49767D0,8.926D-11,0.0D0,
     & 'K_L0    ',     130,   0, 0,.49767D0,5.170D-08,0.0D0,
     & 'A_0(H)0 ',   10111,  11, 0,1.4740D0,0.000D+00,0.0D0,
     & 'A_0(H)+ ',   10211,  21,+1,1.4740D0,0.000D+00,0.0D0,
     & 'A_0(H)- ',  -10211,  12,-1,1.4740D0,0.000D+00,0.0D0/
      DATA (RNAME(I),IDPDG(I),IFLAV(I),ICHRG(I),RMASS(I),RLTIM(I),
     &      RSPIN(I),I=65,80)/
     & '        ',       0,   0, 0,0.0000D0,0.000D+00,0.0D0,
     & '        ',       0,   0, 0,0.0000D0,0.000D+00,0.0D0,
     & '        ',       0,   0, 0,0.0000D0,0.000D+00,0.0D0,
     & '        ',       0,   0, 0,0.0000D0,0.000D+00,0.0D0,
     & '        ',       0,   0, 0,0.0000D0,0.000D+00,0.0D0,
     & '        ',       0,   0, 0,0.0000D0,0.000D+00,0.0D0,
     & 'REMG    ',      98,   0, 0,0.0000D0,0.000D+00,0.0D0,
     & 'REMN    ',      99,   0, 0,0.0000D0,0.000D+00,0.0D0,
     & 'P       ',    2212, 122,+1,.93827D0,1.000D+30,0.5D0,
     & 'DELTA+  ',    2214, 122,+1,1.2320D0,0.000D+00,1.5D0,
     & 'N       ',    2112, 112, 0,.93957D0,8.870D+02,0.5D0,
     & 'DELTA0  ',    2114, 112, 0,1.2320D0,0.000D+00,1.5D0,
     & 'DELTA-  ',    1114, 111,-1,1.2320D0,0.000D+00,1.5D0,
     & 'LAMBDA  ',    3122, 123, 0,1.1157D0,2.632D-10,0.5D0,
     & 'SIGMA0  ',    3212, 123, 0,1.1926D0,7.400D-20,0.5D0,
     & 'SIGMA*0 ',    3214, 123, 0,1.3837D0,0.000D+00,1.5D0/
      DATA (RNAME(I),IDPDG(I),IFLAV(I),ICHRG(I),RMASS(I),RLTIM(I),
     &      RSPIN(I),I=81,96)/
     & 'SIGMA-  ',    3112, 113,-1,1.1974D0,1.479D-10,0.5D0,
     & 'SIGMA*- ',    3114, 113,-1,1.3872D0,0.000D+00,1.5D0,
     & 'XI-     ',    3312, 133,-1,1.3213D0,1.639D-10,0.5D0,
     & 'XI*-    ',    3314, 133,-1,1.5350D0,0.000D+00,1.5D0,
     & 'DELTA++ ',    2224, 222,+2,1.2320D0,0.000D+00,1.5D0,
     & 'SIGMA+  ',    3222, 223,+1,1.1894D0,7.990D-11,0.5D0,
     & 'SIGMA*+ ',    3224, 223,+1,1.3828D0,0.000D+00,1.5D0,
     & 'XI0     ',    3322, 233, 0,1.3149D0,2.900D-10,0.5D0,
     & 'XI*0    ',    3324, 233, 0,1.5318D0,0.000D+00,1.5D0,
     & 'OMEGA-  ',    3334, 333,-1,1.6725D0,8.220D-11,1.5D0,
     & 'PBAR    ',   -2212,-122,-1,.93827D0,1.000D+30,0.5D0,
     & 'DELTABR-',   -2214,-122,-1,1.2320D0,0.000D+00,1.5D0,
     & 'NBAR    ',   -2112,-112, 0,.93957D0,8.870D+02,0.5D0,
     & 'DELTABR0',   -2114,-112, 0,1.2320D0,0.000D+00,1.5D0,
     & 'DELTABR+',   -1114,-111,+1,1.2320D0,0.000D+00,1.5D0,
     & 'LAMBDABR',   -3122,-123, 0,1.1157D0,2.632D-10,0.5D0/
      DATA (RNAME(I),IDPDG(I),IFLAV(I),ICHRG(I),RMASS(I),RLTIM(I),
     &      RSPIN(I),I=97,112)/
     & 'SIGMABR0',   -3212,-123, 0,1.1926D0,7.400D-20,0.5D0,
     & 'SGMA*BR0',   -3214,-123, 0,1.3837D0,0.000D+00,1.5D0,
     & 'SIGMABR+',   -3112,-113,+1,1.1974D0,1.479D-10,0.5D0,
     & 'SGMA*BR+',   -3114,-113,+1,1.3872D0,0.000D+00,1.5D0,
     & 'XIBAR+  ',   -3312,-133,+1,1.3213D0,1.639D-10,0.5D0,
     & 'XI*BAR+ ',   -3314,-133,+1,1.5350D0,0.000D+00,1.5D0,
     & 'DLTABR--',   -2224,-222,-2,1.2320D0,0.000D+00,1.5D0,
     & 'SIGMABR-',   -3222,-223,-1,1.1894D0,7.990D-11,0.5D0,
     & 'SGMA*BR-',   -3224,-223,-1,1.3828D0,0.000D+00,1.5D0,
     & 'XIBAR0  ',   -3322,-233, 0,1.3149D0,2.900D-10,0.5D0,
     & 'XI*BAR  ',   -3324,-233, 0,1.5318D0,0.000D+00,1.5D0,
     & 'OMEGABR+',   -3334,-333,+1,1.6725D0,8.220D-11,1.5D0,
     & 'UU      ',    2203,   0,+4,0.6400D0,0.000D+00,0.0D0,
     & 'UD      ',    2101,   0,+1,0.6400D0,0.000D+00,0.0D0,
     & 'DD      ',    1103,   0,-2,0.6400D0,0.000D+00,0.0D0,
     & 'US      ',    3201,   0,+1,0.8200D0,0.000D+00,0.0D0/
      DATA (RNAME(I),IDPDG(I),IFLAV(I),ICHRG(I),RMASS(I),RLTIM(I),
     &      RSPIN(I),I=113,128)/
     & 'DS      ',    3101,   0,-2,0.8200D0,0.000D+00,0.0D0,
     & 'SS      ',    3303,   0,-2,1.0000D0,0.000D+00,0.0D0,
     & 'UBARUBAR',   -2203,   0,-4,0.6400D0,0.000D+00,0.0D0,
     & 'UBARDBAR',   -2101,   0,-1,0.6400D0,0.000D+00,0.0D0,
     & 'DBARDBAR',   -1103,   0,+2,0.6400D0,0.000D+00,0.0D0,
     & 'UBARSBAR',   -3201,   0,-1,0.8200D0,0.000D+00,0.0D0,
     & 'DBARSBAR',   -3101,   0,+2,0.8200D0,0.000D+00,0.0D0,
     & 'SBARSBAR',   -3303,   0,+2,1.0000D0,0.000D+00,0.0D0,
     & 'E-      ',      11,   0,-1,5.11D-04,1.000D+30,0.5D0,
     & 'NU_E    ',      12,   0, 0,0.0000D0,1.000D+30,0.5D0,
     & 'MU-     ',      13,   0,-1,.10566D0,2.197D-06,0.5D0,
     & 'NU_MU   ',      14,   0, 0,0.0000D0,1.000D+30,0.5D0,
     & 'TAU-    ',      15,   0,-1,1.7771D0,2.916D-13,0.5D0,
     & 'NU_TAU  ',      16,   0, 0,0.0000D0,1.000D+30,0.5D0,
     & 'E+      ',     -11,   0,+1,5.11D-04,1.000D+30,0.5D0,
     & 'NU_EBAR ',     -12,   0, 0,0.0000D0,1.000D+30,0.5D0/
      DATA (RNAME(I),IDPDG(I),IFLAV(I),ICHRG(I),RMASS(I),RLTIM(I),
     &      RSPIN(I),I=129,144)/
     & 'MU+     ',     -13,   0,+1,.10566D0,2.197D-06,0.5D0,
     & 'NU_MUBAR',     -14,   0, 0,0.0000D0,1.000D+30,0.5D0,
     & 'TAU+    ',     -15,   0,+1,1.7771D0,2.916D-13,0.5D0,
     & 'NU_TAUBR',     -16,   0, 0,0.0000D0,1.000D+30,0.5D0,
     & '        ',       0,   0, 0,0.0000D0,0.000D+00,0.0D0,
     & '        ',       0,   0, 0,0.0000D0,0.000D+00,0.0D0,
     & '        ',       0,   0, 0,0.0000D0,0.000D+00,0.0D0,
     & 'D+      ',     411,  41,+1,1.8693D0,1.057D-12,0.0D0,
     & 'D*+     ',     413,  41,+1,2.0100D0,0.000D+00,1.0D0,
     & 'DH_1+   ',   20413,  41,+1,2.4270D0,0.000D+00,1.0D0,
     & 'D*_2+   ',     415,  41,+1,2.4590D0,0.000D+00,2.0D0,
     & 'D0      ',     421,  42, 0,1.8646D0,4.150D-13,0.0D0,
     & 'D*0     ',     423,  42, 0,2.0067D0,0.000D+00,1.0D0,
     & 'DH_10   ',   20423,  42, 0,2.4222D0,0.000D+00,1.0D0,
     & 'D*_20   ',     425,  42, 0,2.4589D0,0.000D+00,2.0D0,
     & 'D_S+    ',     431,  43,+1,1.9685D0,4.670D-13,0.0D0/
      DATA (RNAME(I),IDPDG(I),IFLAV(I),ICHRG(I),RMASS(I),RLTIM(I),
     &      RSPIN(I),I=145,160)/
     & 'D*_S+   ',     433,  43,+1,2.1124D0,0.000D+00,1.0D0,
     & 'DH_S1+  ',   20433,  43,+1,2.5354D0,0.000D+00,1.0D0,
     & 'D*_S2+  ',     435,  43,+1,2.5735D0,0.000D+00,2.0D0,
     & 'SGMA_C++',    4222, 224,+2,2.4528D0,0.000D+00,0.5D0,
     & 'SGM*_C++',    4224, 224,+2,2.5194D0,0.000D+00,1.5D0,
     & 'LMBDA_C+',    4122, 124,+1,2.2849D0,2.060D-13,0.5D0,
     & 'SIGMA_C+',    4212, 124,+1,2.4536D0,0.000D+00,0.5D0,
     & 'SGMA*_C+',    4214, 124,+1,2.5185D0,0.000D+00,1.5D0,
     & 'SIGMA_C0',    4112, 114, 0,2.4522D0,0.000D+00,0.5D0,
     & 'SGMA*_C0',    4114, 114, 0,2.5175D0,0.000D+00,1.5D0,
     & 'XI_C+   ',    4232, 234,+1,2.4656D0,3.500D-13,0.5D0,
     & 'XIP_C+  ',    4322, 234,+1,2.5750D0,0.000D+00,0.5D0,
     & 'XI*_C+  ',    4324, 234,+1,2.6446D0,0.000D+00,1.5D0,
     & 'XI_C0   ',    4132, 134, 0,2.4703D0,9.800D-14,0.5D0,
     & 'XIP_C0  ',    4312, 134, 0,2.5800D0,0.000D+00,0.5D0,
     & 'XI*_C0  ',    4314, 134, 0,2.6438D0,0.000D+00,1.5D0/
      DATA (RNAME(I),IDPDG(I),IFLAV(I),ICHRG(I),RMASS(I),RLTIM(I),
     &      RSPIN(I),I=161,176)/
     & 'OMEGA_C0',    4332, 334, 0,2.7040D0,6.400D-14,0.5D0,
     & 'OMGA*_C0',    4334, 334, 0,2.7300D0,0.000D+00,1.5D0,
     & 'ETA_C   ',     441,  44, 0,2.9798D0,0.000D+00,0.0D0,
     & 'JPSI    ',     443,  44, 0,3.0969D0,0.000D+00,1.0D0,
     & 'CHI_C1  ',   10441,  44, 0,3.4173D0,0.000D+00,0.0D0,
     & 'PSI2S   ',  100443,  44, 0,3.6860D0,0.000D+00,1.0D0,
     & 'PSID    ',   30443,  44, 0,3.7699D0,0.000D+00,1.0D0,
     & '        ',       0,   0, 0,0.0000D0,0.000D+00,0.0D0,
     & '        ',       0,   0, 0,0.0000D0,0.000D+00,0.0D0,
     & '        ',       0,   0, 0,0.0000D0,0.000D+00,0.0D0,
     & 'D-      ',    -411,  14,-1,1.8693D0,1.057D-12,0.0D0,
     & 'D*-     ',    -413,  14,-1,2.0100D0,0.000D+00,1.0D0,
     & 'DH_1-   ',  -20413,  14,-1,2.4270D0,0.000D+00,1.0D0,
     & 'D*_2-   ',    -415,  14,-1,2.4590D0,0.000D+00,2.0D0,
     & 'DBAR0   ',    -421,  24, 0,1.8646D0,4.140D-13,0.0D0,
     & 'D*BAR0  ',    -423,  24, 0,2.0067D0,0.000D+00,1.0D0/
      DATA (RNAME(I),IDPDG(I),IFLAV(I),ICHRG(I),RMASS(I),RLTIM(I),
     &      RSPIN(I),I=177,192)/
     & 'DH_1BAR0',  -20423,  24, 0,2.4222D0,0.000D+00,1.0D0,
     & 'D*_2BAR0',    -425,  24, 0,2.4589D0,0.000D+00,2.0D0,
     & 'D_S-    ',    -431,  34,-1,1.9685D0,4.670D-13,0.0D0,
     & 'D*_S-   ',    -433,  34,-1,2.1124D0,0.000D+00,1.0D0,
     & 'DH_S1-  ',  -20433,  34,-1,2.5354D0,0.000D+00,1.0D0,
     & 'D*_S2-  ',    -435,  34,-1,2.5735D0,0.000D+00,2.0D0,
     & 'SGMA_C--',   -4222,-224,-2,2.4528D0,0.000D+00,0.5D0,
     & 'SGM*_C--',   -4224,-224,-2,2.5194D0,0.000D+00,1.5D0,
     & 'LMBDA_C-',   -4122,-124,-1,2.2849D0,2.060D-13,0.5D0,
     & 'SIGMA_C-',   -4212,-124,-1,2.4536D0,0.000D+00,0.5D0,
     & 'SGMA*_C-',   -4214,-124,-1,2.5185D0,0.000D+00,1.5D0,
     & 'SGM_CBR0',   -4112,-114, 0,2.4522D0,0.000D+00,0.5D0,
     & 'SG*_CBR0',   -4114,-114, 0,2.5175D0,0.000D+00,1.5D0,
     & 'XI_C-   ',   -4232,-234,-1,2.4656D0,3.500D-13,0.5D0,
     & 'XIP_C-  ',   -4322,-234,-1,2.5750D0,0.000D+00,0.5D0,
     & 'XI*_C-  ',   -4324,-234,-1,2.6446D0,0.000D+00,1.5D0/
      DATA (RNAME(I),IDPDG(I),IFLAV(I),ICHRG(I),RMASS(I),RLTIM(I),
     &      RSPIN(I),I=193,208)/
     & 'XI_CBAR0',   -4132,-134, 0,2.4703D0,9.800D-14,0.5D0,
     & 'XIP_CBR0',   -4312,-134, 0,2.5800D0,0.000D+00,0.5D0,
     & 'XI*_CBR0',   -4314,-134, 0,2.6438D0,0.000D+00,1.5D0,
     & 'OMG_CBR0',   -4332,-334, 0,2.7040D0,6.400D-14,0.5D0,
     & 'OM*_CBR0',   -4334,-334, 0,2.7300D0,0.000D+00,1.5D0,
     & 'W+      ',      24,   0,+1,80.420D0,0.000D+00,1.0D0,
     & 'W-      ',     -24,   0,-1,80.420D0,0.000D+00,1.0D0,
     & 'Z0/GAMA*',      23,   0, 0,91.188D0,0.000D+00,1.0D0,
     & 'HIGGS   ',      25,   0, 0,115.00D0,0.000D+00,0.0D0,
     & 'Z0P     ',      32,   0, 0,500.00D0,0.000D+00,1.0D0,
     & 'HIGGSL0 ',      26,   0, 0,0.0000D0,1.000D+30,0.0D0,
     & 'HIGGSH0 ',      35,   0, 0,0.0000D0,1.000D+30,0.0D0,
     & 'HIGGSA0 ',      36,   0, 0,0.0000D0,1.000D+30,0.0D0,
     & 'HIGGS+  ',      37,   0,+1,0.0000D0,1.000D+30,0.0D0,
     & 'HIGGS-  ',     -37,   0,-1,0.0000D0,1.000D+30,0.0D0,
     & 'GRAVITON',      39,   0, 0,0.0000D0,1.000D+30,2.0D0/
      DATA (RNAME(I),IDPDG(I),IFLAV(I),ICHRG(I),RMASS(I),RLTIM(I),
     &      RSPIN(I),I=209,224)/
     & 'VQRK    ',       7,   0,-1,200.00D0,0.000D+00,0.5D0,
     & 'AQRK    ',       8,   0,+2,400.00D0,0.000D+00,0.5D0,
     & 'HQRK    ',       7,   0,-1,400.00D0,0.000D+00,0.5D0,
     & 'HPQK    ',       8,   0,+2,600.00D0,0.000D+00,0.5D0,
     & '        ',       0,   0, 0,0.0000D0,0.000D+00,0.0D0,
     & '        ',       0,   0, 0,0.0000D0,0.000D+00,0.0D0,
     & 'VBAR    ',      -7,   0,+1,200.00D0,0.000D+00,0.5D0,
     & 'ABAR    ',      -8,   0,-2,400.00D0,0.000D+00,0.5D0,
     & 'HBAR    ',      -7,   0,+1,400.00D0,0.000D+00,0.5D0,
     & 'HPBR    ',      -8,   0,-2,600.00D0,0.000D+00,0.5D0,
     & '        ',       0,   0, 0,0.0000D0,0.000D+00,0.0D0,
     & '        ',       0,   0, 0,0.0000D0,0.000D+00,0.0D0,
     & 'B_DBAR0 ',    -511,  51, 0,5.2792D0,1.614D-12,0.0D0,
     & 'B-      ',    -521,  52,-1,5.2789D0,1.652D-12,0.0D0,
     & 'B_SBAR0 ',    -531,  53, 0,5.3693D0,1.540D-12,0.0D0,
     & 'SIGMA_B+',    5222, 225,+1,5.8200D0,1.070D-12,0.5D0/
      DATA (RNAME(I),IDPDG(I),IFLAV(I),ICHRG(I),RMASS(I),RLTIM(I),
     &      RSPIN(I),I=225,240)/
     & 'LMBDA_B0',    5122, 125, 0,5.6240D0,1.070D-12,0.5D0,
     & 'SIGMA_B-',    5112, 115,-1,5.8200D0,1.070D-12,0.5D0,
     & 'XI_B0   ',    5232, 235, 0,5.8000D0,1.070D-12,0.5D0,
     & 'XI_B-   ',    5132, 135,-1,5.8000D0,1.070D-12,0.5D0,
     & 'OMEGA_B-',    5332, 335,-1,6.0400D0,1.070D-12,0.5D0,
     & 'B_C-    ',    -541,  54,-1,6.2500D0,1.000D-12,0.5D0,
     & 'UPSLON1S',     553,  55, 0,9.4604D0,0.000D+00,1.0D0,
     & 'T_B-    ',    -651,  56,-1,0.0000D0,0.000D+00,0.0D0,
     & 'T+      ',     611,  61,+1,0.0000D0,0.000D+00,0.0D0,
     & 'T0      ',     621,  62, 0,0.0000D0,0.000D+00,0.0D0,
     & 'T_S+    ',     631,  63,+1,0.0000D0,0.000D+00,0.0D0,
     & 'SGMA_T++',    6222, 226,+2,0.0000D0,0.000D+00,0.5D0,
     & 'LMBDA_T0',    6122, 126,+1,0.0000D0,0.000D+00,0.5D0,
     & 'SIGMA_T0',    6112, 116, 0,0.0000D0,0.000D+00,0.5D0,
     & 'XI_T+   ',    6232, 236,+1,0.0000D0,0.000D+00,0.5D0,
     & 'XI_T0   ',    6132, 136, 0,0.0000D0,0.000D+00,0.5D0/
      DATA (RNAME(I),IDPDG(I),IFLAV(I),ICHRG(I),RMASS(I),RLTIM(I),
     &      RSPIN(I),I=241,256)/
     & 'OMEGA_T0',    6332, 336, 0,0.0000D0,0.000D+00,0.5D0,
     & 'T_C0    ',     641,  64, 0,0.0000D0,0.000D+00,0.0D0,
     & 'T_B+    ',     651,  65,+1,0.0000D0,0.000D+00,0.0D0,
     & 'TOPONIUM',     663,  66, 0,0.0000D0,0.000D+00,1.0D0,
     & 'B_D0    ',     511,  15, 0,5.2792D0,1.614D-12,0.0D0,
     & 'B+      ',     521,  25,+1,5.2789D0,1.652D-12,0.0D0,
     & 'B_S0    ',     531,  35, 0,5.3693D0,1.540D-12,0.0D0,
     & 'SGM_BBR-',   -5222,-225,-1,5.8200D0,1.070D-12,0.5D0,
     & 'LMD_BBR0',   -5122,-125, 0,5.6240D0,1.070D-12,0.5D0,
     & 'SGM_BBR+',   -5112,-115,+1,5.8200D0,1.070D-12,0.5D0,
     & 'XI_BBAR0',   -5232,-235, 0,5.8000D0,1.070D-12,0.5D0,
     & 'XI_B+   ',   -5132,-135,+1,5.8000D0,1.070D-12,0.5D0,
     & 'OMG_BBR+',   -5332,-335,+1,6.0400D0,1.070D-12,0.5D0,
     & 'B_C+    ',     541,  45,+1,6.2500D0,1.000D-12,0.5D0,
     & 'T-      ',    -611,  16,-1,0.0000D0,0.000D+00,0.0D0,
     & 'TBAR0   ',    -621,  26, 0,0.0000D0,0.000D+00,0.0D0/
      DATA (RNAME(I),IDPDG(I),IFLAV(I),ICHRG(I),RMASS(I),RLTIM(I),
     &      RSPIN(I),I=257,272)/
     & 'T_S-    ',    -631,  36,-1,0.0000D0,0.000D+00,0.0D0,
     & 'SGMA_T--',   -6222,-226,-2,0.0000D0,0.000D+00,0.5D0,
     & 'LAMDA_T-',   -6122,-126,-1,0.0000D0,0.000D+00,0.5D0,
     & 'SGM_TBR0',   -6112,-116, 0,0.0000D0,0.000D+00,0.5D0,
     & 'XI_T-   ',   -6232,-236,-1,0.0000D0,0.000D+00,0.5D0,
     & 'XI_TBAR0',   -6132,-136, 0,0.0000D0,0.000D+00,0.5D0,
     & 'OMG_TBR0',   -6332,-336, 0,0.0000D0,0.000D+00,0.5D0,
     & 'T_CBAR0 ',    -641,  46, 0,0.0000D0,0.000D+00,0.0D0,
     & 'B*BAR0  ',    -513,  51, 0,5.3249D0,0.000D+00,1.0D0,
     & 'B*-     ',    -523,  52,-1,5.3249D0,0.000D+00,1.0D0,
     & 'B*_SBAR0',    -533,  53, 0,5.4163D0,0.000D+00,1.0D0,
     & 'BH_1BAR0',  -20513,  51, 0,5.7600D0,0.000D+00,1.0D0,
     & 'BH_1-   ',  -20523,  52,-1,5.7600D0,0.000D+00,1.0D0,
     & 'BH_S1BR0',  -20533,  53, 0,5.8550D0,0.000D+00,1.0D0,
     & 'B*_2BAR0',    -515,  51, 0,5.7700D0,0.000D+00,2.0D0,
     & 'B*_2-   ',    -525,  52,-1,5.7700D0,0.000D+00,2.0D0/
      DATA (RNAME(I),IDPDG(I),IFLAV(I),ICHRG(I),RMASS(I),RLTIM(I),
     &      RSPIN(I),I=273,288)/
     & 'B*_S2BR0',    -535,  53, 0,5.8650D0,0.000D+00,2.0D0,
     & 'B*0     ',     513,  15, 0,5.3249D0,0.000D+00,1.0D0,
     & 'B*+     ',     523,  25,+1,5.3249D0,0.000D+00,1.0D0,
     & 'B*_S0   ',     533,  35, 0,5.4163D0,0.000D+00,1.0D0,
     & 'BH_10   ',   20513,  15, 0,5.7600D0,0.000D+00,1.0D0,
     & 'BH_1+   ',   20523,  25,+1,5.7600D0,0.000D+00,1.0D0,
     & 'BH_S10  ',   20533,  35, 0,5.8550D0,0.000D+00,1.0D0,
     & 'B*_20   ',     515,  15, 0,5.7700D0,0.000D+00,2.0D0,
     & 'B*_2+   ',     525,  25,+1,5.7700D0,0.000D+00,2.0D0,
     & 'B*_S20  ',     535,  35, 0,5.8650D0,0.000D+00,2.0D0,
     & '        ',       0,   0, 0,0.0000D0,0.000D+00,  0D0,
     & '        ',       0,   0, 0,0.0000D0,0.000D+00,  0D0,
     & 'B_10    ',   10113,  11, 0,1.2295D0,0.000D+00,1.0D0,
     & 'B_1+    ',   10213,  21,+1,1.2295D0,0.000D+00,1.0D0,
     & 'B_1-    ',  -10213,  12,-1,1.2295D0,0.000D+00,1.0D0,
     & 'HL_10   ',   10223,  33, 0,1.1700D0,0.000D+00,1.0D0/
      DATA (RNAME(I),IDPDG(I),IFLAV(I),ICHRG(I),RMASS(I),RLTIM(I),
     &      RSPIN(I),I=289,304)/
     & 'HH_10   ',   10333,  33, 0,1.3950D0,0.000D+00,1.0D0,
     & 'A_00    ', 9000111,  11, 0,.99600D0,0.000D+00,0.0D0,
     & 'A_0+    ', 9000211,  21,+1,.99600D0,0.000D+00,0.0D0,
     & 'A_0-    ',-9000211,  12,-1,.99600D0,0.000D+00,0.0D0,
     & 'F0P0    ', 9010221,  33, 0,.99600D0,0.000D+00,0.0D0,
     & 'FH_00   ',   10221,  33, 0,1.3500D0,0.000D+00,0.0D0,
     & 'B*_C+   ',     543,  45,+1,6.2950D0,0.000D+00,1.0D0,
     & 'B*_C-   ',    -543,  54,-1,6.2950D0,0.000D+00,1.0D0,
     & 'BH_C1+  ',   20543,  45,+1,6.7300D0,0.000D+00,1.0D0,
     & 'BH_C1-  ',  -20543,  54,-1,6.7300D0,0.000D+00,1.0D0,
     & 'B*_C2+  ',     545,  45,+1,6.7400D0,0.000D+00,2.0D0,
     & 'B*_C2-  ',    -545,  54,-1,6.7400D0,0.000D+00,2.0D0,
     & 'H_C     ',   10443,  44, 0,3.5261D0,0.000D+00,1.0D0,
     & 'CHI_C0  ',   20443,  44, 0,3.5105D0,0.000D+00,0.0D0,
     & 'CHI_C2  ',     445,  44, 0,3.5562D0,0.000D+00,2.0D0,
     & 'ETA_B   ',     551,  55, 0,9.0000D0,0.000D+00,0.0D0/
      DATA (RNAME(I),IDPDG(I),IFLAV(I),ICHRG(I),RMASS(I),RLTIM(I),
     &      RSPIN(I),I=305,320)/
     & 'H_B     ',   10553,  55, 0,9.8880D0,0.000D+00,1.0D0,
     & 'CHI_B0  ',   10551,  55, 0,9.8598D0,0.000D+00,0.0D0,
     & 'CHI_B1  ',   20553,  55, 0,9.8919D0,0.000D+00,1.0D0,
     & 'CHI_B2  ',     555,  55, 0,9.9132D0,0.000D+00,2.0D0,
     & 'KL_10   ',   10313,  13, 0,1.5700D0,0.000D+00,1.0D0,
     & 'KL_1+   ',   10323,  23,+1,1.5700D0,0.000D+00,1.0D0,
     & 'KL_1BAR0',  -10313,  31, 0,1.5700D0,0.000D+00,1.0D0,
     & 'KL_1-   ',  -10323,  32,-1,1.5700D0,0.000D+00,1.0D0,
     & 'DL_1+   ',   10413,  41,+1,2.4270D0,0.000D+00,1.0D0,
     & 'DL_10   ',   10423,  42, 0,2.4222D0,0.000D+00,1.0D0,
     & 'DL_S1+  ',   10433,  43,+1,2.5354D0,0.000D+00,1.0D0,
     & 'DL_1-   ',  -10413,  14,-1,2.4270D0,0.000D+00,1.0D0,
     & 'DL_1BAR0',  -10423,  24, 0,2.4222D0,0.000D+00,1.0D0,
     & 'DL_S1-  ',  -10433,  34,-1,2.5354D0,0.000D+00,1.0D0,
     & 'BL_10   ',   10513,  15, 0,5.7600D0,0.000D+00,1.0D0,
     & 'BL_1+   ',   10523,  25,+1,5.7600D0,0.000D+00,1.0D0/
      DATA (RNAME(I),IDPDG(I),IFLAV(I),ICHRG(I),RMASS(I),RLTIM(I),
     &      RSPIN(I),I=321,336)/
     & 'BL_S10  ',   10533,  35, 0,5.8530D0,0.000D+00,1.0D0,
     & 'BL_C1+  ',   10543,  45,+1,6.7300D0,0.000D+00,1.0D0,
     & 'BL_1BAR0',  -10513,  51, 0,5.7600D0,0.000D+00,1.0D0,
     & 'BL_1-   ',  -10523,  52,-1,5.7600D0,0.000D+00,1.0D0,
     & 'BL_S1BR0',  -10533,  53, 0,5.8530D0,0.000D+00,1.0D0,
     & 'BL_C1-  ',  -10543,  54,-1,6.7300D0,0.000D+00,1.0D0,
     & 'K*_0+   ',   10321,  23,+1,1.4290D0,0.000D+00,0.0D0,
     & 'K*_00   ',   10311,  13, 0,1.4290D0,0.000D+00,0.0D0,
     & 'K*_0BAR0',  -10311,  31, 0,1.4290D0,0.000D+00,0.0D0,
     & 'K*_0-   ',  -10321,  32,-1,1.4290D0,0.000D+00,0.0D0,
     & 'D*_0+   ',   10411,  41,+1,2.4230D0,0.000D+00,0.0D0,
     & 'D*_00   ',   10421,  42, 0,2.4230D0,0.000D+00,0.0D0,
     & 'D*_S0+  ',   10431,  43,+1,2.5250D0,0.000D+00,0.0D0,
     & 'D*_0-   ',  -10411,  14,-1,2.4230D0,0.000D+00,0.0D0,
     & 'D*_0BAR0',  -10421,  24, 0,2.4230D0,0.000D+00,0.0D0,
     & 'D*_S0-  ',  -10431,  34,-1,2.5250D0,0.000D+00,0.0D0/
      DATA (RNAME(I),IDPDG(I),IFLAV(I),ICHRG(I),RMASS(I),RLTIM(I),
     &      RSPIN(I),I=337,352)/
     & 'B*_00   ',   10511,  15, 0,5.7600D0,0.000D+00,0.0D0,
     & 'B*_0+   ',   10521,  25,+1,5.7600D0,0.000D+00,0.0D0,
     & 'B*_S00  ',   10531,  35, 0,5.8550D0,0.000D+00,0.0D0,
     & 'B*_C0+  ',   10541,  45,+1,6.7300D0,0.000D+00,0.0D0,
     & 'B*_0BAR0',  -10511,  51, 0,5.7600D0,0.000D+00,0.0D0,
     & 'B*_0-   ',  -10521,  52,-1,5.7600D0,0.000D+00,0.0D0,
     & 'B*_S0BR0',  -10531,  53, 0,5.8550D0,0.000D+00,0.0D0,
     & 'B*_C0-  ',  -10541,  54,-1,6.7300D0,0.000D+00,0.0D0,
     & 'SGMA*_B-',    5114, 115,-1,5.8400D0,0.000D+00,1.5D0,
     & 'SIGMA_B0',    5212, 125, 0,5.8200D0,0.000D+00,0.5D0,
     & 'SGMA*_B0',    5214, 125, 0,5.8400D0,0.000D+00,1.5D0,
     & 'SGMA*_B+',    5224, 225,+1,5.8400D0,0.000D+00,1.5D0,
     & 'XIP_B0  ',    5322, 235, 0,5.9450D0,0.000D+00,0.5D0,
     & 'XI*_B0  ',    5324, 235, 0,5.9450D0,0.000D+00,1.5D0,
     & 'XIP_B-  ',    5312, 135,-1,5.9450D0,0.000D+00,0.5D0,
     & 'XI*_B-  ',    5314, 135,-1,5.9450D0,0.000D+00,1.5D0/
      DATA (RNAME(I),IDPDG(I),IFLAV(I),ICHRG(I),RMASS(I),RLTIM(I),
     &      RSPIN(I),I=353,368)/
     & '0MGA*_B-',    5334, 335,-1,6.0600D0,0.000D+00,1.5D0,
     & 'SG*_BBR+',   -5114,-115,+1,5.8400D0,0.000D+00,1.5D0,
     & 'SGM_BBR0',   -5212,-125, 0,5.8200D0,0.000D+00,0.5D0,
     & 'SG*_BBR0',   -5214,-125, 0,5.8400D0,0.000D+00,1.5D0,
     & 'SG*_BBR-',   -5224,-225,-1,5.8400D0,0.000D+00,1.5D0,
     & 'XIP_BBR0',   -5322,-235, 0,5.9450D0,0.000D+00,0.5D0,
     & 'XI*_BBR0',   -5324,-235, 0,5.9450D0,0.000D+00,1.5D0,
     & 'XIP_B+  ',   -5312,-135,+1,5.9450D0,0.000D+00,0.5D0,
     & 'XI*_B+  ',   -5314,-135,+1,5.9450D0,0.000D+00,1.5D0,
     & '0MGA*_B+',   -5334,-335,+1,6.0600D0,0.000D+00,1.5D0,
     & 'KDL_2+  ',   10325,  23,+1,1.7730D0,0.000D+00,2.0D0,
     & 'KDL_20  ',   10315,  13, 0,1.7730D0,0.000D+00,2.0D0,
     & 'KDL_2BR0',  -10315,  31, 0,1.7730D0,0.000D+00,2.0D0,
     & 'KDL_2-  ',  -10325,  32,-1,1.7730D0,0.000D+00,2.0D0,
     & 'KD*+    ',   30323,  23,+1,1.7170D0,0.000D+00,1.0D0,
     & 'KD*0    ',   30313,  13, 0,1.7170D0,0.000D+00,1.0D0/
      DATA (RNAME(I),IDPDG(I),IFLAV(I),ICHRG(I),RMASS(I),RLTIM(I),
     &      RSPIN(I),I=369,384)/
     & 'KD*BAR0 ',  -30313,  31, 0,1.7170D0,0.000D+00,1.0D0,
     & 'KD*-    ',  -30323,  32,-1,1.7170D0,0.000D+00,1.0D0,
     & 'KDH_2+  ',   20325,  23,+1,1.8160D0,0.000D+00,2.0D0,
     & 'KDH_20  ',   20315,  13, 0,1.8160D0,0.000D+00,2.0D0,
     & 'KDH_2BR0',  -20315,  31, 0,1.8160D0,0.000D+00,2.0D0,
     & 'KDH_2-  ',  -20325,  32,-1,1.8160D0,0.000D+00,2.0D0,
     & 'KD_3+   ',     327,  23,+1,1.7730D0,0.000D+00,3.0D0,
     & 'KD_30   ',     317,  13, 0,1.7730D0,0.000D+00,3.0D0,
     & 'KD_3BAR0',    -317,  31, 0,1.7730D0,0.000D+00,3.0D0,
     & 'KD_3-   ',    -327,  32,-1,1.7730D0,0.000D+00,3.0D0,
     & 'PI_2+   ',   10215,  21,+1,1.6700D0,0.000D+00,2.0D0,
     & 'PI_20   ',   10115,  11, 0,1.6700D0,0.000D+00,2.0D0,
     & 'PI_2-   ',  -10215,  12,-1,1.6700D0,0.000D+00,2.0D0,
     & 'RHOD+   ',   30213,  21,+1,1.7000D0,0.000D+00,1.0D0,
     & 'RHOD0   ',   30113,  11, 0,1.7000D0,0.000D+00,1.0D0,
     & 'RHOD-   ',  -30213,  12,-1,1.7000D0,0.000D+00,1.0D0/
      DATA (RNAME(I),IDPDG(I),IFLAV(I),ICHRG(I),RMASS(I),RLTIM(I),
     &      RSPIN(I),I=385,400)/
     & 'RHO_3+  ',     217,  21,+1,1.6910D0,0.000D+00,3.0D0,
     & 'RHO_30  ',     117,  11, 0,1.6910D0,0.000D+00,3.0D0,
     & 'RHO_3-  ',    -217,  12,-1,1.6910D0,0.000D+00,3.0D0,
     & 'UPSLON2S',  100553,  55, 0,10.023D0,0.000D+00,1.0D0,
     & 'CHI2P_B0',  110551,  55, 0,10.232D0,0.000D+00,0.0D0,
     & 'CHI2P_B1',  120553,  55, 0,10.255D0,0.000D+00,1.0D0,
     & 'CHI2P_B2',  100555,  55, 0,10.269D0,0.000D+00,2.0D0,
     & 'UPSLON3S',  200553,  55, 0,10.355D0,0.000D+00,1.0D0,
     & 'UPSLON4S',  300553,  55, 0,10.580D0,0.000D+00,1.0D0,
     & '        ',       0,   0, 0,0.0   D0,  0.0D+00,  0D0,
     & 'OMEGA_3 ',     227,  33, 0,1.6670D0,0.000D+00,3.0D0,
     & 'PHI_3   ',     337,  33, 0,1.8540D0,0.000D+00,3.0D0,
     & 'ETA_2(L)',   10225,  33, 0,1.6320D0,0.000D+00,2.0D0,
     & 'ETA_2(H)',   10335,  33, 0,1.8540D0,0.000D+00,2.0D0,
     & 'OMEGA(H)',   30223,  33, 0,1.6490D0,0.000D+00,1.0D0,
     & '        ',       0,   0, 0,0.0   D0,0.0D+00  ,  0D0/
      DATA (RNAME(I),IDPDG(I),IFLAV(I),ICHRG(I),RMASS(I),RLTIM(I),
     &      RSPIN(I),I=401,416)/
     & 'SSDL    ', 1000001,   0,-1,0.00D0,1.000D+30,0.0D0,
     & 'SSUL    ', 1000002,   0,+2,0.00D0,1.000D+30,0.0D0,
     & 'SSSL    ', 1000003,   0,-1,0.00D0,1.000D+30,0.0D0,
     & 'SSCL    ', 1000004,   0,+2,0.00D0,1.000D+30,0.0D0,
     & 'SSB1    ', 1000005,   0,-1,0.00D0,1.000D+30,0.0D0,
     & 'SST1    ', 1000006,   0,+2,0.00D0,1.000D+30,0.0D0,
     & 'SSDLBR  ',-1000001,   0,+1,0.00D0,1.000D+30,0.0D0,
     & 'SSULBR  ',-1000002,   0,-2,0.00D0,1.000D+30,0.0D0,
     & 'SSSLBR  ',-1000003,   0,+1,0.00D0,1.000D+30,0.0D0,
     & 'SSCLBR  ',-1000004,   0,-2,0.00D0,1.000D+30,0.0D0,
     & 'SSB1BR  ',-1000005,   0,+1,0.00D0,1.000D+30,0.0D0,
     & 'SST1BR  ',-1000006,   0,-2,0.00D0,1.000D+30,0.0D0,
     & 'SSDR    ', 2000001,   0,-1,0.00D0,1.000D+30,0.0D0,
     & 'SSUR    ', 2000002,   0,+2,0.00D0,1.000D+30,0.0D0,
     & 'SSSR    ', 2000003,   0,-1,0.00D0,1.000D+30,0.0D0,
     & 'SSCR    ', 2000004,   0,+2,0.00D0,1.000D+30,0.0D0/
      DATA (RNAME(I),IDPDG(I),IFLAV(I),ICHRG(I),RMASS(I),RLTIM(I),
     &      RSPIN(I),I=417,432)/
     & 'SSB2    ', 2000005,   0,-1,0.00D0,1.000D+30,0.0D0,
     & 'SST2    ', 2000006,   0,+2,0.00D0,1.000D+30,0.0D0,
     & 'SSDRBR  ',-2000001,   0,+1,0.00D0,1.000D+30,0.0D0,
     & 'SSURBR  ',-2000002,   0,-2,0.00D0,1.000D+30,0.0D0,
     & 'SSSRBR  ',-2000003,   0,+1,0.00D0,1.000D+30,0.0D0,
     & 'SSCRBR  ',-2000004,   0,-2,0.00D0,1.000D+30,0.0D0,
     & 'SSB2BR  ',-2000005,   0,+1,0.00D0,1.000D+30,0.0D0,
     & 'SST2BR  ',-2000006,   0,-2,0.00D0,1.000D+30,0.0D0,
     & 'SSEL-   ', 1000011,   0,-1,0.00D0,1.000D+30,0.0D0,
     & 'SSNUEL  ', 1000012,   0, 0,0.00D0,1.000D+30,0.0D0,
     & 'SSMUL-  ', 1000013,   0,-1,0.00D0,1.000D+30,0.0D0,
     & 'SSNUMUL ', 1000014,   0, 0,0.00D0,1.000D+30,0.0D0,
     & 'SSTAU1- ', 1000015,   0,-1,0.00D0,1.000D+30,0.0D0,
     & 'SSNUTL  ', 1000016,   0, 0,0.00D0,1.000D+30,0.0D0,
     & 'SSEL+   ',-1000011,   0,+1,0.00D0,1.000D+30,0.0D0,
     & 'SSNUELBR',-1000012,   0, 0,0.00D0,1.000D+30,0.0D0/
      DATA (RNAME(I),IDPDG(I),IFLAV(I),ICHRG(I),RMASS(I),RLTIM(I),
     &      RSPIN(I),I=433,448)/
     & 'SSMUL+  ',-1000013,   0,+1,0.00D0,1.000D+30,0.0D0,
     & 'SSNUMLBR',-1000014,   0, 0,0.00D0,1.000D+30,0.0D0,
     & 'SSTAU1+ ',-1000015,   0,+1,0.00D0,1.000D+30,0.0D0,
     & 'SSNUTLBR',-1000016,   0, 0,0.00D0,1.000D+30,0.0D0,
     & 'SSER-   ', 2000011,   0,-1,0.00D0,1.000D+30,0.0D0,
     & 'SSNUER  ', 2000012,   0, 0,0.00D0,1.000D+30,0.0D0,
     & 'SSMUR-  ', 2000013,   0,-1,0.00D0,1.000D+30,0.0D0,
     & 'SSNUMUR ', 2000014,   0, 0,0.00D0,1.000D+30,0.0D0,
     & 'SSTAU2- ', 2000015,   0,-1,0.00D0,1.000D+30,0.0D0,
     & 'SSNUTR  ', 2000016,   0, 0,0.00D0,1.000D+30,0.0D0,
     & 'SSER+   ',-2000011,   0,+1,0.00D0,1.000D+30,0.0D0,
     & 'SSNUERBR',-2000012,   0, 0,0.00D0,1.000D+30,0.0D0,
     & 'SSMUR+  ',-2000013,   0,+1,0.00D0,1.000D+30,0.0D0,
     & 'SSNUMRBR',-2000014,   0, 0,0.00D0,1.000D+30,0.0D0,
     & 'SSTAU2+ ',-2000015,   0,+1,0.00D0,1.000D+30,0.0D0,
     & 'SSNUTRBR',-2000016,   0, 0,0.00D0,1.000D+30,0.0D0/
      DATA (RNAME(I),IDPDG(I),IFLAV(I),ICHRG(I),RMASS(I),RLTIM(I),
     &      RSPIN(I),I=449,NLAST)/
     & 'GLUINO  ', 1000021,   0, 0,0.00D0,1.000D+30,0.5D0,
     & 'NTLINO1 ', 1000022,   0, 0,0.00D0,1.000D+30,0.5D0,
     & 'NTLINO2 ', 1000023,   0, 0,0.00D0,1.000D+30,0.5D0,
     & 'NTLINO3 ', 1000025,   0, 0,0.00D0,1.000D+30,0.5D0,
     & 'NTLINO4 ', 1000035,   0, 0,0.00D0,1.000D+30,0.5D0,
     & 'CHGINO1+', 1000024,   0,+1,0.00D0,1.000D+30,0.5D0,
     & 'CHGINO2+', 1000037,   0,+1,0.00D0,1.000D+30,0.5D0,
     & 'CHGINO1-',-1000024,   0,-1,0.00D0,1.000D+30,0.5D0,
     & 'CHGINO2-',-1000037,   0,-1,0.00D0,1.000D+30,0.5D0,
     & 'GRAVTINO', 1000039,   0, 0,0.00D0,1.000D+30,1.5D0/
C
      DATA QORQQB/.FALSE.,
     & 6*.TRUE.,6*.FALSE.,96*.FALSE.,6*.FALSE.,6*.TRUE.,NREST*.FALSE./
      DATA QBORQQ/.FALSE.,
     & 6*.FALSE.,6*.TRUE.,96*.FALSE.,6*.TRUE.,6*.FALSE.,NREST*.FALSE./
C
C     In the character strings use an ampersand to represent a backslash
C     to avoid compiler problems with the C escape character
      DATA ((TXNAME(J,I),J=1,2),I=0,8)/
     & '                                     ',
     & '                                     ',
     & '                                    d',
     & '                                    d',
     & '                                    u',
     & '                                    u',
     & '                                    s',
     & '                                    s',
     & '                                    c',
     & '                                    c',
     & '                                    b',
     & '                                    b',
     & '                                    t',
     & '                                    t',
     & '                        $&bar{&rm d}$',
     & '                                   -d',
     & '                        $&bar{&rm u}$',
     & '                                   -u'/
      DATA ((TXNAME(J,I),J=1,2),I=9,16)/
     & '                        $&bar{&rm s}$',
     & '                                   -s',
     & '                        $&bar{&rm c}$',
     & '                                   -c',
     & '                        $&bar{&rm b}$',
     & '                                   -b',
     & '                        $&bar{&rm t}$',
     & '                                   -t',
     & '                                  $g$',
     & '                                    g',
     & '                                  CoM',
     & '                                  CoM',
     & '                                 Hard',
     & '                                 Hard',
     & '                                 Soft',
     & '                                 Soft'/
      DATA ((TXNAME(J,I),J=1,2),I=17,24)/
     & '                                 Cone',
     & '                                 Cone',
     & '                                Heavy',
     & '                                Heavy',
     & '                              Cluster',
     & '                              Cluster',
     & '               $&star&star&star&star$',
     & '                                 ****',
     & '                              $&pi^0$',
     & '                       pi<SUP>0</SUP>',
     & '                               $&eta$',
     & '                                  eta',
     & '                             $&rho^0$',
     & '                      rho<SUP>0</SUP>',
     & '                             $&omega$',
     & '                                omega'/
      DATA ((TXNAME(J,I),J=1,2),I=25,32)/
     & '                        $&eta^&prime$',
     & '                      eta<SUP>''</SUP>',
     & '                                $f_2$',
     & '                        f<SUB>2</SUB>',
     & '                              $a^0_1$',
     & '            a<SUB>1</SUB><SUP>0</SUP>',
     & '                             $f_1(L)$',
     & '                     f<SUB>1</SUB>(L)',
     & '                              $a^0_2$',
     & '            a<SUB>2</SUB><SUP>0</SUP>',
     & '                              $&pi^-$',
     & '                       pi<SUP>-</SUP>',
     & '                             $&rho^-$',
     & '                      rho<SUP>-</SUP>',
     & '                              $a^-_1$',
     & '            a<SUB>1</SUB><SUP>-</SUP>'/
      DATA ((TXNAME(J,I),J=1,2),I=33,40)/
     & '                              $a^-_2$',
     & '            a<SUB>2</SUB><SUP>-</SUP>',
     & '                                K$^-$',
     & '                        K<SUP>-</SUP>',
     & '                         K$^{&star-}$',
     & '                       K<SUP>*-</SUP>',
     & '                           K$_1(H)^-$',
     & '         K<SUB>1</SUB>(H)<SUP>-</SUP>',
     & '                       K$^{&star-}_2$',
     & '           K<SUB>2</SUB><SUP>*-</SUP>',
     & '                              $&pi^+$',
     & '                       pi<SUP>+</SUP>',
     & '                             $&rho^+$',
     & '                      rho<SUP>+</SUP>',
     & '                              $a^+_1$',
     & '            a<SUB>1</SUB><SUP>+</SUP>'/
      DATA ((TXNAME(J,I),J=1,2),I=41,48)/
     & '                              $a^+_2$',
     & '            a<SUB>2</SUB><SUP>+</SUP>',
     & '                 $&overline{&rm K}^0$',
     & '                       -K<SUP>0</SUP>',
     & '          $&overline{&rm K}^{&star0}$',
     & '                      -K<SUP>*0</SUP>',
     & '            $&overline{&rm K}_1(H)^0$',
     & '        -K<SUB>1</SUB>(H)<SUP>0</SUP>',
     & '        $&overline{&rm K}^{&star0}_2$',
     & '          -K<SUB>2</SUB><SUP>*0</SUP>',
     & '                                K$^+$',
     & '                        K<SUP>+</SUP>',
     & '                         K$^{&star+}$',
     & '                       K<SUP>*+</SUP>',
     & '                           K$_1(H)^+$',
     & '         K<SUB>1</SUB>(H)<SUP>+</SUP>'/
      DATA ((TXNAME(J,I),J=1,2),I=49,56)/
     & '                       K$^{&star+}_2$',
     & '        K<SUB>2</SUB>(H)<SUP>*+</SUP>',
     & '                                K$^0$',
     & '                        K<SUP>0</SUP>',
     & '                         K$^{&star0}$',
     & '                       K<SUP>*-</SUP>',
     & '                           K$_1(H)^0$',
     & '         K<SUB>1</SUB>(H)<SUP>0</SUP>',
     & '                       K$^{&star0}_2$',
     & '           K<SUB>2</SUB><SUP>*0</SUP>',
     & '                                     ',
     & '                                     ',
     & '                                     ',
     & '                                     ',
     & '                               $&phi$',
     & '                                  phi'/
      DATA ((TXNAME(J,I),J=1,2),I=57,64)/
     & '                          $f_1(1420)$',
     & '                  f<SUB>1</SUB>(1420)',
     & '                         $f^&prime_2$',
     & '            f<SUP>''</SUP><SUB>2</SUB>',
     & '                             $&gamma$',
     & '                                gamma',
     & '                        K$^0_{&rm S}$',
     & '            K<SUB>S</SUB><SUP>0</SUP>',
     & '                        K$^0_{&rm L}$',
     & '            K<SUB>L</SUB><SUP>0</SUP>',
     & '                        $a_0(1450)^0$',
     & '      a<SUB>0</SUB>(1450)<SUP>0</SUP>',
     & '                        $a_0(1450)^+$',
     & '      a<SUB>0</SUB>(1450)<SUP>+</SUP>',
     & '                        $a_0(1450)^-$',
     & '      a<SUB>0</SUB>(1450)<SUP>-</SUP>'/
      DATA ((TXNAME(J,I),J=1,2),I=65,72)/
     & '                                     ',
     & '                                     ',
     & '                                     ',
     & '                                     ',
     & '                                     ',
     & '                                     ',
     & '                                     ',
     & '                                     ',
     & '                                     ',
     & '                                     ',
     & '                                     ',
     & '                                     ',
     & '                     $&gamma$-remnant',
     & '                        gamma-remnant',
     & '                          $N$-remnant',
     & '                            N-remnant'/
      DATA ((TXNAME(J,I),J=1,2),I=73,80)/
     & '                                    p',
     & '                                    p',
     & '                           $&Delta^+$',
     & '                    Delta<SUP>+</SUP>',
     & '                                    n',
     & '                                    n',
     & '                           $&Delta^0$',
     & '                    Delta<SUP>0</SUP>',
     & '                           $&Delta^-$',
     & '                    Delta<SUP>-</SUP>',
     & '                            $&Lambda$',
     & '                               Lambda',
     & '                           $&Sigma^0$',
     & '                    Sigma<SUP>0</SUP>',
     & '                    $&Sigma^{&star0}$',
     & '                   Sigma<SUP>*0</SUP>'/
      DATA ((TXNAME(J,I),J=1,2),I=81,88)/
     & '                           $&Sigma^-$',
     & '                    Sigma<SUP>-</SUP>',
     & '                    $&Sigma^{&star-}$',
     & '                   Sigma<SUP>*-</SUP>',
     & '                              $&Xi^-$',
     & '                       Xi<SUP>-</SUP>',
     & '                       $&Xi^{&star-}$',
     & '                      Xi<SUP>*-</SUP>',
     & '                        $&Delta^{++}$',
     & '                   Delta<SUP>++</SUP>',
     & '                           $&Sigma^+$',
     & '                    Sigma<SUP>+</SUP>',
     & '                    $&Sigma^{&star+}$',
     & '                   Sigma<SUP>*+</SUP>',
     & '                              $&Xi^0$',
     & '                       Xi<SUP>0</SUP>'/
      DATA ((TXNAME(J,I),J=1,2),I=89,96)/
     & '                       $&Xi^{&star0}$',
     & '                      Xi<SUP>*0</SUP>',
     & '                           $&Omega^-$',
     & '                    Omega<SUP>-</SUP>',
     & '                        $&bar{&rm p}$',
     & '                                   -p',
     & '                $&overline{&Delta}^-$',
     & '                   -Delta<SUP>-</SUP>',
     & '                        $&bar{&rm n}$',
     & '                                   -n',
     & '                $&overline{&Delta}^0$',
     & '                   -Delta<SUP>0</SUP>',
     & '                $&overline{&Delta}^+$',
     & '                   -Delta<SUP>+</SUP>',
     & '                 $&overline{&Lambda}$',
     & '                              -Lambda'/
      DATA ((TXNAME(J,I),J=1,2),I=97,104)/
     & '                $&overline{&Sigma}^0$',
     & '                   -Sigma<SUP>0</SUP>',
     & '         $&overline{&Sigma}^{&star0}$',
     & '                  -Sigma<SUP>*0</SUP>',
     & '                $&overline{&Sigma}^+$',
     & '                   -Sigma<SUP>+</SUP>',
     & '         $&overline{&Sigma}^{&star+}$',
     & '                  -Sigma<SUP>*+</SUP>',
     & '                   $&overline{&Xi}^+$',
     & '                      -Xi<SUP>+</SUP>',
     & '            $&overline{&Xi}^{&star+}$',
     & '                     -Xi<SUP>*+</SUP>',
     & '             $&overline{&Delta}^{--}$',
     & '                  -Delta<SUP>--</SUP>',
     & '                $&overline{&Sigma}^-$',
     & '                   -Sigma<SUP>-</SUP>'/
      DATA ((TXNAME(J,I),J=1,2),I=105,112)/
     & '         $&overline{&Sigma}^{&star-}$',
     & '                  -Sigma<SUP>*-</SUP>',
     & '                   $&overline{&Xi}^0$',
     & '                      -Xi<SUP>0</SUP>',
     & '              $&overline&Xi^{&star0}$',
     & '                     -Xi<SUP>*0</SUP>',
     & '                $&overline{&Omega}^+$',
     & '                   -Omega<SUP>+</SUP>',
     & '                                   uu',
     & '                                   uu',
     & '                                   ud',
     & '                                   ud',
     & '                                   dd',
     & '                                   dd',
     & '                                   us',
     & '                                   us'/
      DATA ((TXNAME(J,I),J=1,2),I=113,120)/
     & '                                   ds',
     & '                                   ds',
     & '                                   ss',
     & '                                   ss',
     & '             $&bar{&rm u}&bar{&rm u}$',
     & '                                  -uu',
     & '             $&bar{&rm u}&bar{&rm d}$',
     & '                                  -ud',
     & '             $&bar{&rm d}&bar{&rm d}$',
     & '                                  -dd',
     & '             $&bar{&rm u}&bar{&rm s}$',
     & '                                  -us',
     & '             $&bar{&rm d}&bar{&rm s}$',
     & '                                  -ds',
     & '             $&bar{&rm s}&bar{&rm s}$',
     & '                                  -ss'/
      DATA ((TXNAME(J,I),J=1,2),I=121,128)/
     & '                                e$^-$',
     & '                        e<SUP>-</SUP>',
     & '                        $&nu_{&rm e}$',
     & '                       nu<SUB>e</SUB>',
     & '                              $&mu^-$',
     & '                       mu<SUP>-</SUP>',
     & '                            $&nu_&mu$',
     & '                      nu<SUB>mu</SUB>',
     & '                             $&tau^-$',
     & '                      tau<SUP>-</SUP>',
     & '                           $&nu_&tau$',
     & '                     nu<SUB>tau</SUB>',
     & '                                e$^+$',
     & '                        e<SUP>+</SUP>',
     & '                  $&bar{&nu}_{&rm e}$',
     & '                      -nu<SUB>e</SUB>'/
      DATA ((TXNAME(J,I),J=1,2),I=129,136)/
     & '                              $&mu^+$',
     & '                       mu<SUP>+</SUP>',
     & '                      $&bar{&nu}_&mu$',
     & '                     -nu<SUB>mu</SUB>',
     & '                             $&tau^+$',
     & '                      tau<SUP>+</SUP>',
     & '                     $&bar{&nu}_&tau$',
     & '                    -nu<SUB>tau</SUB>',
     & '                                     ',
     & '                                     ',
     & '                                     ',
     & '                                     ',
     & '                                     ',
     & '                                     ',
     & '                                D$^+$',
     & '                        D<SUP>+</SUP>'/
      DATA ((TXNAME(J,I),J=1,2),I=137,144)/
     & '                         D$^{&star+}$',
     & '                       D<SUP>*+</SUP>',
     & '                           D$_1(H)^+$',
     & '         D<SUB>1</SUB>(H)<SUP>+</SUP>',
     & '                       D$_2^{&star+}$',
     & '           D<SUB>2</SUB><SUP>*+</SUP>',
     & '                                D$^0$',
     & '                        D<SUP>0</SUP>',
     & '                         D$^{&star0}$',
     & '                       D<SUP>*0</SUP>',
     & '                           D$_1(H)^0$',
     & '         D<SUB>1</SUB>(H)<SUP>0</SUP>',
     & '                       D$_2^{&star0}$',
     & '           D<SUB>2</SUB><SUP>*0</SUP>',
     & '                        D$_{&rm s}^+$',
     & '            D<SUB>s</SUB><SUP>+</SUP>'/
      DATA ((TXNAME(J,I),J=1,2),I=145,152)/
     & '                 D$_{&rm s}^{&star+}$',
     & '           D<SUB>s</SUB><SUP>*+</SUP>',
     & '                    D$_{&rm s1}(H)^+$',
     & '        D<SUB>s1</SUB>(H)<SUP>+</SUP>',
     & '                D$^{&star+}_{&rm s2}$',
     & '       D<SUB>s1</SUB>(H)<SUP>*+</SUP>',
     & '                $&Sigma_{&rm c}^{++}$',
     & '       Sigma<SUB>c</SUB><SUP>++</SUP>',
     & '           $&Sigma_{&rm c}^{&star++}$',
     & '      Sigma<SUB>c</SUB><SUP>*++</SUP>',
     & '                  $&Lambda_{&rm c}^+$',
     & '       Lambda<SUB>c</SUB><SUP>+</SUP>',
     & '                   $&Sigma_{&rm c}^+$',
     & '        Sigma<SUB>c</SUB><SUP>+</SUP>',
     & '            $&Sigma_{&rm c}^{&star+}$',
     & '       Sigma<SUB>c</SUB><SUP>*+</SUP>'/
      DATA ((TXNAME(J,I),J=1,2),I=153,160)/
     & '                   $&Sigma_{&rm c}^0$',
     & '        Sigma<SUB>c</SUB><SUP>0</SUP>',
     & '            $&Sigma_{&rm c}^{&star0}$',
     & '       Sigma<SUB>c</SUB><SUP>*0</SUP>',
     & '                      $&Xi_{&rm c}^+$',
     & '           Xi<SUB>c</SUB><SUP>+</SUP>',
     & '              $&Xi_{&rm c}^{&prime+}$',
     & '          Xi<SUB>c</SUB><SUP>''+</SUP>',
     & '               $&Xi_{&rm c}^{&star+}$',
     & '          Xi<SUB>c</SUB><SUP>*+</SUP>',
     & '                      $&Xi_{&rm c}^0$',
     & '           Xi<SUB>c</SUB><SUP>0</SUP>',
     & '              $&Xi_{&rm c}^{&prime0}$',
     & '          Xi<SUB>c</SUB><SUP>''0</SUP>',
     & '               $&Xi_{&rm c}^{&star0}$',
     & '          Xi<SUB>c</SUB><SUP>*0</SUP>'/
      DATA ((TXNAME(J,I),J=1,2),I=161,168)/
     & '                   $&Omega_{&rm c}^0$',
     & '        Omega<SUB>c</SUB><SUP>0</SUP>',
     & '            $&Omega_{&rm c}^{&star0}$',
     & '       Omega<SUB>c</SUB><SUP>*0</SUP>',
     & '                   $&eta_{&rm c}(1S)$',
     & '                  eta<SUB>c</SUB>(1S)',
     & '                             J/$&psi$',
     & '                                J/psi',
     & '                  $&chi_{&rm c0}(1P)$',
     & '                 chi<SUB>c0</SUB>(1P)',
     & '                           $&psi(2S)$',
     & '                              psi(2S)',
     & '                           $&psi(1D)$',
     & '                              psi(1D)',
     & '                                     ',
     & '                                     '/
      DATA ((TXNAME(J,I),J=1,2),I=169,176)/
     & '                                     ',
     & '                                     ',
     & '                                     ',
     & '                                     ',
     & '                                D$^-$',
     & '                        D<SUP>-</SUP>',
     & '                         D$^{&star-}$',
     & '                       D<SUP>*-</SUP>',
     & '                           D$_1(H)^-$',
     & '         D<SUB>1</SUB>(H)<SUP>-</SUP>',
     & '                       D$_2^{&star-}$',
     & '           D<SUB>2</SUB><SUP>*-</SUP>',
     & '                 $&overline{&rm D}^0$',
     & '                       -D<SUP>0</SUP>',
     & '          $&overline{&rm D}^{&star0}$',
     & '                      -D<SUP>*0</SUP>'/
      DATA ((TXNAME(J,I),J=1,2),I=177,184)/
     & '            $&overline{&rm D}_1(H)^0$',
     & '        -D<SUB>1</SUB>(H)<SUP>0</SUP>',
     & '        $&overline{&rm D}_2^{&star0}$',
     & '          -D<SUB>2</SUB><SUP>*0</SUP>',
     & '                        D$_{&rm s}^-$',
     & '            D<SUB>s</SUB><SUP>-</SUP>',
     & '                 D$_{&rm s}^{&star-}$',
     & '           D<SUB>s</SUB><SUP>*-</SUP>',
     & '                    D$_{&rm s1}(H)^-$',
     & '        D<SUB>s1</SUB>(H)<SUP>-</SUP>',
     & '                D$_{&rm s2}^{&star-}$',
     & '       D<SUB>s1</SUB>(H)<SUP>*-</SUP>',
     & '     $&overline{&Sigma}_{&rm c}^{--}$',
     & '      -Sigma<SUB>c</SUB><SUP>--</SUP>',
     & '$&overline{&Sigma}_{&rm c}^{&star--}$',
     & '     -Sigma<SUB>c</SUB><SUP>*--</SUP>'/
      DATA ((TXNAME(J,I),J=1,2),I=185,192)/
     & '       $&overline{&Lambda}_{&rm c}^-$',
     & '      -Lambda<SUB>c</SUB><SUP>-</SUP>',
     & '        $&overline{&Sigma}_{&rm c}^-$',
     & '       -Sigma<SUB>c</SUB><SUP>-</SUP>',
     & ' $&overline{&Sigma}_{&rm c}^{&star-}$',
     & '      -Sigma<SUB>c</SUB><SUP>*-</SUP>',
     & '        $&overline{&Sigma}_{&rm c}^0$',
     & '       -Sigma<SUB>c</SUB><SUP>0</SUP>',
     & ' $&overline{&Sigma}_{&rm c}^{&star0}$',
     & '      -Sigma<SUB>c</SUB><SUP>*0</SUP>',
     & '           $&overline{&Xi}_{&rm c}^-$',
     & '          -Xi<SUB>c</SUB><SUP>-</SUP>',
     & '   $&overline{&Xi}_{&rm c}^{&prime-}$',
     & '         -Xi<SUB>c</SUB><SUP>''-</SUP>',
     & '    $&overline{&Xi}_{&rm c}^{&star-}$',
     & '         -Xi<SUB>c</SUB><SUP>*-</SUP>'/
      DATA ((TXNAME(J,I),J=1,2),I=193,200)/
     & '           $&overline{&Xi}_{&rm c}^0$',
     & '          -Xi<SUB>c</SUB><SUP>0</SUP>',
     & '   $&overline{&Xi}_{&rm c}^{&prime0}$',
     & '         -Xi<SUB>c</SUB><SUP>''0</SUP>',
     & '    $&overline{&Xi}_{&rm c}^{&star0}$',
     & '         -Xi<SUB>c</SUB><SUP>*0</SUP>',
     & '        $&overline{&Omega}_{&rm c}^0$',
     & '       -Omega<SUB>c</SUB><SUP>0</SUP>',
     & ' $&overline{&Omega}_{&rm c}^{&star0}$',
     & '      -Omega<SUB>c</SUB><SUP>*0</SUP>',
     & '                                W$^+$',
     & '                        W<SUP>+</SUP>',
     & '                                W$^-$',
     & '                        W<SUP>-</SUP>',
     & '                   Z$^0/&gamma^&star$',
     & '      Z<SUP>0</SUP>/gamma<SUP>*</SUP>'/
      DATA ((TXNAME(J,I),J=1,2),I=201,208)/
     & '                       $H^0_{&rm SM}$',
     & '           H<SUP>0</SUP><SUB>SM</SUB>',
     & '                        Z$^{&prime0}$',
     & '                       Z<SUP>''0</SUP>',
     & '                                $h^0$',
     & '                        h<SUP>0</SUP>',
     & '                                $H^0$',
     & '                        H<SUP>0</SUP>',
     & '                                $A^0$',
     & '                        A<SUP>0</SUP>',
     & '                                $H^+$',
     & '                        H<SUP>+</SUP>',
     & '                                $H^-$',
     & '                        H<SUP>-</SUP>',
     & '                                  $G$',
     & '                                    G'/
      DATA ((TXNAME(J,I),J=1,2),I=209,216)/
     & '                              V-quark',
     & '                              V-quark',
     & '                              A-quark',
     & '                              A-quark',
     & '                              H-quark',
     & '                              H-quark',
     & '                     H$^&prime$-quark',
     & '                  H<SUP>''</SUP>-quark',
     & '                                     ',
     & '                                     ',
     & '                                     ',
     & '                                     ',
     & '             $&overline{&rm V}$-quark',
     & '                             -V-quark',
     & '             $&overline{&rm A}$-quark',
     & '                             -A-quark'/
      DATA ((TXNAME(J,I),J=1,2),I=217,224)/
     & '             $&overline{&rm H}$-quark',
     & '                             -H-quark',
     & '      $&overline{&rm H}^&prime$-quark',
     & '                 -H<SUP>''</SUP>-quark',
     & '                                     ',
     & '                                     ',
     & '                                     ',
     & '                                     ',
     & '         $&overline{&rm B}_{&rm d}^0$',
     & '           -B<SUB>d</SUB><SUP>0</SUP>',
     & '                                B$^-$',
     & '                        B<SUP>-</SUP>',
     & '         $&overline{&rm B}_{&rm s}^0$',
     & '           -B<SUB>s</SUB><SUP>0</SUP>',
     & '                   $&Sigma_{&rm b}^+$',
     & '        Sigma<SUB>b</SUB><SUP>+</SUP>'/
      DATA ((TXNAME(J,I),J=1,2),I=225,232)/
     & '                  $&Lambda_{&rm b}^0$',
     & '       Lambda<SUB>b</SUB><SUP>0</SUP>',
     & '                   $&Sigma_{&rm b}^-$',
     & '        Sigma<SUB>b</SUB><SUP>-</SUP>',
     & '                      $&Xi_{&rm b}^0$',
     & '           Xi<SUB>b</SUB><SUP>0</SUP>',
     & '                      $&Xi_{&rm b}^-$',
     & '           Xi<SUB>b</SUB><SUP>-</SUP>',
     & '                   $&Omega_{&rm b}^-$',
     & '        Omega<SUB>b</SUB><SUP>-</SUP>',
     & '                        B$_{&rm c}^-$',
     & '            B<SUB>c</SUB><SUP>-</SUP>',
     & '                       $&Upsilon(1S)$',
     & '                          Upsilon(1S)',
     & '                        T$_{&rm b}^-$',
     & '            T<SUB>b</SUB><SUP>-</SUP>'/
      DATA ((TXNAME(J,I),J=1,2),I=233,240)/
     & '                                T$^+$',
     & '                        T<SUP>+</SUP>',
     & '                                T$^0$',
     & '                        T<SUP>0</SUP>',
     & '                        T$_{&rm s}^+$',
     & '            T<SUB>s</SUB><SUP>+</SUP>',
     & '                $&Sigma_{&rm t}^{++}$',
     & '       Sigma<SUB>t</SUB><SUP>++</SUP>',
     & '                  $&Lambda_{&rm t}^0$',
     & '       Lambda<SUB>t</SUB><SUP>0</SUP>',
     & '                   $&Sigma_{&rm t}^0$',
     & '        Sigma<SUB>t</SUB><SUP>0</SUP>',
     & '                     $&chi_{&rm t}^+$',
     & '           Xi<SUB>t</SUB><SUP>+</SUP>',
     & '                     $&chi_{&rm t}^0$',
     & '           Xi<SUB>t</SUB><SUP>0</SUP>'/
      DATA ((TXNAME(J,I),J=1,2),I=241,248)/
     & '                   $&Omega_{&rm t}^0$',
     & '        Omega<SUB>t</SUB><SUP>0</SUP>',
     & '                        T$_{&rm c}^0$',
     & '            T<SUB>c</SUB><SUP>0</SUP>',
     & '                        T$_{&rm b}^+$',
     & '            T<SUB>b</SUB><SUP>+</SUP>',
     & '                             Toponium',
     & '                             Toponium',
     & '                        B$_{&rm d}^0$',
     & '            B<SUB>d</SUB><SUP>0</SUP>',
     & '                                B$^+$',
     & '                        B<SUP>+</SUP>',
     & '                        B$_{&rm s}^0$',
     & '            B<SUB>s</SUB><SUP>0</SUP>',
     & '        $&overline{&Sigma}_{&rm b}^-$',
     & '       -Sigma<SUB>b</SUB><SUP>-</SUP>'/
      DATA ((TXNAME(J,I),J=1,2),I=249,256)/
     & '       $&overline{&Lambda}_{&rm b}^-$',
     & '      -Lambda<SUB>b</SUB><SUP>-</SUP>',
     & '        $&overline{&Sigma}_{&rm b}^+$',
     & '       -Sigma<SUB>b</SUB><SUP>+</SUP>',
     & '           $&overline{&Xi}_{&rm b}^0$',
     & '          -Xi<SUB>b</SUB><SUP>0</SUP>',
     & '                      $&Xi_{&rm b}^+$',
     & '           Xi<SUB>b</SUB><SUP>+</SUP>',
     & '        $&overline{&Omega}_{&rm b}^+$',
     & '       -Omega<SUB>b</SUB><SUP>+</SUP>',
     & '                        B$_{&rm c}^+$',
     & '            B<SUB>c</SUB><SUP>+</SUP>',
     & '                                T$^-$',
     & '                        T<SUP>-</SUP>',
     & '                 $&overline{&rm T}^0$',
     & '                        T<SUP>0</SUP>'/
      DATA ((TXNAME(J,I),J=1,2),I=257,264)/
     & '                        T$_{&rm s}^-$',
     & '            T<SUB>s</SUB><SUP>-</SUP>',
     & '     $&overline{&Sigma}_{&rm t}^{--}$',
     & '       Sigma<SUB>t</SUB><SUP>--</SUP>',
     & '       $&overline{&Lambda}_{&rm t}^-$',
     & '      -Lambda<SUB>t</SUB><SUP>-</SUP>',
     & '        $&overline{&Sigma}_{&rm t}^0$',
     & '       -Sigma<SUB>t</SUB><SUP>0</SUP>',
     & '           $&overline{&Xi}_{&rm t}^-$',
     & '          -Xi<SUB>t</SUB><SUP>-</SUP>',
     & '           $&overline{&Xi}_{&rm t}^0$',
     & '          -Xi<SUB>t</SUB><SUP>0</SUP>',
     & '        $&overline{&Omega}_{&rm t}^0$',
     & '       -Omega<SUB>t</SUB><SUP>0</SUP>',
     & '         $&overline{&rm T}_{&rm c}^0$',
     & '            T<SUB>c</SUB><SUP>0</SUP>'/
      DATA ((TXNAME(J,I),J=1,2),I=265,272)/
     & '          $&overline{&rm B}^{&star0}$',
     & '                      -B<SUP>*0</SUP>',
     & '                         B$^{&star-}$',
     & '                       B<SUP>*-</SUP>',
     & '  $&overline{&rm B}_{&rm s}^{&star0}$',
     & '          -B<SUB>s</SUB><SUP>*0</SUP>',
     & '            $&overline{&rm B}_1(H)^0$',
     & '        -B<SUB>1</SUB>(H)<SUP>0</SUP>',
     & '                           B$_1(H)^-$',
     & '         B<SUB>1</SUB>(H)<SUP>-</SUP>',
     & '     $&overline{&rm B}_{&rm s1}(H)^0$',
     & '       -B<SUB>s1</SUB>(H)<SUP>0</SUP>',
     & '        $&overline{&rm B}_2^{&star0}$',
     & '          -B<SUB>2</SUB><SUP>*0</SUP>',
     & '                       B$_2^{&star-}$',
     & '           B<SUB>2</SUB><SUP>*-</SUP>'/
      DATA ((TXNAME(J,I),J=1,2),I=273,280)/
     & '                B$_{&rm s2}^{&star0}$',
     & '          B<SUB>s2</SUB><SUP>*0</SUP>',
     & '                         B$^{&star0}$',
     & '                       B<SUP>*0</SUP>',
     & '                         B$^{&star+}$',
     & '                       B<SUP>*+</SUP>',
     & '                 B$_{&rm s}^{&star0}$',
     & '           B<SUB>s</SUB><SUP>*0</SUP>',
     & '                           B$_1(H)^0$',
     & '         B<SUB>1</SUB>(H)<SUP>0</SUP>',
     & '                           B$_1(H)^+$',
     & '         B<SUB>1</SUB>(H)<SUP>+</SUP>',
     & '                    B$_{&rm s1}(H)^0$',
     & '        B<SUB>s1</SUB>(H)<SUP>0</SUP>',
     & '                       B$_2^{&star0}$',
     & '           B<SUB>2</SUB><SUP>*0</SUP>'/
      DATA ((TXNAME(J,I),J=1,2),I=281,288)/
     & '                       B$_2^{&star+}$',
     & '           B<SUB>2</SUB><SUP>*+</SUP>',
     & '                B$_{&rm s2}^{&star0}$',
     & '          B<SUB>s2</SUB><SUP>*0</SUP>',
     & '                                     ',
     & '                                     ',
     & '                                     ',
     & '                                     ',
     & '                              b$_1^0$',
     & '            b<SUB>1</SUB><SUP>0</SUP>',
     & '                              b$_1^+$',
     & '            b<SUB>1</SUB><SUP>+</SUP>',
     & '                              b$_1^-$',
     & '            b<SUB>1</SUB><SUP>-</SUP>',
     & '                           h$_1(L)^0$',
     & '         h<SUB>1</SUB>(L)<SUP>0</SUP>'/
      DATA ((TXNAME(J,I),J=1,2),I=289,296)/
     & '                           h$_1(H)^0$',
     & '         h<SUB>1</SUB>(H)<SUP>0</SUP>',
     & '                         a$_0(980)^0$',
     & '       a<SUB>0</SUB>(980)<SUP>0</SUP>',
     & '                         a$_0(980)^+$',
     & '       a<SUB>0</SUB>(980)<SUP>+</SUP>',
     & '                         a$_0(980)^-$',
     & '       a<SUB>0</SUB>(980)<SUP>-</SUP>',
     & '                           f$_0(980)$',
     & '                   f<SUB>0</SUB>(980)',
     & '                          f$_0(1370)$',
     & '                  f<SUB>0</SUB>(1370)',
     & '                 B$_{&rm c}^{&star+}$',
     & '           B<SUB>c</SUB><SUP>*+</SUP>',
     & '                 B$_{&rm c}^{&star-}$',
     & '           B<SUB>c</SUB><SUP>*-</SUP>'/
      DATA ((TXNAME(J,I),J=1,2),I=297,304)/
     & '                    B$_{&rm c1}(H)^+$',
     & '        B<SUB>c1</SUB>(H)<SUP>+</SUP>',
     & '                    B$_{&rm c1}(H)^-$',
     & '        B<SUB>c1</SUB>(H)<SUP>-</SUP>',
     & '                B$_{&rm c2}^{&star+}$',
     & '          B<SUB>c2</SUB><SUP>*+</SUP>',
     & '                B$_{&rm c2}^{&star-}$',
     & '          B<SUB>c2</SUB><SUP>*-</SUP>',
     & '                      h$_{&rm c}(1P)$',
     & '                    h<SUB>c</SUB>(1P)',
     & '                  $&chi_{&rm c0}(1P)$',
     & '                 chi<SUB>c0</SUB>(1P)',
     & '                  $&chi_{&rm c2}(1P)$',
     & '                 chi<SUB>c2</SUB>(1P)',
     & '                   $&eta_{&rm b}(1S)$',
     & '                  eta<SUB>b</SUB>(1S)'/
      DATA ((TXNAME(J,I),J=1,2),I=305,312)/
     & '                      h$_{&rm b}(1P)$',
     & '                    h<SUB>b</SUB>(1P)',
     & '                  $&chi_{&rm b0}(1P)$',
     & '                 chi<SUB>b0</SUB>(1P)',
     & '                  $&chi_{&rm b1}(1P)$',
     & '                 chi<SUB>b1</SUB>(1P)',
     & '                  $&chi_{&rm b2}(1P)$',
     & '                 chi<SUB>b2</SUB>(1P)',
     & '                           K$_1(L)^0$',
     & '         K<SUB>1</SUB>(L)<SUP>0</SUP>',
     & '                           K$_1(L)^+$',
     & '         K<SUB>1</SUB>(L)<SUP>+</SUP>',
     & '            $&overline{&rm K}_1(L)^0$',
     & '        -K<SUB>1</SUB>(L)<SUP>0</SUP>',
     & '                           K$_1(L)^-$',
     & '         K<SUB>1</SUB>(L)<SUP>-</SUP>'/
      DATA ((TXNAME(J,I),J=1,2),I=313,320)/
     & '                           D$_1(L)^+$',
     & '         D<SUB>1</SUB>(L)<SUP>+</SUP>',
     & '                           D$_1(L)^0$',
     & '         D<SUB>1</SUB>(L)<SUP>0</SUP>',
     & '                    D$_{&rm s1}(L)^+$',
     & '        D<SUB>s1</SUB>(L)<SUP>+</SUP>',
     & '                           D$_1(L)^-$',
     & '         D<SUB>1</SUB>(L)<SUP>-</SUP>',
     & '            $&overline{&rm D}_1(L)^0$',
     & '         D<SUB>1</SUB>(L)<SUP>0</SUP>',
     & '                    D$_{&rm s1}(L)^-$',
     & '        D<SUB>s1</SUB>(L)<SUP>-</SUP>',
     & '                           B$_1(L)^0$',
     & '         B<SUB>1</SUB>(L)<SUP>0</SUP>',
     & '                           B$_1(L)^+$',
     & '         B<SUB>1</SUB>(L)<SUP>+</SUP>'/
      DATA ((TXNAME(J,I),J=1,2),I=321,328)/
     & '                    B$_{&rm s1}(L)^0$',
     & '        B<SUB>s1</SUB>(L)<SUP>0</SUP>',
     & '                    B$_{&rm c1}(L)^+$',
     & '        B<SUB>c1</SUB>(L)<SUP>+</SUP>',
     & '            $&overline{&rm B}_1(L)^0$',
     & '        -B<SUB>1</SUB>(L)<SUP>0</SUP>',
     & '                           B$_1(L)^-$',
     & '         B<SUB>1</SUB>(L)<SUP>-</SUP>',
     & '     $&overline{&rm B}_{&rm s1}(L)^0$',
     & '       -B<SUB>s1</SUB>(L)<SUP>0</SUP>',
     & '                    B$_{&rm c1}(L)^-$',
     & '        B<SUB>c1</SUB>(L)<SUP>-</SUP>',
     & '                       K$_0^{&star+}$',
     & '           K<SUB>0</SUB><SUP>*+</SUP>',
     & '                       K$_0^{&star0}$',
     & '           K<SUB>0</SUB><SUP>*0</SUP>'/
      DATA ((TXNAME(J,I),J=1,2),I=329,336)/
     & '        $&overline{&rm K}_0^{&star0}$',
     & '          -K<SUB>0</SUB><SUP>*0</SUP>',
     & '                       K$_0^{&star-}$',
     & '           K<SUB>0</SUB><SUP>*-</SUP>',
     & '                       D$_0^{&star+}$',
     & '           D<SUB>0</SUB><SUP>*+</SUP>',
     & '                       D$_0^{&star0}$',
     & '           D<SUB>0</SUB><SUP>*0</SUP>',
     & '                D$_{&rm s0}^{&star+}$',
     & '          D<SUB>s0</SUB><SUP>*+</SUP>',
     & '                       D$_0^{&star-}$',
     & '           D<SUB>0</SUB><SUP>*-</SUP>',
     & '        $&overline{&rm D}_0^{&star0}$',
     & '          -D<SUB>0</SUB><SUP>*0</SUP>',
     & '                D$_{&rm s0}^{&star-}$',
     & '          D<SUB>s0</SUB><SUP>*-</SUP>'/
      DATA ((TXNAME(J,I),J=1,2),I=337,344)/
     & '                       B$_0^{&star0}$',
     & '           B<SUB>0</SUB><SUP>*0</SUP>',
     & '                       B$_0^{&star+}$',
     & '           B<SUB>0</SUB><SUP>*+</SUP>',
     & '                B$_{&rm s0}^{&star0}$',
     & '          B<SUB>s0</SUB><SUP>*0</SUP>',
     & '                B$_{&rm c0}^{&star+}$',
     & '          B<SUB>c0</SUB><SUP>*+</SUP>',
     & '        $&overline{&rm B}_0^{&star0}$',
     & '          -B<SUB>0</SUB><SUP>*0</SUP>',
     & '                       B$_0^{&star-}$',
     & '           B<SUB>0</SUB><SUP>*-</SUP>',
     & ' $&overline{&rm B}_{&rm s0}^{&star0}$',
     & '         -B<SUB>s0</SUB><SUP>*0</SUP>',
     & '                B$_{&rm c0}^{&star-}$',
     & '          B<SUB>c0</SUB><SUP>*-</SUP>'/
      DATA ((TXNAME(J,I),J=1,2),I=345,352)/
     & '                   $&Sigma_{&rm b}^0$',
     & '        Sigma<SUB>b</SUB><SUP>0</SUP>',
     & '            $&Sigma_{&rm b}^{&star-}$',
     & '       Sigma<SUB>b</SUB><SUP>*-</SUP>',
     & '            $&Sigma_{&rm b}^{&star0}$',
     & '       Sigma<SUB>b</SUB><SUP>*0</SUP>',
     & '            $&Sigma_{&rm b}^{&star+}$',
     & '       Sigma<SUB>b</SUB><SUP>*+</SUP>',
     & '              $&Xi_{&rm b}^{&prime0}$',
     & '          Xi<SUB>b</SUB><SUP>''0</SUP>',
     & '               $&Xi_{&rm b}^{&star0}$',
     & '          Xi<SUB>b</SUB><SUP>*0</SUP>',
     & '              $&Xi_{&rm b}^{&prime-}$',
     & '          Xi<SUB>b</SUB><SUP>''-</SUP>',
     & '               $&Xi_{&rm b}^{&star-}$',
     & '          Xi<SUB>b</SUB><SUP>*-</SUP>'/
      DATA ((TXNAME(J,I),J=1,2),I=353,360)/
     & '            $&Omega_{&rm b}^{&star-}$',
     & '      -Omega<SUB>b</SUB><SUP>*-</SUP>',
     & ' $&overline{&Sigma}_{&rm b}^{&star+}$',
     & '       Sigma<SUB>b</SUB><SUP>*+</SUP>',
     & '        $&overline{&Sigma}_{&rm b}^0$',
     & '       -Sigma<SUB>b</SUB><SUP>0</SUP>',
     & ' $&overline{&Sigma}_{&rm b}^{&star0}$',
     & '      -Sigma<SUB>b</SUB><SUP>*0</SUP>',
     & ' $&overline{&Sigma}_{&rm b}^{&star-}$',
     & '      -Sigma<SUB>b</SUB><SUP>*-</SUP>',
     & '   $&overline{&Xi}_{&rm b}^{&prime0}$',
     & '         -Xi<SUB>b</SUB><SUP>''0</SUP>',
     & '    $&overline{&Xi}_{&rm b}^{&star0}$',
     & '         -Xi<SUB>b</SUB><SUP>*0</SUP>',
     & '   $&overline{&Xi}_{&rm b}^{&prime+}$',
     & '         -Xi<SUB>b</SUB><SUP>''+</SUP>'/
      DATA ((TXNAME(J,I),J=1,2),I=361,368)/
     & '    $&overline{&Xi}_{&rm b}^{&star+}$',
     & '         -Xi<SUB>b</SUB><SUP>*+</SUP>',
     & '            $&Omega_{&rm b}^{&star+}$',
     & '       Omega<SUB>b</SUB><SUP>*+</SUP>',
     & '                          K$(DL)_2^+$',
     & '        K(DL)<SUB>2</SUB><SUP>+</SUP>',
     & '                          K$(DL)_2^0$',
     & '        K(DL)<SUB>2</SUB><SUP>0</SUP>',
     & '           $&overline{&rm K}(DL)_2^0$',
     & '       -K(DL)<SUB>2</SUB><SUP>0</SUP>',
     & '                          K$(DL)_2^-$',
     & '        K(DL)<SUB>2</SUB><SUP>-</SUP>',
     & '                      K$(D)^{&star+}$',
     & '                    K(D)<SUP>*+</SUP>',
     & '                      K$(D)^{&star0}$',
     & '                    K(D)<SUP>*0</SUP>'/
      DATA ((TXNAME(J,I),J=1,2),I=369,376)/
     & '      $&overline{&rm  K}(D)^{&star0}$',
     & '                   -K(D)<SUP>*0</SUP>',
     & '                      K$(D)^{&star-}$',
     & '                    K(D)<SUP>*-</SUP>',
     & '                          K$(DH)_2^+$',
     & '        K(DH)<SUB>2</SUB><SUP>+</SUP>',
     & '                          K$(DH)_2^0$',
     & '        K(DH)<SUB>2</SUB><SUP>0</SUP>',
     & '           $&overline{&rm K}(DH)_2^0$',
     & '       -K(DH)<SUB>2</SUB><SUP>0</SUP>',
     & '                          K$(DH)_2^-$',
     & '        K(DH)<SUB>2</SUB><SUP>-</SUP>',
     & '                           K$(D)_3^+$',
     & '         K(D)<SUB>3</SUB><SUP>+</SUP>',
     & '                           K$(D)_3^0$',
     & '         K(D)<SUB>3</SUB><SUP>0</SUP>'/
      DATA ((TXNAME(J,I),J=1,2),I=377,384)/
     & '            $&overline{&rm K}(D)_3^0$',
     & '        -K(D)<SUB>3</SUB><SUP>0</SUP>',
     & '                           K$(D)_3^-$',
     & '         K(D)<SUB>3</SUB><SUP>-</SUP>',
     & '                            $&pi_2^+$',
     & '           pi<SUB>2</SUB><SUP>+</SUP>',
     & '                            $&pi_2^0$',
     & '           pi<SUB>2</SUB><SUP>0</SUP>',
     & '                            $&pi_2^-$',
     & '           pi<SUB>2</SUB><SUP>-</SUP>',
     & '                          $&rho(D)^+$',
     & '                   rho(D)<SUP>+</SUP>',
     & '                          $&rho(D)^0$',
     & '                   rho(D)<SUP>0</SUP>',
     & '                          $&rho(D)^-$',
     & '                   rho(D)<SUP>-</SUP>'/
      DATA ((TXNAME(J,I),J=1,2),I=385,392)/
     & '                           $&rho_3^+$',
     & '          rho<SUB>3</SUB><SUP>+</SUP>',
     & '                           $&rho_3^0$',
     & '          rho<SUB>3</SUB><SUP>0</SUP>',
     & '                           $&rho_3^-$',
     & '          rho<SUB>3</SUB><SUP>-</SUP>',
     & '                       $&Upsilon(2S)$',
     & '                          Upsilon(2S)',
     & '                  $&chi_{&rm b0}(2P)$',
     & '                 Chi<SUB>b0</SUB>(2P)',
     & '                  $&chi_{&rm b1}(2P)$',
     & '                 Chi<SUB>b1</SUB>(2P)',
     & '                  $&chi_{&rm b2}(2P)$',
     & '                 Chi<SUB>b2</SUB>(2P)',
     & '                       $&Upsilon(3S)$',
     & '                          Upsilon(3S)'/
      DATA ((TXNAME(J,I),J=1,2),I=393,400)/
     & '                       $&Upsilon(4S)$',
     & '                          Upsilon(4S)',
     & '                                     ',
     & '                                     ',
     & '                           $&omega_3$',
     & '                    omega<SUB>3</SUB>',
     & '                             $&phi_3$',
     & '                      phi<SUB>3</SUB>',
     & '                          $&eta_2(L)$',
     & '                   eta<SUB>2</SUB>(L)',
     & '                          $&eta_2(H)$',
     & '                   eta<SUB>2</SUB>(H)',
     & '                          $&omega(H)$',
     & '                             omega(H)',
     & '                                     ',
     & '                                     '/
      DATA ((TXNAME(J,I),J=1,2),I=401,408)/
     & '              $&tilde{&rm d}_{&rm L}$',
     & '                       ~d<SUB>L</SUB>',
     & '              $&tilde{&rm u}_{&rm L}$',
     & '                       ~u<SUB>L</SUB>',
     & '              $&tilde{&rm s}_{&rm L}$',
     & '                       ~s<SUB>L</SUB>',
     & '              $&tilde{&rm c}_{&rm L}$',
     & '                       ~c<SUB>L</SUB>',
     & '                    $&tilde{&rm b}_1$',
     & '                       ~b<SUB>1</SUB>',
     & '                    $&tilde{&rm t}_1$',
     & '                       ~t<SUB>1</SUB>',
     & '   $&overline{&tilde{&rm d}}_{&rm L}$',
     & '                      -~d<SUB>L</SUB>',
     & '   $&overline{&tilde{&rm u}}_{&rm L}$',
     & '                      -~u<SUB>L</SUB>'/
      DATA ((TXNAME(J,I),J=1,2),I=409,416)/
     & '   $&overline{&tilde{&rm s}}_{&rm L}$',
     & '                      -~s<SUB>L</SUB>',
     & '   $&overline{&tilde{&rm c}}_{&rm L}$',
     & '                      -~c<SUB>L</SUB>',
     & '         $&overline{&tilde{&rm b}}_1$',
     & '                      -~b<SUB>1</SUB>',
     & '         $&overline{&tilde{&rm t}}_1$',
     & '                      -~t<SUB>1</SUB>',
     & '              $&tilde{&rm d}_{&rm R}$',
     & '                       ~d<SUB>R</SUB>',
     & '              $&tilde{&rm u}_{&rm R}$',
     & '                       ~u<SUB>R</SUB>',
     & '              $&tilde{&rm s}_{&rm R}$',
     & '                       ~s<SUB>R</SUB>',
     & '              $&tilde{&rm c}_{&rm R}$',
     & '                       ~c<SUB>R</SUB>'/
      DATA ((TXNAME(J,I),J=1,2),I=417,424)/
     & '                    $&tilde{&rm b}_2$',
     & '                       ~b<SUB>2</SUB>',
     & '                    $&tilde{&rm t}_2$',
     & '                       ~t<SUB>2</SUB>',
     & '   $&overline{&tilde{&rm d}}_{&rm R}$',
     & '                      -~d<SUB>R</SUB>',
     & '   $&overline{&tilde{&rm u}}_{&rm R}$',
     & '                      -~u<SUB>R</SUB>',
     & '   $&overline{&tilde{&rm s}}_{&rm R}$',
     & '                      -~s<SUB>R</SUB>',
     & '   $&overline{&tilde{&rm c}}_{&rm R}$',
     & '                      -~c<SUB>R</SUB>',
     & '         $&overline{&tilde{&rm b}}_2$',
     & '                      -~b<SUB>2</SUB>',
     & '         $&overline{&tilde{&rm t}}_2$',
     & '                      -~t<SUB>2</SUB>'/
      DATA ((TXNAME(J,I),J=1,2),I=425,432)/
     & '            $&tilde{&rm e}^-_{&rm L}$',
     & '           ~e<SUP>-</SUP><SUB>L</SUB>',
     & '                $&tilde{&nu}_{&rm e}$',
     & '                    ~nu<SUB>e L</SUB>',
     & '              $&tilde{&mu}^-_{&rm L}$',
     & '          ~mu<SUP>-</SUP><SUB>L</SUB>',
     & '                    $&tilde{&nu}_&mu$',
     & '                   ~nu<SUB>mu L</SUB>',
     & '                   $&tilde{&tau}^-_1$',
     & '         ~tau<SUP>-</SUP><SUB>1</SUB>',
     & '                   $&tilde{&nu}_&tau$',
     & '                  ~nu<SUB>tau L</SUB>',
     & '            $&tilde{&rm e}^+_{&rm L}$',
     & '           ~e<SUP>+</SUP><SUB>L</SUB>',
     & '    $&overline{&tilde{&nu}}_{&rm eL}$',
     & '                    -~nu<SUB>eL</SUB>'/
      DATA ((TXNAME(J,I),J=1,2),I=433,440)/
     & '              $&tilde{&mu}^+_{&rm L}$',
     & '          ~mu<SUP>+</SUP><SUB>L</SUB>',
     & '  $&overline{&tilde{&nu}}_{&rm&mu L}$',
     & '                  -~nu<SUB>mu L</SUB>',
     & '                   $&tilde{&tau}^+_1$',
     & '         ~tau<SUP>+</SUP><SUB>1</SUB>',
     & ' $&overline{&tilde{&nu}}_{&rm&tau L}$',
     & '                 -~nu<SUB>tau L</SUB>',
     & '            $&tilde{&rm e}^-_{&rm R}$',
     & '           ~e<SUP>-</SUP><SUB>R</SUB>',
     & '               $&tilde{&nu}_{&rm eR}$',
     & '                    ~nu<SUB>e R</SUB>',
     & '              $&tilde{&mu}^-_{&rm R}$',
     & '          ~mu<SUP>-</SUP><SUB>R</SUB>',
     & '           $&tilde{&nu}_{&mu{&rm R}}$',
     & '                   ~nu<SUB>mu R</SUB>'/
      DATA ((TXNAME(J,I),J=1,2),I=441,448)/
     & '                   $&tilde{&tau}^-_2$',
     & '         ~tau<SUP>-</SUP><SUB>2</SUB>',
     & '          $&tilde{&nu}_{&tau{&rm R}}$',
     & '                  ~nu<SUB>tau R</SUB>',
     & '            $&tilde{&rm e}^+_{&rm R}$',
     & '           ~e<SUP>+</SUP><SUB>R</SUB>',
     & '    $&overline{&tilde{&nu}}_{&rm eR}$',
     & '                   -~nu<SUB>e R</SUB>',
     & '              $&tilde{&mu}^+_{&rm R}$',
     & '          ~mu<SUP>+</SUP><SUB>R</SUB>',
     & '  $&overline{&tilde{&nu}}_{&rm&mu R}$',
     & '                  -~nu<SUB>mu R</SUB>',
     & '                   $&tilde{&tau}^+_2$',
     & '         ~tau<SUP>+</SUP><SUB>2</SUB>',
     & ' $&overline{&tilde{&nu}}_{&rm&tau R}$',
     & '                 -~nu<SUB>tau R</SUB>'/
      DATA ((TXNAME(J,I),J=1,2),I=449,456)/
     & '                          $&tilde{g}$',
     & '                                   ~g',
     & '                   $&tilde{&chi}^0_1$',
     & '         ~chi<SUP>0</SUP><SUB>1</SUB>',
     & '                   $&tilde{&chi}^0_2$',
     & '         ~chi<SUP>0</SUP><SUB>2</SUB>',
     & '                   $&tilde{&chi}^0_3$',
     & '         ~chi<SUP>0</SUP><SUB>3</SUB>',
     & '                   $&tilde{&chi}^0_4$',
     & '         ~chi<SUP>0</SUP><SUB>4</SUB>',
     & '                   $&tilde{&chi}^+_1$',
     & '         ~chi<SUP>+</SUP><SUB>1</SUB>',
     & '                   $&tilde{&chi}^+_2$',
     & '         ~chi<SUP>+</SUP><SUB>2</SUB>',
     & '                   $&tilde{&chi}^-_1$',
     & '         ~chi<SUP>-</SUP><SUB>1</SUB>'/
      DATA ((TXNAME(J,I),J=1,2),I=457,NLAST)/
     & '                   $&tilde{&chi}^-_2$',
     & '         ~chi<SUP>-</SUP><SUB>2</SUB>',
     & '                          $&tilde{G}$',
     & '                                   ~G'/
C
      DATA (RNAME(I),I=NNEXT,NMXRES)/NLEFT*'        '/
      DATA (IDPDG(I),I=NNEXT,NMXRES)/NLEFT*0/
      DATA (IFLAV(I),I=NNEXT,NMXRES)/NLEFT*0/
      DATA (RMASS(I),I=NNEXT,NMXRES)/NLEFT*0.0000D0/
      DATA (RLTIM(I),I=NNEXT,NMXRES)/NLEFT*0.000D+00/
      DATA (RSPIN(I),I=NNEXT,NMXRES)/NLEFT*0.0D0/
      DATA (TXNAME(1,I),I=NNEXT,NMXRES)/
     & NLEFT*'                                    '/
      DATA (TXNAME(2,I),I=NNEXT,NMXRES)/
     & NLEFT*'                                    '/
C
      DATA (RSTAB(I),I=1,NMXRES)/NMXRES*.FALSE./
      DATA DKPSET/.FALSE./
C
      DATA NDKYS/2263/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=   1,  19)/
     &   6,0.334D0,100,  2,  7,  5,  0,  0,
     &   6,0.333D0,100,  4,  9,  5,  0,  0,
     &   6,0.111D0,100,122,127,  5,  0,  0,
     &   6,0.111D0,100,124,129,  5,  0,  0,
     &   6,0.111D0,100,126,131,  5,  0,  0,
     &  12,0.334D0,100,  8,  1, 11,  0,  0,
     &  12,0.333D0,100, 10,  3, 11,  0,  0,
     &  12,0.111D0,100,128,121, 11,  0,  0,
     &  12,0.111D0,100,130,123, 11,  0,  0,
     &  12,0.111D0,100,132,125, 11,  0,  0,
     &  21,0.988D0,  0, 59, 59,  0,  0,  0,
     &  21,0.012D0,  0,127,121, 59,  0,  0,
     &  22,0.388D0,  0, 59, 59,  0,  0,  0,
     &  22,0.319D0,  0, 21, 21, 21,  0,  0,
     &  22,0.001D0,  0, 21, 59, 59,  0,  0,
     &  22,0.236D0,  0, 38, 30, 21,  0,  0,
     &  22,0.049D0,  0, 38, 30, 59,  0,  0,
     &  22,0.005D0,  0,127,121, 59,  0,  0,
     &  22,0.002D0,  0, 38, 30,127,121,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=  20,  38)/
     &  23,0.989D0,  0, 38, 30,  0,  0,  0,
     &  23,0.010D0,  0, 38, 30, 59,  0,  0,
     &  23,0.001D0,  0, 21, 59,  0,  0,  0,
     &  24,0.888D0,  0, 38, 30, 21,  0,  0,
     &  24,0.085D0,  0, 21, 59,  0,  0,  0,
     &  24,0.022D0,  0, 38, 30,  0,  0,  0,
     &  24,0.001D0,  0, 22, 59,  0,  0,  0,
     &  24,0.001D0,  0, 21,127,121,  0,  0,
     &  24,0.003D0,  0, 38, 30, 21, 21,  0,
     &  25,0.437D0,  0, 38, 30, 22,  0,  0,
     &  25,0.302D0,  0, 23, 59,  0,  0,  0,
     &  25,0.208D0,  0, 21, 21, 22,  0,  0,
     &  25,0.030D0,  0, 24, 59,  0,  0,  0,
     &  25,0.021D0,  0, 59, 59,  0,  0,  0,
     &  25,0.002D0,  0, 21, 21, 21,  0,  0,
     &  26,0.566D0,  0, 38, 30,  0,  0,  0,
     &  26,0.283D0,  0, 21, 21,  0,  0,  0,
     &  26,0.069D0,  0, 38, 30, 21, 21,  0,
     &  26,0.023D0,  0, 46, 34,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=  39,  57)/
     &  26,0.023D0,  0, 50, 42,  0,  0,  0,
     &  26,0.028D0,  0, 38, 38, 30, 30,  0,
     &  26,0.005D0,  0, 22, 22,  0,  0,  0,
     &  26,0.003D0,  0, 21, 21, 21, 21,  0,
     &  27,0.499D0,  0, 39, 30,  0,  0,  0,
     &  27,0.499D0,  0, 31, 38,  0,  0,  0,
     &  27,0.002D0,  0, 21, 59, 59,  0,  0,
     &  28,0.148D0,  0, 21, 21, 38, 30,  0,
     &  28,0.148D0,  0, 23, 38, 30,  0,  0,
     &  28,0.147D0,  0,291, 30,  0,  0,  0,
     &  28,0.147D0,  0,290, 21,  0,  0,  0,
     &  28,0.147D0,  0,292, 38,  0,  0,  0,
     &  28,0.067D0,  0, 22, 38, 30,  0,  0,
     &  28,0.033D0,  0, 22, 21, 21,  0,  0,
     &  28,0.032D0,  0, 46, 42, 30,  0,  0,
     &  28,0.016D0,  0, 46, 34, 21,  0,  0,
     &  28,0.016D0,  0, 50, 42, 21,  0,  0,
     &  28,0.032D0,  0, 50, 34, 38,  0,  0,
     &  28,0.066D0,  0, 59, 23,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=  58,  76)/
     &  28,0.001D0,  0, 56, 59,  0,  0,  0,
     &  29,0.349D0,  0, 39, 30,  0,  0,  0,
     &  29,0.349D0,  0, 31, 38,  0,  0,  0,
     &  29,0.144D0,  0, 22, 21,  0,  0,  0,
     &  29,0.104D0,  0, 24, 38, 30,  0,  0,
     &  29,0.024D0,  0, 46, 34,  0,  0,  0,
     &  29,0.024D0,  0, 50, 42,  0,  0,  0,
     &  29,0.006D0,  0, 25, 21,  0,  0,  0,
     &  30,1.000D0,  0,123,130,  0,  0,  0,
     &  31,1.000D0,  0, 30, 21,  0,  0,  0,
     &  32,0.499D0,  0, 31, 21,  0,  0,  0,
     &  32,0.499D0,  0, 23, 30,  0,  0,  0,
     &  32,0.002D0,  0, 30, 59,  0,  0,  0,
     &  33,0.349D0,  0, 31, 21,  0,  0,  0,
     &  33,0.349D0,  0, 23, 30,  0,  0,  0,
     &  33,0.144D0,  0, 22, 30,  0,  0,  0,
     &  33,0.101D0,  0, 24, 30, 21,  0,  0,
     &  33,0.048D0,  0, 50, 34,  0,  0,  0,
     &  33,0.006D0,  0, 25, 30,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=  77,  95)/
     &  33,0.003D0,  0, 30, 59,  0,  0,  0,
     &  34,0.629D0,  0,123,130,  0,  0,  0,
     &  34,0.212D0,  0, 30, 21,  0,  0,  0,
     &  34,0.056D0,  0, 30, 38, 30,  0,  0,
     &  34,0.017D0,  0, 30, 21, 21,  0,  0,
     &  34,0.048D0,101,121,128, 21,  0,  0,
     &  34,0.032D0,101,123,130, 21,  0,  0,
     &  34,0.006D0,  0,123,130, 59,  0,  0,
     &  35,0.666D0,  0, 42, 30,  0,  0,  0,
     &  35,0.333D0,  0, 34, 21,  0,  0,  0,
     &  35,0.001D0,  0, 34, 59,  0,  0,  0,
     &  36,0.627D0,  0, 43, 30,  0,  0,  0,
     &  36,0.313D0,  0, 35, 21,  0,  0,  0,
     &  36,0.020D0,  0, 42, 31,  0,  0,  0,
     &  36,0.010D0,  0, 34, 23,  0,  0,  0,
     &  36,0.020D0,  0, 34,294,  0,  0,  0,
     &  36,0.010D0,  0, 34, 24,  0,  0,  0,
     &  37,0.331D0,  0, 42, 30,  0,  0,  0,
     &  37,0.166D0,  0, 34, 21,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=  96, 114)/
     &  37,0.168D0,  0, 43, 30,  0,  0,  0,
     &  37,0.084D0,  0, 35, 21,  0,  0,  0,
     &  37,0.087D0,  0, 35, 38, 30,  0,  0,
     &  37,0.044D0,  0, 35, 21, 21,  0,  0,
     &  37,0.059D0,  0, 42, 31,  0,  0,  0,
     &  37,0.029D0,  0, 34, 23,  0,  0,  0,
     &  37,0.029D0,  0, 34, 24,  0,  0,  0,
     &  37,0.002D0,  0, 34, 59,  0,  0,  0,
     &  37,0.001D0,  0, 34, 22,  0,  0,  0,
     &  38,1.000D0,  0,129,124,  0,  0,  0,
     &  39,1.000D0,  0, 38, 21,  0,  0,  0,
     &  40,0.499D0,  0, 39, 21,  0,  0,  0,
     &  40,0.499D0,  0, 23, 38,  0,  0,  0,
     &  40,0.002D0,  0, 38, 59,  0,  0,  0,
     &  41,0.349D0,  0, 39, 21,  0,  0,  0,
     &  41,0.349D0,  0, 23, 38,  0,  0,  0,
     &  41,0.144D0,  0, 22, 38,  0,  0,  0,
     &  41,0.101D0,  0, 24, 38, 21,  0,  0,
     &  41,0.048D0,  0, 46, 42,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 115, 133)/
     &  41,0.006D0,  0, 25, 38,  0,  0,  0,
     &  41,0.003D0,  0, 38, 59,  0,  0,  0,
     &  42,0.500D0,  0, 60,  0,  0,  0,  0,
     &  42,0.500D0,  0, 61,  0,  0,  0,  0,
     &  43,0.665D0,  0, 34, 38,  0,  0,  0,
     &  43,0.333D0,  0, 42, 21,  0,  0,  0,
     &  43,0.002D0,  0, 42, 59,  0,  0,  0,
     &  44,0.627D0,  0, 35, 38,  0,  0,  0,
     &  44,0.313D0,  0, 43, 21,  0,  0,  0,
     &  44,0.020D0,  0, 34, 39,  0,  0,  0,
     &  44,0.010D0,  0, 42, 23,  0,  0,  0,
     &  44,0.020D0,  0, 42,294,  0,  0,  0,
     &  44,0.010D0,  0, 42, 24,  0,  0,  0,
     &  45,0.331D0,  0, 34, 38,  0,  0,  0,
     &  45,0.166D0,  0, 42, 21,  0,  0,  0,
     &  45,0.168D0,  0, 35, 38,  0,  0,  0,
     &  45,0.084D0,  0, 43, 21,  0,  0,  0,
     &  45,0.089D0,  0, 42, 38, 30,  0,  0,
     &  45,0.044D0,  0, 42, 21, 21,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 134, 152)/
     &  45,0.059D0,  0, 34, 39,  0,  0,  0,
     &  45,0.029D0,  0, 42, 23,  0,  0,  0,
     &  45,0.029D0,  0, 42, 24,  0,  0,  0,
     &  45,0.001D0,  0, 42, 22,  0,  0,  0,
     &  46,0.629D0,  0,129,124,  0,  0,  0,
     &  46,0.212D0,  0, 38, 21,  0,  0,  0,
     &  46,0.056D0,  0, 38, 38, 30,  0,  0,
     &  46,0.017D0,  0, 38, 21, 21,  0,  0,
     &  46,0.032D0,101,129,124, 21,  0,  0,
     &  46,0.048D0,101,127,122, 21,  0,  0,
     &  46,0.006D0,  0,129,124, 59,  0,  0,
     &  47,0.666D0,  0, 50, 38,  0,  0,  0,
     &  47,0.333D0,  0, 46, 21,  0,  0,  0,
     &  47,0.001D0,  0, 46, 59,  0,  0,  0,
     &  48,0.627D0,  0, 51, 38,  0,  0,  0,
     &  48,0.313D0,  0, 47, 21,  0,  0,  0,
     &  48,0.020D0,  0, 50, 39,  0,  0,  0,
     &  48,0.010D0,  0, 46, 23,  0,  0,  0,
     &  48,0.020D0,  0, 46,294,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 153, 171)/
     &  48,0.010D0,  0, 46, 24,  0,  0,  0,
     &  49,0.331D0,  0, 50, 38,  0,  0,  0,
     &  49,0.166D0,  0, 46, 21,  0,  0,  0,
     &  49,0.168D0,  0, 51, 38,  0,  0,  0,
     &  49,0.084D0,  0, 47, 21,  0,  0,  0,
     &  49,0.087D0,  0, 47, 38, 30,  0,  0,
     &  49,0.044D0,  0, 47, 21, 21,  0,  0,
     &  49,0.059D0,  0, 50, 39,  0,  0,  0,
     &  49,0.029D0,  0, 46, 23,  0,  0,  0,
     &  49,0.029D0,  0, 46, 24,  0,  0,  0,
     &  49,0.002D0,  0, 46, 59,  0,  0,  0,
     &  49,0.001D0,  0, 46, 22,  0,  0,  0,
     &  50,0.500D0,  0, 60,  0,  0,  0,  0,
     &  50,0.500D0,  0, 61,  0,  0,  0,  0,
     &  51,0.665D0,  0, 46, 30,  0,  0,  0,
     &  51,0.333D0,  0, 50, 21,  0,  0,  0,
     &  51,0.002D0,  0, 50, 59,  0,  0,  0,
     &  52,0.627D0,  0, 47, 30,  0,  0,  0,
     &  52,0.313D0,  0, 51, 21,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 172, 190)/
     &  52,0.020D0,  0, 46, 31,  0,  0,  0,
     &  52,0.010D0,  0, 50, 23,  0,  0,  0,
     &  52,0.020D0,  0, 50,294,  0,  0,  0,
     &  52,0.010D0,  0, 50, 24,  0,  0,  0,
     &  53,0.331D0,  0, 46, 30,  0,  0,  0,
     &  53,0.166D0,  0, 50, 21,  0,  0,  0,
     &  53,0.168D0,  0, 47, 30,  0,  0,  0,
     &  53,0.084D0,  0, 51, 21,  0,  0,  0,
     &  53,0.089D0,  0, 50, 38, 30,  0,  0,
     &  53,0.044D0,  0, 50, 21, 21,  0,  0,
     &  53,0.059D0,  0, 46, 31,  0,  0,  0,
     &  53,0.029D0,  0, 50, 23,  0,  0,  0,
     &  53,0.029D0,  0, 50, 24,  0,  0,  0,
     &  53,0.001D0,  0, 50, 22,  0,  0,  0,
     &  56,0.490D0,  0, 46, 34,  0,  0,  0,
     &  56,0.342D0,  0, 61, 60,  0,  0,  0,
     &  56,0.043D0,  0, 39, 30,  0,  0,  0,
     &  56,0.043D0,  0, 23, 21,  0,  0,  0,
     &  56,0.043D0,  0, 31, 38,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 191, 209)/
     &  56,0.025D0,  0, 38, 30, 21,  0,  0,
     &  56,0.013D0,  0, 22, 59,  0,  0,  0,
     &  56,0.001D0,  0, 21, 59,  0,  0,  0,
     &  57,0.250D0,  0, 50, 43,  0,  0,  0,
     &  57,0.250D0,  0, 34, 47,  0,  0,  0,
     &  57,0.250D0,  0, 42, 51,  0,  0,  0,
     &  57,0.250D0,  0, 46, 35,  0,  0,  0,
     &  58,0.356D0,  0, 46, 34,  0,  0,  0,
     &  58,0.356D0,  0, 50, 42,  0,  0,  0,
     &  58,0.279D0,  0, 22, 22,  0,  0,  0,
     &  58,0.006D0,  0, 38, 30,  0,  0,  0,
     &  58,0.003D0,  0, 21, 21,  0,  0,  0,
     &  60,0.684D0,  0, 38, 30,  0,  0,  0,
     &  60,0.314D0,  0, 21, 21,  0,  0,  0,
     &  60,0.002D0,  0, 38, 30, 59,  0,  0,
     &  61,0.216D0,  0, 21, 21, 21,  0,  0,
     &  61,0.124D0,  0, 38, 30, 21,  0,  0,
     &  61,0.135D0,101,123,130, 38,  0,  0,
     &  61,0.135D0,101,124,129, 30,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 210, 228)/
     &  61,0.187D0,101,121,128, 38,  0,  0,
     &  61,0.187D0,101,122,127, 30,  0,  0,
     &  61,0.006D0,  0,121,128, 38, 59,  0,
     &  61,0.006D0,  0,122,127, 30, 59,  0,
     &  61,0.002D0,  0, 38, 30,  0,  0,  0,
     &  61,0.001D0,  0, 21, 21,  0,  0,  0,
     &  61,0.001D0,  0, 59, 59,  0,  0,  0,
     &  74,0.663D0,  0, 73, 21,  0,  0,  0,
     &  74,0.331D0,  0, 75, 38,  0,  0,  0,
     &  74,0.006D0,  0, 73, 59,  0,  0,  0,
     &  75,1.000D0,101,121,128, 73,  0,  0,
     &  76,0.663D0,  0, 75, 21,  0,  0,  0,
     &  76,0.331D0,  0, 73, 30,  0,  0,  0,
     &  76,0.006D0,  0, 75, 59,  0,  0,  0,
     &  77,1.000D0,  0, 75, 30,  0,  0,  0,
     &  78,0.638D0,  0, 73, 30,  0,  0,  0,
     &  78,0.358D0,  0, 75, 21,  0,  0,  0,
     &  78,0.002D0,  0, 75, 59,  0,  0,  0,
     &  78,0.001D0,  0, 73, 30, 59,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 229, 247)/
     &  78,0.001D0,101,121,128, 73,  0,  0,
     &  79,0.995D0,  0, 78, 59,  0,  0,  0,
     &  79,0.005D0,  0, 78,127,121,  0,  0,
     &  80,0.880D0,  0, 78, 21,  0,  0,  0,
     &  80,0.060D0,  0, 86, 30,  0,  0,  0,
     &  80,0.060D0,  0, 81, 38,  0,  0,  0,
     &  81,0.998D0,  0, 75, 30,  0,  0,  0,
     &  81,0.001D0,  0, 75, 30, 59,  0,  0,
     &  81,0.001D0,101,121,128, 75,  0,  0,
     &  82,0.880D0,  0, 78, 30,  0,  0,  0,
     &  82,0.060D0,  0, 79, 30,  0,  0,  0,
     &  82,0.060D0,  0, 81, 21,  0,  0,  0,
     &  83,0.999D0,  0, 78, 30,  0,  0,  0,
     &  83,0.001D0,101,121,128, 78,  0,  0,
     &  84,0.667D0,  0, 88, 30,  0,  0,  0,
     &  84,0.333D0,  0, 83, 21,  0,  0,  0,
     &  85,1.000D0,  0, 73, 38,  0,  0,  0,
     &  86,0.516D0,  0, 73, 21,  0,  0,  0,
     &  86,0.483D0,  0, 75, 38,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 248, 266)/
     &  86,0.001D0,  0, 73, 59,  0,  0,  0,
     &  87,0.880D0,  0, 78, 38,  0,  0,  0,
     &  87,0.060D0,  0, 86, 21,  0,  0,  0,
     &  87,0.060D0,  0, 79, 38,  0,  0,  0,
     &  88,0.995D0,  0, 78, 21,  0,  0,  0,
     &  88,0.001D0,  0, 78, 59,  0,  0,  0,
     &  88,0.004D0,  0, 79, 59,  0,  0,  0,
     &  89,0.667D0,  0, 83, 38,  0,  0,  0,
     &  89,0.333D0,  0, 88, 21,  0,  0,  0,
     &  90,0.675D0,  0, 78, 34,  0,  0,  0,
     &  90,0.233D0,  0, 88, 30,  0,  0,  0,
     &  90,0.086D0,  0, 83, 21,  0,  0,  0,
     &  90,0.006D0,101,121,128, 88,  0,  0,
     &  92,0.663D0,  0, 91, 21,  0,  0,  0,
     &  92,0.331D0,  0, 93, 30,  0,  0,  0,
     &  92,0.006D0,  0, 91, 59,  0,  0,  0,
     &  93,1.000D0,101,127,122, 91,  0,  0,
     &  94,0.663D0,  0, 93, 21,  0,  0,  0,
     &  94,0.331D0,  0, 91, 38,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 267, 285)/
     &  94,0.006D0,  0, 93, 59,  0,  0,  0,
     &  95,1.000D0,  0, 93, 38,  0,  0,  0,
     &  96,0.638D0,  0, 91, 38,  0,  0,  0,
     &  96,0.358D0,  0, 93, 21,  0,  0,  0,
     &  96,0.002D0,  0, 93, 59,  0,  0,  0,
     &  96,0.001D0,  0, 91, 38, 59,  0,  0,
     &  96,0.001D0,101,127,122, 91,  0,  0,
     &  97,0.995D0,  0, 96, 59,  0,  0,  0,
     &  97,0.005D0,  0, 96,127,121,  0,  0,
     &  98,0.880D0,  0, 96, 21,  0,  0,  0,
     &  98,0.060D0,  0,104, 38,  0,  0,  0,
     &  98,0.060D0,  0, 99, 30,  0,  0,  0,
     &  99,0.998D0,  0, 93, 38,  0,  0,  0,
     &  99,0.001D0,  0, 93, 38, 59,  0,  0,
     &  99,0.001D0,101,127,122, 93,  0,  0,
     & 100,0.880D0,  0, 96, 38,  0,  0,  0,
     & 100,0.060D0,  0, 97, 38,  0,  0,  0,
     & 100,0.060D0,  0, 99, 21,  0,  0,  0,
     & 101,0.999D0,  0, 96, 38,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 286, 304)/
     & 101,0.001D0,101,127,122, 96,  0,  0,
     & 102,0.667D0,  0,106, 38,  0,  0,  0,
     & 102,0.333D0,  0,101, 21,  0,  0,  0,
     & 103,1.000D0,  0, 91, 30,  0,  0,  0,
     & 104,0.516D0,  0, 91, 21,  0,  0,  0,
     & 104,0.483D0,  0, 93, 30,  0,  0,  0,
     & 104,0.001D0,  0, 91, 59,  0,  0,  0,
     & 105,0.880D0,  0, 96, 30,  0,  0,  0,
     & 105,0.060D0,  0,104, 21,  0,  0,  0,
     & 105,0.060D0,  0, 97, 30,  0,  0,  0,
     & 106,0.995D0,  0, 96, 21,  0,  0,  0,
     & 106,0.001D0,  0, 96, 59,  0,  0,  0,
     & 106,0.004D0,  0, 97, 59,  0,  0,  0,
     & 107,0.667D0,  0,101, 30,  0,  0,  0,
     & 107,0.333D0,  0,106, 21,  0,  0,  0,
     & 108,0.675D0,  0, 96, 46,  0,  0,  0,
     & 108,0.233D0,  0,106, 38,  0,  0,  0,
     & 108,0.086D0,  0,101, 21,  0,  0,  0,
     & 108,0.006D0,101,127,122,106,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 305, 323)/
     & 123,0.986D0,100,121,128,124,  0,  0,
     & 123,0.014D0,  0,121,128,124, 59,  0,
     & 125,0.178D0,100,121,128,126,  0,  0,
     & 125,0.171D0,100,123,130,126,  0,  0,
     & 125,0.002D0,  0,123,130, 59,126,  0,
     & 125,0.111D0,  0, 30,126,  0,  0,  0,
     & 125,0.253D0,  0, 31,126,  0,  0,  0,
     & 125,0.181D0,  0, 32,126,  0,  0,  0,
     & 125,0.002D0,  0, 30, 22, 21,126,  0,
     & 125,0.018D0,  0, 30, 24,126,  0,  0,
     & 125,0.004D0,  0, 30, 24, 21,126,  0,
     & 125,0.015D0,  0, 31, 23,126,  0,  0,
     & 125,0.001D0,  0, 31, 24, 21,126,  0,
     & 125,0.024D0,  0, 32, 21,126,  0,  0,
     & 125,0.002D0,  0, 32, 38, 30,126,  0,
     & 125,0.007D0,  0, 34,126,  0,  0,  0,
     & 125,0.014D0,  0, 35,126,  0,  0,  0,
     & 125,0.003D0,  0, 35, 21,126,  0,  0,
     & 125,0.001D0,  0, 34, 38, 30,126,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 324, 342)/
     & 125,0.004D0,  0, 30, 43,126,  0,  0,
     & 125,0.003D0,  0, 34, 50,126,  0,  0,
     & 125,0.003D0,  0, 34, 51,126,  0,  0,
     & 125,0.003D0,  0, 30, 50, 42,126,  0,
     & 129,0.986D0,100,127,122,130,  0,  0,
     & 129,0.014D0,  0,127,122,130, 59,  0,
     & 131,0.178D0,100,127,122,132,  0,  0,
     & 131,0.171D0,100,129,124,132,  0,  0,
     & 131,0.002D0,  0,129,124, 59,132,  0,
     & 131,0.111D0,  0, 38,132,  0,  0,  0,
     & 131,0.253D0,  0, 39,132,  0,  0,  0,
     & 131,0.181D0,  0, 40,132,  0,  0,  0,
     & 131,0.002D0,  0, 38, 22, 21,132,  0,
     & 131,0.018D0,  0, 38, 24,132,  0,  0,
     & 131,0.004D0,  0, 38, 24, 21,132,  0,
     & 131,0.015D0,  0, 39, 23,132,  0,  0,
     & 131,0.001D0,  0, 39, 24, 21,132,  0,
     & 131,0.024D0,  0, 40, 21,132,  0,  0,
     & 131,0.002D0,  0, 40, 38, 30,132,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 343, 361)/
     & 131,0.007D0,  0, 46,132,  0,  0,  0,
     & 131,0.014D0,  0, 47,132,  0,  0,  0,
     & 131,0.003D0,  0, 47, 21,132,  0,  0,
     & 131,0.001D0,  0, 46, 38, 30,132,  0,
     & 131,0.004D0,  0, 38, 51,132,  0,  0,
     & 131,0.003D0,  0, 46, 42,132,  0,  0,
     & 131,0.003D0,  0, 46, 43,132,  0,  0,
     & 131,0.003D0,  0, 38, 50, 42,132,  0,
     & 136,0.067D0,101,122,127, 42,  0,  0,
     & 136,0.067D0,101,124,129, 42,  0,  0,
     & 136,0.048D0,101,122,127, 43,  0,  0,
     & 136,0.048D0,101,124,129, 43,  0,  0,
     & 136,0.003D0,  0, 34, 38,122,127,  0,
     & 136,0.003D0,  0, 34, 38,124,129,  0,
     & 136,0.006D0,101,122,127, 21,  0,  0,
     & 136,0.006D0,101,124,129, 21,  0,  0,
     & 136,0.002D0,101,122,127, 23,  0,  0,
     & 136,0.002D0,101,124,129, 23,  0,  0,
     & 136,0.055D0,  0, 34, 38, 38,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 362, 380)/
     & 136,0.031D0,  0, 34, 39, 38,  0,  0,
     & 136,0.042D0,  0, 34, 38, 38, 21, 21,
     & 136,0.002D0,  0, 34, 38, 38, 38, 31,
     & 136,0.021D0,  0, 35, 38, 38,  0,  0,
     & 136,0.027D0,  0, 42, 38,  0,  0,  0,
     & 136,0.066D0,  0, 42, 39,  0,  0,  0,
     & 136,0.081D0,  0, 42, 40,  0,  0,  0,
     & 136,0.024D0,  0, 42, 38, 21,  0,  0,
     & 136,0.004D0,  0, 42, 38, 23,  0,  0,
     & 136,0.069D0,  0, 42, 38, 38, 30, 21,
     & 136,0.001D0,  0, 42, 38, 38, 30, 23,
     & 136,0.022D0,  0, 43, 38,  0,  0,  0,
     & 136,0.021D0,  0, 43, 39,  0,  0,  0,
     & 136,0.042D0,  0, 43, 38, 21,  0,  0,
     & 136,0.008D0,  0, 43, 38, 23,  0,  0,
     & 136,0.010D0,  0, 43, 38, 38, 30,  0,
     & 136,0.050D0,  0,311, 38,  0,  0,  0,
     & 136,0.034D0,  0,329, 38,  0,  0,  0,
     & 136,0.010D0,  0,369, 38,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 381, 399)/
     & 136,0.031D0,  0, 46, 42, 42,  0,  0,
     & 136,0.003D0,  0, 38, 21,  0,  0,  0,
     & 136,0.001D0,  0, 38, 23,  0,  0,  0,
     & 136,0.002D0,  0, 38, 38, 30,  0,  0,
     & 136,0.008D0,  0, 38, 22,  0,  0,  0,
     & 136,0.001D0,  0, 38, 38, 38, 30, 30,
     & 136,0.003D0,  0, 38, 38, 38, 30, 31,
     & 136,0.008D0,  0, 46, 42,  0,  0,  0,
     & 136,0.005D0,  0, 46, 43,  0,  0,  0,
     & 136,0.026D0,  0, 47, 43,  0,  0,  0,
     & 136,0.005D0,  0, 46, 34, 38,  0,  0,
     & 136,0.007D0,  0, 38, 56,  0,  0,  0,
     & 136,0.023D0,  0, 38, 56, 21,  0,  0,
     & 136,0.005D0,  0, 46, 46, 34,  0,  0,
     & 137,0.683D0,  0,140, 38,  0,  0,  0,
     & 137,0.306D0,  0,136, 21,  0,  0,  0,
     & 137,0.011D0,  0,136, 59,  0,  0,  0,
     & 138,0.667D0,  0,141, 38,  0,  0,  0,
     & 138,0.333D0,  0,137, 21,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 400, 418)/
     & 139,0.220D0,  0,140, 38,  0,  0,  0,
     & 139,0.110D0,  0,136, 21,  0,  0,  0,
     & 139,0.380D0,  0,141, 38,  0,  0,  0,
     & 139,0.190D0,  0,137, 21,  0,  0,  0,
     & 139,0.004D0,  0,136, 22,  0,  0,  0,
     & 139,0.064D0,  0,141, 38, 21,  0,  0,
     & 139,0.032D0,  0,137, 38, 30,  0,  0,
     & 140,0.037D0,101,122,127, 34,  0,  0,
     & 140,0.037D0,101,124,129, 34,  0,  0,
     & 140,0.016D0,101,122,127, 35,  0,  0,
     & 140,0.016D0,101,124,129, 35,  0,  0,
     & 140,0.013D0,  0, 34, 21,122,127,  0,
     & 140,0.013D0,  0, 34, 21,124,129,  0,
     & 140,0.012D0,  0, 42, 30,122,127,  0,
     & 140,0.012D0,  0, 42, 30,124,129,  0,
     & 140,0.003D0,101,122,127, 30,  0,  0,
     & 140,0.003D0,101,124,129, 30,  0,  0,
     & 140,0.039D0,  0, 34, 38,  0,  0,  0,
     & 140,0.091D0,  0, 34, 39,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 419, 437)/
     & 140,0.067D0,  0, 34, 40,  0,  0,  0,
     & 140,0.004D0,  0, 34, 38, 21,  0,  0,
     & 140,0.100D0,  0, 34, 38, 21, 21,  0,
     & 140,0.058D0,  0, 34, 38, 23,  0,  0,
     & 140,0.020D0,  0, 34, 38, 24,  0,  0,
     & 140,0.006D0,  0, 34, 38, 25,  0,  0,
     & 140,0.043D0,  0, 35, 38,  0,  0,  0,
     & 140,0.035D0,  0, 35, 39,  0,  0,  0,
     & 140,0.007D0,  0,312, 38,  0,  0,  0,
     & 140,0.007D0,  0,330, 38,  0,  0,  0,
     & 140,0.020D0,  0, 42, 21,  0,  0,  0,
     & 140,0.006D0,  0, 42, 22,  0,  0,  0,
     & 140,0.009D0,  0, 42, 23,  0,  0,  0,
     & 140,0.016D0,  0, 42, 24,  0,  0,  0,
     & 140,0.014D0,  0, 42, 25,  0,  0,  0,
     & 140,0.003D0,  0, 42,293,  0,  0,  0,
     & 140,0.007D0,  0, 42, 56,  0,  0,  0,
     & 140,0.003D0,  0, 42, 26,  0,  0,  0,
     & 140,0.004D0,  0, 42,294,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 438, 456)/
     & 140,0.006D0,  0, 42, 21, 21,  0,  0,
     & 140,0.042D0,  0, 42, 38, 30, 21,  0,
     & 140,0.004D0,  0, 42, 38, 38, 30, 30,
     & 140,0.076D0,  0, 42, 38, 30, 21, 21,
     & 140,0.026D0,  0, 43, 21,  0,  0,  0,
     & 140,0.014D0,  0, 43, 22,  0,  0,  0,
     & 140,0.014D0,  0, 43, 23,  0,  0,  0,
     & 140,0.011D0,  0, 43, 24,  0,  0,  0,
     & 140,0.018D0,  0, 43, 38, 30,  0,  0,
     & 140,0.004D0,  0, 42, 46, 34,  0,  0,
     & 140,0.004D0,  0, 42, 46, 34, 21,  0,
     & 140,0.005D0,  0, 42, 42, 50,  0,  0,
     & 140,0.002D0,  0, 38, 30,  0,  0,  0,
     & 140,0.001D0,  0, 21, 21,  0,  0,  0,
     & 140,0.008D0,  0, 38, 30, 21,  0,  0,
     & 140,0.007D0,  0, 38, 38, 30, 30,  0,
     & 140,0.015D0,  0, 38, 38, 30, 30, 21,
     & 140,0.004D0,  0, 46, 34,  0,  0,  0,
     & 140,0.003D0,  0, 47, 34,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 457, 475)/
     & 140,0.002D0,  0, 46, 35,  0,  0,  0,
     & 140,0.001D0,  0, 50, 42,  0,  0,  0,
     & 140,0.002D0,  0, 51, 43,  0,  0,  0,
     & 140,0.003D0,  0, 50, 34, 38,  0,  0,
     & 140,0.003D0,  0, 42, 46, 30,  0,  0,
     & 140,0.001D0,  0, 46, 34, 38, 30, 21,
     & 140,0.002D0,  0, 56, 23,  0,  0,  0,
     & 140,0.001D0,  0, 56, 38, 30,  0,  0,
     & 141,0.636D0,  0,140, 21,  0,  0,  0,
     & 141,0.364D0,  0,140, 59,  0,  0,  0,
     & 142,0.667D0,  0,137, 30,  0,  0,  0,
     & 142,0.333D0,  0,141, 21,  0,  0,  0,
     & 143,0.220D0,  0,136, 30,  0,  0,  0,
     & 143,0.110D0,  0,140, 21,  0,  0,  0,
     & 143,0.380D0,  0,137, 30,  0,  0,  0,
     & 143,0.190D0,  0,141, 21,  0,  0,  0,
     & 143,0.004D0,  0,140, 22,  0,  0,  0,
     & 143,0.064D0,  0,137, 30, 21,  0,  0,
     & 143,0.032D0,  0,141, 38, 30,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 476, 494)/
     & 144,0.009D0,  0,124,129,  0,  0,  0,
     & 144,0.019D0,101,122,127, 56,  0,  0,
     & 144,0.019D0,101,124,129, 56,  0,  0,
     & 144,0.025D0,101,122,127, 22,  0,  0,
     & 144,0.025D0,101,124,129, 22,  0,  0,
     & 144,0.009D0,101,122,127, 25,  0,  0,
     & 144,0.009D0,101,124,129, 25,  0,  0,
     & 144,0.036D0,  0, 46, 42,  0,  0,  0,
     & 144,0.034D0,  0, 46, 43,  0,  0,  0,
     & 144,0.007D0,  0, 46,329,  0,  0,  0,
     & 144,0.043D0,  0, 47, 42,  0,  0,  0,
     & 144,0.058D0,  0, 47, 43,  0,  0,  0,
     & 144,0.011D0,  0, 46, 34, 38,  0,  0,
     & 144,0.055D0,  0, 46, 34, 38, 21,  0,
     & 144,0.003D0,  0, 46, 34, 38, 38, 30,
     & 144,0.014D0,  0, 46, 42, 38, 30,  0,
     & 144,0.017D0,  0, 50, 34, 38, 38,  0,
     & 144,0.036D0,  0, 56, 38,  0,  0,  0,
     & 144,0.067D0,  0, 56, 39,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 495, 513)/
     & 144,0.023D0,  0, 56, 38, 21,  0,  0,
     & 144,0.018D0,  0, 56, 38, 38, 30,  0,
     & 144,0.020D0,  0, 22, 38,  0,  0,  0,
     & 144,0.001D0,  0, 23, 38,  0,  0,  0,
     & 144,0.009D0,  0, 24, 38,  0,  0,  0,
     & 144,0.049D0,  0, 25, 38,  0,  0,  0,
     & 144,0.011D0,  0,293, 38,  0,  0,  0,
     & 144,0.015D0,  0, 22, 38, 21,  0,  0,
     & 144,0.016D0,  0, 25, 38, 21,  0,  0,
     & 144,0.103D0,  0, 22, 39,  0,  0,  0,
     & 144,0.120D0,  0, 25, 39,  0,  0,  0,
     & 144,0.010D0,  0, 38, 38, 30,  0,  0,
     & 144,0.046D0,  0, 38, 38, 30, 21,  0,
     & 144,0.003D0,  0, 38, 38, 38, 30, 30,
     & 144,0.042D0,  0, 38, 30, 30, 38, 39,
     & 144,0.001D0,  0, 46, 23,  0,  0,  0,
     & 144,0.005D0,  0, 46, 38, 30,  0,  0,
     & 144,0.001D0,  0, 46, 56,  0,  0,  0,
     & 144,0.004D0,  0, 50, 38,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 514, 532)/
     & 144,0.007D0,  0, 51, 38,  0,  0,  0,
     & 145,0.900D0,  0,144, 59,  0,  0,  0,
     & 145,0.100D0,  0,144, 21,  0,  0,  0,
     & 146,0.500D0,  0,137, 50,  0,  0,  0,
     & 146,0.500D0,  0,141, 46,  0,  0,  0,
     & 147,0.440D0,  0,136, 50,  0,  0,  0,
     & 147,0.440D0,  0,140, 46,  0,  0,  0,
     & 147,0.055D0,  0,137, 50,  0,  0,  0,
     & 147,0.055D0,  0,141, 46,  0,  0,  0,
     & 147,0.010D0,  0,144, 22,  0,  0,  0,
     & 148,1.000D0,  0,150, 38,  0,  0,  0,
     & 149,1.000D0,  0,150, 38,  0,  0,  0,
     & 150,0.028D0,101,122,127, 78,  0,  0,
     & 150,0.010D0,101,122,127, 80,  0,  0,
     & 150,0.028D0,101,124,129, 78,  0,  0,
     & 150,0.010D0,101,124,129, 80,  0,  0,
     & 150,0.026D0,  0, 73, 42,  0,  0,  0,
     & 150,0.030D0,  0, 73, 42, 21,  0,  0,
     & 150,0.029D0,  0, 73, 42, 38, 30,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 533, 551)/
     & 150,0.014D0,  0, 73, 42, 22,  0,  0,
     & 150,0.020D0,  0, 73, 43,  0,  0,  0,
     & 150,0.029D0,  0, 73, 34, 38,  0,  0,
     & 150,0.039D0,  0, 73, 34, 38, 21,  0,
     & 150,0.002D0,  0, 73, 34, 38, 38, 30,
     & 150,0.010D0,  0, 73, 34, 38, 21, 21,
     & 150,0.014D0,  0, 73, 35, 38,  0,  0,
     & 150,0.010D0,  0, 74, 42,  0,  0,  0,
     & 150,0.020D0,  0, 74, 43,  0,  0,  0,
     & 150,0.010D0,  0, 74, 43, 21,  0,  0,
     & 150,0.007D0,  0, 85, 34,  0,  0,  0,
     & 150,0.014D0,  0, 85, 35,  0,  0,  0,
     & 150,0.004D0,  0, 73,293,  0,  0,  0,
     & 150,0.003D0,  0, 73, 38, 30,  0,  0,
     & 150,0.003D0,  0, 73, 38, 30, 38, 30,
     & 150,0.001D0,  0, 73, 56,  0,  0,  0,
     & 150,0.002D0,  0, 73, 46, 34,  0,  0,
     & 150,0.010D0,  0, 78, 38,  0,  0,  0,
     & 150,0.020D0,  0, 78, 39,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 552, 570)/
     & 150,0.030D0,  0, 78, 38, 21,  0,  0,
     & 150,0.010D0,  0, 78, 38, 22,  0,  0,
     & 150,0.020D0,  0, 78, 38, 24,  0,  0,
     & 150,0.035D0,  0, 78, 38, 38, 30,  0,
     & 150,0.020D0,  0, 78, 38, 21, 21,  0,
     & 150,0.010D0,  0, 78, 38, 38, 30, 21,
     & 150,0.010D0,  0, 78, 38, 21, 21, 21,
     & 150,0.007D0,  0, 78, 46, 42,  0,  0,
     & 150,0.011D0,  0, 79, 38,  0,  0,  0,
     & 150,0.022D0,  0, 79, 38, 21,  0,  0,
     & 150,0.013D0,  0, 79, 38, 38, 30,  0,
     & 150,0.010D0,  0, 79, 38, 21, 21,  0,
     & 150,0.007D0,  0, 79, 38, 38, 30, 21,
     & 150,0.005D0,  0, 79, 38, 21, 21, 21,
     & 150,0.005D0,  0, 80, 38,  0,  0,  0,
     & 150,0.015D0,  0, 80, 39,  0,  0,  0,
     & 150,0.011D0,  0, 86, 21,  0,  0,  0,
     & 150,0.007D0,  0, 86, 22,  0,  0,  0,
     & 150,0.010D0,  0, 86, 23,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 571, 589)/
     & 150,0.031D0,  0, 86, 24,  0,  0,  0,
     & 150,0.010D0,  0, 86, 25,  0,  0,  0,
     & 150,0.004D0,  0, 86, 56,  0,  0,  0,
     & 150,0.026D0,  0, 86, 38, 30,  0,  0,
     & 150,0.005D0,  0, 86, 38, 38, 30, 30,
     & 150,0.005D0,  0, 86, 38, 30, 21, 21,
     & 150,0.005D0,  0, 87, 21,  0,  0,  0,
     & 150,0.006D0,  0, 87, 23,  0,  0,  0,
     & 150,0.004D0,  0, 86, 46, 34,  0,  0,
     & 150,0.002D0,  0, 86, 46, 30,  0,  0,
     & 150,0.001D0,  0, 86, 46, 30, 21,  0,
     & 150,0.016D0,  0, 81, 38, 38,  0,  0,
     & 150,0.003D0,  0, 88, 46,  0,  0,  0,
     & 150,0.002D0,  0, 89, 46,  0,  0,  0,
     & 150,0.003D0,  0, 83, 46, 38,  0,  0,
     & 150,0.040D0,  0, 75, 46, 21,  0,  0,
     & 150,0.040D0,  0, 75, 46, 38, 30,  0,
     & 150,0.020D0,  0, 75, 46, 21, 21,  0,
     & 150,0.010D0,  0, 75, 46, 38, 30, 21/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 590, 608)/
     & 150,0.010D0,  0, 75, 46, 21, 21, 21,
     & 150,0.020D0,  0, 75, 47, 21,  0,  0,
     & 150,0.040D0,  0, 75, 42, 38,  0,  0,
     & 150,0.020D0,  0, 75, 42, 39,  0,  0,
     & 150,0.010D0,  0, 75, 42, 38, 38, 30,
     & 150,0.010D0,  0, 75, 42, 38, 21, 21,
     & 150,0.006D0,  0, 75, 43, 38,  0,  0,
     & 151,1.000D0,  0,150, 21,  0,  0,  0,
     & 152,1.000D0,  0,150, 21,  0,  0,  0,
     & 153,1.000D0,  0,150, 30,  0,  0,  0,
     & 154,1.000D0,  0,150, 30,  0,  0,  0,
     & 155,0.045D0,101,122,127, 88,  0,  0,
     & 155,0.005D0,101,122,127, 89,  0,  0,
     & 155,0.045D0,101,124,129, 88,  0,  0,
     & 155,0.005D0,101,124,129, 89,  0,  0,
     & 155,0.021D0,  0, 86, 42,  0,  0,  0,
     & 155,0.032D0,  0, 87, 42,  0,  0,  0,
     & 155,0.032D0,  0, 79, 38, 42,  0,  0,
     & 155,0.045D0,  0, 86, 43,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 609, 627)/
     & 155,0.065D0,  0, 87, 43,  0,  0,  0,
     & 155,0.065D0,  0, 79, 38, 43,  0,  0,
     & 155,0.055D0,  0, 88, 38,  0,  0,  0,
     & 155,0.160D0,  0, 88, 39,  0,  0,  0,
     & 155,0.105D0,  0, 89, 38,  0,  0,  0,
     & 155,0.320D0,  0, 89, 39,  0,  0,  0,
     & 156,1.000D0,  0,155, 59,  0,  0,  0,
     & 157,0.667D0,  0,158, 38,  0,  0,  0,
     & 157,0.333D0,  0,155, 21,  0,  0,  0,
     & 158,0.045D0,101,122,127, 83,  0,  0,
     & 158,0.045D0,101,124,129, 83,  0,  0,
     & 158,0.005D0,101,122,127, 84,  0,  0,
     & 158,0.005D0,101,124,129, 84,  0,  0,
     & 158,0.020D0,  0, 79, 42,  0,  0,  0,
     & 158,0.020D0,  0, 79, 21, 42,  0,  0,
     & 158,0.020D0,  0, 80, 42,  0,  0,  0,
     & 158,0.060D0,  0, 79, 43,  0,  0,  0,
     & 158,0.060D0,  0, 79, 21, 43,  0,  0,
     & 158,0.060D0,  0, 80, 43,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 628, 646)/
     & 158,0.020D0,  0, 86, 34,  0,  0,  0,
     & 158,0.060D0,  0, 86, 35,  0,  0,  0,
     & 158,0.040D0,  0, 87, 34,  0,  0,  0,
     & 158,0.120D0,  0, 87, 35,  0,  0,  0,
     & 158,0.020D0,  0, 83, 38,  0,  0,  0,
     & 158,0.060D0,  0, 83, 39,  0,  0,  0,
     & 158,0.040D0,  0, 84, 38,  0,  0,  0,
     & 158,0.120D0,  0, 84, 39,  0,  0,  0,
     & 158,0.010D0,  0, 88, 21,  0,  0,  0,
     & 158,0.030D0,  0, 88, 23,  0,  0,  0,
     & 158,0.020D0,  0, 89, 21,  0,  0,  0,
     & 158,0.060D0,  0, 89, 23,  0,  0,  0,
     & 158,0.030D0,  0, 88, 56,  0,  0,  0,
     & 158,0.030D0,  0, 90, 46,  0,  0,  0,
     & 159,1.000D0,  0,158, 59,  0,  0,  0,
     & 160,0.670D0,  0,155, 30,  0,  0,  0,
     & 160,0.330D0,  0,158, 21,  0,  0,  0,
     & 161,0.050D0,101,122,127, 90,  0,  0,
     & 161,0.050D0,101,124,129, 90,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 647, 665)/
     & 161,0.075D0,  0, 88, 42,  0,  0,  0,
     & 161,0.225D0,  0, 88, 43,  0,  0,  0,
     & 161,0.150D0,  0, 89, 42,  0,  0,  0,
     & 161,0.450D0,  0, 89, 43,  0,  0,  0,
     & 162,1.000D0,  0,161, 59,  0,  0,  0,
     & 163,0.028D0,  0, 25, 38, 30,  0,  0,
     & 163,0.014D0,  0, 25, 21, 21,  0,  0,
     & 163,0.018D0,  0, 39, 31,  0,  0,  0,
     & 163,0.009D0,  0, 23, 23,  0,  0,  0,
     & 163,0.010D0,  0, 51, 34, 38,  0,  0,
     & 163,0.010D0,  0, 43, 47, 30,  0,  0,
     & 163,0.004D0,  0, 51, 43,  0,  0,  0,
     & 163,0.004D0,  0, 47, 35,  0,  0,  0,
     & 163,0.007D0,  0, 56, 56,  0,  0,  0,
     & 163,0.022D0,  0, 46, 42, 30,  0,  0,
     & 163,0.011D0,  0, 46, 34, 21,  0,  0,
     & 163,0.011D0,  0, 50, 42, 21,  0,  0,
     & 163,0.022D0,  0, 50, 34, 38,  0,  0,
     & 163,0.032D0,  0, 22, 38, 30,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 666, 684)/
     & 163,0.016D0,  0, 22, 21, 21,  0,  0,
     & 163,0.020D0,  0, 38, 30, 46, 34,  0,
     & 163,0.012D0,  0, 38, 30, 38, 30,  0,
     & 163,0.001D0,  0, 73, 91,  0,  0,  0,
     & 163,0.001D0,  0, 59, 59,  0,  0,  0,
     & 163,0.748D0,  0, 13, 13,  0,  0,  0,
     & 164,0.060D0,  0,121,127,  0,  0,  0,
     & 164,0.060D0,  0,123,129,  0,  0,  0,
     & 164,0.004D0,  0, 39, 30,  0,  0,  0,
     & 164,0.004D0,  0, 23, 21,  0,  0,  0,
     & 164,0.004D0,  0, 31, 38,  0,  0,  0,
     & 164,0.003D0,  0, 41, 31,  0,  0,  0,
     & 164,0.003D0,  0, 29, 23,  0,  0,  0,
     & 164,0.003D0,  0, 33, 39,  0,  0,  0,
     & 164,0.009D0,  0, 24, 38, 38, 30, 30,
     & 164,0.007D0,  0, 24, 38, 30,  0,  0,
     & 164,0.003D0,  0, 51, 45,  0,  0,  0,
     & 164,0.003D0,  0, 43, 53,  0,  0,  0,
     & 164,0.003D0,  0, 24, 51, 42,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 685, 703)/
     & 164,0.003D0,  0, 24, 43, 50,  0,  0,
     & 164,0.004D0,  0, 24, 26,  0,  0,  0,
     & 164,0.003D0,  0, 46, 35,  0,  0,  0,
     & 164,0.003D0,  0, 34, 47,  0,  0,  0,
     & 164,0.002D0,  0, 50, 43,  0,  0,  0,
     & 164,0.002D0,  0, 42, 51,  0,  0,  0,
     & 164,0.003D0,  0, 24, 21, 21,  0,  0,
     & 164,0.002D0,  0,286, 30,  0,  0,  0,
     & 164,0.002D0,  0,287, 38,  0,  0,  0,
     & 164,0.003D0,  0, 24, 46, 42, 30,  0,
     & 164,0.003D0,  0, 24, 34, 50, 38,  0,
     & 164,0.002D0,  0,285, 21,  0,  0,  0,
     & 164,0.001D0,  0, 56, 51, 42,  0,  0,
     & 164,0.001D0,  0, 56, 43, 50,  0,  0,
     & 164,0.001D0,  0, 24, 50, 42,  0,  0,
     & 164,0.001D0,  0, 24, 46, 34,  0,  0,
     & 164,0.002D0,  0, 56, 38, 30, 38, 30,
     & 164,0.002D0,  0, 85, 91, 30,  0,  0,
     & 164,0.002D0,  0,103, 73, 38,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 704, 722)/
     & 164,0.002D0,  0, 24, 22,  0,  0,  0,
     & 164,0.001D0,  0, 56, 50, 42,  0,  0,
     & 164,0.001D0,  0, 56, 46, 34,  0,  0,
     & 164,0.001D0,  0, 73, 91, 24,  0,  0,
     & 164,0.001D0,  0, 85,103,  0,  0,  0,
     & 164,0.001D0,  0, 82,100,  0,  0,  0,
     & 164,0.001D0,  0, 87,105,  0,  0,  0,
     & 164,0.001D0,  0, 73, 91, 25,  0,  0,
     & 164,0.001D0,  0, 56, 58,  0,  0,  0,
     & 164,0.001D0,  0, 56, 38, 30,  0,  0,
     & 164,0.001D0,  0, 56, 46, 42, 30,  0,
     & 164,0.001D0,  0, 56, 34, 50, 38,  0,
     & 164,0.001D0,  0, 56, 22,  0,  0,  0,
     & 164,0.001D0,  0, 84,102,  0,  0,  0,
     & 164,0.001D0,  0, 73, 34, 98,  0,  0,
     & 164,0.001D0,  0, 91, 46, 80,  0,  0,
     & 164,0.034D0,  0, 38, 38, 30, 30, 21,
     & 164,0.029D0,  0, 23, 23, 23, 21,  0,
     & 164,0.015D0,  0, 38, 30, 21,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 723, 741)/
     & 164,0.012D0,  0, 38, 30, 21, 34, 46,
     & 164,0.009D0,  0, 23, 23, 23, 24,  0,
     & 164,0.007D0,  0, 38, 30, 34, 46,  0,
     & 164,0.002D0,  0, 46, 42, 30,  0,  0,
     & 164,0.001D0,  0, 46, 34, 21,  0,  0,
     & 164,0.001D0,  0, 50, 42, 21,  0,  0,
     & 164,0.002D0,  0, 50, 34, 38,  0,  0,
     & 164,0.006D0,  0, 73, 91, 38, 30,  0,
     & 164,0.004D0,  0, 38, 30, 38, 30,  0,
     & 164,0.004D0,  0, 38, 30, 38, 30, 23,
     & 164,0.004D0,  0, 75, 93, 38, 30,  0,
     & 164,0.001D0,  0, 86,104,  0,  0,  0,
     & 164,0.001D0,  0, 79, 97,  0,  0,  0,
     & 164,0.001D0,  0, 81, 99,  0,  0,  0,
     & 164,0.003D0,  0, 23, 23, 34, 46,  0,
     & 164,0.002D0,  0, 73, 91, 38, 30, 21,
     & 164,0.002D0,  0, 73, 91,  0,  0,  0,
     & 164,0.002D0,  0, 73, 91, 22,  0,  0,
     & 164,0.002D0,  0, 73, 93, 30,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 742, 760)/
     & 164,0.002D0,  0, 75, 93,  0,  0,  0,
     & 164,0.001D0,  0, 83,102,  0,  0,  0,
     & 164,0.001D0,  0, 88,106,  0,  0,  0,
     & 164,0.001D0,  0, 78, 96,  0,  0,  0,
     & 164,0.001D0,  0, 73, 91, 21,  0,  0,
     & 164,0.001D0,  0, 78,104, 38,  0,  0,
     & 164,0.001D0,  0, 96, 86, 30,  0,  0,
     & 164,0.001D0,  0, 73, 34, 96,  0,  0,
     & 164,0.001D0,  0, 91, 46, 78,  0,  0,
     & 164,0.001D0,  0, 46, 34, 46, 34,  0,
     & 164,0.013D0,  0, 59,163,  0,  0,  0,
     & 164,0.008D0,  0, 59, 38, 30, 21, 21,
     & 164,0.004D0,  0, 59, 22, 38, 30,  0,
     & 164,0.002D0,  0, 59, 22, 21, 21,  0,
     & 164,0.003D0,  0, 59, 39, 31,  0,  0,
     & 164,0.002D0,  0, 59, 23, 23,  0,  0,
     & 164,0.004D0,  0, 59, 25,  0,  0,  0,
     & 164,0.003D0,  0, 59, 38, 30, 38, 30,
     & 164,0.002D0,  0, 59, 24, 24,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 761, 779)/
     & 164,0.001D0,  0, 59, 26,  0,  0,  0,
     & 164,0.001D0,  0, 59, 22,  0,  0,  0,
     & 164,0.001D0,  0, 59, 28,  0,  0,  0,
     & 164,0.001D0,  0, 59, 58,  0,  0,  0,
     & 164,0.020D0,  0,  1,  7,  0,  0,  0,
     & 164,0.080D0,  0,  2,  8,  0,  0,  0,
     & 164,0.020D0,  0,  3,  9,  0,  0,  0,
     & 164,0.364D0,130, 13, 13, 13,  0,  0,
     & 164,0.091D0,130, 13, 13, 59,  0,  0,
     & 165,0.037D0,  0, 38, 30, 38, 30,  0,
     & 165,0.030D0,  0, 38, 30, 46, 34,  0,
     & 165,0.016D0,  0, 23, 38, 30,  0,  0,
     & 165,0.015D0,  0, 23, 38, 30, 38, 30,
     & 165,0.004D0,  0, 46, 43, 30,  0,  0,
     & 165,0.002D0,  0, 46, 35, 21,  0,  0,
     & 165,0.002D0,  0, 51, 43, 21,  0,  0,
     & 165,0.004D0,  0, 51, 35, 38,  0,  0,
     & 165,0.008D0,  0, 38, 30,  0,  0,  0,
     & 165,0.007D0,  0, 46, 34,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 780, 798)/
     & 165,0.005D0,  0, 38, 30, 73, 91,  0,
     & 165,0.003D0,  0, 21, 21,  0,  0,  0,
     & 165,0.003D0,  0, 22, 22,  0,  0,  0,
     & 165,0.007D0,  0, 59,164,  0,  0,  0,
     & 165,0.857D0,  0, 13, 13,  0,  0,  0,
     & 166,0.008D0,  0,121,127,  0,  0,  0,
     & 166,0.008D0,  0,123,129,  0,  0,  0,
     & 166,0.001D0,  0,125,131,  0,  0,  0,
     & 166,0.338D0,  0,164, 38, 30,  0,  0,
     & 166,0.169D0,  0,164, 21, 21,  0,  0,
     & 166,0.027D0,  0,164, 22,  0,  0,  0,
     & 166,0.001D0,  0,164, 21,  0,  0,  0,
     & 166,0.004D0,  0, 23, 23, 23, 21,  0,
     & 166,0.003D0,  0, 23, 23, 21,  0,  0,
     & 166,0.002D0,  0, 38, 30, 46, 34,  0,
     & 166,0.001D0,  0, 38, 30, 73, 91,  0,
     & 166,0.093D0,  0, 59,165,  0,  0,  0,
     & 166,0.087D0,  0, 59,302,  0,  0,  0,
     & 166,0.078D0,  0, 59,303,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 799, 817)/
     & 166,0.003D0,  0, 59,163,  0,  0,  0,
     & 166,0.003D0,  0,  1,  7,  0,  0,  0,
     & 166,0.012D0,  0,  2,  8,  0,  0,  0,
     & 166,0.003D0,  0,  3,  9,  0,  0,  0,
     & 166,0.127D0,130, 13, 13, 13,  0,  0,
     & 166,0.032D0,130, 13, 13, 59,  0,  0,
     & 167,0.500D0,  0,136,171,  0,  0,  0,
     & 167,0.500D0,  0,140,175,  0,  0,  0,
     & 171,0.067D0,101,128,121, 50,  0,  0,
     & 171,0.067D0,101,130,123, 50,  0,  0,
     & 171,0.048D0,101,128,121, 51,  0,  0,
     & 171,0.048D0,101,130,123, 51,  0,  0,
     & 171,0.003D0,  0,128,121, 46, 30,  0,
     & 171,0.003D0,  0,130,123, 46, 30,  0,
     & 171,0.006D0,101,128,121, 21,  0,  0,
     & 171,0.006D0,101,130,123, 21,  0,  0,
     & 171,0.002D0,101,128,121, 23,  0,  0,
     & 171,0.002D0,101,130,123, 23,  0,  0,
     & 171,0.055D0,  0, 46, 30, 30,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 818, 836)/
     & 171,0.031D0,  0, 46, 31, 30,  0,  0,
     & 171,0.042D0,  0, 46, 30, 30, 21, 21,
     & 171,0.002D0,  0, 46, 30, 30, 30, 39,
     & 171,0.021D0,  0, 47, 30, 30,  0,  0,
     & 171,0.027D0,  0, 50, 30,  0,  0,  0,
     & 171,0.066D0,  0, 50, 31,  0,  0,  0,
     & 171,0.081D0,  0, 50, 32,  0,  0,  0,
     & 171,0.024D0,  0, 50, 30, 21,  0,  0,
     & 171,0.004D0,  0, 50, 30, 23,  0,  0,
     & 171,0.069D0,  0, 50, 30, 30, 38, 21,
     & 171,0.001D0,  0, 50, 30, 30, 38, 23,
     & 171,0.022D0,  0, 51, 30,  0,  0,  0,
     & 171,0.021D0,  0, 51, 31,  0,  0,  0,
     & 171,0.042D0,  0, 51, 30, 21,  0,  0,
     & 171,0.008D0,  0, 51, 30, 23,  0,  0,
     & 171,0.010D0,  0, 51, 30, 30, 38,  0,
     & 171,0.050D0,  0,309, 30,  0,  0,  0,
     & 171,0.034D0,  0,328, 30,  0,  0,  0,
     & 171,0.010D0,  0,368, 30,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 837, 855)/
     & 171,0.031D0,  0, 34, 50, 50,  0,  0,
     & 171,0.003D0,  0, 30, 21,  0,  0,  0,
     & 171,0.001D0,  0, 30, 23,  0,  0,  0,
     & 171,0.002D0,  0, 30, 30, 38,  0,  0,
     & 171,0.008D0,  0, 30, 22,  0,  0,  0,
     & 171,0.001D0,  0, 30, 30, 30, 38, 38,
     & 171,0.003D0,  0, 30, 30, 30, 38, 39,
     & 171,0.008D0,  0, 34, 50,  0,  0,  0,
     & 171,0.005D0,  0, 34, 51,  0,  0,  0,
     & 171,0.026D0,  0, 35, 51,  0,  0,  0,
     & 171,0.005D0,  0, 34, 46, 30,  0,  0,
     & 171,0.007D0,  0, 30, 56,  0,  0,  0,
     & 171,0.023D0,  0, 30, 56, 21,  0,  0,
     & 171,0.005D0,  0, 34, 34, 46,  0,  0,
     & 172,0.683D0,  0,175, 30,  0,  0,  0,
     & 172,0.306D0,  0,171, 21,  0,  0,  0,
     & 172,0.011D0,  0,171, 59,  0,  0,  0,
     & 173,0.667D0,  0,176, 30,  0,  0,  0,
     & 173,0.333D0,  0,172, 21,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 856, 874)/
     & 174,0.220D0,  0,175, 30,  0,  0,  0,
     & 174,0.110D0,  0,171, 21,  0,  0,  0,
     & 174,0.380D0,  0,176, 30,  0,  0,  0,
     & 174,0.190D0,  0,172, 21,  0,  0,  0,
     & 174,0.004D0,  0,171, 22,  0,  0,  0,
     & 174,0.064D0,  0,176, 30, 21,  0,  0,
     & 174,0.032D0,  0,172, 38, 30,  0,  0,
     & 175,0.037D0,101,128,121, 46,  0,  0,
     & 175,0.037D0,101,130,123, 46,  0,  0,
     & 175,0.016D0,101,128,121, 47,  0,  0,
     & 175,0.016D0,101,130,123, 47,  0,  0,
     & 175,0.013D0,  0,128,121, 46, 21,  0,
     & 175,0.013D0,  0,130,123, 46, 21,  0,
     & 175,0.012D0,  0,128,121, 50, 38,  0,
     & 175,0.012D0,  0,130,123, 50, 38,  0,
     & 175,0.003D0,101,128,121, 38,  0,  0,
     & 175,0.003D0,101,130,123, 38,  0,  0,
     & 175,0.039D0,  0, 46, 30,  0,  0,  0,
     & 175,0.091D0,  0, 46, 31,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 875, 893)/
     & 175,0.067D0,  0, 46, 32,  0,  0,  0,
     & 175,0.004D0,  0, 46, 30, 21,  0,  0,
     & 175,0.100D0,  0, 46, 30, 21, 21,  0,
     & 175,0.058D0,  0, 46, 30, 23,  0,  0,
     & 175,0.020D0,  0, 46, 30, 24,  0,  0,
     & 175,0.006D0,  0, 46, 30, 25,  0,  0,
     & 175,0.043D0,  0, 47, 30,  0,  0,  0,
     & 175,0.035D0,  0, 47, 31,  0,  0,  0,
     & 175,0.007D0,  0,310, 30,  0,  0,  0,
     & 175,0.007D0,  0,327, 30,  0,  0,  0,
     & 175,0.020D0,  0, 50, 21,  0,  0,  0,
     & 175,0.006D0,  0, 50, 22,  0,  0,  0,
     & 175,0.009D0,  0, 50, 23,  0,  0,  0,
     & 175,0.016D0,  0, 50, 24,  0,  0,  0,
     & 175,0.014D0,  0, 50, 25,  0,  0,  0,
     & 175,0.003D0,  0, 50,293,  0,  0,  0,
     & 175,0.007D0,  0, 50, 56,  0,  0,  0,
     & 175,0.003D0,  0, 50, 26,  0,  0,  0,
     & 175,0.004D0,  0, 50,294,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 894, 912)/
     & 175,0.006D0,  0, 50, 21, 21,  0,  0,
     & 175,0.042D0,  0, 50, 30, 38, 21,  0,
     & 175,0.004D0,  0, 50, 30, 30, 38, 38,
     & 175,0.076D0,  0, 50, 30, 38, 21, 21,
     & 175,0.026D0,  0, 51, 21,  0,  0,  0,
     & 175,0.014D0,  0, 51, 22,  0,  0,  0,
     & 175,0.014D0,  0, 51, 23,  0,  0,  0,
     & 175,0.011D0,  0, 51, 24,  0,  0,  0,
     & 175,0.018D0,  0, 51, 30, 38,  0,  0,
     & 175,0.004D0,  0, 50, 34, 46,  0,  0,
     & 175,0.004D0,  0, 50, 34, 46, 21,  0,
     & 175,0.005D0,  0, 50, 50, 42,  0,  0,
     & 175,0.002D0,  0, 30, 38,  0,  0,  0,
     & 175,0.001D0,  0, 21, 21,  0,  0,  0,
     & 175,0.008D0,  0, 30, 38, 21,  0,  0,
     & 175,0.007D0,  0, 30, 30, 38, 38,  0,
     & 175,0.015D0,  0, 30, 30, 38, 38, 21,
     & 175,0.004D0,  0, 34, 46,  0,  0,  0,
     & 175,0.003D0,  0, 35, 46,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 913, 931)/
     & 175,0.002D0,  0, 34, 47,  0,  0,  0,
     & 175,0.001D0,  0, 42, 50,  0,  0,  0,
     & 175,0.002D0,  0, 43, 51,  0,  0,  0,
     & 175,0.003D0,  0, 42, 46, 30,  0,  0,
     & 175,0.003D0,  0, 50, 34, 38,  0,  0,
     & 175,0.001D0,  0, 34, 46, 30, 38, 21,
     & 175,0.002D0,  0, 56, 23,  0,  0,  0,
     & 175,0.001D0,  0, 56, 30, 38,  0,  0,
     & 176,0.636D0,  0,175, 21,  0,  0,  0,
     & 176,0.364D0,  0,175, 59,  0,  0,  0,
     & 177,0.667D0,  0,172, 38,  0,  0,  0,
     & 177,0.333D0,  0,176, 21,  0,  0,  0,
     & 178,0.220D0,  0,171, 38,  0,  0,  0,
     & 178,0.110D0,  0,175, 21,  0,  0,  0,
     & 178,0.380D0,  0,172, 38,  0,  0,  0,
     & 178,0.190D0,  0,176, 21,  0,  0,  0,
     & 178,0.004D0,  0,175, 22,  0,  0,  0,
     & 178,0.064D0,  0,172, 38, 21,  0,  0,
     & 178,0.032D0,  0,176, 38, 30,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 932, 950)/
     & 179,0.009D0,  0,130,123,  0,  0,  0,
     & 179,0.019D0,101,128,121, 56,  0,  0,
     & 179,0.019D0,101,130,123, 56,  0,  0,
     & 179,0.025D0,101,128,121, 22,  0,  0,
     & 179,0.025D0,101,130,123, 22,  0,  0,
     & 179,0.009D0,101,128,121, 25,  0,  0,
     & 179,0.009D0,101,130,123, 25,  0,  0,
     & 179,0.036D0,  0, 34, 50,  0,  0,  0,
     & 179,0.034D0,  0, 34, 51,  0,  0,  0,
     & 179,0.007D0,  0, 34,328,  0,  0,  0,
     & 179,0.043D0,  0, 35, 50,  0,  0,  0,
     & 179,0.058D0,  0, 35, 51,  0,  0,  0,
     & 179,0.011D0,  0, 34, 46, 30,  0,  0,
     & 179,0.055D0,  0, 34, 46, 30, 21,  0,
     & 179,0.003D0,  0, 34, 46, 30, 38, 30,
     & 179,0.014D0,  0, 34, 50, 38, 30,  0,
     & 179,0.017D0,  0, 42, 46, 30, 30,  0,
     & 179,0.036D0,  0, 56, 30,  0,  0,  0,
     & 179,0.067D0,  0, 56, 31,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 951, 969)/
     & 179,0.023D0,  0, 56, 30, 21,  0,  0,
     & 179,0.018D0,  0, 56, 30, 38, 30,  0,
     & 179,0.020D0,  0, 22, 30,  0,  0,  0,
     & 179,0.001D0,  0, 23, 30,  0,  0,  0,
     & 179,0.009D0,  0, 24, 30,  0,  0,  0,
     & 179,0.049D0,  0, 25, 30,  0,  0,  0,
     & 179,0.011D0,  0,293, 30,  0,  0,  0,
     & 179,0.015D0,  0, 22, 30, 21,  0,  0,
     & 179,0.016D0,  0, 25, 30, 21,  0,  0,
     & 179,0.103D0,  0, 22, 31,  0,  0,  0,
     & 179,0.120D0,  0, 25, 31,  0,  0,  0,
     & 179,0.010D0,  0, 30, 38, 30,  0,  0,
     & 179,0.046D0,  0, 30, 38, 30, 21,  0,
     & 179,0.003D0,  0, 30, 38, 38, 30, 30,
     & 179,0.042D0,  0, 30, 38, 38, 30, 31,
     & 179,0.001D0,  0, 34, 23,  0,  0,  0,
     & 179,0.005D0,  0, 34, 38, 30,  0,  0,
     & 179,0.001D0,  0, 34, 56,  0,  0,  0,
     & 179,0.004D0,  0, 42, 30,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 970, 988)/
     & 179,0.007D0,  0, 43, 30,  0,  0,  0,
     & 180,0.900D0,  0,179, 59,  0,  0,  0,
     & 180,0.100D0,  0,179, 21,  0,  0,  0,
     & 181,0.500D0,  0,172, 42,  0,  0,  0,
     & 181,0.500D0,  0,176, 34,  0,  0,  0,
     & 182,0.440D0,  0,171, 42,  0,  0,  0,
     & 182,0.440D0,  0,175, 34,  0,  0,  0,
     & 182,0.055D0,  0,172, 42,  0,  0,  0,
     & 182,0.055D0,  0,176, 34,  0,  0,  0,
     & 182,0.010D0,  0,179, 22,  0,  0,  0,
     & 183,1.000D0,  0,185, 30,  0,  0,  0,
     & 184,1.000D0,  0,185, 30,  0,  0,  0,
     & 185,0.028D0,101,128,121, 96,  0,  0,
     & 185,0.010D0,101,128,121, 98,  0,  0,
     & 185,0.028D0,101,130,123, 96,  0,  0,
     & 185,0.010D0,101,130,123, 98,  0,  0,
     & 185,0.026D0,  0, 91, 50,  0,  0,  0,
     & 185,0.030D0,  0, 91, 50, 21,  0,  0,
     & 185,0.029D0,  0, 91, 50, 38, 30,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I= 989,1007)/
     & 185,0.014D0,  0, 91, 50, 22,  0,  0,
     & 185,0.020D0,  0, 91, 51,  0,  0,  0,
     & 185,0.029D0,  0, 91, 46, 30,  0,  0,
     & 185,0.039D0,  0, 91, 46, 30, 21,  0,
     & 185,0.002D0,  0, 91, 46, 30, 30, 38,
     & 185,0.010D0,  0, 91, 46, 30, 21, 21,
     & 185,0.014D0,  0, 91, 47, 30,  0,  0,
     & 185,0.010D0,  0, 92, 50,  0,  0,  0,
     & 185,0.020D0,  0, 92, 51,  0,  0,  0,
     & 185,0.010D0,  0, 92, 51, 21,  0,  0,
     & 185,0.007D0,  0,103, 46,  0,  0,  0,
     & 185,0.014D0,  0,103, 47,  0,  0,  0,
     & 185,0.004D0,  0, 91,293,  0,  0,  0,
     & 185,0.003D0,  0, 91, 38, 30,  0,  0,
     & 185,0.003D0,  0, 91, 38, 30, 38, 30,
     & 185,0.001D0,  0, 91, 56,  0,  0,  0,
     & 185,0.002D0,  0, 91, 46, 34,  0,  0,
     & 185,0.010D0,  0, 96, 30,  0,  0,  0,
     & 185,0.020D0,  0, 96, 31,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1008,1026)/
     & 185,0.030D0,  0, 96, 30, 21,  0,  0,
     & 185,0.010D0,  0, 96, 30, 22,  0,  0,
     & 185,0.020D0,  0, 96, 30, 24,  0,  0,
     & 185,0.035D0,  0, 96, 30, 30, 38,  0,
     & 185,0.020D0,  0, 96, 30, 21, 21,  0,
     & 185,0.010D0,  0, 96, 30, 38, 30, 21,
     & 185,0.010D0,  0, 96, 30, 21, 21, 21,
     & 185,0.007D0,  0, 96, 34, 50,  0,  0,
     & 185,0.011D0,  0, 97, 30,  0,  0,  0,
     & 185,0.022D0,  0, 97, 30, 21,  0,  0,
     & 185,0.013D0,  0, 97, 30, 38, 30,  0,
     & 185,0.010D0,  0, 97, 30, 21, 21,  0,
     & 185,0.007D0,  0, 97, 30, 38, 30, 21,
     & 185,0.005D0,  0, 97, 30, 21, 21, 21,
     & 185,0.005D0,  0, 98, 30,  0,  0,  0,
     & 185,0.015D0,  0, 98, 31,  0,  0,  0,
     & 185,0.011D0,  0,104, 21,  0,  0,  0,
     & 185,0.007D0,  0,104, 22,  0,  0,  0,
     & 185,0.010D0,  0,104, 23,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1027,1045)/
     & 185,0.031D0,  0,104, 24,  0,  0,  0,
     & 185,0.010D0,  0,104, 25,  0,  0,  0,
     & 185,0.004D0,  0,104, 56,  0,  0,  0,
     & 185,0.026D0,  0,104, 38, 30,  0,  0,
     & 185,0.005D0,  0,104, 38, 38, 30, 30,
     & 185,0.005D0,  0,104, 38, 30, 21, 21,
     & 185,0.005D0,  0,105, 21,  0,  0,  0,
     & 185,0.006D0,  0,105, 23,  0,  0,  0,
     & 185,0.004D0,  0,104, 46, 34,  0,  0,
     & 185,0.002D0,  0,104, 34, 38,  0,  0,
     & 185,0.001D0,  0,104, 34, 38, 21,  0,
     & 185,0.016D0,  0, 99, 30, 30,  0,  0,
     & 185,0.003D0,  0,106, 34,  0,  0,  0,
     & 185,0.002D0,  0,107, 34,  0,  0,  0,
     & 185,0.003D0,  0,101, 34, 30,  0,  0,
     & 185,0.040D0,  0, 93, 34, 21,  0,  0,
     & 185,0.040D0,  0, 93, 34, 38, 30,  0,
     & 185,0.020D0,  0, 93, 34, 21, 21,  0,
     & 185,0.010D0,  0, 93, 34, 38, 30, 21/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1046,1064)/
     & 185,0.010D0,  0, 93, 34, 21, 21, 21,
     & 185,0.020D0,  0, 93, 35, 21,  0,  0,
     & 185,0.040D0,  0, 93, 50, 30,  0,  0,
     & 185,0.020D0,  0, 93, 50, 31,  0,  0,
     & 185,0.010D0,  0, 93, 50, 30, 38, 30,
     & 185,0.010D0,  0, 93, 50, 30, 21, 21,
     & 185,0.006D0,  0, 93, 51, 30,  0,  0,
     & 186,1.000D0,  0,185, 21,  0,  0,  0,
     & 187,1.000D0,  0,185, 21,  0,  0,  0,
     & 188,1.000D0,  0,185, 38,  0,  0,  0,
     & 189,1.000D0,  0,185, 38,  0,  0,  0,
     & 190,0.045D0,101,128,121,106,  0,  0,
     & 190,0.005D0,101,128,121,107,  0,  0,
     & 190,0.045D0,101,130,123,106,  0,  0,
     & 190,0.005D0,101,130,123,107,  0,  0,
     & 190,0.021D0,  0,104, 50,  0,  0,  0,
     & 190,0.032D0,  0,105, 50,  0,  0,  0,
     & 190,0.032D0,  0, 97, 30, 50,  0,  0,
     & 190,0.045D0,  0,104, 51,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1065,1083)/
     & 190,0.065D0,  0,105, 51,  0,  0,  0,
     & 190,0.065D0,  0, 97, 30, 51,  0,  0,
     & 190,0.055D0,  0,106, 30,  0,  0,  0,
     & 190,0.160D0,  0,106, 31,  0,  0,  0,
     & 190,0.105D0,  0,107, 30,  0,  0,  0,
     & 190,0.320D0,  0,107, 31,  0,  0,  0,
     & 191,1.000D0,  0,190, 59,  0,  0,  0,
     & 192,0.667D0,  0,193, 30,  0,  0,  0,
     & 192,0.333D0,  0,190, 21,  0,  0,  0,
     & 193,0.045D0,101,128,121,101,  0,  0,
     & 193,0.045D0,101,130,123,101,  0,  0,
     & 193,0.005D0,101,128,121,102,  0,  0,
     & 193,0.005D0,101,130,123,102,  0,  0,
     & 193,0.020D0,  0, 97, 50,  0,  0,  0,
     & 193,0.020D0,  0, 97, 21, 50,  0,  0,
     & 193,0.020D0,  0, 98, 50,  0,  0,  0,
     & 193,0.060D0,  0, 97, 51,  0,  0,  0,
     & 193,0.060D0,  0, 97, 21, 51,  0,  0,
     & 193,0.060D0,  0, 98, 51,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1084,1102)/
     & 193,0.020D0,  0,104, 46,  0,  0,  0,
     & 193,0.060D0,  0,104, 47,  0,  0,  0,
     & 193,0.040D0,  0,105, 46,  0,  0,  0,
     & 193,0.120D0,  0,105, 47,  0,  0,  0,
     & 193,0.020D0,  0,101, 30,  0,  0,  0,
     & 193,0.060D0,  0,101, 31,  0,  0,  0,
     & 193,0.040D0,  0,102, 30,  0,  0,  0,
     & 193,0.120D0,  0,102, 31,  0,  0,  0,
     & 193,0.010D0,  0,106, 21,  0,  0,  0,
     & 193,0.030D0,  0,106, 23,  0,  0,  0,
     & 193,0.020D0,  0,107, 21,  0,  0,  0,
     & 193,0.060D0,  0,107, 23,  0,  0,  0,
     & 193,0.030D0,  0,106, 56,  0,  0,  0,
     & 193,0.030D0,  0,108, 34,  0,  0,  0,
     & 194,1.000D0,  0,193, 59,  0,  0,  0,
     & 195,0.670D0,  0,190, 38,  0,  0,  0,
     & 195,0.330D0,  0,193, 21,  0,  0,  0,
     & 196,0.050D0,101,128,121,108,  0,  0,
     & 196,0.050D0,101,130,123,108,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1103,1121)/
     & 196,0.075D0,  0,106, 50,  0,  0,  0,
     & 196,0.225D0,  0,106, 51,  0,  0,  0,
     & 196,0.150D0,  0,107, 50,  0,  0,  0,
     & 196,0.450D0,  0,107, 51,  0,  0,  0,
     & 197,1.000D0,  0,196, 59,  0,  0,  0,
     & 209,0.250D0,100,  1,  8,  4,  0,  0,
     & 209,0.250D0,100,  3, 10,  4,  0,  0,
     & 209,0.250D0,100,  5, 12,  4,  0,  0,
     & 209,0.085D0,100,121,128,  4,  0,  0,
     & 209,0.085D0,100,123,130,  4,  0,  0,
     & 209,0.080D0,100,125,132,  4,  0,  0,
     & 210,0.250D0,100,  2,  7,209,  0,  0,
     & 210,0.250D0,100,  4,  9,209,  0,  0,
     & 210,0.250D0,100,  6, 11,209,  0,  0,
     & 210,0.085D0,100,122,127,209,  0,  0,
     & 210,0.085D0,100,124,129,209,  0,  0,
     & 210,0.080D0,100,126,131,209,  0,  0,
     & 211,0.250D0,100,  1,  8,  6,  0,  0,
     & 211,0.250D0,100,  3, 10,  6,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1122,1140)/
     & 211,0.250D0,100,  5, 12,  6,  0,  0,
     & 211,0.085D0,100,121,128,  6,  0,  0,
     & 211,0.085D0,100,123,130,  6,  0,  0,
     & 211,0.080D0,100,125,132,  6,  0,  0,
     & 212,0.250D0,100,  2,  7,211,  0,  0,
     & 212,0.250D0,100,  4,  9,211,  0,  0,
     & 212,0.250D0,100,  6, 11,211,  0,  0,
     & 212,0.085D0,100,122,127,211,  0,  0,
     & 212,0.085D0,100,124,129,211,  0,  0,
     & 212,0.080D0,100,126,131,211,  0,  0,
     & 215,0.250D0,100,  7,  2, 10,  0,  0,
     & 215,0.250D0,100,  9,  4, 10,  0,  0,
     & 215,0.250D0,100, 11,  6, 10,  0,  0,
     & 215,0.085D0,100,127,122, 10,  0,  0,
     & 215,0.085D0,100,129,124, 10,  0,  0,
     & 215,0.080D0,100,131,126, 10,  0,  0,
     & 216,0.250D0,100,  8,  1,215,  0,  0,
     & 216,0.250D0,100, 10,  3,215,  0,  0,
     & 216,0.250D0,100, 12,  5,215,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1141,1159)/
     & 216,0.085D0,100,128,121,215,  0,  0,
     & 216,0.085D0,100,130,123,215,  0,  0,
     & 216,0.080D0,100,132,125,215,  0,  0,
     & 217,0.250D0,100,  7,  2, 12,  0,  0,
     & 217,0.250D0,100,  9,  4, 12,  0,  0,
     & 217,0.250D0,100, 11,  6, 12,  0,  0,
     & 217,0.085D0,100,127,122, 12,  0,  0,
     & 217,0.085D0,100,129,124, 12,  0,  0,
     & 217,0.080D0,100,131,126, 12,  0,  0,
     & 218,0.250D0,100,  8,  1,217,  0,  0,
     & 218,0.250D0,100, 10,  3,217,  0,  0,
     & 218,0.250D0,100, 12,  5,217,  0,  0,
     & 218,0.085D0,100,128,121,217,  0,  0,
     & 218,0.085D0,100,130,123,217,  0,  0,
     & 218,0.080D0,100,132,125,217,  0,  0,
     & 221,0.016D0,101,121,128,136,  0,  0,
     & 221,0.016D0,101,123,130,136,  0,  0,
     & 221,0.008D0,101,125,132,136,  0,  0,
     & 221,0.048D0,101,121,128,137,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1160,1178)/
     & 221,0.048D0,101,123,130,137,  0,  0,
     & 221,0.022D0,101,125,132,137,  0,  0,
     & 221,0.003D0,101,121,128,331,  0,  0,
     & 221,0.003D0,101,123,130,331,  0,  0,
     & 221,0.001D0,101,125,132,331,  0,  0,
     & 221,0.008D0,101,121,128,138,  0,  0,
     & 221,0.008D0,101,123,130,138,  0,  0,
     & 221,0.004D0,101,125,132,138,  0,  0,
     & 221,0.008D0,101,121,128,313,  0,  0,
     & 221,0.008D0,101,123,130,313,  0,  0,
     & 221,0.004D0,101,125,132,313,  0,  0,
     & 221,0.013D0,101,121,128,139,  0,  0,
     & 221,0.013D0,101,123,130,139,  0,  0,
     & 221,0.006D0,101,125,132,139,  0,  0,
     & 221,0.004D0,  0,136, 30,  0,  0,  0,
     & 221,0.010D0,  0,136, 31,  0,  0,  0,
     & 221,0.006D0,  0,136, 32,  0,  0,  0,
     & 221,0.003D0,  0,137, 30,  0,  0,  0,
     & 221,0.009D0,  0,137, 31,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1179,1197)/
     & 221,0.017D0,  0,137, 32,  0,  0,  0,
     & 221,0.011D0,  0,136,179,  0,  0,  0,
     & 221,0.015D0,  0,136,180,  0,  0,  0,
     & 221,0.011D0,  0,137,179,  0,  0,  0,
     & 221,0.022D0,  0,137,180,  0,  0,  0,
     & 221,0.001D0,  0,164, 42,  0,  0,  0,
     & 221,0.002D0,  0,164, 43,  0,  0,  0,
     & 221,0.001D0,  0,165, 42,  0,  0,  0,
     & 221,0.001D0,  0,165, 43,  0,  0,  0,
     & 221,0.001D0,  0,166, 42,  0,  0,  0,
     & 221,0.001D0,  0,166, 43,  0,  0,  0,
     & 221,0.207D0,100,  1,  8,  4,  7,  0,
     & 221,0.207D0,100,  3, 10,  4,  7,  0,
     & 221,0.024D0,100,  1,  8,  2,  7,  0,
     & 221,0.024D0,100,  3, 10,  2,  7,  0,
     & 221,0.012D0,100,  3,  8,  4,  7,  0,
     & 221,0.012D0,100,  1, 10,  4,  7,  0,
     & 221,0.069D0,100,  4,  8,  1,  7,  0,
     & 221,0.069D0,100,  4, 10,  3,  7,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1198,1216)/
     & 221,0.008D0,100,  2,  8,  1,  7,  0,
     & 221,0.008D0,100,  2, 10,  3,  7,  0,
     & 221,0.004D0,100,  4,  8,  3,  7,  0,
     & 221,0.004D0,100,  4, 10,  1,  7,  0,
     & 222,0.016D0,101,121,128,140,  0,  0,
     & 222,0.016D0,101,123,130,140,  0,  0,
     & 222,0.008D0,101,125,132,140,  0,  0,
     & 222,0.048D0,101,121,128,141,  0,  0,
     & 222,0.048D0,101,123,130,141,  0,  0,
     & 222,0.022D0,101,125,132,141,  0,  0,
     & 222,0.003D0,101,121,128,332,  0,  0,
     & 222,0.003D0,101,123,130,332,  0,  0,
     & 222,0.001D0,101,125,132,332,  0,  0,
     & 222,0.008D0,101,121,128,142,  0,  0,
     & 222,0.008D0,101,123,130,142,  0,  0,
     & 222,0.004D0,101,125,132,142,  0,  0,
     & 222,0.008D0,101,121,128,314,  0,  0,
     & 222,0.008D0,101,123,130,314,  0,  0,
     & 222,0.004D0,101,125,132,314,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1217,1235)/
     & 222,0.013D0,101,121,128,143,  0,  0,
     & 222,0.013D0,101,123,130,143,  0,  0,
     & 222,0.006D0,101,125,132,143,  0,  0,
     & 222,0.004D0,  0,140, 30,  0,  0,  0,
     & 222,0.010D0,  0,140, 31,  0,  0,  0,
     & 222,0.006D0,  0,140, 32,  0,  0,  0,
     & 222,0.003D0,  0,141, 30,  0,  0,  0,
     & 222,0.009D0,  0,141, 31,  0,  0,  0,
     & 222,0.017D0,  0,141, 32,  0,  0,  0,
     & 222,0.011D0,  0,140,179,  0,  0,  0,
     & 222,0.015D0,  0,140,180,  0,  0,  0,
     & 222,0.011D0,  0,141,179,  0,  0,  0,
     & 222,0.022D0,  0,141,180,  0,  0,  0,
     & 222,0.001D0,  0,164, 34,  0,  0,  0,
     & 222,0.002D0,  0,164, 35,  0,  0,  0,
     & 222,0.001D0,  0,165, 34,  0,  0,  0,
     & 222,0.001D0,  0,165, 35,  0,  0,  0,
     & 222,0.001D0,  0,166, 34,  0,  0,  0,
     & 222,0.001D0,  0,166, 35,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1236,1254)/
     & 222,0.207D0,100,  1,  8,  4,  8,  0,
     & 222,0.207D0,100,  3, 10,  4,  8,  0,
     & 222,0.024D0,100,  1,  8,  2,  8,  0,
     & 222,0.024D0,100,  3, 10,  2,  8,  0,
     & 222,0.012D0,100,  3,  8,  4,  8,  0,
     & 222,0.012D0,100,  1, 10,  4,  8,  0,
     & 222,0.069D0,100,  4,  8,  1,  8,  0,
     & 222,0.069D0,100,  4, 10,  3,  8,  0,
     & 222,0.008D0,100,  2,  8,  1,  8,  0,
     & 222,0.008D0,100,  2, 10,  3,  8,  0,
     & 222,0.004D0,100,  4,  8,  3,  8,  0,
     & 222,0.004D0,100,  4, 10,  1,  8,  0,
     & 223,0.016D0,101,121,128,144,  0,  0,
     & 223,0.016D0,101,123,130,144,  0,  0,
     & 223,0.008D0,101,125,132,144,  0,  0,
     & 223,0.048D0,101,121,128,145,  0,  0,
     & 223,0.048D0,101,123,130,145,  0,  0,
     & 223,0.022D0,101,125,132,145,  0,  0,
     & 223,0.003D0,101,121,128,333,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1255,1273)/
     & 223,0.003D0,101,123,130,333,  0,  0,
     & 223,0.001D0,101,125,132,333,  0,  0,
     & 223,0.008D0,101,121,128,146,  0,  0,
     & 223,0.008D0,101,123,130,146,  0,  0,
     & 223,0.004D0,101,125,132,146,  0,  0,
     & 223,0.008D0,101,121,128,315,  0,  0,
     & 223,0.008D0,101,123,130,315,  0,  0,
     & 223,0.004D0,101,125,132,315,  0,  0,
     & 223,0.013D0,101,121,128,147,  0,  0,
     & 223,0.013D0,101,123,130,147,  0,  0,
     & 223,0.006D0,101,125,132,147,  0,  0,
     & 223,0.004D0,  0,144, 30,  0,  0,  0,
     & 223,0.010D0,  0,144, 31,  0,  0,  0,
     & 223,0.006D0,  0,144, 32,  0,  0,  0,
     & 223,0.003D0,  0,145, 30,  0,  0,  0,
     & 223,0.009D0,  0,145, 31,  0,  0,  0,
     & 223,0.017D0,  0,145, 32,  0,  0,  0,
     & 223,0.011D0,  0,144,179,  0,  0,  0,
     & 223,0.015D0,  0,144,180,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1274,1292)/
     & 223,0.011D0,  0,145,179,  0,  0,  0,
     & 223,0.022D0,  0,145,180,  0,  0,  0,
     & 223,0.001D0,  0,164, 25,  0,  0,  0,
     & 223,0.002D0,  0,164, 56,  0,  0,  0,
     & 223,0.001D0,  0,165, 25,  0,  0,  0,
     & 223,0.001D0,  0,165, 56,  0,  0,  0,
     & 223,0.001D0,  0,166, 25,  0,  0,  0,
     & 223,0.001D0,  0,166, 56,  0,  0,  0,
     & 223,0.207D0,100,  1,  8,  4,  9,  0,
     & 223,0.207D0,100,  3, 10,  4,  9,  0,
     & 223,0.024D0,100,  1,  8,  2,  9,  0,
     & 223,0.024D0,100,  3, 10,  2,  9,  0,
     & 223,0.012D0,100,  3,  8,  4,  9,  0,
     & 223,0.012D0,100,  1, 10,  4,  9,  0,
     & 223,0.069D0,100,  4,  8,  1,  9,  0,
     & 223,0.069D0,100,  4, 10,  3,  9,  0,
     & 223,0.008D0,100,  2,  8,  1,  9,  0,
     & 223,0.008D0,100,  2, 10,  3,  9,  0,
     & 223,0.004D0,100,  4,  8,  3,  9,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1293,1311)/
     & 223,0.004D0,100,  4, 10,  1,  9,  0,
     & 224,0.090D0,100,121,128,  4,109,  0,
     & 224,0.090D0,100,123,130,  4,109,  0,
     & 224,0.045D0,100,125,132,  4,109,  0,
     & 224,0.010D0,100,121,128,  2,109,  0,
     & 224,0.010D0,100,123,130,  2,109,  0,
     & 224,0.005D0,100,125,132,  2,109,  0,
     & 224,0.242D0,100,  1,  8,  4,109,  0,
     & 224,0.242D0,100,  3, 10,  4,109,  0,
     & 224,0.027D0,100,  1,  8,  2,109,  0,
     & 224,0.027D0,100,  3, 10,  2,109,  0,
     & 224,0.012D0,100,  3,  8,  4,109,  0,
     & 224,0.012D0,100,  1, 10,  4,109,  0,
     & 224,0.081D0,100,  4,  8,  1,109,  0,
     & 224,0.081D0,100,  4, 10,  3,109,  0,
     & 224,0.009D0,100,  2,  8,  1,109,  0,
     & 224,0.009D0,100,  2, 10,  3,109,  0,
     & 224,0.004D0,100,  4,  8,  3,109,  0,
     & 224,0.004D0,100,  4, 10,  1,109,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1312,1330)/
     & 225,0.090D0,100,121,128,  4,110,  0,
     & 225,0.090D0,100,123,130,  4,110,  0,
     & 225,0.045D0,100,125,132,  4,110,  0,
     & 225,0.010D0,100,121,128,  2,110,  0,
     & 225,0.010D0,100,123,130,  2,110,  0,
     & 225,0.005D0,100,125,132,  2,110,  0,
     & 225,0.242D0,100,  1,  8,  4,110,  0,
     & 225,0.242D0,100,  3, 10,  4,110,  0,
     & 225,0.027D0,100,  1,  8,  2,110,  0,
     & 225,0.027D0,100,  3, 10,  2,110,  0,
     & 225,0.012D0,100,  3,  8,  4,110,  0,
     & 225,0.012D0,100,  1, 10,  4,110,  0,
     & 225,0.081D0,100,  4,  8,  1,110,  0,
     & 225,0.081D0,100,  4, 10,  3,110,  0,
     & 225,0.009D0,100,  2,  8,  1,110,  0,
     & 225,0.009D0,100,  2, 10,  3,110,  0,
     & 225,0.004D0,100,  4,  8,  3,110,  0,
     & 225,0.004D0,100,  4, 10,  1,110,  0,
     & 226,0.090D0,100,121,128,  4,111,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1331,1349)/
     & 226,0.090D0,100,123,130,  4,111,  0,
     & 226,0.045D0,100,125,132,  4,111,  0,
     & 226,0.010D0,100,121,128,  2,111,  0,
     & 226,0.010D0,100,123,130,  2,111,  0,
     & 226,0.005D0,100,125,132,  2,111,  0,
     & 226,0.242D0,100,  1,  8,  4,111,  0,
     & 226,0.242D0,100,  3, 10,  4,111,  0,
     & 226,0.027D0,100,  1,  8,  2,111,  0,
     & 226,0.027D0,100,  3, 10,  2,111,  0,
     & 226,0.012D0,100,  3,  8,  4,111,  0,
     & 226,0.012D0,100,  1, 10,  4,111,  0,
     & 226,0.081D0,100,  4,  8,  1,111,  0,
     & 226,0.081D0,100,  4, 10,  3,111,  0,
     & 226,0.009D0,100,  2,  8,  1,111,  0,
     & 226,0.009D0,100,  2, 10,  3,111,  0,
     & 226,0.004D0,100,  4,  8,  3,111,  0,
     & 226,0.004D0,100,  4, 10,  1,111,  0,
     & 227,0.090D0,100,121,128,  4,112,  0,
     & 227,0.090D0,100,123,130,  4,112,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1350,1368)/
     & 227,0.045D0,100,125,132,  4,112,  0,
     & 227,0.010D0,100,121,128,  2,112,  0,
     & 227,0.010D0,100,123,130,  2,112,  0,
     & 227,0.005D0,100,125,132,  2,112,  0,
     & 227,0.242D0,100,  1,  8,  4,112,  0,
     & 227,0.242D0,100,  3, 10,  4,112,  0,
     & 227,0.027D0,100,  1,  8,  2,112,  0,
     & 227,0.027D0,100,  3, 10,  2,112,  0,
     & 227,0.012D0,100,  3,  8,  4,112,  0,
     & 227,0.012D0,100,  1, 10,  4,112,  0,
     & 227,0.081D0,100,  4,  8,  1,112,  0,
     & 227,0.081D0,100,  4, 10,  3,112,  0,
     & 227,0.009D0,100,  2,  8,  1,112,  0,
     & 227,0.009D0,100,  2, 10,  3,112,  0,
     & 227,0.004D0,100,  4,  8,  3,112,  0,
     & 227,0.004D0,100,  4, 10,  1,112,  0,
     & 228,0.090D0,100,121,128,  4,113,  0,
     & 228,0.090D0,100,123,130,  4,113,  0,
     & 228,0.045D0,100,125,132,  4,113,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1369,1387)/
     & 228,0.010D0,100,121,128,  2,113,  0,
     & 228,0.010D0,100,123,130,  2,113,  0,
     & 228,0.005D0,100,125,132,  2,113,  0,
     & 228,0.242D0,100,  1,  8,  4,113,  0,
     & 228,0.242D0,100,  3, 10,  4,113,  0,
     & 228,0.027D0,100,  1,  8,  2,113,  0,
     & 228,0.027D0,100,  3, 10,  2,113,  0,
     & 228,0.012D0,100,  3,  8,  4,113,  0,
     & 228,0.012D0,100,  1, 10,  4,113,  0,
     & 228,0.081D0,100,  4,  8,  1,113,  0,
     & 228,0.081D0,100,  4, 10,  3,113,  0,
     & 228,0.009D0,100,  2,  8,  1,113,  0,
     & 228,0.009D0,100,  2, 10,  3,113,  0,
     & 228,0.004D0,100,  4,  8,  3,113,  0,
     & 228,0.004D0,100,  4, 10,  1,113,  0,
     & 229,0.090D0,100,121,128,  4,114,  0,
     & 229,0.090D0,100,123,130,  4,114,  0,
     & 229,0.045D0,100,125,132,  4,114,  0,
     & 229,0.010D0,100,121,128,  2,114,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1388,1406)/
     & 229,0.010D0,100,123,130,  2,114,  0,
     & 229,0.005D0,100,125,132,  2,114,  0,
     & 229,0.242D0,100,  1,  8,  4,114,  0,
     & 229,0.242D0,100,  3, 10,  4,114,  0,
     & 229,0.027D0,100,  1,  8,  2,114,  0,
     & 229,0.027D0,100,  3, 10,  2,114,  0,
     & 229,0.012D0,100,  3,  8,  4,114,  0,
     & 229,0.012D0,100,  1, 10,  4,114,  0,
     & 229,0.081D0,100,  4,  8,  1,114,  0,
     & 229,0.081D0,100,  4, 10,  3,114,  0,
     & 229,0.009D0,100,  2,  8,  1,114,  0,
     & 229,0.009D0,100,  2, 10,  3,114,  0,
     & 229,0.004D0,100,  4,  8,  3,114,  0,
     & 229,0.004D0,100,  4, 10,  1,114,  0,
     & 230,0.080D0,100,121,128,  4, 10,  0,
     & 230,0.080D0,100,123,130,  4, 10,  0,
     & 230,0.040D0,100,125,132,  4, 10,  0,
     & 230,0.080D0,100,121,128,  9,  5,  0,
     & 230,0.080D0,100,123,130,  9,  5,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1407,1425)/
     & 230,0.228D0,100,  1,  8,  4, 10,  0,
     & 230,0.228D0,100,  3, 10,  4, 10,  0,
     & 230,0.012D0,100,  3,  8,  4, 10,  0,
     & 230,0.012D0,100,  1, 10,  4, 10,  0,
     & 230,0.076D0,100,  4,  8,  1, 10,  0,
     & 230,0.076D0,100,  4, 10,  3, 10,  0,
     & 230,0.004D0,100,  4,  8,  3, 10,  0,
     & 230,0.004D0,100,  4, 10,  1, 10,  0,
     & 231,0.025D0,  0,121,127,  0,  0,  0,
     & 231,0.025D0,  0,123,129,  0,  0,  0,
     & 231,0.025D0,  0,125,131,  0,  0,  0,
     & 231,0.008D0,  0,  1,  7,  0,  0,  0,
     & 231,0.033D0,  0,  2,  8,  0,  0,  0,
     & 231,0.008D0,  0,  3,  9,  0,  0,  0,
     & 231,0.033D0,  0,  4, 10,  0,  0,  0,
     & 231,0.801D0,130, 13, 13, 13,  0,  0,
     & 231,0.042D0,130, 13, 13, 59,  0,  0,
     & 245,0.016D0,101,127,122,171,  0,  0,
     & 245,0.016D0,101,129,124,171,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1426,1444)/
     & 245,0.008D0,101,131,126,171,  0,  0,
     & 245,0.048D0,101,127,122,172,  0,  0,
     & 245,0.048D0,101,129,124,172,  0,  0,
     & 245,0.022D0,101,131,126,172,  0,  0,
     & 245,0.003D0,101,127,122,334,  0,  0,
     & 245,0.003D0,101,129,124,334,  0,  0,
     & 245,0.001D0,101,131,126,334,  0,  0,
     & 245,0.008D0,101,127,122,173,  0,  0,
     & 245,0.008D0,101,129,124,173,  0,  0,
     & 245,0.004D0,101,131,126,173,  0,  0,
     & 245,0.008D0,101,127,122,316,  0,  0,
     & 245,0.008D0,101,129,124,316,  0,  0,
     & 245,0.004D0,101,131,126,316,  0,  0,
     & 245,0.013D0,101,127,122,174,  0,  0,
     & 245,0.013D0,101,129,124,174,  0,  0,
     & 245,0.006D0,101,131,126,174,  0,  0,
     & 245,0.004D0,  0,171, 38,  0,  0,  0,
     & 245,0.010D0,  0,171, 39,  0,  0,  0,
     & 245,0.006D0,  0,171, 40,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1445,1463)/
     & 245,0.003D0,  0,172, 38,  0,  0,  0,
     & 245,0.009D0,  0,172, 39,  0,  0,  0,
     & 245,0.017D0,  0,172, 40,  0,  0,  0,
     & 245,0.011D0,  0,171,144,  0,  0,  0,
     & 245,0.015D0,  0,171,145,  0,  0,  0,
     & 245,0.011D0,  0,172,144,  0,  0,  0,
     & 245,0.022D0,  0,172,145,  0,  0,  0,
     & 245,0.001D0,  0,164, 50,  0,  0,  0,
     & 245,0.002D0,  0,164, 51,  0,  0,  0,
     & 245,0.001D0,  0,165, 50,  0,  0,  0,
     & 245,0.001D0,  0,165, 51,  0,  0,  0,
     & 245,0.001D0,  0,166, 50,  0,  0,  0,
     & 245,0.001D0,  0,166, 51,  0,  0,  0,
     & 245,0.207D0,100,  7,  2, 10,  1,  0,
     & 245,0.207D0,100,  9,  4, 10,  1,  0,
     & 245,0.024D0,100,  7,  2,  8,  1,  0,
     & 245,0.024D0,100,  9,  4,  8,  1,  0,
     & 245,0.012D0,100,  9,  2, 10,  1,  0,
     & 245,0.012D0,100,  7,  4, 10,  1,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1464,1482)/
     & 245,0.069D0,100, 10,  2,  7,  1,  0,
     & 245,0.069D0,100, 10,  4,  9,  1,  0,
     & 245,0.008D0,100,  8,  2,  7,  1,  0,
     & 245,0.008D0,100,  8,  4,  9,  1,  0,
     & 245,0.004D0,100, 10,  2,  9,  1,  0,
     & 245,0.004D0,100, 10,  4,  7,  1,  0,
     & 246,0.016D0,101,127,122,175,  0,  0,
     & 246,0.016D0,101,129,124,175,  0,  0,
     & 246,0.008D0,101,131,126,175,  0,  0,
     & 246,0.048D0,101,127,122,176,  0,  0,
     & 246,0.048D0,101,129,124,176,  0,  0,
     & 246,0.022D0,101,131,126,176,  0,  0,
     & 246,0.003D0,101,127,122,335,  0,  0,
     & 246,0.003D0,101,129,124,335,  0,  0,
     & 246,0.001D0,101,131,126,335,  0,  0,
     & 246,0.008D0,101,127,122,177,  0,  0,
     & 246,0.008D0,101,129,124,177,  0,  0,
     & 246,0.004D0,101,131,126,177,  0,  0,
     & 246,0.008D0,101,127,122,317,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1483,1501)/
     & 246,0.008D0,101,129,124,317,  0,  0,
     & 246,0.004D0,101,131,126,317,  0,  0,
     & 246,0.013D0,101,127,122,178,  0,  0,
     & 246,0.013D0,101,129,124,178,  0,  0,
     & 246,0.006D0,101,131,126,178,  0,  0,
     & 246,0.004D0,  0,175, 38,  0,  0,  0,
     & 246,0.010D0,  0,175, 39,  0,  0,  0,
     & 246,0.006D0,  0,175, 40,  0,  0,  0,
     & 246,0.003D0,  0,176, 38,  0,  0,  0,
     & 246,0.009D0,  0,176, 39,  0,  0,  0,
     & 246,0.017D0,  0,176, 40,  0,  0,  0,
     & 246,0.011D0,  0,175,144,  0,  0,  0,
     & 246,0.015D0,  0,175,145,  0,  0,  0,
     & 246,0.011D0,  0,176,144,  0,  0,  0,
     & 246,0.022D0,  0,176,145,  0,  0,  0,
     & 246,0.001D0,  0,164, 46,  0,  0,  0,
     & 246,0.002D0,  0,164, 47,  0,  0,  0,
     & 246,0.001D0,  0,165, 46,  0,  0,  0,
     & 246,0.001D0,  0,165, 47,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1502,1520)/
     & 246,0.001D0,  0,166, 46,  0,  0,  0,
     & 246,0.001D0,  0,166, 47,  0,  0,  0,
     & 246,0.207D0,100,  7,  2, 10,  2,  0,
     & 246,0.207D0,100,  9,  4, 10,  2,  0,
     & 246,0.024D0,100,  7,  2,  8,  2,  0,
     & 246,0.024D0,100,  9,  4,  8,  2,  0,
     & 246,0.012D0,100,  9,  2, 10,  2,  0,
     & 246,0.012D0,100,  7,  4, 10,  2,  0,
     & 246,0.069D0,100, 10,  2,  7,  2,  0,
     & 246,0.069D0,100, 10,  4,  9,  2,  0,
     & 246,0.008D0,100,  8,  2,  7,  2,  0,
     & 246,0.008D0,100,  8,  4,  9,  2,  0,
     & 246,0.004D0,100, 10,  2,  9,  2,  0,
     & 246,0.004D0,100, 10,  4,  7,  2,  0,
     & 247,0.016D0,101,127,122,179,  0,  0,
     & 247,0.016D0,101,129,124,179,  0,  0,
     & 247,0.008D0,101,131,126,179,  0,  0,
     & 247,0.048D0,101,127,122,180,  0,  0,
     & 247,0.048D0,101,129,124,180,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1521,1539)/
     & 247,0.022D0,101,131,126,180,  0,  0,
     & 247,0.003D0,101,127,122,336,  0,  0,
     & 247,0.003D0,101,129,124,336,  0,  0,
     & 247,0.001D0,101,131,126,336,  0,  0,
     & 247,0.008D0,101,127,122,181,  0,  0,
     & 247,0.008D0,101,129,124,181,  0,  0,
     & 247,0.004D0,101,131,126,181,  0,  0,
     & 247,0.008D0,101,127,122,318,  0,  0,
     & 247,0.008D0,101,129,124,318,  0,  0,
     & 247,0.004D0,101,131,126,318,  0,  0,
     & 247,0.013D0,101,127,122,182,  0,  0,
     & 247,0.013D0,101,129,124,182,  0,  0,
     & 247,0.006D0,101,131,126,182,  0,  0,
     & 247,0.004D0,  0,179, 38,  0,  0,  0,
     & 247,0.010D0,  0,179, 39,  0,  0,  0,
     & 247,0.006D0,  0,179, 40,  0,  0,  0,
     & 247,0.003D0,  0,180, 38,  0,  0,  0,
     & 247,0.009D0,  0,180, 39,  0,  0,  0,
     & 247,0.017D0,  0,180, 40,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1540,1558)/
     & 247,0.011D0,  0,179,144,  0,  0,  0,
     & 247,0.015D0,  0,179,145,  0,  0,  0,
     & 247,0.011D0,  0,180,144,  0,  0,  0,
     & 247,0.022D0,  0,180,145,  0,  0,  0,
     & 247,0.001D0,  0,164, 25,  0,  0,  0,
     & 247,0.002D0,  0,164, 56,  0,  0,  0,
     & 247,0.001D0,  0,165, 25,  0,  0,  0,
     & 247,0.001D0,  0,165, 56,  0,  0,  0,
     & 247,0.001D0,  0,166, 25,  0,  0,  0,
     & 247,0.001D0,  0,166, 56,  0,  0,  0,
     & 247,0.207D0,100,  7,  2, 10,  3,  0,
     & 247,0.207D0,100,  9,  4, 10,  3,  0,
     & 247,0.024D0,100,  7,  2,  8,  3,  0,
     & 247,0.024D0,100,  9,  4,  8,  3,  0,
     & 247,0.012D0,100,  9,  2, 10,  3,  0,
     & 247,0.012D0,100,  7,  4, 10,  3,  0,
     & 247,0.069D0,100, 10,  2,  7,  3,  0,
     & 247,0.069D0,100, 10,  4,  9,  3,  0,
     & 247,0.008D0,100,  8,  2,  7,  3,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1559,1577)/
     & 247,0.008D0,100,  8,  4,  9,  3,  0,
     & 247,0.004D0,100, 10,  2,  9,  3,  0,
     & 247,0.004D0,100, 10,  4,  7,  3,  0,
     & 248,0.090D0,100,127,122, 10,115,  0,
     & 248,0.090D0,100,129,124, 10,115,  0,
     & 248,0.045D0,100,131,126, 10,115,  0,
     & 248,0.010D0,100,127,122,  8,115,  0,
     & 248,0.010D0,100,129,124,  8,115,  0,
     & 248,0.005D0,100,131,126,  8,115,  0,
     & 248,0.242D0,100,  7,  2, 10,115,  0,
     & 248,0.242D0,100,  9,  4, 10,115,  0,
     & 248,0.027D0,100,  7,  2,  8,115,  0,
     & 248,0.027D0,100,  9,  4,  8,115,  0,
     & 248,0.012D0,100,  9,  2, 10,115,  0,
     & 248,0.012D0,100,  7,  4, 10,115,  0,
     & 248,0.081D0,100, 10,  2,  7,115,  0,
     & 248,0.081D0,100, 10,  4,  9,115,  0,
     & 248,0.009D0,100,  8,  2,  7,115,  0,
     & 248,0.009D0,100,  8,  4,  9,115,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1578,1596)/
     & 248,0.004D0,100, 10,  2,  9,115,  0,
     & 248,0.004D0,100, 10,  4,  7,115,  0,
     & 249,0.090D0,100,127,122, 10,116,  0,
     & 249,0.090D0,100,129,124, 10,116,  0,
     & 249,0.045D0,100,131,126, 10,116,  0,
     & 249,0.010D0,100,127,122,  8,116,  0,
     & 249,0.010D0,100,129,124,  8,116,  0,
     & 249,0.005D0,100,131,126,  8,116,  0,
     & 249,0.242D0,100,  7,  2, 10,116,  0,
     & 249,0.242D0,100,  9,  4, 10,116,  0,
     & 249,0.027D0,100,  7,  2,  8,116,  0,
     & 249,0.027D0,100,  9,  4,  8,116,  0,
     & 249,0.012D0,100,  9,  2, 10,116,  0,
     & 249,0.012D0,100,  7,  4, 10,116,  0,
     & 249,0.081D0,100, 10,  2,  7,116,  0,
     & 249,0.081D0,100, 10,  4,  9,116,  0,
     & 249,0.009D0,100,  8,  2,  7,116,  0,
     & 249,0.009D0,100,  8,  4,  9,116,  0,
     & 249,0.004D0,100, 10,  2,  9,116,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1597,1615)/
     & 249,0.004D0,100, 10,  4,  7,116,  0,
     & 250,0.090D0,100,127,122, 10,117,  0,
     & 250,0.090D0,100,129,124, 10,117,  0,
     & 250,0.045D0,100,131,126, 10,117,  0,
     & 250,0.010D0,100,127,122,  8,117,  0,
     & 250,0.010D0,100,129,124,  8,117,  0,
     & 250,0.005D0,100,131,126,  8,117,  0,
     & 250,0.242D0,100,  7,  2, 10,117,  0,
     & 250,0.242D0,100,  9,  4, 10,117,  0,
     & 250,0.027D0,100,  7,  2,  8,117,  0,
     & 250,0.027D0,100,  9,  4,  8,117,  0,
     & 250,0.012D0,100,  9,  2, 10,117,  0,
     & 250,0.012D0,100,  7,  4, 10,117,  0,
     & 250,0.081D0,100, 10,  2,  7,117,  0,
     & 250,0.081D0,100, 10,  4,  9,117,  0,
     & 250,0.009D0,100,  8,  2,  7,117,  0,
     & 250,0.009D0,100,  8,  4,  9,117,  0,
     & 250,0.004D0,100, 10,  2,  9,117,  0,
     & 250,0.004D0,100, 10,  4,  7,117,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1616,1634)/
     & 251,0.090D0,100,127,122, 10,118,  0,
     & 251,0.090D0,100,129,124, 10,118,  0,
     & 251,0.045D0,100,131,126, 10,118,  0,
     & 251,0.010D0,100,127,122,  8,118,  0,
     & 251,0.010D0,100,129,124,  8,118,  0,
     & 251,0.005D0,100,131,126,  8,118,  0,
     & 251,0.242D0,100,  7,  2, 10,118,  0,
     & 251,0.242D0,100,  9,  4, 10,118,  0,
     & 251,0.027D0,100,  7,  2,  8,118,  0,
     & 251,0.027D0,100,  9,  4,  8,118,  0,
     & 251,0.012D0,100,  9,  2, 10,118,  0,
     & 251,0.012D0,100,  7,  4, 10,118,  0,
     & 251,0.081D0,100, 10,  2,  7,118,  0,
     & 251,0.081D0,100, 10,  4,  9,118,  0,
     & 251,0.009D0,100,  8,  2,  7,118,  0,
     & 251,0.009D0,100,  8,  4,  9,118,  0,
     & 251,0.004D0,100, 10,  2,  9,118,  0,
     & 251,0.004D0,100, 10,  4,  7,118,  0,
     & 252,0.090D0,100,127,122, 10,119,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1635,1653)/
     & 252,0.090D0,100,129,124, 10,119,  0,
     & 252,0.045D0,100,131,126, 10,119,  0,
     & 252,0.010D0,100,127,122,  8,119,  0,
     & 252,0.010D0,100,129,124,  8,119,  0,
     & 252,0.005D0,100,131,126,  8,119,  0,
     & 252,0.242D0,100,  7,  2, 10,119,  0,
     & 252,0.242D0,100,  9,  4, 10,119,  0,
     & 252,0.027D0,100,  7,  2,  8,119,  0,
     & 252,0.027D0,100,  9,  4,  8,119,  0,
     & 252,0.012D0,100,  9,  2, 10,119,  0,
     & 252,0.012D0,100,  7,  4, 10,119,  0,
     & 252,0.081D0,100, 10,  2,  7,119,  0,
     & 252,0.081D0,100, 10,  4,  9,119,  0,
     & 252,0.009D0,100,  8,  2,  7,119,  0,
     & 252,0.009D0,100,  8,  4,  9,119,  0,
     & 252,0.004D0,100, 10,  2,  9,119,  0,
     & 252,0.004D0,100, 10,  4,  7,119,  0,
     & 253,0.090D0,100,127,122, 10,120,  0,
     & 253,0.090D0,100,129,124, 10,120,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1654,1672)/
     & 253,0.045D0,100,131,126, 10,120,  0,
     & 253,0.010D0,100,127,122,  8,120,  0,
     & 253,0.010D0,100,129,124,  8,120,  0,
     & 253,0.005D0,100,131,126,  8,120,  0,
     & 253,0.242D0,100,  7,  2, 10,120,  0,
     & 253,0.242D0,100,  9,  4, 10,120,  0,
     & 253,0.027D0,100,  7,  2,  8,120,  0,
     & 253,0.027D0,100,  9,  4,  8,120,  0,
     & 253,0.012D0,100,  9,  2, 10,120,  0,
     & 253,0.012D0,100,  7,  4, 10,120,  0,
     & 253,0.081D0,100, 10,  2,  7,120,  0,
     & 253,0.081D0,100, 10,  4,  9,120,  0,
     & 253,0.009D0,100,  8,  2,  7,120,  0,
     & 253,0.009D0,100,  8,  4,  9,120,  0,
     & 253,0.004D0,100, 10,  2,  9,120,  0,
     & 253,0.004D0,100, 10,  4,  7,120,  0,
     & 254,0.080D0,100,127,122, 10,  4,  0,
     & 254,0.080D0,100,129,124, 10,  4,  0,
     & 254,0.040D0,100,131,126, 10,  4,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1673,1691)/
     & 254,0.080D0,100,127,122,  3, 11,  0,
     & 254,0.080D0,100,129,124,  3, 11,  0,
     & 254,0.228D0,100,  7,  2, 10,  4,  0,
     & 254,0.228D0,100,  9,  4, 10,  4,  0,
     & 254,0.012D0,100,  9,  2, 10,  4,  0,
     & 254,0.012D0,100,  7,  4, 10,  4,  0,
     & 254,0.076D0,100, 10,  2,  7,  4,  0,
     & 254,0.076D0,100, 10,  4,  9,  4,  0,
     & 254,0.004D0,100, 10,  2,  9,  4,  0,
     & 254,0.004D0,100, 10,  4,  7,  4,  0,
     & 265,1.000D0,  0,221, 59,  0,  0,  0,
     & 266,1.000D0,  0,222, 59,  0,  0,  0,
     & 267,1.000D0,  0,223, 59,  0,  0,  0,
     & 268,0.667D0,  0,266, 38,  0,  0,  0,
     & 268,0.333D0,  0,265, 21,  0,  0,  0,
     & 269,0.667D0,  0,265, 30,  0,  0,  0,
     & 269,0.333D0,  0,266, 21,  0,  0,  0,
     & 270,0.500D0,  0,265, 50,  0,  0,  0,
     & 270,0.500D0,  0,266, 46,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1692,1710)/
     & 271,0.290D0,  0,266, 38,  0,  0,  0,
     & 271,0.150D0,  0,265, 21,  0,  0,  0,
     & 271,0.290D0,  0,222, 38,  0,  0,  0,
     & 271,0.150D0,  0,221, 21,  0,  0,  0,
     & 271,0.060D0,  0,266, 38, 21,  0,  0,
     & 271,0.020D0,  0,265, 38, 30,  0,  0,
     & 271,0.010D0,  0,265, 21, 21,  0,  0,
     & 271,0.020D0,  0,222, 38, 21,  0,  0,
     & 271,0.010D0,  0,221, 38, 30,  0,  0,
     & 272,0.290D0,  0,265, 30,  0,  0,  0,
     & 272,0.150D0,  0,266, 21,  0,  0,  0,
     & 272,0.290D0,  0,221, 30,  0,  0,  0,
     & 272,0.150D0,  0,222, 21,  0,  0,  0,
     & 272,0.060D0,  0,265, 30, 21,  0,  0,
     & 272,0.020D0,  0,266, 38, 30,  0,  0,
     & 272,0.010D0,  0,266, 21, 21,  0,  0,
     & 272,0.020D0,  0,221, 30, 21,  0,  0,
     & 272,0.010D0,  0,222, 38, 30,  0,  0,
     & 273,0.350D0,  0,221, 50,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1711,1729)/
     & 273,0.350D0,  0,222, 46,  0,  0,  0,
     & 273,0.150D0,  0,265, 50,  0,  0,  0,
     & 273,0.150D0,  0,266, 46,  0,  0,  0,
     & 274,1.000D0,  0,245, 59,  0,  0,  0,
     & 275,1.000D0,  0,246, 59,  0,  0,  0,
     & 276,1.000D0,  0,247, 59,  0,  0,  0,
     & 277,0.667D0,  0,275, 30,  0,  0,  0,
     & 277,0.333D0,  0,274, 21,  0,  0,  0,
     & 278,0.667D0,  0,274, 38,  0,  0,  0,
     & 278,0.333D0,  0,275, 21,  0,  0,  0,
     & 279,0.500D0,  0,274, 42,  0,  0,  0,
     & 279,0.500D0,  0,275, 34,  0,  0,  0,
     & 280,0.290D0,  0,275, 30,  0,  0,  0,
     & 280,0.150D0,  0,274, 21,  0,  0,  0,
     & 280,0.290D0,  0,246, 30,  0,  0,  0,
     & 280,0.150D0,  0,245, 21,  0,  0,  0,
     & 280,0.060D0,  0,275, 30, 21,  0,  0,
     & 280,0.020D0,  0,274, 38, 30,  0,  0,
     & 280,0.010D0,  0,274, 21, 21,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1730,1748)/
     & 280,0.020D0,  0,246, 30, 21,  0,  0,
     & 280,0.010D0,  0,245, 38, 30,  0,  0,
     & 281,0.290D0,  0,274, 38,  0,  0,  0,
     & 281,0.150D0,  0,275, 21,  0,  0,  0,
     & 281,0.290D0,  0,245, 38,  0,  0,  0,
     & 281,0.150D0,  0,246, 21,  0,  0,  0,
     & 281,0.060D0,  0,274, 38, 21,  0,  0,
     & 281,0.020D0,  0,275, 38, 30,  0,  0,
     & 281,0.010D0,  0,275, 21, 21,  0,  0,
     & 281,0.020D0,  0,245, 38, 21,  0,  0,
     & 281,0.010D0,  0,246, 38, 30,  0,  0,
     & 282,0.350D0,  0,245, 42,  0,  0,  0,
     & 282,0.350D0,  0,246, 34,  0,  0,  0,
     & 282,0.150D0,  0,274, 42,  0,  0,  0,
     & 282,0.150D0,  0,275, 34,  0,  0,  0,
     & 285,1.000D0,  0, 24, 21,  0,  0,  0,
     & 286,0.998D0,  0, 24, 38,  0,  0,  0,
     & 286,0.002D0,  0, 38, 59,  0,  0,  0,
     & 287,0.998D0,  0, 24, 30,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1749,1767)/
     & 287,0.002D0,  0, 30, 59,  0,  0,  0,
     & 288,0.330D0,  0, 39, 30,  0,  0,  0,
     & 288,0.340D0,  0, 23, 21,  0,  0,  0,
     & 288,0.330D0,  0, 31, 38,  0,  0,  0,
     & 289,0.250D0,  0, 46, 35,  0,  0,  0,
     & 289,0.250D0,  0, 34, 47,  0,  0,  0,
     & 289,0.250D0,  0, 50, 43,  0,  0,  0,
     & 289,0.250D0,  0, 42, 51,  0,  0,  0,
     & 290,0.996D0,  0, 22, 21,  0,  0,  0,
     & 290,0.002D0,  0, 46, 34,  0,  0,  0,
     & 290,0.002D0,  0, 50, 42,  0,  0,  0,
     & 291,0.996D0,  0, 22, 38,  0,  0,  0,
     & 291,0.004D0,  0, 46, 42,  0,  0,  0,
     & 292,0.996D0,  0, 22, 30,  0,  0,  0,
     & 292,0.004D0,  0, 50, 34,  0,  0,  0,
     & 293,0.520D0,  0, 38, 30,  0,  0,  0,
     & 293,0.260D0,  0, 21, 21,  0,  0,  0,
     & 293,0.110D0,  0, 46, 34,  0,  0,  0,
     & 293,0.110D0,  0, 50, 42,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1768,1786)/
     & 294,0.620D0,  0, 38, 30,  0,  0,  0,
     & 294,0.310D0,  0, 21, 21,  0,  0,  0,
     & 294,0.035D0,  0, 46, 34,  0,  0,  0,
     & 294,0.035D0,  0, 50, 42,  0,  0,  0,
     & 295,1.000D0,  0,254, 59,  0,  0,  0,
     & 296,1.000D0,  0,230, 59,  0,  0,  0,
     & 297,1.000D0,  0,254, 59,  0,  0,  0,
     & 298,1.000D0,  0,230, 59,  0,  0,  0,
     & 299,1.000D0,  0,254, 59,  0,  0,  0,
     & 300,1.000D0,  0,230, 59,  0,  0,  0,
     & 301,0.050D0,  0,121,127,  0,  0,  0,
     & 301,0.050D0,  0,123,129,  0,  0,  0,
     & 301,0.017D0,  0,  1,  7,  0,  0,  0,
     & 301,0.066D0,  0,  2,  8,  0,  0,  0,
     & 301,0.017D0,  0,  3,  9,  0,  0,  0,
     & 301,0.640D0,130, 13, 13, 13,  0,  0,
     & 301,0.160D0,130, 13, 13, 59,  0,  0,
     & 302,0.022D0,  0, 38, 30, 38, 30, 23,
     & 302,0.016D0,  0, 38, 30, 38, 30,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1787,1805)/
     & 302,0.009D0,  0, 38, 30, 46, 34,  0,
     & 302,0.004D0,  0, 23, 38, 30,  0,  0,
     & 302,0.002D0,  0, 46, 43, 30,  0,  0,
     & 302,0.002D0,  0, 34, 51, 38,  0,  0,
     & 302,0.001D0,  0, 38, 30, 73, 91,  0,
     & 302,0.273D0,  0, 59,164,  0,  0,  0,
     & 302,0.671D0,  0, 13, 13,  0,  0,  0,
     & 303,0.022D0,  0, 38, 30, 38, 30,  0,
     & 303,0.019D0,  0, 38, 30, 46, 34,  0,
     & 303,0.012D0,  0, 38, 30, 38, 30, 23,
     & 303,0.007D0,  0, 23, 38, 30,  0,  0,
     & 303,0.002D0,  0, 46, 43, 30,  0,  0,
     & 303,0.002D0,  0, 34, 51, 38,  0,  0,
     & 303,0.003D0,  0, 38, 30, 73, 91,  0,
     & 303,0.002D0,  0, 38, 30,  0,  0,  0,
     & 303,0.002D0,  0, 46, 34,  0,  0,  0,
     & 303,0.001D0,  0, 21, 21,  0,  0,  0,
     & 303,0.135D0,  0, 59,164,  0,  0,  0,
     & 303,0.793D0,  0, 13, 13,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1806,1824)/
     & 304,1.000D0,  0, 13, 13,  0,  0,  0,
     & 305,1.000D0,  0, 13, 13,  0,  0,  0,
     & 306,0.050D0,  0, 59,231,  0,  0,  0,
     & 306,0.950D0,  0, 13, 13,  0,  0,  0,
     & 307,0.350D0,  0, 59,231,  0,  0,  0,
     & 307,0.650D0,  0, 13, 13,  0,  0,  0,
     & 308,0.220D0,  0, 59,231,  0,  0,  0,
     & 308,0.780D0,  0, 13, 13,  0,  0,  0,
     & 309,0.280D0,  0, 46, 31,  0,  0,  0,
     & 309,0.140D0,  0, 50, 23,  0,  0,  0,
     & 309,0.187D0,  0,327, 30,  0,  0,  0,
     & 309,0.093D0,  0,328, 21,  0,  0,  0,
     & 309,0.110D0,  0, 50, 24,  0,  0,  0,
     & 309,0.107D0,  0, 47, 30,  0,  0,  0,
     & 309,0.053D0,  0, 51, 21,  0,  0,  0,
     & 309,0.030D0,  0, 50,293,  0,  0,  0,
     & 310,0.280D0,  0, 50, 39,  0,  0,  0,
     & 310,0.140D0,  0, 46, 23,  0,  0,  0,
     & 310,0.187D0,  0,328, 38,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1825,1843)/
     & 310,0.093D0,  0,327, 21,  0,  0,  0,
     & 310,0.110D0,  0, 46, 24,  0,  0,  0,
     & 310,0.107D0,  0, 51, 38,  0,  0,  0,
     & 310,0.053D0,  0, 47, 21,  0,  0,  0,
     & 310,0.030D0,  0, 46,293,  0,  0,  0,
     & 311,0.280D0,  0, 34, 39,  0,  0,  0,
     & 311,0.140D0,  0, 42, 23,  0,  0,  0,
     & 311,0.187D0,  0,330, 38,  0,  0,  0,
     & 311,0.093D0,  0,329, 21,  0,  0,  0,
     & 311,0.110D0,  0, 42, 24,  0,  0,  0,
     & 311,0.107D0,  0, 35, 38,  0,  0,  0,
     & 311,0.053D0,  0, 43, 21,  0,  0,  0,
     & 311,0.030D0,  0, 42,293,  0,  0,  0,
     & 312,0.280D0,  0, 42, 31,  0,  0,  0,
     & 312,0.140D0,  0, 34, 23,  0,  0,  0,
     & 312,0.187D0,  0,329, 30,  0,  0,  0,
     & 312,0.093D0,  0,330, 21,  0,  0,  0,
     & 312,0.110D0,  0, 34, 24,  0,  0,  0,
     & 312,0.107D0,  0, 43, 30,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1844,1862)/
     & 312,0.053D0,  0, 35, 21,  0,  0,  0,
     & 312,0.030D0,  0, 34,293,  0,  0,  0,
     & 313,0.430D0,  0,140, 38,  0,  0,  0,
     & 313,0.215D0,  0,136, 21,  0,  0,  0,
     & 313,0.235D0,  0,140, 38, 21,  0,  0,
     & 313,0.120D0,  0,136, 38, 30,  0,  0,
     & 314,0.430D0,  0,136, 30,  0,  0,  0,
     & 314,0.215D0,  0,140, 21,  0,  0,  0,
     & 314,0.235D0,  0,136, 30, 21,  0,  0,
     & 314,0.120D0,  0,140, 38, 30,  0,  0,
     & 315,0.480D0,  0,136, 50,  0,  0,  0,
     & 315,0.480D0,  0,140, 46,  0,  0,  0,
     & 315,0.040D0,  0,145, 59,  0,  0,  0,
     & 316,0.430D0,  0,175, 30,  0,  0,  0,
     & 316,0.215D0,  0,171, 21,  0,  0,  0,
     & 316,0.235D0,  0,175, 30, 21,  0,  0,
     & 316,0.120D0,  0,171, 38, 30,  0,  0,
     & 317,0.430D0,  0,171, 38,  0,  0,  0,
     & 317,0.215D0,  0,175, 21,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1863,1881)/
     & 317,0.235D0,  0,171, 38, 21,  0,  0,
     & 317,0.120D0,  0,175, 38, 30,  0,  0,
     & 318,0.480D0,  0,171, 42,  0,  0,  0,
     & 318,0.480D0,  0,175, 34,  0,  0,  0,
     & 318,0.040D0,  0,180, 59,  0,  0,  0,
     & 319,0.540D0,  0,275, 30,  0,  0,  0,
     & 319,0.270D0,  0,274, 21,  0,  0,  0,
     & 319,0.030D0,  0,275, 30, 21,  0,  0,
     & 319,0.010D0,  0,274, 38, 30,  0,  0,
     & 319,0.010D0,  0,274, 21, 21,  0,  0,
     & 319,0.090D0,  0,246, 30, 21,  0,  0,
     & 319,0.030D0,  0,245, 38, 30,  0,  0,
     & 319,0.020D0,  0,245, 21, 21,  0,  0,
     & 320,0.540D0,  0,274, 38,  0,  0,  0,
     & 320,0.270D0,  0,275, 21,  0,  0,  0,
     & 320,0.030D0,  0,274, 38, 21,  0,  0,
     & 320,0.010D0,  0,275, 38, 30,  0,  0,
     & 320,0.010D0,  0,275, 21, 21,  0,  0,
     & 320,0.090D0,  0,245, 38, 21,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1882,1900)/
     & 320,0.030D0,  0,246, 38, 30,  0,  0,
     & 320,0.020D0,  0,246, 21, 21,  0,  0,
     & 321,0.500D0,  0,266, 46,  0,  0,  0,
     & 321,0.500D0,  0,265, 50,  0,  0,  0,
     & 322,1.000D0,  0,254, 59,  0,  0,  0,
     & 323,0.540D0,  0,266, 38,  0,  0,  0,
     & 323,0.270D0,  0,265, 21,  0,  0,  0,
     & 323,0.030D0,  0,266, 38, 21,  0,  0,
     & 323,0.010D0,  0,265, 38, 30,  0,  0,
     & 323,0.010D0,  0,265, 21, 21,  0,  0,
     & 323,0.090D0,  0,222, 38, 21,  0,  0,
     & 323,0.030D0,  0,221, 38, 30,  0,  0,
     & 323,0.020D0,  0,221, 21, 21,  0,  0,
     & 324,0.540D0,  0,265, 30,  0,  0,  0,
     & 324,0.270D0,  0,266, 21,  0,  0,  0,
     & 324,0.030D0,  0,265, 30, 21,  0,  0,
     & 324,0.010D0,  0,266, 38, 30,  0,  0,
     & 324,0.010D0,  0,266, 21, 21,  0,  0,
     & 324,0.090D0,  0,221, 30, 21,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1901,1919)/
     & 324,0.030D0,  0,222, 38, 30,  0,  0,
     & 324,0.020D0,  0,222, 21, 21,  0,  0,
     & 325,0.500D0,  0,275, 34,  0,  0,  0,
     & 325,0.500D0,  0,274, 42,  0,  0,  0,
     & 326,1.000D0,  0,230, 59,  0,  0,  0,
     & 327,0.667D0,  0, 50, 38,  0,  0,  0,
     & 327,0.333D0,  0, 46, 21,  0,  0,  0,
     & 328,0.667D0,  0, 46, 30,  0,  0,  0,
     & 328,0.333D0,  0, 50, 21,  0,  0,  0,
     & 329,0.667D0,  0, 34, 38,  0,  0,  0,
     & 329,0.333D0,  0, 42, 21,  0,  0,  0,
     & 330,0.667D0,  0, 42, 30,  0,  0,  0,
     & 330,0.333D0,  0, 34, 21,  0,  0,  0,
     & 331,0.667D0,  0,140, 38,  0,  0,  0,
     & 331,0.333D0,  0,136, 21,  0,  0,  0,
     & 332,0.667D0,  0,136, 30,  0,  0,  0,
     & 332,0.333D0,  0,140, 21,  0,  0,  0,
     & 333,0.500D0,  0,136, 50,  0,  0,  0,
     & 333,0.500D0,  0,140, 46,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1920,1938)/
     & 334,0.667D0,  0,175, 30,  0,  0,  0,
     & 334,0.333D0,  0,171, 21,  0,  0,  0,
     & 335,0.667D0,  0,171, 38,  0,  0,  0,
     & 335,0.333D0,  0,175, 21,  0,  0,  0,
     & 336,0.500D0,  0,171, 42,  0,  0,  0,
     & 336,0.500D0,  0,175, 34,  0,  0,  0,
     & 337,0.667D0,  0,246, 30,  0,  0,  0,
     & 337,0.333D0,  0,245, 21,  0,  0,  0,
     & 338,0.667D0,  0,245, 38,  0,  0,  0,
     & 338,0.333D0,  0,246, 21,  0,  0,  0,
     & 339,0.500D0,  0,246, 34,  0,  0,  0,
     & 339,0.500D0,  0,245, 42,  0,  0,  0,
     & 340,1.000D0,  0,254, 59,  0,  0,  0,
     & 341,0.667D0,  0,222, 38,  0,  0,  0,
     & 341,0.333D0,  0,221, 21,  0,  0,  0,
     & 342,0.667D0,  0,221, 30,  0,  0,  0,
     & 342,0.333D0,  0,222, 21,  0,  0,  0,
     & 343,0.500D0,  0,222, 46,  0,  0,  0,
     & 343,0.500D0,  0,221, 50,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1939,1957)/
     & 344,1.000D0,  0,230, 59,  0,  0,  0,
     & 345,1.000D0,  0,225, 30,  0,  0,  0,
     & 346,1.000D0,  0,225, 21,  0,  0,  0,
     & 347,1.000D0,  0,225, 21,  0,  0,  0,
     & 348,1.000D0,  0,225, 38,  0,  0,  0,
     & 349,0.600D0,  0,228, 38,  0,  0,  0,
     & 349,0.300D0,  0,227, 21,  0,  0,  0,
     & 349,0.100D0,  0,227, 59,  0,  0,  0,
     & 350,0.600D0,  0,228, 38,  0,  0,  0,
     & 350,0.300D0,  0,227, 21,  0,  0,  0,
     & 350,0.100D0,  0,227, 59,  0,  0,  0,
     & 351,0.600D0,  0,227, 30,  0,  0,  0,
     & 351,0.300D0,  0,228, 21,  0,  0,  0,
     & 351,0.100D0,  0,228, 59,  0,  0,  0,
     & 352,0.600D0,  0,227, 30,  0,  0,  0,
     & 352,0.300D0,  0,228, 21,  0,  0,  0,
     & 352,0.100D0,  0,228, 59,  0,  0,  0,
     & 353,1.000D0,  0,229, 59,  0,  0,  0,
     & 354,1.000D0,  0,249, 38,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1958,1976)/
     & 355,1.000D0,  0,249, 21,  0,  0,  0,
     & 356,1.000D0,  0,249, 21,  0,  0,  0,
     & 357,1.000D0,  0,249, 30,  0,  0,  0,
     & 358,0.600D0,  0,252, 30,  0,  0,  0,
     & 358,0.300D0,  0,251, 21,  0,  0,  0,
     & 358,0.100D0,  0,251, 59,  0,  0,  0,
     & 359,0.600D0,  0,252, 30,  0,  0,  0,
     & 359,0.300D0,  0,251, 21,  0,  0,  0,
     & 359,0.100D0,  0,251, 59,  0,  0,  0,
     & 360,0.600D0,  0,251, 38,  0,  0,  0,
     & 360,0.300D0,  0,252, 21,  0,  0,  0,
     & 360,0.100D0,  0,252, 59,  0,  0,  0,
     & 361,0.600D0,  0,251, 38,  0,  0,  0,
     & 361,0.300D0,  0,252, 21,  0,  0,  0,
     & 361,0.100D0,  0,252, 59,  0,  0,  0,
     & 362,1.000D0,  0,253, 59,  0,  0,  0,
     & 363,0.400D0,  0, 53, 38,  0,  0,  0,
     & 363,0.200D0,  0, 49, 21,  0,  0,  0,
     & 363,0.100D0,  0, 51, 38,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1977,1995)/
     & 363,0.050D0,  0, 47, 21,  0,  0,  0,
     & 363,0.150D0,  0, 46, 26,  0,  0,  0,
     & 363,0.050D0,  0, 46, 56,  0,  0,  0,
     & 363,0.050D0,  0, 46, 24,  0,  0,  0,
     & 364,0.400D0,  0, 49, 30,  0,  0,  0,
     & 364,0.200D0,  0, 53, 21,  0,  0,  0,
     & 364,0.100D0,  0, 47, 30,  0,  0,  0,
     & 364,0.050D0,  0, 51, 21,  0,  0,  0,
     & 364,0.150D0,  0, 50, 26,  0,  0,  0,
     & 364,0.050D0,  0, 50, 56,  0,  0,  0,
     & 364,0.050D0,  0, 50, 24,  0,  0,  0,
     & 365,0.400D0,  0, 37, 38,  0,  0,  0,
     & 365,0.200D0,  0, 45, 21,  0,  0,  0,
     & 365,0.100D0,  0, 35, 38,  0,  0,  0,
     & 365,0.050D0,  0, 43, 21,  0,  0,  0,
     & 365,0.150D0,  0, 42, 26,  0,  0,  0,
     & 365,0.050D0,  0, 42, 56,  0,  0,  0,
     & 365,0.050D0,  0, 42, 24,  0,  0,  0,
     & 366,0.400D0,  0, 45, 30,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=1996,2014)/
     & 366,0.200D0,  0, 37, 21,  0,  0,  0,
     & 366,0.100D0,  0, 43, 30,  0,  0,  0,
     & 366,0.050D0,  0, 35, 21,  0,  0,  0,
     & 366,0.150D0,  0, 34, 26,  0,  0,  0,
     & 366,0.050D0,  0, 34, 56,  0,  0,  0,
     & 366,0.050D0,  0, 34, 24,  0,  0,  0,
     & 367,0.258D0,  0, 50, 38,  0,  0,  0,
     & 367,0.129D0,  0, 46, 21,  0,  0,  0,
     & 367,0.209D0,  0, 50, 39,  0,  0,  0,
     & 367,0.105D0,  0, 46, 23,  0,  0,  0,
     & 367,0.199D0,  0, 51, 38,  0,  0,  0,
     & 367,0.100D0,  0, 47, 21,  0,  0,  0,
     & 368,0.258D0,  0, 46, 30,  0,  0,  0,
     & 368,0.129D0,  0, 50, 21,  0,  0,  0,
     & 368,0.209D0,  0, 46, 31,  0,  0,  0,
     & 368,0.105D0,  0, 50, 23,  0,  0,  0,
     & 368,0.199D0,  0, 47, 30,  0,  0,  0,
     & 368,0.100D0,  0, 51, 21,  0,  0,  0,
     & 369,0.258D0,  0, 34, 38,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=2015,2033)/
     & 369,0.129D0,  0, 42, 21,  0,  0,  0,
     & 369,0.209D0,  0, 34, 39,  0,  0,  0,
     & 369,0.105D0,  0, 42, 23,  0,  0,  0,
     & 369,0.199D0,  0, 35, 38,  0,  0,  0,
     & 369,0.100D0,  0, 43, 21,  0,  0,  0,
     & 370,0.258D0,  0, 42, 30,  0,  0,  0,
     & 370,0.129D0,  0, 34, 21,  0,  0,  0,
     & 370,0.209D0,  0, 42, 31,  0,  0,  0,
     & 370,0.105D0,  0, 34, 23,  0,  0,  0,
     & 370,0.199D0,  0, 43, 30,  0,  0,  0,
     & 370,0.100D0,  0, 35, 21,  0,  0,  0,
     & 371,0.400D0,  0, 53, 38,  0,  0,  0,
     & 371,0.200D0,  0, 49, 21,  0,  0,  0,
     & 371,0.100D0,  0, 51, 38,  0,  0,  0,
     & 371,0.050D0,  0, 47, 21,  0,  0,  0,
     & 371,0.150D0,  0, 46, 26,  0,  0,  0,
     & 371,0.050D0,  0, 46, 56,  0,  0,  0,
     & 371,0.050D0,  0, 46, 24,  0,  0,  0,
     & 372,0.400D0,  0, 49, 30,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=2034,2052)/
     & 372,0.200D0,  0, 53, 21,  0,  0,  0,
     & 372,0.100D0,  0, 47, 30,  0,  0,  0,
     & 372,0.050D0,  0, 51, 21,  0,  0,  0,
     & 372,0.150D0,  0, 50, 26,  0,  0,  0,
     & 372,0.050D0,  0, 50, 56,  0,  0,  0,
     & 372,0.050D0,  0, 50, 24,  0,  0,  0,
     & 373,0.400D0,  0, 37, 38,  0,  0,  0,
     & 373,0.200D0,  0, 45, 21,  0,  0,  0,
     & 373,0.100D0,  0, 35, 38,  0,  0,  0,
     & 373,0.050D0,  0, 43, 21,  0,  0,  0,
     & 373,0.150D0,  0, 42, 26,  0,  0,  0,
     & 373,0.050D0,  0, 42, 56,  0,  0,  0,
     & 373,0.050D0,  0, 42, 24,  0,  0,  0,
     & 374,0.400D0,  0, 45, 30,  0,  0,  0,
     & 374,0.200D0,  0, 37, 21,  0,  0,  0,
     & 374,0.100D0,  0, 43, 30,  0,  0,  0,
     & 374,0.050D0,  0, 35, 21,  0,  0,  0,
     & 374,0.150D0,  0, 34, 26,  0,  0,  0,
     & 374,0.050D0,  0, 34, 56,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=2053,2071)/
     & 374,0.050D0,  0, 34, 24,  0,  0,  0,
     & 375,0.208D0,  0, 50, 39,  0,  0,  0,
     & 375,0.104D0,  0, 46, 23,  0,  0,  0,
     & 375,0.134D0,  0, 51, 38,  0,  0,  0,
     & 375,0.067D0,  0, 47, 21,  0,  0,  0,
     & 375,0.124D0,  0, 50, 38,  0,  0,  0,
     & 375,0.062D0,  0, 46, 21,  0,  0,  0,
     & 375,0.301D0,  0, 46, 22,  0,  0,  0,
     & 376,0.208D0,  0, 46, 31,  0,  0,  0,
     & 376,0.104D0,  0, 50, 23,  0,  0,  0,
     & 376,0.134D0,  0, 47, 30,  0,  0,  0,
     & 376,0.067D0,  0, 51, 21,  0,  0,  0,
     & 376,0.124D0,  0, 46, 30,  0,  0,  0,
     & 376,0.062D0,  0, 50, 21,  0,  0,  0,
     & 376,0.301D0,  0, 50, 22,  0,  0,  0,
     & 377,0.208D0,  0, 34, 39,  0,  0,  0,
     & 377,0.104D0,  0, 42, 23,  0,  0,  0,
     & 377,0.134D0,  0, 35, 38,  0,  0,  0,
     & 377,0.067D0,  0, 43, 21,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=2072,2090)/
     & 377,0.124D0,  0, 34, 38,  0,  0,  0,
     & 377,0.062D0,  0, 42, 21,  0,  0,  0,
     & 377,0.301D0,  0, 42, 22,  0,  0,  0,
     & 378,0.208D0,  0, 42, 31,  0,  0,  0,
     & 378,0.104D0,  0, 34, 23,  0,  0,  0,
     & 378,0.134D0,  0, 43, 30,  0,  0,  0,
     & 378,0.067D0,  0, 35, 21,  0,  0,  0,
     & 378,0.124D0,  0, 42, 30,  0,  0,  0,
     & 378,0.062D0,  0, 34, 21,  0,  0,  0,
     & 378,0.301D0,  0, 34, 22,  0,  0,  0,
     & 379,0.562D0,  0, 26, 38,  0,  0,  0,
     & 379,0.155D0,  0, 39, 21,  0,  0,  0,
     & 379,0.155D0,  0, 23, 38,  0,  0,  0,
     & 379,0.088D0,  0,293, 38,  0,  0,  0,
     & 379,0.020D0,  0, 46, 43,  0,  0,  0,
     & 379,0.020D0,  0, 42, 47,  0,  0,  0,
     & 380,0.562D0,  0, 26, 21,  0,  0,  0,
     & 380,0.155D0,  0, 39, 30,  0,  0,  0,
     & 380,0.155D0,  0, 31, 38,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=2091,2109)/
     & 380,0.088D0,  0,293, 21,  0,  0,  0,
     & 380,0.010D0,  0, 46, 35,  0,  0,  0,
     & 380,0.010D0,  0, 50, 43,  0,  0,  0,
     & 380,0.010D0,  0, 34, 47,  0,  0,  0,
     & 380,0.010D0,  0, 42, 51,  0,  0,  0,
     & 381,0.562D0,  0, 26, 30,  0,  0,  0,
     & 381,0.155D0,  0, 31, 21,  0,  0,  0,
     & 381,0.155D0,  0, 23, 30,  0,  0,  0,
     & 381,0.088D0,  0,293, 30,  0,  0,  0,
     & 381,0.020D0,  0, 34, 51,  0,  0,  0,
     & 381,0.020D0,  0, 50, 35,  0,  0,  0,
     & 382,0.360D0,  0, 31, 38, 38,  0,  0,
     & 382,0.180D0,  0, 23, 38, 21,  0,  0,
     & 382,0.040D0,  0, 39, 21, 21,  0,  0,
     & 382,0.020D0,  0, 39, 38, 30,  0,  0,
     & 382,0.300D0,  0, 38, 21,  0,  0,  0,
     & 382,0.040D0,  0, 46, 43,  0,  0,  0,
     & 382,0.040D0,  0, 42, 47,  0,  0,  0,
     & 382,0.020D0,  0, 22, 39,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=2110,2128)/
     & 383,0.180D0,  0, 39, 30, 21,  0,  0,
     & 383,0.180D0,  0, 31, 38, 21,  0,  0,
     & 383,0.160D0,  0, 23, 21, 21,  0,  0,
     & 383,0.080D0,  0, 23, 38, 30,  0,  0,
     & 383,0.300D0,  0, 38, 30,  0,  0,  0,
     & 383,0.020D0,  0, 46, 35,  0,  0,  0,
     & 383,0.020D0,  0, 50, 43,  0,  0,  0,
     & 383,0.020D0,  0, 34, 47,  0,  0,  0,
     & 383,0.020D0,  0, 42, 51,  0,  0,  0,
     & 383,0.020D0,  0, 22, 23,  0,  0,  0,
     & 384,0.360D0,  0, 39, 30, 30,  0,  0,
     & 384,0.180D0,  0, 23, 30, 21,  0,  0,
     & 384,0.040D0,  0, 31, 21, 21,  0,  0,
     & 384,0.020D0,  0, 31, 30, 38,  0,  0,
     & 384,0.300D0,  0, 30, 21,  0,  0,  0,
     & 384,0.040D0,  0, 34, 51,  0,  0,  0,
     & 384,0.040D0,  0, 50, 35,  0,  0,  0,
     & 384,0.020D0,  0, 22, 31,  0,  0,  0,
     & 385,0.184D0,  0, 41, 21,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=2129,2147)/
     & 385,0.184D0,  0, 29, 38,  0,  0,  0,
     & 385,0.184D0,  0, 39, 23,  0,  0,  0,
     & 385,0.236D0,  0, 38, 21,  0,  0,  0,
     & 385,0.160D0,  0, 24, 38,  0,  0,  0,
     & 385,0.018D0,  0, 46, 43,  0,  0,  0,
     & 385,0.018D0,  0, 42, 47,  0,  0,  0,
     & 385,0.016D0,  0, 46, 42,  0,  0,  0,
     & 386,0.184D0,  0, 41, 30,  0,  0,  0,
     & 386,0.184D0,  0, 33, 38,  0,  0,  0,
     & 386,0.184D0,  0, 39, 31,  0,  0,  0,
     & 386,0.236D0,  0, 38, 30,  0,  0,  0,
     & 386,0.160D0,  0, 24, 21,  0,  0,  0,
     & 386,0.009D0,  0, 46, 35,  0,  0,  0,
     & 386,0.009D0,  0, 50, 43,  0,  0,  0,
     & 386,0.009D0,  0, 34, 47,  0,  0,  0,
     & 386,0.009D0,  0, 42, 51,  0,  0,  0,
     & 386,0.008D0,  0, 46, 34,  0,  0,  0,
     & 386,0.008D0,  0, 42, 50,  0,  0,  0,
     & 387,0.184D0,  0, 33, 21,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=2148,2166)/
     & 387,0.184D0,  0, 29, 30,  0,  0,  0,
     & 387,0.184D0,  0, 31, 23,  0,  0,  0,
     & 387,0.236D0,  0, 30, 21,  0,  0,  0,
     & 387,0.160D0,  0, 24, 30,  0,  0,  0,
     & 387,0.018D0,  0, 34, 51,  0,  0,  0,
     & 387,0.018D0,  0, 50, 35,  0,  0,  0,
     & 387,0.016D0,  0, 34, 50,  0,  0,  0,
     & 388,0.183D0,  0,231, 38, 30,  0,  0,
     & 388,0.091D0,  0,231, 21, 21,  0,  0,
     & 388,0.067D0,  0, 59,307,  0,  0,  0,
     & 388,0.066D0,  0, 59,308,  0,  0,  0,
     & 388,0.043D0,  0, 59,309,  0,  0,  0,
     & 388,0.446D0,130, 13, 13, 13,  0,  0,
     & 388,0.023D0,130, 13, 13, 59,  0,  0,
     & 388,0.013D0,  0,121,127,  0,  0,  0,
     & 388,0.013D0,  0,123,129,  0,  0,  0,
     & 388,0.013D0,  0,125,131,  0,  0,  0,
     & 388,0.004D0,  0,  1,  7,  0,  0,  0,
     & 388,0.017D0,  0,  2,  8,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=2167,2185)/
     & 388,0.004D0,  0,  3,  9,  0,  0,  0,
     & 388,0.017D0,  0,  4, 10,  0,  0,  0,
     & 389,0.046D0,  0, 59,388,  0,  0,  0,
     & 389,0.009D0,  0, 59,231,  0,  0,  0,
     & 389,0.755D0,  0, 13, 13,  0,  0,  0,
     & 389,0.030D0,  0,121,127,  0,  0,  0,
     & 389,0.030D0,  0,123,129,  0,  0,  0,
     & 389,0.030D0,  0,125,131,  0,  0,  0,
     & 389,0.010D0,  0,  1,  7,  0,  0,  0,
     & 389,0.040D0,  0,  2,  8,  0,  0,  0,
     & 389,0.010D0,  0,  3,  9,  0,  0,  0,
     & 389,0.040D0,  0,  4, 10,  0,  0,  0,
     & 390,0.210D0,  0, 59,388,  0,  0,  0,
     & 390,0.085D0,  0, 59,231,  0,  0,  0,
     & 390,0.565D0,  0, 13, 13,  0,  0,  0,
     & 390,0.022D0,  0,121,127,  0,  0,  0,
     & 390,0.022D0,  0,123,129,  0,  0,  0,
     & 390,0.022D0,  0,125,131,  0,  0,  0,
     & 390,0.007D0,  0,  1,  7,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=2186,2204)/
     & 390,0.030D0,  0,  2,  8,  0,  0,  0,
     & 390,0.007D0,  0,  3,  9,  0,  0,  0,
     & 390,0.030D0,  0,  4, 10,  0,  0,  0,
     & 391,0.162D0,  0, 59,388,  0,  0,  0,
     & 391,0.071D0,  0, 59,231,  0,  0,  0,
     & 391,0.615D0,  0, 13, 13,  0,  0,  0,
     & 391,0.024D0,  0,121,127,  0,  0,  0,
     & 391,0.024D0,  0,123,129,  0,  0,  0,
     & 391,0.024D0,  0,125,131,  0,  0,  0,
     & 391,0.008D0,  0,  1,  7,  0,  0,  0,
     & 391,0.032D0,  0,  2,  8,  0,  0,  0,
     & 391,0.008D0,  0,  3,  9,  0,  0,  0,
     & 391,0.032D0,  0,  4, 10,  0,  0,  0,
     & 392,0.034D0,  0,267, 38, 30,  0,  0,
     & 392,0.017D0,  0,267, 21, 21,  0,  0,
     & 392,0.044D0,  0,231, 38, 30,  0,  0,
     & 392,0.022D0,  0,231, 21, 21,  0,  0,
     & 392,0.050D0,  0,267, 59, 59,  0,  0,
     & 392,0.114D0,  0, 59,389,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=2205,2223)/
     & 392,0.113D0,  0, 59,390,  0,  0,  0,
     & 392,0.054D0,  0, 59,391,  0,  0,  0,
     & 392,0.403D0,130, 13, 13, 13,  0,  0,
     & 392,0.021D0,130, 13, 13, 59,  0,  0,
     & 392,0.020D0,  0,121,127,  0,  0,  0,
     & 392,0.020D0,  0,123,129,  0,  0,  0,
     & 392,0.020D0,  0,125,131,  0,  0,  0,
     & 392,0.007D0,  0,  1,  7,  0,  0,  0,
     & 392,0.027D0,  0,  2,  8,  0,  0,  0,
     & 392,0.007D0,  0,  3,  9,  0,  0,  0,
     & 392,0.027D0,  0,  4, 10,  0,  0,  0,
     & 393,0.250D0,  0,246,222,  0,  0,  0,
     & 393,0.250D0,  0,245,221,  0,  0,  0,
     & 393,0.385D0,130, 13, 13, 13,  0,  0,
     & 393,0.020D0,130, 13, 13, 59,  0,  0,
     & 393,0.015D0,  0,121,127,  0,  0,  0,
     & 393,0.015D0,  0,123,129,  0,  0,  0,
     & 393,0.015D0,  0,125,131,  0,  0,  0,
     & 393,0.005D0,  0,  1,  7,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=2224,2242)/
     & 393,0.020D0,  0,  2,  8,  0,  0,  0,
     & 393,0.005D0,  0,  3,  9,  0,  0,  0,
     & 393,0.020D0,  0,  4, 10,  0,  0,  0,
     & 395,0.195D0,  0, 39, 30,  0,  0,  0,
     & 395,0.195D0,  0, 23, 21,  0,  0,  0,
     & 395,0.195D0,  0, 31, 38,  0,  0,  0,
     & 395,0.105D0,  0,286, 30,  0,  0,  0,
     & 395,0.105D0,  0,285, 21,  0,  0,  0,
     & 395,0.105D0,  0,287, 38,  0,  0,  0,
     & 395,0.065D0,  0, 24, 38, 30,  0,  0,
     & 395,0.035D0,  0, 24, 21, 21,  0,  0,
     & 396,0.320D0,  0, 46, 34,  0,  0,  0,
     & 396,0.320D0,  0, 60, 61,  0,  0,  0,
     & 396,0.090D0,  0, 46, 35,  0,  0,  0,
     & 396,0.090D0,  0, 42, 51,  0,  0,  0,
     & 396,0.090D0,  0, 50, 43,  0,  0,  0,
     & 396,0.090D0,  0, 34, 47,  0,  0,  0,
     & 397,0.312D0,  0, 41, 30,  0,  0,  0,
     & 397,0.312D0,  0, 29, 21,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=2243,2261)/
     & 397,0.312D0,  0, 33, 38,  0,  0,  0,
     & 397,0.016D0,  0, 46, 35,  0,  0,  0,
     & 397,0.016D0,  0, 42, 51,  0,  0,  0,
     & 397,0.016D0,  0, 50, 43,  0,  0,  0,
     & 397,0.016D0,  0, 34, 47,  0,  0,  0,
     & 398,0.805D0,  0, 26, 22,  0,  0,  0,
     & 398,0.065D0,  0, 41, 30,  0,  0,  0,
     & 398,0.065D0,  0, 29, 21,  0,  0,  0,
     & 398,0.065D0,  0, 33, 38,  0,  0,  0,
     & 399,0.667D0,  0, 24, 38, 30,  0,  0,
     & 399,0.333D0,  0, 24, 21, 21,  0,  0,
     &  62,0.440D0,  0, 21, 22,  0,  0,  0,
     &  62,0.160D0,  0, 21, 25,  0,  0,  0,
     &  62,0.200D0,  0, 50, 42,  0,  0,  0,
     &  62,0.200D0,  0, 46, 34,  0,  0,  0,
     &  63,0.440D0,  0, 38, 22,  0,  0,  0,
     &  63,0.160D0,  0, 38, 25,  0,  0,  0,
     &  63,0.400D0,  0, 46, 42,  0,  0,  0,
     &  64,0.440D0,  0, 30, 22,  0,  0,  0/
      DATA (IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5),I=2262,2263)/
     &  64,0.160D0,  0, 30, 25,  0,  0,  0,
     &  64,0.400D0,  0, 50, 34,  0,  0,  0/
C--data for MRST98 LO PDF's
      DATA (FMRS(1,1,I, 1),I=1,49)/
     &     0.01518D0,  0.01868D0,  0.02298D0,  0.02594D0,  0.02828D0,
     &     0.03023D0,  0.03724D0,  0.04592D0,  0.05197D0,  0.05679D0,
     &     0.06085D0,  0.07576D0,  0.09547D0,  0.11035D0,  0.12307D0,
     &     0.13453D0,  0.15525D0,  0.18319D0,  0.22542D0,  0.26441D0,
     &     0.33553D0,  0.39881D0,  0.45451D0,  0.51363D0,  0.56120D0,
     &     0.59755D0,  0.62324D0,  0.63889D0,  0.64529D0,  0.64295D0,
     &     0.63335D0,  0.61691D0,  0.59464D0,  0.56748D0,  0.53621D0,
     &     0.50180D0,  0.46495D0,  0.42660D0,  0.38735D0,  0.34791D0,
     &     0.30888D0,  0.27105D0,  0.23455D0,  0.16807D0,  0.11197D0,
     &     0.06774D0,  0.03566D0,  0.00443D0,  0.00000D0/
      DATA (FMRS(1,1,I, 2),I=1,49)/
     &     0.01534D0,  0.01889D0,  0.02325D0,  0.02625D0,  0.02862D0,
     &     0.03061D0,  0.03771D0,  0.04653D0,  0.05268D0,  0.05757D0,
     &     0.06171D0,  0.07691D0,  0.09707D0,  0.11230D0,  0.12533D0,
     &     0.13708D0,  0.15827D0,  0.18678D0,  0.22968D0,  0.26907D0,
     &     0.34038D0,  0.40321D0,  0.45801D0,  0.51556D0,  0.56122D0,
     &     0.59551D0,  0.61905D0,  0.63261D0,  0.63699D0,  0.63286D0,
     &     0.62162D0,  0.60381D0,  0.58043D0,  0.55244D0,  0.52060D0,
     &     0.48591D0,  0.44902D0,  0.41090D0,  0.37213D0,  0.33332D0,
     &     0.29514D0,  0.25827D0,  0.22283D0,  0.15873D0,  0.10506D0,
     &     0.06310D0,  0.03294D0,  0.00399D0,  0.00000D0/
      DATA (FMRS(1,1,I, 3),I=1,49)/
     &     0.01559D0,  0.01920D0,  0.02365D0,  0.02672D0,  0.02914D0,
     &     0.03116D0,  0.03842D0,  0.04744D0,  0.05374D0,  0.05876D0,
     &     0.06301D0,  0.07866D0,  0.09949D0,  0.11525D0,  0.12874D0,
     &     0.14090D0,  0.16278D0,  0.19212D0,  0.23598D0,  0.27589D0,
     &     0.34735D0,  0.40941D0,  0.46279D0,  0.51792D0,  0.56073D0,
     &     0.59195D0,  0.61237D0,  0.62289D0,  0.62439D0,  0.61773D0,
     &     0.60419D0,  0.58448D0,  0.55962D0,  0.53052D0,  0.49799D0,
     &     0.46298D0,  0.42617D0,  0.38844D0,  0.35048D0,  0.31268D0,
     &     0.27573D0,  0.24031D0,  0.20643D0,  0.14575D0,  0.09554D0,
     &     0.05679D0,  0.02927D0,  0.00342D0,  0.00000D0/
      DATA (FMRS(1,1,I, 4),I=1,49)/
     &     0.01577D0,  0.01944D0,  0.02395D0,  0.02707D0,  0.02952D0,
     &     0.03158D0,  0.03895D0,  0.04812D0,  0.05453D0,  0.05964D0,
     &     0.06398D0,  0.07996D0,  0.10128D0,  0.11743D0,  0.13126D0,
     &     0.14371D0,  0.16610D0,  0.19602D0,  0.24052D0,  0.28078D0,
     &     0.35225D0,  0.41367D0,  0.46596D0,  0.51926D0,  0.56000D0,
     &     0.58897D0,  0.60716D0,  0.61554D0,  0.61505D0,  0.60661D0,
     &     0.59150D0,  0.57049D0,  0.54465D0,  0.51484D0,  0.48194D0,
     &     0.44680D0,  0.41012D0,  0.37271D0,  0.33536D0,  0.29833D0,
     &     0.26227D0,  0.22791D0,  0.19519D0,  0.13692D0,  0.08913D0,
     &     0.05257D0,  0.02685D0,  0.00306D0,  0.00000D0/
      DATA (FMRS(1,1,I, 5),I=1,49)/
     &     0.01597D0,  0.01969D0,  0.02427D0,  0.02744D0,  0.02993D0,
     &     0.03202D0,  0.03952D0,  0.04885D0,  0.05537D0,  0.06058D0,
     &     0.06501D0,  0.08134D0,  0.10319D0,  0.11975D0,  0.13393D0,
     &     0.14669D0,  0.16958D0,  0.20009D0,  0.24521D0,  0.28578D0,
     &     0.35715D0,  0.41781D0,  0.46887D0,  0.52022D0,  0.55877D0,
     &     0.58539D0,  0.60126D0,  0.60744D0,  0.60489D0,  0.59469D0,
     &     0.57807D0,  0.55581D0,  0.52903D0,  0.49861D0,  0.46535D0,
     &     0.43012D0,  0.39368D0,  0.35672D0,  0.32002D0,  0.28380D0,
     &     0.24878D0,  0.21549D0,  0.18398D0,  0.12819D0,  0.08284D0,
     &     0.04845D0,  0.02451D0,  0.00272D0,  0.00000D0/
      DATA (FMRS(1,1,I, 6),I=1,49)/
     &     0.01613D0,  0.01990D0,  0.02455D0,  0.02776D0,  0.03029D0,
     &     0.03241D0,  0.04001D0,  0.04949D0,  0.05611D0,  0.06141D0,
     &     0.06592D0,  0.08256D0,  0.10485D0,  0.12178D0,  0.13626D0,
     &     0.14927D0,  0.17260D0,  0.20361D0,  0.24924D0,  0.29005D0,
     &     0.36128D0,  0.42124D0,  0.47121D0,  0.52086D0,  0.55750D0,
     &     0.58213D0,  0.59603D0,  0.60035D0,  0.59612D0,  0.58445D0,
     &     0.56659D0,  0.54334D0,  0.51581D0,  0.48493D0,  0.45142D0,
     &     0.41618D0,  0.37998D0,  0.34345D0,  0.30732D0,  0.27182D0,
     &     0.23768D0,  0.20532D0,  0.17482D0,  0.12110D0,  0.07777D0,
     &     0.04515D0,  0.02267D0,  0.00245D0,  0.00000D0/
      DATA (FMRS(1,1,I, 7),I=1,49)/
     &     0.01630D0,  0.02011D0,  0.02482D0,  0.02807D0,  0.03063D0,
     &     0.03278D0,  0.04049D0,  0.05010D0,  0.05683D0,  0.06221D0,
     &     0.06680D0,  0.08373D0,  0.10647D0,  0.12373D0,  0.13849D0,
     &     0.15175D0,  0.17549D0,  0.20695D0,  0.25304D0,  0.29403D0,
     &     0.36506D0,  0.42430D0,  0.47319D0,  0.52118D0,  0.55597D0,
     &     0.57870D0,  0.59079D0,  0.59337D0,  0.58760D0,  0.57458D0,
     &     0.55556D0,  0.53145D0,  0.50329D0,  0.47196D0,  0.43832D0,
     &     0.40316D0,  0.36719D0,  0.33110D0,  0.29555D0,  0.26076D0,
     &     0.22742D0,  0.19600D0,  0.16642D0,  0.11467D0,  0.07318D0,
     &     0.04221D0,  0.02103D0,  0.00223D0,  0.00000D0/
      DATA (FMRS(1,1,I, 8),I=1,49)/
     &     0.01647D0,  0.02033D0,  0.02511D0,  0.02840D0,  0.03100D0,
     &     0.03318D0,  0.04101D0,  0.05076D0,  0.05760D0,  0.06307D0,
     &     0.06774D0,  0.08499D0,  0.10819D0,  0.12581D0,  0.14088D0,
     &     0.15440D0,  0.17856D0,  0.21047D0,  0.25702D0,  0.29817D0,
     &     0.36893D0,  0.42735D0,  0.47507D0,  0.52128D0,  0.55411D0,
     &     0.57487D0,  0.58505D0,  0.58586D0,  0.57850D0,  0.56412D0,
     &     0.54397D0,  0.51898D0,  0.49021D0,  0.45851D0,  0.42474D0,
     &     0.38970D0,  0.35404D0,  0.31842D0,  0.28351D0,  0.24949D0,
     &     0.21700D0,  0.18654D0,  0.15795D0,  0.10821D0,  0.06861D0,
     &     0.03930D0,  0.01942D0,  0.00201D0,  0.00000D0/
      DATA (FMRS(1,1,I, 9),I=1,49)/
     &     0.01662D0,  0.02053D0,  0.02536D0,  0.02869D0,  0.03133D0,
     &     0.03353D0,  0.04146D0,  0.05135D0,  0.05828D0,  0.06382D0,
     &     0.06856D0,  0.08610D0,  0.10971D0,  0.12764D0,  0.14296D0,
     &     0.15670D0,  0.18121D0,  0.21352D0,  0.26045D0,  0.30172D0,
     &     0.37220D0,  0.42986D0,  0.47655D0,  0.52120D0,  0.55234D0,
     &     0.57141D0,  0.57995D0,  0.57927D0,  0.57058D0,  0.55506D0,
     &     0.53402D0,  0.50830D0,  0.47904D0,  0.44709D0,  0.41323D0,
     &     0.37832D0,  0.34296D0,  0.30776D0,  0.27344D0,  0.24008D0,
     &     0.20833D0,  0.17868D0,  0.15093D0,  0.10287D0,  0.06487D0,
     &     0.03693D0,  0.01812D0,  0.00183D0,  0.00000D0/
      DATA (FMRS(1,1,I,10),I=1,49)/
     &     0.01676D0,  0.02072D0,  0.02560D0,  0.02898D0,  0.03164D0,
     &     0.03388D0,  0.04190D0,  0.05191D0,  0.05894D0,  0.06456D0,
     &     0.06937D0,  0.08718D0,  0.11117D0,  0.12940D0,  0.14497D0,
     &     0.15892D0,  0.18377D0,  0.21643D0,  0.26368D0,  0.30503D0,
     &     0.37520D0,  0.43209D0,  0.47774D0,  0.52089D0,  0.55041D0,
     &     0.56787D0,  0.57486D0,  0.57280D0,  0.56285D0,  0.54631D0,
     &     0.52442D0,  0.49810D0,  0.46842D0,  0.43624D0,  0.40236D0,
     &     0.36762D0,  0.33255D0,  0.29778D0,  0.26402D0,  0.23132D0,
     &     0.20029D0,  0.17139D0,  0.14445D0,  0.09798D0,  0.06147D0,
     &     0.03479D0,  0.01695D0,  0.00168D0,  0.00000D0/
      DATA (FMRS(1,1,I,11),I=1,49)/
     &     0.01688D0,  0.02087D0,  0.02580D0,  0.02920D0,  0.03189D0,
     &     0.03415D0,  0.04225D0,  0.05236D0,  0.05946D0,  0.06515D0,
     &     0.07001D0,  0.08804D0,  0.11234D0,  0.13081D0,  0.14657D0,
     &     0.16068D0,  0.18579D0,  0.21873D0,  0.26622D0,  0.30762D0,
     &     0.37751D0,  0.43378D0,  0.47859D0,  0.52054D0,  0.54880D0,
     &     0.56500D0,  0.57079D0,  0.56765D0,  0.55675D0,  0.53942D0,
     &     0.51689D0,  0.49012D0,  0.46015D0,  0.42782D0,  0.39393D0,
     &     0.35936D0,  0.32453D0,  0.29009D0,  0.25678D0,  0.22461D0,
     &     0.19416D0,  0.16583D0,  0.13951D0,  0.09427D0,  0.05892D0,
     &     0.03318D0,  0.01609D0,  0.00157D0,  0.00000D0/
      DATA (FMRS(1,1,I,12),I=1,49)/
     &     0.01713D0,  0.02119D0,  0.02622D0,  0.02969D0,  0.03243D0,
     &     0.03474D0,  0.04300D0,  0.05334D0,  0.06060D0,  0.06641D0,
     &     0.07140D0,  0.08989D0,  0.11485D0,  0.13381D0,  0.14997D0,
     &     0.16442D0,  0.19008D0,  0.22357D0,  0.27152D0,  0.31299D0,
     &     0.38219D0,  0.43708D0,  0.48008D0,  0.51946D0,  0.54505D0,
     &     0.55859D0,  0.56192D0,  0.55654D0,  0.54370D0,  0.52483D0,
     &     0.50100D0,  0.47335D0,  0.44283D0,  0.41025D0,  0.37649D0,
     &     0.34225D0,  0.30799D0,  0.27433D0,  0.24202D0,  0.21092D0,
     &     0.18167D0,  0.15459D0,  0.12954D0,  0.08683D0,  0.05380D0,
     &     0.03001D0,  0.01438D0,  0.00136D0,  0.00000D0/
      DATA (FMRS(1,1,I,13),I=1,49)/
     &     0.01734D0,  0.02147D0,  0.02658D0,  0.03011D0,  0.03290D0,
     &     0.03525D0,  0.04366D0,  0.05419D0,  0.06158D0,  0.06752D0,
     &     0.07261D0,  0.09150D0,  0.11703D0,  0.13641D0,  0.15292D0,
     &     0.16765D0,  0.19375D0,  0.22769D0,  0.27599D0,  0.31747D0,
     &     0.38599D0,  0.43964D0,  0.48105D0,  0.51822D0,  0.54152D0,
     &     0.55284D0,  0.55412D0,  0.54689D0,  0.53251D0,  0.51240D0,
     &     0.48756D0,  0.45925D0,  0.42833D0,  0.39563D0,  0.36202D0,
     &     0.32809D0,  0.29438D0,  0.26143D0,  0.22998D0,  0.19977D0,
     &     0.17155D0,  0.14553D0,  0.12155D0,  0.08091D0,  0.04976D0,
     &     0.02753D0,  0.01306D0,  0.00120D0,  0.00000D0/
      DATA (FMRS(1,1,I,14),I=1,49)/
     &     0.01759D0,  0.02179D0,  0.02699D0,  0.03059D0,  0.03343D0,
     &     0.03582D0,  0.04441D0,  0.05515D0,  0.06270D0,  0.06876D0,
     &     0.07397D0,  0.09331D0,  0.11948D0,  0.13933D0,  0.15621D0,
     &     0.17125D0,  0.19782D0,  0.23224D0,  0.28086D0,  0.32228D0,
     &     0.38998D0,  0.44216D0,  0.48181D0,  0.51649D0,  0.53727D0,
     &     0.54619D0,  0.54525D0,  0.53606D0,  0.52007D0,  0.49864D0,
     &     0.47286D0,  0.44390D0,  0.41261D0,  0.37987D0,  0.34645D0,
     &     0.31295D0,  0.27985D0,  0.24773D0,  0.21718D0,  0.18802D0,
     &     0.16091D0,  0.13605D0,  0.11323D0,  0.07479D0,  0.04562D0,
     &     0.02500D0,  0.01174D0,  0.00105D0,  0.00000D0/
      DATA (FMRS(1,1,I,15),I=1,49)/
     &     0.01784D0,  0.02212D0,  0.02742D0,  0.03109D0,  0.03399D0,
     &     0.03643D0,  0.04519D0,  0.05616D0,  0.06388D0,  0.07007D0,
     &     0.07541D0,  0.09522D0,  0.12203D0,  0.14235D0,  0.15961D0,
     &     0.17496D0,  0.20199D0,  0.23684D0,  0.28574D0,  0.32703D0,
     &     0.39374D0,  0.44435D0,  0.48208D0,  0.51422D0,  0.53243D0,
     &     0.53888D0,  0.53581D0,  0.52470D0,  0.50714D0,  0.48444D0,
     &     0.45778D0,  0.42824D0,  0.39670D0,  0.36400D0,  0.33079D0,
     &     0.29784D0,  0.26546D0,  0.23422D0,  0.20462D0,  0.17657D0,
     &     0.15056D0,  0.12684D0,  0.10517D0,  0.06893D0,  0.04169D0,
     &     0.02264D0,  0.01051D0,  0.00091D0,  0.00000D0/
      DATA (FMRS(1,1,I,16),I=1,49)/
     &     0.01807D0,  0.02243D0,  0.02782D0,  0.03155D0,  0.03450D0,
     &     0.03698D0,  0.04591D0,  0.05708D0,  0.06495D0,  0.07127D0,
     &     0.07672D0,  0.09696D0,  0.12435D0,  0.14510D0,  0.16268D0,
     &     0.17830D0,  0.20573D0,  0.24094D0,  0.29002D0,  0.33115D0,
     &     0.39689D0,  0.44603D0,  0.48202D0,  0.51185D0,  0.52778D0,
     &     0.53213D0,  0.52713D0,  0.51440D0,  0.49550D0,  0.47182D0,
     &     0.44444D0,  0.41444D0,  0.38277D0,  0.35014D0,  0.31726D0,
     &     0.28479D0,  0.25306D0,  0.22258D0,  0.19389D0,  0.16682D0,
     &     0.14175D0,  0.11905D0,  0.09839D0,  0.06403D0,  0.03844D0,
     &     0.02069D0,  0.00951D0,  0.00080D0,  0.00000D0/
      DATA (FMRS(1,1,I,17),I=1,49)/
     &     0.01831D0,  0.02273D0,  0.02822D0,  0.03202D0,  0.03502D0,
     &     0.03755D0,  0.04663D0,  0.05802D0,  0.06604D0,  0.07249D0,
     &     0.07805D0,  0.09872D0,  0.12670D0,  0.14787D0,  0.16578D0,
     &     0.18165D0,  0.20947D0,  0.24500D0,  0.29423D0,  0.33515D0,
     &     0.39986D0,  0.44747D0,  0.48171D0,  0.50924D0,  0.52291D0,
     &     0.52522D0,  0.51836D0,  0.50409D0,  0.48395D0,  0.45934D0,
     &     0.43132D0,  0.40095D0,  0.36919D0,  0.33668D0,  0.30419D0,
     &     0.27223D0,  0.24118D0,  0.21147D0,  0.18368D0,  0.15756D0,
     &     0.13343D0,  0.11172D0,  0.09203D0,  0.05947D0,  0.03543D0,
     &     0.01891D0,  0.00861D0,  0.00070D0,  0.00000D0/
      DATA (FMRS(1,1,I,18),I=1,49)/
     &     0.01851D0,  0.02299D0,  0.02855D0,  0.03241D0,  0.03546D0,
     &     0.03802D0,  0.04724D0,  0.05881D0,  0.06696D0,  0.07351D0,
     &     0.07917D0,  0.10019D0,  0.12865D0,  0.15015D0,  0.16833D0,
     &     0.18440D0,  0.21252D0,  0.24831D0,  0.29761D0,  0.33832D0,
     &     0.40212D0,  0.44845D0,  0.48121D0,  0.50687D0,  0.51871D0,
     &     0.51934D0,  0.51104D0,  0.49556D0,  0.47446D0,  0.44911D0,
     &     0.42066D0,  0.39005D0,  0.35822D0,  0.32587D0,  0.29370D0,
     &     0.26224D0,  0.23174D0,  0.20270D0,  0.17561D0,  0.15023D0,
     &     0.12693D0,  0.10599D0,  0.08707D0,  0.05595D0,  0.03312D0,
     &     0.01756D0,  0.00793D0,  0.00063D0,  0.00000D0/
      DATA (FMRS(1,1,I,19),I=1,49)/
     &     0.01875D0,  0.02330D0,  0.02896D0,  0.03288D0,  0.03599D0,
     &     0.03859D0,  0.04798D0,  0.05977D0,  0.06807D0,  0.07475D0,
     &     0.08052D0,  0.10198D0,  0.13101D0,  0.15292D0,  0.17139D0,
     &     0.18771D0,  0.21617D0,  0.25222D0,  0.30155D0,  0.34198D0,
     &     0.40461D0,  0.44935D0,  0.48033D0,  0.50374D0,  0.51343D0,
     &     0.51210D0,  0.50212D0,  0.48526D0,  0.46307D0,  0.43693D0,
     &     0.40797D0,  0.37715D0,  0.34533D0,  0.31321D0,  0.28148D0,
     &     0.25058D0,  0.22080D0,  0.19255D0,  0.16635D0,  0.14187D0,
     &     0.11948D0,  0.09946D0,  0.08142D0,  0.05198D0,  0.03054D0,
     &     0.01606D0,  0.00718D0,  0.00056D0,  0.00000D0/
      DATA (FMRS(1,1,I,20),I=1,49)/
     &     0.01896D0,  0.02358D0,  0.02932D0,  0.03331D0,  0.03646D0,
     &     0.03911D0,  0.04864D0,  0.06062D0,  0.06906D0,  0.07585D0,
     &     0.08173D0,  0.10357D0,  0.13310D0,  0.15536D0,  0.17410D0,
     &     0.19062D0,  0.21937D0,  0.25563D0,  0.30495D0,  0.34510D0,
     &     0.40666D0,  0.44998D0,  0.47941D0,  0.50085D0,  0.50868D0,
     &     0.50571D0,  0.49430D0,  0.47628D0,  0.45320D0,  0.42642D0,
     &     0.39707D0,  0.36611D0,  0.33435D0,  0.30245D0,  0.27113D0,
     &     0.24074D0,  0.21159D0,  0.18404D0,  0.15862D0,  0.13491D0,
     &     0.11330D0,  0.09405D0,  0.07676D0,  0.04872D0,  0.02844D0,
     &     0.01484D0,  0.00658D0,  0.00050D0,  0.00000D0/
      DATA (FMRS(1,1,I,21),I=1,49)/
     &     0.01916D0,  0.02384D0,  0.02966D0,  0.03370D0,  0.03689D0,
     &     0.03958D0,  0.04926D0,  0.06141D0,  0.06998D0,  0.07687D0,
     &     0.08284D0,  0.10503D0,  0.13502D0,  0.15758D0,  0.17655D0,
     &     0.19325D0,  0.22223D0,  0.25866D0,  0.30794D0,  0.34779D0,
     &     0.40831D0,  0.45032D0,  0.47832D0,  0.49795D0,  0.50413D0,
     &     0.49968D0,  0.48705D0,  0.46802D0,  0.44417D0,  0.41690D0,
     &     0.38723D0,  0.35619D0,  0.32452D0,  0.29287D0,  0.26194D0,
     &     0.23205D0,  0.20344D0,  0.17655D0,  0.15180D0,  0.12880D0,
     &     0.10792D0,  0.08934D0,  0.07273D0,  0.04591D0,  0.02665D0,
     &     0.01381D0,  0.00607D0,  0.00045D0,  0.00000D0/
      DATA (FMRS(1,1,I,22),I=1,49)/
     &     0.01941D0,  0.02417D0,  0.03009D0,  0.03420D0,  0.03745D0,
     &     0.04018D0,  0.05003D0,  0.06241D0,  0.07114D0,  0.07817D0,
     &     0.08426D0,  0.10688D0,  0.13744D0,  0.16039D0,  0.17965D0,
     &     0.19656D0,  0.22582D0,  0.26244D0,  0.31163D0,  0.35107D0,
     &     0.41025D0,  0.45056D0,  0.47676D0,  0.49416D0,  0.49829D0,
     &     0.49204D0,  0.47792D0,  0.45768D0,  0.43295D0,  0.40511D0,
     &     0.37512D0,  0.34401D0,  0.31250D0,  0.28120D0,  0.25076D0,
     &     0.22150D0,  0.19361D0,  0.16754D0,  0.14361D0,  0.12149D0,
     &     0.10149D0,  0.08376D0,  0.06796D0,  0.04260D0,  0.02455D0,
     &     0.01262D0,  0.00549D0,  0.00039D0,  0.00000D0/
      DATA (FMRS(1,1,I,23),I=1,49)/
     &     0.01965D0,  0.02448D0,  0.03049D0,  0.03467D0,  0.03797D0,
     &     0.04075D0,  0.05077D0,  0.06336D0,  0.07225D0,  0.07940D0,
     &     0.08560D0,  0.10863D0,  0.13972D0,  0.16302D0,  0.18254D0,
     &     0.19964D0,  0.22916D0,  0.26592D0,  0.31498D0,  0.35400D0,
     &     0.41189D0,  0.45060D0,  0.47511D0,  0.49045D0,  0.49274D0,
     &     0.48487D0,  0.46938D0,  0.44808D0,  0.42260D0,  0.39428D0,
     &     0.36409D0,  0.33294D0,  0.30164D0,  0.27069D0,  0.24070D0,
     &     0.21203D0,  0.18488D0,  0.15951D0,  0.13633D0,  0.11502D0,
     &     0.09581D0,  0.07887D0,  0.06380D0,  0.03974D0,  0.02273D0,
     &     0.01159D0,  0.00500D0,  0.00035D0,  0.00000D0/
      DATA (FMRS(1,1,I,24),I=1,49)/
     &     0.01987D0,  0.02478D0,  0.03088D0,  0.03511D0,  0.03847D0,
     &     0.04129D0,  0.05147D0,  0.06426D0,  0.07329D0,  0.08055D0,
     &     0.08686D0,  0.11027D0,  0.14184D0,  0.16546D0,  0.18521D0,
     &     0.20248D0,  0.23220D0,  0.26906D0,  0.31795D0,  0.35654D0,
     &     0.41317D0,  0.45035D0,  0.47330D0,  0.48677D0,  0.48734D0,
     &     0.47799D0,  0.46135D0,  0.43917D0,  0.41301D0,  0.38430D0,
     &     0.35392D0,  0.32282D0,  0.29171D0,  0.26113D0,  0.23164D0,
     &     0.20355D0,  0.17701D0,  0.15231D0,  0.12990D0,  0.10928D0,
     &     0.09079D0,  0.07455D0,  0.06012D0,  0.03723D0,  0.02116D0,
     &     0.01072D0,  0.00459D0,  0.00031D0,  0.00000D0/
      DATA (FMRS(1,1,I,25),I=1,49)/
     &     0.02010D0,  0.02507D0,  0.03126D0,  0.03556D0,  0.03897D0,
     &     0.04183D0,  0.05216D0,  0.06515D0,  0.07433D0,  0.08171D0,
     &     0.08812D0,  0.11191D0,  0.14397D0,  0.16790D0,  0.18786D0,
     &     0.20530D0,  0.23522D0,  0.27216D0,  0.32085D0,  0.35900D0,
     &     0.41434D0,  0.45001D0,  0.47142D0,  0.48304D0,  0.48197D0,
     &     0.47120D0,  0.45346D0,  0.43043D0,  0.40367D0,  0.37460D0,
     &     0.34407D0,  0.31306D0,  0.28215D0,  0.25197D0,  0.22296D0,
     &     0.19546D0,  0.16953D0,  0.14549D0,  0.12381D0,  0.10387D0,
     &     0.08608D0,  0.07049D0,  0.05669D0,  0.03490D0,  0.01971D0,
     &     0.00991D0,  0.00421D0,  0.00028D0,  0.00000D0/
      DATA (FMRS(1,1,I,26),I=1,49)/
     &     0.02032D0,  0.02536D0,  0.03164D0,  0.03600D0,  0.03946D0,
     &     0.04236D0,  0.05285D0,  0.06604D0,  0.07535D0,  0.08285D0,
     &     0.08936D0,  0.11352D0,  0.14603D0,  0.17026D0,  0.19043D0,
     &     0.20801D0,  0.23810D0,  0.27509D0,  0.32355D0,  0.36123D0,
     &     0.41527D0,  0.44945D0,  0.46936D0,  0.47919D0,  0.47657D0,
     &     0.46453D0,  0.44572D0,  0.42188D0,  0.39463D0,  0.36526D0,
     &     0.33462D0,  0.30373D0,  0.27307D0,  0.24328D0,  0.21472D0,
     &     0.18782D0,  0.16253D0,  0.13914D0,  0.11811D0,  0.09886D0,
     &     0.08171D0,  0.06673D0,  0.05353D0,  0.03277D0,  0.01840D0,
     &     0.00919D0,  0.00387D0,  0.00025D0,  0.00000D0/
      DATA (FMRS(1,1,I,27),I=1,49)/
     &     0.02054D0,  0.02564D0,  0.03200D0,  0.03642D0,  0.03992D0,
     &     0.04287D0,  0.05350D0,  0.06688D0,  0.07633D0,  0.08394D0,
     &     0.09053D0,  0.11504D0,  0.14798D0,  0.17249D0,  0.19284D0,
     &     0.21055D0,  0.24079D0,  0.27781D0,  0.32602D0,  0.36325D0,
     &     0.41604D0,  0.44883D0,  0.46732D0,  0.47551D0,  0.47145D0,
     &     0.45823D0,  0.43846D0,  0.41392D0,  0.38625D0,  0.35664D0,
     &     0.32595D0,  0.29518D0,  0.26477D0,  0.23536D0,  0.20725D0,
     &     0.18088D0,  0.15618D0,  0.13340D0,  0.11297D0,  0.09435D0,
     &     0.07779D0,  0.06337D0,  0.05071D0,  0.03088D0,  0.01724D0,
     &     0.00855D0,  0.00357D0,  0.00023D0,  0.00000D0/
      DATA (FMRS(1,1,I,28),I=1,49)/
     &     0.02074D0,  0.02591D0,  0.03234D0,  0.03682D0,  0.04037D0,
     &     0.04335D0,  0.05412D0,  0.06768D0,  0.07725D0,  0.08496D0,
     &     0.09165D0,  0.11648D0,  0.14982D0,  0.17457D0,  0.19509D0,
     &     0.21292D0,  0.24327D0,  0.28031D0,  0.32827D0,  0.36504D0,
     &     0.41665D0,  0.44811D0,  0.46527D0,  0.47196D0,  0.46656D0,
     &     0.45228D0,  0.43165D0,  0.40650D0,  0.37846D0,  0.34867D0,
     &     0.31800D0,  0.28733D0,  0.25718D0,  0.22812D0,  0.20048D0,
     &     0.17458D0,  0.15043D0,  0.12823D0,  0.10834D0,  0.09029D0,
     &     0.07427D0,  0.06037D0,  0.04820D0,  0.02920D0,  0.01621D0,
     &     0.00800D0,  0.00332D0,  0.00021D0,  0.00000D0/
      DATA (FMRS(1,1,I,29),I=1,49)/
     &     0.02094D0,  0.02617D0,  0.03269D0,  0.03722D0,  0.04081D0,
     &     0.04383D0,  0.05475D0,  0.06848D0,  0.07818D0,  0.08599D0,
     &     0.09277D0,  0.11792D0,  0.15165D0,  0.17664D0,  0.19733D0,
     &     0.21527D0,  0.24574D0,  0.28277D0,  0.33045D0,  0.36674D0,
     &     0.41715D0,  0.44728D0,  0.46313D0,  0.46834D0,  0.46164D0,
     &     0.44631D0,  0.42488D0,  0.39917D0,  0.37077D0,  0.34082D0,
     &     0.31017D0,  0.27964D0,  0.24978D0,  0.22107D0,  0.19390D0,
     &     0.16849D0,  0.14488D0,  0.12325D0,  0.10390D0,  0.08640D0,
     &     0.07092D0,  0.05751D0,  0.04581D0,  0.02761D0,  0.01524D0,
     &     0.00748D0,  0.00308D0,  0.00019D0,  0.00000D0/
      DATA (FMRS(1,1,I,30),I=1,49)/
     &     0.02115D0,  0.02644D0,  0.03303D0,  0.03762D0,  0.04125D0,
     &     0.04431D0,  0.05536D0,  0.06927D0,  0.07910D0,  0.08701D0,
     &     0.09387D0,  0.11934D0,  0.15345D0,  0.17867D0,  0.19951D0,
     &     0.21755D0,  0.24811D0,  0.28512D0,  0.33251D0,  0.36831D0,
     &     0.41752D0,  0.44634D0,  0.46092D0,  0.46470D0,  0.45678D0,
     &     0.44042D0,  0.41827D0,  0.39206D0,  0.36329D0,  0.33323D0,
     &     0.30260D0,  0.27226D0,  0.24270D0,  0.21435D0,  0.18761D0,
     &     0.16271D0,  0.13963D0,  0.11853D0,  0.09974D0,  0.08276D0,
     &     0.06777D0,  0.05484D0,  0.04358D0,  0.02615D0,  0.01436D0,
     &     0.00700D0,  0.00286D0,  0.00017D0,  0.00000D0/
      DATA (FMRS(1,1,I,31),I=1,49)/
     &     0.02134D0,  0.02669D0,  0.03336D0,  0.03800D0,  0.04168D0,
     &     0.04477D0,  0.05595D0,  0.07003D0,  0.07997D0,  0.08798D0,
     &     0.09492D0,  0.12069D0,  0.15515D0,  0.18059D0,  0.20157D0,
     &     0.21970D0,  0.25034D0,  0.28732D0,  0.33440D0,  0.36974D0,
     &     0.41780D0,  0.44538D0,  0.45878D0,  0.46121D0,  0.45216D0,
     &     0.43488D0,  0.41206D0,  0.38539D0,  0.35634D0,  0.32619D0,
     &     0.29560D0,  0.26544D0,  0.23618D0,  0.20818D0,  0.18185D0,
     &     0.15743D0,  0.13483D0,  0.11423D0,  0.09594D0,  0.07945D0,
     &     0.06492D0,  0.05243D0,  0.04157D0,  0.02483D0,  0.01357D0,
     &     0.00658D0,  0.00267D0,  0.00016D0,  0.00000D0/
      DATA (FMRS(1,1,I,32),I=1,49)/
     &     0.02153D0,  0.02693D0,  0.03367D0,  0.03836D0,  0.04208D0,
     &     0.04521D0,  0.05651D0,  0.07075D0,  0.08080D0,  0.08890D0,
     &     0.09592D0,  0.12197D0,  0.15676D0,  0.18239D0,  0.20349D0,
     &     0.22170D0,  0.25240D0,  0.28933D0,  0.33609D0,  0.37098D0,
     &     0.41793D0,  0.44434D0,  0.45663D0,  0.45780D0,  0.44772D0,
     &     0.42965D0,  0.40618D0,  0.37910D0,  0.34986D0,  0.31963D0,
     &     0.28912D0,  0.25913D0,  0.23015D0,  0.20249D0,  0.17658D0,
     &     0.15257D0,  0.13044D0,  0.11030D0,  0.09247D0,  0.07643D0,
     &     0.06234D0,  0.05026D0,  0.03976D0,  0.02365D0,  0.01287D0,
     &     0.00620D0,  0.00250D0,  0.00014D0,  0.00000D0/
      DATA (FMRS(1,1,I,33),I=1,49)/
     &     0.02171D0,  0.02717D0,  0.03398D0,  0.03872D0,  0.04248D0,
     &     0.04565D0,  0.05708D0,  0.07147D0,  0.08164D0,  0.08983D0,
     &     0.09693D0,  0.12326D0,  0.15838D0,  0.18421D0,  0.20543D0,
     &     0.22371D0,  0.25448D0,  0.29136D0,  0.33779D0,  0.37222D0,
     &     0.41806D0,  0.44331D0,  0.45449D0,  0.45441D0,  0.44330D0,
     &     0.42446D0,  0.40038D0,  0.37291D0,  0.34349D0,  0.31319D0,
     &     0.28277D0,  0.25295D0,  0.22427D0,  0.19695D0,  0.17145D0,
     &     0.14785D0,  0.12618D0,  0.10650D0,  0.08912D0,  0.07353D0,
     &     0.05986D0,  0.04817D0,  0.03803D0,  0.02252D0,  0.01220D0,
     &     0.00585D0,  0.00235D0,  0.00013D0,  0.00000D0/
      DATA (FMRS(1,1,I,34),I=1,49)/
     &     0.02190D0,  0.02741D0,  0.03429D0,  0.03909D0,  0.04289D0,
     &     0.04609D0,  0.05764D0,  0.07219D0,  0.08247D0,  0.09075D0,
     &     0.09793D0,  0.12453D0,  0.15996D0,  0.18597D0,  0.20731D0,
     &     0.22565D0,  0.25646D0,  0.29325D0,  0.33935D0,  0.37330D0,
     &     0.41800D0,  0.44209D0,  0.45219D0,  0.45092D0,  0.43883D0,
     &     0.41923D0,  0.39461D0,  0.36679D0,  0.33718D0,  0.30687D0,
     &     0.27654D0,  0.24693D0,  0.21853D0,  0.19159D0,  0.16650D0,
     &     0.14332D0,  0.12207D0,  0.10288D0,  0.08593D0,  0.07076D0,
     &     0.05749D0,  0.04618D0,  0.03639D0,  0.02146D0,  0.01157D0,
     &     0.00552D0,  0.00220D0,  0.00012D0,  0.00000D0/
      DATA (FMRS(1,1,I,35),I=1,49)/
     &     0.02208D0,  0.02764D0,  0.03459D0,  0.03943D0,  0.04327D0,
     &     0.04650D0,  0.05818D0,  0.07288D0,  0.08327D0,  0.09162D0,
     &     0.09888D0,  0.12574D0,  0.16147D0,  0.18765D0,  0.20909D0,
     &     0.22750D0,  0.25834D0,  0.29505D0,  0.34083D0,  0.37432D0,
     &     0.41794D0,  0.44094D0,  0.45002D0,  0.44763D0,  0.43463D0,
     &     0.41432D0,  0.38921D0,  0.36108D0,  0.33130D0,  0.30099D0,
     &     0.27077D0,  0.24136D0,  0.21322D0,  0.18665D0,  0.16193D0,
     &     0.13915D0,  0.11830D0,  0.09955D0,  0.08301D0,  0.06823D0,
     &     0.05533D0,  0.04437D0,  0.03490D0,  0.02050D0,  0.01100D0,
     &     0.00523D0,  0.00207D0,  0.00011D0,  0.00000D0/
      DATA (FMRS(1,1,I,36),I=1,49)/
     &     0.02225D0,  0.02787D0,  0.03488D0,  0.03977D0,  0.04364D0,
     &     0.04690D0,  0.05869D0,  0.07354D0,  0.08402D0,  0.09246D0,
     &     0.09978D0,  0.12689D0,  0.16290D0,  0.18924D0,  0.21077D0,
     &     0.22923D0,  0.26010D0,  0.29672D0,  0.34217D0,  0.37521D0,
     &     0.41781D0,  0.43978D0,  0.44789D0,  0.44447D0,  0.43062D0,
     &     0.40968D0,  0.38412D0,  0.35571D0,  0.32579D0,  0.29550D0,
     &     0.26538D0,  0.23618D0,  0.20831D0,  0.18206D0,  0.15771D0,
     &     0.13531D0,  0.11485D0,  0.09649D0,  0.08034D0,  0.06592D0,
     &     0.05337D0,  0.04272D0,  0.03354D0,  0.01963D0,  0.01049D0,
     &     0.00496D0,  0.00196D0,  0.00011D0,  0.00000D0/
      DATA (FMRS(1,1,I,37),I=1,49)/
     &     0.02242D0,  0.02809D0,  0.03517D0,  0.04010D0,  0.04401D0,
     &     0.04731D0,  0.05921D0,  0.07420D0,  0.08479D0,  0.09331D0,
     &     0.10070D0,  0.12805D0,  0.16433D0,  0.19082D0,  0.21245D0,
     &     0.23095D0,  0.26184D0,  0.29836D0,  0.34345D0,  0.37604D0,
     &     0.41760D0,  0.43853D0,  0.44568D0,  0.44123D0,  0.42654D0,
     &     0.40499D0,  0.37899D0,  0.35034D0,  0.32029D0,  0.29001D0,
     &     0.26003D0,  0.23104D0,  0.20345D0,  0.17752D0,  0.15354D0,
     &     0.13153D0,  0.11147D0,  0.09348D0,  0.07771D0,  0.06366D0,
     &     0.05147D0,  0.04112D0,  0.03222D0,  0.01879D0,  0.01000D0,
     &     0.00471D0,  0.00185D0,  0.00010D0,  0.00000D0/
      DATA (FMRS(1,1,I,38),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,2,I, 1),I=1,49)/
     &     0.00513D0,  0.00648D0,  0.00818D0,  0.00938D0,  0.01034D0,
     &     0.01116D0,  0.01418D0,  0.01818D0,  0.02118D0,  0.02372D0,
     &     0.02613D0,  0.03576D0,  0.05040D0,  0.06228D0,  0.07266D0,
     &     0.08202D0,  0.09864D0,  0.12002D0,  0.14955D0,  0.17387D0,
     &     0.21184D0,  0.23954D0,  0.25956D0,  0.27606D0,  0.28502D0,
     &     0.28790D0,  0.28586D0,  0.27985D0,  0.27060D0,  0.25918D0,
     &     0.24535D0,  0.23028D0,  0.21416D0,  0.19735D0,  0.18044D0,
     &     0.16347D0,  0.14671D0,  0.13049D0,  0.11512D0,  0.10018D0,
     &     0.08630D0,  0.07360D0,  0.06172D0,  0.04171D0,  0.02610D0,
     &     0.01478D0,  0.00721D0,  0.00074D0,  0.00000D0/
      DATA (FMRS(1,2,I, 2),I=1,49)/
     &     0.00518D0,  0.00654D0,  0.00828D0,  0.00950D0,  0.01049D0,
     &     0.01133D0,  0.01443D0,  0.01854D0,  0.02162D0,  0.02423D0,
     &     0.02670D0,  0.03657D0,  0.05155D0,  0.06366D0,  0.07421D0,
     &     0.08371D0,  0.10052D0,  0.12206D0,  0.15163D0,  0.17583D0,
     &     0.21329D0,  0.24028D0,  0.25950D0,  0.27498D0,  0.28295D0,
     &     0.28491D0,  0.28206D0,  0.27535D0,  0.26555D0,  0.25365D0,
     &     0.23952D0,  0.22423D0,  0.20802D0,  0.19123D0,  0.17441D0,
     &     0.15763D0,  0.14114D0,  0.12520D0,  0.11019D0,  0.09565D0,
     &     0.08218D0,  0.06990D0,  0.05847D0,  0.03927D0,  0.02442D0,
     &     0.01373D0,  0.00665D0,  0.00066D0,  0.00000D0/
      DATA (FMRS(1,2,I, 3),I=1,49)/
     &     0.00524D0,  0.00664D0,  0.00843D0,  0.00970D0,  0.01072D0,
     &     0.01159D0,  0.01481D0,  0.01908D0,  0.02229D0,  0.02501D0,
     &     0.02757D0,  0.03781D0,  0.05328D0,  0.06572D0,  0.07653D0,
     &     0.08622D0,  0.10330D0,  0.12505D0,  0.15465D0,  0.17864D0,
     &     0.21528D0,  0.24119D0,  0.25922D0,  0.27320D0,  0.27971D0,
     &     0.28035D0,  0.27635D0,  0.26864D0,  0.25807D0,  0.24551D0,
     &     0.23101D0,  0.21544D0,  0.19911D0,  0.18240D0,  0.16578D0,
     &     0.14929D0,  0.13320D0,  0.11772D0,  0.10322D0,  0.08926D0,
     &     0.07639D0,  0.06473D0,  0.05394D0,  0.03591D0,  0.02212D0,
     &     0.01231D0,  0.00589D0,  0.00057D0,  0.00000D0/
      DATA (FMRS(1,2,I, 4),I=1,49)/
     &     0.00529D0,  0.00672D0,  0.00855D0,  0.00985D0,  0.01090D0,
     &     0.01179D0,  0.01510D0,  0.01949D0,  0.02279D0,  0.02558D0,
     &     0.02822D0,  0.03873D0,  0.05456D0,  0.06724D0,  0.07823D0,
     &     0.08806D0,  0.10532D0,  0.12720D0,  0.15680D0,  0.18061D0,
     &     0.21663D0,  0.24172D0,  0.25888D0,  0.27177D0,  0.27723D0,
     &     0.27696D0,  0.27213D0,  0.26373D0,  0.25262D0,  0.23966D0,
     &     0.22489D0,  0.20919D0,  0.19281D0,  0.17616D0,  0.15968D0,
     &     0.14345D0,  0.12763D0,  0.11250D0,  0.09838D0,  0.08485D0,
     &     0.07242D0,  0.06118D0,  0.05083D0,  0.03363D0,  0.02058D0,
     &     0.01136D0,  0.00539D0,  0.00050D0,  0.00000D0/
      DATA (FMRS(1,2,I, 5),I=1,49)/
     &     0.00534D0,  0.00680D0,  0.00868D0,  0.01001D0,  0.01108D0,
     &     0.01200D0,  0.01540D0,  0.01993D0,  0.02332D0,  0.02620D0,
     &     0.02891D0,  0.03971D0,  0.05590D0,  0.06884D0,  0.08000D0,
     &     0.08997D0,  0.10741D0,  0.12941D0,  0.15897D0,  0.18257D0,
     &     0.21790D0,  0.24212D0,  0.25836D0,  0.27010D0,  0.27446D0,
     &     0.27326D0,  0.26762D0,  0.25853D0,  0.24692D0,  0.23356D0,
     &     0.21851D0,  0.20270D0,  0.18633D0,  0.16975D0,  0.15345D0,
     &     0.13751D0,  0.12199D0,  0.10721D0,  0.09351D0,  0.08043D0,
     &     0.06843D0,  0.05765D0,  0.04775D0,  0.03138D0,  0.01907D0,
     &     0.01045D0,  0.00491D0,  0.00045D0,  0.00000D0/
      DATA (FMRS(1,2,I, 6),I=1,49)/
     &     0.00539D0,  0.00688D0,  0.00879D0,  0.01015D0,  0.01125D0,
     &     0.01219D0,  0.01567D0,  0.02031D0,  0.02379D0,  0.02674D0,
     &     0.02951D0,  0.04056D0,  0.05708D0,  0.07022D0,  0.08154D0,
     &     0.09162D0,  0.10921D0,  0.13130D0,  0.16082D0,  0.18422D0,
     &     0.21894D0,  0.24239D0,  0.25783D0,  0.26859D0,  0.27204D0,
     &     0.27005D0,  0.26373D0,  0.25409D0,  0.24206D0,  0.22838D0,
     &     0.21313D0,  0.19724D0,  0.18088D0,  0.16440D0,  0.14826D0,
     &     0.13257D0,  0.11731D0,  0.10284D0,  0.08950D0,  0.07679D0,
     &     0.06517D0,  0.05477D0,  0.04524D0,  0.02956D0,  0.01786D0,
     &     0.00972D0,  0.00453D0,  0.00040D0,  0.00000D0/
      DATA (FMRS(1,2,I, 7),I=1,49)/
     &     0.00544D0,  0.00695D0,  0.00890D0,  0.01029D0,  0.01141D0,
     &     0.01237D0,  0.01593D0,  0.02068D0,  0.02425D0,  0.02727D0,
     &     0.03010D0,  0.04138D0,  0.05820D0,  0.07155D0,  0.08301D0,
     &     0.09319D0,  0.11091D0,  0.13308D0,  0.16253D0,  0.18572D0,
     &     0.21983D0,  0.24255D0,  0.25721D0,  0.26706D0,  0.26966D0,
     &     0.26692D0,  0.25996D0,  0.24983D0,  0.23740D0,  0.22344D0,
     &     0.20806D0,  0.19209D0,  0.17575D0,  0.15940D0,  0.14342D0,
     &     0.12794D0,  0.11298D0,  0.09881D0,  0.08579D0,  0.07344D0,
     &     0.06219D0,  0.05213D0,  0.04295D0,  0.02791D0,  0.01677D0,
     &     0.00906D0,  0.00419D0,  0.00037D0,  0.00000D0/
      DATA (FMRS(1,2,I, 8),I=1,49)/
     &     0.00549D0,  0.00703D0,  0.00902D0,  0.01044D0,  0.01159D0,
     &     0.01257D0,  0.01622D0,  0.02109D0,  0.02474D0,  0.02783D0,
     &     0.03073D0,  0.04227D0,  0.05940D0,  0.07296D0,  0.08456D0,
     &     0.09485D0,  0.11270D0,  0.13493D0,  0.16429D0,  0.18726D0,
     &     0.22070D0,  0.24263D0,  0.25647D0,  0.26535D0,  0.26707D0,
     &     0.26357D0,  0.25596D0,  0.24532D0,  0.23250D0,  0.21829D0,
     &     0.20276D0,  0.18675D0,  0.17045D0,  0.15424D0,  0.13845D0,
     &     0.12321D0,  0.10855D0,  0.09470D0,  0.08203D0,  0.07005D0,
     &     0.05917D0,  0.04947D0,  0.04065D0,  0.02627D0,  0.01569D0,
     &     0.00842D0,  0.00386D0,  0.00033D0,  0.00000D0/
      DATA (FMRS(1,2,I, 9),I=1,49)/
     &     0.00553D0,  0.00711D0,  0.00913D0,  0.01057D0,  0.01174D0,
     &     0.01274D0,  0.01647D0,  0.02144D0,  0.02517D0,  0.02833D0,
     &     0.03129D0,  0.04304D0,  0.06045D0,  0.07418D0,  0.08591D0,
     &     0.09629D0,  0.11425D0,  0.13653D0,  0.16579D0,  0.18855D0,
     &     0.22139D0,  0.24264D0,  0.25577D0,  0.26380D0,  0.26479D0,
     &     0.26063D0,  0.25250D0,  0.24142D0,  0.22830D0,  0.21390D0,
     &     0.19824D0,  0.18222D0,  0.16597D0,  0.14988D0,  0.13426D0,
     &     0.11924D0,  0.10484D0,  0.09128D0,  0.07889D0,  0.06724D0,
     &     0.05666D0,  0.04727D0,  0.03875D0,  0.02492D0,  0.01480D0,
     &     0.00790D0,  0.00360D0,  0.00030D0,  0.00000D0/
      DATA (FMRS(1,2,I,10),I=1,49)/
     &     0.00558D0,  0.00718D0,  0.00923D0,  0.01071D0,  0.01190D0,
     &     0.01291D0,  0.01671D0,  0.02178D0,  0.02559D0,  0.02881D0,
     &     0.03183D0,  0.04379D0,  0.06146D0,  0.07536D0,  0.08720D0,
     &     0.09766D0,  0.11571D0,  0.13802D0,  0.16719D0,  0.18973D0,
     &     0.22198D0,  0.24256D0,  0.25502D0,  0.26225D0,  0.26252D0,
     &     0.25776D0,  0.24914D0,  0.23766D0,  0.22428D0,  0.20968D0,
     &     0.19393D0,  0.17791D0,  0.16173D0,  0.14575D0,  0.13032D0,
     &     0.11552D0,  0.10136D0,  0.08807D0,  0.07596D0,  0.06462D0,
     &     0.05433D0,  0.04524D0,  0.03701D0,  0.02369D0,  0.01400D0,
     &     0.00743D0,  0.00336D0,  0.00028D0,  0.00000D0/
      DATA (FMRS(1,2,I,11),I=1,49)/
     &     0.00562D0,  0.00723D0,  0.00932D0,  0.01081D0,  0.01202D0,
     &     0.01305D0,  0.01691D0,  0.02206D0,  0.02593D0,  0.02920D0,
     &     0.03226D0,  0.04438D0,  0.06226D0,  0.07629D0,  0.08822D0,
     &     0.09874D0,  0.11687D0,  0.13920D0,  0.16827D0,  0.19064D0,
     &     0.22242D0,  0.24246D0,  0.25439D0,  0.26100D0,  0.26071D0,
     &     0.25548D0,  0.24648D0,  0.23472D0,  0.22112D0,  0.20638D0,
     &     0.19059D0,  0.17454D0,  0.15845D0,  0.14257D0,  0.12728D0,
     &     0.11265D0,  0.09869D0,  0.08561D0,  0.07373D0,  0.06261D0,
     &     0.05256D0,  0.04369D0,  0.03568D0,  0.02275D0,  0.01339D0,
     &     0.00707D0,  0.00318D0,  0.00026D0,  0.00000D0/
      DATA (FMRS(1,2,I,12),I=1,49)/
     &     0.00570D0,  0.00736D0,  0.00950D0,  0.01104D0,  0.01228D0,
     &     0.01335D0,  0.01733D0,  0.02266D0,  0.02665D0,  0.03003D0,
     &     0.03319D0,  0.04566D0,  0.06397D0,  0.07827D0,  0.09038D0,
     &     0.10102D0,  0.11928D0,  0.14164D0,  0.17050D0,  0.19247D0,
     &     0.22321D0,  0.24211D0,  0.25293D0,  0.25822D0,  0.25677D0,
     &     0.25059D0,  0.24082D0,  0.22847D0,  0.21448D0,  0.19945D0,
     &     0.18361D0,  0.16759D0,  0.15163D0,  0.13598D0,  0.12100D0,
     &     0.10676D0,  0.09321D0,  0.08058D0,  0.06917D0,  0.05856D0,
     &     0.04898D0,  0.04057D0,  0.03301D0,  0.02089D0,  0.01219D0,
     &     0.00638D0,  0.00284D0,  0.00022D0,  0.00000D0/
      DATA (FMRS(1,2,I,13),I=1,49)/
     &     0.00578D0,  0.00747D0,  0.00966D0,  0.01124D0,  0.01252D0,
     &     0.01361D0,  0.01770D0,  0.02318D0,  0.02729D0,  0.03076D0,
     &     0.03400D0,  0.04677D0,  0.06545D0,  0.07997D0,  0.09223D0,
     &     0.10297D0,  0.12133D0,  0.14370D0,  0.17234D0,  0.19395D0,
     &     0.22379D0,  0.24170D0,  0.25156D0,  0.25575D0,  0.25334D0,
     &     0.24638D0,  0.23598D0,  0.22317D0,  0.20887D0,  0.19364D0,
     &     0.17776D0,  0.16180D0,  0.14597D0,  0.13054D0,  0.11583D0,
     &     0.10193D0,  0.08873D0,  0.07648D0,  0.06548D0,  0.05529D0,
     &     0.04609D0,  0.03806D0,  0.03088D0,  0.01941D0,  0.01124D0,
     &     0.00583D0,  0.00257D0,  0.00020D0,  0.00000D0/
      DATA (FMRS(1,2,I,14),I=1,49)/
     &     0.00586D0,  0.00760D0,  0.00985D0,  0.01147D0,  0.01278D0,
     &     0.01391D0,  0.01812D0,  0.02377D0,  0.02801D0,  0.03158D0,
     &     0.03491D0,  0.04802D0,  0.06710D0,  0.08186D0,  0.09428D0,
     &     0.10512D0,  0.12358D0,  0.14593D0,  0.17430D0,  0.19551D0,
     &     0.22431D0,  0.24113D0,  0.24990D0,  0.25292D0,  0.24948D0,
     &     0.24168D0,  0.23063D0,  0.21737D0,  0.20273D0,  0.18735D0,
     &     0.17142D0,  0.15550D0,  0.13986D0,  0.12470D0,  0.11033D0,
     &     0.09680D0,  0.08400D0,  0.07217D0,  0.06162D0,  0.05183D0,
     &     0.04308D0,  0.03546D0,  0.02866D0,  0.01788D0,  0.01027D0,
     &     0.00528D0,  0.00231D0,  0.00017D0,  0.00000D0/
      DATA (FMRS(1,2,I,15),I=1,49)/
     &     0.00596D0,  0.00773D0,  0.01005D0,  0.01171D0,  0.01307D0,
     &     0.01423D0,  0.01857D0,  0.02439D0,  0.02876D0,  0.03244D0,
     &     0.03586D0,  0.04932D0,  0.06880D0,  0.08380D0,  0.09637D0,
     &     0.10730D0,  0.12584D0,  0.14815D0,  0.17622D0,  0.19694D0,
     &     0.22466D0,  0.24034D0,  0.24804D0,  0.24983D0,  0.24536D0,
     &     0.23677D0,  0.22506D0,  0.21136D0,  0.19645D0,  0.18096D0,
     &     0.16500D0,  0.14922D0,  0.13378D0,  0.11890D0,  0.10488D0,
     &     0.09171D0,  0.07933D0,  0.06793D0,  0.05781D0,  0.04848D0,
     &     0.04016D0,  0.03293D0,  0.02652D0,  0.01642D0,  0.00936D0,
     &     0.00477D0,  0.00206D0,  0.00015D0,  0.00000D0/
      DATA (FMRS(1,2,I,16),I=1,49)/
     &     0.00604D0,  0.00786D0,  0.01023D0,  0.01194D0,  0.01333D0,
     &     0.01452D0,  0.01898D0,  0.02497D0,  0.02945D0,  0.03323D0,
     &     0.03674D0,  0.05050D0,  0.07034D0,  0.08554D0,  0.09824D0,
     &     0.10925D0,  0.12785D0,  0.15009D0,  0.17786D0,  0.19815D0,
     &     0.22486D0,  0.23952D0,  0.24625D0,  0.24698D0,  0.24163D0,
     &     0.23233D0,  0.22009D0,  0.20603D0,  0.19091D0,  0.17529D0,
     &     0.15938D0,  0.14374D0,  0.12849D0,  0.11388D0,  0.10016D0,
     &     0.08733D0,  0.07533D0,  0.06433D0,  0.05458D0,  0.04564D0,
     &     0.03769D0,  0.03082D0,  0.02473D0,  0.01521D0,  0.00860D0,
     &     0.00435D0,  0.00186D0,  0.00013D0,  0.00000D0/
      DATA (FMRS(1,2,I,17),I=1,49)/
     &     0.00614D0,  0.00799D0,  0.01042D0,  0.01217D0,  0.01359D0,
     &     0.01482D0,  0.01940D0,  0.02555D0,  0.03016D0,  0.03404D0,
     &     0.03763D0,  0.05170D0,  0.07188D0,  0.08729D0,  0.10010D0,
     &     0.11119D0,  0.12983D0,  0.15200D0,  0.17943D0,  0.19928D0,
     &     0.22497D0,  0.23860D0,  0.24438D0,  0.24406D0,  0.23786D0,
     &     0.22788D0,  0.21517D0,  0.20077D0,  0.18546D0,  0.16976D0,
     &     0.15392D0,  0.13841D0,  0.12338D0,  0.10905D0,  0.09563D0,
     &     0.08314D0,  0.07152D0,  0.06090D0,  0.05152D0,  0.04295D0,
     &     0.03537D0,  0.02883D0,  0.02306D0,  0.01409D0,  0.00791D0,
     &     0.00396D0,  0.00168D0,  0.00011D0,  0.00000D0/
      DATA (FMRS(1,2,I,18),I=1,49)/
     &     0.00621D0,  0.00810D0,  0.01058D0,  0.01236D0,  0.01382D0,
     &     0.01507D0,  0.01975D0,  0.02604D0,  0.03075D0,  0.03471D0,
     &     0.03837D0,  0.05269D0,  0.07316D0,  0.08872D0,  0.10163D0,
     &     0.11277D0,  0.13143D0,  0.15352D0,  0.18066D0,  0.20012D0,
     &     0.22496D0,  0.23774D0,  0.24276D0,  0.24159D0,  0.23471D0,
     &     0.22421D0,  0.21113D0,  0.19645D0,  0.18102D0,  0.16532D0,
     &     0.14952D0,  0.13412D0,  0.11930D0,  0.10519D0,  0.09201D0,
     &     0.07983D0,  0.06850D0,  0.05818D0,  0.04914D0,  0.04085D0,
     &     0.03356D0,  0.02728D0,  0.02176D0,  0.01322D0,  0.00738D0,
     &     0.00367D0,  0.00154D0,  0.00010D0,  0.00000D0/
      DATA (FMRS(1,2,I,19),I=1,49)/
     &     0.00631D0,  0.00824D0,  0.01077D0,  0.01261D0,  0.01410D0,
     &     0.01538D0,  0.02018D0,  0.02663D0,  0.03146D0,  0.03553D0,
     &     0.03927D0,  0.05390D0,  0.07469D0,  0.09044D0,  0.10345D0,
     &     0.11464D0,  0.13332D0,  0.15529D0,  0.18206D0,  0.20106D0,
     &     0.22486D0,  0.23661D0,  0.24071D0,  0.23855D0,  0.23089D0,
     &     0.21978D0,  0.20626D0,  0.19133D0,  0.17575D0,  0.16006D0,
     &     0.14433D0,  0.12911D0,  0.11452D0,  0.10069D0,  0.08783D0,
     &     0.07600D0,  0.06503D0,  0.05507D0,  0.04638D0,  0.03845D0,
     &     0.03149D0,  0.02552D0,  0.02030D0,  0.01225D0,  0.00679D0,
     &     0.00335D0,  0.00139D0,  0.00009D0,  0.00000D0/
      DATA (FMRS(1,2,I,20),I=1,49)/
     &     0.00640D0,  0.00837D0,  0.01095D0,  0.01282D0,  0.01434D0,
     &     0.01565D0,  0.02057D0,  0.02717D0,  0.03210D0,  0.03625D0,
     &     0.04007D0,  0.05496D0,  0.07605D0,  0.09195D0,  0.10504D0,
     &     0.11628D0,  0.13496D0,  0.15682D0,  0.18325D0,  0.20182D0,
     &     0.22471D0,  0.23557D0,  0.23887D0,  0.23587D0,  0.22753D0,
     &     0.21592D0,  0.20204D0,  0.18691D0,  0.17123D0,  0.15556D0,
     &     0.13990D0,  0.12485D0,  0.11047D0,  0.09690D0,  0.08432D0,
     &     0.07279D0,  0.06213D0,  0.05248D0,  0.04407D0,  0.03646D0,
     &     0.02978D0,  0.02408D0,  0.01910D0,  0.01145D0,  0.00631D0,
     &     0.00309D0,  0.00127D0,  0.00008D0,  0.00000D0/
      DATA (FMRS(1,2,I,21),I=1,49)/
     &     0.00648D0,  0.00848D0,  0.01111D0,  0.01302D0,  0.01457D0,
     &     0.01591D0,  0.02092D0,  0.02766D0,  0.03269D0,  0.03692D0,
     &     0.04081D0,  0.05593D0,  0.07728D0,  0.09331D0,  0.10647D0,
     &     0.11774D0,  0.13641D0,  0.15816D0,  0.18425D0,  0.20243D0,
     &     0.22446D0,  0.23452D0,  0.23710D0,  0.23336D0,  0.22443D0,
     &     0.21239D0,  0.19820D0,  0.18290D0,  0.16716D0,  0.15148D0,
     &     0.13595D0,  0.12104D0,  0.10685D0,  0.09353D0,  0.08121D0,
     &     0.06995D0,  0.05958D0,  0.05021D0,  0.04207D0,  0.03472D0,
     &     0.02829D0,  0.02282D0,  0.01806D0,  0.01077D0,  0.00590D0,
     &     0.00287D0,  0.00118D0,  0.00007D0,  0.00000D0/
      DATA (FMRS(1,2,I,22),I=1,49)/
     &     0.00659D0,  0.00863D0,  0.01133D0,  0.01328D0,  0.01487D0,
     &     0.01624D0,  0.02138D0,  0.02828D0,  0.03345D0,  0.03777D0,
     &     0.04174D0,  0.05717D0,  0.07882D0,  0.09501D0,  0.10826D0,
     &     0.11956D0,  0.13822D0,  0.15980D0,  0.18547D0,  0.20313D0,
     &     0.22408D0,  0.23313D0,  0.23482D0,  0.23017D0,  0.22053D0,
     &     0.20797D0,  0.19344D0,  0.17794D0,  0.16215D0,  0.14650D0,
     &     0.13110D0,  0.11639D0,  0.10245D0,  0.08944D0,  0.07745D0,
     &     0.06653D0,  0.05651D0,  0.04748D0,  0.03968D0,  0.03265D0,
     &     0.02652D0,  0.02133D0,  0.01682D0,  0.00997D0,  0.00542D0,
     &     0.00262D0,  0.00106D0,  0.00006D0,  0.00000D0/
      DATA (FMRS(1,2,I,23),I=1,49)/
     &     0.00669D0,  0.00878D0,  0.01153D0,  0.01352D0,  0.01515D0,
     &     0.01655D0,  0.02181D0,  0.02888D0,  0.03416D0,  0.03858D0,
     &     0.04263D0,  0.05833D0,  0.08027D0,  0.09661D0,  0.10992D0,
     &     0.12125D0,  0.13987D0,  0.16129D0,  0.18654D0,  0.20370D0,
     &     0.22365D0,  0.23178D0,  0.23266D0,  0.22717D0,  0.21689D0,
     &     0.20387D0,  0.18906D0,  0.17340D0,  0.15758D0,  0.14198D0,
     &     0.12670D0,  0.11220D0,  0.09851D0,  0.08577D0,  0.07408D0,
     &     0.06350D0,  0.05377D0,  0.04507D0,  0.03757D0,  0.03084D0,
     &     0.02497D0,  0.02003D0,  0.01574D0,  0.00927D0,  0.00500D0,
     &     0.00240D0,  0.00096D0,  0.00006D0,  0.00000D0/
      DATA (FMRS(1,2,I,24),I=1,49)/
     &     0.00679D0,  0.00892D0,  0.01172D0,  0.01376D0,  0.01542D0,
     &     0.01685D0,  0.02222D0,  0.02944D0,  0.03483D0,  0.03934D0,
     &     0.04345D0,  0.05941D0,  0.08161D0,  0.09806D0,  0.11144D0,
     &     0.12278D0,  0.14136D0,  0.16260D0,  0.18745D0,  0.20414D0,
     &     0.22314D0,  0.23041D0,  0.23054D0,  0.22429D0,  0.21345D0,
     &     0.20006D0,  0.18498D0,  0.16918D0,  0.15336D0,  0.13783D0,
     &     0.12271D0,  0.10840D0,  0.09494D0,  0.08246D0,  0.07106D0,
     &     0.06075D0,  0.05132D0,  0.04292D0,  0.03570D0,  0.02922D0,
     &     0.02361D0,  0.01888D0,  0.01480D0,  0.00867D0,  0.00465D0,
     &     0.00221D0,  0.00088D0,  0.00005D0,  0.00000D0/
      DATA (FMRS(1,2,I,25),I=1,49)/
     &     0.00689D0,  0.00906D0,  0.01192D0,  0.01399D0,  0.01569D0,
     &     0.01715D0,  0.02264D0,  0.03000D0,  0.03550D0,  0.04009D0,
     &     0.04429D0,  0.06049D0,  0.08294D0,  0.09952D0,  0.11294D0,
     &     0.12429D0,  0.14282D0,  0.16389D0,  0.18832D0,  0.20454D0,
     &     0.22261D0,  0.22902D0,  0.22843D0,  0.22145D0,  0.21007D0,
     &     0.19632D0,  0.18101D0,  0.16509D0,  0.14928D0,  0.13382D0,
     &     0.11886D0,  0.10475D0,  0.09153D0,  0.07931D0,  0.06819D0,
     &     0.05815D0,  0.04900D0,  0.04089D0,  0.03393D0,  0.02770D0,
     &     0.02232D0,  0.01781D0,  0.01392D0,  0.00811D0,  0.00432D0,
     &     0.00204D0,  0.00081D0,  0.00004D0,  0.00000D0/
      DATA (FMRS(1,2,I,26),I=1,49)/
     &     0.00699D0,  0.00920D0,  0.01211D0,  0.01423D0,  0.01596D0,
     &     0.01744D0,  0.02304D0,  0.03056D0,  0.03616D0,  0.04084D0,
     &     0.04510D0,  0.06154D0,  0.08423D0,  0.10091D0,  0.11437D0,
     &     0.12573D0,  0.14419D0,  0.16508D0,  0.18909D0,  0.20485D0,
     &     0.22201D0,  0.22760D0,  0.22631D0,  0.21867D0,  0.20676D0,
     &     0.19266D0,  0.17717D0,  0.16120D0,  0.14536D0,  0.12999D0,
     &     0.11520D0,  0.10128D0,  0.08831D0,  0.07633D0,  0.06548D0,
     &     0.05572D0,  0.04685D0,  0.03900D0,  0.03228D0,  0.02629D0,
     &     0.02113D0,  0.01682D0,  0.01311D0,  0.00760D0,  0.00403D0,
     &     0.00189D0,  0.00074D0,  0.00004D0,  0.00000D0/
      DATA (FMRS(1,2,I,27),I=1,49)/
     &     0.00708D0,  0.00933D0,  0.01230D0,  0.01445D0,  0.01621D0,
     &     0.01773D0,  0.02343D0,  0.03108D0,  0.03678D0,  0.04155D0,
     &     0.04587D0,  0.06253D0,  0.08544D0,  0.10221D0,  0.11571D0,
     &     0.12707D0,  0.14546D0,  0.16617D0,  0.18977D0,  0.20509D0,
     &     0.22139D0,  0.22623D0,  0.22430D0,  0.21604D0,  0.20367D0,
     &     0.18926D0,  0.17361D0,  0.15759D0,  0.14176D0,  0.12648D0,
     &     0.11185D0,  0.09812D0,  0.08537D0,  0.07364D0,  0.06303D0,
     &     0.05352D0,  0.04490D0,  0.03729D0,  0.03081D0,  0.02503D0,
     &     0.02007D0,  0.01594D0,  0.01240D0,  0.00714D0,  0.00376D0,
     &     0.00176D0,  0.00068D0,  0.00004D0,  0.00000D0/
      DATA (FMRS(1,2,I,28),I=1,49)/
     &     0.00718D0,  0.00946D0,  0.01247D0,  0.01467D0,  0.01646D0,
     &     0.01800D0,  0.02380D0,  0.03158D0,  0.03738D0,  0.04221D0,
     &     0.04660D0,  0.06346D0,  0.08657D0,  0.10342D0,  0.11695D0,
     &     0.12830D0,  0.14663D0,  0.16715D0,  0.19037D0,  0.20527D0,
     &     0.22075D0,  0.22489D0,  0.22237D0,  0.21353D0,  0.20079D0,
     &     0.18610D0,  0.17031D0,  0.15425D0,  0.13844D0,  0.12326D0,
     &     0.10877D0,  0.09523D0,  0.08268D0,  0.07119D0,  0.06080D0,
     &     0.05153D0,  0.04314D0,  0.03575D0,  0.02948D0,  0.02390D0,
     &     0.01913D0,  0.01516D0,  0.01177D0,  0.00675D0,  0.00353D0,
     &     0.00164D0,  0.00063D0,  0.00003D0,  0.00000D0/
      DATA (FMRS(1,2,I,29),I=1,49)/
     &     0.00727D0,  0.00959D0,  0.01265D0,  0.01488D0,  0.01670D0,
     &     0.01827D0,  0.02417D0,  0.03208D0,  0.03797D0,  0.04288D0,
     &     0.04733D0,  0.06440D0,  0.08769D0,  0.10463D0,  0.11818D0,
     &     0.12952D0,  0.14777D0,  0.16810D0,  0.19092D0,  0.20540D0,
     &     0.22008D0,  0.22352D0,  0.22043D0,  0.21103D0,  0.19791D0,
     &     0.18297D0,  0.16705D0,  0.15095D0,  0.13519D0,  0.12011D0,
     &     0.10577D0,  0.09241D0,  0.08008D0,  0.06881D0,  0.05866D0,
     &     0.04961D0,  0.04145D0,  0.03427D0,  0.02822D0,  0.02282D0,
     &     0.01822D0,  0.01441D0,  0.01116D0,  0.00637D0,  0.00332D0,
     &     0.00153D0,  0.00059D0,  0.00003D0,  0.00000D0/
      DATA (FMRS(1,2,I,30),I=1,49)/
     &     0.00737D0,  0.00972D0,  0.01283D0,  0.01510D0,  0.01695D0,
     &     0.01854D0,  0.02454D0,  0.03258D0,  0.03856D0,  0.04354D0,
     &     0.04805D0,  0.06532D0,  0.08879D0,  0.10580D0,  0.11936D0,
     &     0.13069D0,  0.14886D0,  0.16900D0,  0.19141D0,  0.20548D0,
     &     0.21937D0,  0.22213D0,  0.21850D0,  0.20855D0,  0.19507D0,
     &     0.17994D0,  0.16388D0,  0.14775D0,  0.13208D0,  0.11709D0,
     &     0.10291D0,  0.08973D0,  0.07760D0,  0.06655D0,  0.05664D0,
     &     0.04779D0,  0.03985D0,  0.03289D0,  0.02702D0,  0.02182D0,
     &     0.01738D0,  0.01372D0,  0.01060D0,  0.00602D0,  0.00312D0,
     &     0.00143D0,  0.00055D0,  0.00003D0,  0.00000D0/
      DATA (FMRS(1,2,I,31),I=1,49)/
     &     0.00746D0,  0.00985D0,  0.01300D0,  0.01530D0,  0.01718D0,
     &     0.01880D0,  0.02489D0,  0.03306D0,  0.03912D0,  0.04417D0,
     &     0.04873D0,  0.06619D0,  0.08983D0,  0.10690D0,  0.12048D0,
     &     0.13179D0,  0.14987D0,  0.16982D0,  0.19186D0,  0.20553D0,
     &     0.21868D0,  0.22081D0,  0.21666D0,  0.20623D0,  0.19242D0,
     &     0.17710D0,  0.16093D0,  0.14478D0,  0.12919D0,  0.11430D0,
     &     0.10026D0,  0.08726D0,  0.07533D0,  0.06447D0,  0.05479D0,
     &     0.04614D0,  0.03840D0,  0.03163D0,  0.02594D0,  0.02091D0,
     &     0.01662D0,  0.01309D0,  0.01009D0,  0.00571D0,  0.00295D0,
     &     0.00134D0,  0.00051D0,  0.00003D0,  0.00000D0/
      DATA (FMRS(1,2,I,32),I=1,49)/
     &     0.00755D0,  0.00997D0,  0.01317D0,  0.01550D0,  0.01741D0,
     &     0.01905D0,  0.02522D0,  0.03351D0,  0.03966D0,  0.04477D0,
     &     0.04938D0,  0.06700D0,  0.09079D0,  0.10792D0,  0.12151D0,
     &     0.13280D0,  0.15080D0,  0.17056D0,  0.19223D0,  0.20552D0,
     &     0.21797D0,  0.21951D0,  0.21489D0,  0.20403D0,  0.18991D0,
     &     0.17441D0,  0.15817D0,  0.14202D0,  0.12646D0,  0.11170D0,
     &     0.09780D0,  0.08498D0,  0.07322D0,  0.06257D0,  0.05306D0,
     &     0.04463D0,  0.03708D0,  0.03049D0,  0.02496D0,  0.02008D0,
     &     0.01594D0,  0.01252D0,  0.00963D0,  0.00542D0,  0.00279D0,
     &     0.00126D0,  0.00048D0,  0.00002D0,  0.00000D0/
      DATA (FMRS(1,2,I,33),I=1,49)/
     &     0.00764D0,  0.01009D0,  0.01333D0,  0.01570D0,  0.01763D0,
     &     0.01930D0,  0.02556D0,  0.03396D0,  0.04019D0,  0.04537D0,
     &     0.05004D0,  0.06783D0,  0.09177D0,  0.10895D0,  0.12254D0,
     &     0.13381D0,  0.15173D0,  0.17130D0,  0.19261D0,  0.20552D0,
     &     0.21726D0,  0.21822D0,  0.21313D0,  0.20185D0,  0.18743D0,
     &     0.17175D0,  0.15545D0,  0.13931D0,  0.12379D0,  0.10917D0,
     &     0.09540D0,  0.08276D0,  0.07118D0,  0.06072D0,  0.05139D0,
     &     0.04317D0,  0.03581D0,  0.02938D0,  0.02402D0,  0.01929D0,
     &     0.01528D0,  0.01198D0,  0.00920D0,  0.00516D0,  0.00264D0,
     &     0.00119D0,  0.00045D0,  0.00002D0,  0.00000D0/
      DATA (FMRS(1,2,I,34),I=1,49)/
     &     0.00773D0,  0.01021D0,  0.01350D0,  0.01590D0,  0.01786D0,
     &     0.01955D0,  0.02590D0,  0.03441D0,  0.04072D0,  0.04597D0,
     &     0.05068D0,  0.06863D0,  0.09272D0,  0.10994D0,  0.12353D0,
     &     0.13477D0,  0.15260D0,  0.17197D0,  0.19290D0,  0.20543D0,
     &     0.21649D0,  0.21688D0,  0.21134D0,  0.19965D0,  0.18497D0,
     &     0.16913D0,  0.15278D0,  0.13665D0,  0.12121D0,  0.10669D0,
     &     0.09308D0,  0.08060D0,  0.06921D0,  0.05894D0,  0.04980D0,
     &     0.04176D0,  0.03458D0,  0.02833D0,  0.02311D0,  0.01853D0,
     &     0.01465D0,  0.01147D0,  0.00879D0,  0.00491D0,  0.00250D0,
     &     0.00112D0,  0.00042D0,  0.00002D0,  0.00000D0/
      DATA (FMRS(1,2,I,35),I=1,49)/
     &     0.00781D0,  0.01033D0,  0.01366D0,  0.01609D0,  0.01808D0,
     &     0.01979D0,  0.02622D0,  0.03484D0,  0.04123D0,  0.04653D0,
     &     0.05129D0,  0.06941D0,  0.09362D0,  0.11088D0,  0.12448D0,
     &     0.13569D0,  0.15342D0,  0.17260D0,  0.19318D0,  0.20535D0,
     &     0.21576D0,  0.21562D0,  0.20966D0,  0.19759D0,  0.18266D0,
     &     0.16668D0,  0.15028D0,  0.13418D0,  0.11882D0,  0.10439D0,
     &     0.09094D0,  0.07861D0,  0.06739D0,  0.05729D0,  0.04834D0,
     &     0.04048D0,  0.03346D0,  0.02736D0,  0.02228D0,  0.01784D0,
     &     0.01408D0,  0.01100D0,  0.00842D0,  0.00468D0,  0.00237D0,
     &     0.00106D0,  0.00039D0,  0.00002D0,  0.00000D0/
      DATA (FMRS(1,2,I,36),I=1,49)/
     &     0.00790D0,  0.01044D0,  0.01382D0,  0.01628D0,  0.01829D0,
     &     0.02002D0,  0.02653D0,  0.03525D0,  0.04172D0,  0.04707D0,
     &     0.05188D0,  0.07013D0,  0.09447D0,  0.11177D0,  0.12535D0,
     &     0.13654D0,  0.15418D0,  0.17318D0,  0.19341D0,  0.20524D0,
     &     0.21505D0,  0.21440D0,  0.20805D0,  0.19563D0,  0.18048D0,
     &     0.16438D0,  0.14795D0,  0.13186D0,  0.11657D0,  0.10226D0,
     &     0.08894D0,  0.07676D0,  0.06571D0,  0.05578D0,  0.04700D0,
     &     0.03929D0,  0.03242D0,  0.02648D0,  0.02153D0,  0.01720D0,
     &     0.01356D0,  0.01058D0,  0.00808D0,  0.00448D0,  0.00226D0,
     &     0.00101D0,  0.00037D0,  0.00002D0,  0.00000D0/
      DATA (FMRS(1,2,I,37),I=1,49)/
     &     0.00798D0,  0.01056D0,  0.01397D0,  0.01646D0,  0.01850D0,
     &     0.02025D0,  0.02684D0,  0.03567D0,  0.04221D0,  0.04762D0,
     &     0.05247D0,  0.07087D0,  0.09532D0,  0.11265D0,  0.12622D0,
     &     0.13738D0,  0.15492D0,  0.17373D0,  0.19361D0,  0.20510D0,
     &     0.21429D0,  0.21315D0,  0.20641D0,  0.19365D0,  0.17829D0,
     &     0.16207D0,  0.14561D0,  0.12954D0,  0.11434D0,  0.10013D0,
     &     0.08696D0,  0.07493D0,  0.06406D0,  0.05429D0,  0.04567D0,
     &     0.03812D0,  0.03141D0,  0.02561D0,  0.02079D0,  0.01659D0,
     &     0.01305D0,  0.01017D0,  0.00775D0,  0.00428D0,  0.00215D0,
     &     0.00095D0,  0.00035D0,  0.00002D0,  0.00000D0/
      DATA (FMRS(1,2,I,38),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,3,I, 1),I=1,49)/
     &     3.68244D0,  3.61785D0,  3.55346D0,  3.51555D0,  3.48837D0,
     &     3.46702D0,  3.39811D0,  3.32177D0,  3.27072D0,  3.23000D0,
     &     3.19378D0,  3.05765D0,  2.86346D0,  2.71339D0,  2.58651D0,
     &     2.47572D0,  2.28777D0,  2.06245D0,  1.78178D0,  1.57726D0,
     &     1.30519D0,  1.14076D0,  1.03654D0,  0.95264D0,  0.89447D0,
     &     0.84663D0,  0.80090D0,  0.75325D0,  0.70217D0,  0.64784D0,
     &     0.59048D0,  0.53173D0,  0.47263D0,  0.41459D0,  0.35887D0,
     &     0.30634D0,  0.25757D0,  0.21335D0,  0.17415D0,  0.13936D0,
     &     0.10957D0,  0.08459D0,  0.06372D0,  0.03369D0,  0.01574D0,
     &     0.00625D0,  0.00195D0,  0.00005D0,  0.00000D0/
      DATA (FMRS(1,3,I, 2),I=1,49)/
     &     6.24307D0,  5.86376D0,  5.50631D0,  5.30646D0,  5.16844D0,
     &     5.06337D0,  4.74657D0,  4.44005D0,  4.26242D0,  4.13555D0,
     &     4.03502D0,  3.71094D0,  3.34882D0,  3.11051D0,  2.92600D0,
     &     2.77355D0,  2.52821D0,  2.24967D0,  1.91859D0,  1.68481D0,
     &     1.37946D0,  1.19535D0,  1.07673D0,  0.97819D0,  0.90750D0,
     &     0.84881D0,  0.79381D0,  0.73852D0,  0.68149D0,  0.62276D0,
     &     0.56254D0,  0.50226D0,  0.44285D0,  0.38548D0,  0.33123D0,
     &     0.28073D0,  0.23437D0,  0.19279D0,  0.15633D0,  0.12427D0,
     &     0.09707D0,  0.07445D0,  0.05572D0,  0.02906D0,  0.01339D0,
     &     0.00524D0,  0.00161D0,  0.00004D0,  0.00000D0/
      DATA (FMRS(1,3,I, 3),I=1,49)/
     &    11.05139D0,  9.94786D0,  8.95244D0,  8.41536D0,  8.05287D0,
     &     7.78166D0,  6.98996D0,  6.26416D0,  5.86369D0,  5.58758D0,
     &     5.37431D0,  4.72923D0,  4.08790D0,  3.70661D0,  3.43015D0,
     &     3.21204D0,  2.87740D0,  2.51734D0,  2.11023D0,  1.83283D0,
     &     1.47833D0,  1.26530D0,  1.12571D0,  1.00618D0,  0.91793D0,
     &     0.84442D0,  0.77712D0,  0.71204D0,  0.64770D0,  0.58389D0,
     &     0.52071D0,  0.45928D0,  0.40030D0,  0.34459D0,  0.29298D0,
     &     0.24576D0,  0.20309D0,  0.16540D0,  0.13284D0,  0.10462D0,
     &     0.08093D0,  0.06152D0,  0.04560D0,  0.02333D0,  0.01054D0,
     &     0.00404D0,  0.00122D0,  0.00003D0,  0.00000D0/
      DATA (FMRS(1,3,I, 4),I=1,49)/
     &    15.37825D0, 13.53065D0, 11.90193D0, 11.03924D0, 10.46378D0,
     &    10.03696D0,  8.81034D0,  7.71341D0,  7.12073D0,  6.71781D0,
     &     6.40918D0,  5.49848D0,  4.63276D0,  4.13943D0,  3.79203D0,
     &     3.52386D0,  3.12196D0,  2.70149D0,  2.23890D0,  1.93011D0,
     &     1.54059D0,  1.30714D0,  1.15286D0,  1.01886D0,  0.91881D0,
     &     0.83562D0,  0.76055D0,  0.68952D0,  0.62095D0,  0.55452D0,
     &     0.49011D0,  0.42861D0,  0.37052D0,  0.31647D0,  0.26702D0,
     &     0.22241D0,  0.18246D0,  0.14751D0,  0.11769D0,  0.09209D0,
     &     0.07074D0,  0.05343D0,  0.03933D0,  0.01985D0,  0.00885D0,
     &     0.00335D0,  0.00100D0,  0.00002D0,  0.00000D0/
      DATA (FMRS(1,3,I, 5),I=1,49)/
     &    20.54786D0, 17.73643D0, 15.30522D0, 14.03720D0, 13.19955D0,
     &    12.58273D0, 10.83264D0,  9.29877D0,  8.48369D0,  7.93560D0,
     &     7.51848D0,  6.31010D0,  5.19808D0,  4.58383D0,  4.16067D0,
     &     3.83948D0,  3.36690D0,  2.88348D0,  2.36367D0,  2.02276D0,
     &     1.59751D0,  1.34336D0,  1.17440D0,  1.02619D0,  0.91484D0,
     &     0.82260D0,  0.74049D0,  0.66431D0,  0.59227D0,  0.52387D0,
     &     0.45886D0,  0.39784D0,  0.34106D0,  0.28898D0,  0.24193D0,
     &     0.20003D0,  0.16291D0,  0.13075D0,  0.10361D0,  0.08049D0,
     &     0.06141D0,  0.04606D0,  0.03367D0,  0.01676D0,  0.00737D0,
     &     0.00275D0,  0.00081D0,  0.00002D0,  0.00000D0/
      DATA (FMRS(1,3,I, 6),I=1,49)/
     &    25.87997D0, 22.00579D0, 18.70564D0, 17.00514D0, 15.89031D0,
     &    15.07400D0, 12.78092D0, 10.80231D0,  9.76436D0,  9.07223D0,
     &     8.54820D0,  7.05063D0,  5.70461D0,  4.97765D0,  4.48471D0,
     &     4.11512D0,  3.57867D0,  3.03899D0,  2.46867D0,  2.09967D0,
     &     1.64344D0,  1.37152D0,  1.19009D0,  1.03003D0,  0.90944D0,
     &     0.81000D0,  0.72245D0,  0.64242D0,  0.56795D0,  0.49835D0,
     &     0.43318D0,  0.37285D0,  0.31739D0,  0.26712D0,  0.22217D0,
     &     0.18254D0,  0.14775D0,  0.11786D0,  0.09285D0,  0.07171D0,
     &     0.05439D0,  0.04056D0,  0.02948D0,  0.01450D0,  0.00631D0,
     &     0.00232D0,  0.00067D0,  0.00002D0,  0.00000D0/
      DATA (FMRS(1,3,I, 7),I=1,49)/
     &    31.48650D0, 26.43816D0, 22.19174D0, 20.02570D0, 18.61470D0,
     &    17.58636D0, 14.72161D0, 12.28168D0, 11.01532D0, 10.17669D0,
     &     9.54456D0,  7.75761D0,  6.18119D0,  5.34474D0,  4.78459D0,
     &     4.36861D0,  3.77149D0,  3.17878D0,  2.56125D0,  2.16614D0,
     &     1.68135D0,  1.39321D0,  1.20050D0,  1.02990D0,  0.90129D0,
     &     0.79577D0,  0.70378D0,  0.62075D0,  0.54457D0,  0.47435D0,
     &     0.40939D0,  0.34999D0,  0.29601D0,  0.24758D0,  0.20467D0,
     &     0.16718D0,  0.13453D0,  0.10670D0,  0.08361D0,  0.06425D0,
     &     0.04845D0,  0.03594D0,  0.02598D0,  0.01264D0,  0.00544D0,
     &     0.00198D0,  0.00057D0,  0.00001D0,  0.00000D0/
      DATA (FMRS(1,3,I, 8),I=1,49)/
     &    38.19562D0, 31.67731D0, 26.26192D0, 23.52700D0, 21.75654D0,
     &    20.47217D0, 16.92324D0, 13.93891D0, 12.40615D0, 11.39793D0,
     &    10.64140D0,  8.52490D0,  6.69053D0,  5.73328D0,  5.09966D0,
     &     4.63338D0,  3.97084D0,  3.32155D0,  2.65414D0,  2.23167D0,
     &     1.71719D0,  1.41235D0,  1.20819D0,  1.02708D0,  0.89064D0,
     &     0.77934D0,  0.68328D0,  0.59764D0,  0.52014D0,  0.44964D0,
     &     0.38523D0,  0.32704D0,  0.27476D0,  0.22832D0,  0.18758D0,
     &     0.15228D0,  0.12182D0,  0.09604D0,  0.07484D0,  0.05719D0,
     &     0.04288D0,  0.03164D0,  0.02275D0,  0.01095D0,  0.00466D0,
     &     0.00168D0,  0.00048D0,  0.00001D0,  0.00000D0/
      DATA (FMRS(1,3,I, 9),I=1,49)/
     &    44.69263D0, 36.69535D0, 30.11768D0, 26.82255D0, 24.70025D0,
     &    23.16639D0, 18.95601D0, 15.45187D0, 13.66736D0, 12.49995D0,
     &    11.62724D0,  9.20581D0,  7.13631D0,  6.07035D0,  5.37118D0,
     &     4.86033D0,  4.14011D0,  3.44140D0,  2.73081D0,  2.28485D0,
     &     1.74506D0,  1.42613D0,  1.21246D0,  1.02274D0,  0.88003D0,
     &     0.76424D0,  0.66513D0,  0.57765D0,  0.49935D0,  0.42889D0,
     &     0.36519D0,  0.30820D0,  0.25746D0,  0.21275D0,  0.17388D0,
     &     0.14043D0,  0.11178D0,  0.08767D0,  0.06799D0,  0.05171D0,
     &     0.03859D0,  0.02834D0,  0.02028D0,  0.00968D0,  0.00408D0,
     &     0.00146D0,  0.00041D0,  0.00001D0,  0.00000D0/
      DATA (FMRS(1,3,I,10),I=1,49)/
     &    51.42669D0, 41.84610D0, 34.03689D0, 30.15309D0, 27.66303D0,
     &    25.86942D0, 20.97504D0, 16.93923D0, 14.89954D0, 13.57172D0,
     &    12.58248D0,  9.85775D0,  7.55746D0,  6.38605D0,  5.62372D0,
     &     5.07013D0,  4.29501D0,  3.54959D0,  2.79853D0,  2.33075D0,
     &     1.76763D0,  1.43584D0,  1.21358D0,  1.01625D0,  0.86814D0,
     &     0.74860D0,  0.64707D0,  0.55827D0,  0.47958D0,  0.40941D0,
     &     0.34660D0,  0.29089D0,  0.24172D0,  0.19871D0,  0.16160D0,
     &     0.12988D0,  0.10289D0,  0.08032D0,  0.06202D0,  0.04695D0,
     &     0.03489D0,  0.02551D0,  0.01818D0,  0.00860D0,  0.00360D0,
     &     0.00128D0,  0.00036D0,  0.00001D0,  0.00000D0/
      DATA (FMRS(1,3,I,11),I=1,49)/
     &    57.20334D0, 46.22931D0, 37.34534D0, 32.95134D0, 30.14391D0,
     &    28.12686D0, 22.64741D0, 18.16087D0, 15.90648D0, 14.44434D0,
     &    13.35786D0, 10.38182D0,  7.89242D0,  6.63544D0,  5.82215D0,
     &     5.23423D0,  4.41529D0,  3.63279D0,  2.84983D0,  2.36499D0,
     &     1.78374D0,  1.44206D0,  1.21326D0,  1.01023D0,  0.85815D0,
     &     0.73593D0,  0.63273D0,  0.54312D0,  0.46430D0,  0.39449D0,
     &     0.33248D0,  0.27783D0,  0.22993D0,  0.18826D0,  0.15250D0,
     &     0.12212D0,  0.09637D0,  0.07495D0,  0.05770D0,  0.04352D0,
     &     0.03223D0,  0.02349D0,  0.01668D0,  0.00784D0,  0.00326D0,
     &     0.00115D0,  0.00032D0,  0.00001D0,  0.00000D0/
      DATA (FMRS(1,3,I,12),I=1,49)/
     &    70.62117D0, 56.29525D0, 44.85603D0, 39.26056D0, 35.71024D0,
     &    33.17249D0, 26.34026D0, 20.82458D0, 18.08508D0, 16.32156D0,
     &    15.01807D0, 11.48651D0,  8.58576D0,  7.14521D0,  6.22372D0,
     &     5.56345D0,  4.65284D0,  3.79371D0,  2.94559D0,  2.42633D0,
     &     1.80899D0,  1.44797D0,  1.20662D0,  0.99291D0,  0.83369D0,
     &     0.70687D0,  0.60112D0,  0.51056D0,  0.43209D0,  0.36357D0,
     &     0.30359D0,  0.25146D0,  0.20630D0,  0.16753D0,  0.13462D0,
     &     0.10696D0,  0.08376D0,  0.06466D0,  0.04944D0,  0.03702D0,
     &     0.02722D0,  0.01971D0,  0.01390D0,  0.00645D0,  0.00265D0,
     &     0.00093D0,  0.00026D0,  0.00001D0,  0.00000D0/
      DATA (FMRS(1,3,I,13),I=1,49)/
     &    83.50434D0, 65.82890D0, 51.87140D0, 45.10521D0, 40.83618D0,
     &    37.79736D0, 29.67546D0, 23.19327D0, 20.00393D0, 17.96325D0,
     &    16.46149D0, 12.42825D0,  9.16326D0,  7.56303D0,  6.54853D0,
     &     5.82663D0,  4.83880D0,  3.91602D0,  3.01472D0,  2.46779D0,
     &     1.82202D0,  1.44614D0,  1.19543D0,  0.97402D0,  0.80992D0,
     &     0.68027D0,  0.57325D0,  0.48262D0,  0.40504D0,  0.33808D0,
     &     0.28014D0,  0.23033D0,  0.18761D0,  0.15130D0,  0.12077D0,
     &     0.09534D0,  0.07419D0,  0.05692D0,  0.04326D0,  0.03220D0,
     &     0.02354D0,  0.01696D0,  0.01189D0,  0.00546D0,  0.00222D0,
     &     0.00077D0,  0.00021D0,  0.00001D0,  0.00000D0/
      DATA (FMRS(1,3,I,14),I=1,49)/
     &    99.26808D0, 77.34151D0, 60.22972D0, 52.01289D0, 46.85941D0,
     &    43.20707D0, 33.52017D0, 25.88194D0, 22.16110D0, 19.79557D0,
     &    18.06292D0, 13.45200D0,  9.77556D0,  7.99825D0,  6.88178D0,
     &     6.09288D0,  5.02224D0,  4.03207D0,  3.07569D0,  2.50055D0,
     &     1.82658D0,  1.43637D0,  1.17694D0,  0.94870D0,  0.78062D0,
     &     0.64903D0,  0.54156D0,  0.45166D0,  0.37564D0,  0.31084D0,
     &     0.25547D0,  0.20834D0,  0.16843D0,  0.13481D0,  0.10686D0,
     &     0.08378D0,  0.06476D0,  0.04934D0,  0.03727D0,  0.02756D0,
     &     0.02003D0,  0.01435D0,  0.01000D0,  0.00454D0,  0.00183D0,
     &     0.00063D0,  0.00017D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,3,I,15),I=1,49)/
     &   117.13634D0, 90.22787D0, 69.46667D0, 59.58908D0, 53.42973D0,
     &    49.08310D0, 37.64029D0, 28.72286D0, 24.42074D0, 21.70264D0,
     &    19.72087D0, 14.49332D0, 10.38573D0,  8.42544D0,  7.20484D0,
     &     6.34818D0,  5.19436D0,  4.13748D0,  3.12707D0,  2.52493D0,
     &     1.82437D0,  1.42118D0,  1.15415D0,  0.92032D0,  0.74934D0,
     &     0.61673D0,  0.50955D0,  0.42103D0,  0.34703D0,  0.28471D0,
     &     0.23205D0,  0.18777D0,  0.15064D0,  0.11967D0,  0.09419D0,
     &     0.07336D0,  0.05631D0,  0.04263D0,  0.03201D0,  0.02354D0,
     &     0.01700D0,  0.01211D0,  0.00839D0,  0.00377D0,  0.00151D0,
     &     0.00052D0,  0.00014D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,3,I,16),I=1,49)/
     &   134.87820D0,102.87527D0, 78.42588D0, 66.88609D0, 59.72612D0,
     &    54.69190D0, 41.52393D0, 31.36570D0, 26.50579D0, 23.45176D0,
     &    21.23395D0, 15.42784D0, 10.92244D0,  8.79593D0,  7.48170D0,
     &     6.56462D0,  5.33723D0,  4.22208D0,  3.16533D0,  2.54035D0,
     &     1.81781D0,  1.40424D0,  1.13142D0,  0.89365D0,  0.72095D0,
     &     0.58811D0,  0.48181D0,  0.39483D0,  0.32289D0,  0.26295D0,
     &     0.21278D0,  0.17100D0,  0.13629D0,  0.10758D0,  0.08415D0,
     &     0.06517D0,  0.04972D0,  0.03744D0,  0.02797D0,  0.02046D0,
     &     0.01470D0,  0.01042D0,  0.00719D0,  0.00321D0,  0.00127D0,
     &     0.00043D0,  0.00012D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,3,I,17),I=1,49)/
     &   154.38010D0,116.63111D0, 88.06633D0, 74.68806D0, 66.42747D0,
     &    60.64011D0, 45.59593D0, 34.10384D0, 28.65021D0, 25.24085D0,
     &    22.77463D0, 16.36506D0, 11.45095D0,  9.15610D0,  7.74790D0,
     &     6.77064D0,  5.47057D0,  4.29852D0,  3.19720D0,  2.55058D0,
     &     1.80771D0,  1.38488D0,  1.10716D0,  0.86634D0,  0.69264D0,
     &     0.56014D0,  0.45511D0,  0.36997D0,  0.30026D0,  0.24276D0,
     &     0.19507D0,  0.15573D0,  0.12333D0,  0.09676D0,  0.07524D0,
     &     0.05794D0,  0.04395D0,  0.03292D0,  0.02447D0,  0.01781D0,
     &     0.01274D0,  0.00899D0,  0.00618D0,  0.00274D0,  0.00108D0,
     &     0.00037D0,  0.00010D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,3,I,18),I=1,49)/
     &   171.60985D0,128.66806D0, 96.41977D0, 81.40891D0, 72.17590D0,
     &    65.72558D0, 49.04064D0, 36.39427D0, 30.43144D0, 26.71914D0,
     &    24.04215D0, 17.12464D0, 11.87120D0,  9.43856D0,  7.95410D0,
     &     6.92832D0,  5.57016D0,  4.35322D0,  3.21721D0,  2.55406D0,
     &     1.79608D0,  1.36671D0,  1.08575D0,  0.84319D0,  0.66925D0,
     &     0.53749D0,  0.43376D0,  0.35041D0,  0.28267D0,  0.22722D0,
     &     0.18154D0,  0.14418D0,  0.11359D0,  0.08871D0,  0.06865D0,
     &     0.05262D0,  0.03976D0,  0.02965D0,  0.02195D0,  0.01592D0,
     &     0.01135D0,  0.00798D0,  0.00547D0,  0.00241D0,  0.00095D0,
     &     0.00032D0,  0.00009D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,3,I,19),I=1,49)/
     &   193.78899D0,144.01862D0,106.97157D0, 89.85031D0, 79.36631D0,
     &    72.06629D0, 53.29134D0, 39.18974D0, 32.59051D0, 28.50177D0,
     &    25.56394D0, 18.02311D0, 12.35926D0,  9.76179D0,  8.18702D0,
     &     7.10431D0,  5.67841D0,  4.40968D0,  3.23437D0,  2.55292D0,
     &     1.77867D0,  1.34261D0,  1.05865D0,  0.81484D0,  0.64125D0,
     &     0.51082D0,  0.40904D0,  0.32798D0,  0.26269D0,  0.20975D0,
     &     0.16651D0,  0.13145D0,  0.10293D0,  0.07994D0,  0.06153D0,
     &     0.04691D0,  0.03527D0,  0.02618D0,  0.01929D0,  0.01394D0,
     &     0.00989D0,  0.00693D0,  0.00473D0,  0.00207D0,  0.00081D0,
     &     0.00027D0,  0.00007D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,3,I,20),I=1,49)/
     &   214.89481D0,158.49641D0,116.83355D0, 97.69725D0, 86.02460D0,
     &    77.91979D0, 57.17770D0, 41.71972D0, 34.53225D0, 30.09744D0,
     &    26.92084D0, 18.81368D0, 12.78187D0, 10.03830D0,  8.38419D0,
     &     7.25181D0,  5.76723D0,  4.45410D0,  3.24560D0,  2.54901D0,
     &     1.76164D0,  1.32048D0,  1.03446D0,  0.79010D0,  0.61721D0,
     &     0.48824D0,  0.38835D0,  0.30938D0,  0.24629D0,  0.19551D0,
     &     0.15438D0,  0.12122D0,  0.09444D0,  0.07299D0,  0.05594D0,
     &     0.04245D0,  0.03178D0,  0.02349D0,  0.01725D0,  0.01242D0,
     &     0.00879D0,  0.00614D0,  0.00418D0,  0.00182D0,  0.00071D0,
     &     0.00024D0,  0.00007D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,3,I,21),I=1,49)/
     &   234.93695D0,172.12665D0,126.03609D0,104.98046D0, 92.18044D0,
     &    83.31506D0, 60.72429D0, 44.00365D0, 36.27307D0, 31.52044D0,
     &    28.12565D0, 19.50453D0, 13.14306D0, 10.27071D0,  8.54710D0,
     &     7.37140D0,  5.83642D0,  4.48556D0,  3.24949D0,  2.54059D0,
     &     1.74309D0,  1.29840D0,  1.01128D0,  0.76711D0,  0.59538D0,
     &     0.46805D0,  0.37012D0,  0.29319D0,  0.23219D0,  0.18337D0,
     &     0.14410D0,  0.11261D0,  0.08738D0,  0.06725D0,  0.05133D0,
     &     0.03881D0,  0.02895D0,  0.02133D0,  0.01562D0,  0.01121D0,
     &     0.00791D0,  0.00551D0,  0.00374D0,  0.00162D0,  0.00063D0,
     &     0.00021D0,  0.00006D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,3,I,22),I=1,49)/
     &   261.98752D0,190.37146D0,138.25069D0,114.59908D0,100.28083D0,
     &    90.39440D0, 65.33586D0, 46.94503D0, 38.50155D0, 33.33386D0,
     &    29.65516D0, 20.37022D0, 13.58831D0, 10.55348D0,  8.74295D0,
     &     7.51340D0,  5.91633D0,  4.51953D0,  3.25037D0,  2.52703D0,
     &     1.71812D0,  1.26985D0,  0.98192D0,  0.73853D0,  0.56860D0,
     &     0.44359D0,  0.34825D0,  0.27396D0,  0.21556D0,  0.16918D0,
     &     0.13216D0,  0.10269D0,  0.07927D0,  0.06069D0,  0.04611D0,
     &     0.03471D0,  0.02577D0,  0.01891D0,  0.01380D0,  0.00987D0,
     &     0.00694D0,  0.00482D0,  0.00326D0,  0.00141D0,  0.00055D0,
     &     0.00018D0,  0.00005D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,3,I,23),I=1,49)/
     &   289.01031D0,208.43709D0,150.23653D0,123.98669D0,108.15595D0,
     &    97.25583D0, 69.76177D0, 49.73855D0, 40.60409D0, 35.03629D0,
     &    31.08496D0, 21.16773D0, 13.99081D0, 10.80513D0,  8.91469D0,
     &     7.63597D0,  5.98282D0,  4.54504D0,  3.24687D0,  2.51128D0,
     &     1.69316D0,  1.24243D0,  0.95435D0,  0.71223D0,  0.54431D0,
     &     0.42170D0,  0.32889D0,  0.25710D0,  0.20110D0,  0.15697D0,
     &     0.12195D0,  0.09429D0,  0.07242D0,  0.05518D0,  0.04175D0,
     &     0.03132D0,  0.02316D0,  0.01693D0,  0.01232D0,  0.00878D0,
     &     0.00615D0,  0.00426D0,  0.00288D0,  0.00124D0,  0.00048D0,
     &     0.00016D0,  0.00004D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,3,I,24),I=1,49)/
     &   315.12421D0,225.74153D0,161.61246D0,132.84715D0,115.55888D0,
     &   103.68510D0, 73.86555D0, 52.29894D0, 42.51674D0, 36.57598D0,
     &    32.37159D0, 21.87235D0, 14.33730D0, 11.01653D0,  9.05547D0,
     &     7.73389D0,  6.03187D0,  4.55934D0,  3.23736D0,  2.49207D0,
     &     1.66734D0,  1.21544D0,  0.92800D0,  0.68769D0,  0.52210D0,
     &     0.40197D0,  0.31164D0,  0.24228D0,  0.18850D0,  0.14640D0,
     &     0.11322D0,  0.08715D0,  0.06666D0,  0.05059D0,  0.03813D0,
     &     0.02850D0,  0.02101D0,  0.01531D0,  0.01111D0,  0.00790D0,
     &     0.00552D0,  0.00382D0,  0.00258D0,  0.00111D0,  0.00043D0,
     &     0.00014D0,  0.00004D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,3,I,25),I=1,49)/
     &   342.80673D0,243.95296D0,173.49684D0,142.06322D0,123.23465D0,
     &   110.33495D0, 78.07693D0, 54.90473D0, 44.45325D0, 38.12883D0,
     &    33.66507D0, 22.57285D0, 14.67683D0, 11.22134D0,  9.19035D0,
     &     7.82660D0,  6.07682D0,  4.57070D0,  3.22605D0,  2.47181D0,
     &     1.64130D0,  1.18872D0,  0.90224D0,  0.66398D0,  0.50084D0,
     &     0.38326D0,  0.29541D0,  0.22842D0,  0.17680D0,  0.13666D0,
     &     0.10521D0,  0.08063D0,  0.06143D0,  0.04643D0,  0.03487D0,
     &     0.02598D0,  0.01909D0,  0.01388D0,  0.01004D0,  0.00712D0,
     &     0.00496D0,  0.00343D0,  0.00231D0,  0.00099D0,  0.00038D0,
     &     0.00013D0,  0.00004D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,3,I,26),I=1,49)/
     &   370.71918D0,262.16998D0,185.28712D0,151.16048D0,130.78375D0,
     &   116.85600D0, 82.16776D0, 57.40948D0, 46.30192D0, 39.60334D0,
     &    34.88776D0, 23.22383D0, 14.98428D0, 11.40259D0,  9.30664D0,
     &     7.90402D0,  6.11093D0,  4.57472D0,  3.21035D0,  2.44880D0,
     &     1.61427D0,  1.16192D0,  0.87693D0,  0.64114D0,  0.48063D0,
     &     0.36570D0,  0.28035D0,  0.21566D0,  0.16615D0,  0.12784D0,
     &     0.09801D0,  0.07482D0,  0.05679D0,  0.04277D0,  0.03202D0,
     &     0.02378D0,  0.01743D0,  0.01263D0,  0.00912D0,  0.00645D0,
     &     0.00449D0,  0.00310D0,  0.00208D0,  0.00089D0,  0.00034D0,
     &     0.00012D0,  0.00003D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,3,I,27),I=1,49)/
     &   398.31635D0,280.05777D0,196.78310D0,159.99336D0,138.09111D0,
     &   123.15311D0, 86.08746D0, 59.78946D0, 48.04917D0, 40.99130D0,
     &    36.03455D0, 23.82682D0, 15.26416D0, 11.56505D0,  9.40909D0,
     &     7.97073D0,  6.13825D0,  4.57511D0,  3.19349D0,  2.42581D0,
     &     1.58834D0,  1.13668D0,  0.85340D0,  0.62017D0,  0.46227D0,
     &     0.34987D0,  0.26689D0,  0.20435D0,  0.15674D0,  0.12011D0,
     &     0.09172D0,  0.06977D0,  0.05278D0,  0.03962D0,  0.02958D0,
     &     0.02190D0,  0.01601D0,  0.01157D0,  0.00834D0,  0.00589D0,
     &     0.00409D0,  0.00282D0,  0.00189D0,  0.00081D0,  0.00031D0,
     &     0.00010D0,  0.00003D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,3,I,28),I=1,49)/
     &   425.10541D0,297.30496D0,207.79007D0,168.41481D0,145.03664D0,
     &   129.12375D0, 89.77434D0, 62.00834D0, 49.66874D0, 42.27205D0,
     &    37.08847D0, 24.37295D0, 15.51221D0, 11.70602D0,  9.49577D0,
     &     8.02523D0,  6.15776D0,  4.57120D0,  3.17506D0,  2.40249D0,
     &     1.56325D0,  1.11278D0,  0.83141D0,  0.60084D0,  0.44554D0,
     &     0.33559D0,  0.25483D0,  0.19432D0,  0.14844D0,  0.11333D0,
     &     0.08624D0,  0.06537D0,  0.04932D0,  0.03692D0,  0.02748D0,
     &     0.02030D0,  0.01481D0,  0.01068D0,  0.00768D0,  0.00541D0,
     &     0.00376D0,  0.00258D0,  0.00173D0,  0.00074D0,  0.00028D0,
     &     0.00010D0,  0.00003D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,3,I,29),I=1,49)/
     &   452.96622D0,315.13217D0,219.09509D0,177.03108D0,152.12305D0,
     &   135.20210D0, 93.50108D0, 64.23380D0, 51.28493D0, 43.54515D0,
     &    38.13279D0, 24.90754D0, 15.75054D0, 11.83897D0,  9.57579D0,
     &     8.07414D0,  6.17308D0,  4.56436D0,  3.15482D0,  2.37807D0,
     &     1.53780D0,  1.08891D0,  0.80971D0,  0.58195D0,  0.42935D0,
     &     0.32187D0,  0.24333D0,  0.18479D0,  0.14060D0,  0.10697D0,
     &     0.08112D0,  0.06130D0,  0.04611D0,  0.03442D0,  0.02556D0,
     &     0.01884D0,  0.01371D0,  0.00987D0,  0.00709D0,  0.00499D0,
     &     0.00346D0,  0.00237D0,  0.00159D0,  0.00068D0,  0.00026D0,
     &     0.00009D0,  0.00002D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,3,I,30),I=1,49)/
     &   481.05176D0,332.98895D0,230.34398D0,185.57016D0,159.12541D0,
     &   141.19426D0, 97.14677D0, 66.39220D0, 52.84356D0, 44.76743D0,
     &    39.13180D0, 25.41137D0, 15.96984D0, 11.95815D0,  9.64523D0,
     &     8.11468D0,  6.18265D0,  4.55389D0,  3.13269D0,  2.35270D0,
     &     1.51231D0,  1.06542D0,  0.78862D0,  0.56381D0,  0.41396D0,
     &     0.30893D0,  0.23257D0,  0.17592D0,  0.13335D0,  0.10111D0,
     &     0.07645D0,  0.05760D0,  0.04319D0,  0.03217D0,  0.02383D0,
     &     0.01753D0,  0.01273D0,  0.00915D0,  0.00656D0,  0.00461D0,
     &     0.00319D0,  0.00219D0,  0.00146D0,  0.00062D0,  0.00024D0,
     &     0.00008D0,  0.00002D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,3,I,31),I=1,49)/
     &   508.69336D0,350.46606D0,241.29128D0,193.85184D0,165.89978D0,
     &   146.97998D0,100.64462D0, 68.44891D0, 54.32217D0, 45.92301D0,
     &    40.07352D0, 25.88124D0, 16.17098D0, 12.06571D0,  9.70659D0,
     &     8.14933D0,  6.18899D0,  4.54214D0,  3.11075D0,  2.32815D0,
     &     1.48813D0,  1.04340D0,  0.76902D0,  0.54710D0,  0.39988D0,
     &     0.29718D0,  0.22284D0,  0.16794D0,  0.12688D0,  0.09590D0,
     &     0.07230D0,  0.05433D0,  0.04063D0,  0.03020D0,  0.02232D0,
     &     0.01639D0,  0.01188D0,  0.00852D0,  0.00610D0,  0.00428D0,
     &     0.00296D0,  0.00203D0,  0.00136D0,  0.00057D0,  0.00022D0,
     &     0.00007D0,  0.00002D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,3,I,32),I=1,49)/
     &   535.18030D0,367.11212D0,251.65173D0,201.65910D0,172.26764D0,
     &   152.40591D0,103.89980D0, 70.34598D0, 55.67789D0, 46.97741D0,
     &    40.92907D0, 26.30087D0, 16.34517D0, 12.15570D0,  9.75539D0,
     &     8.17448D0,  6.18955D0,  4.52735D0,  3.08788D0,  2.30359D0,
     &     1.46475D0,  1.02248D0,  0.75063D0,  0.53161D0,  0.38695D0,
     &     0.28648D0,  0.21405D0,  0.16077D0,  0.12112D0,  0.09128D0,
     &     0.06863D0,  0.05145D0,  0.03839D0,  0.02847D0,  0.02101D0,
     &     0.01540D0,  0.01114D0,  0.00798D0,  0.00571D0,  0.00400D0,
     &     0.00276D0,  0.00189D0,  0.00126D0,  0.00054D0,  0.00020D0,
     &     0.00007D0,  0.00002D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,3,I,33),I=1,49)/
     &   563.08673D0,384.57391D0,262.47256D0,209.79239D0,178.88937D0,
     &   158.04028D0,107.26506D0, 72.29848D0, 57.06943D0, 48.05758D0,
     &    41.80413D0, 26.72791D0, 16.52149D0, 12.24650D0,  9.80451D0,
     &     8.19975D0,  6.19012D0,  4.51259D0,  3.06514D0,  2.27926D0,
     &     1.44171D0,  1.00196D0,  0.73265D0,  0.51654D0,  0.37443D0,
     &     0.27615D0,  0.20559D0,  0.15389D0,  0.11561D0,  0.08687D0,
     &     0.06514D0,  0.04872D0,  0.03627D0,  0.02685D0,  0.01977D0,
     &     0.01446D0,  0.01045D0,  0.00747D0,  0.00534D0,  0.00374D0,
     &     0.00258D0,  0.00176D0,  0.00118D0,  0.00050D0,  0.00019D0,
     &     0.00006D0,  0.00002D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,3,I,34),I=1,49)/
     &   590.49207D0,401.61096D0,272.95639D0,217.63766D0,185.25558D0,
     &   163.44283D0,110.46277D0, 74.13376D0, 58.36747D0, 49.05885D0,
     &    42.61046D0, 27.11206D0, 16.67322D0, 12.31989D0,  9.84041D0,
     &     8.21457D0,  6.18338D0,  4.49312D0,  3.03982D0,  2.25340D0,
     &     1.41818D0,  0.98144D0,  0.71494D0,  0.50189D0,  0.36238D0,
     &     0.26631D0,  0.19763D0,  0.14748D0,  0.11046D0,  0.08279D0,
     &     0.06193D0,  0.04622D0,  0.03434D0,  0.02537D0,  0.01865D0,
     &     0.01362D0,  0.00983D0,  0.00702D0,  0.00501D0,  0.00351D0,
     &     0.00242D0,  0.00165D0,  0.00110D0,  0.00046D0,  0.00018D0,
     &     0.00006D0,  0.00002D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,3,I,35),I=1,49)/
     &   617.67798D0,418.44214D0,283.27148D0,225.33791D0,191.49365D0,
     &   168.72942D0,113.57884D0, 75.91459D0, 59.62379D0, 50.02613D0,
     &    43.38823D0, 27.48080D0, 16.81807D0, 12.38969D0,  9.87443D0,
     &     8.22855D0,  6.17694D0,  4.47470D0,  3.01600D0,  2.22915D0,
     &     1.39622D0,  0.96237D0,  0.69854D0,  0.48839D0,  0.35132D0,
     &     0.25731D0,  0.19037D0,  0.14164D0,  0.10579D0,  0.07911D0,
     &     0.05904D0,  0.04396D0,  0.03261D0,  0.02405D0,  0.01765D0,
     &     0.01287D0,  0.00928D0,  0.00662D0,  0.00472D0,  0.00330D0,
     &     0.00227D0,  0.00155D0,  0.00103D0,  0.00044D0,  0.00017D0,
     &     0.00006D0,  0.00002D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,3,I,36),I=1,49)/
     &   643.85529D0,434.56937D0,293.10349D0,232.65437D0,197.40677D0,
     &   173.73129D0,116.50865D0, 77.57690D0, 60.79072D0, 50.92106D0,
     &    44.10533D0, 27.81589D0, 16.94600D0, 12.44906D0,  9.90141D0,
     &     8.23759D0,  6.16791D0,  4.45540D0,  2.99242D0,  2.20560D0,
     &     1.37532D0,  0.94442D0,  0.68324D0,  0.47589D0,  0.34114D0,
     &     0.24908D0,  0.18375D0,  0.13636D0,  0.10159D0,  0.07580D0,
     &     0.05645D0,  0.04195D0,  0.03106D0,  0.02287D0,  0.01676D0,
     &     0.01221D0,  0.00879D0,  0.00626D0,  0.00446D0,  0.00311D0,
     &     0.00214D0,  0.00146D0,  0.00097D0,  0.00041D0,  0.00016D0,
     &     0.00005D0,  0.00001D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,3,I,37),I=1,49)/
     &   670.62598D0,450.98129D0,303.05762D0,240.03790D0,203.35986D0,
     &   178.75746D0,119.43383D0, 79.22430D0, 61.94125D0, 51.79964D0,
     &    44.80675D0, 28.13850D0, 17.06516D0, 12.50182D0,  9.92310D0,
     &     8.24227D0,  6.15572D0,  4.43398D0,  2.96756D0,  2.18122D0,
     &     1.35409D0,  0.92638D0,  0.66799D0,  0.46354D0,  0.33115D0,
     &     0.24105D0,  0.17731D0,  0.13125D0,  0.09756D0,  0.07262D0,
     &     0.05397D0,  0.04005D0,  0.02960D0,  0.02176D0,  0.01592D0,
     &     0.01159D0,  0.00833D0,  0.00593D0,  0.00422D0,  0.00294D0,
     &     0.00202D0,  0.00138D0,  0.00092D0,  0.00039D0,  0.00015D0,
     &     0.00005D0,  0.00001D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,3,I,38),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I, 1),I=1,49)/
     &     0.86800D0,  0.76598D0,  0.67520D0,  0.62675D0,  0.59428D0,
     &     0.57013D0,  0.50046D0,  0.43816D0,  0.40484D0,  0.38253D0,
     &     0.36613D0,  0.31874D0,  0.27654D0,  0.25397D0,  0.23882D0,
     &     0.22750D0,  0.21099D0,  0.19387D0,  0.17401D0,  0.15872D0,
     &     0.13363D0,  0.11222D0,  0.09356D0,  0.07392D0,  0.05824D0,
     &     0.04613D0,  0.03700D0,  0.03017D0,  0.02498D0,  0.02125D0,
     &     0.01786D0,  0.01513D0,  0.01268D0,  0.01040D0,  0.00852D0,
     &     0.00674D0,  0.00520D0,  0.00388D0,  0.00299D0,  0.00201D0,
     &     0.00134D0,  0.00094D0,  0.00051D0,  0.00021D0,  0.00007D0,
     &     0.00003D0, -0.00001D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I, 2),I=1,49)/
     &     0.88205D0,  0.77983D0,  0.68869D0,  0.63997D0,  0.60729D0,
     &     0.58296D0,  0.51264D0,  0.44961D0,  0.41580D0,  0.39312D0,
     &     0.37640D0,  0.32792D0,  0.28442D0,  0.26097D0,  0.24515D0,
     &     0.23328D0,  0.21590D0,  0.19782D0,  0.17683D0,  0.16077D0,
     &     0.13467D0,  0.11273D0,  0.09381D0,  0.07406D0,  0.05839D0,
     &     0.04632D0,  0.03722D0,  0.03037D0,  0.02516D0,  0.02135D0,
     &     0.01792D0,  0.01513D0,  0.01262D0,  0.01032D0,  0.00842D0,
     &     0.00664D0,  0.00510D0,  0.00380D0,  0.00291D0,  0.00197D0,
     &     0.00130D0,  0.00091D0,  0.00051D0,  0.00020D0,  0.00007D0,
     &     0.00002D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I, 3),I=1,49)/
     &     0.91886D0,  0.81356D0,  0.71953D0,  0.66920D0,  0.63541D0,
     &     0.61023D0,  0.53738D0,  0.47189D0,  0.43666D0,  0.41295D0,
     &     0.39539D0,  0.34428D0,  0.29794D0,  0.27277D0,  0.25567D0,
     &     0.24279D0,  0.22388D0,  0.20416D0,  0.18131D0,  0.16398D0,
     &     0.13630D0,  0.11352D0,  0.09418D0,  0.07425D0,  0.05857D0,
     &     0.04653D0,  0.03744D0,  0.03056D0,  0.02532D0,  0.02139D0,
     &     0.01791D0,  0.01504D0,  0.01246D0,  0.01016D0,  0.00822D0,
     &     0.00648D0,  0.00493D0,  0.00368D0,  0.00278D0,  0.00188D0,
     &     0.00124D0,  0.00086D0,  0.00051D0,  0.00020D0,  0.00006D0,
     &     0.00002D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I, 4),I=1,49)/
     &     0.95997D0,  0.84981D0,  0.75147D0,  0.69884D0,  0.66351D0,
     &     0.63718D0,  0.56100D0,  0.49247D0,  0.45556D0,  0.43069D0,
     &     0.41221D0,  0.35830D0,  0.30918D0,  0.28239D0,  0.26415D0,
     &     0.25039D0,  0.23017D0,  0.20908D0,  0.18474D0,  0.16642D0,
     &     0.13752D0,  0.11409D0,  0.09444D0,  0.07437D0,  0.05864D0,
     &     0.04662D0,  0.03752D0,  0.03063D0,  0.02535D0,  0.02135D0,
     &     0.01783D0,  0.01492D0,  0.01232D0,  0.01000D0,  0.00803D0,
     &     0.00631D0,  0.00479D0,  0.00358D0,  0.00268D0,  0.00180D0,
     &     0.00120D0,  0.00084D0,  0.00049D0,  0.00020D0,  0.00006D0,
     &     0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I, 5),I=1,49)/
     &     1.02269D0,  0.90363D0,  0.79759D0,  0.74093D0,  0.70294D0,
     &     0.67465D0,  0.59289D0,  0.51944D0,  0.47990D0,  0.45324D0,
     &     0.43337D0,  0.37541D0,  0.32249D0,  0.29359D0,  0.27391D0,
     &     0.25907D0,  0.23726D0,  0.21456D0,  0.18851D0,  0.16906D0,
     &     0.13883D0,  0.11469D0,  0.09468D0,  0.07442D0,  0.05863D0,
     &     0.04662D0,  0.03753D0,  0.03061D0,  0.02531D0,  0.02124D0,
     &     0.01767D0,  0.01472D0,  0.01211D0,  0.00977D0,  0.00782D0,
     &     0.00614D0,  0.00464D0,  0.00341D0,  0.00257D0,  0.00173D0,
     &     0.00113D0,  0.00080D0,  0.00046D0,  0.00018D0,  0.00005D0,
     &     0.00002D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I, 6),I=1,49)/
     &     1.08763D0,  0.95875D0,  0.84428D0,  0.78326D0,  0.74239D0,
     &     0.71199D0,  0.62427D0,  0.54563D0,  0.50333D0,  0.47482D0,
     &     0.45353D0,  0.39146D0,  0.33478D0,  0.30385D0,  0.28279D0,
     &     0.26692D0,  0.24362D0,  0.21944D0,  0.19183D0,  0.17138D0,
     &     0.13995D0,  0.11519D0,  0.09486D0,  0.07444D0,  0.05860D0,
     &     0.04659D0,  0.03750D0,  0.03056D0,  0.02523D0,  0.02111D0,
     &     0.01751D0,  0.01454D0,  0.01191D0,  0.00957D0,  0.00764D0,
     &     0.00598D0,  0.00450D0,  0.00328D0,  0.00247D0,  0.00167D0,
     &     0.00107D0,  0.00076D0,  0.00044D0,  0.00016D0,  0.00005D0,
     &     0.00002D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I, 7),I=1,49)/
     &     1.16556D0,  1.02401D0,  0.89875D0,  0.83219D0,  0.78769D0,
     &     0.75465D0,  0.65951D0,  0.57450D0,  0.52889D0,  0.49818D0,
     &     0.47520D0,  0.40838D0,  0.34748D0,  0.31432D0,  0.29177D0,
     &     0.27481D0,  0.24995D0,  0.22424D0,  0.19505D0,  0.17361D0,
     &     0.14101D0,  0.11563D0,  0.09500D0,  0.07441D0,  0.05852D0,
     &     0.04652D0,  0.03740D0,  0.03045D0,  0.02509D0,  0.02093D0,
     &     0.01733D0,  0.01434D0,  0.01170D0,  0.00939D0,  0.00744D0,
     &     0.00582D0,  0.00436D0,  0.00318D0,  0.00238D0,  0.00161D0,
     &     0.00104D0,  0.00073D0,  0.00042D0,  0.00014D0,  0.00005D0,
     &     0.00002D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I, 8),I=1,49)/
     &     1.26306D0,  1.10484D0,  0.96554D0,  0.89180D0,  0.84263D0,
     &     0.80618D0,  0.70157D0,  0.60853D0,  0.55877D0,  0.52532D0,
     &     0.50028D0,  0.42768D0,  0.36175D0,  0.32597D0,  0.30171D0,
     &     0.28349D0,  0.25687D0,  0.22944D0,  0.19851D0,  0.17597D0,
     &     0.14210D0,  0.11607D0,  0.09509D0,  0.07433D0,  0.05839D0,
     &     0.04638D0,  0.03725D0,  0.03028D0,  0.02490D0,  0.02071D0,
     &     0.01710D0,  0.01411D0,  0.01147D0,  0.00917D0,  0.00724D0,
     &     0.00565D0,  0.00421D0,  0.00306D0,  0.00228D0,  0.00155D0,
     &     0.00101D0,  0.00070D0,  0.00040D0,  0.00013D0,  0.00005D0,
     &     0.00002D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I, 9),I=1,49)/
     &     1.36120D0,  1.18550D0,  1.03156D0,  0.95040D0,  0.89642D0,
     &     0.85647D0,  0.74219D0,  0.64102D0,  0.58710D0,  0.55092D0,
     &     0.52385D0,  0.44558D0,  0.37481D0,  0.33656D0,  0.31068D0,
     &     0.29130D0,  0.26304D0,  0.23405D0,  0.20153D0,  0.17803D0,
     &     0.14303D0,  0.11643D0,  0.09515D0,  0.07423D0,  0.05825D0,
     &     0.04622D0,  0.03709D0,  0.03010D0,  0.02471D0,  0.02052D0,
     &     0.01688D0,  0.01389D0,  0.01125D0,  0.00895D0,  0.00706D0,
     &     0.00550D0,  0.00409D0,  0.00295D0,  0.00220D0,  0.00150D0,
     &     0.00098D0,  0.00067D0,  0.00039D0,  0.00013D0,  0.00005D0,
     &     0.00002D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I,10),I=1,49)/
     &     1.47041D0,  1.27446D0,  1.10370D0,  1.01406D0,  0.95460D0,
     &     0.91068D0,  0.78549D0,  0.67526D0,  0.61674D0,  0.57757D0,
     &     0.54827D0,  0.46388D0,  0.38797D0,  0.34713D0,  0.31960D0,
     &     0.29901D0,  0.26910D0,  0.23853D0,  0.20444D0,  0.17998D0,
     &     0.14388D0,  0.11673D0,  0.09517D0,  0.07410D0,  0.05807D0,
     &     0.04602D0,  0.03690D0,  0.02989D0,  0.02450D0,  0.02029D0,
     &     0.01665D0,  0.01365D0,  0.01102D0,  0.00875D0,  0.00689D0,
     &     0.00534D0,  0.00396D0,  0.00285D0,  0.00213D0,  0.00144D0,
     &     0.00094D0,  0.00064D0,  0.00038D0,  0.00013D0,  0.00004D0,
     &     0.00002D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I,11),I=1,49)/
     &     1.56638D0,  1.35212D0,  1.16625D0,  1.06903D0,  1.00469D0,
     &     0.95725D0,  0.82240D0,  0.70420D0,  0.64167D0,  0.59990D0,
     &     0.56868D0,  0.47904D0,  0.39878D0,  0.35576D0,  0.32683D0,
     &     0.30525D0,  0.27397D0,  0.24210D0,  0.20674D0,  0.18151D0,
     &     0.14453D0,  0.11694D0,  0.09517D0,  0.07398D0,  0.05791D0,
     &     0.04585D0,  0.03673D0,  0.02971D0,  0.02433D0,  0.02010D0,
     &     0.01646D0,  0.01346D0,  0.01083D0,  0.00860D0,  0.00675D0,
     &     0.00520D0,  0.00385D0,  0.00277D0,  0.00207D0,  0.00139D0,
     &     0.00090D0,  0.00062D0,  0.00037D0,  0.00013D0,  0.00004D0,
     &     0.00002D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I,12),I=1,49)/
     &     1.80214D0,  1.54109D0,  1.31694D0,  1.20067D0,  1.12412D0,
     &     1.06789D0,  0.90916D0,  0.77146D0,  0.69919D0,  0.65116D0,
     &     0.61534D0,  0.51323D0,  0.42280D0,  0.37478D0,  0.34269D0,
     &     0.31886D0,  0.28449D0,  0.24976D0,  0.21162D0,  0.18471D0,
     &     0.14585D0,  0.11732D0,  0.09509D0,  0.07364D0,  0.05748D0,
     &     0.04542D0,  0.03629D0,  0.02928D0,  0.02389D0,  0.01964D0,
     &     0.01603D0,  0.01303D0,  0.01043D0,  0.00824D0,  0.00644D0,
     &     0.00493D0,  0.00365D0,  0.00261D0,  0.00193D0,  0.00129D0,
     &     0.00082D0,  0.00058D0,  0.00033D0,  0.00012D0,  0.00003D0,
     &     0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I,13),I=1,49)/
     &     2.04055D0,  1.73004D0,  1.46588D0,  1.32988D0,  1.24076D0,
     &     1.17553D0,  0.99250D0,  0.83521D0,  0.75328D0,  0.69907D0,
     &     0.65875D0,  0.54456D0,  0.44445D0,  0.39176D0,  0.35673D0,
     &     0.33084D0,  0.29368D0,  0.25636D0,  0.21574D0,  0.18736D0,
     &     0.14688D0,  0.11755D0,  0.09493D0,  0.07328D0,  0.05705D0,
     &     0.04498D0,  0.03587D0,  0.02887D0,  0.02347D0,  0.01921D0,
     &     0.01564D0,  0.01265D0,  0.01010D0,  0.00793D0,  0.00617D0,
     &     0.00472D0,  0.00348D0,  0.00248D0,  0.00181D0,  0.00123D0,
     &     0.00077D0,  0.00054D0,  0.00031D0,  0.00011D0,  0.00003D0,
     &     0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I,14),I=1,49)/
     &     2.34878D0,  1.97162D0,  1.65417D0,  1.49212D0,  1.38650D0,
     &     1.30951D0,  1.09500D0,  0.91263D0,  0.81846D0,  0.75649D0,
     &     0.71054D0,  0.58140D0,  0.46952D0,  0.41122D0,  0.37271D0,
     &     0.34438D0,  0.30396D0,  0.26367D0,  0.22023D0,  0.19019D0,
     &     0.14790D0,  0.11770D0,  0.09464D0,  0.07279D0,  0.05650D0,
     &     0.04444D0,  0.03534D0,  0.02838D0,  0.02299D0,  0.01873D0,
     &     0.01518D0,  0.01221D0,  0.00971D0,  0.00758D0,  0.00587D0,
     &     0.00448D0,  0.00329D0,  0.00233D0,  0.00171D0,  0.00117D0,
     &     0.00073D0,  0.00051D0,  0.00028D0,  0.00010D0,  0.00003D0,
     &     0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I,15),I=1,49)/
     &     2.72076D0,  2.25974D0,  1.87603D0,  1.68193D0,  1.55614D0,
     &     1.46482D0,  1.21228D0,  1.00004D0,  0.89145D0,  0.82040D0,
     &     0.76790D0,  0.62156D0,  0.49638D0,  0.43184D0,  0.38951D0,
     &     0.35852D0,  0.31456D0,  0.27109D0,  0.22467D0,  0.19292D0,
     &     0.14878D0,  0.11770D0,  0.09423D0,  0.07216D0,  0.05583D0,
     &     0.04380D0,  0.03471D0,  0.02777D0,  0.02242D0,  0.01821D0,
     &     0.01468D0,  0.01176D0,  0.00931D0,  0.00721D0,  0.00560D0,
     &     0.00425D0,  0.00310D0,  0.00215D0,  0.00160D0,  0.00107D0,
     &     0.00067D0,  0.00046D0,  0.00026D0,  0.00009D0,  0.00003D0,
     &     0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I,16),I=1,49)/
     &     3.10372D0,  2.55317D0,  2.09952D0,  1.87189D0,  1.72513D0,
     &     1.61899D0,  1.32738D0,  1.08482D0,  0.96174D0,  0.88163D0,
     &     0.82262D0,  0.65935D0,  0.52128D0,  0.45078D0,  0.40481D0,
     &     0.37132D0,  0.32407D0,  0.27766D0,  0.22852D0,  0.19522D0,
     &     0.14943D0,  0.11759D0,  0.09376D0,  0.07153D0,  0.05518D0,
     &     0.04316D0,  0.03411D0,  0.02721D0,  0.02189D0,  0.01771D0,
     &     0.01421D0,  0.01135D0,  0.00894D0,  0.00691D0,  0.00532D0,
     &     0.00403D0,  0.00292D0,  0.00202D0,  0.00150D0,  0.00098D0,
     &     0.00063D0,  0.00043D0,  0.00024D0,  0.00009D0,  0.00003D0,
     &     0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I,17),I=1,49)/
     &     3.53791D0,  2.88253D0,  2.34786D0,  2.08172D0,  1.91099D0,
     &     1.78798D0,  1.45224D0,  1.17581D0,  1.03669D0,  0.94660D0,
     &     0.88048D0,  0.69881D0,  0.54694D0,  0.47011D0,  0.42034D0,
     &     0.38424D0,  0.33357D0,  0.28414D0,  0.23224D0,  0.19739D0,
     &     0.14997D0,  0.11738D0,  0.09322D0,  0.07083D0,  0.05448D0,
     &     0.04248D0,  0.03349D0,  0.02663D0,  0.02135D0,  0.01720D0,
     &     0.01373D0,  0.01094D0,  0.00857D0,  0.00662D0,  0.00504D0,
     &     0.00382D0,  0.00275D0,  0.00191D0,  0.00140D0,  0.00091D0,
     &     0.00060D0,  0.00040D0,  0.00021D0,  0.00008D0,  0.00002D0,
     &     0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I,18),I=1,49)/
     &     3.93600D0,  3.18179D0,  2.57144D0,  2.26962D0,  2.07679D0,
     &     1.93828D0,  1.56224D0,  1.25519D0,  1.10169D0,  1.00271D0,
     &     0.93026D0,  0.73238D0,  0.56848D0,  0.48622D0,  0.43319D0,
     &     0.39487D0,  0.34131D0,  0.28936D0,  0.23517D0,  0.19905D0,
     &     0.15030D0,  0.11713D0,  0.09270D0,  0.07021D0,  0.05385D0,
     &     0.04190D0,  0.03295D0,  0.02612D0,  0.02087D0,  0.01677D0,
     &     0.01334D0,  0.01060D0,  0.00827D0,  0.00637D0,  0.00486D0,
     &     0.00366D0,  0.00263D0,  0.00181D0,  0.00134D0,  0.00088D0,
     &     0.00056D0,  0.00038D0,  0.00020D0,  0.00007D0,  0.00002D0,
     &     0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I,19),I=1,49)/
     &     4.46512D0,  3.57604D0,  2.86339D0,  2.51369D0,  2.29136D0,
     &     2.13222D0,  1.70289D0,  1.35573D0,  1.18356D0,  1.07308D0,
     &     0.99248D0,  0.77387D0,  0.59477D0,  0.50571D0,  0.44864D0,
     &     0.40759D0,  0.35048D0,  0.29545D0,  0.23852D0,  0.20087D0,
     &     0.15057D0,  0.11671D0,  0.09200D0,  0.06939D0,  0.05304D0,
     &     0.04116D0,  0.03225D0,  0.02548D0,  0.02030D0,  0.01627D0,
     &     0.01289D0,  0.01018D0,  0.00793D0,  0.00608D0,  0.00462D0,
     &     0.00346D0,  0.00247D0,  0.00170D0,  0.00124D0,  0.00082D0,
     &     0.00052D0,  0.00036D0,  0.00020D0,  0.00007D0,  0.00002D0,
     &     0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I,20),I=1,49)/
     &     4.98110D0,  3.95717D0,  3.14315D0,  2.74636D0,  2.49515D0,
     &     2.31589D0,  1.83490D0,  1.44924D0,  1.25928D0,  1.13790D0,
     &     1.04961D0,  0.81156D0,  0.61839D0,  0.52309D0,  0.46234D0,
     &     0.41880D0,  0.35851D0,  0.30072D0,  0.24136D0,  0.20237D0,
     &     0.15073D0,  0.11629D0,  0.09134D0,  0.06865D0,  0.05232D0,
     &     0.04048D0,  0.03163D0,  0.02492D0,  0.01980D0,  0.01582D0,
     &     0.01251D0,  0.00983D0,  0.00765D0,  0.00583D0,  0.00441D0,
     &     0.00330D0,  0.00234D0,  0.00161D0,  0.00116D0,  0.00076D0,
     &     0.00049D0,  0.00034D0,  0.00019D0,  0.00006D0,  0.00002D0,
     &     0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I,21),I=1,49)/
     &     5.48855D0,  4.32906D0,  3.41400D0,  2.97058D0,  2.69088D0,
     &     2.49185D0,  1.96033D0,  1.53734D0,  1.33025D0,  1.19843D0,
     &     1.10279D0,  0.84628D0,  0.63987D0,  0.53877D0,  0.47461D0,
     &     0.42879D0,  0.36557D0,  0.30530D0,  0.24373D0,  0.20356D0,
     &     0.15074D0,  0.11580D0,  0.09065D0,  0.06792D0,  0.05161D0,
     &     0.03984D0,  0.03104D0,  0.02440D0,  0.01932D0,  0.01538D0,
     &     0.01214D0,  0.00950D0,  0.00738D0,  0.00561D0,  0.00423D0,
     &     0.00315D0,  0.00224D0,  0.00152D0,  0.00110D0,  0.00072D0,
     &     0.00045D0,  0.00032D0,  0.00018D0,  0.00006D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I,22),I=1,49)/
     &     6.18910D0,  4.83835D0,  3.78189D0,  3.27368D0,  2.95458D0,
     &     2.72828D0,  2.12748D0,  1.65375D0,  1.42355D0,  1.27771D0,
     &     1.17223D0,  0.89116D0,  0.66734D0,  0.55867D0,  0.49010D0,
     &     0.44134D0,  0.37438D0,  0.31092D0,  0.24658D0,  0.20493D0,
     &     0.15066D0,  0.11512D0,  0.08974D0,  0.06696D0,  0.05069D0,
     &     0.03901D0,  0.03030D0,  0.02374D0,  0.01874D0,  0.01485D0,
     &     0.01168D0,  0.00911D0,  0.00704D0,  0.00533D0,  0.00400D0,
     &     0.00297D0,  0.00211D0,  0.00142D0,  0.00104D0,  0.00068D0,
     &     0.00042D0,  0.00029D0,  0.00017D0,  0.00005D0,  0.00002D0,
     &     0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I,23),I=1,49)/
     &     6.90776D0,  5.35634D0,  4.15288D0,  3.57780D0,  3.21822D0,
     &     2.96398D0,  2.29266D0,  1.76775D0,  1.51442D0,  1.35462D0,
     &     1.23937D0,  0.93411D0,  0.69332D0,  0.57734D0,  0.50454D0,
     &     0.45297D0,  0.38246D0,  0.31600D0,  0.24910D0,  0.20608D0,
     &     0.15048D0,  0.11442D0,  0.08886D0,  0.06603D0,  0.04982D0,
     &     0.03823D0,  0.02961D0,  0.02314D0,  0.01820D0,  0.01437D0,
     &     0.01125D0,  0.00875D0,  0.00671D0,  0.00507D0,  0.00380D0,
     &     0.00282D0,  0.00198D0,  0.00134D0,  0.00099D0,  0.00065D0,
     &     0.00039D0,  0.00026D0,  0.00015D0,  0.00005D0,  0.00002D0,
     &     0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I,24),I=1,49)/
     &     7.62426D0,  5.86871D0,  4.51692D0,  3.87481D0,  3.47482D0,
     &     3.19280D0,  2.45168D0,  1.87657D0,  1.60070D0,  1.42736D0,
     &     1.30266D0,  0.97414D0,  0.71722D0,  0.59437D0,  0.51760D0,
     &     0.46341D0,  0.38962D0,  0.32042D0,  0.25117D0,  0.20694D0,
     &     0.15017D0,  0.11367D0,  0.08795D0,  0.06511D0,  0.04897D0,
     &     0.03748D0,  0.02894D0,  0.02253D0,  0.01769D0,  0.01392D0,
     &     0.01087D0,  0.00842D0,  0.00645D0,  0.00484D0,  0.00362D0,
     &     0.00267D0,  0.00187D0,  0.00128D0,  0.00093D0,  0.00060D0,
     &     0.00037D0,  0.00024D0,  0.00014D0,  0.00004D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I,25),I=1,49)/
     &     8.39819D0,  6.41814D0,  4.90446D0,  4.18965D0,  3.74601D0,
     &     3.43405D0,  2.61811D0,  1.98959D0,  1.68991D0,  1.50231D0,
     &     1.36770D0,  1.01493D0,  0.74134D0,  0.61144D0,  0.53063D0,
     &     0.47380D0,  0.39668D0,  0.32474D0,  0.25316D0,  0.20772D0,
     &     0.14981D0,  0.11289D0,  0.08703D0,  0.06420D0,  0.04813D0,
     &     0.03673D0,  0.02828D0,  0.02194D0,  0.01719D0,  0.01349D0,
     &     0.01049D0,  0.00810D0,  0.00620D0,  0.00463D0,  0.00344D0,
     &     0.00252D0,  0.00177D0,  0.00122D0,  0.00086D0,  0.00056D0,
     &     0.00034D0,  0.00023D0,  0.00012D0,  0.00004D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I,26),I=1,49)/
     &     9.19912D0,  6.98269D0,  5.29980D0,  4.50945D0,  4.02062D0,
     &     3.67776D0,  2.78497D0,  2.10203D0,  1.77824D0,  1.57626D0,
     &     1.43169D0,  1.05466D0,  0.76454D0,  0.62772D0,  0.54298D0,
     &     0.48357D0,  0.40325D0,  0.32867D0,  0.25488D0,  0.20830D0,
     &     0.14936D0,  0.11205D0,  0.08608D0,  0.06328D0,  0.04729D0,
     &     0.03598D0,  0.02762D0,  0.02140D0,  0.01669D0,  0.01307D0,
     &     0.01014D0,  0.00780D0,  0.00595D0,  0.00443D0,  0.00330D0,
     &     0.00240D0,  0.00168D0,  0.00114D0,  0.00081D0,  0.00053D0,
     &     0.00032D0,  0.00022D0,  0.00012D0,  0.00004D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I,27),I=1,49)/
     &    10.00621D0,  7.54783D0,  5.69293D0,  4.82623D0,  4.29189D0,
     &     3.91798D0,  2.94832D0,  2.21133D0,  1.86373D0,  1.64761D0,
     &     1.49327D0,  1.09257D0,  0.78647D0,  0.64301D0,  0.55451D0,
     &     0.49265D0,  0.40930D0,  0.33223D0,  0.25638D0,  0.20876D0,
     &     0.14886D0,  0.11122D0,  0.08517D0,  0.06240D0,  0.04650D0,
     &     0.03528D0,  0.02702D0,  0.02089D0,  0.01623D0,  0.01267D0,
     &     0.00980D0,  0.00752D0,  0.00573D0,  0.00425D0,  0.00316D0,
     &     0.00230D0,  0.00159D0,  0.00107D0,  0.00077D0,  0.00050D0,
     &     0.00030D0,  0.00020D0,  0.00011D0,  0.00003D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I,28),I=1,49)/
     &    10.80590D0,  8.10435D0,  6.07766D0,  5.13510D0,  4.55568D0,
     &     4.15111D0,  3.10583D0,  2.31601D0,  1.94527D0,  1.71546D0,
     &     1.55167D0,  1.12822D0,  0.80689D0,  0.65715D0,  0.56511D0,
     &     0.50095D0,  0.41476D0,  0.33539D0,  0.25764D0,  0.20907D0,
     &     0.14833D0,  0.11039D0,  0.08428D0,  0.06155D0,  0.04576D0,
     &     0.03462D0,  0.02647D0,  0.02040D0,  0.01582D0,  0.01230D0,
     &     0.00949D0,  0.00726D0,  0.00551D0,  0.00409D0,  0.00302D0,
     &     0.00221D0,  0.00152D0,  0.00102D0,  0.00073D0,  0.00048D0,
     &     0.00029D0,  0.00019D0,  0.00010D0,  0.00004D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I,29),I=1,49)/
     &    11.65207D0,  8.68978D0,  6.48001D0,  5.45700D0,  4.82993D0,
     &     4.39300D0,  3.26826D0,  2.42329D0,  2.02852D0,  1.78454D0,
     &     1.61099D0,  1.16415D0,  0.82729D0,  0.67117D0,  0.57557D0,
     &     0.50910D0,  0.42008D0,  0.33842D0,  0.25880D0,  0.20930D0,
     &     0.14773D0,  0.10953D0,  0.08337D0,  0.06069D0,  0.04500D0,
     &     0.03397D0,  0.02591D0,  0.01991D0,  0.01541D0,  0.01194D0,
     &     0.00919D0,  0.00702D0,  0.00530D0,  0.00393D0,  0.00290D0,
     &     0.00211D0,  0.00145D0,  0.00096D0,  0.00070D0,  0.00045D0,
     &     0.00028D0,  0.00018D0,  0.00010D0,  0.00003D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I,30),I=1,49)/
     &    12.52131D0,  9.28774D0,  6.88859D0,  5.78276D0,  5.10678D0,
     &     4.63673D0,  3.43094D0,  2.53005D0,  2.11104D0,  1.85281D0,
     &     1.66948D0,  1.19929D0,  0.84705D0,  0.68466D0,  0.58556D0,
     &     0.51685D0,  0.42507D0,  0.34121D0,  0.25979D0,  0.20942D0,
     &     0.14709D0,  0.10866D0,  0.08245D0,  0.05983D0,  0.04425D0,
     &     0.03334D0,  0.02536D0,  0.01943D0,  0.01501D0,  0.01160D0,
     &     0.00891D0,  0.00678D0,  0.00511D0,  0.00378D0,  0.00279D0,
     &     0.00202D0,  0.00138D0,  0.00091D0,  0.00067D0,  0.00043D0,
     &     0.00026D0,  0.00018D0,  0.00010D0,  0.00003D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I,31),I=1,49)/
     &    13.38978D0,  9.88200D0,  7.29246D0,  6.10376D0,  5.37897D0,
     &     4.87592D0,  3.58970D0,  2.63365D0,  2.19084D0,  1.91866D0,
     &     1.72578D0,  1.23288D0,  0.86578D0,  0.69738D0,  0.59494D0,
     &     0.52409D0,  0.42970D0,  0.34375D0,  0.26065D0,  0.20947D0,
     &     0.14644D0,  0.10781D0,  0.08158D0,  0.05902D0,  0.04354D0,
     &     0.03274D0,  0.02484D0,  0.01899D0,  0.01463D0,  0.01128D0,
     &     0.00865D0,  0.00657D0,  0.00493D0,  0.00364D0,  0.00268D0,
     &     0.00194D0,  0.00132D0,  0.00087D0,  0.00064D0,  0.00041D0,
     &     0.00025D0,  0.00017D0,  0.00009D0,  0.00003D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I,32),I=1,49)/
     &    14.23688D0, 10.45864D0,  7.68231D0,  6.41264D0,  5.64030D0,
     &     5.10517D0,  3.74102D0,  2.73180D0,  2.26617D0,  1.98065D0,
     &     1.77865D0,  1.26417D0,  0.88305D0,  0.70902D0,  0.60346D0,
     &     0.53062D0,  0.43382D0,  0.34595D0,  0.26134D0,  0.20941D0,
     &     0.14577D0,  0.10696D0,  0.08072D0,  0.05825D0,  0.04287D0,
     &     0.03215D0,  0.02436D0,  0.01857D0,  0.01428D0,  0.01098D0,
     &     0.00840D0,  0.00638D0,  0.00476D0,  0.00351D0,  0.00258D0,
     &     0.00187D0,  0.00127D0,  0.00083D0,  0.00061D0,  0.00039D0,
     &     0.00024D0,  0.00016D0,  0.00009D0,  0.00002D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I,33),I=1,49)/
     &    15.13941D0, 11.07021D0,  8.09390D0,  6.73786D0,  5.91493D0,
     &     5.34574D0,  3.89907D0,  2.83385D0,  2.34427D0,  2.04479D0,
     &     1.83327D0,  1.29634D0,  0.90070D0,  0.72088D0,  0.61213D0,
     &     0.53725D0,  0.43798D0,  0.34817D0,  0.26202D0,  0.20935D0,
     &     0.14510D0,  0.10612D0,  0.07988D0,  0.05749D0,  0.04221D0,
     &     0.03158D0,  0.02388D0,  0.01816D0,  0.01393D0,  0.01069D0,
     &     0.00816D0,  0.00620D0,  0.00459D0,  0.00338D0,  0.00248D0,
     &     0.00179D0,  0.00121D0,  0.00080D0,  0.00058D0,  0.00037D0,
     &     0.00022D0,  0.00014D0,  0.00008D0,  0.00002D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I,34),I=1,49)/
     &    16.04276D0, 11.67919D0,  8.50158D0,  7.05899D0,  6.18548D0,
     &     5.58230D0,  4.05359D0,  2.93300D0,  2.41985D0,  2.10667D0,
     &     1.88583D0,  1.32700D0,  0.91732D0,  0.73194D0,  0.62013D0,
     &     0.54331D0,  0.44171D0,  0.35007D0,  0.26248D0,  0.20913D0,
     &     0.14434D0,  0.10523D0,  0.07901D0,  0.05671D0,  0.04155D0,
     &     0.03102D0,  0.02340D0,  0.01777D0,  0.01360D0,  0.01042D0,
     &     0.00793D0,  0.00600D0,  0.00446D0,  0.00326D0,  0.00238D0,
     &     0.00173D0,  0.00118D0,  0.00076D0,  0.00055D0,  0.00036D0,
     &     0.00022D0,  0.00014D0,  0.00007D0,  0.00002D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I,35),I=1,49)/
     &    16.94849D0, 12.28721D0,  8.90688D0,  7.37746D0,  6.45332D0,
     &     5.81617D0,  4.20570D0,  3.03017D0,  2.49373D0,  2.16705D0,
     &     1.93704D0,  1.35674D0,  0.93336D0,  0.74257D0,  0.62781D0,
     &     0.54911D0,  0.44527D0,  0.35187D0,  0.26291D0,  0.20892D0,
     &     0.14363D0,  0.10440D0,  0.07819D0,  0.05599D0,  0.04092D0,
     &     0.03050D0,  0.02296D0,  0.01740D0,  0.01329D0,  0.01017D0,
     &     0.00772D0,  0.00583D0,  0.00433D0,  0.00315D0,  0.00229D0,
     &     0.00167D0,  0.00114D0,  0.00073D0,  0.00053D0,  0.00035D0,
     &     0.00021D0,  0.00013D0,  0.00007D0,  0.00002D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I,36),I=1,49)/
     &    17.83243D0, 12.87802D0,  9.29900D0,  7.68475D0,  6.71127D0,
     &     6.04107D0,  4.35129D0,  3.12272D0,  2.56388D0,  2.22424D0,
     &     1.98545D0,  1.38466D0,  0.94830D0,  0.75241D0,  0.63488D0,
     &     0.55441D0,  0.44848D0,  0.35346D0,  0.26323D0,  0.20867D0,
     &     0.14292D0,  0.10358D0,  0.07741D0,  0.05529D0,  0.04033D0,
     &     0.03000D0,  0.02255D0,  0.01705D0,  0.01300D0,  0.00993D0,
     &     0.00753D0,  0.00566D0,  0.00421D0,  0.00306D0,  0.00221D0,
     &     0.00161D0,  0.00110D0,  0.00071D0,  0.00051D0,  0.00034D0,
     &     0.00020D0,  0.00013D0,  0.00007D0,  0.00002D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I,37),I=1,49)/
     &    18.74867D0, 13.48785D0,  9.70200D0,  7.99976D0,  6.97522D0,
     &     6.27087D0,  4.49936D0,  3.21639D0,  2.63465D0,  2.28182D0,
     &     2.03408D0,  1.41252D0,  0.96307D0,  0.76207D0,  0.64176D0,
     &     0.55956D0,  0.45155D0,  0.35492D0,  0.26347D0,  0.20834D0,
     &     0.14216D0,  0.10274D0,  0.07660D0,  0.05459D0,  0.03974D0,
     &     0.02950D0,  0.02213D0,  0.01670D0,  0.01272D0,  0.00970D0,
     &     0.00733D0,  0.00550D0,  0.00408D0,  0.00297D0,  0.00214D0,
     &     0.00155D0,  0.00105D0,  0.00068D0,  0.00049D0,  0.00032D0,
     &     0.00018D0,  0.00012D0,  0.00007D0,  0.00002D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,4,I,38),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I, 1),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I, 2),I=1,49)/
     &     0.00003D0,  0.00003D0,  0.00002D0,  0.00002D0,  0.00002D0,
     &     0.00002D0,  0.00002D0,  0.00002D0,  0.00002D0,  0.00002D0,
     &     0.00002D0,  0.00002D0,  0.00002D0,  0.00002D0,  0.00002D0,
     &     0.00002D0,  0.00002D0,  0.00001D0,  0.00001D0,  0.00001D0,
     &     0.00001D0,  0.00001D0,  0.00001D0,  0.00001D0,  0.00001D0,
     &     0.00001D0,  0.00001D0,  0.00001D0,  0.00001D0,  0.00001D0,
     &     0.00001D0,  0.00001D0,  0.00001D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I, 3),I=1,49)/
     &     0.03227D0,  0.02900D0,  0.02605D0,  0.02445D0,  0.02338D0,
     &     0.02257D0,  0.02019D0,  0.01798D0,  0.01674D0,  0.01586D0,
     &     0.01516D0,  0.01302D0,  0.01084D0,  0.00956D0,  0.00865D0,
     &     0.00795D0,  0.00692D0,  0.00587D0,  0.00477D0,  0.00405D0,
     &     0.00317D0,  0.00263D0,  0.00225D0,  0.00190D0,  0.00163D0,
     &     0.00139D0,  0.00119D0,  0.00101D0,  0.00085D0,  0.00072D0,
     &     0.00059D0,  0.00048D0,  0.00039D0,  0.00031D0,  0.00025D0,
     &     0.00019D0,  0.00015D0,  0.00011D0,  0.00008D0,  0.00006D0,
     &     0.00004D0,  0.00003D0,  0.00002D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I, 4),I=1,49)/
     &     0.08412D0,  0.07493D0,  0.06672D0,  0.06231D0,  0.05935D0,
     &     0.05713D0,  0.05068D0,  0.04474D0,  0.04144D0,  0.03913D0,
     &     0.03731D0,  0.03177D0,  0.02623D0,  0.02303D0,  0.02077D0,
     &     0.01905D0,  0.01652D0,  0.01397D0,  0.01129D0,  0.00957D0,
     &     0.00745D0,  0.00615D0,  0.00525D0,  0.00441D0,  0.00375D0,
     &     0.00320D0,  0.00272D0,  0.00230D0,  0.00193D0,  0.00161D0,
     &     0.00132D0,  0.00108D0,  0.00087D0,  0.00069D0,  0.00054D0,
     &     0.00042D0,  0.00032D0,  0.00024D0,  0.00018D0,  0.00013D0,
     &     0.00009D0,  0.00006D0,  0.00004D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I, 5),I=1,49)/
     &     0.14877D0,  0.13082D0,  0.11499D0,  0.10659D0,  0.10097D0,
     &     0.09680D0,  0.08477D0,  0.07388D0,  0.06791D0,  0.06379D0,
     &     0.06056D0,  0.05091D0,  0.04152D0,  0.03619D0,  0.03249D0,
     &     0.02969D0,  0.02561D0,  0.02153D0,  0.01729D0,  0.01459D0,
     &     0.01127D0,  0.00925D0,  0.00785D0,  0.00655D0,  0.00553D0,
     &     0.00469D0,  0.00396D0,  0.00333D0,  0.00278D0,  0.00231D0,
     &     0.00189D0,  0.00153D0,  0.00123D0,  0.00097D0,  0.00076D0,
     &     0.00059D0,  0.00045D0,  0.00034D0,  0.00025D0,  0.00018D0,
     &     0.00012D0,  0.00009D0,  0.00006D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I, 6),I=1,49)/
     &     0.22202D0,  0.19306D0,  0.16779D0,  0.15452D0,  0.14570D0,
     &     0.13918D0,  0.12051D0,  0.10386D0,  0.09484D0,  0.08868D0,
     &     0.08388D0,  0.06972D0,  0.05624D0,  0.04872D0,  0.04355D0,
     &     0.03966D0,  0.03405D0,  0.02848D0,  0.02274D0,  0.01911D0,
     &     0.01466D0,  0.01197D0,  0.01011D0,  0.00838D0,  0.00703D0,
     &     0.00592D0,  0.00498D0,  0.00416D0,  0.00346D0,  0.00286D0,
     &     0.00233D0,  0.00188D0,  0.00150D0,  0.00118D0,  0.00092D0,
     &     0.00071D0,  0.00054D0,  0.00041D0,  0.00030D0,  0.00021D0,
     &     0.00015D0,  0.00010D0,  0.00007D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I, 7),I=1,49)/
     &     0.30272D0,  0.26063D0,  0.22430D0,  0.20535D0,  0.19284D0,
     &     0.18362D0,  0.15743D0,  0.13433D0,  0.12195D0,  0.11355D0,
     &     0.10705D0,  0.08808D0,  0.07034D0,  0.06058D0,  0.05394D0,
     &     0.04898D0,  0.04185D0,  0.03485D0,  0.02767D0,  0.02316D0,
     &     0.01766D0,  0.01434D0,  0.01204D0,  0.00992D0,  0.00828D0,
     &     0.00693D0,  0.00580D0,  0.00482D0,  0.00399D0,  0.00328D0,
     &     0.00266D0,  0.00214D0,  0.00170D0,  0.00133D0,  0.00104D0,
     &     0.00080D0,  0.00060D0,  0.00045D0,  0.00033D0,  0.00024D0,
     &     0.00016D0,  0.00011D0,  0.00007D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I, 8),I=1,49)/
     &     0.40640D0,  0.34641D0,  0.29514D0,  0.26863D0,  0.25121D0,
     &     0.23843D0,  0.20237D0,  0.17095D0,  0.15427D0,  0.14303D0,
     &     0.13440D0,  0.10944D0,  0.08650D0,  0.07407D0,  0.06568D0,
     &     0.05945D0,  0.05056D0,  0.04189D0,  0.03309D0,  0.02757D0,
     &     0.02089D0,  0.01686D0,  0.01408D0,  0.01153D0,  0.00956D0,
     &     0.00796D0,  0.00662D0,  0.00548D0,  0.00451D0,  0.00369D0,
     &     0.00298D0,  0.00239D0,  0.00189D0,  0.00148D0,  0.00114D0,
     &     0.00087D0,  0.00066D0,  0.00049D0,  0.00037D0,  0.00026D0,
     &     0.00018D0,  0.00012D0,  0.00007D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I, 9),I=1,49)/
     &     0.51210D0,  0.43288D0,  0.36574D0,  0.33126D0,  0.30871D0,
     &     0.29222D0,  0.24594D0,  0.20601D0,  0.18499D0,  0.17091D0,
     &     0.16014D0,  0.12927D0,  0.10130D0,  0.08631D0,  0.07626D0,
     &     0.06885D0,  0.05833D0,  0.04813D0,  0.03783D0,  0.03141D0,
     &     0.02366D0,  0.01900D0,  0.01580D0,  0.01287D0,  0.01061D0,
     &     0.00880D0,  0.00728D0,  0.00600D0,  0.00491D0,  0.00401D0,
     &     0.00322D0,  0.00257D0,  0.00203D0,  0.00158D0,  0.00122D0,
     &     0.00093D0,  0.00070D0,  0.00052D0,  0.00039D0,  0.00028D0,
     &     0.00018D0,  0.00012D0,  0.00007D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I,10),I=1,49)/
     &     0.62615D0,  0.52524D0,  0.44038D0,  0.39709D0,  0.36888D0,
     &     0.34831D0,  0.29091D0,  0.24179D0,  0.21613D0,  0.19903D0,
     &     0.18601D0,  0.14895D0,  0.11579D0,  0.09820D0,  0.08649D0,
     &     0.07789D0,  0.06575D0,  0.05404D0,  0.04228D0,  0.03498D0,
     &     0.02621D0,  0.02095D0,  0.01734D0,  0.01405D0,  0.01153D0,
     &     0.00952D0,  0.00784D0,  0.00644D0,  0.00525D0,  0.00426D0,
     &     0.00342D0,  0.00272D0,  0.00213D0,  0.00166D0,  0.00127D0,
     &     0.00097D0,  0.00073D0,  0.00054D0,  0.00040D0,  0.00029D0,
     &     0.00019D0,  0.00013D0,  0.00007D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I,11),I=1,49)/
     &     0.72756D0,  0.60673D0,  0.50572D0,  0.45443D0,  0.42111D0,
     &     0.39687D0,  0.32951D0,  0.27226D0,  0.24251D0,  0.22276D0,
     &     0.20777D0,  0.16535D0,  0.12775D0,  0.10795D0,  0.09484D0,
     &     0.08524D0,  0.07175D0,  0.05879D0,  0.04583D0,  0.03782D0,
     &     0.02821D0,  0.02247D0,  0.01853D0,  0.01496D0,  0.01223D0,
     &     0.01005D0,  0.00826D0,  0.00676D0,  0.00549D0,  0.00445D0,
     &     0.00355D0,  0.00282D0,  0.00221D0,  0.00171D0,  0.00131D0,
     &     0.00099D0,  0.00074D0,  0.00055D0,  0.00041D0,  0.00029D0,
     &     0.00019D0,  0.00013D0,  0.00007D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I,12),I=1,49)/
     &     0.97596D0,  0.80419D0,  0.66232D0,  0.59100D0,  0.54494D0,
     &     0.51159D0,  0.41968D0,  0.34257D0,  0.30297D0,  0.27688D0,
     &     0.25720D0,  0.20210D0,  0.15417D0,  0.12932D0,  0.11303D0,
     &     0.10119D0,  0.08465D0,  0.06892D0,  0.05333D0,  0.04376D0,
     &     0.03235D0,  0.02557D0,  0.02094D0,  0.01675D0,  0.01359D0,
     &     0.01109D0,  0.00904D0,  0.00734D0,  0.00594D0,  0.00477D0,
     &     0.00379D0,  0.00299D0,  0.00233D0,  0.00179D0,  0.00137D0,
     &     0.00103D0,  0.00077D0,  0.00057D0,  0.00042D0,  0.00030D0,
     &     0.00019D0,  0.00013D0,  0.00007D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I,13),I=1,49)/
     &     1.22977D0,  1.00344D0,  0.81836D0,  0.72605D0,  0.66675D0,
     &     0.62396D0,  0.50684D0,  0.40963D0,  0.36016D0,  0.32776D0,
     &     0.30345D0,  0.23597D0,  0.17813D0,  0.14851D0,  0.12924D0,
     &     0.11531D0,  0.09599D0,  0.07773D0,  0.05977D0,  0.04882D0,
     &     0.03581D0,  0.02811D0,  0.02289D0,  0.01818D0,  0.01465D0,
     &     0.01187D0,  0.00963D0,  0.00777D0,  0.00625D0,  0.00500D0,
     &     0.00395D0,  0.00310D0,  0.00241D0,  0.00185D0,  0.00140D0,
     &     0.00105D0,  0.00078D0,  0.00058D0,  0.00043D0,  0.00031D0,
     &     0.00019D0,  0.00013D0,  0.00007D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I,14),I=1,49)/
     &     1.55816D0,  1.25825D0,  1.01555D0,  0.89552D0,  0.81883D0,
     &     0.76371D0,  0.61389D0,  0.49095D0,  0.42897D0,  0.38864D0,
     &     0.35854D0,  0.27572D0,  0.20581D0,  0.17047D0,  0.14766D0,
     &     0.13128D0,  0.10869D0,  0.08751D0,  0.06683D0,  0.05430D0,
     &     0.03950D0,  0.03078D0,  0.02489D0,  0.01962D0,  0.01569D0,
     &     0.01264D0,  0.01018D0,  0.00817D0,  0.00653D0,  0.00519D0,
     &     0.00408D0,  0.00319D0,  0.00246D0,  0.00188D0,  0.00142D0,
     &     0.00106D0,  0.00078D0,  0.00058D0,  0.00043D0,  0.00031D0,
     &     0.00019D0,  0.00012D0,  0.00007D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I,15),I=1,49)/
     &     1.94525D0,  1.55494D0,  1.24230D0,  1.08896D0,  0.99149D0,
     &     0.92172D0,  0.73335D0,  0.58046D0,  0.50409D0,  0.45471D0,
     &     0.41801D0,  0.31797D0,  0.23473D0,  0.19316D0,  0.16655D0,
     &     0.14754D0,  0.12149D0,  0.09725D0,  0.07376D0,  0.05961D0,
     &     0.04299D0,  0.03326D0,  0.02672D0,  0.02089D0,  0.01659D0,
     &     0.01327D0,  0.01061D0,  0.00847D0,  0.00673D0,  0.00532D0,
     &     0.00416D0,  0.00323D0,  0.00248D0,  0.00188D0,  0.00142D0,
     &     0.00105D0,  0.00077D0,  0.00057D0,  0.00042D0,  0.00031D0,
     &     0.00019D0,  0.00012D0,  0.00007D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I,16),I=1,49)/
     &     2.34531D0,  1.85826D0,  1.47159D0,  1.28330D0,  1.16416D0,
     &     1.07915D0,  0.85101D0,  0.66758D0,  0.57668D0,  0.51821D0,
     &     0.47495D0,  0.35786D0,  0.26164D0,  0.21408D0,  0.18385D0,
     &     0.16236D0,  0.13305D0,  0.10596D0,  0.07987D0,  0.06425D0,
     &     0.04599D0,  0.03535D0,  0.02822D0,  0.02192D0,  0.01729D0,
     &     0.01375D0,  0.01093D0,  0.00867D0,  0.00685D0,  0.00540D0,
     &     0.00420D0,  0.00325D0,  0.00248D0,  0.00188D0,  0.00141D0,
     &     0.00104D0,  0.00076D0,  0.00056D0,  0.00041D0,  0.00030D0,
     &     0.00018D0,  0.00011D0,  0.00006D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I,17),I=1,49)/
     &     2.80142D0,  2.20072D0,  1.72790D0,  1.49927D0,  1.35523D0,
     &     1.25280D0,  0.97945D0,  0.76167D0,  0.65458D0,  0.58603D0,
     &     0.53553D0,  0.39978D0,  0.28955D0,  0.23561D0,  0.20153D0,
     &     0.17743D0,  0.14473D0,  0.11467D0,  0.08591D0,  0.06880D0,
     &     0.04888D0,  0.03733D0,  0.02963D0,  0.02285D0,  0.01791D0,
     &     0.01415D0,  0.01119D0,  0.00883D0,  0.00694D0,  0.00544D0,
     &     0.00421D0,  0.00324D0,  0.00247D0,  0.00186D0,  0.00139D0,
     &     0.00102D0,  0.00075D0,  0.00055D0,  0.00040D0,  0.00029D0,
     &     0.00018D0,  0.00011D0,  0.00006D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I,18),I=1,49)/
     &     3.21652D0,  2.50960D0,  1.95700D0,  1.69126D0,  1.52443D0,
     &     1.40610D0,  1.09176D0,  0.84313D0,  0.72161D0,  0.64414D0,
     &     0.58724D0,  0.43516D0,  0.31280D0,  0.25339D0,  0.21606D0,
     &     0.18974D0,  0.15419D0,  0.12166D0,  0.09071D0,  0.07236D0,
     &     0.05109D0,  0.03882D0,  0.03067D0,  0.02352D0,  0.01834D0,
     &     0.01442D0,  0.01135D0,  0.00892D0,  0.00699D0,  0.00545D0,
     &     0.00421D0,  0.00322D0,  0.00245D0,  0.00184D0,  0.00137D0,
     &     0.00100D0,  0.00073D0,  0.00053D0,  0.00039D0,  0.00029D0,
     &     0.00017D0,  0.00010D0,  0.00006D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I,19),I=1,49)/
     &     3.76652D0,  2.91536D0,  2.25532D0,  1.93997D0,  1.74280D0,
     &     1.60338D0,  1.23496D0,  0.94601D0,  0.80577D0,  0.71678D0,
     &     0.65167D0,  0.47873D0,  0.34109D0,  0.27487D0,  0.23349D0,
     &     0.20445D0,  0.16541D0,  0.12988D0,  0.09628D0,  0.07646D0,
     &     0.05359D0,  0.04046D0,  0.03178D0,  0.02422D0,  0.01877D0,
     &     0.01467D0,  0.01149D0,  0.00898D0,  0.00700D0,  0.00543D0,
     &     0.00418D0,  0.00319D0,  0.00241D0,  0.00180D0,  0.00134D0,
     &     0.00098D0,  0.00071D0,  0.00052D0,  0.00038D0,  0.00028D0,
     &     0.00017D0,  0.00010D0,  0.00006D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I,20),I=1,49)/
     &     4.30575D0,  3.30993D0,  2.54302D0,  2.17866D0,  1.95165D0,
     &     1.79153D0,  1.37036D0,  1.04242D0,  0.88422D0,  0.78423D0,
     &     0.71130D0,  0.51866D0,  0.36673D0,  0.29419D0,  0.24910D0,
     &     0.21757D0,  0.17534D0,  0.13711D0,  0.10112D0,  0.07999D0,
     &     0.05571D0,  0.04184D0,  0.03270D0,  0.02477D0,  0.01909D0,
     &     0.01486D0,  0.01158D0,  0.00901D0,  0.00699D0,  0.00541D0,
     &     0.00414D0,  0.00315D0,  0.00237D0,  0.00177D0,  0.00131D0,
     &     0.00095D0,  0.00069D0,  0.00050D0,  0.00037D0,  0.00027D0,
     &     0.00016D0,  0.00009D0,  0.00005D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I,21),I=1,49)/
     &     4.82956D0,  3.69021D0,  2.81808D0,  2.40576D0,  2.14966D0,
     &     1.96944D0,  1.49728D0,  1.13198D0,  0.95669D0,  0.84628D0,
     &     0.76597D0,  0.55486D0,  0.38968D0,  0.31136D0,  0.26288D0,
     &     0.22909D0,  0.18399D0,  0.14333D0,  0.10523D0,  0.08295D0,
     &     0.05744D0,  0.04293D0,  0.03340D0,  0.02518D0,  0.01931D0,
     &     0.01496D0,  0.01161D0,  0.00900D0,  0.00696D0,  0.00536D0,
     &     0.00409D0,  0.00310D0,  0.00233D0,  0.00173D0,  0.00128D0,
     &     0.00093D0,  0.00067D0,  0.00049D0,  0.00036D0,  0.00027D0,
     &     0.00015D0,  0.00009D0,  0.00005D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I,22),I=1,49)/
     &     5.55546D0,  4.21326D0,  3.19353D0,  2.71436D0,  2.41786D0,
     &     2.20981D0,  1.66741D0,  1.25104D0,  1.05255D0,  0.92807D0,
     &     0.83783D0,  0.60198D0,  0.41926D0,  0.33333D0,  0.28043D0,
     &     0.24370D0,  0.19489D0,  0.15111D0,  0.11032D0,  0.08657D0,
     &     0.05953D0,  0.04421D0,  0.03422D0,  0.02563D0,  0.01955D0,
     &     0.01506D0,  0.01163D0,  0.00897D0,  0.00690D0,  0.00529D0,
     &     0.00403D0,  0.00304D0,  0.00227D0,  0.00168D0,  0.00124D0,
     &     0.00090D0,  0.00064D0,  0.00047D0,  0.00035D0,  0.00026D0,
     &     0.00015D0,  0.00008D0,  0.00005D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I,23),I=1,49)/
     &     6.30033D0,  4.74567D0,  3.57260D0,  3.02443D0,  2.68642D0,
     &     2.44984D0,  1.83585D0,  1.36787D0,  1.14612D0,  1.00758D0,
     &     0.90746D0,  0.64718D0,  0.44730D0,  0.35401D0,  0.29686D0,
     &     0.25731D0,  0.20497D0,  0.15824D0,  0.11492D0,  0.08982D0,
     &     0.06136D0,  0.04532D0,  0.03489D0,  0.02598D0,  0.01971D0,
     &     0.01511D0,  0.01161D0,  0.00892D0,  0.00683D0,  0.00522D0,
     &     0.00395D0,  0.00297D0,  0.00222D0,  0.00163D0,  0.00120D0,
     &     0.00087D0,  0.00062D0,  0.00045D0,  0.00034D0,  0.00025D0,
     &     0.00014D0,  0.00008D0,  0.00005D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I,24),I=1,49)/
     &     7.03684D0,  5.26796D0,  3.94145D0,  3.32468D0,  2.94556D0,
     &     2.68082D0,  1.99651D0,  1.47829D0,  1.23404D0,  1.08198D0,
     &     0.97239D0,  0.68884D0,  0.47281D0,  0.37266D0,  0.31157D0,
     &     0.26944D0,  0.21386D0,  0.16445D0,  0.11886D0,  0.09256D0,
     &     0.06285D0,  0.04618D0,  0.03539D0,  0.02621D0,  0.01979D0,
     &     0.01510D0,  0.01155D0,  0.00884D0,  0.00675D0,  0.00513D0,
     &     0.00387D0,  0.00290D0,  0.00216D0,  0.00159D0,  0.00116D0,
     &     0.00084D0,  0.00060D0,  0.00044D0,  0.00033D0,  0.00024D0,
     &     0.00014D0,  0.00007D0,  0.00004D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I,25),I=1,49)/
     &     7.83575D0,  5.83079D0,  4.33631D0,  3.64485D0,  3.22112D0,
     &     2.92590D0,  2.16582D0,  1.59383D0,  1.32566D0,  1.15927D0,
     &     1.03966D0,  0.73165D0,  0.49881D0,  0.39156D0,  0.32642D0,
     &     0.28163D0,  0.22275D0,  0.17063D0,  0.12274D0,  0.09523D0,
     &     0.06428D0,  0.04699D0,  0.03585D0,  0.02642D0,  0.01984D0,
     &     0.01507D0,  0.01148D0,  0.00875D0,  0.00665D0,  0.00505D0,
     &     0.00380D0,  0.00284D0,  0.00210D0,  0.00154D0,  0.00112D0,
     &     0.00081D0,  0.00058D0,  0.00042D0,  0.00031D0,  0.00024D0,
     &     0.00014D0,  0.00007D0,  0.00004D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I,26),I=1,49)/
     &     8.65815D0,  6.40607D0,  4.73699D0,  3.96832D0,  3.49865D0,
     &     3.17213D0,  2.33459D0,  1.70806D0,  1.41577D0,  1.23500D0,
     &     1.10538D0,  0.77305D0,  0.52365D0,  0.40947D0,  0.34040D0,
     &     0.29306D0,  0.23101D0,  0.17630D0,  0.12625D0,  0.09761D0,
     &     0.06550D0,  0.04766D0,  0.03620D0,  0.02654D0,  0.01984D0,
     &     0.01501D0,  0.01139D0,  0.00864D0,  0.00655D0,  0.00495D0,
     &     0.00371D0,  0.00276D0,  0.00204D0,  0.00149D0,  0.00108D0,
     &     0.00078D0,  0.00056D0,  0.00041D0,  0.00030D0,  0.00023D0,
     &     0.00014D0,  0.00007D0,  0.00004D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I,27),I=1,49)/
     &     9.48773D0,  6.98283D0,  5.13620D0,  4.28942D0,  3.77342D0,
     &     3.41540D0,  2.50025D0,  1.81942D0,  1.50325D0,  1.30829D0,
     &     1.16884D0,  0.81270D0,  0.54722D0,  0.42638D0,  0.35354D0,
     &     0.30375D0,  0.23869D0,  0.18153D0,  0.12945D0,  0.09975D0,
     &     0.06658D0,  0.04823D0,  0.03648D0,  0.02662D0,  0.01982D0,
     &     0.01493D0,  0.01129D0,  0.00853D0,  0.00645D0,  0.00486D0,
     &     0.00363D0,  0.00270D0,  0.00199D0,  0.00145D0,  0.00105D0,
     &     0.00075D0,  0.00054D0,  0.00039D0,  0.00030D0,  0.00022D0,
     &     0.00014D0,  0.00007D0,  0.00004D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I,28),I=1,49)/
     &    10.30763D0,  7.54945D0,  5.52601D0,  4.60181D0,  4.04004D0,
     &     3.65097D0,  2.65960D0,  1.92581D0,  1.58647D0,  1.37780D0,
     &     1.22885D0,  0.84989D0,  0.56911D0,  0.44198D0,  0.36560D0,
     &     0.31352D0,  0.24565D0,  0.18623D0,  0.13228D0,  0.10162D0,
     &     0.06750D0,  0.04868D0,  0.03669D0,  0.02666D0,  0.01976D0,
     &     0.01484D0,  0.01118D0,  0.00842D0,  0.00635D0,  0.00477D0,
     &     0.00355D0,  0.00263D0,  0.00193D0,  0.00141D0,  0.00102D0,
     &     0.00073D0,  0.00052D0,  0.00038D0,  0.00029D0,  0.00022D0,
     &     0.00014D0,  0.00007D0,  0.00004D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I,29),I=1,49)/
     &    11.17527D0,  8.14579D0,  5.93397D0,  4.92768D0,  4.31749D0,
     &     3.89565D0,  2.82415D0,  2.03499D0,  1.67156D0,  1.44867D0,
     &     1.28991D0,  0.88743D0,  0.59103D0,  0.45751D0,  0.37756D0,
     &     0.32318D0,  0.25249D0,  0.19081D0,  0.13501D0,  0.10341D0,
     &     0.06835D0,  0.04909D0,  0.03686D0,  0.02667D0,  0.01969D0,
     &     0.01473D0,  0.01106D0,  0.00831D0,  0.00624D0,  0.00467D0,
     &     0.00347D0,  0.00257D0,  0.00188D0,  0.00136D0,  0.00099D0,
     &     0.00070D0,  0.00050D0,  0.00037D0,  0.00028D0,  0.00021D0,
     &     0.00014D0,  0.00007D0,  0.00004D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I,30),I=1,49)/
     &    12.06456D0,  8.75358D0,  6.34740D0,  5.25678D0,  4.59701D0,
     &     4.14168D0,  2.98858D0,  2.14338D0,  1.75569D0,  1.51853D0,
     &     1.34994D0,  0.92405D0,  0.61221D0,  0.47241D0,  0.38898D0,
     &     0.33235D0,  0.25894D0,  0.19508D0,  0.13752D0,  0.10502D0,
     &     0.06908D0,  0.04942D0,  0.03697D0,  0.02664D0,  0.01960D0,
     &     0.01461D0,  0.01093D0,  0.00819D0,  0.00613D0,  0.00458D0,
     &     0.00339D0,  0.00250D0,  0.00183D0,  0.00132D0,  0.00095D0,
     &     0.00068D0,  0.00049D0,  0.00036D0,  0.00027D0,  0.00021D0,
     &     0.00014D0,  0.00007D0,  0.00004D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I,31),I=1,49)/
     &    12.95374D0,  9.35831D0,  6.75669D0,  5.58162D0,  4.87232D0,
     &     4.38360D0,  3.14942D0,  2.24882D0,  1.83726D0,  1.58610D0,
     &     1.40790D0,  0.95916D0,  0.63237D0,  0.48653D0,  0.39975D0,
     &     0.34099D0,  0.26498D0,  0.19905D0,  0.13983D0,  0.10648D0,
     &     0.06974D0,  0.04970D0,  0.03705D0,  0.02660D0,  0.01950D0,
     &     0.01449D0,  0.01081D0,  0.00807D0,  0.00603D0,  0.00449D0,
     &     0.00332D0,  0.00244D0,  0.00178D0,  0.00129D0,  0.00093D0,
     &     0.00066D0,  0.00047D0,  0.00035D0,  0.00026D0,  0.00020D0,
     &     0.00013D0,  0.00007D0,  0.00004D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I,32),I=1,49)/
     &    13.81822D0,  9.94319D0,  7.15042D0,  5.89310D0,  5.13569D0,
     &     4.61461D0,  3.30209D0,  2.34827D0,  1.91389D0,  1.64940D0,
     &     1.46205D0,  0.99170D0,  0.65086D0,  0.49940D0,  0.40952D0,
     &     0.34877D0,  0.27037D0,  0.20256D0,  0.14182D0,  0.10773D0,
     &     0.07026D0,  0.04989D0,  0.03708D0,  0.02652D0,  0.01938D0,
     &     0.01436D0,  0.01068D0,  0.00795D0,  0.00592D0,  0.00440D0,
     &     0.00325D0,  0.00238D0,  0.00174D0,  0.00125D0,  0.00090D0,
     &     0.00064D0,  0.00046D0,  0.00034D0,  0.00026D0,  0.00020D0,
     &     0.00013D0,  0.00007D0,  0.00004D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I,33),I=1,49)/
     &    14.74174D0, 10.56553D0,  7.56770D0,  6.22245D0,  5.41371D0,
     &     4.85814D0,  3.46239D0,  2.45228D0,  1.99384D0,  1.71531D0,
     &     1.51837D0,  1.02539D0,  0.66993D0,  0.51263D0,  0.41953D0,
     &     0.35674D0,  0.27589D0,  0.20614D0,  0.14386D0,  0.10899D0,
     &     0.07078D0,  0.05009D0,  0.03711D0,  0.02645D0,  0.01927D0,
     &     0.01422D0,  0.01055D0,  0.00784D0,  0.00582D0,  0.00432D0,
     &     0.00318D0,  0.00233D0,  0.00169D0,  0.00122D0,  0.00087D0,
     &     0.00062D0,  0.00044D0,  0.00033D0,  0.00025D0,  0.00020D0,
     &     0.00013D0,  0.00007D0,  0.00004D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I,34),I=1,49)/
     &    15.66159D0, 11.18202D0,  7.97872D0,  6.54573D0,  5.68591D0,
     &     5.09611D0,  3.61802D0,  2.55254D0,  2.07056D0,  1.77835D0,
     &     1.57208D0,  1.05721D0,  0.68771D0,  0.52486D0,  0.42872D0,
     &     0.36401D0,  0.28085D0,  0.20931D0,  0.14560D0,  0.11004D0,
     &     0.07117D0,  0.05019D0,  0.03707D0,  0.02633D0,  0.01912D0,
     &     0.01408D0,  0.01041D0,  0.00771D0,  0.00572D0,  0.00423D0,
     &     0.00311D0,  0.00227D0,  0.00165D0,  0.00118D0,  0.00085D0,
     &     0.00060D0,  0.00043D0,  0.00032D0,  0.00025D0,  0.00020D0,
     &     0.00013D0,  0.00007D0,  0.00004D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I,35),I=1,49)/
     &    16.58568D0, 11.79905D0,  8.38856D0,  6.86738D0,  5.95633D0,
     &     5.33223D0,  3.77185D0,  2.65127D0,  2.14594D0,  1.84019D0,
     &     1.62469D0,  1.08825D0,  0.70498D0,  0.53670D0,  0.43761D0,
     &     0.37103D0,  0.28563D0,  0.21235D0,  0.14727D0,  0.11103D0,
     &     0.07154D0,  0.05029D0,  0.03704D0,  0.02622D0,  0.01898D0,
     &     0.01394D0,  0.01028D0,  0.00760D0,  0.00562D0,  0.00415D0,
     &     0.00304D0,  0.00222D0,  0.00161D0,  0.00115D0,  0.00082D0,
     &     0.00058D0,  0.00042D0,  0.00031D0,  0.00024D0,  0.00019D0,
     &     0.00013D0,  0.00007D0,  0.00004D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I,36),I=1,49)/
     &    17.48656D0, 12.39804D0,  8.78469D0,  7.17746D0,  6.21652D0,
     &     5.55909D0,  3.91895D0,  2.74520D0,  2.21743D0,  1.89869D0,
     &     1.67437D0,  1.11736D0,  0.72106D0,  0.54767D0,  0.44580D0,
     &     0.37747D0,  0.28999D0,  0.21509D0,  0.14875D0,  0.11190D0,
     &     0.07184D0,  0.05035D0,  0.03698D0,  0.02610D0,  0.01884D0,
     &     0.01380D0,  0.01016D0,  0.00749D0,  0.00553D0,  0.00407D0,
     &     0.00298D0,  0.00217D0,  0.00157D0,  0.00112D0,  0.00080D0,
     &     0.00057D0,  0.00041D0,  0.00031D0,  0.00024D0,  0.00019D0,
     &     0.00013D0,  0.00007D0,  0.00004D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I,37),I=1,49)/
     &    18.41889D0, 13.01534D0,  9.19117D0,  7.49481D0,  6.48233D0,
     &     5.79049D0,  4.06828D0,  2.84006D0,  2.28940D0,  1.95745D0,
     &     1.72416D0,  1.14634D0,  0.73693D0,  0.55843D0,  0.45379D0,
     &     0.38373D0,  0.29419D0,  0.21770D0,  0.15013D0,  0.11269D0,
     &     0.07209D0,  0.05037D0,  0.03690D0,  0.02596D0,  0.01869D0,
     &     0.01365D0,  0.01003D0,  0.00738D0,  0.00543D0,  0.00399D0,
     &     0.00291D0,  0.00212D0,  0.00153D0,  0.00109D0,  0.00078D0,
     &     0.00055D0,  0.00040D0,  0.00030D0,  0.00023D0,  0.00019D0,
     &     0.00013D0,  0.00007D0,  0.00004D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,5,I,38),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I, 1),I=1,49)/
     &     0.44989D0,  0.39539D0,  0.34747D0,  0.32216D0,  0.30531D0,
     &     0.29285D0,  0.25722D0,  0.22578D0,  0.20909D0,  0.19792D0,
     &     0.18955D0,  0.16547D0,  0.14378D0,  0.13212D0,  0.12429D0,
     &     0.11845D0,  0.11003D0,  0.10150D0,  0.09208D0,  0.08532D0,
     &     0.07497D0,  0.06641D0,  0.05872D0,  0.04993D0,  0.04200D0,
     &     0.03492D0,  0.02867D0,  0.02327D0,  0.01867D0,  0.01463D0,
     &     0.01149D0,  0.00885D0,  0.00675D0,  0.00511D0,  0.00375D0,
     &     0.00275D0,  0.00200D0,  0.00140D0,  0.00092D0,  0.00067D0,
     &     0.00045D0,  0.00028D0,  0.00020D0,  0.00007D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I, 2),I=1,49)/
     &     0.46639D0,  0.41136D0,  0.36279D0,  0.33706D0,  0.31990D0,
     &     0.30719D0,  0.27073D0,  0.23840D0,  0.22115D0,  0.20956D0,
     &     0.20084D0,  0.17557D0,  0.15249D0,  0.13993D0,  0.13142D0,
     &     0.12504D0,  0.11578D0,  0.10635D0,  0.09591D0,  0.08845D0,
     &     0.07719D0,  0.06805D0,  0.05996D0,  0.05084D0,  0.04269D0,
     &     0.03544D0,  0.02909D0,  0.02361D0,  0.01895D0,  0.01488D0,
     &     0.01169D0,  0.00902D0,  0.00689D0,  0.00524D0,  0.00385D0,
     &     0.00283D0,  0.00206D0,  0.00146D0,  0.00096D0,  0.00071D0,
     &     0.00048D0,  0.00029D0,  0.00022D0,  0.00008D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I, 3),I=1,49)/
     &     0.50684D0,  0.44821D0,  0.39632D0,  0.36876D0,  0.35036D0,
     &     0.33670D0,  0.29743D0,  0.26242D0,  0.24363D0,  0.23094D0,
     &     0.22132D0,  0.19327D0,  0.16725D0,  0.15293D0,  0.14314D0,
     &     0.13576D0,  0.12501D0,  0.11402D0,  0.10188D0,  0.09328D0,
     &     0.08055D0,  0.07049D0,  0.06177D0,  0.05212D0,  0.04362D0,
     &     0.03613D0,  0.02960D0,  0.02400D0,  0.01926D0,  0.01513D0,
     &     0.01189D0,  0.00918D0,  0.00704D0,  0.00535D0,  0.00395D0,
     &     0.00290D0,  0.00211D0,  0.00152D0,  0.00101D0,  0.00074D0,
     &     0.00051D0,  0.00031D0,  0.00023D0,  0.00008D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I, 4),I=1,49)/
     &     0.55058D0,  0.48672D0,  0.43021D0,  0.40019D0,  0.38014D0,
     &     0.36526D0,  0.32246D0,  0.28426D0,  0.26371D0,  0.24981D0,
     &     0.23922D0,  0.20826D0,  0.17939D0,  0.16343D0,  0.15249D0,
     &     0.14425D0,  0.13221D0,  0.11993D0,  0.10640D0,  0.09689D0,
     &     0.08300D0,  0.07224D0,  0.06305D0,  0.05299D0,  0.04421D0,
     &     0.03653D0,  0.02989D0,  0.02420D0,  0.01939D0,  0.01523D0,
     &     0.01197D0,  0.00924D0,  0.00709D0,  0.00537D0,  0.00399D0,
     &     0.00293D0,  0.00213D0,  0.00154D0,  0.00102D0,  0.00074D0,
     &     0.00053D0,  0.00032D0,  0.00024D0,  0.00009D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I, 5),I=1,49)/
     &     0.61607D0,  0.54291D0,  0.47835D0,  0.44415D0,  0.42133D0,
     &     0.40441D0,  0.35583D0,  0.31254D0,  0.28927D0,  0.27353D0,
     &     0.26150D0,  0.22639D0,  0.19363D0,  0.17555D0,  0.16316D0,
     &     0.15384D0,  0.14026D0,  0.12643D0,  0.11130D0,  0.10077D0,
     &     0.08558D0,  0.07403D0,  0.06431D0,  0.05381D0,  0.04474D0,
     &     0.03686D0,  0.03008D0,  0.02432D0,  0.01945D0,  0.01528D0,
     &     0.01199D0,  0.00925D0,  0.00709D0,  0.00537D0,  0.00398D0,
     &     0.00293D0,  0.00214D0,  0.00154D0,  0.00103D0,  0.00074D0,
     &     0.00052D0,  0.00032D0,  0.00024D0,  0.00008D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I, 6),I=1,49)/
     &     0.68336D0,  0.60005D0,  0.52679D0,  0.48807D0,  0.46228D0,
     &     0.44318D0,  0.38846D0,  0.33984D0,  0.31375D0,  0.29611D0,
     &     0.28263D0,  0.24332D0,  0.20674D0,  0.18660D0,  0.17283D0,
     &     0.16249D0,  0.14745D0,  0.13219D0,  0.11560D0,  0.10414D0,
     &     0.08779D0,  0.07555D0,  0.06535D0,  0.05447D0,  0.04515D0,
     &     0.03709D0,  0.03021D0,  0.02439D0,  0.01946D0,  0.01528D0,
     &     0.01197D0,  0.00923D0,  0.00707D0,  0.00536D0,  0.00396D0,
     &     0.00291D0,  0.00213D0,  0.00154D0,  0.00103D0,  0.00073D0,
     &     0.00051D0,  0.00032D0,  0.00023D0,  0.00008D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I, 7),I=1,49)/
     &     0.76355D0,  0.66723D0,  0.58292D0,  0.53852D0,  0.50902D0,
     &     0.48721D0,  0.42490D0,  0.36978D0,  0.34030D0,  0.32042D0,
     &     0.30522D0,  0.26107D0,  0.22021D0,  0.19782D0,  0.18257D0,
     &     0.17114D0,  0.15457D0,  0.13784D0,  0.11976D0,  0.10736D0,
     &     0.08987D0,  0.07693D0,  0.06629D0,  0.05503D0,  0.04547D0,
     &     0.03726D0,  0.03027D0,  0.02439D0,  0.01942D0,  0.01523D0,
     &     0.01190D0,  0.00918D0,  0.00701D0,  0.00533D0,  0.00392D0,
     &     0.00287D0,  0.00209D0,  0.00153D0,  0.00101D0,  0.00073D0,
     &     0.00050D0,  0.00032D0,  0.00022D0,  0.00007D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I, 8),I=1,49)/
     &     0.86343D0,  0.75010D0,  0.65144D0,  0.59973D0,  0.56547D0,
     &     0.54018D0,  0.46822D0,  0.40492D0,  0.37123D0,  0.34856D0,
     &     0.33127D0,  0.28125D0,  0.23529D0,  0.21028D0,  0.19331D0,
     &     0.18063D0,  0.16233D0,  0.14394D0,  0.12420D0,  0.11077D0,
     &     0.09202D0,  0.07835D0,  0.06722D0,  0.05555D0,  0.04575D0,
     &     0.03737D0,  0.03028D0,  0.02434D0,  0.01934D0,  0.01514D0,
     &     0.01181D0,  0.00909D0,  0.00694D0,  0.00526D0,  0.00387D0,
     &     0.00282D0,  0.00206D0,  0.00150D0,  0.00100D0,  0.00072D0,
     &     0.00049D0,  0.00031D0,  0.00021D0,  0.00008D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I, 9),I=1,49)/
     &     0.96361D0,  0.83251D0,  0.71897D0,  0.65971D0,  0.62055D0,
     &     0.59171D0,  0.50993D0,  0.43838D0,  0.40047D0,  0.37504D0,
     &     0.35567D0,  0.29991D0,  0.24906D0,  0.22156D0,  0.20298D0,
     &     0.18914D0,  0.16924D0,  0.14933D0,  0.12809D0,  0.11373D0,
     &     0.09387D0,  0.07954D0,  0.06798D0,  0.05596D0,  0.04595D0,
     &     0.03743D0,  0.03026D0,  0.02427D0,  0.01926D0,  0.01505D0,
     &     0.01172D0,  0.00900D0,  0.00687D0,  0.00519D0,  0.00383D0,
     &     0.00278D0,  0.00203D0,  0.00148D0,  0.00098D0,  0.00071D0,
     &     0.00048D0,  0.00031D0,  0.00021D0,  0.00008D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I,10),I=1,49)/
     &     1.07479D0,  0.92315D0,  0.79255D0,  0.72469D0,  0.67997D0,
     &     0.64711D0,  0.55427D0,  0.47353D0,  0.43097D0,  0.40251D0,
     &     0.38089D0,  0.31894D0,  0.26290D0,  0.23280D0,  0.21256D0,
     &     0.19753D0,  0.17599D0,  0.15455D0,  0.13181D0,  0.11654D0,
     &     0.09559D0,  0.08062D0,  0.06865D0,  0.05629D0,  0.04608D0,
     &     0.03743D0,  0.03019D0,  0.02416D0,  0.01913D0,  0.01493D0,
     &     0.01161D0,  0.00890D0,  0.00677D0,  0.00511D0,  0.00377D0,
     &     0.00274D0,  0.00200D0,  0.00145D0,  0.00096D0,  0.00068D0,
     &     0.00046D0,  0.00030D0,  0.00020D0,  0.00008D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I,11),I=1,49)/
     &     1.17232D0,  1.00213D0,  0.85623D0,  0.78069D0,  0.73104D0,
     &     0.69461D0,  0.59200D0,  0.50321D0,  0.45658D0,  0.42550D0,
     &     0.40194D0,  0.33467D0,  0.27424D0,  0.24195D0,  0.22032D0,
     &     0.20431D0,  0.18142D0,  0.15872D0,  0.13477D0,  0.11875D0,
     &     0.09692D0,  0.08144D0,  0.06915D0,  0.05653D0,  0.04615D0,
     &     0.03741D0,  0.03011D0,  0.02406D0,  0.01902D0,  0.01482D0,
     &     0.01152D0,  0.00881D0,  0.00669D0,  0.00505D0,  0.00371D0,
     &     0.00270D0,  0.00197D0,  0.00143D0,  0.00094D0,  0.00066D0,
     &     0.00045D0,  0.00029D0,  0.00020D0,  0.00008D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I,12),I=1,49)/
     &     1.41135D0,  1.19389D0,  1.00931D0,  0.91452D0,  0.85253D0,
     &     0.80723D0,  0.68048D0,  0.57199D0,  0.51554D0,  0.47813D0,
     &     0.44992D0,  0.37007D0,  0.29939D0,  0.26209D0,  0.23729D0,
     &     0.21905D0,  0.19312D0,  0.16764D0,  0.14100D0,  0.12337D0,
     &     0.09965D0,  0.08309D0,  0.07010D0,  0.05694D0,  0.04624D0,
     &     0.03729D0,  0.02989D0,  0.02378D0,  0.01873D0,  0.01456D0,
     &     0.01128D0,  0.00861D0,  0.00651D0,  0.00490D0,  0.00360D0,
     &     0.00260D0,  0.00189D0,  0.00137D0,  0.00090D0,  0.00062D0,
     &     0.00043D0,  0.00028D0,  0.00019D0,  0.00007D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I,13),I=1,49)/
     &     1.65256D0,  1.38522D0,  1.16028D0,  1.04559D0,  0.97092D0,
     &     0.91653D0,  0.76529D0,  0.63704D0,  0.57085D0,  0.52722D0,
     &     0.49446D0,  0.40243D0,  0.32201D0,  0.28002D0,  0.25230D0,
     &     0.23200D0,  0.20332D0,  0.17533D0,  0.14629D0,  0.12724D0,
     &     0.10187D0,  0.08438D0,  0.07080D0,  0.05719D0,  0.04622D0,
     &     0.03712D0,  0.02965D0,  0.02350D0,  0.01845D0,  0.01430D0,
     &     0.01104D0,  0.00841D0,  0.00634D0,  0.00476D0,  0.00349D0,
     &     0.00251D0,  0.00182D0,  0.00132D0,  0.00086D0,  0.00060D0,
     &     0.00042D0,  0.00026D0,  0.00018D0,  0.00006D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I,14),I=1,49)/
     &     1.96387D0,  1.62942D0,  1.35081D0,  1.20988D0,  1.11860D0,
     &     1.05236D0,  0.86939D0,  0.71589D0,  0.63738D0,  0.58593D0,
     &     0.54750D0,  0.44041D0,  0.34815D0,  0.30054D0,  0.26935D0,
     &     0.24663D0,  0.21473D0,  0.18383D0,  0.15206D0,  0.13140D0,
     &     0.10419D0,  0.08567D0,  0.07145D0,  0.05736D0,  0.04609D0,
     &     0.03684D0,  0.02930D0,  0.02313D0,  0.01809D0,  0.01398D0,
     &     0.01074D0,  0.00816D0,  0.00615D0,  0.00459D0,  0.00334D0,
     &     0.00240D0,  0.00174D0,  0.00125D0,  0.00082D0,  0.00057D0,
     &     0.00038D0,  0.00024D0,  0.00016D0,  0.00006D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I,15),I=1,49)/
     &     2.33902D0,  1.92024D0,  1.57497D0,  1.40179D0,  1.29021D0,
     &     1.20956D0,  0.98833D0,  0.80477D0,  0.71175D0,  0.65116D0,
     &     0.60614D0,  0.48174D0,  0.37612D0,  0.32226D0,  0.28724D0,
     &     0.26188D0,  0.22649D0,  0.19248D0,  0.15783D0,  0.13549D0,
     &     0.10637D0,  0.08680D0,  0.07195D0,  0.05738D0,  0.04585D0,
     &     0.03646D0,  0.02886D0,  0.02269D0,  0.01768D0,  0.01360D0,
     &     0.01043D0,  0.00789D0,  0.00592D0,  0.00441D0,  0.00321D0,
     &     0.00230D0,  0.00166D0,  0.00118D0,  0.00078D0,  0.00054D0,
     &     0.00037D0,  0.00022D0,  0.00015D0,  0.00006D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I,16),I=1,49)/
     &     2.72482D0,  2.21608D0,  1.80052D0,  1.59364D0,  1.46096D0,
     &     1.36541D0,  1.10490D0,  0.89086D0,  0.78327D0,  0.71357D0,
     &     0.66200D0,  0.52058D0,  0.40200D0,  0.34217D0,  0.30354D0,
     &     0.27569D0,  0.23704D0,  0.20015D0,  0.16285D0,  0.13900D0,
     &     0.10817D0,  0.08767D0,  0.07227D0,  0.05729D0,  0.04554D0,
     &     0.03606D0,  0.02842D0,  0.02227D0,  0.01728D0,  0.01326D0,
     &     0.01012D0,  0.00763D0,  0.00571D0,  0.00425D0,  0.00307D0,
     &     0.00219D0,  0.00158D0,  0.00112D0,  0.00073D0,  0.00051D0,
     &     0.00035D0,  0.00021D0,  0.00014D0,  0.00005D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I,17),I=1,49)/
     &     3.16184D0,  2.54784D0,  2.05090D0,  1.80533D0,  1.64858D0,
     &     1.53608D0,  1.23122D0,  0.98314D0,  0.85944D0,  0.77972D0,
     &     0.72099D0,  0.56109D0,  0.42865D0,  0.36249D0,  0.32006D0,
     &     0.28962D0,  0.24759D0,  0.20774D0,  0.16775D0,  0.14236D0,
     &     0.10984D0,  0.08843D0,  0.07249D0,  0.05712D0,  0.04518D0,
     &     0.03560D0,  0.02794D0,  0.02182D0,  0.01686D0,  0.01291D0,
     &     0.00980D0,  0.00737D0,  0.00550D0,  0.00408D0,  0.00294D0,
     &     0.00209D0,  0.00150D0,  0.00107D0,  0.00069D0,  0.00049D0,
     &     0.00034D0,  0.00019D0,  0.00014D0,  0.00005D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I,18),I=1,49)/
     &     3.56226D0,  2.84906D0,  2.27616D0,  1.99475D0,  1.81581D0,
     &     1.68774D0,  1.34241D0,  1.06358D0,  0.92544D0,  0.83679D0,
     &     0.77171D0,  0.59551D0,  0.45100D0,  0.37940D0,  0.33372D0,
     &     0.30107D0,  0.25620D0,  0.21386D0,  0.17164D0,  0.14499D0,
     &     0.11108D0,  0.08895D0,  0.07258D0,  0.05692D0,  0.04483D0,
     &     0.03518D0,  0.02753D0,  0.02142D0,  0.01651D0,  0.01260D0,
     &     0.00954D0,  0.00717D0,  0.00532D0,  0.00393D0,  0.00284D0,
     &     0.00201D0,  0.00144D0,  0.00103D0,  0.00066D0,  0.00045D0,
     &     0.00032D0,  0.00018D0,  0.00013D0,  0.00004D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I,19),I=1,49)/
     &     4.09416D0,  3.24567D0,  2.57011D0,  2.24065D0,  2.03209D0,
     &     1.88332D0,  1.48448D0,  1.16540D0,  1.00850D0,  0.90831D0,
     &     0.83504D0,  0.63803D0,  0.47827D0,  0.39987D0,  0.35015D0,
     &     0.31478D0,  0.26640D0,  0.22104D0,  0.17612D0,  0.14797D0,
     &     0.11241D0,  0.08943D0,  0.07259D0,  0.05659D0,  0.04434D0,
     &     0.03464D0,  0.02699D0,  0.02092D0,  0.01606D0,  0.01221D0,
     &     0.00922D0,  0.00691D0,  0.00511D0,  0.00375D0,  0.00271D0,
     &     0.00191D0,  0.00136D0,  0.00097D0,  0.00063D0,  0.00043D0,
     &     0.00030D0,  0.00017D0,  0.00012D0,  0.00004D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I,20),I=1,49)/
     &     4.61257D0,  3.62885D0,  2.85161D0,  2.47491D0,  2.23738D0,
     &     2.06842D0,  1.61774D0,  1.26001D0,  1.08527D0,  0.97415D0,
     &     0.89315D0,  0.67662D0,  0.50274D0,  0.41811D0,  0.36471D0,
     &     0.32688D0,  0.27534D0,  0.22728D0,  0.17996D0,  0.15048D0,
     &     0.11349D0,  0.08979D0,  0.07253D0,  0.05626D0,  0.04389D0,
     &     0.03414D0,  0.02651D0,  0.02047D0,  0.01566D0,  0.01187D0,
     &     0.00894D0,  0.00668D0,  0.00493D0,  0.00361D0,  0.00261D0,
     &     0.00182D0,  0.00129D0,  0.00093D0,  0.00059D0,  0.00040D0,
     &     0.00028D0,  0.00016D0,  0.00011D0,  0.00004D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I,21),I=1,49)/
     &     5.12222D0,  4.00261D0,  3.12404D0,  2.70057D0,  2.43446D0,
     &     2.24566D0,  1.74429D0,  1.34911D0,  1.15718D0,  1.03559D0,
     &     0.94721D0,  0.71215D0,  0.52500D0,  0.43455D0,  0.37776D0,
     &     0.33766D0,  0.28323D0,  0.23271D0,  0.18324D0,  0.15257D0,
     &     0.11432D0,  0.08998D0,  0.07237D0,  0.05588D0,  0.04342D0,
     &     0.03365D0,  0.02604D0,  0.02004D0,  0.01529D0,  0.01156D0,
     &     0.00869D0,  0.00646D0,  0.00477D0,  0.00348D0,  0.00251D0,
     &     0.00175D0,  0.00124D0,  0.00088D0,  0.00057D0,  0.00038D0,
     &     0.00026D0,  0.00015D0,  0.00010D0,  0.00004D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I,22),I=1,49)/
     &     5.82554D0,  4.51423D0,  3.49391D0,  3.00548D0,  2.69986D0,
     &     2.48370D0,  1.91285D0,  1.46678D0,  1.25167D0,  1.11601D0,
     &     1.01775D0,  0.75806D0,  0.55345D0,  0.45543D0,  0.39424D0,
     &     0.35121D0,  0.29307D0,  0.23942D0,  0.18722D0,  0.15507D0,
     &     0.11526D0,  0.09014D0,  0.07211D0,  0.05536D0,  0.04279D0,
     &     0.03301D0,  0.02543D0,  0.01950D0,  0.01483D0,  0.01117D0,
     &     0.00837D0,  0.00620D0,  0.00456D0,  0.00332D0,  0.00238D0,
     &     0.00166D0,  0.00117D0,  0.00083D0,  0.00053D0,  0.00035D0,
     &     0.00024D0,  0.00015D0,  0.00010D0,  0.00003D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I,23),I=1,49)/
     &     6.54676D0,  5.03439D0,  3.86673D0,  3.31126D0,  2.96506D0,
     &     2.72090D0,  2.07933D0,  1.58195D0,  1.34364D0,  1.19398D0,
     &     1.08591D0,  0.80195D0,  0.58033D0,  0.47501D0,  0.40960D0,
     &     0.36377D0,  0.30212D0,  0.24551D0,  0.19078D0,  0.15726D0,
     &     0.11602D0,  0.09021D0,  0.07181D0,  0.05483D0,  0.04218D0,
     &     0.03240D0,  0.02486D0,  0.01900D0,  0.01440D0,  0.01081D0,
     &     0.00808D0,  0.00597D0,  0.00437D0,  0.00317D0,  0.00227D0,
     &     0.00157D0,  0.00111D0,  0.00080D0,  0.00050D0,  0.00034D0,
     &     0.00022D0,  0.00014D0,  0.00009D0,  0.00003D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I,24),I=1,49)/
     &     7.26565D0,  5.54876D0,  4.23247D0,  3.60982D0,  3.22311D0,
     &     2.95109D0,  2.23956D0,  1.69183D0,  1.43093D0,  1.26769D0,
     &     1.15015D0,  0.84286D0,  0.60508D0,  0.49288D0,  0.42351D0,
     &     0.37509D0,  0.31017D0,  0.25086D0,  0.19381D0,  0.15905D0,
     &     0.11655D0,  0.09013D0,  0.07142D0,  0.05426D0,  0.04157D0,
     &     0.03180D0,  0.02431D0,  0.01852D0,  0.01399D0,  0.01048D0,
     &     0.00780D0,  0.00574D0,  0.00419D0,  0.00304D0,  0.00217D0,
     &     0.00149D0,  0.00106D0,  0.00075D0,  0.00048D0,  0.00032D0,
     &     0.00021D0,  0.00013D0,  0.00009D0,  0.00003D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I,25),I=1,49)/
     &     8.04192D0,  6.10017D0,  4.62168D0,  3.92618D0,  3.49572D0,
     &     3.19370D0,  2.40717D0,  1.80591D0,  1.52114D0,  1.34361D0,
     &     1.21613D0,  0.88453D0,  0.63003D0,  0.51078D0,  0.43739D0,
     &     0.38633D0,  0.31813D0,  0.25609D0,  0.19674D0,  0.16076D0,
     &     0.11701D0,  0.09001D0,  0.07101D0,  0.05368D0,  0.04095D0,
     &     0.03121D0,  0.02377D0,  0.01805D0,  0.01359D0,  0.01015D0,
     &     0.00753D0,  0.00553D0,  0.00402D0,  0.00291D0,  0.00207D0,
     &     0.00142D0,  0.00101D0,  0.00071D0,  0.00045D0,  0.00030D0,
     &     0.00020D0,  0.00012D0,  0.00008D0,  0.00003D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I,26),I=1,49)/
     &     8.84513D0,  6.66663D0,  5.01863D0,  4.24745D0,  3.77171D0,
     &     3.43873D0,  2.57518D0,  1.91937D0,  1.61043D0,  1.41849D0,
     &     1.28102D0,  0.92509D0,  0.65405D0,  0.52788D0,  0.45056D0,
     &     0.39694D0,  0.32555D0,  0.26091D0,  0.19936D0,  0.16223D0,
     &     0.11732D0,  0.08979D0,  0.07053D0,  0.05307D0,  0.04031D0,
     &     0.03061D0,  0.02325D0,  0.01759D0,  0.01321D0,  0.00982D0,
     &     0.00728D0,  0.00532D0,  0.00387D0,  0.00279D0,  0.00197D0,
     &     0.00136D0,  0.00096D0,  0.00067D0,  0.00043D0,  0.00029D0,
     &     0.00019D0,  0.00011D0,  0.00007D0,  0.00003D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I,27),I=1,49)/
     &     9.65435D0,  7.23356D0,  5.41328D0,  4.56560D0,  4.04426D0,
     &     3.68017D0,  2.73960D0,  2.02962D0,  1.69683D0,  1.49072D0,
     &     1.34344D0,  0.96379D0,  0.67674D0,  0.54393D0,  0.46286D0,
     &     0.40680D0,  0.33241D0,  0.26531D0,  0.20171D0,  0.16351D0,
     &     0.11755D0,  0.08953D0,  0.07005D0,  0.05247D0,  0.03970D0,
     &     0.03004D0,  0.02275D0,  0.01715D0,  0.01284D0,  0.00953D0,
     &     0.00704D0,  0.00513D0,  0.00373D0,  0.00268D0,  0.00189D0,
     &     0.00130D0,  0.00092D0,  0.00064D0,  0.00040D0,  0.00027D0,
     &     0.00018D0,  0.00010D0,  0.00007D0,  0.00002D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I,28),I=1,49)/
     &    10.45602D0,  7.79175D0,  5.79941D0,  4.87575D0,  4.30926D0,
     &     3.91444D0,  2.89810D0,  2.13519D0,  1.77921D0,  1.55938D0,
     &     1.40263D0,  1.00018D0,  0.69787D0,  0.55877D0,  0.47417D0,
     &     0.41582D0,  0.33862D0,  0.26925D0,  0.20376D0,  0.16459D0,
     &     0.11767D0,  0.08923D0,  0.06955D0,  0.05189D0,  0.03911D0,
     &     0.02950D0,  0.02227D0,  0.01675D0,  0.01249D0,  0.00926D0,
     &     0.00681D0,  0.00496D0,  0.00359D0,  0.00258D0,  0.00181D0,
     &     0.00125D0,  0.00088D0,  0.00062D0,  0.00038D0,  0.00026D0,
     &     0.00017D0,  0.00010D0,  0.00007D0,  0.00002D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I,29),I=1,49)/
     &    11.30416D0,  8.37884D0,  6.20316D0,  5.19892D0,  4.58469D0,
     &     4.15747D0,  3.06152D0,  2.24335D0,  1.86330D0,  1.62927D0,
     &     1.46273D0,  1.03685D0,  0.71898D0,  0.57351D0,  0.48535D0,
     &     0.42471D0,  0.34469D0,  0.27305D0,  0.20570D0,  0.16558D0,
     &     0.11773D0,  0.08889D0,  0.06902D0,  0.05129D0,  0.03852D0,
     &     0.02896D0,  0.02179D0,  0.01634D0,  0.01216D0,  0.00899D0,
     &     0.00659D0,  0.00479D0,  0.00347D0,  0.00248D0,  0.00174D0,
     &     0.00119D0,  0.00084D0,  0.00059D0,  0.00036D0,  0.00024D0,
     &     0.00016D0,  0.00009D0,  0.00006D0,  0.00002D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I,30),I=1,49)/
     &    12.17534D0,  8.97841D0,  6.61310D0,  5.52592D0,  4.86271D0,
     &     4.40230D0,  3.22516D0,  2.35097D0,  1.94663D0,  1.69833D0,
     &     1.52199D0,  1.07270D0,  0.73942D0,  0.58770D0,  0.49605D0,
     &     0.43317D0,  0.35042D0,  0.27659D0,  0.20745D0,  0.16642D0,
     &     0.11771D0,  0.08850D0,  0.06847D0,  0.05068D0,  0.03793D0,
     &     0.02842D0,  0.02132D0,  0.01595D0,  0.01184D0,  0.00872D0,
     &     0.00639D0,  0.00464D0,  0.00334D0,  0.00238D0,  0.00167D0,
     &     0.00115D0,  0.00081D0,  0.00056D0,  0.00034D0,  0.00023D0,
     &     0.00015D0,  0.00009D0,  0.00006D0,  0.00002D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I,31),I=1,49)/
     &    13.04562D0,  9.57419D0,  7.01826D0,  5.84808D0,  5.13599D0,
     &     4.64254D0,  3.38483D0,  2.45538D0,  2.02720D0,  1.76492D0,
     &     1.57901D0,  1.10697D0,  0.75881D0,  0.60107D0,  0.50610D0,
     &     0.44109D0,  0.35574D0,  0.27985D0,  0.20903D0,  0.16716D0,
     &     0.11764D0,  0.08810D0,  0.06793D0,  0.05010D0,  0.03737D0,
     &     0.02791D0,  0.02089D0,  0.01558D0,  0.01154D0,  0.00848D0,
     &     0.00620D0,  0.00450D0,  0.00323D0,  0.00230D0,  0.00160D0,
     &     0.00110D0,  0.00077D0,  0.00053D0,  0.00032D0,  0.00022D0,
     &     0.00015D0,  0.00008D0,  0.00006D0,  0.00002D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I,32),I=1,49)/
     &    13.89443D0, 10.15226D0,  7.40931D0,  6.15805D0,  5.39834D0,
     &     4.87276D0,  3.53699D0,  2.55429D0,  2.10325D0,  1.82761D0,
     &     1.63256D0,  1.13890D0,  0.77669D0,  0.61332D0,  0.51524D0,
     &     0.44825D0,  0.36050D0,  0.28271D0,  0.21036D0,  0.16773D0,
     &     0.11750D0,  0.08767D0,  0.06738D0,  0.04952D0,  0.03683D0,
     &     0.02743D0,  0.02048D0,  0.01524D0,  0.01125D0,  0.00826D0,
     &     0.00603D0,  0.00436D0,  0.00312D0,  0.00222D0,  0.00155D0,
     &     0.00106D0,  0.00074D0,  0.00051D0,  0.00031D0,  0.00021D0,
     &     0.00014D0,  0.00008D0,  0.00005D0,  0.00002D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I,33),I=1,49)/
     &    14.79866D0, 10.76526D0,  7.82209D0,  6.48437D0,  5.67399D0,
     &     5.11430D0,  3.69589D0,  2.65710D0,  2.18207D0,  1.89245D0,
     &     1.68785D0,  1.17170D0,  0.79496D0,  0.62581D0,  0.52453D0,
     &     0.45551D0,  0.36532D0,  0.28560D0,  0.21171D0,  0.16831D0,
     &     0.11736D0,  0.08724D0,  0.06684D0,  0.04896D0,  0.03630D0,
     &     0.02696D0,  0.02007D0,  0.01490D0,  0.01098D0,  0.00805D0,
     &     0.00586D0,  0.00423D0,  0.00302D0,  0.00214D0,  0.00150D0,
     &     0.00102D0,  0.00071D0,  0.00049D0,  0.00030D0,  0.00020D0,
     &     0.00013D0,  0.00008D0,  0.00005D0,  0.00002D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I,34),I=1,49)/
     &    15.70368D0, 11.37564D0,  8.23095D0,  6.80656D0,  5.94554D0,
     &     5.35181D0,  3.85123D0,  2.75698D0,  2.25835D0,  1.95501D0,
     &     1.74107D0,  1.20298D0,  0.81219D0,  0.63747D0,  0.53315D0,
     &     0.46219D0,  0.36968D0,  0.28814D0,  0.21281D0,  0.16870D0,
     &     0.11711D0,  0.08674D0,  0.06626D0,  0.04836D0,  0.03575D0,
     &     0.02649D0,  0.01967D0,  0.01456D0,  0.01071D0,  0.00784D0,
     &     0.00568D0,  0.00409D0,  0.00292D0,  0.00207D0,  0.00144D0,
     &     0.00098D0,  0.00068D0,  0.00047D0,  0.00029D0,  0.00019D0,
     &     0.00012D0,  0.00007D0,  0.00005D0,  0.00002D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I,35),I=1,49)/
     &    16.61098D0, 11.98498D0,  8.63737D0,  7.12604D0,  6.21432D0,
     &     5.58657D0,  4.00413D0,  2.85486D0,  2.33290D0,  2.01603D0,
     &     1.79291D0,  1.23331D0,  0.82880D0,  0.64868D0,  0.54141D0,
     &     0.46858D0,  0.37384D0,  0.29056D0,  0.21385D0,  0.16907D0,
     &     0.11687D0,  0.08628D0,  0.06571D0,  0.04780D0,  0.03525D0,
     &     0.02604D0,  0.01929D0,  0.01425D0,  0.01046D0,  0.00764D0,
     &     0.00552D0,  0.00397D0,  0.00283D0,  0.00200D0,  0.00139D0,
     &     0.00095D0,  0.00066D0,  0.00045D0,  0.00028D0,  0.00019D0,
     &     0.00012D0,  0.00007D0,  0.00005D0,  0.00002D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I,36),I=1,49)/
     &    17.49641D0, 12.57703D0,  9.03053D0,  7.43428D0,  6.47316D0,
     &     5.81232D0,  4.15045D0,  2.94807D0,  2.40367D0,  2.07383D0,
     &     1.84191D0,  1.26179D0,  0.84428D0,  0.65906D0,  0.54902D0,
     &     0.47444D0,  0.37762D0,  0.29271D0,  0.21474D0,  0.16935D0,
     &     0.11660D0,  0.08580D0,  0.06517D0,  0.04726D0,  0.03476D0,
     &     0.02562D0,  0.01894D0,  0.01396D0,  0.01022D0,  0.00745D0,
     &     0.00538D0,  0.00386D0,  0.00274D0,  0.00194D0,  0.00135D0,
     &     0.00092D0,  0.00063D0,  0.00044D0,  0.00027D0,  0.00018D0,
     &     0.00011D0,  0.00007D0,  0.00005D0,  0.00002D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I,37),I=1,49)/
     &    18.41415D0, 13.18812D0,  9.43458D0,  7.75025D0,  6.73800D0,
     &     6.04297D0,  4.29926D0,  3.04240D0,  2.47507D0,  2.13202D0,
     &     1.89114D0,  1.29020D0,  0.85959D0,  0.66927D0,  0.55646D0,
     &     0.48015D0,  0.38126D0,  0.29476D0,  0.21554D0,  0.16955D0,
     &     0.11628D0,  0.08530D0,  0.06461D0,  0.04672D0,  0.03427D0,
     &     0.02520D0,  0.01858D0,  0.01367D0,  0.00999D0,  0.00727D0,
     &     0.00525D0,  0.00375D0,  0.00266D0,  0.00188D0,  0.00131D0,
     &     0.00088D0,  0.00061D0,  0.00042D0,  0.00026D0,  0.00017D0,
     &     0.00011D0,  0.00006D0,  0.00004D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,6,I,38),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I, 1),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I, 2),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I, 3),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I, 4),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I, 5),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I, 6),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I, 7),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I, 8),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I, 9),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I,10),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I,11),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I,12),I=1,49)/
     &     0.00042D0,  0.00036D0,  0.00032D0,  0.00030D0,  0.00028D0,
     &     0.00027D0,  0.00023D0,  0.00020D0,  0.00019D0,  0.00018D0,
     &     0.00017D0,  0.00014D0,  0.00012D0,  0.00011D0,  0.00010D0,
     &     0.00009D0,  0.00008D0,  0.00007D0,  0.00006D0,  0.00005D0,
     &     0.00005D0,  0.00004D0,  0.00003D0,  0.00003D0,  0.00003D0,
     &     0.00002D0,  0.00002D0,  0.00002D0,  0.00002D0,  0.00001D0,
     &     0.00001D0,  0.00001D0,  0.00001D0,  0.00001D0,  0.00001D0,
     &     0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I,13),I=1,49)/
     &     0.21520D0,  0.16773D0,  0.13065D0,  0.11283D0,  0.10165D0,
     &     0.09372D0,  0.07266D0,  0.05600D0,  0.04786D0,  0.04266D0,
     &     0.03883D0,  0.02862D0,  0.02044D0,  0.01649D0,  0.01402D0,
     &     0.01228D0,  0.00994D0,  0.00781D0,  0.00579D0,  0.00460D0,
     &     0.00322D0,  0.00243D0,  0.00191D0,  0.00146D0,  0.00114D0,
     &     0.00089D0,  0.00070D0,  0.00055D0,  0.00043D0,  0.00034D0,
     &     0.00026D0,  0.00020D0,  0.00015D0,  0.00011D0,  0.00009D0,
     &     0.00006D0,  0.00005D0,  0.00003D0,  0.00002D0,  0.00001D0,
     &     0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I,14),I=1,49)/
     &     0.62424D0,  0.48455D0,  0.37589D0,  0.32385D0,  0.29126D0,
     &     0.26818D0,  0.20706D0,  0.15892D0,  0.13546D0,  0.12053D0,
     &     0.10954D0,  0.08034D0,  0.05707D0,  0.04589D0,  0.03892D0,
     &     0.03403D0,  0.02747D0,  0.02151D0,  0.01589D0,  0.01258D0,
     &     0.00876D0,  0.00658D0,  0.00515D0,  0.00391D0,  0.00303D0,
     &     0.00236D0,  0.00185D0,  0.00144D0,  0.00112D0,  0.00088D0,
     &     0.00067D0,  0.00051D0,  0.00039D0,  0.00029D0,  0.00022D0,
     &     0.00016D0,  0.00011D0,  0.00008D0,  0.00006D0,  0.00004D0,
     &     0.00002D0,  0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I,15),I=1,49)/
     &     1.00765D0,  0.77678D0,  0.59844D0,  0.51350D0,  0.46049D0,
     &     0.42306D0,  0.32436D0,  0.24719D0,  0.20981D0,  0.18611D0,
     &     0.16874D0,  0.12279D0,  0.08652D0,  0.06923D0,  0.05850D0,
     &     0.05102D0,  0.04100D0,  0.03196D0,  0.02347D0,  0.01849D0,
     &     0.01279D0,  0.00955D0,  0.00743D0,  0.00560D0,  0.00430D0,
     &     0.00334D0,  0.00260D0,  0.00202D0,  0.00157D0,  0.00121D0,
     &     0.00093D0,  0.00071D0,  0.00053D0,  0.00040D0,  0.00029D0,
     &     0.00021D0,  0.00015D0,  0.00011D0,  0.00007D0,  0.00005D0,
     &     0.00003D0,  0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I,16),I=1,49)/
     &     1.42250D0,  1.08981D0,  0.83442D0,  0.71339D0,  0.63810D0,
     &     0.58505D0,  0.44575D0,  0.33755D0,  0.28542D0,  0.25249D0,
     &     0.22841D0,  0.16506D0,  0.11545D0,  0.09197D0,  0.07747D0,
     &     0.06738D0,  0.05394D0,  0.04186D0,  0.03057D0,  0.02399D0,
     &     0.01648D0,  0.01223D0,  0.00946D0,  0.00708D0,  0.00541D0,
     &     0.00417D0,  0.00323D0,  0.00250D0,  0.00193D0,  0.00149D0,
     &     0.00113D0,  0.00086D0,  0.00064D0,  0.00048D0,  0.00035D0,
     &     0.00026D0,  0.00018D0,  0.00013D0,  0.00009D0,  0.00005D0,
     &     0.00003D0,  0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I,17),I=1,49)/
     &     1.90329D0,  1.44918D0,  1.10274D0,  0.93938D0,  0.83807D0,
     &     0.76686D0,  0.58064D0,  0.43692D0,  0.36805D0,  0.32470D0,
     &     0.29309D0,  0.21032D0,  0.14604D0,  0.11582D0,  0.09725D0,
     &     0.08437D0,  0.06728D0,  0.05198D0,  0.03776D0,  0.02950D0,
     &     0.02012D0,  0.01485D0,  0.01142D0,  0.00850D0,  0.00645D0,
     &     0.00494D0,  0.00381D0,  0.00293D0,  0.00225D0,  0.00172D0,
     &     0.00131D0,  0.00098D0,  0.00073D0,  0.00054D0,  0.00040D0,
     &     0.00029D0,  0.00021D0,  0.00014D0,  0.00010D0,  0.00006D0,
     &     0.00003D0,  0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I,18),I=1,49)/
     &     2.33137D0,  1.76616D0,  1.33713D0,  1.13567D0,  1.01106D0,
     &     0.92363D0,  0.69576D0,  0.52083D0,  0.43738D0,  0.38501D0,
     &     0.34690D0,  0.24753D0,  0.17085D0,  0.13502D0,  0.11307D0,
     &     0.09789D0,  0.07781D0,  0.05991D0,  0.04333D0,  0.03374D0,
     &     0.02288D0,  0.01680D0,  0.01286D0,  0.00952D0,  0.00719D0,
     &     0.00549D0,  0.00420D0,  0.00322D0,  0.00246D0,  0.00188D0,
     &     0.00142D0,  0.00107D0,  0.00079D0,  0.00059D0,  0.00043D0,
     &     0.00031D0,  0.00022D0,  0.00015D0,  0.00010D0,  0.00006D0,
     &     0.00003D0,  0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I,19),I=1,49)/
     &     2.89798D0,  2.18213D0,  1.64207D0,  1.38971D0,  1.23410D0,
     &     1.12518D0,  0.84241D0,  0.62670D0,  0.52435D0,  0.46034D0,
     &     0.41389D0,  0.29333D0,  0.20103D0,  0.15819D0,  0.13206D0,
     &     0.11405D0,  0.09031D0,  0.06924D0,  0.04982D0,  0.03863D0,
     &     0.02602D0,  0.01899D0,  0.01446D0,  0.01064D0,  0.00798D0,
     &     0.00606D0,  0.00462D0,  0.00352D0,  0.00268D0,  0.00204D0,
     &     0.00153D0,  0.00115D0,  0.00085D0,  0.00062D0,  0.00046D0,
     &     0.00034D0,  0.00024D0,  0.00016D0,  0.00010D0,  0.00006D0,
     &     0.00003D0,  0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I,20),I=1,49)/
     &     3.45978D0,  2.59142D0,  1.93977D0,  1.63658D0,  1.45012D0,
     &     1.31987D0,  0.98290D0,  0.72728D0,  0.60655D0,  0.53126D0,
     &     0.47676D0,  0.33590D0,  0.22879D0,  0.17936D0,  0.14933D0,
     &     0.12869D0,  0.10156D0,  0.07757D0,  0.05556D0,  0.04293D0,
     &     0.02875D0,  0.02087D0,  0.01582D0,  0.01157D0,  0.00864D0,
     &     0.00653D0,  0.00495D0,  0.00376D0,  0.00285D0,  0.00216D0,
     &     0.00162D0,  0.00120D0,  0.00089D0,  0.00065D0,  0.00048D0,
     &     0.00035D0,  0.00025D0,  0.00017D0,  0.00010D0,  0.00006D0,
     &     0.00003D0,  0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I,21),I=1,49)/
     &     3.99390D0,  2.97724D0,  2.21795D0,  1.86604D0,  1.65015D0,
     &     1.49961D0,  1.11138D0,  0.81834D0,  0.68051D0,  0.59480D0,
     &     0.53289D0,  0.37345D0,  0.25296D0,  0.19764D0,  0.16415D0,
     &     0.14119D0,  0.11109D0,  0.08457D0,  0.06032D0,  0.04645D0,
     &     0.03094D0,  0.02236D0,  0.01688D0,  0.01228D0,  0.00913D0,
     &     0.00687D0,  0.00519D0,  0.00392D0,  0.00296D0,  0.00223D0,
     &     0.00167D0,  0.00124D0,  0.00091D0,  0.00067D0,  0.00049D0,
     &     0.00036D0,  0.00025D0,  0.00017D0,  0.00010D0,  0.00006D0,
     &     0.00003D0,  0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I,22),I=1,49)/
     &     4.74104D0,  3.51318D0,  2.60162D0,  2.18119D0,  1.92405D0,
     &     1.74515D0,  1.28558D0,  0.94085D0,  0.77956D0,  0.67959D0,
     &     0.60758D0,  0.42298D0,  0.28453D0,  0.22138D0,  0.18331D0,
     &     0.15728D0,  0.12329D0,  0.09346D0,  0.06632D0,  0.05087D0,
     &     0.03366D0,  0.02418D0,  0.01815D0,  0.01313D0,  0.00971D0,
     &     0.00726D0,  0.00546D0,  0.00411D0,  0.00309D0,  0.00232D0,
     &     0.00172D0,  0.00128D0,  0.00094D0,  0.00068D0,  0.00049D0,
     &     0.00036D0,  0.00026D0,  0.00017D0,  0.00010D0,  0.00006D0,
     &     0.00003D0,  0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I,23),I=1,49)/
     &     5.50879D0,  4.05964D0,  2.98973D0,  2.49849D0,  2.19888D0,
     &     1.99086D0,  1.45844D0,  1.06135D0,  0.87646D0,  0.76222D0,
     &     0.68014D0,  0.47060D0,  0.31455D0,  0.24380D0,  0.20130D0,
     &     0.17233D0,  0.13462D0,  0.10166D0,  0.07179D0,  0.05486D0,
     &     0.03607D0,  0.02577D0,  0.01926D0,  0.01386D0,  0.01019D0,
     &     0.00758D0,  0.00568D0,  0.00425D0,  0.00318D0,  0.00238D0,
     &     0.00176D0,  0.00130D0,  0.00095D0,  0.00069D0,  0.00050D0,
     &     0.00037D0,  0.00026D0,  0.00017D0,  0.00010D0,  0.00006D0,
     &     0.00003D0,  0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I,24),I=1,49)/
     &     6.25919D0,  4.58931D0,  3.36270D0,  2.80183D0,  2.46064D0,
     &     2.22421D0,  1.62105D0,  1.17360D0,  0.96617D0,  0.83838D0,
     &     0.74677D0,  0.51381D0,  0.34143D0,  0.26369D0,  0.21716D0,
     &     0.18553D0,  0.14447D0,  0.10870D0,  0.07643D0,  0.05820D0,
     &     0.03805D0,  0.02705D0,  0.02012D0,  0.01441D0,  0.01054D0,
     &     0.00781D0,  0.00582D0,  0.00434D0,  0.00324D0,  0.00241D0,
     &     0.00178D0,  0.00131D0,  0.00095D0,  0.00069D0,  0.00050D0,
     &     0.00037D0,  0.00026D0,  0.00017D0,  0.00010D0,  0.00006D0,
     &     0.00003D0,  0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I,25),I=1,49)/
     &     7.07966D0,  5.16501D0,  3.76564D0,  3.12838D0,  2.74171D0,
     &     2.47426D0,  1.79422D0,  1.29235D0,  1.06071D0,  0.91840D0,
     &     0.81663D0,  0.55877D0,  0.36917D0,  0.28412D0,  0.23339D0,
     &     0.19900D0,  0.15447D0,  0.11582D0,  0.08108D0,  0.06153D0,
     &     0.03999D0,  0.02830D0,  0.02096D0,  0.01493D0,  0.01087D0,
     &     0.00803D0,  0.00595D0,  0.00442D0,  0.00329D0,  0.00244D0,
     &     0.00180D0,  0.00131D0,  0.00096D0,  0.00069D0,  0.00050D0,
     &     0.00036D0,  0.00026D0,  0.00017D0,  0.00010D0,  0.00006D0,
     &     0.00003D0,  0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I,26),I=1,49)/
     &     7.91829D0,  5.74916D0,  4.17141D0,  3.45573D0,  3.02255D0,
     &     2.72346D0,  1.96537D0,  1.40870D0,  1.15285D0,  0.99608D0,
     &     0.88421D0,  0.60182D0,  0.39541D0,  0.30330D0,  0.24854D0,
     &     0.21150D0,  0.16368D0,  0.12231D0,  0.08527D0,  0.06448D0,
     &     0.04169D0,  0.02937D0,  0.02165D0,  0.01535D0,  0.01113D0,
     &     0.00818D0,  0.00604D0,  0.00447D0,  0.00331D0,  0.00245D0,
     &     0.00180D0,  0.00131D0,  0.00095D0,  0.00068D0,  0.00049D0,
     &     0.00036D0,  0.00026D0,  0.00017D0,  0.00010D0,  0.00006D0,
     &     0.00003D0,  0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I,27),I=1,49)/
     &     8.76657D0,  6.33661D0,  4.57707D0,  3.78184D0,  3.30161D0,
     &     2.97059D0,  2.13403D0,  1.52261D0,  1.24269D0,  1.07161D0,
     &     0.94977D0,  0.64324D0,  0.42046D0,  0.32150D0,  0.26285D0,
     &     0.22328D0,  0.17230D0,  0.12835D0,  0.08912D0,  0.06719D0,
     &     0.04322D0,  0.03031D0,  0.02226D0,  0.01571D0,  0.01134D0,
     &     0.00830D0,  0.00611D0,  0.00451D0,  0.00333D0,  0.00245D0,
     &     0.00180D0,  0.00131D0,  0.00095D0,  0.00068D0,  0.00048D0,
     &     0.00036D0,  0.00026D0,  0.00017D0,  0.00010D0,  0.00006D0,
     &     0.00003D0,  0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I,28),I=1,49)/
     &     9.60252D0,  6.91204D0,  4.97199D0,  4.09813D0,  3.57154D0,
     &     3.20914D0,  2.29574D0,  1.63105D0,  1.32784D0,  1.14296D0,
     &     1.01154D0,  0.68194D0,  0.44362D0,  0.33823D0,  0.27595D0,
     &     0.23401D0,  0.18011D0,  0.13377D0,  0.09255D0,  0.06957D0,
     &     0.04454D0,  0.03111D0,  0.02277D0,  0.01600D0,  0.01150D0,
     &     0.00839D0,  0.00616D0,  0.00453D0,  0.00333D0,  0.00245D0,
     &     0.00179D0,  0.00130D0,  0.00094D0,  0.00067D0,  0.00048D0,
     &     0.00035D0,  0.00025D0,  0.00017D0,  0.00010D0,  0.00006D0,
     &     0.00003D0,  0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I,29),I=1,49)/
     &    10.48807D0,  7.51842D0,  5.38590D0,  4.42859D0,  3.85291D0,
     &     3.45734D0,  2.46302D0,  1.74255D0,  1.41507D0,  1.21586D0,
     &     1.07451D0,  0.72111D0,  0.46688D0,  0.35494D0,  0.28897D0,
     &     0.24464D0,  0.18781D0,  0.13908D0,  0.09587D0,  0.07187D0,
     &     0.04579D0,  0.03185D0,  0.02323D0,  0.01626D0,  0.01165D0,
     &     0.00847D0,  0.00619D0,  0.00454D0,  0.00333D0,  0.00244D0,
     &     0.00178D0,  0.00129D0,  0.00093D0,  0.00066D0,  0.00047D0,
     &     0.00035D0,  0.00025D0,  0.00017D0,  0.00010D0,  0.00006D0,
     &     0.00003D0,  0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I,30),I=1,49)/
     &    11.39334D0,  8.13482D0,  5.80422D0,  4.76138D0,  4.13555D0,
     &     3.70617D0,  2.62967D0,  1.85288D0,  1.50103D0,  1.28747D0,
     &     1.13621D0,  0.75917D0,  0.48927D0,  0.37093D0,  0.30137D0,
     &     0.25473D0,  0.19506D0,  0.14404D0,  0.09894D0,  0.07396D0,
     &     0.04691D0,  0.03251D0,  0.02363D0,  0.01647D0,  0.01175D0,
     &     0.00851D0,  0.00621D0,  0.00454D0,  0.00332D0,  0.00243D0,
     &     0.00176D0,  0.00127D0,  0.00091D0,  0.00065D0,  0.00046D0,
     &     0.00034D0,  0.00025D0,  0.00017D0,  0.00010D0,  0.00006D0,
     &     0.00003D0,  0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I,31),I=1,49)/
     &    12.30020D0,  8.74942D0,  6.21933D0,  5.09070D0,  4.41468D0,
     &     3.95152D0,  2.79315D0,  1.96055D0,  1.58465D0,  1.35697D0,
     &     1.19598D0,  0.79580D0,  0.51068D0,  0.38615D0,  0.31314D0,
     &     0.26427D0,  0.20189D0,  0.14868D0,  0.10179D0,  0.07589D0,
     &     0.04793D0,  0.03309D0,  0.02397D0,  0.01665D0,  0.01184D0,
     &     0.00855D0,  0.00621D0,  0.00453D0,  0.00330D0,  0.00241D0,
     &     0.00174D0,  0.00126D0,  0.00090D0,  0.00064D0,  0.00046D0,
     &     0.00034D0,  0.00025D0,  0.00017D0,  0.00010D0,  0.00006D0,
     &     0.00003D0,  0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I,32),I=1,49)/
     &    13.17835D0,  9.34137D0,  6.61692D0,  5.40505D0,  4.68045D0,
     &     4.18467D0,  2.94753D0,  2.06155D0,  1.66276D0,  1.42169D0,
     &     1.25150D0,  0.82954D0,  0.53019D0,  0.39993D0,  0.32374D0,
     &     0.27283D0,  0.20796D0,  0.15278D0,  0.10427D0,  0.07755D0,
     &     0.04878D0,  0.03356D0,  0.02424D0,  0.01677D0,  0.01189D0,
     &     0.00856D0,  0.00621D0,  0.00451D0,  0.00328D0,  0.00239D0,
     &     0.00173D0,  0.00124D0,  0.00089D0,  0.00063D0,  0.00045D0,
     &     0.00033D0,  0.00025D0,  0.00017D0,  0.00010D0,  0.00006D0,
     &     0.00003D0,  0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I,33),I=1,49)/
     &    14.12059D0,  9.97430D0,  7.04054D0,  5.73929D0,  4.96264D0,
     &     4.43195D0,  3.11069D0,  2.16791D0,  1.74484D0,  1.48959D0,
     &     1.30967D0,  0.86476D0,  0.55049D0,  0.41422D0,  0.33471D0,
     &     0.28168D0,  0.21423D0,  0.15699D0,  0.10682D0,  0.07925D0,
     &     0.04965D0,  0.03404D0,  0.02451D0,  0.01690D0,  0.01194D0,
     &     0.00857D0,  0.00620D0,  0.00449D0,  0.00326D0,  0.00237D0,
     &     0.00171D0,  0.00123D0,  0.00088D0,  0.00062D0,  0.00044D0,
     &     0.00032D0,  0.00025D0,  0.00017D0,  0.00010D0,  0.00006D0,
     &     0.00003D0,  0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I,34),I=1,49)/
     &    15.05309D0, 10.59701D0,  7.45476D0,  6.06488D0,  5.23678D0,
     &     4.67164D0,  3.26773D0,  2.26948D0,  1.82284D0,  1.55389D0,
     &     1.36460D0,  0.89767D0,  0.56921D0,  0.42730D0,  0.34468D0,
     &     0.28967D0,  0.21983D0,  0.16070D0,  0.10902D0,  0.08069D0,
     &     0.05036D0,  0.03441D0,  0.02470D0,  0.01698D0,  0.01196D0,
     &     0.00856D0,  0.00617D0,  0.00446D0,  0.00323D0,  0.00234D0,
     &     0.00168D0,  0.00121D0,  0.00086D0,  0.00061D0,  0.00043D0,
     &     0.00032D0,  0.00024D0,  0.00017D0,  0.00010D0,  0.00006D0,
     &     0.00003D0,  0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I,35),I=1,49)/
     &    15.99294D0, 11.22254D0,  7.86947D0,  6.39022D0,  5.51032D0,
     &     4.91055D0,  3.42373D0,  2.37005D0,  1.89992D0,  1.61733D0,
     &     1.41872D0,  0.92998D0,  0.58753D0,  0.44006D0,  0.35440D0,
     &     0.29744D0,  0.22527D0,  0.16430D0,  0.11114D0,  0.08207D0,
     &     0.05103D0,  0.03476D0,  0.02489D0,  0.01705D0,  0.01198D0,
     &     0.00855D0,  0.00615D0,  0.00444D0,  0.00321D0,  0.00232D0,
     &     0.00166D0,  0.00119D0,  0.00085D0,  0.00060D0,  0.00042D0,
     &     0.00031D0,  0.00024D0,  0.00017D0,  0.00010D0,  0.00006D0,
     &     0.00003D0,  0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I,36),I=1,49)/
     &    16.90825D0, 11.82917D0,  8.26989D0,  6.70353D0,  5.77324D0,
     &     5.13985D0,  3.57272D0,  2.46560D0,  1.97292D0,  1.67727D0,
     &     1.46976D0,  0.96025D0,  0.60456D0,  0.45187D0,  0.36334D0,
     &     0.30458D0,  0.23023D0,  0.16756D0,  0.11304D0,  0.08330D0,
     &     0.05162D0,  0.03506D0,  0.02503D0,  0.01710D0,  0.01198D0,
     &     0.00853D0,  0.00612D0,  0.00440D0,  0.00318D0,  0.00229D0,
     &     0.00164D0,  0.00117D0,  0.00083D0,  0.00059D0,  0.00042D0,
     &     0.00031D0,  0.00024D0,  0.00017D0,  0.00010D0,  0.00006D0,
     &     0.00003D0,  0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I,37),I=1,49)/
     &    17.85379D0, 12.45318D0,  8.67996D0,  7.02354D0,  6.04126D0,
     &     5.37323D0,  3.72362D0,  2.56187D0,  2.04622D0,  1.73730D0,
     &     1.52078D0,  0.99029D0,  0.62133D0,  0.46343D0,  0.37206D0,
     &     0.31151D0,  0.23502D0,  0.17068D0,  0.11483D0,  0.08444D0,
     &     0.05214D0,  0.03531D0,  0.02515D0,  0.01713D0,  0.01196D0,
     &     0.00850D0,  0.00608D0,  0.00437D0,  0.00315D0,  0.00226D0,
     &     0.00162D0,  0.00115D0,  0.00082D0,  0.00058D0,  0.00041D0,
     &     0.00030D0,  0.00024D0,  0.00017D0,  0.00010D0,  0.00006D0,
     &     0.00003D0,  0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,7,I,38),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I, 1),I=1,49)/
     &     0.88043D0,  0.77333D0,  0.67888D0,  0.62888D0,  0.59555D0,
     &     0.57086D0,  0.50019D0,  0.43775D0,  0.40464D0,  0.38254D0,
     &     0.36610D0,  0.31885D0,  0.27689D0,  0.25464D0,  0.23989D0,
     &     0.22903D0,  0.21364D0,  0.19859D0,  0.18303D0,  0.17273D0,
     &     0.15826D0,  0.14656D0,  0.13527D0,  0.12062D0,  0.10522D0,
     &     0.08955D0,  0.07420D0,  0.05981D0,  0.04692D0,  0.03554D0,
     &     0.02630D0,  0.01878D0,  0.01298D0,  0.00870D0,  0.00554D0,
     &     0.00339D0,  0.00198D0,  0.00110D0,  0.00049D0,  0.00026D0,
     &     0.00012D0,  0.00002D0,  0.00002D0,  0.00000D0, -0.00001D0,
     &    -0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I, 2),I=1,49)/
     &     0.89442D0,  0.78714D0,  0.69235D0,  0.64208D0,  0.60853D0,
     &     0.58367D0,  0.51236D0,  0.44919D0,  0.41561D0,  0.39314D0,
     &     0.37639D0,  0.32808D0,  0.28485D0,  0.26176D0,  0.24637D0,
     &     0.23501D0,  0.21882D0,  0.20291D0,  0.18634D0,  0.17532D0,
     &     0.15979D0,  0.14730D0,  0.13538D0,  0.12014D0,  0.10435D0,
     &     0.08847D0,  0.07306D0,  0.05873D0,  0.04595D0,  0.03477D0,
     &     0.02571D0,  0.01837D0,  0.01273D0,  0.00855D0,  0.00550D0,
     &     0.00340D0,  0.00204D0,  0.00117D0,  0.00055D0,  0.00031D0,
     &     0.00017D0,  0.00006D0,  0.00005D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I, 3),I=1,49)/
     &     0.93116D0,  0.82082D0,  0.72315D0,  0.67127D0,  0.63662D0,
     &     0.61092D0,  0.53708D0,  0.47148D0,  0.43647D0,  0.41299D0,
     &     0.39541D0,  0.34450D0,  0.29850D0,  0.27374D0,  0.25714D0,
     &     0.24483D0,  0.22722D0,  0.20981D0,  0.19154D0,  0.17933D0,
     &     0.16210D0,  0.14837D0,  0.13550D0,  0.11937D0,  0.10300D0,
     &     0.08681D0,  0.07133D0,  0.05711D0,  0.04449D0,  0.03362D0,
     &     0.02480D0,  0.01774D0,  0.01234D0,  0.00831D0,  0.00539D0,
     &     0.00338D0,  0.00208D0,  0.00122D0,  0.00062D0,  0.00038D0,
     &     0.00022D0,  0.00010D0,  0.00007D0,  0.00002D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I, 4),I=1,49)/
     &     0.97222D0,  0.85703D0,  0.75505D0,  0.70088D0,  0.66470D0,
     &     0.63785D0,  0.56070D0,  0.49207D0,  0.45539D0,  0.43075D0,
     &     0.41225D0,  0.35857D0,  0.30984D0,  0.28350D0,  0.26581D0,
     &     0.25266D0,  0.23382D0,  0.21514D0,  0.19549D0,  0.18234D0,
     &     0.16379D0,  0.14912D0,  0.13552D0,  0.11873D0,  0.10198D0,
     &     0.08556D0,  0.07005D0,  0.05591D0,  0.04344D0,  0.03278D0,
     &     0.02413D0,  0.01727D0,  0.01201D0,  0.00813D0,  0.00530D0,
     &     0.00334D0,  0.00207D0,  0.00123D0,  0.00065D0,  0.00042D0,
     &     0.00025D0,  0.00012D0,  0.00009D0,  0.00002D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I, 5),I=1,49)/
     &     1.03488D0,  0.91080D0,  0.80113D0,  0.74294D0,  0.70410D0,
     &     0.67529D0,  0.59258D0,  0.51904D0,  0.47974D0,  0.45332D0,
     &     0.43343D0,  0.37573D0,  0.32325D0,  0.29486D0,  0.27577D0,
     &     0.26158D0,  0.24123D0,  0.22104D0,  0.19979D0,  0.18555D0,
     &     0.16552D0,  0.14984D0,  0.13548D0,  0.11801D0,  0.10084D0,
     &     0.08422D0,  0.06865D0,  0.05459D0,  0.04229D0,  0.03183D0,
     &     0.02342D0,  0.01674D0,  0.01163D0,  0.00790D0,  0.00517D0,
     &     0.00326D0,  0.00204D0,  0.00126D0,  0.00069D0,  0.00044D0,
     &     0.00027D0,  0.00014D0,  0.00010D0,  0.00004D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I, 6),I=1,49)/
     &     1.09976D0,  0.96588D0,  0.84779D0,  0.78524D0,  0.74353D0,
     &     0.71261D0,  0.62395D0,  0.54523D0,  0.50318D0,  0.47492D0,
     &     0.45362D0,  0.39183D0,  0.33563D0,  0.30525D0,  0.28482D0,
     &     0.26964D0,  0.24787D0,  0.22628D0,  0.20357D0,  0.18835D0,
     &     0.16700D0,  0.15043D0,  0.13540D0,  0.11734D0,  0.09983D0,
     &     0.08303D0,  0.06744D0,  0.05346D0,  0.04131D0,  0.03103D0,
     &     0.02280D0,  0.01628D0,  0.01131D0,  0.00768D0,  0.00506D0,
     &     0.00319D0,  0.00201D0,  0.00126D0,  0.00071D0,  0.00044D0,
     &     0.00028D0,  0.00015D0,  0.00010D0,  0.00005D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I, 7),I=1,49)/
     &     1.17764D0,  1.03108D0,  0.90223D0,  0.83415D0,  0.78882D0,
     &     0.75526D0,  0.65918D0,  0.57411D0,  0.52875D0,  0.49829D0,
     &     0.47532D0,  0.40880D0,  0.34842D0,  0.31585D0,  0.29397D0,
     &     0.27773D0,  0.25447D0,  0.23144D0,  0.20722D0,  0.19102D0,
     &     0.16837D0,  0.15091D0,  0.13525D0,  0.11665D0,  0.09880D0,
     &     0.08184D0,  0.06625D0,  0.05236D0,  0.04036D0,  0.03026D0,
     &     0.02219D0,  0.01583D0,  0.01099D0,  0.00745D0,  0.00494D0,
     &     0.00313D0,  0.00199D0,  0.00124D0,  0.00071D0,  0.00044D0,
     &     0.00028D0,  0.00014D0,  0.00011D0,  0.00005D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I, 8),I=1,49)/
     &     1.27508D0,  1.11188D0,  0.96899D0,  0.89374D0,  0.84374D0,
     &     0.80677D0,  0.70124D0,  0.60814D0,  0.55864D0,  0.52545D0,
     &     0.50042D0,  0.42815D0,  0.36279D0,  0.32765D0,  0.30409D0,
     &     0.28664D0,  0.26167D0,  0.23701D0,  0.21111D0,  0.19383D0,
     &     0.16977D0,  0.15136D0,  0.13503D0,  0.11586D0,  0.09768D0,
     &     0.08056D0,  0.06499D0,  0.05119D0,  0.03935D0,  0.02943D0,
     &     0.02154D0,  0.01534D0,  0.01065D0,  0.00723D0,  0.00480D0,
     &     0.00305D0,  0.00194D0,  0.00121D0,  0.00071D0,  0.00043D0,
     &     0.00029D0,  0.00014D0,  0.00011D0,  0.00005D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I, 9),I=1,49)/
     &     1.37316D0,  1.19249D0,  1.03498D0,  0.95232D0,  0.89751D0,
     &     0.85705D0,  0.74185D0,  0.64064D0,  0.58699D0,  0.55108D0,
     &     0.52402D0,  0.44610D0,  0.37594D0,  0.33836D0,  0.31323D0,
     &     0.29464D0,  0.26809D0,  0.24193D0,  0.21452D0,  0.19627D0,
     &     0.17094D0,  0.15171D0,  0.13480D0,  0.11515D0,  0.09667D0,
     &     0.07946D0,  0.06388D0,  0.05018D0,  0.03847D0,  0.02871D0,
     &     0.02099D0,  0.01493D0,  0.01036D0,  0.00705D0,  0.00466D0,
     &     0.00297D0,  0.00189D0,  0.00119D0,  0.00071D0,  0.00043D0,
     &     0.00029D0,  0.00015D0,  0.00010D0,  0.00005D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I,10),I=1,49)/
     &     1.48232D0,  1.28141D0,  1.10710D0,  1.01596D0,  0.95567D0,
     &     0.91125D0,  0.78516D0,  0.67489D0,  0.61664D0,  0.57774D0,
     &     0.54846D0,  0.46445D0,  0.38919D0,  0.34906D0,  0.32230D0,
     &     0.30254D0,  0.27439D0,  0.24670D0,  0.21778D0,  0.19857D0,
     &     0.17201D0,  0.15198D0,  0.13451D0,  0.11441D0,  0.09567D0,
     &     0.07837D0,  0.06280D0,  0.04920D0,  0.03762D0,  0.02802D0,
     &     0.02045D0,  0.01454D0,  0.01009D0,  0.00685D0,  0.00453D0,
     &     0.00289D0,  0.00185D0,  0.00117D0,  0.00069D0,  0.00044D0,
     &     0.00029D0,  0.00015D0,  0.00011D0,  0.00004D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I,11),I=1,49)/
     &     1.57825D0,  1.35904D0,  1.16962D0,  1.07091D0,  1.00575D0,
     &     0.95780D0,  0.82207D0,  0.70384D0,  0.64159D0,  0.60009D0,
     &     0.56890D0,  0.47964D0,  0.40007D0,  0.35779D0,  0.32966D0,
     &     0.30893D0,  0.27945D0,  0.25052D0,  0.22036D0,  0.20038D0,
     &     0.17283D0,  0.15216D0,  0.13426D0,  0.11380D0,  0.09487D0,
     &     0.07750D0,  0.06195D0,  0.04843D0,  0.03696D0,  0.02748D0,
     &     0.02002D0,  0.01423D0,  0.00988D0,  0.00669D0,  0.00443D0,
     &     0.00283D0,  0.00181D0,  0.00116D0,  0.00068D0,  0.00044D0,
     &     0.00028D0,  0.00016D0,  0.00011D0,  0.00004D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I,12),I=1,49)/
     &     1.81391D0,  1.54794D0,  1.32027D0,  1.20251D0,  1.12515D0,
     &     1.06843D0,  0.90882D0,  0.77111D0,  0.69913D0,  0.65138D0,
     &     0.61560D0,  0.51392D0,  0.42424D0,  0.37702D0,  0.34578D0,
     &     0.32285D0,  0.29039D0,  0.25868D0,  0.22580D0,  0.20412D0,
     &     0.17445D0,  0.15244D0,  0.13361D0,  0.11242D0,  0.09312D0,
     &     0.07561D0,  0.06012D0,  0.04679D0,  0.03556D0,  0.02636D0,
     &     0.01913D0,  0.01356D0,  0.00940D0,  0.00637D0,  0.00422D0,
     &     0.00270D0,  0.00172D0,  0.00112D0,  0.00066D0,  0.00042D0,
     &     0.00027D0,  0.00016D0,  0.00011D0,  0.00004D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I,13),I=1,49)/
     &     2.05224D0,  1.73683D0,  1.46916D0,  1.33169D0,  1.24177D0,
     &     1.17604D0,  0.99216D0,  0.83488D0,  0.75325D0,  0.69933D0,
     &     0.65905D0,  0.54532D0,  0.44603D0,  0.39419D0,  0.36006D0,
     &     0.33511D0,  0.29992D0,  0.26571D0,  0.23041D0,  0.20724D0,
     &     0.17571D0,  0.15255D0,  0.13296D0,  0.11116D0,  0.09157D0,
     &     0.07397D0,  0.05855D0,  0.04538D0,  0.03436D0,  0.02540D0,
     &     0.01839D0,  0.01299D0,  0.00900D0,  0.00610D0,  0.00403D0,
     &     0.00259D0,  0.00165D0,  0.00107D0,  0.00064D0,  0.00040D0,
     &     0.00027D0,  0.00015D0,  0.00011D0,  0.00004D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I,14),I=1,49)/
     &     2.36037D0,  1.97834D0,  1.65740D0,  1.49390D0,  1.38749D0,
     &     1.31001D0,  1.09465D0,  0.91231D0,  0.81846D0,  0.75678D0,
     &     0.71089D0,  0.58224D0,  0.47125D0,  0.41385D0,  0.37630D0,
     &     0.34896D0,  0.31058D0,  0.27348D0,  0.23541D0,  0.21054D0,
     &     0.17694D0,  0.15252D0,  0.13212D0,  0.10968D0,  0.08980D0,
     &     0.07213D0,  0.05680D0,  0.04381D0,  0.03304D0,  0.02434D0,
     &     0.01758D0,  0.01241D0,  0.00857D0,  0.00582D0,  0.00382D0,
     &     0.00247D0,  0.00159D0,  0.00103D0,  0.00060D0,  0.00038D0,
     &     0.00026D0,  0.00014D0,  0.00011D0,  0.00004D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I,15),I=1,49)/
     &     2.73224D0,  2.26638D0,  1.87922D0,  1.68367D0,  1.55710D0,
     &     1.46530D0,  1.21194D0,  0.99975D0,  0.89148D0,  0.82073D0,
     &     0.76831D0,  0.62250D0,  0.49828D0,  0.43470D0,  0.39338D0,
     &     0.36342D0,  0.32158D0,  0.28138D0,  0.24036D0,  0.21374D0,
     &     0.17800D0,  0.15230D0,  0.13108D0,  0.10804D0,  0.08789D0,
     &     0.07017D0,  0.05499D0,  0.04222D0,  0.03170D0,  0.02325D0,
     &     0.01673D0,  0.01178D0,  0.00810D0,  0.00551D0,  0.00361D0,
     &     0.00232D0,  0.00150D0,  0.00098D0,  0.00058D0,  0.00036D0,
     &     0.00025D0,  0.00014D0,  0.00010D0,  0.00004D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I,16),I=1,49)/
     &     3.11511D0,  2.55975D0,  2.10267D0,  1.87361D0,  1.72607D0,
     &     1.61945D0,  1.32704D0,  1.08455D0,  0.96180D0,  0.88200D0,
     &     0.82308D0,  0.66038D0,  0.52333D0,  0.45384D0,  0.40893D0,
     &     0.37652D0,  0.33144D0,  0.28836D0,  0.24465D0,  0.21643D0,
     &     0.17877D0,  0.15196D0,  0.13002D0,  0.10649D0,  0.08613D0,
     &     0.06841D0,  0.05335D0,  0.04078D0,  0.03051D0,  0.02230D0,
     &     0.01601D0,  0.01123D0,  0.00772D0,  0.00522D0,  0.00344D0,
     &     0.00221D0,  0.00143D0,  0.00094D0,  0.00056D0,  0.00035D0,
     &     0.00023D0,  0.00014D0,  0.00009D0,  0.00004D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I,17),I=1,49)/
     &     3.54920D0,  2.88904D0,  2.35096D0,  2.08340D0,  1.91191D0,
     &     1.78843D0,  1.45191D0,  1.17555D0,  1.03678D0,  0.94701D0,
     &     0.88099D0,  0.69993D0,  0.54914D0,  0.47339D0,  0.42472D0,
     &     0.38973D0,  0.34130D0,  0.29525D0,  0.24881D0,  0.21897D0,
     &     0.17941D0,  0.15149D0,  0.12887D0,  0.10488D0,  0.08433D0,
     &     0.06664D0,  0.05172D0,  0.03936D0,  0.02933D0,  0.02138D0,
     &     0.01531D0,  0.01070D0,  0.00735D0,  0.00494D0,  0.00327D0,
     &     0.00210D0,  0.00135D0,  0.00089D0,  0.00053D0,  0.00034D0,
     &     0.00022D0,  0.00013D0,  0.00009D0,  0.00004D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I,18),I=1,49)/
     &     3.94722D0,  3.18825D0,  2.57451D0,  2.27128D0,  2.07769D0,
     &     1.93872D0,  1.56191D0,  1.25495D0,  1.10181D0,  1.00316D0,
     &     0.93081D0,  0.73357D0,  0.57081D0,  0.48966D0,  0.43777D0,
     &     0.40060D0,  0.34934D0,  0.30080D0,  0.25209D0,  0.22090D0,
     &     0.17980D0,  0.15100D0,  0.12785D0,  0.10349D0,  0.08283D0,
     &     0.06518D0,  0.05037D0,  0.03822D0,  0.02839D0,  0.02063D0,
     &     0.01472D0,  0.01026D0,  0.00705D0,  0.00475D0,  0.00313D0,
     &     0.00200D0,  0.00129D0,  0.00084D0,  0.00049D0,  0.00033D0,
     &     0.00020D0,  0.00013D0,  0.00009D0,  0.00003D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I,19),I=1,49)/
     &     4.47623D0,  3.58243D0,  2.86642D0,  2.51532D0,  2.29224D0,
     &     2.13264D0,  1.70256D0,  1.35552D0,  1.18371D0,  1.07357D0,
     &     0.99309D0,  0.77516D0,  0.59726D0,  0.50937D0,  0.45348D0,
     &     0.41360D0,  0.35886D0,  0.30730D0,  0.25582D0,  0.22304D0,
     &     0.18010D0,  0.15028D0,  0.12653D0,  0.10177D0,  0.08099D0,
     &     0.06341D0,  0.04879D0,  0.03686D0,  0.02728D0,  0.01973D0,
     &     0.01404D0,  0.00977D0,  0.00668D0,  0.00449D0,  0.00295D0,
     &     0.00189D0,  0.00122D0,  0.00079D0,  0.00046D0,  0.00031D0,
     &     0.00019D0,  0.00011D0,  0.00008D0,  0.00003D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I,20),I=1,49)/
     &     4.99213D0,  3.96349D0,  3.14614D0,  2.74797D0,  2.49601D0,
     &     2.31631D0,  1.83458D0,  1.44905D0,  1.25946D0,  1.13844D0,
     &     1.05027D0,  0.81294D0,  0.62102D0,  0.52694D0,  0.46740D0,
     &     0.42508D0,  0.36719D0,  0.31292D0,  0.25900D0,  0.22482D0,
     &     0.18028D0,  0.14958D0,  0.12531D0,  0.10024D0,  0.07938D0,
     &     0.06186D0,  0.04742D0,  0.03568D0,  0.02633D0,  0.01896D0,
     &     0.01347D0,  0.00937D0,  0.00636D0,  0.00427D0,  0.00280D0,
     &     0.00180D0,  0.00116D0,  0.00076D0,  0.00045D0,  0.00029D0,
     &     0.00019D0,  0.00009D0,  0.00007D0,  0.00003D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I,21),I=1,49)/
     &     5.49949D0,  4.33534D0,  3.41695D0,  2.97216D0,  2.69173D0,
     &     2.49225D0,  1.96002D0,  1.53717D0,  1.33047D0,  1.19901D0,
     &     1.10350D0,  0.84773D0,  0.64263D0,  0.54279D0,  0.47988D0,
     &     0.43530D0,  0.37453D0,  0.31778D0,  0.26166D0,  0.22622D0,
     &     0.18027D0,  0.14882D0,  0.12412D0,  0.09878D0,  0.07788D0,
     &     0.06045D0,  0.04618D0,  0.03463D0,  0.02546D0,  0.01831D0,
     &     0.01296D0,  0.00899D0,  0.00611D0,  0.00409D0,  0.00268D0,
     &     0.00172D0,  0.00111D0,  0.00073D0,  0.00045D0,  0.00028D0,
     &     0.00018D0,  0.00010D0,  0.00007D0,  0.00003D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I,22),I=1,49)/
     &     6.19994D0,  4.84455D0,  3.78480D0,  3.27524D0,  2.95541D0,
     &     2.72867D0,  2.12718D0,  1.65361D0,  1.42381D0,  1.27834D0,
     &     1.17300D0,  0.89272D0,  0.67027D0,  0.56291D0,  0.49563D0,
     &     0.44814D0,  0.38367D0,  0.32378D0,  0.26487D0,  0.22786D0,
     &     0.18016D0,  0.14778D0,  0.12256D0,  0.09693D0,  0.07601D0,
     &     0.05870D0,  0.04463D0,  0.03333D0,  0.02440D0,  0.01750D0,
     &     0.01234D0,  0.00854D0,  0.00580D0,  0.00388D0,  0.00253D0,
     &     0.00162D0,  0.00104D0,  0.00069D0,  0.00042D0,  0.00026D0,
     &     0.00018D0,  0.00010D0,  0.00006D0,  0.00003D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I,23),I=1,49)/
     &     6.91850D0,  5.36248D0,  4.15576D0,  3.57933D0,  3.21903D0,
     &     2.96436D0,  2.29236D0,  1.76765D0,  1.51472D0,  1.35530D0,
     &     1.24020D0,  0.93576D0,  0.69640D0,  0.58179D0,  0.51031D0,
     &     0.46004D0,  0.39207D0,  0.32922D0,  0.26771D0,  0.22925D0,
     &     0.17994D0,  0.14672D0,  0.12105D0,  0.09521D0,  0.07427D0,
     &     0.05708D0,  0.04320D0,  0.03213D0,  0.02345D0,  0.01676D0,
     &     0.01179D0,  0.00813D0,  0.00551D0,  0.00368D0,  0.00240D0,
     &     0.00152D0,  0.00099D0,  0.00064D0,  0.00039D0,  0.00024D0,
     &     0.00017D0,  0.00009D0,  0.00006D0,  0.00003D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I,24),I=1,49)/
     &     7.63491D0,  5.87479D0,  4.51976D0,  3.87632D0,  3.47562D0,
     &     3.19317D0,  2.45140D0,  1.87649D0,  1.60104D0,  1.42808D0,
     &     1.30355D0,  0.97589D0,  0.72045D0,  0.59900D0,  0.52360D0,
     &     0.47074D0,  0.39952D0,  0.33394D0,  0.27005D0,  0.23029D0,
     &     0.17956D0,  0.14561D0,  0.11956D0,  0.09355D0,  0.07262D0,
     &     0.05557D0,  0.04190D0,  0.03105D0,  0.02258D0,  0.01609D0,
     &     0.01128D0,  0.00777D0,  0.00525D0,  0.00350D0,  0.00227D0,
     &     0.00145D0,  0.00095D0,  0.00060D0,  0.00036D0,  0.00023D0,
     &     0.00015D0,  0.00008D0,  0.00006D0,  0.00003D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I,25),I=1,49)/
     &     8.40875D0,  6.42416D0,  4.90727D0,  4.19114D0,  3.74679D0,
     &     3.43441D0,  2.61784D0,  1.98954D0,  1.69029D0,  1.50308D0,
     &     1.36865D0,  1.01677D0,  0.74472D0,  0.61626D0,  0.53686D0,
     &     0.48138D0,  0.40687D0,  0.33856D0,  0.27230D0,  0.23124D0,
     &     0.17912D0,  0.14448D0,  0.11807D0,  0.09190D0,  0.07100D0,
     &     0.05410D0,  0.04063D0,  0.03001D0,  0.02174D0,  0.01545D0,
     &     0.01080D0,  0.00742D0,  0.00500D0,  0.00332D0,  0.00215D0,
     &     0.00138D0,  0.00091D0,  0.00056D0,  0.00034D0,  0.00022D0,
     &     0.00014D0,  0.00008D0,  0.00005D0,  0.00002D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I,26),I=1,49)/
     &     9.20959D0,  6.98865D0,  5.30257D0,  4.51092D0,  4.02140D0,
     &     3.67813D0,  2.78472D0,  2.10201D0,  1.77866D0,  1.57708D0,
     &     1.43269D0,  1.05659D0,  0.76808D0,  0.63273D0,  0.54942D0,
     &     0.49139D0,  0.41371D0,  0.34277D0,  0.27426D0,  0.23197D0,
     &     0.17855D0,  0.14327D0,  0.11656D0,  0.09025D0,  0.06944D0,
     &     0.05268D0,  0.03941D0,  0.02899D0,  0.02094D0,  0.01485D0,
     &     0.01035D0,  0.00708D0,  0.00476D0,  0.00316D0,  0.00205D0,
     &     0.00131D0,  0.00085D0,  0.00054D0,  0.00031D0,  0.00021D0,
     &     0.00013D0,  0.00008D0,  0.00005D0,  0.00002D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I,27),I=1,49)/
     &    10.01660D0,  7.55374D0,  5.69567D0,  4.82767D0,  4.29265D0,
     &     3.91834D0,  2.94808D0,  2.21134D0,  1.86419D0,  1.64848D0,
     &     1.49433D0,  1.09459D0,  0.79015D0,  0.64820D0,  0.56116D0,
     &     0.50070D0,  0.42001D0,  0.34660D0,  0.27598D0,  0.23256D0,
     &     0.17794D0,  0.14210D0,  0.11511D0,  0.08871D0,  0.06797D0,
     &     0.05137D0,  0.03829D0,  0.02806D0,  0.02022D0,  0.01430D0,
     &     0.00994D0,  0.00679D0,  0.00455D0,  0.00301D0,  0.00196D0,
     &     0.00124D0,  0.00081D0,  0.00052D0,  0.00030D0,  0.00020D0,
     &     0.00013D0,  0.00008D0,  0.00005D0,  0.00002D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I,28),I=1,49)/
     &    10.81622D0,  8.11020D0,  6.08037D0,  5.13653D0,  4.55643D0,
     &     4.15146D0,  3.10560D0,  2.31605D0,  1.94577D0,  1.71637D0,
     &     1.55278D0,  1.13032D0,  0.81070D0,  0.66250D0,  0.57195D0,
     &     0.50921D0,  0.42571D0,  0.35000D0,  0.27744D0,  0.23299D0,
     &     0.17730D0,  0.14094D0,  0.11373D0,  0.08726D0,  0.06658D0,
     &     0.05015D0,  0.03725D0,  0.02723D0,  0.01957D0,  0.01380D0,
     &     0.00957D0,  0.00653D0,  0.00437D0,  0.00288D0,  0.00188D0,
     &     0.00119D0,  0.00077D0,  0.00050D0,  0.00029D0,  0.00019D0,
     &     0.00012D0,  0.00007D0,  0.00005D0,  0.00002D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I,29),I=1,49)/
     &    11.66230D0,  8.69558D0,  6.48269D0,  5.45841D0,  4.83067D0,
     &     4.39335D0,  3.26805D0,  2.42336D0,  2.02906D0,  1.78549D0,
     &     1.61215D0,  1.16634D0,  0.83123D0,  0.67669D0,  0.58260D0,
     &     0.51757D0,  0.43126D0,  0.35327D0,  0.27879D0,  0.23332D0,
     &     0.17659D0,  0.13975D0,  0.11233D0,  0.08581D0,  0.06521D0,
     &     0.04895D0,  0.03623D0,  0.02642D0,  0.01893D0,  0.01332D0,
     &     0.00922D0,  0.00628D0,  0.00420D0,  0.00276D0,  0.00179D0,
     &     0.00113D0,  0.00073D0,  0.00048D0,  0.00028D0,  0.00018D0,
     &     0.00012D0,  0.00007D0,  0.00004D0,  0.00001D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I,30),I=1,49)/
     &    12.53147D0,  9.29349D0,  6.89124D0,  5.78416D0,  5.10752D0,
     &     4.63707D0,  3.43073D0,  2.53015D0,  2.11162D0,  1.85381D0,
     &     1.67070D0,  1.20157D0,  0.85112D0,  0.69035D0,  0.59278D0,
     &     0.52552D0,  0.43648D0,  0.35628D0,  0.27996D0,  0.23352D0,
     &     0.17581D0,  0.13853D0,  0.11093D0,  0.08439D0,  0.06389D0,
     &     0.04778D0,  0.03525D0,  0.02563D0,  0.01832D0,  0.01286D0,
     &     0.00888D0,  0.00603D0,  0.00403D0,  0.00265D0,  0.00171D0,
     &     0.00109D0,  0.00070D0,  0.00046D0,  0.00026D0,  0.00017D0,
     &     0.00011D0,  0.00006D0,  0.00004D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I,31),I=1,49)/
     &    13.39986D0,  9.88770D0,  7.29509D0,  6.10513D0,  5.37969D0,
     &     4.87627D0,  3.58951D0,  2.63377D0,  2.19145D0,  1.91971D0,
     &     1.72706D0,  1.23525D0,  0.86997D0,  0.70322D0,  0.60234D0,
     &     0.53296D0,  0.44131D0,  0.35903D0,  0.28099D0,  0.23364D0,
     &     0.17503D0,  0.13736D0,  0.10960D0,  0.08305D0,  0.06264D0,
     &     0.04669D0,  0.03435D0,  0.02491D0,  0.01775D0,  0.01244D0,
     &     0.00857D0,  0.00581D0,  0.00387D0,  0.00255D0,  0.00164D0,
     &     0.00105D0,  0.00067D0,  0.00044D0,  0.00025D0,  0.00016D0,
     &     0.00011D0,  0.00006D0,  0.00004D0,  0.00002D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I,32),I=1,49)/
     &    14.24690D0, 10.46430D0,  7.68491D0,  6.41400D0,  5.64102D0,
     &     5.10551D0,  3.74084D0,  2.73196D0,  2.26682D0,  1.98174D0,
     &     1.77998D0,  1.26662D0,  0.88736D0,  0.71501D0,  0.61103D0,
     &     0.53966D0,  0.44562D0,  0.36142D0,  0.28180D0,  0.23363D0,
     &     0.17423D0,  0.13620D0,  0.10832D0,  0.08177D0,  0.06147D0,
     &     0.04567D0,  0.03352D0,  0.02425D0,  0.01724D0,  0.01204D0,
     &     0.00828D0,  0.00559D0,  0.00373D0,  0.00245D0,  0.00158D0,
     &     0.00099D0,  0.00065D0,  0.00042D0,  0.00024D0,  0.00015D0,
     &     0.00010D0,  0.00006D0,  0.00004D0,  0.00002D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I,33),I=1,49)/
     &    15.14936D0, 11.07583D0,  8.09647D0,  6.73922D0,  5.91564D0,
     &     5.34608D0,  3.89891D0,  2.83403D0,  2.34496D0,  2.04593D0,
     &     1.83464D0,  1.29886D0,  0.90513D0,  0.72701D0,  0.61986D0,
     &     0.54647D0,  0.44998D0,  0.36383D0,  0.28262D0,  0.23362D0,
     &     0.17343D0,  0.13505D0,  0.10704D0,  0.08050D0,  0.06032D0,
     &     0.04468D0,  0.03270D0,  0.02360D0,  0.01675D0,  0.01165D0,
     &     0.00800D0,  0.00538D0,  0.00360D0,  0.00236D0,  0.00153D0,
     &     0.00094D0,  0.00062D0,  0.00040D0,  0.00024D0,  0.00014D0,
     &     0.00010D0,  0.00005D0,  0.00004D0,  0.00002D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I,34),I=1,49)/
     &    16.05264D0, 11.68476D0,  8.50413D0,  7.06033D0,  6.18619D0,
     &     5.58264D0,  4.05344D0,  2.93321D0,  2.42057D0,  2.10785D0,
     &     1.88726D0,  1.32960D0,  0.92187D0,  0.73821D0,  0.62802D0,
     &     0.55270D0,  0.45389D0,  0.36590D0,  0.28320D0,  0.23345D0,
     &     0.17251D0,  0.13385D0,  0.10575D0,  0.07924D0,  0.05918D0,
     &     0.04371D0,  0.03189D0,  0.02297D0,  0.01625D0,  0.01129D0,
     &     0.00773D0,  0.00520D0,  0.00346D0,  0.00227D0,  0.00146D0,
     &     0.00090D0,  0.00059D0,  0.00038D0,  0.00022D0,  0.00014D0,
     &     0.00009D0,  0.00005D0,  0.00004D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I,35),I=1,49)/
     &    16.95831D0, 12.29275D0,  8.90942D0,  7.37879D0,  6.45402D0,
     &     5.81651D0,  4.20556D0,  3.03041D0,  2.49449D0,  2.16827D0,
     &     1.93852D0,  1.35941D0,  0.93802D0,  0.74899D0,  0.63586D0,
     &     0.55868D0,  0.45763D0,  0.36787D0,  0.28375D0,  0.23328D0,
     &     0.17165D0,  0.13272D0,  0.10453D0,  0.07807D0,  0.05811D0,
     &     0.04281D0,  0.03114D0,  0.02238D0,  0.01579D0,  0.01096D0,
     &     0.00748D0,  0.00503D0,  0.00334D0,  0.00218D0,  0.00141D0,
     &     0.00087D0,  0.00056D0,  0.00036D0,  0.00021D0,  0.00013D0,
     &     0.00009D0,  0.00005D0,  0.00004D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I,36),I=1,49)/
     &    17.84218D0, 12.88352D0,  9.30151D0,  7.68607D0,  6.71197D0,
     &     6.04141D0,  4.35117D0,  3.12299D0,  2.56467D0,  2.22550D0,
     &     1.98697D0,  1.38741D0,  0.95307D0,  0.75895D0,  0.64306D0,
     &     0.56414D0,  0.46100D0,  0.36960D0,  0.28418D0,  0.23305D0,
     &     0.17079D0,  0.13162D0,  0.10337D0,  0.07695D0,  0.05711D0,
     &     0.04196D0,  0.03045D0,  0.02184D0,  0.01537D0,  0.01065D0,
     &     0.00725D0,  0.00488D0,  0.00323D0,  0.00211D0,  0.00135D0,
     &     0.00084D0,  0.00054D0,  0.00035D0,  0.00020D0,  0.00012D0,
     &     0.00009D0,  0.00005D0,  0.00003D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I,37),I=1,49)/
     &    18.75837D0, 13.49331D0,  9.70449D0,  8.00107D0,  6.97591D0,
     &     6.27121D0,  4.49926D0,  3.21668D0,  2.63548D0,  2.28312D0,
     &     2.03566D0,  1.41534D0,  0.96795D0,  0.76874D0,  0.65009D0,
     &     0.56943D0,  0.46423D0,  0.37122D0,  0.28450D0,  0.23274D0,
     &     0.16989D0,  0.13050D0,  0.10219D0,  0.07583D0,  0.05612D0,
     &     0.04112D0,  0.02978D0,  0.02129D0,  0.01496D0,  0.01035D0,
     &     0.00703D0,  0.00473D0,  0.00312D0,  0.00203D0,  0.00130D0,
     &     0.00081D0,  0.00052D0,  0.00034D0,  0.00019D0,  0.00012D0,
     &     0.00008D0,  0.00005D0,  0.00003D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(1,8,I,38),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,1,I, 1),I=1,49)/
     &     0.01616D0,  0.01968D0,  0.02397D0,  0.02690D0,  0.02921D0,
     &     0.03113D0,  0.03797D0,  0.04639D0,  0.05222D0,  0.05685D0,
     &     0.06076D0,  0.07508D0,  0.09409D0,  0.10852D0,  0.12095D0,
     &     0.13220D0,  0.15265D0,  0.18041D0,  0.22265D0,  0.26180D0,
     &     0.33338D0,  0.39710D0,  0.45318D0,  0.51262D0,  0.56037D0,
     &     0.59685D0,  0.62256D0,  0.63820D0,  0.64458D0,  0.64218D0,
     &     0.63256D0,  0.61605D0,  0.59381D0,  0.56668D0,  0.53544D0,
     &     0.50113D0,  0.46441D0,  0.42608D0,  0.38703D0,  0.34764D0,
     &     0.30873D0,  0.27101D0,  0.23457D0,  0.16829D0,  0.11224D0,
     &     0.06802D0,  0.03588D0,  0.00449D0,  0.00000D0/
      DATA (FMRS(2,1,I, 2),I=1,49)/
     &     0.01632D0,  0.01989D0,  0.02423D0,  0.02721D0,  0.02954D0,
     &     0.03149D0,  0.03843D0,  0.04698D0,  0.05290D0,  0.05761D0,
     &     0.06159D0,  0.07621D0,  0.09566D0,  0.11046D0,  0.12320D0,
     &     0.13473D0,  0.15566D0,  0.18401D0,  0.22694D0,  0.26649D0,
     &     0.33826D0,  0.40154D0,  0.45671D0,  0.51456D0,  0.56041D0,
     &     0.59481D0,  0.61838D0,  0.63191D0,  0.63628D0,  0.63211D0,
     &     0.62085D0,  0.60298D0,  0.57964D0,  0.55165D0,  0.51988D0,
     &     0.48526D0,  0.44851D0,  0.41042D0,  0.37182D0,  0.33308D0,
     &     0.29500D0,  0.25823D0,  0.22287D0,  0.15893D0,  0.10532D0,
     &     0.06336D0,  0.03315D0,  0.00405D0,  0.00000D0/
      DATA (FMRS(2,1,I, 3),I=1,49)/
     &     0.01657D0,  0.02020D0,  0.02463D0,  0.02767D0,  0.03005D0,
     &     0.03204D0,  0.03912D0,  0.04786D0,  0.05393D0,  0.05876D0,
     &     0.06285D0,  0.07791D0,  0.09803D0,  0.11338D0,  0.12658D0,
     &     0.13853D0,  0.16018D0,  0.18937D0,  0.23326D0,  0.27335D0,
     &     0.34527D0,  0.40778D0,  0.46152D0,  0.51696D0,  0.55995D0,
     &     0.59126D0,  0.61170D0,  0.62221D0,  0.62369D0,  0.61697D0,
     &     0.60343D0,  0.58371D0,  0.55889D0,  0.52978D0,  0.49735D0,
     &     0.46237D0,  0.42568D0,  0.38804D0,  0.35014D0,  0.31246D0,
     &     0.27562D0,  0.24027D0,  0.20650D0,  0.14595D0,  0.09580D0,
     &     0.05701D0,  0.02946D0,  0.00347D0,  0.00000D0/
      DATA (FMRS(2,1,I, 4),I=1,49)/
     &     0.01676D0,  0.02044D0,  0.02493D0,  0.02801D0,  0.03042D0,
     &     0.03244D0,  0.03964D0,  0.04852D0,  0.05470D0,  0.05962D0,
     &     0.06379D0,  0.07918D0,  0.09980D0,  0.11554D0,  0.12909D0,
     &     0.14134D0,  0.16349D0,  0.19329D0,  0.23784D0,  0.27828D0,
     &     0.35023D0,  0.41207D0,  0.46471D0,  0.51833D0,  0.55923D0,
     &     0.58830D0,  0.60648D0,  0.61486D0,  0.61433D0,  0.60584D0,
     &     0.59072D0,  0.56980D0,  0.54398D0,  0.51418D0,  0.48131D0,
     &     0.44619D0,  0.40966D0,  0.37236D0,  0.33505D0,  0.29814D0,
     &     0.26220D0,  0.22791D0,  0.19528D0,  0.13713D0,  0.08936D0,
     &     0.05277D0,  0.02703D0,  0.00310D0,  0.00000D0/
      DATA (FMRS(2,1,I, 5),I=1,49)/
     &     0.01695D0,  0.02068D0,  0.02524D0,  0.02837D0,  0.03082D0,
     &     0.03287D0,  0.04018D0,  0.04922D0,  0.05552D0,  0.06053D0,
     &     0.06480D0,  0.08053D0,  0.10168D0,  0.11784D0,  0.13174D0,
     &     0.14430D0,  0.16698D0,  0.19737D0,  0.24257D0,  0.28331D0,
     &     0.35517D0,  0.41625D0,  0.46767D0,  0.51932D0,  0.55801D0,
     &     0.58472D0,  0.60061D0,  0.60677D0,  0.60420D0,  0.59394D0,
     &     0.57732D0,  0.55511D0,  0.52831D0,  0.49795D0,  0.46473D0,
     &     0.42958D0,  0.39324D0,  0.35636D0,  0.31976D0,  0.28363D0,
     &     0.24869D0,  0.21549D0,  0.18405D0,  0.12838D0,  0.08307D0,
     &     0.04866D0,  0.02468D0,  0.00276D0,  0.00000D0/
      DATA (FMRS(2,1,I, 6),I=1,49)/
     &     0.01712D0,  0.02090D0,  0.02552D0,  0.02868D0,  0.03117D0,
     &     0.03325D0,  0.04066D0,  0.04984D0,  0.05623D0,  0.06133D0,
     &     0.06568D0,  0.08172D0,  0.10333D0,  0.11984D0,  0.13405D0,
     &     0.14688D0,  0.17001D0,  0.20090D0,  0.24663D0,  0.28761D0,
     &     0.35934D0,  0.41972D0,  0.47004D0,  0.51998D0,  0.55675D0,
     &     0.58145D0,  0.59540D0,  0.59970D0,  0.59545D0,  0.58373D0,
     &     0.56587D0,  0.54263D0,  0.51509D0,  0.48426D0,  0.45082D0,
     &     0.41570D0,  0.37956D0,  0.34309D0,  0.30710D0,  0.27167D0,
     &     0.23758D0,  0.20532D0,  0.17488D0,  0.12129D0,  0.07799D0,
     &     0.04537D0,  0.02283D0,  0.00249D0,  0.00000D0/
      DATA (FMRS(2,1,I, 7),I=1,49)/
     &     0.01728D0,  0.02111D0,  0.02578D0,  0.02899D0,  0.03151D0,
     &     0.03361D0,  0.04113D0,  0.05044D0,  0.05693D0,  0.06211D0,
     &     0.06653D0,  0.08287D0,  0.10492D0,  0.12178D0,  0.13628D0,
     &     0.14936D0,  0.17290D0,  0.20425D0,  0.25045D0,  0.29164D0,
     &     0.36316D0,  0.42280D0,  0.47203D0,  0.52030D0,  0.55522D0,
     &     0.57804D0,  0.59016D0,  0.59271D0,  0.58692D0,  0.57390D0,
     &     0.55488D0,  0.53075D0,  0.50265D0,  0.47135D0,  0.43776D0,
     &     0.40267D0,  0.36679D0,  0.33078D0,  0.29535D0,  0.26064D0,
     &     0.22735D0,  0.19600D0,  0.16649D0,  0.11484D0,  0.07339D0,
     &     0.04241D0,  0.02117D0,  0.00226D0,  0.00000D0/
      DATA (FMRS(2,1,I, 8),I=1,49)/
     &     0.01745D0,  0.02133D0,  0.02606D0,  0.02931D0,  0.03187D0,
     &     0.03400D0,  0.04163D0,  0.05108D0,  0.05768D0,  0.06295D0,
     &     0.06745D0,  0.08411D0,  0.10662D0,  0.12385D0,  0.13865D0,
     &     0.15200D0,  0.17596D0,  0.20780D0,  0.25445D0,  0.29582D0,
     &     0.36707D0,  0.42589D0,  0.47392D0,  0.52041D0,  0.55338D0,
     &     0.57422D0,  0.58442D0,  0.58519D0,  0.57783D0,  0.56344D0,
     &     0.54329D0,  0.51831D0,  0.48960D0,  0.45793D0,  0.42423D0,
     &     0.38922D0,  0.35366D0,  0.31814D0,  0.28333D0,  0.24940D0,
     &     0.21696D0,  0.18656D0,  0.15803D0,  0.10837D0,  0.06882D0,
     &     0.03949D0,  0.01956D0,  0.00204D0,  0.00000D0/
      DATA (FMRS(2,1,I, 9),I=1,49)/
     &     0.01760D0,  0.02152D0,  0.02631D0,  0.02960D0,  0.03218D0,
     &     0.03434D0,  0.04207D0,  0.05164D0,  0.05833D0,  0.06368D0,
     &     0.06825D0,  0.08519D0,  0.10811D0,  0.12566D0,  0.14073D0,
     &     0.15430D0,  0.17863D0,  0.21087D0,  0.25789D0,  0.29938D0,
     &     0.37036D0,  0.42844D0,  0.47541D0,  0.52034D0,  0.55162D0,
     &     0.57077D0,  0.57932D0,  0.57861D0,  0.56993D0,  0.55438D0,
     &     0.53332D0,  0.50767D0,  0.47844D0,  0.44653D0,  0.41277D0,
     &     0.37787D0,  0.34261D0,  0.30753D0,  0.27327D0,  0.24001D0,
     &     0.20832D0,  0.17873D0,  0.15102D0,  0.10304D0,  0.06508D0,
     &     0.03712D0,  0.01826D0,  0.00186D0,  0.00000D0/
      DATA (FMRS(2,1,I,10),I=1,49)/
     &     0.01775D0,  0.02171D0,  0.02655D0,  0.02988D0,  0.03249D0,
     &     0.03468D0,  0.04249D0,  0.05219D0,  0.05897D0,  0.06440D0,
     &     0.06904D0,  0.08625D0,  0.10956D0,  0.12741D0,  0.14273D0,
     &     0.15651D0,  0.18119D0,  0.21379D0,  0.26115D0,  0.30273D0,
     &     0.37339D0,  0.43070D0,  0.47663D0,  0.52004D0,  0.54971D0,
     &     0.56723D0,  0.57424D0,  0.57214D0,  0.56221D0,  0.54564D0,
     &     0.52375D0,  0.49748D0,  0.46783D0,  0.43572D0,  0.40192D0,
     &     0.36718D0,  0.33221D0,  0.29755D0,  0.26385D0,  0.23124D0,
     &     0.20028D0,  0.17145D0,  0.14454D0,  0.09813D0,  0.06166D0,
     &     0.03497D0,  0.01708D0,  0.00171D0,  0.00000D0/
      DATA (FMRS(2,1,I,11),I=1,49)/
     &     0.01786D0,  0.02185D0,  0.02674D0,  0.03010D0,  0.03274D0,
     &     0.03494D0,  0.04284D0,  0.05263D0,  0.05949D0,  0.06497D0,
     &     0.06967D0,  0.08709D0,  0.11072D0,  0.12880D0,  0.14432D0,
     &     0.15827D0,  0.18322D0,  0.21609D0,  0.26371D0,  0.30535D0,
     &     0.37572D0,  0.43240D0,  0.47751D0,  0.51970D0,  0.54811D0,
     &     0.56435D0,  0.57017D0,  0.56701D0,  0.55612D0,  0.53878D0,
     &     0.51626D0,  0.48950D0,  0.45957D0,  0.42732D0,  0.39351D0,
     &     0.35893D0,  0.32420D0,  0.28986D0,  0.25663D0,  0.22452D0,
     &     0.19414D0,  0.16588D0,  0.13961D0,  0.09442D0,  0.05909D0,
     &     0.03336D0,  0.01621D0,  0.00160D0,  0.00000D0/
      DATA (FMRS(2,1,I,12),I=1,49)/
     &     0.01811D0,  0.02217D0,  0.02715D0,  0.03057D0,  0.03326D0,
     &     0.03551D0,  0.04357D0,  0.05358D0,  0.06059D0,  0.06620D0,
     &     0.07102D0,  0.08890D0,  0.11320D0,  0.13179D0,  0.14772D0,
     &     0.16201D0,  0.18751D0,  0.22095D0,  0.26905D0,  0.31076D0,
     &     0.38043D0,  0.43573D0,  0.47902D0,  0.51865D0,  0.54434D0,
     &     0.55794D0,  0.56131D0,  0.55592D0,  0.54308D0,  0.52418D0,
     &     0.50041D0,  0.47277D0,  0.44227D0,  0.40979D0,  0.37605D0,
     &     0.34185D0,  0.30765D0,  0.27411D0,  0.24188D0,  0.21085D0,
     &     0.18166D0,  0.15463D0,  0.12966D0,  0.08698D0,  0.05397D0,
     &     0.03017D0,  0.01449D0,  0.00138D0,  0.00000D0/
      DATA (FMRS(2,1,I,13),I=1,49)/
     &     0.01832D0,  0.02245D0,  0.02751D0,  0.03099D0,  0.03372D0,
     &     0.03601D0,  0.04421D0,  0.05440D0,  0.06155D0,  0.06727D0,
     &     0.07220D0,  0.09048D0,  0.11535D0,  0.13437D0,  0.15065D0,
     &     0.16524D0,  0.19119D0,  0.22510D0,  0.27356D0,  0.31528D0,
     &     0.38427D0,  0.43832D0,  0.48002D0,  0.51742D0,  0.54081D0,
     &     0.55220D0,  0.55352D0,  0.54629D0,  0.53189D0,  0.51174D0,
     &     0.48699D0,  0.45870D0,  0.42778D0,  0.39517D0,  0.36159D0,
     &     0.32774D0,  0.29406D0,  0.26124D0,  0.22984D0,  0.19975D0,
     &     0.17155D0,  0.14556D0,  0.12166D0,  0.08107D0,  0.04993D0,
     &     0.02767D0,  0.01316D0,  0.00122D0,  0.00000D0/
      DATA (FMRS(2,1,I,14),I=1,49)/
     &     0.01856D0,  0.02276D0,  0.02791D0,  0.03145D0,  0.03424D0,
     &     0.03657D0,  0.04493D0,  0.05533D0,  0.06263D0,  0.06849D0,
     &     0.07353D0,  0.09227D0,  0.11778D0,  0.13727D0,  0.15393D0,
     &     0.16884D0,  0.19528D0,  0.22966D0,  0.27847D0,  0.32014D0,
     &     0.38833D0,  0.44089D0,  0.48079D0,  0.51572D0,  0.53660D0,
     &     0.54555D0,  0.54466D0,  0.53550D0,  0.51948D0,  0.49806D0,
     &     0.47232D0,  0.44337D0,  0.41209D0,  0.37941D0,  0.34606D0,
     &     0.31264D0,  0.27962D0,  0.24761D0,  0.21707D0,  0.18804D0,
     &     0.16093D0,  0.13609D0,  0.11331D0,  0.07496D0,  0.04577D0,
     &     0.02513D0,  0.01183D0,  0.00106D0,  0.00000D0/
      DATA (FMRS(2,1,I,15),I=1,49)/
     &     0.01882D0,  0.02309D0,  0.02833D0,  0.03194D0,  0.03478D0,
     &     0.03716D0,  0.04569D0,  0.05632D0,  0.06378D0,  0.06977D0,
     &     0.07493D0,  0.09414D0,  0.12031D0,  0.14028D0,  0.15732D0,
     &     0.17254D0,  0.19946D0,  0.23430D0,  0.28337D0,  0.32492D0,
     &     0.39212D0,  0.44309D0,  0.48109D0,  0.51344D0,  0.53176D0,
     &     0.53830D0,  0.53520D0,  0.52410D0,  0.50654D0,  0.48389D0,
     &     0.45725D0,  0.42772D0,  0.39621D0,  0.36351D0,  0.33050D0,
     &     0.29757D0,  0.26525D0,  0.23404D0,  0.20451D0,  0.17653D0,
     &     0.15059D0,  0.12691D0,  0.10526D0,  0.06909D0,  0.04183D0,
     &     0.02276D0,  0.01059D0,  0.00092D0,  0.00000D0/
      DATA (FMRS(2,1,I,16),I=1,49)/
     &     0.01904D0,  0.02338D0,  0.02872D0,  0.03239D0,  0.03528D0,
     &     0.03770D0,  0.04639D0,  0.05722D0,  0.06483D0,  0.07094D0,
     &     0.07621D0,  0.09585D0,  0.12261D0,  0.14301D0,  0.16039D0,
     &     0.17588D0,  0.20321D0,  0.23842D0,  0.28769D0,  0.32908D0,
     &     0.39530D0,  0.44481D0,  0.48105D0,  0.51110D0,  0.52712D0,
     &     0.53155D0,  0.52655D0,  0.51382D0,  0.49491D0,  0.47126D0,
     &     0.44390D0,  0.41395D0,  0.38228D0,  0.34968D0,  0.31695D0,
     &     0.28453D0,  0.25288D0,  0.22245D0,  0.19380D0,  0.16677D0,
     &     0.14180D0,  0.11912D0,  0.09847D0,  0.06418D0,  0.03856D0,
     &     0.02081D0,  0.00959D0,  0.00081D0,  0.00000D0/
      DATA (FMRS(2,1,I,17),I=1,49)/
     &     0.01928D0,  0.02369D0,  0.02911D0,  0.03284D0,  0.03578D0,
     &     0.03825D0,  0.04709D0,  0.05813D0,  0.06589D0,  0.07213D0,
     &     0.07751D0,  0.09758D0,  0.12493D0,  0.14576D0,  0.16348D0,
     &     0.17924D0,  0.20696D0,  0.24251D0,  0.29193D0,  0.33312D0,
     &     0.39831D0,  0.44629D0,  0.48077D0,  0.50852D0,  0.52228D0,
     &     0.52463D0,  0.51781D0,  0.50355D0,  0.48335D0,  0.45879D0,
     &     0.43078D0,  0.40049D0,  0.36872D0,  0.33629D0,  0.30386D0,
     &     0.27197D0,  0.24101D0,  0.21137D0,  0.18360D0,  0.15751D0,
     &     0.13349D0,  0.11178D0,  0.09210D0,  0.05961D0,  0.03555D0,
     &     0.01901D0,  0.00868D0,  0.00071D0,  0.00000D0/
      DATA (FMRS(2,1,I,18),I=1,49)/
     &     0.01947D0,  0.02394D0,  0.02943D0,  0.03322D0,  0.03621D0,
     &     0.03871D0,  0.04769D0,  0.05889D0,  0.06678D0,  0.07312D0,
     &     0.07860D0,  0.09903D0,  0.12687D0,  0.14804D0,  0.16603D0,
     &     0.18199D0,  0.21002D0,  0.24583D0,  0.29534D0,  0.33632D0,
     &     0.40060D0,  0.44729D0,  0.48029D0,  0.50614D0,  0.51810D0,
     &     0.51876D0,  0.51049D0,  0.49502D0,  0.47387D0,  0.44861D0,
     &     0.42013D0,  0.38960D0,  0.35780D0,  0.32553D0,  0.29342D0,
     &     0.26197D0,  0.23158D0,  0.20258D0,  0.17557D0,  0.15022D0,
     &     0.12699D0,  0.10608D0,  0.08715D0,  0.05607D0,  0.03324D0,
     &     0.01765D0,  0.00799D0,  0.00064D0,  0.00000D0/
      DATA (FMRS(2,1,I,19),I=1,49)/
     &     0.01970D0,  0.02424D0,  0.02983D0,  0.03369D0,  0.03672D0,
     &     0.03927D0,  0.04841D0,  0.05983D0,  0.06787D0,  0.07433D0,
     &     0.07993D0,  0.10079D0,  0.12921D0,  0.15080D0,  0.16909D0,
     &     0.18531D0,  0.21368D0,  0.24977D0,  0.29932D0,  0.34002D0,
     &     0.40312D0,  0.44820D0,  0.47944D0,  0.50301D0,  0.51281D0,
     &     0.51154D0,  0.50156D0,  0.48470D0,  0.46252D0,  0.43645D0,
     &     0.40748D0,  0.37672D0,  0.34495D0,  0.31293D0,  0.28123D0,
     &     0.25036D0,  0.22064D0,  0.19244D0,  0.16630D0,  0.14187D0,
     &     0.11955D0,  0.09954D0,  0.08152D0,  0.05209D0,  0.03065D0,
     &     0.01614D0,  0.00723D0,  0.00056D0,  0.00000D0/
      DATA (FMRS(2,1,I,20),I=1,49)/
     &     0.01991D0,  0.02452D0,  0.03019D0,  0.03410D0,  0.03718D0,
     &     0.03977D0,  0.04905D0,  0.06066D0,  0.06884D0,  0.07541D0,
     &     0.08111D0,  0.10235D0,  0.13129D0,  0.15323D0,  0.17180D0,
     &     0.18822D0,  0.21689D0,  0.25320D0,  0.30276D0,  0.34318D0,
     &     0.40521D0,  0.44885D0,  0.47855D0,  0.50013D0,  0.50806D0,
     &     0.50515D0,  0.49374D0,  0.47571D0,  0.45269D0,  0.42596D0,
     &     0.39662D0,  0.36569D0,  0.33399D0,  0.30222D0,  0.27090D0,
     &     0.24056D0,  0.21144D0,  0.18393D0,  0.15855D0,  0.13491D0,
     &     0.11336D0,  0.09413D0,  0.07687D0,  0.04883D0,  0.02854D0,
     &     0.01493D0,  0.00663D0,  0.00051D0,  0.00000D0/
      DATA (FMRS(2,1,I,21),I=1,49)/
     &     0.02011D0,  0.02477D0,  0.03051D0,  0.03448D0,  0.03760D0,
     &     0.04023D0,  0.04965D0,  0.06143D0,  0.06973D0,  0.07641D0,
     &     0.08220D0,  0.10379D0,  0.13319D0,  0.15544D0,  0.17424D0,
     &     0.19085D0,  0.21976D0,  0.25625D0,  0.30577D0,  0.34590D0,
     &     0.40689D0,  0.44921D0,  0.47746D0,  0.49725D0,  0.50352D0,
     &     0.49914D0,  0.48649D0,  0.46748D0,  0.44367D0,  0.41645D0,
     &     0.38678D0,  0.35582D0,  0.32417D0,  0.29264D0,  0.26169D0,
     &     0.23187D0,  0.20335D0,  0.17646D0,  0.15176D0,  0.12881D0,
     &     0.10798D0,  0.08943D0,  0.07284D0,  0.04602D0,  0.02675D0,
     &     0.01389D0,  0.00613D0,  0.00046D0,  0.00000D0/
      DATA (FMRS(2,1,I,22),I=1,49)/
     &     0.02035D0,  0.02509D0,  0.03093D0,  0.03496D0,  0.03814D0,
     &     0.04081D0,  0.05040D0,  0.06241D0,  0.07087D0,  0.07768D0,
     &     0.08359D0,  0.10562D0,  0.13559D0,  0.15824D0,  0.17734D0,
     &     0.19417D0,  0.22338D0,  0.26006D0,  0.30949D0,  0.34920D0,
     &     0.40885D0,  0.44948D0,  0.47592D0,  0.49348D0,  0.49770D0,
     &     0.49152D0,  0.47736D0,  0.45716D0,  0.43246D0,  0.40467D0,
     &     0.37468D0,  0.34367D0,  0.31217D0,  0.28097D0,  0.25052D0,
     &     0.22133D0,  0.19355D0,  0.16747D0,  0.14359D0,  0.12150D0,
     &     0.10155D0,  0.08384D0,  0.06806D0,  0.04272D0,  0.02464D0,
     &     0.01269D0,  0.00554D0,  0.00040D0,  0.00000D0/
      DATA (FMRS(2,1,I,23),I=1,49)/
     &     0.02058D0,  0.02539D0,  0.03132D0,  0.03542D0,  0.03865D0,
     &     0.04137D0,  0.05112D0,  0.06333D0,  0.07195D0,  0.07888D0,
     &     0.08490D0,  0.10735D0,  0.13786D0,  0.16087D0,  0.18023D0,
     &     0.19726D0,  0.22673D0,  0.26356D0,  0.31287D0,  0.35216D0,
     &     0.41052D0,  0.44953D0,  0.47430D0,  0.48980D0,  0.49215D0,
     &     0.48435D0,  0.46885D0,  0.44758D0,  0.42215D0,  0.39387D0,
     &     0.36366D0,  0.33261D0,  0.30132D0,  0.27045D0,  0.24050D0,
     &     0.21190D0,  0.18476D0,  0.15947D0,  0.13635D0,  0.11504D0,
     &     0.09587D0,  0.07894D0,  0.06387D0,  0.03984D0,  0.02282D0,
     &     0.01167D0,  0.00505D0,  0.00036D0,  0.00000D0/
      DATA (FMRS(2,1,I,24),I=1,49)/
     &     0.02080D0,  0.02568D0,  0.03170D0,  0.03585D0,  0.03914D0,
     &     0.04189D0,  0.05180D0,  0.06421D0,  0.07296D0,  0.08001D0,
     &     0.08614D0,  0.10897D0,  0.13997D0,  0.16330D0,  0.18290D0,
     &     0.20010D0,  0.22978D0,  0.26672D0,  0.31586D0,  0.35473D0,
     &     0.41182D0,  0.44931D0,  0.47248D0,  0.48612D0,  0.48676D0,
     &     0.47750D0,  0.46081D0,  0.43866D0,  0.41258D0,  0.38389D0,
     &     0.35352D0,  0.32245D0,  0.29140D0,  0.26089D0,  0.23143D0,
     &     0.20340D0,  0.17690D0,  0.15229D0,  0.12990D0,  0.10931D0,
     &     0.09084D0,  0.07461D0,  0.06021D0,  0.03734D0,  0.02125D0,
     &     0.01078D0,  0.00462D0,  0.00032D0,  0.00000D0/
      DATA (FMRS(2,1,I,25),I=1,49)/
     &     0.02102D0,  0.02596D0,  0.03207D0,  0.03629D0,  0.03962D0,
     &     0.04242D0,  0.05248D0,  0.06508D0,  0.07398D0,  0.08115D0,
     &     0.08738D0,  0.11059D0,  0.14207D0,  0.16573D0,  0.18556D0,
     &     0.20292D0,  0.23281D0,  0.26985D0,  0.31879D0,  0.35722D0,
     &     0.41303D0,  0.44900D0,  0.47060D0,  0.48240D0,  0.48138D0,
     &     0.47074D0,  0.45292D0,  0.42993D0,  0.40324D0,  0.37421D0,
     &     0.34370D0,  0.31266D0,  0.28186D0,  0.25172D0,  0.22275D0,
     &     0.19528D0,  0.16943D0,  0.14547D0,  0.12379D0,  0.10391D0,
     &     0.08611D0,  0.07055D0,  0.05678D0,  0.03501D0,  0.01980D0,
     &     0.00997D0,  0.00424D0,  0.00029D0,  0.00000D0/
      DATA (FMRS(2,1,I,26),I=1,49)/
     &     0.02124D0,  0.02625D0,  0.03244D0,  0.03672D0,  0.04010D0,
     &     0.04294D0,  0.05315D0,  0.06595D0,  0.07499D0,  0.08227D0,
     &     0.08860D0,  0.11218D0,  0.14413D0,  0.16809D0,  0.18813D0,
     &     0.20564D0,  0.23571D0,  0.27281D0,  0.32152D0,  0.35948D0,
     &     0.41398D0,  0.44847D0,  0.46857D0,  0.47858D0,  0.47599D0,
     &     0.46404D0,  0.44519D0,  0.42139D0,  0.39420D0,  0.36490D0,
     &     0.33431D0,  0.30337D0,  0.27282D0,  0.24304D0,  0.21455D0,
     &     0.18765D0,  0.16244D0,  0.13911D0,  0.11808D0,  0.09890D0,
     &     0.08174D0,  0.06681D0,  0.05361D0,  0.03286D0,  0.01847D0,
     &     0.00924D0,  0.00390D0,  0.00026D0,  0.00000D0/
      DATA (FMRS(2,1,I,27),I=1,49)/
     &     0.02145D0,  0.02652D0,  0.03279D0,  0.03713D0,  0.04055D0,
     &     0.04343D0,  0.05378D0,  0.06677D0,  0.07594D0,  0.08333D0,
     &     0.08975D0,  0.11368D0,  0.14607D0,  0.17031D0,  0.19054D0,
     &     0.20819D0,  0.23841D0,  0.27555D0,  0.32402D0,  0.36153D0,
     &     0.41478D0,  0.44786D0,  0.46655D0,  0.47490D0,  0.47088D0,
     &     0.45773D0,  0.43795D0,  0.41346D0,  0.38583D0,  0.35628D0,
     &     0.32564D0,  0.29483D0,  0.26454D0,  0.23512D0,  0.20709D0,
     &     0.18074D0,  0.15610D0,  0.13337D0,  0.11295D0,  0.09439D0,
     &     0.07783D0,  0.06346D0,  0.05079D0,  0.03096D0,  0.01730D0,
     &     0.00860D0,  0.00360D0,  0.00023D0,  0.00000D0/
      DATA (FMRS(2,1,I,28),I=1,49)/
     &     0.02164D0,  0.02677D0,  0.03312D0,  0.03751D0,  0.04098D0,
     &     0.04390D0,  0.05439D0,  0.06755D0,  0.07684D0,  0.08433D0,
     &     0.09084D0,  0.11510D0,  0.14789D0,  0.17239D0,  0.19279D0,
     &     0.21056D0,  0.24091D0,  0.27806D0,  0.32630D0,  0.36334D0,
     &     0.41540D0,  0.44716D0,  0.46451D0,  0.47135D0,  0.46602D0,
     &     0.45177D0,  0.43117D0,  0.40606D0,  0.37805D0,  0.34829D0,
     &     0.31763D0,  0.28699D0,  0.25693D0,  0.22788D0,  0.20031D0,
     &     0.17447D0,  0.15036D0,  0.12818D0,  0.10834D0,  0.09032D0,
     &     0.07432D0,  0.06046D0,  0.04827D0,  0.02929D0,  0.01628D0,
     &     0.00804D0,  0.00334D0,  0.00021D0,  0.00000D0/
      DATA (FMRS(2,1,I,29),I=1,49)/
     &     0.02184D0,  0.02703D0,  0.03346D0,  0.03790D0,  0.04142D0,
     &     0.04437D0,  0.05500D0,  0.06833D0,  0.07775D0,  0.08534D0,
     &     0.09195D0,  0.11653D0,  0.14972D0,  0.17447D0,  0.19503D0,
     &     0.21292D0,  0.24339D0,  0.28054D0,  0.32851D0,  0.36507D0,
     &     0.41592D0,  0.44635D0,  0.46240D0,  0.46773D0,  0.46111D0,
     &     0.44581D0,  0.42442D0,  0.39875D0,  0.37037D0,  0.34044D0,
     &     0.30980D0,  0.27932D0,  0.24952D0,  0.22085D0,  0.19375D0,
     &     0.16840D0,  0.14482D0,  0.12320D0,  0.10392D0,  0.08643D0,
     &     0.07097D0,  0.05759D0,  0.04588D0,  0.02770D0,  0.01531D0,
     &     0.00752D0,  0.00311D0,  0.00019D0,  0.00000D0/
      DATA (FMRS(2,1,I,30),I=1,49)/
     &     0.02204D0,  0.02729D0,  0.03379D0,  0.03829D0,  0.04185D0,
     &     0.04484D0,  0.05560D0,  0.06911D0,  0.07865D0,  0.08634D0,
     &     0.09303D0,  0.11793D0,  0.15151D0,  0.17649D0,  0.19722D0,
     &     0.21521D0,  0.24577D0,  0.28291D0,  0.33057D0,  0.36667D0,
     &     0.41631D0,  0.44543D0,  0.46021D0,  0.46408D0,  0.45622D0,
     &     0.43995D0,  0.41780D0,  0.39163D0,  0.36293D0,  0.33287D0,
     &     0.30229D0,  0.27195D0,  0.24246D0,  0.21416D0,  0.18750D0,
     &     0.16265D0,  0.13957D0,  0.11850D0,  0.09976D0,  0.08278D0,
     &     0.06783D0,  0.05492D0,  0.04366D0,  0.02623D0,  0.01442D0,
     &     0.00705D0,  0.00289D0,  0.00017D0,  0.00000D0/
      DATA (FMRS(2,1,I,31),I=1,49)/
     &     0.02222D0,  0.02753D0,  0.03410D0,  0.03866D0,  0.04226D0,
     &     0.04528D0,  0.05617D0,  0.06985D0,  0.07951D0,  0.08729D0,
     &     0.09407D0,  0.11927D0,  0.15320D0,  0.17841D0,  0.19928D0,
     &     0.21737D0,  0.24802D0,  0.28513D0,  0.33249D0,  0.36812D0,
     &     0.41660D0,  0.44449D0,  0.45808D0,  0.46059D0,  0.45160D0,
     &     0.43442D0,  0.41159D0,  0.38497D0,  0.35599D0,  0.32584D0,
     &     0.29532D0,  0.26514D0,  0.23594D0,  0.20800D0,  0.18176D0,
     &     0.15738D0,  0.13478D0,  0.11421D0,  0.09597D0,  0.07947D0,
     &     0.06498D0,  0.05251D0,  0.04166D0,  0.02491D0,  0.01363D0,
     &     0.00662D0,  0.00270D0,  0.00016D0,  0.00000D0/
      DATA (FMRS(2,1,I,32),I=1,49)/
     &     0.02240D0,  0.02776D0,  0.03441D0,  0.03901D0,  0.04265D0,
     &     0.04571D0,  0.05672D0,  0.07055D0,  0.08032D0,  0.08819D0,
     &     0.09505D0,  0.12053D0,  0.15480D0,  0.18021D0,  0.20120D0,
     &     0.21937D0,  0.25009D0,  0.28716D0,  0.33421D0,  0.36938D0,
     &     0.41675D0,  0.44346D0,  0.45593D0,  0.45721D0,  0.44717D0,
     &     0.42917D0,  0.40572D0,  0.37869D0,  0.34947D0,  0.31928D0,
     &     0.28882D0,  0.25885D0,  0.22992D0,  0.20233D0,  0.17646D0,
     &     0.15252D0,  0.13038D0,  0.11028D0,  0.09251D0,  0.07647D0,
     &     0.06240D0,  0.05033D0,  0.03984D0,  0.02372D0,  0.01293D0,
     &     0.00625D0,  0.00253D0,  0.00015D0,  0.00000D0/
      DATA (FMRS(2,1,I,33),I=1,49)/
     &     0.02258D0,  0.02800D0,  0.03471D0,  0.03936D0,  0.04304D0,
     &     0.04613D0,  0.05727D0,  0.07126D0,  0.08114D0,  0.08911D0,
     &     0.09604D0,  0.12181D0,  0.15642D0,  0.18202D0,  0.20315D0,
     &     0.22140D0,  0.25219D0,  0.28920D0,  0.33594D0,  0.37065D0,
     &     0.41690D0,  0.44243D0,  0.45378D0,  0.45384D0,  0.44278D0,
     &     0.42397D0,  0.39993D0,  0.37250D0,  0.34307D0,  0.31283D0,
     &     0.28245D0,  0.25269D0,  0.22404D0,  0.19681D0,  0.17131D0,
     &     0.14780D0,  0.12613D0,  0.10648D0,  0.08918D0,  0.07357D0,
     &     0.05991D0,  0.04824D0,  0.03811D0,  0.02259D0,  0.01226D0,
     &     0.00589D0,  0.00237D0,  0.00014D0,  0.00000D0/
      DATA (FMRS(2,1,I,34),I=1,49)/
     &     0.02276D0,  0.02823D0,  0.03502D0,  0.03972D0,  0.04344D0,
     &     0.04656D0,  0.05782D0,  0.07197D0,  0.08196D0,  0.09001D0,
     &     0.09702D0,  0.12306D0,  0.15799D0,  0.18378D0,  0.20502D0,
     &     0.22334D0,  0.25418D0,  0.29111D0,  0.33751D0,  0.37174D0,
     &     0.41686D0,  0.44123D0,  0.45149D0,  0.45035D0,  0.43832D0,
     &     0.41874D0,  0.39416D0,  0.36638D0,  0.33679D0,  0.30651D0,
     &     0.27625D0,  0.24670D0,  0.21831D0,  0.19144D0,  0.16636D0,
     &     0.14329D0,  0.12204D0,  0.10286D0,  0.08597D0,  0.07080D0,
     &     0.05755D0,  0.04624D0,  0.03646D0,  0.02153D0,  0.01162D0,
     &     0.00556D0,  0.00222D0,  0.00012D0,  0.00000D0/
      DATA (FMRS(2,1,I,35),I=1,49)/
     &     0.02294D0,  0.02846D0,  0.03531D0,  0.04006D0,  0.04381D0,
     &     0.04697D0,  0.05834D0,  0.07264D0,  0.08274D0,  0.09087D0,
     &     0.09796D0,  0.12426D0,  0.15949D0,  0.18547D0,  0.20682D0,
     &     0.22520D0,  0.25608D0,  0.29293D0,  0.33900D0,  0.37277D0,
     &     0.41683D0,  0.44010D0,  0.44933D0,  0.44706D0,  0.43413D0,
     &     0.41383D0,  0.38877D0,  0.36068D0,  0.33093D0,  0.30063D0,
     &     0.27049D0,  0.24114D0,  0.21302D0,  0.18649D0,  0.16180D0,
     &     0.13914D0,  0.11828D0,  0.09955D0,  0.08303D0,  0.06826D0,
     &     0.05540D0,  0.04443D0,  0.03497D0,  0.02057D0,  0.01106D0,
     &     0.00526D0,  0.00209D0,  0.00012D0,  0.00000D0/
      DATA (FMRS(2,1,I,36),I=1,49)/
     &     0.02310D0,  0.02867D0,  0.03558D0,  0.04038D0,  0.04417D0,
     &     0.04736D0,  0.05885D0,  0.07328D0,  0.08348D0,  0.09170D0,
     &     0.09885D0,  0.12540D0,  0.16092D0,  0.18705D0,  0.20850D0,
     &     0.22693D0,  0.25784D0,  0.29461D0,  0.34036D0,  0.37368D0,
     &     0.41672D0,  0.43895D0,  0.44722D0,  0.44390D0,  0.43013D0,
     &     0.40920D0,  0.38369D0,  0.35531D0,  0.32545D0,  0.29515D0,
     &     0.26511D0,  0.23598D0,  0.20812D0,  0.18191D0,  0.15758D0,
     &     0.13530D0,  0.11483D0,  0.09649D0,  0.08034D0,  0.06595D0,
     &     0.05344D0,  0.04278D0,  0.03361D0,  0.01970D0,  0.01054D0,
     &     0.00499D0,  0.00197D0,  0.00011D0,  0.00000D0/
      DATA (FMRS(2,1,I,37),I=1,49)/
     &     0.02327D0,  0.02889D0,  0.03587D0,  0.04071D0,  0.04453D0,
     &     0.04775D0,  0.05935D0,  0.07393D0,  0.08423D0,  0.09253D0,
     &     0.09975D0,  0.12655D0,  0.16235D0,  0.18864D0,  0.21018D0,
     &     0.22866D0,  0.25959D0,  0.29626D0,  0.34166D0,  0.37452D0,
     &     0.41652D0,  0.43771D0,  0.44502D0,  0.44067D0,  0.42606D0,
     &     0.40453D0,  0.37859D0,  0.34994D0,  0.31996D0,  0.28968D0,
     &     0.25976D0,  0.23084D0,  0.20328D0,  0.17738D0,  0.15341D0,
     &     0.13150D0,  0.11145D0,  0.09348D0,  0.07773D0,  0.06369D0,
     &     0.05153D0,  0.04117D0,  0.03229D0,  0.01885D0,  0.01005D0,
     &     0.00474D0,  0.00186D0,  0.00010D0,  0.00000D0/
      DATA (FMRS(2,1,I,38),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,2,I, 1),I=1,49)/
     &     0.00683D0,  0.00832D0,  0.01013D0,  0.01138D0,  0.01237D0,
     &     0.01320D0,  0.01619D0,  0.02004D0,  0.02286D0,  0.02522D0,
     &     0.02744D0,  0.03623D0,  0.04952D0,  0.06032D0,  0.06982D0,
     &     0.07843D0,  0.09385D0,  0.11395D0,  0.14220D0,  0.16592D0,
     &     0.20382D0,  0.23228D0,  0.25344D0,  0.27158D0,  0.28216D0,
     &     0.28647D0,  0.28570D0,  0.28068D0,  0.27216D0,  0.26127D0,
     &     0.24773D0,  0.23281D0,  0.21663D0,  0.19968D0,  0.18252D0,
     &     0.16522D0,  0.14809D0,  0.13153D0,  0.11576D0,  0.10050D0,
     &     0.08631D0,  0.07335D0,  0.06127D0,  0.04098D0,  0.02531D0,
     &     0.01409D0,  0.00672D0,  0.00064D0,  0.00000D0/
      DATA (FMRS(2,2,I, 2),I=1,49)/
     &     0.00687D0,  0.00838D0,  0.01023D0,  0.01151D0,  0.01252D0,
     &     0.01336D0,  0.01643D0,  0.02037D0,  0.02327D0,  0.02569D0,
     &     0.02797D0,  0.03698D0,  0.05059D0,  0.06162D0,  0.07129D0,
     &     0.08004D0,  0.09567D0,  0.11595D0,  0.14429D0,  0.16793D0,
     &     0.20539D0,  0.23318D0,  0.25356D0,  0.27069D0,  0.28025D0,
     &     0.28363D0,  0.28200D0,  0.27624D0,  0.26713D0,  0.25572D0,
     &     0.24185D0,  0.22669D0,  0.21040D0,  0.19345D0,  0.17637D0,
     &     0.15928D0,  0.14242D0,  0.12615D0,  0.11076D0,  0.09591D0,
     &     0.08215D0,  0.06963D0,  0.05800D0,  0.03856D0,  0.02367D0,
     &     0.01309D0,  0.00619D0,  0.00057D0,  0.00000D0/
      DATA (FMRS(2,2,I, 3),I=1,49)/
     &     0.00693D0,  0.00848D0,  0.01038D0,  0.01170D0,  0.01274D0,
     &     0.01362D0,  0.01679D0,  0.02088D0,  0.02389D0,  0.02641D0,
     &     0.02877D0,  0.03812D0,  0.05220D0,  0.06356D0,  0.07349D0,
     &     0.08244D0,  0.09836D0,  0.11888D0,  0.14732D0,  0.17082D0,
     &     0.20757D0,  0.23434D0,  0.25356D0,  0.26918D0,  0.27725D0,
     &     0.27927D0,  0.27642D0,  0.26960D0,  0.25969D0,  0.24758D0,
     &     0.23327D0,  0.21778D0,  0.20136D0,  0.18446D0,  0.16756D0,
     &     0.15079D0,  0.13434D0,  0.11852D0,  0.10371D0,  0.08946D0,
     &     0.07631D0,  0.06442D0,  0.05345D0,  0.03522D0,  0.02142D0,
     &     0.01172D0,  0.00548D0,  0.00049D0,  0.00000D0/
      DATA (FMRS(2,2,I, 4),I=1,49)/
     &     0.00697D0,  0.00855D0,  0.01050D0,  0.01184D0,  0.01291D0,
     &     0.01380D0,  0.01706D0,  0.02126D0,  0.02435D0,  0.02694D0,
     &     0.02937D0,  0.03897D0,  0.05339D0,  0.06499D0,  0.07510D0,
     &     0.08419D0,  0.10031D0,  0.12100D0,  0.14949D0,  0.17285D0,
     &     0.20905D0,  0.23506D0,  0.25342D0,  0.26794D0,  0.27493D0,
     &     0.27599D0,  0.27230D0,  0.26475D0,  0.25426D0,  0.24171D0,
     &     0.22712D0,  0.21140D0,  0.19495D0,  0.17811D0,  0.16138D0,
     &     0.14485D0,  0.12869D0,  0.11323D0,  0.09881D0,  0.08500D0,
     &     0.07230D0,  0.06086D0,  0.05034D0,  0.03297D0,  0.01992D0,
     &     0.01081D0,  0.00501D0,  0.00044D0,  0.00000D0/
      DATA (FMRS(2,2,I, 5),I=1,49)/
     &     0.00702D0,  0.00863D0,  0.01062D0,  0.01200D0,  0.01309D0,
     &     0.01401D0,  0.01735D0,  0.02167D0,  0.02485D0,  0.02751D0,
     &     0.03001D0,  0.03988D0,  0.05465D0,  0.06649D0,  0.07678D0,
     &     0.08602D0,  0.10233D0,  0.12317D0,  0.15168D0,  0.17488D0,
     &     0.21046D0,  0.23564D0,  0.25309D0,  0.26645D0,  0.27234D0,
     &     0.27243D0,  0.26786D0,  0.25959D0,  0.24854D0,  0.23557D0,
     &     0.22068D0,  0.20486D0,  0.18841D0,  0.17163D0,  0.15506D0,
     &     0.13880D0,  0.12296D0,  0.10788D0,  0.09387D0,  0.08052D0,
     &     0.06829D0,  0.05730D0,  0.04726D0,  0.03074D0,  0.01844D0,
     &     0.00993D0,  0.00456D0,  0.00039D0,  0.00000D0/
      DATA (FMRS(2,2,I, 6),I=1,49)/
     &     0.00706D0,  0.00870D0,  0.01073D0,  0.01213D0,  0.01325D0,
     &     0.01419D0,  0.01761D0,  0.02203D0,  0.02528D0,  0.02801D0,
     &     0.03057D0,  0.04067D0,  0.05575D0,  0.06780D0,  0.07825D0,
     &     0.08760D0,  0.10408D0,  0.12504D0,  0.15354D0,  0.17659D0,
     &     0.21162D0,  0.23607D0,  0.25274D0,  0.26511D0,  0.27006D0,
     &     0.26933D0,  0.26403D0,  0.25518D0,  0.24367D0,  0.23035D0,
     &     0.21525D0,  0.19935D0,  0.18289D0,  0.16620D0,  0.14980D0,
     &     0.13377D0,  0.11822D0,  0.10346D0,  0.08981D0,  0.07685D0,
     &     0.06502D0,  0.05441D0,  0.04475D0,  0.02894D0,  0.01725D0,
     &     0.00923D0,  0.00420D0,  0.00035D0,  0.00000D0/
      DATA (FMRS(2,2,I, 7),I=1,49)/
     &     0.00711D0,  0.00877D0,  0.01083D0,  0.01227D0,  0.01340D0,
     &     0.01436D0,  0.01785D0,  0.02237D0,  0.02570D0,  0.02850D0,
     &     0.03112D0,  0.04143D0,  0.05680D0,  0.06905D0,  0.07964D0,
     &     0.08911D0,  0.10573D0,  0.12679D0,  0.15527D0,  0.17816D0,
     &     0.21263D0,  0.23638D0,  0.25229D0,  0.26373D0,  0.26781D0,
     &     0.26630D0,  0.26033D0,  0.25095D0,  0.23903D0,  0.22536D0,
     &     0.21011D0,  0.19416D0,  0.17766D0,  0.16111D0,  0.14488D0,
     &     0.12910D0,  0.11382D0,  0.09936D0,  0.08606D0,  0.07347D0,
     &     0.06201D0,  0.05178D0,  0.04247D0,  0.02732D0,  0.01619D0,
     &     0.00860D0,  0.00389D0,  0.00031D0,  0.00000D0/
      DATA (FMRS(2,2,I, 8),I=1,49)/
     &     0.00716D0,  0.00885D0,  0.01095D0,  0.01241D0,  0.01357D0,
     &     0.01455D0,  0.01812D0,  0.02275D0,  0.02616D0,  0.02902D0,
     &     0.03170D0,  0.04225D0,  0.05792D0,  0.07038D0,  0.08112D0,
     &     0.09070D0,  0.10747D0,  0.12863D0,  0.15707D0,  0.17976D0,
     &     0.21362D0,  0.23661D0,  0.25172D0,  0.26218D0,  0.26535D0,
     &     0.26303D0,  0.25640D0,  0.24647D0,  0.23413D0,  0.22018D0,
     &     0.20477D0,  0.18875D0,  0.17228D0,  0.15585D0,  0.13983D0,
     &     0.12430D0,  0.10932D0,  0.09519D0,  0.08225D0,  0.07005D0,
     &     0.05898D0,  0.04912D0,  0.04018D0,  0.02570D0,  0.01514D0,
     &     0.00799D0,  0.00358D0,  0.00028D0,  0.00000D0/
      DATA (FMRS(2,2,I, 9),I=1,49)/
     &     0.00720D0,  0.00891D0,  0.01105D0,  0.01254D0,  0.01372D0,
     &     0.01472D0,  0.01836D0,  0.02308D0,  0.02656D0,  0.02948D0,
     &     0.03221D0,  0.04297D0,  0.05891D0,  0.07154D0,  0.08241D0,
     &     0.09208D0,  0.10897D0,  0.13020D0,  0.15860D0,  0.18111D0,
     &     0.21443D0,  0.23674D0,  0.25116D0,  0.26078D0,  0.26316D0,
     &     0.26017D0,  0.25299D0,  0.24260D0,  0.22991D0,  0.21577D0,
     &     0.20023D0,  0.18414D0,  0.16776D0,  0.15141D0,  0.13557D0,
     &     0.12027D0,  0.10555D0,  0.09171D0,  0.07908D0,  0.06721D0,
     &     0.05646D0,  0.04691D0,  0.03829D0,  0.02437D0,  0.01428D0,
     &     0.00749D0,  0.00333D0,  0.00026D0,  0.00000D0/
      DATA (FMRS(2,2,I,10),I=1,49)/
     &     0.00724D0,  0.00898D0,  0.01115D0,  0.01266D0,  0.01386D0,
     &     0.01488D0,  0.01859D0,  0.02340D0,  0.02695D0,  0.02993D0,
     &     0.03271D0,  0.04366D0,  0.05985D0,  0.07265D0,  0.08364D0,
     &     0.09340D0,  0.11040D0,  0.13168D0,  0.16002D0,  0.18235D0,
     &     0.21512D0,  0.23679D0,  0.25054D0,  0.25935D0,  0.26099D0,
     &     0.25738D0,  0.24967D0,  0.23885D0,  0.22588D0,  0.21153D0,
     &     0.19588D0,  0.17977D0,  0.16345D0,  0.14723D0,  0.13156D0,
     &     0.11648D0,  0.10202D0,  0.08846D0,  0.07613D0,  0.06457D0,
     &     0.05413D0,  0.04488D0,  0.03655D0,  0.02315D0,  0.01349D0,
     &     0.00703D0,  0.00311D0,  0.00024D0,  0.00000D0/
      DATA (FMRS(2,2,I,11),I=1,49)/
     &     0.00727D0,  0.00904D0,  0.01123D0,  0.01276D0,  0.01398D0,
     &     0.01501D0,  0.01877D0,  0.02366D0,  0.02727D0,  0.03029D0,
     &     0.03311D0,  0.04422D0,  0.06061D0,  0.07353D0,  0.08461D0,
     &     0.09444D0,  0.11152D0,  0.13285D0,  0.16112D0,  0.18330D0,
     &     0.21564D0,  0.23680D0,  0.25001D0,  0.25818D0,  0.25925D0,
     &     0.25517D0,  0.24705D0,  0.23591D0,  0.22272D0,  0.20821D0,
     &     0.19248D0,  0.17638D0,  0.16011D0,  0.14399D0,  0.12847D0,
     &     0.11356D0,  0.09932D0,  0.08597D0,  0.07388D0,  0.06256D0,
     &     0.05235D0,  0.04334D0,  0.03522D0,  0.02223D0,  0.01290D0,
     &     0.00670D0,  0.00295D0,  0.00022D0,  0.00000D0/
      DATA (FMRS(2,2,I,12),I=1,49)/
     &     0.00735D0,  0.00915D0,  0.01141D0,  0.01298D0,  0.01423D0,
     &     0.01529D0,  0.01917D0,  0.02422D0,  0.02794D0,  0.03106D0,
     &     0.03397D0,  0.04541D0,  0.06221D0,  0.07541D0,  0.08668D0,
     &     0.09664D0,  0.11388D0,  0.13528D0,  0.16340D0,  0.18523D0,
     &     0.21662D0,  0.23667D0,  0.24876D0,  0.25560D0,  0.25550D0,
     &     0.25041D0,  0.24145D0,  0.22968D0,  0.21606D0,  0.20125D0,
     &     0.18540D0,  0.16932D0,  0.15319D0,  0.13731D0,  0.12210D0,
     &     0.10759D0,  0.09378D0,  0.08090D0,  0.06929D0,  0.05847D0,
     &     0.04874D0,  0.04022D0,  0.03256D0,  0.02039D0,  0.01173D0,
     &     0.00603D0,  0.00263D0,  0.00019D0,  0.00000D0/
      DATA (FMRS(2,2,I,13),I=1,49)/
     &     0.00742D0,  0.00926D0,  0.01156D0,  0.01317D0,  0.01446D0,
     &     0.01554D0,  0.01952D0,  0.02471D0,  0.02853D0,  0.03173D0,
     &     0.03472D0,  0.04644D0,  0.06360D0,  0.07703D0,  0.08845D0,
     &     0.09852D0,  0.11589D0,  0.13732D0,  0.16529D0,  0.18680D0,
     &     0.21735D0,  0.23643D0,  0.24757D0,  0.25329D0,  0.25220D0,
     &     0.24629D0,  0.23665D0,  0.22439D0,  0.21043D0,  0.19540D0,
     &     0.17949D0,  0.16343D0,  0.14746D0,  0.13180D0,  0.11686D0,
     &     0.10269D0,  0.08926D0,  0.07677D0,  0.06556D0,  0.05517D0,
     &     0.04584D0,  0.03772D0,  0.03044D0,  0.01893D0,  0.01082D0,
     &     0.00551D0,  0.00238D0,  0.00017D0,  0.00000D0/
      DATA (FMRS(2,2,I,14),I=1,49)/
     &     0.00750D0,  0.00938D0,  0.01173D0,  0.01339D0,  0.01471D0,
     &     0.01583D0,  0.01992D0,  0.02526D0,  0.02920D0,  0.03250D0,
     &     0.03557D0,  0.04761D0,  0.06516D0,  0.07882D0,  0.09041D0,
     &     0.10060D0,  0.11809D0,  0.13955D0,  0.16731D0,  0.18846D0,
     &     0.21802D0,  0.23605D0,  0.24613D0,  0.25062D0,  0.24846D0,
     &     0.24169D0,  0.23135D0,  0.21858D0,  0.20428D0,  0.18902D0,
     &     0.17309D0,  0.15708D0,  0.14130D0,  0.12590D0,  0.11127D0,
     &     0.09745D0,  0.08445D0,  0.07239D0,  0.06165D0,  0.05170D0,
     &     0.04281D0,  0.03511D0,  0.02824D0,  0.01743D0,  0.00988D0,
     &     0.00499D0,  0.00213D0,  0.00015D0,  0.00000D0/
      DATA (FMRS(2,2,I,15),I=1,49)/
     &     0.00758D0,  0.00950D0,  0.01192D0,  0.01362D0,  0.01498D0,
     &     0.01613D0,  0.02034D0,  0.02584D0,  0.02990D0,  0.03330D0,
     &     0.03646D0,  0.04882D0,  0.06676D0,  0.08067D0,  0.09242D0,
     &     0.10271D0,  0.12031D0,  0.14177D0,  0.16927D0,  0.19002D0,
     &     0.21855D0,  0.23546D0,  0.24445D0,  0.24771D0,  0.24448D0,
     &     0.23683D0,  0.22584D0,  0.21262D0,  0.19799D0,  0.18255D0,
     &     0.16661D0,  0.15073D0,  0.13511D0,  0.12003D0,  0.10571D0,
     &     0.09233D0,  0.07973D0,  0.06812D0,  0.05781D0,  0.04834D0,
     &     0.03990D0,  0.03259D0,  0.02612D0,  0.01599D0,  0.00899D0,
     &     0.00450D0,  0.00190D0,  0.00013D0,  0.00000D0/
      DATA (FMRS(2,2,I,16),I=1,49)/
     &     0.00766D0,  0.00962D0,  0.01210D0,  0.01384D0,  0.01522D0,
     &     0.01640D0,  0.02073D0,  0.02638D0,  0.03055D0,  0.03403D0,
     &     0.03728D0,  0.04992D0,  0.06822D0,  0.08234D0,  0.09422D0,
     &     0.10460D0,  0.12228D0,  0.14371D0,  0.17097D0,  0.19133D0,
     &     0.21891D0,  0.23481D0,  0.24283D0,  0.24499D0,  0.24085D0,
     &     0.23246D0,  0.22090D0,  0.20727D0,  0.19242D0,  0.17687D0,
     &     0.16094D0,  0.14517D0,  0.12974D0,  0.11493D0,  0.10094D0,
     &     0.08792D0,  0.07568D0,  0.06448D0,  0.05456D0,  0.04548D0,
     &     0.03743D0,  0.03047D0,  0.02435D0,  0.01480D0,  0.00826D0,
     &     0.00410D0,  0.00171D0,  0.00011D0,  0.00000D0/
      DATA (FMRS(2,2,I,17),I=1,49)/
     &     0.00775D0,  0.00975D0,  0.01228D0,  0.01406D0,  0.01548D0,
     &     0.01669D0,  0.02112D0,  0.02692D0,  0.03120D0,  0.03478D0,
     &     0.03810D0,  0.05104D0,  0.06968D0,  0.08400D0,  0.09602D0,
     &     0.10648D0,  0.12423D0,  0.14563D0,  0.17261D0,  0.19256D0,
     &     0.21918D0,  0.23405D0,  0.24112D0,  0.24221D0,  0.23719D0,
     &     0.22809D0,  0.21600D0,  0.20198D0,  0.18694D0,  0.17130D0,
     &     0.15541D0,  0.13976D0,  0.12455D0,  0.11000D0,  0.09636D0,
     &     0.08368D0,  0.07182D0,  0.06101D0,  0.05149D0,  0.04278D0,
     &     0.03510D0,  0.02849D0,  0.02269D0,  0.01370D0,  0.00759D0,
     &     0.00374D0,  0.00155D0,  0.00010D0,  0.00000D0/
      DATA (FMRS(2,2,I,18),I=1,49)/
     &     0.00782D0,  0.00985D0,  0.01243D0,  0.01424D0,  0.01569D0,
     &     0.01692D0,  0.02146D0,  0.02738D0,  0.03175D0,  0.03540D0,
     &     0.03879D0,  0.05197D0,  0.07089D0,  0.08537D0,  0.09749D0,
     &     0.10801D0,  0.12581D0,  0.14716D0,  0.17390D0,  0.19349D0,
     &     0.21930D0,  0.23333D0,  0.23963D0,  0.23986D0,  0.23413D0,
     &     0.22447D0,  0.21197D0,  0.19769D0,  0.18248D0,  0.16678D0,
     &     0.15094D0,  0.13543D0,  0.12040D0,  0.10608D0,  0.09270D0,
     &     0.08031D0,  0.06878D0,  0.05828D0,  0.04908D0,  0.04068D0,
     &     0.03329D0,  0.02694D0,  0.02140D0,  0.01285D0,  0.00708D0,
     &     0.00346D0,  0.00142D0,  0.00009D0,  0.00000D0/
      DATA (FMRS(2,2,I,19),I=1,49)/
     &     0.00791D0,  0.00998D0,  0.01261D0,  0.01447D0,  0.01595D0,
     &     0.01722D0,  0.02186D0,  0.02794D0,  0.03242D0,  0.03616D0,
     &     0.03963D0,  0.05310D0,  0.07234D0,  0.08702D0,  0.09924D0,
     &     0.10983D0,  0.12767D0,  0.14895D0,  0.17537D0,  0.19453D0,
     &     0.21933D0,  0.23238D0,  0.23773D0,  0.23696D0,  0.23039D0,
     &     0.22010D0,  0.20715D0,  0.19257D0,  0.17716D0,  0.16147D0,
     &     0.14570D0,  0.13034D0,  0.11556D0,  0.10152D0,  0.08847D0,
     &     0.07643D0,  0.06526D0,  0.05515D0,  0.04631D0,  0.03827D0,
     &     0.03122D0,  0.02519D0,  0.01995D0,  0.01190D0,  0.00650D0,
     &     0.00315D0,  0.00128D0,  0.00008D0,  0.00000D0/
      DATA (FMRS(2,2,I,20),I=1,49)/
     &     0.00799D0,  0.01010D0,  0.01278D0,  0.01467D0,  0.01619D0,
     &     0.01748D0,  0.02223D0,  0.02844D0,  0.03302D0,  0.03684D0,
     &     0.04038D0,  0.05409D0,  0.07362D0,  0.08846D0,  0.10078D0,
     &     0.11143D0,  0.12930D0,  0.15050D0,  0.17662D0,  0.19539D0,
     &     0.21931D0,  0.23148D0,  0.23602D0,  0.23438D0,  0.22712D0,
     &     0.21628D0,  0.20296D0,  0.18814D0,  0.17260D0,  0.15692D0,
     &     0.14124D0,  0.12600D0,  0.11146D0,  0.09768D0,  0.08490D0,
     &     0.07317D0,  0.06233D0,  0.05253D0,  0.04400D0,  0.03627D0,
     &     0.02950D0,  0.02375D0,  0.01875D0,  0.01112D0,  0.00604D0,
     &     0.00291D0,  0.00117D0,  0.00007D0,  0.00000D0/
      DATA (FMRS(2,2,I,21),I=1,49)/
     &     0.00806D0,  0.01021D0,  0.01293D0,  0.01486D0,  0.01641D0,
     &     0.01772D0,  0.02256D0,  0.02890D0,  0.03357D0,  0.03747D0,
     &     0.04106D0,  0.05501D0,  0.07479D0,  0.08976D0,  0.10217D0,
     &     0.11285D0,  0.13073D0,  0.15184D0,  0.17768D0,  0.19608D0,
     &     0.21918D0,  0.23055D0,  0.23436D0,  0.23195D0,  0.22407D0,
     &     0.21277D0,  0.19913D0,  0.18411D0,  0.16851D0,  0.15282D0,
     &     0.13724D0,  0.12215D0,  0.10780D0,  0.09426D0,  0.08175D0,
     &     0.07030D0,  0.05975D0,  0.05024D0,  0.04199D0,  0.03453D0,
     &     0.02802D0,  0.02251D0,  0.01772D0,  0.01045D0,  0.00564D0,
     &     0.00270D0,  0.00108D0,  0.00006D0,  0.00000D0/
      DATA (FMRS(2,2,I,22),I=1,49)/
     &     0.00816D0,  0.01035D0,  0.01313D0,  0.01511D0,  0.01669D0,
     &     0.01803D0,  0.02299D0,  0.02949D0,  0.03427D0,  0.03826D0,
     &     0.04194D0,  0.05616D0,  0.07626D0,  0.09141D0,  0.10390D0,
     &     0.11463D0,  0.13252D0,  0.15350D0,  0.17897D0,  0.19689D0,
     &     0.21895D0,  0.22932D0,  0.23223D0,  0.22887D0,  0.22024D0,
     &     0.20839D0,  0.19437D0,  0.17913D0,  0.16346D0,  0.14778D0,
     &     0.13233D0,  0.11744D0,  0.10335D0,  0.09011D0,  0.07794D0,
     &     0.06684D0,  0.05665D0,  0.04749D0,  0.03958D0,  0.03245D0,
     &     0.02625D0,  0.02103D0,  0.01650D0,  0.00967D0,  0.00518D0,
     &     0.00246D0,  0.00097D0,  0.00005D0,  0.00000D0/
      DATA (FMRS(2,2,I,23),I=1,49)/
     &     0.00826D0,  0.01049D0,  0.01333D0,  0.01534D0,  0.01695D0,
     &     0.01833D0,  0.02340D0,  0.03004D0,  0.03494D0,  0.03901D0,
     &     0.04276D0,  0.05725D0,  0.07764D0,  0.09293D0,  0.10551D0,
     &     0.11628D0,  0.13416D0,  0.15502D0,  0.18011D0,  0.19758D0,
     &     0.21867D0,  0.22812D0,  0.23018D0,  0.22598D0,  0.21667D0,
     &     0.20434D0,  0.19000D0,  0.17460D0,  0.15883D0,  0.14320D0,
     &     0.12787D0,  0.11321D0,  0.09934D0,  0.08640D0,  0.07454D0,
     &     0.06376D0,  0.05389D0,  0.04504D0,  0.03744D0,  0.03063D0,
     &     0.02471D0,  0.01973D0,  0.01544D0,  0.00899D0,  0.00479D0,
     &     0.00225D0,  0.00088D0,  0.00005D0,  0.00000D0/
      DATA (FMRS(2,2,I,24),I=1,49)/
     &     0.00835D0,  0.01062D0,  0.01351D0,  0.01556D0,  0.01721D0,
     &     0.01861D0,  0.02378D0,  0.03057D0,  0.03556D0,  0.03972D0,
     &     0.04354D0,  0.05827D0,  0.07891D0,  0.09434D0,  0.10698D0,
     &     0.11778D0,  0.13564D0,  0.15636D0,  0.18108D0,  0.19811D0,
     &     0.21829D0,  0.22687D0,  0.22819D0,  0.22319D0,  0.21330D0,
     &     0.20053D0,  0.18593D0,  0.17036D0,  0.15459D0,  0.13902D0,
     &     0.12383D0,  0.10936D0,  0.09573D0,  0.08306D0,  0.07149D0,
     &     0.06100D0,  0.05144D0,  0.04289D0,  0.03556D0,  0.02901D0,
     &     0.02335D0,  0.01859D0,  0.01451D0,  0.00840D0,  0.00444D0,
     &     0.00208D0,  0.00081D0,  0.00004D0,  0.00000D0/
      DATA (FMRS(2,2,I,25),I=1,49)/
     &     0.00844D0,  0.01075D0,  0.01369D0,  0.01578D0,  0.01746D0,
     &     0.01889D0,  0.02417D0,  0.03109D0,  0.03619D0,  0.04043D0,
     &     0.04431D0,  0.05929D0,  0.08018D0,  0.09573D0,  0.10844D0,
     &     0.11926D0,  0.13709D0,  0.15767D0,  0.18202D0,  0.19861D0,
     &     0.21788D0,  0.22561D0,  0.22620D0,  0.22044D0,  0.20998D0,
     &     0.19681D0,  0.18196D0,  0.16625D0,  0.15048D0,  0.13499D0,
     &     0.11994D0,  0.10567D0,  0.09228D0,  0.07987D0,  0.06858D0,
     &     0.05838D0,  0.04911D0,  0.04085D0,  0.03379D0,  0.02749D0,
     &     0.02207D0,  0.01753D0,  0.01364D0,  0.00785D0,  0.00413D0,
     &     0.00192D0,  0.00074D0,  0.00004D0,  0.00000D0/
      DATA (FMRS(2,2,I,26),I=1,49)/
     &     0.00853D0,  0.01088D0,  0.01388D0,  0.01600D0,  0.01772D0,
     &     0.01917D0,  0.02456D0,  0.03161D0,  0.03680D0,  0.04112D0,
     &     0.04508D0,  0.06028D0,  0.08140D0,  0.09707D0,  0.10983D0,
     &     0.12067D0,  0.13846D0,  0.15889D0,  0.18286D0,  0.19901D0,
     &     0.21739D0,  0.22430D0,  0.22419D0,  0.21773D0,  0.20672D0,
     &     0.19320D0,  0.17811D0,  0.16233D0,  0.14654D0,  0.13113D0,
     &     0.11622D0,  0.10216D0,  0.08901D0,  0.07686D0,  0.06584D0,
     &     0.05592D0,  0.04692D0,  0.03894D0,  0.03214D0,  0.02608D0,
     &     0.02089D0,  0.01655D0,  0.01285D0,  0.00735D0,  0.00384D0,
     &     0.00177D0,  0.00068D0,  0.00003D0,  0.00000D0/
      DATA (FMRS(2,2,I,27),I=1,49)/
     &     0.00862D0,  0.01100D0,  0.01405D0,  0.01622D0,  0.01796D0,
     &     0.01944D0,  0.02492D0,  0.03211D0,  0.03739D0,  0.04178D0,
     &     0.04580D0,  0.06121D0,  0.08256D0,  0.09833D0,  0.11114D0,
     &     0.12198D0,  0.13974D0,  0.16000D0,  0.18361D0,  0.19934D0,
     &     0.21688D0,  0.22303D0,  0.22227D0,  0.21516D0,  0.20368D0,
     &     0.18983D0,  0.17455D0,  0.15870D0,  0.14292D0,  0.12759D0,
     &     0.11282D0,  0.09895D0,  0.08604D0,  0.07413D0,  0.06336D0,
     &     0.05370D0,  0.04495D0,  0.03722D0,  0.03066D0,  0.02482D0,
     &     0.01983D0,  0.01568D0,  0.01214D0,  0.00691D0,  0.00359D0,
     &     0.00164D0,  0.00063D0,  0.00003D0,  0.00000D0/
      DATA (FMRS(2,2,I,28),I=1,49)/
     &     0.00871D0,  0.01113D0,  0.01422D0,  0.01642D0,  0.01819D0,
     &     0.01970D0,  0.02527D0,  0.03257D0,  0.03795D0,  0.04240D0,
     &     0.04648D0,  0.06209D0,  0.08364D0,  0.09950D0,  0.11235D0,
     &     0.12320D0,  0.14090D0,  0.16101D0,  0.18426D0,  0.19960D0,
     &     0.21635D0,  0.22178D0,  0.22043D0,  0.21273D0,  0.20082D0,
     &     0.18670D0,  0.17123D0,  0.15532D0,  0.13957D0,  0.12434D0,
     &     0.10972D0,  0.09602D0,  0.08332D0,  0.07164D0,  0.06111D0,
     &     0.05170D0,  0.04318D0,  0.03568D0,  0.02933D0,  0.02371D0,
     &     0.01889D0,  0.01491D0,  0.01151D0,  0.00652D0,  0.00337D0,
     &     0.00153D0,  0.00058D0,  0.00003D0,  0.00000D0/
      DATA (FMRS(2,2,I,29),I=1,49)/
     &     0.00880D0,  0.01125D0,  0.01439D0,  0.01662D0,  0.01842D0,
     &     0.01995D0,  0.02562D0,  0.03305D0,  0.03850D0,  0.04303D0,
     &     0.04716D0,  0.06297D0,  0.08471D0,  0.10067D0,  0.11354D0,
     &     0.12440D0,  0.14205D0,  0.16199D0,  0.18487D0,  0.19981D0,
     &     0.21577D0,  0.22050D0,  0.21856D0,  0.21030D0,  0.19797D0,
     &     0.18358D0,  0.16796D0,  0.15200D0,  0.13629D0,  0.12116D0,
     &     0.10670D0,  0.09318D0,  0.08069D0,  0.06924D0,  0.05894D0,
     &     0.04976D0,  0.04148D0,  0.03421D0,  0.02806D0,  0.02263D0,
     &     0.01799D0,  0.01417D0,  0.01091D0,  0.00615D0,  0.00316D0,
     &     0.00143D0,  0.00054D0,  0.00003D0,  0.00000D0/
      DATA (FMRS(2,2,I,30),I=1,49)/
     &     0.00889D0,  0.01137D0,  0.01456D0,  0.01683D0,  0.01865D0,
     &     0.02021D0,  0.02596D0,  0.03351D0,  0.03906D0,  0.04365D0,
     &     0.04784D0,  0.06384D0,  0.08576D0,  0.10180D0,  0.11470D0,
     &     0.12555D0,  0.14314D0,  0.16292D0,  0.18544D0,  0.19997D0,
     &     0.21516D0,  0.21921D0,  0.21670D0,  0.20790D0,  0.19518D0,
     &     0.18054D0,  0.16480D0,  0.14880D0,  0.13314D0,  0.11810D0,
     &     0.10380D0,  0.09048D0,  0.07819D0,  0.06696D0,  0.05688D0,
     &     0.04793D0,  0.03987D0,  0.03282D0,  0.02686D0,  0.02162D0,
     &     0.01715D0,  0.01347D0,  0.01036D0,  0.00581D0,  0.00297D0,
     &     0.00134D0,  0.00050D0,  0.00002D0,  0.00000D0/
      DATA (FMRS(2,2,I,31),I=1,49)/
     &     0.00897D0,  0.01149D0,  0.01472D0,  0.01702D0,  0.01887D0,
     &     0.02045D0,  0.02630D0,  0.03396D0,  0.03958D0,  0.04424D0,
     &     0.04848D0,  0.06466D0,  0.08676D0,  0.10286D0,  0.11579D0,
     &     0.12663D0,  0.14416D0,  0.16377D0,  0.18594D0,  0.20009D0,
     &     0.21455D0,  0.21797D0,  0.21493D0,  0.20563D0,  0.19256D0,
     &     0.17769D0,  0.16185D0,  0.14582D0,  0.13021D0,  0.11528D0,
     &     0.10112D0,  0.08798D0,  0.07588D0,  0.06486D0,  0.05500D0,
     &     0.04626D0,  0.03841D0,  0.03155D0,  0.02578D0,  0.02071D0,
     &     0.01640D0,  0.01285D0,  0.00986D0,  0.00551D0,  0.00280D0,
     &     0.00125D0,  0.00046D0,  0.00002D0,  0.00000D0/
      DATA (FMRS(2,2,I,32),I=1,49)/
     &     0.00905D0,  0.01160D0,  0.01487D0,  0.01721D0,  0.01909D0,
     &     0.02069D0,  0.02661D0,  0.03438D0,  0.04008D0,  0.04480D0,
     &     0.04909D0,  0.06543D0,  0.08768D0,  0.10385D0,  0.11679D0,
     &     0.12763D0,  0.14509D0,  0.16454D0,  0.18637D0,  0.20016D0,
     &     0.21393D0,  0.21676D0,  0.21323D0,  0.20346D0,  0.19008D0,
     &     0.17502D0,  0.15909D0,  0.14304D0,  0.12749D0,  0.11266D0,
     &     0.09863D0,  0.08567D0,  0.07376D0,  0.06293D0,  0.05328D0,
     &     0.04474D0,  0.03708D0,  0.03039D0,  0.02479D0,  0.01988D0,
     &     0.01572D0,  0.01229D0,  0.00941D0,  0.00524D0,  0.00265D0,
     &     0.00118D0,  0.00043D0,  0.00002D0,  0.00000D0/
      DATA (FMRS(2,2,I,33),I=1,49)/
     &     0.00914D0,  0.01172D0,  0.01503D0,  0.01740D0,  0.01930D0,
     &     0.02092D0,  0.02693D0,  0.03481D0,  0.04058D0,  0.04536D0,
     &     0.04970D0,  0.06621D0,  0.08862D0,  0.10485D0,  0.11781D0,
     &     0.12863D0,  0.14602D0,  0.16531D0,  0.18679D0,  0.20022D0,
     &     0.21330D0,  0.21555D0,  0.21154D0,  0.20131D0,  0.18763D0,
     &     0.17238D0,  0.15637D0,  0.14031D0,  0.12482D0,  0.11010D0,
     &     0.09620D0,  0.08342D0,  0.07168D0,  0.06106D0,  0.05161D0,
     &     0.04326D0,  0.03580D0,  0.02928D0,  0.02384D0,  0.01908D0,
     &     0.01506D0,  0.01176D0,  0.00899D0,  0.00498D0,  0.00251D0,
     &     0.00111D0,  0.00041D0,  0.00002D0,  0.00000D0/
      DATA (FMRS(2,2,I,34),I=1,49)/
     &     0.00922D0,  0.01183D0,  0.01519D0,  0.01758D0,  0.01951D0,
     &     0.02116D0,  0.02725D0,  0.03523D0,  0.04108D0,  0.04592D0,
     &     0.05030D0,  0.06698D0,  0.08953D0,  0.10581D0,  0.11878D0,
     &     0.12959D0,  0.14690D0,  0.16601D0,  0.18715D0,  0.20021D0,
     &     0.21262D0,  0.21429D0,  0.20982D0,  0.19916D0,  0.18519D0,
     &     0.16977D0,  0.15369D0,  0.13763D0,  0.12221D0,  0.10760D0,
     &     0.09385D0,  0.08123D0,  0.06969D0,  0.05926D0,  0.05001D0,
     &     0.04183D0,  0.03456D0,  0.02822D0,  0.02295D0,  0.01833D0,
     &     0.01444D0,  0.01126D0,  0.00858D0,  0.00473D0,  0.00238D0,
     &     0.00105D0,  0.00038D0,  0.00002D0,  0.00000D0/
      DATA (FMRS(2,2,I,35),I=1,49)/
     &     0.00930D0,  0.01194D0,  0.01534D0,  0.01777D0,  0.01972D0,
     &     0.02138D0,  0.02755D0,  0.03564D0,  0.04156D0,  0.04645D0,
     &     0.05088D0,  0.06771D0,  0.09039D0,  0.10673D0,  0.11970D0,
     &     0.13050D0,  0.14773D0,  0.16667D0,  0.18748D0,  0.20020D0,
     &     0.21197D0,  0.21309D0,  0.20820D0,  0.19714D0,  0.18290D0,
     &     0.16734D0,  0.15119D0,  0.13514D0,  0.11978D0,  0.10528D0,
     &     0.09167D0,  0.07922D0,  0.06786D0,  0.05760D0,  0.04853D0,
     &     0.04052D0,  0.03343D0,  0.02726D0,  0.02213D0,  0.01765D0,
     &     0.01387D0,  0.01080D0,  0.00822D0,  0.00451D0,  0.00226D0,
     &     0.00099D0,  0.00036D0,  0.00002D0,  0.00000D0/
      DATA (FMRS(2,2,I,36),I=1,49)/
     &     0.00938D0,  0.01205D0,  0.01549D0,  0.01794D0,  0.01992D0,
     &     0.02160D0,  0.02784D0,  0.03602D0,  0.04201D0,  0.04696D0,
     &     0.05143D0,  0.06840D0,  0.09121D0,  0.10758D0,  0.12056D0,
     &     0.13134D0,  0.14849D0,  0.16728D0,  0.18776D0,  0.20016D0,
     &     0.21132D0,  0.21194D0,  0.20664D0,  0.19522D0,  0.18074D0,
     &     0.16504D0,  0.14884D0,  0.13281D0,  0.11752D0,  0.10313D0,
     &     0.08965D0,  0.07735D0,  0.06616D0,  0.05608D0,  0.04717D0,
     &     0.03933D0,  0.03239D0,  0.02637D0,  0.02137D0,  0.01702D0,
     &     0.01336D0,  0.01038D0,  0.00788D0,  0.00431D0,  0.00215D0,
     &     0.00094D0,  0.00034D0,  0.00001D0,  0.00000D0/
      DATA (FMRS(2,2,I,37),I=1,49)/
     &     0.00946D0,  0.01216D0,  0.01563D0,  0.01812D0,  0.02011D0,
     &     0.02182D0,  0.02814D0,  0.03641D0,  0.04247D0,  0.04747D0,
     &     0.05199D0,  0.06909D0,  0.09202D0,  0.10844D0,  0.12142D0,
     &     0.13217D0,  0.14925D0,  0.16786D0,  0.18802D0,  0.20008D0,
     &     0.21063D0,  0.21075D0,  0.20506D0,  0.19327D0,  0.17856D0,
     &     0.16274D0,  0.14648D0,  0.13048D0,  0.11526D0,  0.10099D0,
     &     0.08766D0,  0.07551D0,  0.06448D0,  0.05458D0,  0.04583D0,
     &     0.03816D0,  0.03137D0,  0.02550D0,  0.02064D0,  0.01641D0,
     &     0.01285D0,  0.00997D0,  0.00756D0,  0.00412D0,  0.00204D0,
     &     0.00089D0,  0.00032D0,  0.00001D0,  0.00000D0/
      DATA (FMRS(2,2,I,38),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,3,I, 1),I=1,49)/
     &     2.49594D0,  2.59678D0,  2.70121D0,  2.76381D0,  2.80882D0,
     &     2.84400D0,  2.95410D0,  3.06293D0,  3.12376D0,  3.16433D0,
     &     3.19612D0,  3.26381D0,  3.24185D0,  3.15396D0,  3.04339D0,
     &     2.92461D0,  2.68378D0,  2.34265D0,  1.85814D0,  1.47710D0,
     &     0.96403D0,  0.68739D0,  0.56164D0,  0.53053D0,  0.57114D0,
     &     0.63752D0,  0.70266D0,  0.75190D0,  0.77864D0,  0.78165D0,
     &     0.76223D0,  0.72410D0,  0.67143D0,  0.60861D0,  0.54010D0,
     &     0.46946D0,  0.39966D0,  0.33340D0,  0.27271D0,  0.21796D0,
     &     0.17035D0,  0.13022D0,  0.09678D0,  0.04919D0,  0.02174D0,
     &     0.00799D0,  0.00226D0,  0.00004D0,  0.00000D0/
      DATA (FMRS(2,3,I, 2),I=1,49)/
     &     4.92533D0,  4.79050D0,  4.65910D0,  4.58370D0,  4.53079D0,
     &     4.49006D0,  4.36491D0,  4.24084D0,  4.16793D0,  4.11560D0,
     &     4.07957D0,  3.94076D0,  3.72768D0,  3.53640D0,  3.35786D0,
     &     3.19001D0,  2.88282D0,  2.48367D0,  1.95213D0,  1.55132D0,
     &     1.02835D0,  0.75268D0,  0.62744D0,  0.59181D0,  0.62218D0,
     &     0.67462D0,  0.72413D0,  0.75779D0,  0.77032D0,  0.76124D0,
     &     0.73236D0,  0.68747D0,  0.63069D0,  0.56612D0,  0.49789D0,
     &     0.42912D0,  0.36239D0,  0.29993D0,  0.24354D0,  0.19324D0,
     &     0.14994D0,  0.11382D0,  0.08400D0,  0.04209D0,  0.01833D0,
     &     0.00664D0,  0.00185D0,  0.00003D0,  0.00000D0/
      DATA (FMRS(2,3,I, 3),I=1,49)/
     &     9.56993D0,  8.80858D0,  8.10702D0,  7.72221D0,  7.45989D0,
     &     7.26226D0,  6.67868D0,  6.13604D0,  5.83460D0,  5.62657D0,
     &     5.47187D0,  4.98498D0,  4.45878D0,  4.10350D0,  3.81920D0,
     &     3.57625D0,  3.16921D0,  2.68460D0,  2.08542D0,  1.65674D0,
     &     1.11953D0,  0.84374D0,  0.71690D0,  0.67195D0,  0.68567D0,
     &     0.71718D0,  0.74433D0,  0.75653D0,  0.75014D0,  0.72558D0,
     &     0.68509D0,  0.63243D0,  0.57149D0,  0.50592D0,  0.43925D0,
     &     0.37400D0,  0.31223D0,  0.25550D0,  0.20529D0,  0.16120D0,
     &     0.12380D0,  0.09303D0,  0.06796D0,  0.03337D0,  0.01425D0,
     &     0.00506D0,  0.00138D0,  0.00002D0,  0.00000D0/
      DATA (FMRS(2,3,I, 4),I=1,49)/
     &    13.80940D0, 12.36505D0, 11.07010D0, 10.37511D0,  9.90777D0,
     &     9.55916D0,  8.54772D0,  7.63175D0,  7.13319D0,  6.79336D0,
     &     6.53831D0,  5.76591D0,  4.99154D0,  4.51033D0,  4.14636D0,
     &     3.84778D0,  3.36791D0,  2.82235D0,  2.17611D0,  1.72845D0,
     &     1.18134D0,  0.90432D0,  0.77478D0,  0.72147D0,  0.72239D0,
     &     0.73883D0,  0.75059D0,  0.74861D0,  0.73014D0,  0.69610D0,
     &     0.64889D0,  0.59216D0,  0.52949D0,  0.46423D0,  0.39938D0,
     &     0.33717D0,  0.27919D0,  0.22665D0,  0.18078D0,  0.14088D0,
     &     0.10742D0,  0.08015D0,  0.05814D0,  0.02814D0,  0.01185D0,
     &     0.00415D0,  0.00112D0,  0.00002D0,  0.00000D0/
      DATA (FMRS(2,3,I, 5),I=1,49)/
     &    18.88911D0, 16.54105D0, 14.48190D0, 13.39606D0, 12.67388D0,
     &    12.13950D0, 10.61083D0,  9.25560D0,  8.52999D0,  8.04031D0,
     &     7.67199D0,  6.58349D0,  5.54112D0,  4.92668D0,  4.47939D0,
     &     4.12305D0,  3.56848D0,  2.96102D0,  2.26733D0,  1.80038D0,
     &     1.24179D0,  0.96142D0,  0.82726D0,  0.76409D0,  0.75165D0,
     &     0.75317D0,  0.75022D0,  0.73504D0,  0.70570D0,  0.66340D0,
     &     0.61066D0,  0.55093D0,  0.48745D0,  0.42321D0,  0.36077D0,
     &     0.30193D0,  0.24792D0,  0.19962D0,  0.15797D0,  0.12220D0,
     &     0.09245D0,  0.06850D0,  0.04934D0,  0.02353D0,  0.00976D0,
     &     0.00337D0,  0.00090D0,  0.00002D0,  0.00000D0/
      DATA (FMRS(2,3,I, 6),I=1,49)/
     &    24.17862D0, 20.81157D0, 17.90894D0, 16.39907D0, 15.40344D0,
     &    14.67132D0, 12.59987D0, 10.79385D0,  9.83948D0,  9.20057D0,
     &     8.72036D0,  7.32519D0,  6.02998D0,  5.29291D0,  4.77007D0,
     &     4.36196D0,  3.74120D0,  3.07968D0,  2.34504D0,  1.86151D0,
     &     1.29269D0,  1.00884D0,  0.87005D0,  0.79769D0,  0.77342D0,
     &     0.76224D0,  0.74721D0,  0.72151D0,  0.68376D0,  0.63535D0,
     &     0.57871D0,  0.51714D0,  0.45352D0,  0.39051D0,  0.33033D0,
     &     0.27444D0,  0.22374D0,  0.17892D0,  0.14065D0,  0.10811D0,
     &     0.08127D0,  0.05985D0,  0.04284D0,  0.02018D0,  0.00827D0,
     &     0.00283D0,  0.00075D0,  0.00001D0,  0.00000D0/
      DATA (FMRS(2,3,I, 7),I=1,49)/
     &    29.73861D0, 25.23818D0, 21.41267D0, 19.44500D0, 18.15658D0,
     &    17.21404D0, 14.57125D0, 12.29875D0, 11.11092D0, 10.32111D0,
     &     9.72854D0,  8.02926D0,  6.48794D0,  5.63342D0,  5.03891D0,
     &     4.58210D0,  3.89945D0,  3.18799D0,  2.41570D0,  1.91680D0,
     &     1.33767D0,  1.04936D0,  0.90523D0,  0.82366D0,  0.78841D0,
     &     0.76591D0,  0.74039D0,  0.70578D0,  0.66114D0,  0.60793D0,
     &     0.54844D0,  0.48585D0,  0.42265D0,  0.36114D0,  0.30329D0,
     &     0.25030D0,  0.20271D0,  0.16106D0,  0.12587D0,  0.09616D0,
     &     0.07187D0,  0.05262D0,  0.03744D0,  0.01745D0,  0.00707D0,
     &     0.00239D0,  0.00063D0,  0.00001D0,  0.00000D0/
      DATA (FMRS(2,3,I, 8),I=1,49)/
     &    36.41777D0, 30.48425D0, 25.50925D0, 22.97827D0, 21.33235D0,
     &    20.13434D0, 16.80486D0, 13.98059D0, 12.52029D0, 11.55588D0,
     &    10.83420D0,  8.78991D0,  6.97511D0,  5.99232D0,  5.32046D0,
     &     4.81154D0,  4.06330D0,  3.29938D0,  2.48793D0,  1.97297D0,
     &     1.38262D0,  1.08896D0,  0.93866D0,  0.84707D0,  0.80034D0,
     &     0.76640D0,  0.73057D0,  0.68748D0,  0.63647D0,  0.57905D0,
     &     0.51730D0,  0.45416D0,  0.39180D0,  0.33216D0,  0.27689D0,
     &     0.22693D0,  0.18251D0,  0.14405D0,  0.11189D0,  0.08494D0,
     &     0.06310D0,  0.04592D0,  0.03248D0,  0.01496D0,  0.00600D0,
     &     0.00201D0,  0.00052D0,  0.00001D0,  0.00000D0/
      DATA (FMRS(2,3,I, 9),I=1,49)/
     &    42.89913D0, 35.51439D0, 29.39055D0, 26.30256D0, 24.30551D0,
     &    22.85784D0, 18.86316D0, 15.51177D0, 13.79420D0, 12.66617D0,
     &    11.82423D0,  9.46212D0,  7.39982D0,  6.30264D0,  5.56252D0,
     &     5.00794D0,  4.20275D0,  3.39360D0,  2.54868D0,  2.01994D0,
     &     1.41958D0,  1.12075D0,  0.96469D0,  0.86425D0,  0.80777D0,
     &     0.76439D0,  0.72030D0,  0.67061D0,  0.61480D0,  0.55436D0,
     &     0.49120D0,  0.42796D0,  0.36659D0,  0.30874D0,  0.25576D0,
     &     0.20835D0,  0.16660D0,  0.13075D0,  0.10101D0,  0.07629D0,
     &     0.05637D0,  0.04082D0,  0.02872D0,  0.01310D0,  0.00521D0,
     &     0.00173D0,  0.00045D0,  0.00001D0,  0.00000D0/
      DATA (FMRS(2,3,I,10),I=1,49)/
     &    49.61974D0, 40.67585D0, 33.33157D0, 29.65726D0, 27.29273D0,
     &    25.58490D0, 20.90223D0, 17.01226D0, 15.03449D0, 13.74211D0,
     &    12.78005D0, 10.10345D0,  7.80003D0,  6.59295D0,  5.78776D0,
     &     5.18997D0,  4.33113D0,  3.47979D0,  2.60379D0,  2.06215D0,
     &     1.45191D0,  1.14765D0,  0.98577D0,  0.87686D0,  0.81144D0,
     &     0.75966D0,  0.70838D0,  0.65310D0,  0.59339D0,  0.53065D0,
     &     0.46666D0,  0.40372D0,  0.34354D0,  0.28753D0,  0.23679D0,
     &     0.19183D0,  0.15254D0,  0.11910D0,  0.09155D0,  0.06880D0,
     &     0.05059D0,  0.03647D0,  0.02554D0,  0.01155D0,  0.00456D0,
     &     0.00150D0,  0.00039D0,  0.00001D0,  0.00000D0/
      DATA (FMRS(2,3,I,11),I=1,49)/
     &    55.39180D0, 45.07076D0, 36.65840D0, 32.47479D0, 29.79258D0,
     &    27.86062D0, 22.58892D0, 18.24235D0, 16.04583D0, 14.61602D0,
     &    13.55394D0, 10.61757D0,  8.11747D0,  6.82180D0,  5.96451D0,
     &     5.33234D0,  4.43100D0,  3.54652D0,  2.64619D0,  2.09446D0,
     &     1.47626D0,  1.16746D0,  1.00084D0,  0.88523D0,  0.81292D0,
     &     0.75482D0,  0.69824D0,  0.63893D0,  0.57653D0,  0.51229D0,
     &     0.44790D0,  0.38538D0,  0.32625D0,  0.27173D0,  0.22275D0,
     &     0.17969D0,  0.14226D0,  0.11063D0,  0.08472D0,  0.06341D0,
     &     0.04647D0,  0.03337D0,  0.02328D0,  0.01046D0,  0.00410D0,
     &     0.00135D0,  0.00035D0,  0.00001D0,  0.00000D0/
      DATA (FMRS(2,3,I,12),I=1,49)/
     &    68.81419D0, 55.16745D0, 44.20809D0, 38.82247D0, 35.39534D0,
     &    32.94036D0, 26.30577D0, 20.91710D0, 18.22705D0, 16.48958D0,
     &    15.20488D0, 11.69679D0,  8.77186D0,  7.28789D0,  6.32113D0,
     &     5.61724D0,  4.62839D0,  3.67636D0,  2.72714D0,  2.15522D0,
     &     1.52072D0,  1.20219D0,  1.02548D0,  0.89610D0,  0.81011D0,
     &     0.73981D0,  0.67337D0,  0.60686D0,  0.53995D0,  0.47362D0,
     &     0.40911D0,  0.34808D0,  0.29158D0,  0.24046D0,  0.19523D0,
     &     0.15609D0,  0.12251D0,  0.09445D0,  0.07178D0,  0.05329D0,
     &     0.03875D0,  0.02763D0,  0.01914D0,  0.00848D0,  0.00328D0,
     &     0.00107D0,  0.00027D0,  0.00001D0,  0.00000D0/
      DATA (FMRS(2,3,I,13),I=1,49)/
     &    81.72071D0, 64.73620D0, 51.25830D0, 44.69851D0, 40.54929D0,
     &    37.59021D0, 29.65526D0, 23.28836D0, 20.14139D0, 18.12166D0,
     &    16.63424D0, 12.61228D0,  9.31401D0,  7.66787D0,  6.60816D0,
     &     5.84402D0,  4.78269D0,  3.77556D0,  2.78721D0,  2.19932D0,
     &     1.55169D0,  1.22492D0,  1.03973D0,  0.89912D0,  0.80240D0,
     &     0.72291D0,  0.64937D0,  0.57800D0,  0.50838D0,  0.44121D0,
     &     0.37732D0,  0.31807D0,  0.26412D0,  0.21603D0,  0.17402D0,
     &     0.13809D0,  0.10760D0,  0.08235D0,  0.06220D0,  0.04588D0,
     &     0.03314D0,  0.02349D0,  0.01618D0,  0.00709D0,  0.00272D0,
     &     0.00088D0,  0.00022D0,  0.00001D0,  0.00000D0/
      DATA (FMRS(2,3,I,14),I=1,49)/
     &    97.52657D0, 76.29261D0, 59.65305D0, 51.63612D0, 46.59734D0,
     &    43.02061D0, 33.50751D0, 25.97167D0, 22.28590D0, 19.93624D0,
     &    18.21366D0, 13.60275D0,  9.88582D0,  8.06142D0,  6.90102D0,
     &     6.07241D0,  4.93443D0,  3.87015D0,  2.84210D0,  2.23830D0,
     &     1.57740D0,  1.24193D0,  1.04776D0,  0.89562D0,  0.78827D0,
     &     0.70003D0,  0.62012D0,  0.54473D0,  0.47326D0,  0.40608D0,
     &     0.34362D0,  0.28678D0,  0.23589D0,  0.19121D0,  0.15279D0,
     &     0.12024D0,  0.09296D0,  0.07060D0,  0.05295D0,  0.03880D0,
     &     0.02782D0,  0.01961D0,  0.01341D0,  0.00581D0,  0.00221D0,
     &     0.00071D0,  0.00018D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,3,I,15),I=1,49)/
     &   115.42858D0, 89.21046D0, 68.91241D0, 59.22810D0, 53.17852D0,
     &    48.90368D0, 37.62299D0, 28.79719D0, 24.52433D0, 21.81818D0,
     &    19.84305D0, 14.60749D0, 10.45530D0,  8.44881D0,  7.18665D0,
     &     6.29326D0,  5.07912D0,  3.95881D0,  2.89174D0,  2.27205D0,
     &     1.59726D0,  1.25251D0,  1.04935D0,  0.88634D0,  0.76946D0,
     &     0.67380D0,  0.58880D0,  0.51059D0,  0.43833D0,  0.37190D0,
     &     0.31141D0,  0.25732D0,  0.20974D0,  0.16850D0,  0.13349D0,
     &     0.10422D0,  0.07994D0,  0.06028D0,  0.04489D0,  0.03267D0,
     &     0.02328D0,  0.01630D0,  0.01109D0,  0.00475D0,  0.00179D0,
     &     0.00057D0,  0.00015D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,3,I,16),I=1,49)/
     &   133.20726D0,101.88441D0, 77.88580D0, 66.53202D0, 59.47687D0,
     &    54.51081D0, 41.49468D0, 31.41946D0, 26.58451D0, 23.53963D0,
     &    21.32609D0, 15.50695D0, 10.95547D0,  8.78473D0,  7.43186D0,
     &     6.48132D0,  5.20052D0,  4.03146D0,  2.93090D0,  2.29753D0,
     &     1.61041D0,  1.25744D0,  1.04659D0,  0.87462D0,  0.75027D0,
     &     0.64906D0,  0.56054D0,  0.48074D0,  0.40844D0,  0.34317D0,
     &     0.28476D0,  0.23329D0,  0.18860D0,  0.15037D0,  0.11827D0,
     &     0.09171D0,  0.06985D0,  0.05235D0,  0.03876D0,  0.02805D0,
     &     0.01988D0,  0.01385D0,  0.00937D0,  0.00398D0,  0.00150D0,
     &     0.00048D0,  0.00012D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,3,I,17),I=1,49)/
     &   152.75288D0,115.66533D0, 87.53463D0, 74.33386D0, 66.17272D0,
     &    60.44971D0, 45.54741D0, 34.13087D0, 28.69873D0, 25.29647D0,
     &    22.83273D0, 16.40709D0, 11.44748D0,  9.11138D0,  7.66812D0,
     &     6.66113D0,  5.31487D0,  4.09842D0,  2.96558D0,  2.31899D0,
     &     1.61977D0,  1.25878D0,  1.04063D0,  0.86046D0,  0.72956D0,
     &     0.62377D0,  0.53260D0,  0.45191D0,  0.38010D0,  0.31636D0,
     &     0.26019D0,  0.21141D0,  0.16955D0,  0.13419D0,  0.10481D0,
     &     0.08073D0,  0.06109D0,  0.04550D0,  0.03350D0,  0.02411D0,
     &     0.01700D0,  0.01178D0,  0.00794D0,  0.00335D0,  0.00125D0,
     &     0.00040D0,  0.00010D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,3,I,18),I=1,49)/
     &   170.01192D0,127.71370D0, 95.88535D0, 81.04548D0, 71.90795D0,
     &    65.51928D0, 48.96956D0, 36.39437D0, 30.45131D0, 26.74517D0,
     &    24.06967D0, 17.13549D0, 11.83889D0,  9.36824D0,  7.85201D0,
     &     6.79985D0,  5.40144D0,  4.14772D0,  2.98965D0,  2.33267D0,
     &     1.62383D0,  1.25653D0,  1.03280D0,  0.84662D0,  0.71111D0,
     &     0.60235D0,  0.50969D0,  0.42880D0,  0.35778D0,  0.29558D0,
     &     0.24138D0,  0.19483D0,  0.15529D0,  0.12217D0,  0.09488D0,
     &     0.07271D0,  0.05474D0,  0.04057D0,  0.02974D0,  0.02131D0,
     &     0.01497D0,  0.01034D0,  0.00694D0,  0.00291D0,  0.00108D0,
     &     0.00035D0,  0.00009D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,3,I,19),I=1,49)/
     &   192.21783D0,143.06714D0,106.42301D0, 89.46533D0, 79.07272D0,
     &    71.83153D0, 53.18588D0, 39.15232D0, 32.57201D0, 28.48916D0,
     &    25.55252D0, 17.99626D0, 12.29353D0,  9.66291D0,  8.06074D0,
     &     6.95556D0,  5.49677D0,  4.20023D0,  3.01333D0,  2.34451D0,
     &     1.62470D0,  1.25025D0,  1.02039D0,  0.82787D0,  0.68779D0,
     &     0.57628D0,  0.48256D0,  0.40194D0,  0.33226D0,  0.27214D0,
     &     0.22041D0,  0.17653D0,  0.13970D0,  0.10915D0,  0.08422D0,
     &     0.06416D0,  0.04803D0,  0.03538D0,  0.02582D0,  0.01841D0,
     &     0.01287D0,  0.00885D0,  0.00592D0,  0.00247D0,  0.00092D0,
     &     0.00029D0,  0.00008D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,3,I,20),I=1,49)/
     &   213.34880D0,157.54303D0,116.26574D0, 97.28644D0, 85.70139D0,
     &    77.65329D0, 57.03621D0, 41.64487D0, 34.47643D0, 30.04790D0,
     &    26.87277D0, 18.75275D0, 12.68704D0,  9.91527D0,  8.23788D0,
     &     7.08656D0,  5.57571D0,  4.24254D0,  3.03117D0,  2.35234D0,
     &     1.62325D0,  1.24282D0,  1.00799D0,  0.81051D0,  0.66705D0,
     &     0.55370D0,  0.45951D0,  0.37948D0,  0.31121D0,  0.25302D0,
     &     0.20347D0,  0.16190D0,  0.12732D0,  0.09891D0,  0.07590D0,
     &     0.05752D0,  0.04285D0,  0.03141D0,  0.02283D0,  0.01621D0,
     &     0.01129D0,  0.00774D0,  0.00517D0,  0.00215D0,  0.00079D0,
     &     0.00025D0,  0.00007D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,3,I,21),I=1,49)/
     &   233.39284D0,171.15466D0,125.43786D0,104.53514D0, 91.82097D0,
     &    83.01126D0, 60.54451D0, 43.89167D0, 36.18145D0, 31.43626D0,
     &    28.04374D0, 19.41375D0, 13.02433D0, 10.12820D0,  8.38525D0,
     &     7.19405D0,  5.63853D0,  4.27419D0,  3.04230D0,  2.35510D0,
     &     1.61821D0,  1.23292D0,  0.99418D0,  0.79299D0,  0.64721D0,
     &     0.53284D0,  0.43872D0,  0.35966D0,  0.29291D0,  0.23658D0,
     &     0.18910D0,  0.14961D0,  0.11702D0,  0.09045D0,  0.06907D0,
     &     0.05212D0,  0.03865D0,  0.02823D0,  0.02044D0,  0.01446D0,
     &     0.01004D0,  0.00687D0,  0.00457D0,  0.00189D0,  0.00070D0,
     &     0.00022D0,  0.00006D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,3,I,22),I=1,49)/
     &   260.44016D0,189.36696D0,137.60457D0,114.10131D0, 99.86725D0,
     &    90.03576D0, 65.10178D0, 46.78208D0, 38.36169D0, 33.20363D0,
     &    29.52871D0, 20.24143D0, 13.44020D0, 10.38777D0,  8.56307D0,
     &     7.32250D0,  5.71195D0,  4.30962D0,  3.05294D0,  2.35572D0,
     &     1.60960D0,  1.21865D0,  0.97551D0,  0.77034D0,  0.62226D0,
     &     0.50716D0,  0.41356D0,  0.33596D0,  0.27128D0,  0.21734D0,
     &     0.17244D0,  0.13547D0,  0.10527D0,  0.08085D0,  0.06139D0,
     &     0.04607D0,  0.03398D0,  0.02471D0,  0.01781D0,  0.01255D0,
     &     0.00868D0,  0.00593D0,  0.00393D0,  0.00162D0,  0.00060D0,
     &     0.00019D0,  0.00005D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,3,I,23),I=1,49)/
     &   287.44696D0,207.38838D0,149.53354D0,123.42919D0,107.68206D0,
     &    96.83708D0, 69.47065D0, 49.52397D0, 40.41636D0, 34.86102D0,
     &    30.91543D0, 21.00356D0, 13.81644D0, 10.61949D0,  8.71986D0,
     &     7.43441D0,  5.77408D0,  4.33783D0,  3.05923D0,  2.35324D0,
     &     1.59919D0,  1.20346D0,  0.95679D0,  0.74861D0,  0.59903D0,
     &     0.48379D0,  0.39106D0,  0.31505D0,  0.25241D0,  0.20076D0,
     &     0.15822D0,  0.12352D0,  0.09541D0,  0.07286D0,  0.05504D0,
     &     0.04110D0,  0.03018D0,  0.02185D0,  0.01570D0,  0.01103D0,
     &     0.00760D0,  0.00518D0,  0.00342D0,  0.00141D0,  0.00052D0,
     &     0.00017D0,  0.00004D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,3,I,24),I=1,49)/
     &   313.51825D0,224.63136D0,160.84229D0,132.22295D0,115.01953D0,
     &   103.20245D0, 73.51698D0, 52.03463D0, 42.28400D0, 36.35911D0,
     &    32.16307D0, 21.67765D0, 14.14149D0, 10.81558D0,  8.84983D0,
     &     7.52509D0,  5.82169D0,  4.35654D0,  3.05952D0,  2.34629D0,
     &     1.58590D0,  1.18656D0,  0.93734D0,  0.72724D0,  0.57702D0,
     &     0.46218D0,  0.37070D0,  0.29646D0,  0.23590D0,  0.18642D0,
     &     0.14603D0,  0.11337D0,  0.08712D0,  0.06621D0,  0.04979D0,
     &     0.03702D0,  0.02708D0,  0.01953D0,  0.01399D0,  0.00980D0,
     &     0.00674D0,  0.00458D0,  0.00302D0,  0.00124D0,  0.00046D0,
     &     0.00015D0,  0.00004D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,3,I,25),I=1,49)/
     &   341.15173D0,242.77290D0,172.65150D0,141.36496D0,122.62321D0,
     &   109.78229D0, 77.66644D0, 54.58787D0, 44.17350D0, 37.86890D0,
     &    33.41642D0, 22.34751D0, 14.46016D0, 11.00588D0,  8.97477D0,
     &     7.61137D0,  5.86592D0,  4.37273D0,  3.05810D0,  2.33803D0,
     &     1.57177D0,  1.16920D0,  0.91780D0,  0.70620D0,  0.55570D0,
     &     0.44154D0,  0.35145D0,  0.27905D0,  0.22057D0,  0.17322D0,
     &     0.13490D0,  0.10417D0,  0.07964D0,  0.06025D0,  0.04510D0,
     &     0.03340D0,  0.02434D0,  0.01749D0,  0.01249D0,  0.00873D0,
     &     0.00599D0,  0.00406D0,  0.00268D0,  0.00110D0,  0.00041D0,
     &     0.00013D0,  0.00004D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,3,I,26),I=1,49)/
     &   368.98822D0,260.90195D0,184.35516D0,150.38000D0,130.09390D0,
     &   116.22827D0, 81.69344D0, 57.04021D0, 45.97627D0, 39.30195D0,
     &    34.60083D0, 22.97047D0, 14.74975D0, 11.17543D0,  9.08370D0,
     &     7.68467D0,  5.90104D0,  4.38251D0,  3.05244D0,  2.32659D0,
     &     1.55551D0,  1.15047D0,  0.89759D0,  0.68521D0,  0.53495D0,
     &     0.42187D0,  0.33342D0,  0.26295D0,  0.20656D0,  0.16128D0,
     &     0.12493D0,  0.09597D0,  0.07303D0,  0.05500D0,  0.04100D0,
     &     0.03027D0,  0.02198D0,  0.01575D0,  0.01122D0,  0.00782D0,
     &     0.00536D0,  0.00363D0,  0.00239D0,  0.00098D0,  0.00036D0,
     &     0.00012D0,  0.00003D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,3,I,27),I=1,49)/
     &   396.49847D0,278.69458D0,195.76036D0,159.12776D0,137.32101D0,
     &   122.44904D0, 85.54959D0, 59.36906D0, 47.67925D0, 40.65031D0,
     &    35.71157D0, 23.54779D0, 15.01388D0, 11.32784D0,  9.18018D0,
     &     7.74858D0,  5.93008D0,  4.38884D0,  3.04508D0,  2.31422D0,
     &     1.53913D0,  1.13220D0,  0.87829D0,  0.66558D0,  0.51586D0,
     &     0.40401D0,  0.31721D0,  0.24862D0,  0.19419D0,  0.15083D0,
     &     0.11625D0,  0.08889D0,  0.06736D0,  0.05053D0,  0.03753D0,
     &     0.02761D0,  0.01999D0,  0.01428D0,  0.01015D0,  0.00707D0,
     &     0.00483D0,  0.00327D0,  0.00215D0,  0.00088D0,  0.00033D0,
     &     0.00011D0,  0.00003D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,3,I,28),I=1,49)/
     &   423.18488D0,295.83777D0,206.67247D0,167.46211D0,144.18538D0,
     &   128.34305D0, 89.17443D0, 61.53922D0, 49.25727D0, 41.89430D0,
     &    36.73269D0, 24.07136D0, 15.24876D0, 11.46075D0,  9.26257D0,
     &     7.80186D0,  5.95221D0,  4.39115D0,  3.03561D0,  2.30059D0,
     &     1.52239D0,  1.11417D0,  0.85969D0,  0.64709D0,  0.49822D0,
     &     0.38776D0,  0.30261D0,  0.23584D0,  0.18326D0,  0.14166D0,
     &     0.10869D0,  0.08277D0,  0.06247D0,  0.04670D0,  0.03458D0,
     &     0.02536D0,  0.01831D0,  0.01305D0,  0.00927D0,  0.00644D0,
     &     0.00439D0,  0.00297D0,  0.00195D0,  0.00080D0,  0.00030D0,
     &     0.00010D0,  0.00003D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,3,I,29),I=1,49)/
     &   450.92862D0,313.54996D0,217.87523D0,175.98549D0,151.18591D0,
     &   134.34097D0, 92.83694D0, 63.71518D0, 50.83173D0, 43.13081D0,
     &    37.74429D0, 24.58404D0, 15.47489D0, 11.58672D0,  9.33925D0,
     &     7.85026D0,  5.97071D0,  4.39081D0,  3.02434D0,  2.28559D0,
     &     1.50481D0,  1.09565D0,  0.84093D0,  0.62877D0,  0.48096D0,
     &     0.37201D0,  0.28863D0,  0.22371D0,  0.17297D0,  0.13307D0,
     &     0.10166D0,  0.07711D0,  0.05798D0,  0.04320D0,  0.03189D0,
     &     0.02332D0,  0.01680D0,  0.01195D0,  0.00847D0,  0.00587D0,
     &     0.00400D0,  0.00270D0,  0.00178D0,  0.00073D0,  0.00027D0,
     &     0.00009D0,  0.00002D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,3,I,30),I=1,49)/
     &   478.88074D0,331.28183D0,229.01660D0,184.42841D0,158.10007D0,
     &   140.25114D0, 96.41853D0, 65.82523D0, 52.35015D0, 44.31818D0,
     &    38.71195D0, 25.06767D0, 15.68364D0, 11.70050D0,  9.40671D0,
     &     7.89123D0,  5.98412D0,  4.38708D0,  3.01099D0,  2.26914D0,
     &     1.48646D0,  1.07684D0,  0.82225D0,  0.61085D0,  0.46437D0,
     &     0.35704D0,  0.27550D0,  0.21242D0,  0.16347D0,  0.12519D0,
     &     0.09525D0,  0.07197D0,  0.05394D0,  0.04005D0,  0.02949D0,
     &     0.02151D0,  0.01546D0,  0.01097D0,  0.00776D0,  0.00538D0,
     &     0.00366D0,  0.00247D0,  0.00162D0,  0.00067D0,  0.00025D0,
     &     0.00008D0,  0.00002D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,3,I,31),I=1,49)/
     &   506.38092D0,348.62979D0,239.85460D0,192.61319D0,164.78622D0,
     &   145.95520D0, 99.85363D0, 67.83522D0, 53.79026D0, 45.44058D0,
     &    39.62410D0, 25.51892D0, 15.87554D0, 11.80362D0,  9.46678D0,
     &     7.92687D0,  5.99445D0,  4.38186D0,  2.99723D0,  2.25276D0,
     &     1.46868D0,  1.05889D0,  0.80464D0,  0.59419D0,  0.44909D0,
     &     0.34338D0,  0.26361D0,  0.20228D0,  0.15498D0,  0.11820D0,
     &     0.08960D0,  0.06746D0,  0.05040D0,  0.03731D0,  0.02741D0,
     &     0.01994D0,  0.01431D0,  0.01014D0,  0.00716D0,  0.00495D0,
     &     0.00337D0,  0.00227D0,  0.00149D0,  0.00061D0,  0.00023D0,
     &     0.00007D0,  0.00002D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,3,I,32),I=1,49)/
     &   532.71063D0,365.14023D0,250.10423D0,200.32385D0,171.06720D0,
     &   151.30153D0,103.04897D0, 69.68893D0, 55.11074D0, 46.46502D0,
     &    40.45333D0, 25.92270D0, 16.04272D0, 11.89083D0,  9.51556D0,
     &     7.95409D0,  5.99947D0,  4.37358D0,  2.98195D0,  2.23557D0,
     &     1.45083D0,  1.04132D0,  0.78773D0,  0.57848D0,  0.43489D0,
     &     0.33086D0,  0.25280D0,  0.19316D0,  0.14738D0,  0.11200D0,
     &     0.08461D0,  0.06352D0,  0.04732D0,  0.03494D0,  0.02560D0,
     &     0.01860D0,  0.01332D0,  0.00942D0,  0.00665D0,  0.00459D0,
     &     0.00312D0,  0.00210D0,  0.00138D0,  0.00057D0,  0.00021D0,
     &     0.00007D0,  0.00002D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,3,I,33),I=1,49)/
     &   560.44952D0,382.45715D0,260.80753D0,208.35481D0,177.59706D0,
     &   156.85155D0,106.35128D0, 71.59602D0, 56.46558D0, 47.51407D0,
     &    41.30114D0, 26.33344D0, 16.21190D0, 11.97881D0,  9.56466D0,
     &     7.98144D0,  6.00450D0,  4.36531D0,  2.96673D0,  2.21850D0,
     &     1.43317D0,  1.02401D0,  0.77116D0,  0.56317D0,  0.42112D0,
     &     0.31878D0,  0.24243D0,  0.18443D0,  0.14015D0,  0.10612D0,
     &     0.07989D0,  0.05980D0,  0.04442D0,  0.03272D0,  0.02392D0,
     &     0.01734D0,  0.01239D0,  0.00875D0,  0.00617D0,  0.00426D0,
     &     0.00289D0,  0.00195D0,  0.00128D0,  0.00052D0,  0.00020D0,
     &     0.00006D0,  0.00002D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,3,I,34),I=1,49)/
     &   587.66711D0,399.34082D0,271.17145D0,216.09799D0,183.87283D0,
     &   162.17198D0,109.48943D0, 73.38959D0, 57.73061D0, 48.48780D0,
     &    42.08379D0, 26.70440D0, 16.35846D0, 12.05124D0,  9.60203D0,
     &     7.99942D0,  6.00308D0,  4.35260D0,  2.94870D0,  2.19937D0,
     &     1.41431D0,  1.00609D0,  0.75435D0,  0.54797D0,  0.40769D0,
     &     0.30718D0,  0.23257D0,  0.17622D0,  0.13341D0,  0.10068D0,
     &     0.07556D0,  0.05639D0,  0.04179D0,  0.03071D0,  0.02240D0,
     &     0.01621D0,  0.01157D0,  0.00816D0,  0.00575D0,  0.00396D0,
     &     0.00269D0,  0.00181D0,  0.00119D0,  0.00049D0,  0.00018D0,
     &     0.00006D0,  0.00002D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,3,I,35),I=1,49)/
     &   614.66376D0,416.01791D0,281.36646D0,223.69629D0,190.02084D0,
     &   167.37685D0,112.54659D0, 75.12943D0, 58.95456D0, 49.42817D0,
     &    42.83852D0, 27.06040D0, 16.49837D0, 12.12015D0,  9.63748D0,
     &     8.01641D0,  6.00168D0,  4.34055D0,  2.93168D0,  2.18137D0,
     &     1.39666D0,  0.98938D0,  0.73876D0,  0.53395D0,  0.39535D0,
     &     0.29658D0,  0.22360D0,  0.16878D0,  0.12732D0,  0.09577D0,
     &     0.07167D0,  0.05334D0,  0.03944D0,  0.02892D0,  0.02106D0,
     &     0.01521D0,  0.01085D0,  0.00764D0,  0.00537D0,  0.00370D0,
     &     0.00251D0,  0.00169D0,  0.00111D0,  0.00046D0,  0.00017D0,
     &     0.00006D0,  0.00002D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,3,I,36),I=1,49)/
     &   640.64490D0,431.98953D0,291.07977D0,230.91319D0,195.84616D0,
     &   172.29993D0,115.42027D0, 76.75350D0, 60.09168D0, 50.29848D0,
     &    43.53482D0, 27.38445D0, 16.62263D0, 12.17943D0,  9.66642D0,
     &     8.02868D0,  5.99763D0,  4.32731D0,  2.91439D0,  2.16350D0,
     &     1.37952D0,  0.97339D0,  0.72400D0,  0.52085D0,  0.38394D0,
     &     0.28684D0,  0.21543D0,  0.16204D0,  0.12184D0,  0.09139D0,
     &     0.06820D0,  0.05064D0,  0.03736D0,  0.02734D0,  0.01987D0,
     &     0.01434D0,  0.01021D0,  0.00718D0,  0.00505D0,  0.00348D0,
     &     0.00236D0,  0.00159D0,  0.00104D0,  0.00043D0,  0.00016D0,
     &     0.00005D0,  0.00001D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,3,I,37),I=1,49)/
     &   667.19971D0,448.23413D0,300.90906D0,238.19307D0,201.70891D0,
     &   177.24495D0,118.28902D0, 78.36304D0, 61.21302D0, 51.15329D0,
     &    44.21644D0, 27.69705D0, 16.73916D0, 12.23290D0,  9.69072D0,
     &     8.03703D0,  5.99069D0,  4.31202D0,  2.89571D0,  2.14460D0,
     &     1.36178D0,  0.95706D0,  0.70912D0,  0.50779D0,  0.37268D0,
     &     0.27731D0,  0.20750D0,  0.15552D0,  0.11658D0,  0.08719D0,
     &     0.06491D0,  0.04808D0,  0.03540D0,  0.02586D0,  0.01877D0,
     &     0.01352D0,  0.00961D0,  0.00676D0,  0.00475D0,  0.00327D0,
     &     0.00222D0,  0.00149D0,  0.00098D0,  0.00040D0,  0.00015D0,
     &     0.00005D0,  0.00001D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,3,I,38),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I, 1),I=1,49)/
     &     0.96883D0,  0.83010D0,  0.71060D0,  0.64853D0,  0.60767D0,
     &     0.57770D0,  0.49346D0,  0.42161D0,  0.38501D0,  0.36146D0,
     &     0.34535D0,  0.30095D0,  0.26559D0,  0.24803D0,  0.23669D0,
     &     0.22831D0,  0.21597D0,  0.20255D0,  0.18524D0,  0.17029D0,
     &     0.14323D0,  0.11890D0,  0.09745D0,  0.07499D0,  0.05725D0,
     &     0.04365D0,  0.03351D0,  0.02602D0,  0.02043D0,  0.01653D0,
     &     0.01318D0,  0.01067D0,  0.00853D0,  0.00671D0,  0.00530D0,
     &     0.00405D0,  0.00296D0,  0.00217D0,  0.00162D0,  0.00103D0,
     &     0.00065D0,  0.00047D0,  0.00023D0,  0.00008D0,  0.00004D0,
     &     0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I, 2),I=1,49)/
     &     0.97285D0,  0.83723D0,  0.71985D0,  0.65865D0,  0.61827D0,
     &     0.58859D0,  0.50491D0,  0.43319D0,  0.39649D0,  0.37279D0,
     &     0.35657D0,  0.31149D0,  0.27487D0,  0.25626D0,  0.24402D0,
     &     0.23487D0,  0.22125D0,  0.20637D0,  0.18739D0,  0.17135D0,
     &     0.14312D0,  0.11837D0,  0.09689D0,  0.07465D0,  0.05719D0,
     &     0.04386D0,  0.03391D0,  0.02652D0,  0.02098D0,  0.01703D0,
     &     0.01365D0,  0.01107D0,  0.00885D0,  0.00698D0,  0.00550D0,
     &     0.00421D0,  0.00309D0,  0.00226D0,  0.00169D0,  0.00108D0,
     &     0.00069D0,  0.00049D0,  0.00025D0,  0.00010D0,  0.00003D0,
     &     0.00002D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I, 3),I=1,49)/
     &     0.99630D0,  0.86193D0,  0.74498D0,  0.68373D0,  0.64319D0,
     &     0.61334D0,  0.52882D0,  0.45586D0,  0.41827D0,  0.39388D0,
     &     0.37707D0,  0.32984D0,  0.29034D0,  0.26968D0,  0.25582D0,
     &     0.24531D0,  0.22956D0,  0.21234D0,  0.19077D0,  0.17310D0,
     &     0.14315D0,  0.11778D0,  0.09624D0,  0.07426D0,  0.05716D0,
     &     0.04417D0,  0.03445D0,  0.02716D0,  0.02168D0,  0.01765D0,
     &     0.01422D0,  0.01151D0,  0.00919D0,  0.00726D0,  0.00569D0,
     &     0.00437D0,  0.00323D0,  0.00233D0,  0.00177D0,  0.00113D0,
     &     0.00072D0,  0.00052D0,  0.00028D0,  0.00011D0,  0.00003D0,
     &     0.00002D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I, 4),I=1,49)/
     &     1.02892D0,  0.89240D0,  0.77327D0,  0.71073D0,  0.66929D0,
     &     0.63873D0,  0.55202D0,  0.47687D0,  0.43798D0,  0.41263D0,
     &     0.39503D0,  0.34528D0,  0.30287D0,  0.28033D0,  0.26505D0,
     &     0.25342D0,  0.23594D0,  0.21688D0,  0.19336D0,  0.17449D0,
     &     0.14328D0,  0.11746D0,  0.09586D0,  0.07403D0,  0.05716D0,
     &     0.04437D0,  0.03479D0,  0.02755D0,  0.02207D0,  0.01800D0,
     &     0.01451D0,  0.01172D0,  0.00935D0,  0.00736D0,  0.00577D0,
     &     0.00444D0,  0.00328D0,  0.00236D0,  0.00178D0,  0.00114D0,
     &     0.00075D0,  0.00052D0,  0.00029D0,  0.00011D0,  0.00004D0,
     &     0.00003D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I, 5),I=1,49)/
     &     1.08451D0,  0.94133D0,  0.81630D0,  0.75061D0,  0.70706D0,
     &     0.67493D0,  0.58367D0,  0.50437D0,  0.46318D0,  0.43623D0,
     &     0.41737D0,  0.36373D0,  0.31732D0,  0.29240D0,  0.27539D0,
     &     0.26243D0,  0.24295D0,  0.22186D0,  0.19623D0,  0.17608D0,
     &     0.14355D0,  0.11725D0,  0.09556D0,  0.07384D0,  0.05715D0,
     &     0.04453D0,  0.03504D0,  0.02784D0,  0.02236D0,  0.01824D0,
     &     0.01470D0,  0.01187D0,  0.00949D0,  0.00742D0,  0.00580D0,
     &     0.00445D0,  0.00328D0,  0.00235D0,  0.00175D0,  0.00116D0,
     &     0.00074D0,  0.00053D0,  0.00029D0,  0.00011D0,  0.00004D0,
     &     0.00002D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I, 6),I=1,49)/
     &     1.14357D0,  0.99242D0,  0.86045D0,  0.79114D0,  0.74518D0,
     &     0.71127D0,  0.61492D0,  0.53108D0,  0.48742D0,  0.45878D0,
     &     0.43857D0,  0.38094D0,  0.33056D0,  0.30333D0,  0.28470D0,
     &     0.27048D0,  0.24918D0,  0.22626D0,  0.19875D0,  0.17749D0,
     &     0.14383D0,  0.11711D0,  0.09533D0,  0.07370D0,  0.05713D0,
     &     0.04464D0,  0.03521D0,  0.02805D0,  0.02256D0,  0.01839D0,
     &     0.01482D0,  0.01197D0,  0.00955D0,  0.00745D0,  0.00580D0,
     &     0.00443D0,  0.00326D0,  0.00233D0,  0.00174D0,  0.00116D0,
     &     0.00074D0,  0.00053D0,  0.00029D0,  0.00011D0,  0.00004D0,
     &     0.00002D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I, 7),I=1,49)/
     &     1.21691D0,  1.05450D0,  0.91294D0,  0.83868D0,  0.78948D0,
     &     0.75319D0,  0.65015D0,  0.56049D0,  0.51374D0,  0.48302D0,
     &     0.46120D0,  0.39885D0,  0.34401D0,  0.31429D0,  0.29395D0,
     &     0.27845D0,  0.25529D0,  0.23055D0,  0.20123D0,  0.17890D0,
     &     0.14416D0,  0.11703D0,  0.09514D0,  0.07357D0,  0.05711D0,
     &     0.04471D0,  0.03532D0,  0.02818D0,  0.02268D0,  0.01846D0,
     &     0.01487D0,  0.01199D0,  0.00952D0,  0.00742D0,  0.00577D0,
     &     0.00441D0,  0.00322D0,  0.00229D0,  0.00172D0,  0.00114D0,
     &     0.00072D0,  0.00051D0,  0.00029D0,  0.00010D0,  0.00004D0,
     &     0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I, 8),I=1,49)/
     &     1.31000D0,  1.13230D0,  0.97784D0,  0.89699D0,  0.84348D0,
     &     0.80406D0,  0.69226D0,  0.59511D0,  0.54444D0,  0.51110D0,
     &     0.48726D0,  0.41913D0,  0.35898D0,  0.32638D0,  0.30408D0,
     &     0.28713D0,  0.26192D0,  0.23518D0,  0.20389D0,  0.18042D0,
     &     0.14454D0,  0.11697D0,  0.09497D0,  0.07342D0,  0.05705D0,
     &     0.04474D0,  0.03539D0,  0.02827D0,  0.02275D0,  0.01851D0,
     &     0.01488D0,  0.01197D0,  0.00947D0,  0.00737D0,  0.00571D0,
     &     0.00437D0,  0.00318D0,  0.00224D0,  0.00169D0,  0.00111D0,
     &     0.00070D0,  0.00049D0,  0.00029D0,  0.00010D0,  0.00004D0,
     &     0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I, 9),I=1,49)/
     &     1.40457D0,  1.21051D0,  1.04237D0,  0.95458D0,  0.89657D0,
     &     0.85387D0,  0.73299D0,  0.62815D0,  0.57350D0,  0.53752D0,
     &     0.51167D0,  0.43783D0,  0.37258D0,  0.33726D0,  0.31316D0,
     &     0.29488D0,  0.26778D0,  0.23925D0,  0.20624D0,  0.18177D0,
     &     0.14489D0,  0.11694D0,  0.09483D0,  0.07330D0,  0.05698D0,
     &     0.04474D0,  0.03543D0,  0.02831D0,  0.02277D0,  0.01852D0,
     &     0.01487D0,  0.01192D0,  0.00942D0,  0.00732D0,  0.00564D0,
     &     0.00433D0,  0.00313D0,  0.00219D0,  0.00166D0,  0.00109D0,
     &     0.00068D0,  0.00049D0,  0.00028D0,  0.00010D0,  0.00003D0,
     &     0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I,10),I=1,49)/
     &     1.51092D0,  1.29750D0,  1.11331D0,  1.01744D0,  0.95421D0,
     &     0.90772D0,  0.77643D0,  0.66288D0,  0.60378D0,  0.56488D0,
     &     0.53682D0,  0.45681D0,  0.38616D0,  0.34803D0,  0.32208D0,
     &     0.30246D0,  0.27350D0,  0.24321D0,  0.20851D0,  0.18308D0,
     &     0.14525D0,  0.11692D0,  0.09469D0,  0.07316D0,  0.05689D0,
     &     0.04470D0,  0.03541D0,  0.02828D0,  0.02274D0,  0.01846D0,
     &     0.01479D0,  0.01184D0,  0.00933D0,  0.00722D0,  0.00556D0,
     &     0.00426D0,  0.00307D0,  0.00215D0,  0.00161D0,  0.00106D0,
     &     0.00067D0,  0.00048D0,  0.00027D0,  0.00010D0,  0.00003D0,
     &     0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I,11),I=1,49)/
     &     1.60472D0,  1.37368D0,  1.17498D0,  1.07183D0,  1.00391D0,
     &     0.95405D0,  0.81348D0,  0.69224D0,  0.62923D0,  0.58777D0,
     &     0.55781D0,  0.47247D0,  0.39725D0,  0.35677D0,  0.32928D0,
     &     0.30856D0,  0.27807D0,  0.24637D0,  0.21032D0,  0.18413D0,
     &     0.14554D0,  0.11692D0,  0.09459D0,  0.07304D0,  0.05681D0,
     &     0.04465D0,  0.03537D0,  0.02823D0,  0.02270D0,  0.01839D0,
     &     0.01471D0,  0.01176D0,  0.00923D0,  0.00712D0,  0.00549D0,
     &     0.00419D0,  0.00301D0,  0.00213D0,  0.00157D0,  0.00105D0,
     &     0.00065D0,  0.00047D0,  0.00027D0,  0.00010D0,  0.00004D0,
     &     0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I,12),I=1,49)/
     &     1.83637D0,  1.55987D0,  1.32404D0,  1.20242D0,  1.12267D0,
     &     1.06429D0,  0.90056D0,  0.76032D0,  0.68777D0,  0.64012D0,
     &     0.60555D0,  0.50757D0,  0.42172D0,  0.37588D0,  0.34496D0,
     &     0.32177D0,  0.28792D0,  0.25312D0,  0.21417D0,  0.18636D0,
     &     0.14617D0,  0.11691D0,  0.09435D0,  0.07276D0,  0.05658D0,
     &     0.04447D0,  0.03521D0,  0.02807D0,  0.02254D0,  0.01819D0,
     &     0.01452D0,  0.01154D0,  0.00905D0,  0.00695D0,  0.00533D0,
     &     0.00404D0,  0.00292D0,  0.00205D0,  0.00149D0,  0.00100D0,
     &     0.00062D0,  0.00045D0,  0.00024D0,  0.00010D0,  0.00003D0,
     &     0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I,13),I=1,49)/
     &     2.07152D0,  1.74663D0,  1.47172D0,  1.33085D0,  1.23884D0,
     &     1.17167D0,  0.98420D0,  0.82476D0,  0.74268D0,  0.68890D0,
     &     0.64981D0,  0.53955D0,  0.44363D0,  0.39281D0,  0.35874D0,
     &     0.33333D0,  0.29647D0,  0.25893D0,  0.21746D0,  0.18826D0,
     &     0.14670D0,  0.11688D0,  0.09412D0,  0.07248D0,  0.05632D0,
     &     0.04424D0,  0.03500D0,  0.02787D0,  0.02234D0,  0.01798D0,
     &     0.01431D0,  0.01132D0,  0.00886D0,  0.00679D0,  0.00517D0,
     &     0.00390D0,  0.00284D0,  0.00195D0,  0.00143D0,  0.00095D0,
     &     0.00059D0,  0.00043D0,  0.00023D0,  0.00009D0,  0.00002D0,
     &     0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I,14),I=1,49)/
     &     2.37643D0,  1.98603D0,  1.65879D0,  1.49235D0,  1.38415D0,
     &     1.30543D0,  1.08702D0,  0.90288D0,  0.80867D0,  0.74716D0,
     &     0.70240D0,  0.57696D0,  0.46881D0,  0.41209D0,  0.37432D0,
     &     0.34632D0,  0.30599D0,  0.26535D0,  0.22106D0,  0.19032D0,
     &     0.14723D0,  0.11682D0,  0.09381D0,  0.07211D0,  0.05596D0,
     &     0.04392D0,  0.03471D0,  0.02757D0,  0.02204D0,  0.01767D0,
     &     0.01400D0,  0.01105D0,  0.00862D0,  0.00657D0,  0.00496D0,
     &     0.00374D0,  0.00270D0,  0.00182D0,  0.00137D0,  0.00090D0,
     &     0.00057D0,  0.00039D0,  0.00023D0,  0.00007D0,  0.00002D0,
     &     0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I,15),I=1,49)/
     &     2.74566D0,  2.27231D0,  1.87960D0,  1.68150D0,  1.55338D0,
     &     1.46052D0,  1.20454D0,  0.99082D0,  0.88227D0,  0.81170D0,
     &     0.76034D0,  0.61745D0,  0.49560D0,  0.43237D0,  0.39059D0,
     &     0.35980D0,  0.31580D0,  0.27191D0,  0.22470D0,  0.19238D0,
     &     0.14774D0,  0.11669D0,  0.09344D0,  0.07165D0,  0.05549D0,
     &     0.04347D0,  0.03429D0,  0.02720D0,  0.02166D0,  0.01729D0,
     &     0.01366D0,  0.01073D0,  0.00832D0,  0.00636D0,  0.00476D0,
     &     0.00357D0,  0.00255D0,  0.00175D0,  0.00131D0,  0.00086D0,
     &     0.00052D0,  0.00037D0,  0.00021D0,  0.00007D0,  0.00002D0,
     &     0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I,16),I=1,49)/
     &     3.12622D0,  2.56414D0,  2.10216D0,  1.87087D0,  1.72199D0,
     &     1.61445D0,  1.31978D0,  1.07596D0,  0.95298D0,  0.87335D0,
     &     0.81544D0,  0.65540D0,  0.52031D0,  0.45090D0,  0.40535D0,
     &     0.37197D0,  0.32458D0,  0.27772D0,  0.22787D0,  0.19414D0,
     &     0.14813D0,  0.11651D0,  0.09303D0,  0.07117D0,  0.05501D0,
     &     0.04302D0,  0.03385D0,  0.02678D0,  0.02128D0,  0.01692D0,
     &     0.01332D0,  0.01043D0,  0.00806D0,  0.00611D0,  0.00459D0,
     &     0.00341D0,  0.00242D0,  0.00166D0,  0.00123D0,  0.00082D0,
     &     0.00050D0,  0.00034D0,  0.00020D0,  0.00006D0,  0.00003D0,
     &     0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I,17),I=1,49)/
     &     3.55799D0,  2.89188D0,  2.34954D0,  2.08007D0,  1.90742D0,
     &     1.78316D0,  1.44470D0,  1.16721D0,  1.02825D0,  0.93863D0,
     &     0.87356D0,  0.69490D0,  0.54567D0,  0.46976D0,  0.42028D0,
     &     0.38422D0,  0.33334D0,  0.28346D0,  0.23097D0,  0.19583D0,
     &     0.14845D0,  0.11627D0,  0.09257D0,  0.07063D0,  0.05448D0,
     &     0.04252D0,  0.03337D0,  0.02631D0,  0.02087D0,  0.01652D0,
     &     0.01297D0,  0.01012D0,  0.00778D0,  0.00585D0,  0.00440D0,
     &     0.00326D0,  0.00231D0,  0.00157D0,  0.00115D0,  0.00076D0,
     &     0.00047D0,  0.00031D0,  0.00019D0,  0.00006D0,  0.00003D0,
     &     0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I,18),I=1,49)/
     &     3.95423D0,  3.18985D0,  2.57232D0,  2.26740D0,  2.07281D0,
     &     1.93314D0,  1.55464D0,  1.24668D0,  1.09337D0,  0.99486D0,
     &     0.92342D0,  0.72838D0,  0.56689D0,  0.48541D0,  0.43260D0,
     &     0.39429D0,  0.34049D0,  0.28810D0,  0.23344D0,  0.19715D0,
     &     0.14866D0,  0.11602D0,  0.09214D0,  0.07013D0,  0.05399D0,
     &     0.04205D0,  0.03295D0,  0.02591D0,  0.02050D0,  0.01618D0,
     &     0.01266D0,  0.00984D0,  0.00753D0,  0.00565D0,  0.00424D0,
     &     0.00314D0,  0.00221D0,  0.00150D0,  0.00109D0,  0.00072D0,
     &     0.00043D0,  0.00030D0,  0.00018D0,  0.00006D0,  0.00002D0,
     &     0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I,19),I=1,49)/
     &     4.48113D0,  3.58253D0,  2.86323D0,  2.51070D0,  2.28676D0,
     &     2.12659D0,  1.69508D0,  1.34718D0,  1.17523D0,  1.06522D0,
     &     0.98559D0,  0.76963D0,  0.59272D0,  0.50431D0,  0.44739D0,
     &     0.40630D0,  0.34895D0,  0.29355D0,  0.23628D0,  0.19863D0,
     &     0.14882D0,  0.11566D0,  0.09156D0,  0.06947D0,  0.05334D0,
     &     0.04144D0,  0.03238D0,  0.02540D0,  0.02000D0,  0.01574D0,
     &     0.01227D0,  0.00950D0,  0.00724D0,  0.00541D0,  0.00404D0,
     &     0.00298D0,  0.00211D0,  0.00142D0,  0.00103D0,  0.00067D0,
     &     0.00041D0,  0.00028D0,  0.00016D0,  0.00006D0,  0.00002D0,
     &     0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I,20),I=1,49)/
     &     4.99499D0,  3.96212D0,  3.14196D0,  2.74258D0,  2.48991D0,
     &     2.30973D0,  1.82681D0,  1.44056D0,  1.25085D0,  1.12995D0,
     &     1.04258D0,  0.80704D0,  0.61586D0,  0.52113D0,  0.46048D0,
     &     0.41689D0,  0.35636D0,  0.29827D0,  0.23871D0,  0.19986D0,
     &     0.14892D0,  0.11531D0,  0.09101D0,  0.06887D0,  0.05276D0,
     &     0.04087D0,  0.03186D0,  0.02494D0,  0.01954D0,  0.01534D0,
     &     0.01192D0,  0.00921D0,  0.00699D0,  0.00520D0,  0.00387D0,
     &     0.00284D0,  0.00201D0,  0.00135D0,  0.00099D0,  0.00063D0,
     &     0.00039D0,  0.00027D0,  0.00014D0,  0.00005D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I,21),I=1,49)/
     &     5.50061D0,  4.33261D0,  3.41176D0,  2.96594D0,  2.68491D0,
     &     2.48503D0,  1.95181D0,  1.52837D0,  1.32157D0,  1.19023D0,
     &     1.09549D0,  0.84140D0,  0.63686D0,  0.53627D0,  0.47219D0,
     &     0.42632D0,  0.36291D0,  0.30239D0,  0.24078D0,  0.20086D0,
     &     0.14892D0,  0.11489D0,  0.09045D0,  0.06826D0,  0.05215D0,
     &     0.04031D0,  0.03135D0,  0.02446D0,  0.01914D0,  0.01497D0,
     &     0.01162D0,  0.00892D0,  0.00678D0,  0.00502D0,  0.00373D0,
     &     0.00273D0,  0.00191D0,  0.00128D0,  0.00093D0,  0.00060D0,
     &     0.00037D0,  0.00026D0,  0.00014D0,  0.00005D0,  0.00001D0,
     &     0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I,22),I=1,49)/
     &     6.19859D0,  4.83989D0,  3.77815D0,  3.26780D0,  2.94753D0,
     &     2.72049D0,  2.11828D0,  1.64429D0,  1.41443D0,  1.26909D0,
     &     1.16448D0,  0.88574D0,  0.66367D0,  0.55547D0,  0.48697D0,
     &     0.43816D0,  0.37106D0,  0.30748D0,  0.24329D0,  0.20204D0,
     &     0.14885D0,  0.11433D0,  0.08969D0,  0.06745D0,  0.05136D0,
     &     0.03959D0,  0.03069D0,  0.02386D0,  0.01861D0,  0.01451D0,
     &     0.01121D0,  0.00856D0,  0.00649D0,  0.00480D0,  0.00355D0,
     &     0.00258D0,  0.00180D0,  0.00120D0,  0.00087D0,  0.00057D0,
     &     0.00034D0,  0.00024D0,  0.00013D0,  0.00004D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I,23),I=1,49)/
     &     6.91462D0,  5.35579D0,  4.14753D0,  3.57056D0,  3.20996D0,
     &     2.95511D0,  2.28266D0,  1.75769D0,  1.50477D0,  1.34548D0,
     &     1.23109D0,  0.92809D0,  0.68898D0,  0.57345D0,  0.50073D0,
     &     0.44914D0,  0.37855D0,  0.31211D0,  0.24552D0,  0.20305D0,
     &     0.14871D0,  0.11376D0,  0.08894D0,  0.06666D0,  0.05060D0,
     &     0.03890D0,  0.03007D0,  0.02332D0,  0.01811D0,  0.01408D0,
     &     0.01081D0,  0.00824D0,  0.00620D0,  0.00458D0,  0.00337D0,
     &     0.00246D0,  0.00171D0,  0.00112D0,  0.00082D0,  0.00053D0,
     &     0.00032D0,  0.00022D0,  0.00013D0,  0.00004D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I,24),I=1,49)/
     &     7.62855D0,  5.86601D0,  4.50985D0,  3.86607D0,  3.46522D0,
     &     3.18268D0,  2.44073D0,  1.86575D0,  1.59038D0,  1.41758D0,
     &     1.29375D0,  0.96750D0,  0.71223D0,  0.58984D0,  0.51319D0,
     &     0.45902D0,  0.38523D0,  0.31616D0,  0.24739D0,  0.20383D0,
     &     0.14846D0,  0.11312D0,  0.08817D0,  0.06586D0,  0.04986D0,
     &     0.03821D0,  0.02946D0,  0.02275D0,  0.01763D0,  0.01365D0,
     &     0.01046D0,  0.00797D0,  0.00597D0,  0.00439D0,  0.00323D0,
     &     0.00235D0,  0.00162D0,  0.00107D0,  0.00078D0,  0.00051D0,
     &     0.00031D0,  0.00021D0,  0.00012D0,  0.00003D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I,25),I=1,49)/
     &     8.39955D0,  6.41302D0,  4.89545D0,  4.17923D0,  3.73489D0,
     &     3.42253D0,  2.60607D0,  1.97793D0,  1.67884D0,  1.49183D0,
     &     1.35810D0,  1.00761D0,  0.73567D0,  0.60627D0,  0.52562D0,
     &     0.46884D0,  0.39183D0,  0.32012D0,  0.24919D0,  0.20455D0,
     &     0.14818D0,  0.11246D0,  0.08739D0,  0.06506D0,  0.04911D0,
     &     0.03752D0,  0.02885D0,  0.02220D0,  0.01716D0,  0.01324D0,
     &     0.01012D0,  0.00771D0,  0.00575D0,  0.00422D0,  0.00309D0,
     &     0.00225D0,  0.00154D0,  0.00103D0,  0.00074D0,  0.00048D0,
     &     0.00030D0,  0.00020D0,  0.00010D0,  0.00002D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I,26),I=1,49)/
     &     9.19737D0,  6.97494D0,  5.28863D0,  4.49714D0,  4.00779D0,
     &     3.66466D0,  2.77170D0,  2.08938D0,  1.76629D0,  1.56497D0,
     &     1.42130D0,  1.04661D0,  0.75821D0,  0.62194D0,  0.53740D0,
     &     0.47810D0,  0.39797D0,  0.32376D0,  0.25078D0,  0.20510D0,
     &     0.14782D0,  0.11174D0,  0.08657D0,  0.06424D0,  0.04835D0,
     &     0.03684D0,  0.02824D0,  0.02168D0,  0.01670D0,  0.01284D0,
     &     0.00977D0,  0.00742D0,  0.00552D0,  0.00404D0,  0.00296D0,
     &     0.00214D0,  0.00146D0,  0.00097D0,  0.00071D0,  0.00044D0,
     &     0.00028D0,  0.00017D0,  0.00010D0,  0.00003D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I,27),I=1,49)/
     &    10.00116D0,  7.53729D0,  5.67949D0,  4.81192D0,  4.27724D0,
     &     3.90320D0,  2.93374D0,  2.19765D0,  1.85088D0,  1.63549D0,
     &     1.48207D0,  1.08380D0,  0.77950D0,  0.63664D0,  0.54841D0,
     &     0.48671D0,  0.40364D0,  0.32707D0,  0.25218D0,  0.20556D0,
     &     0.14742D0,  0.11104D0,  0.08576D0,  0.06344D0,  0.04762D0,
     &     0.03619D0,  0.02766D0,  0.02119D0,  0.01627D0,  0.01248D0,
     &     0.00947D0,  0.00716D0,  0.00532D0,  0.00389D0,  0.00284D0,
     &     0.00205D0,  0.00139D0,  0.00092D0,  0.00068D0,  0.00042D0,
     &     0.00026D0,  0.00016D0,  0.00009D0,  0.00003D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I,28),I=1,49)/
     &    10.79744D0,  8.09092D0,  6.06186D0,  5.11871D0,  4.53915D0,
     &     4.13458D0,  3.08987D0,  2.30126D0,  1.93148D0,  1.70248D0,
     &     1.53966D0,  1.11875D0,  0.79931D0,  0.65024D0,  0.55853D0,
     &     0.49459D0,  0.40879D0,  0.33003D0,  0.25337D0,  0.20589D0,
     &     0.14698D0,  0.11033D0,  0.08498D0,  0.06267D0,  0.04691D0,
     &     0.03557D0,  0.02711D0,  0.02071D0,  0.01586D0,  0.01214D0,
     &     0.00920D0,  0.00692D0,  0.00514D0,  0.00376D0,  0.00272D0,
     &     0.00196D0,  0.00133D0,  0.00087D0,  0.00064D0,  0.00040D0,
     &     0.00025D0,  0.00016D0,  0.00009D0,  0.00003D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I,29),I=1,49)/
     &    11.63983D0,  8.67317D0,  6.46161D0,  5.43834D0,  4.81133D0,
     &     4.37457D0,  3.25082D0,  2.40738D0,  2.01373D0,  1.77063D0,
     &     1.59811D0,  1.15395D0,  0.81909D0,  0.66374D0,  0.56853D0,
     &     0.50235D0,  0.41381D0,  0.33288D0,  0.25448D0,  0.20616D0,
     &     0.14650D0,  0.10959D0,  0.08417D0,  0.06189D0,  0.04620D0,
     &     0.03495D0,  0.02656D0,  0.02024D0,  0.01545D0,  0.01181D0,
     &     0.00893D0,  0.00670D0,  0.00496D0,  0.00362D0,  0.00261D0,
     &     0.00187D0,  0.00127D0,  0.00083D0,  0.00060D0,  0.00038D0,
     &     0.00023D0,  0.00015D0,  0.00008D0,  0.00003D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I,30),I=1,49)/
     &    12.50504D0,  9.26774D0,  6.86743D0,  5.76168D0,  5.08599D0,
     &     4.61626D0,  3.41191D0,  2.51292D0,  2.09519D0,  1.83795D0,
     &     1.65570D0,  1.18836D0,  0.83825D0,  0.67674D0,  0.57810D0,
     &     0.50972D0,  0.41855D0,  0.33552D0,  0.25546D0,  0.20633D0,
     &     0.14597D0,  0.10882D0,  0.08334D0,  0.06111D0,  0.04550D0,
     &     0.03432D0,  0.02602D0,  0.01977D0,  0.01507D0,  0.01148D0,
     &     0.00865D0,  0.00649D0,  0.00478D0,  0.00347D0,  0.00250D0,
     &     0.00177D0,  0.00121D0,  0.00078D0,  0.00056D0,  0.00036D0,
     &     0.00022D0,  0.00014D0,  0.00008D0,  0.00002D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I,31),I=1,49)/
     &    13.36928D0,  9.85846D0,  7.26844D0,  6.08018D0,  5.35592D0,
     &     4.85338D0,  3.56907D0,  2.61529D0,  2.17393D0,  1.90285D0,
     &     1.71111D0,  1.22123D0,  0.85642D0,  0.68899D0,  0.58709D0,
     &     0.51663D0,  0.42295D0,  0.33794D0,  0.25632D0,  0.20644D0,
     &     0.14544D0,  0.10808D0,  0.08256D0,  0.06036D0,  0.04483D0,
     &     0.03373D0,  0.02551D0,  0.01933D0,  0.01470D0,  0.01117D0,
     &     0.00840D0,  0.00629D0,  0.00462D0,  0.00334D0,  0.00240D0,
     &     0.00170D0,  0.00116D0,  0.00075D0,  0.00053D0,  0.00034D0,
     &     0.00021D0,  0.00014D0,  0.00007D0,  0.00002D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I,32),I=1,49)/
     &    14.21204D0, 10.43149D0,  7.65538D0,  6.38652D0,  5.61495D0,
     &     5.08051D0,  3.71876D0,  2.71221D0,  2.24821D0,  1.96390D0,
     &     1.76311D0,  1.25185D0,  0.87317D0,  0.70020D0,  0.59526D0,
     &     0.52288D0,  0.42687D0,  0.34005D0,  0.25702D0,  0.20645D0,
     &     0.14487D0,  0.10733D0,  0.08179D0,  0.05963D0,  0.04417D0,
     &     0.03317D0,  0.02503D0,  0.01893D0,  0.01436D0,  0.01089D0,
     &     0.00816D0,  0.00610D0,  0.00447D0,  0.00322D0,  0.00232D0,
     &     0.00164D0,  0.00111D0,  0.00072D0,  0.00051D0,  0.00033D0,
     &     0.00020D0,  0.00013D0,  0.00007D0,  0.00002D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I,33),I=1,49)/
     &    15.10980D0, 11.03912D0,  8.06381D0,  6.70901D0,  5.88712D0,
     &     5.31881D0,  3.87508D0,  2.81294D0,  2.32519D0,  2.02704D0,
     &     1.81681D0,  1.28330D0,  0.89029D0,  0.71163D0,  0.60357D0,
     &     0.52922D0,  0.43085D0,  0.34218D0,  0.25771D0,  0.20646D0,
     &     0.14430D0,  0.10659D0,  0.08103D0,  0.05890D0,  0.04353D0,
     &     0.03261D0,  0.02455D0,  0.01854D0,  0.01403D0,  0.01061D0,
     &     0.00794D0,  0.00591D0,  0.00432D0,  0.00310D0,  0.00224D0,
     &     0.00159D0,  0.00107D0,  0.00069D0,  0.00049D0,  0.00032D0,
     &     0.00019D0,  0.00012D0,  0.00006D0,  0.00002D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I,34),I=1,49)/
     &    16.00814D0, 11.64399D0,  8.46821D0,  7.02730D0,  6.15513D0,
     &     5.55303D0,  4.02783D0,  2.91076D0,  2.39965D0,  2.08793D0,
     &     1.86846D0,  1.31328D0,  0.90643D0,  0.72231D0,  0.61128D0,
     &     0.53505D0,  0.43443D0,  0.34403D0,  0.25822D0,  0.20634D0,
     &     0.14366D0,  0.10580D0,  0.08022D0,  0.05817D0,  0.04288D0,
     &     0.03206D0,  0.02408D0,  0.01814D0,  0.01369D0,  0.01034D0,
     &     0.00771D0,  0.00572D0,  0.00418D0,  0.00300D0,  0.00216D0,
     &     0.00152D0,  0.00103D0,  0.00065D0,  0.00048D0,  0.00031D0,
     &     0.00018D0,  0.00012D0,  0.00006D0,  0.00002D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I,35),I=1,49)/
     &    16.90871D0, 12.24779D0,  8.87019D0,  7.34290D0,  6.42039D0,
     &     5.78454D0,  4.17816D0,  3.00661D0,  2.47242D0,  2.14733D0,
     &     1.91876D0,  1.34235D0,  0.92199D0,  0.73258D0,  0.61867D0,
     &     0.54063D0,  0.43786D0,  0.34580D0,  0.25870D0,  0.20622D0,
     &     0.14305D0,  0.10506D0,  0.07947D0,  0.05749D0,  0.04228D0,
     &     0.03154D0,  0.02364D0,  0.01777D0,  0.01338D0,  0.01009D0,
     &     0.00750D0,  0.00555D0,  0.00406D0,  0.00290D0,  0.00208D0,
     &     0.00145D0,  0.00100D0,  0.00062D0,  0.00047D0,  0.00030D0,
     &     0.00017D0,  0.00012D0,  0.00005D0,  0.00002D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I,36),I=1,49)/
     &    17.78739D0, 12.83436D0,  9.25897D0,  7.64732D0,  6.67578D0,
     &     6.00710D0,  4.32199D0,  3.09786D0,  2.54148D0,  2.20357D0,
     &     1.96631D0,  1.36964D0,  0.93649D0,  0.74208D0,  0.62547D0,
     &     0.54573D0,  0.44096D0,  0.34736D0,  0.25907D0,  0.20605D0,
     &     0.14244D0,  0.10433D0,  0.07874D0,  0.05683D0,  0.04170D0,
     &     0.03105D0,  0.02321D0,  0.01741D0,  0.01309D0,  0.00985D0,
     &     0.00731D0,  0.00540D0,  0.00394D0,  0.00282D0,  0.00201D0,
     &     0.00140D0,  0.00096D0,  0.00060D0,  0.00045D0,  0.00029D0,
     &     0.00016D0,  0.00012D0,  0.00005D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I,37),I=1,49)/
     &    18.69798D0, 13.43965D0,  9.65843D0,  7.95932D0,  6.93703D0,
     &     6.23444D0,  4.46823D0,  3.19019D0,  2.61115D0,  2.26017D0,
     &     2.01407D0,  1.39688D0,  0.95084D0,  0.75143D0,  0.63213D0,
     &     0.55070D0,  0.44393D0,  0.34881D0,  0.25937D0,  0.20581D0,
     &     0.14178D0,  0.10356D0,  0.07799D0,  0.05614D0,  0.04110D0,
     &     0.03053D0,  0.02278D0,  0.01705D0,  0.01280D0,  0.00961D0,
     &     0.00713D0,  0.00525D0,  0.00382D0,  0.00273D0,  0.00195D0,
     &     0.00136D0,  0.00092D0,  0.00058D0,  0.00043D0,  0.00028D0,
     &     0.00015D0,  0.00011D0,  0.00005D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,4,I,38),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I, 1),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I, 2),I=1,49)/
     &     0.00003D0,  0.00002D0,  0.00002D0,  0.00002D0,  0.00002D0,
     &     0.00002D0,  0.00002D0,  0.00002D0,  0.00002D0,  0.00002D0,
     &     0.00002D0,  0.00002D0,  0.00002D0,  0.00002D0,  0.00002D0,
     &     0.00002D0,  0.00002D0,  0.00001D0,  0.00001D0,  0.00001D0,
     &     0.00001D0,  0.00001D0,  0.00001D0,  0.00001D0,  0.00001D0,
     &     0.00001D0,  0.00001D0,  0.00001D0,  0.00001D0,  0.00001D0,
     &     0.00001D0,  0.00001D0,  0.00001D0,  0.00001D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I, 3),I=1,49)/
     &     0.02821D0,  0.02609D0,  0.02411D0,  0.02301D0,  0.02226D0,
     &     0.02169D0,  0.01996D0,  0.01827D0,  0.01727D0,  0.01654D0,
     &     0.01595D0,  0.01400D0,  0.01174D0,  0.01027D0,  0.00917D0,
     &     0.00829D0,  0.00696D0,  0.00558D0,  0.00415D0,  0.00329D0,
     &     0.00239D0,  0.00200D0,  0.00182D0,  0.00170D0,  0.00161D0,
     &     0.00151D0,  0.00140D0,  0.00127D0,  0.00113D0,  0.00099D0,
     &     0.00084D0,  0.00071D0,  0.00058D0,  0.00047D0,  0.00038D0,
     &     0.00029D0,  0.00023D0,  0.00017D0,  0.00013D0,  0.00009D0,
     &     0.00006D0,  0.00004D0,  0.00003D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I, 4),I=1,49)/
     &     0.07423D0,  0.06794D0,  0.06215D0,  0.05896D0,  0.05679D0,
     &     0.05514D0,  0.05023D0,  0.04550D0,  0.04276D0,  0.04079D0,
     &     0.03919D0,  0.03404D0,  0.02827D0,  0.02460D0,  0.02188D0,
     &     0.01974D0,  0.01650D0,  0.01320D0,  0.00980D0,  0.00778D0,
     &     0.00567D0,  0.00475D0,  0.00430D0,  0.00399D0,  0.00376D0,
     &     0.00351D0,  0.00322D0,  0.00290D0,  0.00256D0,  0.00223D0,
     &     0.00189D0,  0.00158D0,  0.00129D0,  0.00104D0,  0.00083D0,
     &     0.00064D0,  0.00049D0,  0.00037D0,  0.00027D0,  0.00020D0,
     &     0.00014D0,  0.00009D0,  0.00006D0,  0.00002D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I, 5),I=1,49)/
     &     0.13335D0,  0.12014D0,  0.10818D0,  0.10170D0,  0.09731D0,
     &     0.09401D0,  0.08430D0,  0.07519D0,  0.07001D0,  0.06635D0,
     &     0.06344D0,  0.05426D0,  0.04442D0,  0.03837D0,  0.03396D0,
     &     0.03053D0,  0.02541D0,  0.02025D0,  0.01501D0,  0.01192D0,
     &     0.00870D0,  0.00726D0,  0.00654D0,  0.00602D0,  0.00561D0,
     &     0.00519D0,  0.00472D0,  0.00422D0,  0.00370D0,  0.00319D0,
     &     0.00269D0,  0.00224D0,  0.00183D0,  0.00146D0,  0.00116D0,
     &     0.00089D0,  0.00068D0,  0.00051D0,  0.00038D0,  0.00027D0,
     &     0.00019D0,  0.00013D0,  0.00008D0,  0.00003D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I, 6),I=1,49)/
     &     0.20163D0,  0.17920D0,  0.15918D0,  0.14846D0,  0.14125D0,
     &     0.13587D0,  0.12018D0,  0.10574D0,  0.09768D0,  0.09205D0,
     &     0.08763D0,  0.07395D0,  0.05979D0,  0.05130D0,  0.04521D0,
     &     0.04052D0,  0.03360D0,  0.02669D0,  0.01976D0,  0.01569D0,
     &     0.01145D0,  0.00954D0,  0.00855D0,  0.00780D0,  0.00720D0,
     &     0.00661D0,  0.00597D0,  0.00530D0,  0.00461D0,  0.00396D0,
     &     0.00333D0,  0.00275D0,  0.00223D0,  0.00178D0,  0.00140D0,
     &     0.00108D0,  0.00082D0,  0.00061D0,  0.00045D0,  0.00032D0,
     &     0.00022D0,  0.00015D0,  0.00010D0,  0.00003D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I, 7),I=1,49)/
     &     0.27774D0,  0.24395D0,  0.21415D0,  0.19835D0,  0.18780D0,
     &     0.17996D0,  0.15730D0,  0.13677D0,  0.12547D0,  0.11766D0,
     &     0.11157D0,  0.09303D0,  0.07437D0,  0.06341D0,  0.05566D0,
     &     0.04974D0,  0.04109D0,  0.03255D0,  0.02405D0,  0.01909D0,
     &     0.01394D0,  0.01158D0,  0.01033D0,  0.00936D0,  0.00857D0,
     &     0.00780D0,  0.00699D0,  0.00616D0,  0.00533D0,  0.00455D0,
     &     0.00380D0,  0.00313D0,  0.00253D0,  0.00201D0,  0.00157D0,
     &     0.00121D0,  0.00091D0,  0.00068D0,  0.00050D0,  0.00036D0,
     &     0.00024D0,  0.00016D0,  0.00011D0,  0.00003D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I, 8),I=1,49)/
     &     0.37644D0,  0.32674D0,  0.28346D0,  0.26073D0,  0.24565D0,
     &     0.23449D0,  0.20256D0,  0.17404D0,  0.15854D0,  0.14793D0,
     &     0.13972D0,  0.11511D0,  0.09095D0,  0.07707D0,  0.06738D0,
     &     0.06004D0,  0.04941D0,  0.03901D0,  0.02877D0,  0.02283D0,
     &     0.01667D0,  0.01381D0,  0.01226D0,  0.01101D0,  0.01000D0,
     &     0.00902D0,  0.00803D0,  0.00703D0,  0.00604D0,  0.00513D0,
     &     0.00426D0,  0.00349D0,  0.00280D0,  0.00222D0,  0.00173D0,
     &     0.00132D0,  0.00099D0,  0.00074D0,  0.00054D0,  0.00039D0,
     &     0.00026D0,  0.00017D0,  0.00011D0,  0.00003D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I, 9),I=1,49)/
     &     0.47784D0,  0.41072D0,  0.35284D0,  0.32270D0,  0.30279D0,
     &     0.28813D0,  0.24646D0,  0.20968D0,  0.18991D0,  0.17647D0,
     &     0.16612D0,  0.13548D0,  0.10603D0,  0.08938D0,  0.07787D0,
     &     0.06921D0,  0.05678D0,  0.04472D0,  0.03292D0,  0.02612D0,
     &     0.01906D0,  0.01575D0,  0.01392D0,  0.01241D0,  0.01119D0,
     &     0.01003D0,  0.00887D0,  0.00772D0,  0.00660D0,  0.00557D0,
     &     0.00461D0,  0.00376D0,  0.00301D0,  0.00237D0,  0.00184D0,
     &     0.00140D0,  0.00105D0,  0.00077D0,  0.00057D0,  0.00041D0,
     &     0.00027D0,  0.00018D0,  0.00011D0,  0.00003D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I,10),I=1,49)/
     &     0.58781D0,  0.50078D0,  0.42641D0,  0.38796D0,  0.36269D0,
     &     0.34414D0,  0.29176D0,  0.24601D0,  0.22164D0,  0.20518D0,
     &     0.19257D0,  0.15561D0,  0.12070D0,  0.10126D0,  0.08794D0,
     &     0.07799D0,  0.06379D0,  0.05011D0,  0.03684D0,  0.02922D0,
     &     0.02130D0,  0.01755D0,  0.01544D0,  0.01368D0,  0.01225D0,
     &     0.01090D0,  0.00959D0,  0.00830D0,  0.00706D0,  0.00594D0,
     &     0.00489D0,  0.00397D0,  0.00316D0,  0.00248D0,  0.00192D0,
     &     0.00146D0,  0.00109D0,  0.00080D0,  0.00059D0,  0.00042D0,
     &     0.00027D0,  0.00018D0,  0.00012D0,  0.00003D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I,11),I=1,49)/
     &     0.68602D0,  0.58051D0,  0.49095D0,  0.44491D0,  0.41476D0,
     &     0.39269D0,  0.33066D0,  0.27690D0,  0.24847D0,  0.22936D0,
     &     0.21477D0,  0.17232D0,  0.13275D0,  0.11095D0,  0.09613D0,
     &     0.08510D0,  0.06944D0,  0.05445D0,  0.03997D0,  0.03169D0,
     &     0.02308D0,  0.01898D0,  0.01663D0,  0.01466D0,  0.01306D0,
     &     0.01157D0,  0.01013D0,  0.00872D0,  0.00740D0,  0.00620D0,
     &     0.00508D0,  0.00411D0,  0.00327D0,  0.00256D0,  0.00197D0,
     &     0.00149D0,  0.00111D0,  0.00081D0,  0.00060D0,  0.00042D0,
     &     0.00028D0,  0.00018D0,  0.00012D0,  0.00003D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I,12),I=1,49)/
     &     0.92772D0,  0.77438D0,  0.64603D0,  0.58078D0,  0.53835D0,
     &     0.50746D0,  0.42147D0,  0.34811D0,  0.30983D0,  0.28433D0,
     &     0.26501D0,  0.20960D0,  0.15924D0,  0.13208D0,  0.11385D0,
     &     0.10043D0,  0.08155D0,  0.06370D0,  0.04663D0,  0.03692D0,
     &     0.02683D0,  0.02195D0,  0.01909D0,  0.01665D0,  0.01467D0,
     &     0.01287D0,  0.01115D0,  0.00952D0,  0.00801D0,  0.00666D0,
     &     0.00542D0,  0.00436D0,  0.00344D0,  0.00268D0,  0.00205D0,
     &     0.00155D0,  0.00115D0,  0.00083D0,  0.00061D0,  0.00043D0,
     &     0.00028D0,  0.00018D0,  0.00011D0,  0.00003D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I,13),I=1,49)/
     &     1.17595D0,  0.97076D0,  0.80093D0,  0.71538D0,  0.66007D0,
     &     0.61997D0,  0.50921D0,  0.41588D0,  0.36771D0,  0.33586D0,
     &     0.31184D0,  0.24377D0,  0.18310D0,  0.15092D0,  0.12956D0,
     &     0.11394D0,  0.09216D0,  0.07174D0,  0.05238D0,  0.04143D0,
     &     0.03003D0,  0.02446D0,  0.02114D0,  0.01827D0,  0.01595D0,
     &     0.01387D0,  0.01193D0,  0.01011D0,  0.00845D0,  0.00698D0,
     &     0.00565D0,  0.00451D0,  0.00355D0,  0.00275D0,  0.00209D0,
     &     0.00157D0,  0.00116D0,  0.00084D0,  0.00061D0,  0.00043D0,
     &     0.00028D0,  0.00018D0,  0.00011D0,  0.00003D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I,14),I=1,49)/
     &     1.49839D0,  1.22261D0,  0.99703D0,  0.88447D0,  0.81213D0,
     &     0.75993D0,  0.61688D0,  0.49791D0,  0.43718D0,  0.39731D0,
     &     0.36742D0,  0.28369D0,  0.21052D0,  0.17237D0,  0.14732D0,
     &     0.12915D0,  0.10402D0,  0.08067D0,  0.05873D0,  0.04638D0,
     &     0.03352D0,  0.02715D0,  0.02331D0,  0.01995D0,  0.01725D0,
     &     0.01486D0,  0.01267D0,  0.01065D0,  0.00884D0,  0.00725D0,
     &     0.00583D0,  0.00463D0,  0.00362D0,  0.00279D0,  0.00211D0,
     &     0.00158D0,  0.00116D0,  0.00083D0,  0.00061D0,  0.00043D0,
     &     0.00027D0,  0.00018D0,  0.00011D0,  0.00003D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I,15),I=1,49)/
     &     1.87945D0,  1.51634D0,  1.22268D0,  1.07750D0,  0.98475D0,
     &     0.91809D0,  0.73686D0,  0.58798D0,  0.51279D0,  0.46377D0,
     &     0.42722D0,  0.32591D0,  0.23902D0,  0.19443D0,  0.16545D0,
     &     0.14459D0,  0.11596D0,  0.08960D0,  0.06503D0,  0.05127D0,
     &     0.03691D0,  0.02973D0,  0.02534D0,  0.02147D0,  0.01838D0,
     &     0.01569D0,  0.01327D0,  0.01107D0,  0.00912D0,  0.00743D0,
     &     0.00594D0,  0.00469D0,  0.00364D0,  0.00279D0,  0.00210D0,
     &     0.00156D0,  0.00114D0,  0.00082D0,  0.00059D0,  0.00041D0,
     &     0.00026D0,  0.00017D0,  0.00010D0,  0.00003D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I,16),I=1,49)/
     &     2.27429D0,  1.81716D0,  1.45106D0,  1.27151D0,  1.15736D0,
     &     1.07564D0,  0.85491D0,  0.67549D0,  0.58568D0,  0.52749D0,
     &     0.48429D0,  0.36563D0,  0.26542D0,  0.21469D0,  0.18200D0,
     &     0.15862D0,  0.12673D0,  0.09760D0,  0.07063D0,  0.05559D0,
     &     0.03988D0,  0.03195D0,  0.02705D0,  0.02273D0,  0.01930D0,
     &     0.01634D0,  0.01371D0,  0.01136D0,  0.00930D0,  0.00753D0,
     &     0.00599D0,  0.00470D0,  0.00364D0,  0.00277D0,  0.00208D0,
     &     0.00154D0,  0.00112D0,  0.00080D0,  0.00058D0,  0.00040D0,
     &     0.00025D0,  0.00016D0,  0.00010D0,  0.00003D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I,17),I=1,49)/
     &     2.72539D0,  2.15724D0,  1.70653D0,  1.48715D0,  1.34837D0,
     &     1.24937D0,  0.98364D0,  0.76983D0,  0.66373D0,  0.59537D0,
     &     0.54484D0,  0.40724D0,  0.29272D0,  0.23547D0,  0.19888D0,
     &     0.17287D0,  0.13761D0,  0.10564D0,  0.07622D0,  0.05987D0,
     &     0.04278D0,  0.03409D0,  0.02869D0,  0.02390D0,  0.02012D0,
     &     0.01691D0,  0.01408D0,  0.01159D0,  0.00943D0,  0.00759D0,
     &     0.00600D0,  0.00469D0,  0.00361D0,  0.00273D0,  0.00204D0,
     &     0.00151D0,  0.00109D0,  0.00078D0,  0.00056D0,  0.00039D0,
     &     0.00024D0,  0.00015D0,  0.00009D0,  0.00003D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I,18),I=1,49)/
     &     3.13641D0,  2.46418D0,  1.93488D0,  1.67881D0,  1.51744D0,
     &     1.40264D0,  1.09608D0,  0.85138D0,  0.73076D0,  0.65340D0,
     &     0.59642D0,  0.44225D0,  0.31539D0,  0.25259D0,  0.21272D0,
     &     0.18450D0,  0.14644D0,  0.11211D0,  0.08069D0,  0.06328D0,
     &     0.04506D0,  0.03575D0,  0.02993D0,  0.02476D0,  0.02070D0,
     &     0.01729D0,  0.01432D0,  0.01172D0,  0.00949D0,  0.00760D0,
     &     0.00598D0,  0.00466D0,  0.00357D0,  0.00269D0,  0.00201D0,
     &     0.00147D0,  0.00106D0,  0.00075D0,  0.00054D0,  0.00038D0,
     &     0.00023D0,  0.00015D0,  0.00009D0,  0.00003D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I,19),I=1,49)/
     &     3.68153D0,  2.86757D0,  2.23222D0,  1.92702D0,  1.73553D0,
     &     1.59976D0,  1.23927D0,  0.95419D0,  0.81477D0,  0.72581D0,
     &     0.66053D0,  0.48527D0,  0.34292D0,  0.27324D0,  0.22931D0,
     &     0.19839D0,  0.15691D0,  0.11975D0,  0.08593D0,  0.06725D0,
     &     0.04768D0,  0.03762D0,  0.03130D0,  0.02569D0,  0.02130D0,
     &     0.01766D0,  0.01453D0,  0.01182D0,  0.00951D0,  0.00757D0,
     &     0.00594D0,  0.00459D0,  0.00350D0,  0.00264D0,  0.00195D0,
     &     0.00143D0,  0.00103D0,  0.00072D0,  0.00052D0,  0.00036D0,
     &     0.00022D0,  0.00014D0,  0.00008D0,  0.00003D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I,20),I=1,49)/
     &     4.21665D0,  3.26014D0,  2.51906D0,  2.16522D0,  1.94405D0,
     &     1.78768D0,  1.37455D0,  1.05042D0,  0.89295D0,  0.79293D0,
     &     0.71977D0,  0.52460D0,  0.36780D0,  0.29178D0,  0.24415D0,
     &     0.21076D0,  0.16620D0,  0.12648D0,  0.09052D0,  0.07070D0,
     &     0.04993D0,  0.03920D0,  0.03244D0,  0.02644D0,  0.02178D0,
     &     0.01794D0,  0.01467D0,  0.01187D0,  0.00951D0,  0.00753D0,
     &     0.00588D0,  0.00453D0,  0.00344D0,  0.00258D0,  0.00191D0,
     &     0.00139D0,  0.00099D0,  0.00070D0,  0.00050D0,  0.00035D0,
     &     0.00021D0,  0.00013D0,  0.00008D0,  0.00003D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I,21),I=1,49)/
     &     4.73651D0,  3.63839D0,  2.79314D0,  2.39169D0,  2.14159D0,
     &     1.96521D0,  1.50121D0,  1.13968D0,  0.96506D0,  0.85456D0,
     &     0.77398D0,  0.56020D0,  0.39006D0,  0.30823D0,  0.25724D0,
     &     0.22164D0,  0.17431D0,  0.13232D0,  0.09445D0,  0.07364D0,
     &     0.05181D0,  0.04050D0,  0.03335D0,  0.02701D0,  0.02212D0,
     &     0.01812D0,  0.01474D0,  0.01187D0,  0.00946D0,  0.00747D0,
     &     0.00580D0,  0.00446D0,  0.00337D0,  0.00252D0,  0.00185D0,
     &     0.00135D0,  0.00096D0,  0.00068D0,  0.00049D0,  0.00034D0,
     &     0.00020D0,  0.00013D0,  0.00007D0,  0.00003D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I,22),I=1,49)/
     &     5.45753D0,  4.15887D0,  3.16726D0,  2.69936D0,  2.40907D0,
     &     2.20495D0,  1.67083D0,  1.25820D0,  1.06032D0,  0.93568D0,
     &     0.84511D0,  0.60646D0,  0.41869D0,  0.32928D0,  0.27391D0,
     &     0.23544D0,  0.18455D0,  0.13964D0,  0.09936D0,  0.07728D0,
     &     0.05411D0,  0.04206D0,  0.03442D0,  0.02766D0,  0.02248D0,
     &     0.01829D0,  0.01478D0,  0.01184D0,  0.00938D0,  0.00736D0,
     &     0.00570D0,  0.00435D0,  0.00328D0,  0.00244D0,  0.00179D0,
     &     0.00129D0,  0.00092D0,  0.00065D0,  0.00046D0,  0.00032D0,
     &     0.00019D0,  0.00012D0,  0.00007D0,  0.00003D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I,23),I=1,49)/
     &     6.19783D0,  4.68879D0,  3.54494D0,  3.00840D0,  2.67675D0,
     &     2.44420D0,  1.83862D0,  1.37436D0,  1.15316D0,  1.01443D0,
     &     0.91394D0,  0.65074D0,  0.44579D0,  0.34906D0,  0.28951D0,
     &     0.24830D0,  0.19403D0,  0.14639D0,  0.10384D0,  0.08058D0,
     &     0.05616D0,  0.04343D0,  0.03534D0,  0.02820D0,  0.02276D0,
     &     0.01841D0,  0.01478D0,  0.01177D0,  0.00929D0,  0.00725D0,
     &     0.00558D0,  0.00425D0,  0.00319D0,  0.00236D0,  0.00173D0,
     &     0.00124D0,  0.00088D0,  0.00062D0,  0.00044D0,  0.00031D0,
     &     0.00018D0,  0.00011D0,  0.00007D0,  0.00003D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I,24),I=1,49)/
     &     6.92966D0,  5.20839D0,  3.91218D0,  3.30740D0,  2.93482D0,
     &     2.67420D0,  1.99847D0,  1.48399D0,  1.24028D0,  1.08801D0,
     &     0.97803D0,  0.69152D0,  0.47043D0,  0.36691D0,  0.30350D0,
     &     0.25978D0,  0.20243D0,  0.15231D0,  0.10773D0,  0.08341D0,
     &     0.05788D0,  0.04454D0,  0.03605D0,  0.02858D0,  0.02293D0,
     &     0.01844D0,  0.01473D0,  0.01167D0,  0.00917D0,  0.00713D0,
     &     0.00547D0,  0.00415D0,  0.00310D0,  0.00229D0,  0.00167D0,
     &     0.00120D0,  0.00085D0,  0.00059D0,  0.00043D0,  0.00030D0,
     &     0.00017D0,  0.00011D0,  0.00006D0,  0.00003D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I,25),I=1,49)/
     &     7.72396D0,  5.76848D0,  4.30532D0,  3.62618D0,  3.20915D0,
     &     2.91815D0,  2.16681D0,  1.59861D0,  1.33097D0,  1.16435D0,
     &     1.04435D0,  0.73337D0,  0.49551D0,  0.38498D0,  0.31761D0,
     &     0.27133D0,  0.21084D0,  0.15821D0,  0.11158D0,  0.08620D0,
     &     0.05955D0,  0.04560D0,  0.03673D0,  0.02893D0,  0.02307D0,
     &     0.01845D0,  0.01466D0,  0.01156D0,  0.00904D0,  0.00700D0,
     &     0.00535D0,  0.00404D0,  0.00301D0,  0.00221D0,  0.00161D0,
     &     0.00115D0,  0.00081D0,  0.00057D0,  0.00041D0,  0.00028D0,
     &     0.00017D0,  0.00010D0,  0.00006D0,  0.00003D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I,26),I=1,49)/
     &     8.54145D0,  6.34073D0,  4.70401D0,  3.94803D0,  3.48525D0,
     &     3.16305D0,  2.33446D0,  1.71181D0,  1.42007D0,  1.23908D0,
     &     1.10907D0,  0.77380D0,  0.51947D0,  0.40212D0,  0.33092D0,
     &     0.28218D0,  0.21869D0,  0.16367D0,  0.11510D0,  0.08871D0,
     &     0.06103D0,  0.04651D0,  0.03727D0,  0.02918D0,  0.02314D0,
     &     0.01840D0,  0.01456D0,  0.01142D0,  0.00889D0,  0.00686D0,
     &     0.00522D0,  0.00393D0,  0.00292D0,  0.00214D0,  0.00155D0,
     &     0.00111D0,  0.00078D0,  0.00054D0,  0.00039D0,  0.00027D0,
     &     0.00016D0,  0.00009D0,  0.00005D0,  0.00003D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I,27),I=1,49)/
     &     9.36625D0,  6.91445D0,  5.10115D0,  4.26741D0,  3.75848D0,
     &     3.40490D0,  2.49891D0,  1.82207D0,  1.50649D0,  1.31134D0,
     &     1.17150D0,  0.81249D0,  0.54219D0,  0.41829D0,  0.34343D0,
     &     0.29234D0,  0.22601D0,  0.16873D0,  0.11834D0,  0.09101D0,
     &     0.06235D0,  0.04731D0,  0.03774D0,  0.02938D0,  0.02318D0,
     &     0.01834D0,  0.01444D0,  0.01128D0,  0.00875D0,  0.00672D0,
     &     0.00510D0,  0.00383D0,  0.00283D0,  0.00207D0,  0.00150D0,
     &     0.00107D0,  0.00075D0,  0.00052D0,  0.00038D0,  0.00026D0,
     &     0.00015D0,  0.00009D0,  0.00005D0,  0.00003D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I,28),I=1,49)/
     &    10.18132D0,  7.47793D0,  5.48877D0,  4.57798D0,  4.02345D0,
     &     3.63894D0,  2.65699D0,  1.92733D0,  1.58864D0,  1.37981D0,
     &     1.23051D0,  0.84875D0,  0.56329D0,  0.43322D0,  0.35493D0,
     &     0.30165D0,  0.23267D0,  0.17330D0,  0.12123D0,  0.09305D0,
     &     0.06349D0,  0.04798D0,  0.03811D0,  0.02952D0,  0.02317D0,
     &     0.01825D0,  0.01431D0,  0.01114D0,  0.00861D0,  0.00659D0,
     &     0.00498D0,  0.00373D0,  0.00275D0,  0.00201D0,  0.00145D0,
     &     0.00103D0,  0.00072D0,  0.00050D0,  0.00036D0,  0.00026D0,
     &     0.00014D0,  0.00008D0,  0.00005D0,  0.00003D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I,29),I=1,49)/
     &    11.04388D0,  8.07089D0,  5.89435D0,  4.90182D0,  4.29909D0,
     &     3.88193D0,  2.82014D0,  2.03528D0,  1.67258D0,  1.44958D0,
     &     1.29048D0,  0.88533D0,  0.58442D0,  0.44808D0,  0.36634D0,
     &     0.31085D0,  0.23922D0,  0.17778D0,  0.12404D0,  0.09501D0,
     &     0.06457D0,  0.04859D0,  0.03843D0,  0.02962D0,  0.02314D0,
     &     0.01814D0,  0.01416D0,  0.01098D0,  0.00846D0,  0.00645D0,
     &     0.00486D0,  0.00363D0,  0.00267D0,  0.00194D0,  0.00140D0,
     &     0.00099D0,  0.00069D0,  0.00048D0,  0.00035D0,  0.00025D0,
     &     0.00014D0,  0.00008D0,  0.00005D0,  0.00003D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I,30),I=1,49)/
     &    11.92777D0,  8.67505D0,  6.30518D0,  5.22873D0,  4.57663D0,
     &     4.12613D0,  2.98306D0,  2.14237D0,  1.75551D0,  1.51831D0,
     &     1.34943D0,  0.92100D0,  0.60483D0,  0.46237D0,  0.37725D0,
     &     0.31962D0,  0.24543D0,  0.18198D0,  0.12665D0,  0.09681D0,
     &     0.06554D0,  0.04912D0,  0.03869D0,  0.02967D0,  0.02307D0,
     &     0.01801D0,  0.01401D0,  0.01082D0,  0.00830D0,  0.00632D0,
     &     0.00475D0,  0.00353D0,  0.00259D0,  0.00188D0,  0.00135D0,
     &     0.00095D0,  0.00066D0,  0.00047D0,  0.00034D0,  0.00024D0,
     &     0.00014D0,  0.00008D0,  0.00004D0,  0.00002D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I,31),I=1,49)/
     &    12.81161D0,  9.27611D0,  6.71181D0,  5.55130D0,  4.84990D0,
     &     4.36615D0,  3.14234D0,  2.24650D0,  1.83587D0,  1.58474D0,
     &     1.40629D0,  0.95519D0,  0.62425D0,  0.47590D0,  0.38756D0,
     &     0.32788D0,  0.25125D0,  0.18591D0,  0.12907D0,  0.09846D0,
     &     0.06642D0,  0.04959D0,  0.03891D0,  0.02970D0,  0.02299D0,
     &     0.01788D0,  0.01385D0,  0.01067D0,  0.00816D0,  0.00619D0,
     &     0.00464D0,  0.00344D0,  0.00252D0,  0.00182D0,  0.00130D0,
     &     0.00092D0,  0.00064D0,  0.00045D0,  0.00033D0,  0.00023D0,
     &     0.00013D0,  0.00007D0,  0.00004D0,  0.00002D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I,32),I=1,49)/
     &    13.67059D0,  9.85720D0,  7.10279D0,  5.86046D0,  5.11119D0,
     &     4.59523D0,  3.29346D0,  2.34466D0,  1.91134D0,  1.64694D0,
     &     1.45941D0,  0.98687D0,  0.64209D0,  0.48825D0,  0.39691D0,
     &     0.33535D0,  0.25648D0,  0.18940D0,  0.13119D0,  0.09990D0,
     &     0.06714D0,  0.04995D0,  0.03906D0,  0.02968D0,  0.02289D0,
     &     0.01773D0,  0.01369D0,  0.01051D0,  0.00801D0,  0.00606D0,
     &     0.00453D0,  0.00335D0,  0.00245D0,  0.00177D0,  0.00126D0,
     &     0.00089D0,  0.00062D0,  0.00043D0,  0.00032D0,  0.00023D0,
     &     0.00013D0,  0.00007D0,  0.00004D0,  0.00002D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I,33),I=1,49)/
     &    14.58850D0, 10.47558D0,  7.51716D0,  6.18731D0,  5.38695D0,
     &     4.83668D0,  3.45207D0,  2.44727D0,  1.99002D0,  1.71168D0,
     &     1.51462D0,  1.01965D0,  0.66046D0,  0.50094D0,  0.40651D0,
     &     0.34300D0,  0.26182D0,  0.19296D0,  0.13335D0,  0.10136D0,
     &     0.06788D0,  0.05032D0,  0.03921D0,  0.02967D0,  0.02278D0,
     &     0.01759D0,  0.01353D0,  0.01035D0,  0.00787D0,  0.00594D0,
     &     0.00443D0,  0.00327D0,  0.00238D0,  0.00172D0,  0.00122D0,
     &     0.00086D0,  0.00060D0,  0.00042D0,  0.00031D0,  0.00022D0,
     &     0.00013D0,  0.00007D0,  0.00004D0,  0.00002D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I,34),I=1,49)/
     &    15.50215D0, 11.08776D0,  7.92505D0,  6.50796D0,  5.65681D0,
     &     5.07248D0,  3.60600D0,  2.54615D0,  2.06552D0,  1.77359D0,
     &     1.56726D0,  1.05062D0,  0.67763D0,  0.51270D0,  0.41535D0,
     &     0.35001D0,  0.26666D0,  0.19615D0,  0.13524D0,  0.10260D0,
     &     0.06847D0,  0.05058D0,  0.03928D0,  0.02960D0,  0.02264D0,
     &     0.01742D0,  0.01336D0,  0.01019D0,  0.00772D0,  0.00581D0,
     &     0.00432D0,  0.00318D0,  0.00232D0,  0.00166D0,  0.00118D0,
     &     0.00083D0,  0.00058D0,  0.00041D0,  0.00030D0,  0.00022D0,
     &     0.00013D0,  0.00007D0,  0.00004D0,  0.00002D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I,35),I=1,49)/
     &    16.42021D0, 11.70052D0,  8.33176D0,  6.82695D0,  5.92484D0,
     &     5.30641D0,  3.75809D0,  2.64348D0,  2.13966D0,  1.83429D0,
     &     1.61881D0,  1.08081D0,  0.69429D0,  0.52409D0,  0.42389D0,
     &     0.35678D0,  0.27133D0,  0.19921D0,  0.13706D0,  0.10380D0,
     &     0.06904D0,  0.05083D0,  0.03934D0,  0.02953D0,  0.02251D0,
     &     0.01726D0,  0.01320D0,  0.01004D0,  0.00759D0,  0.00569D0,
     &     0.00422D0,  0.00310D0,  0.00225D0,  0.00162D0,  0.00115D0,
     &     0.00080D0,  0.00056D0,  0.00039D0,  0.00029D0,  0.00021D0,
     &     0.00013D0,  0.00007D0,  0.00004D0,  0.00002D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I,36),I=1,49)/
     &    17.31499D0, 12.29519D0,  8.72473D0,  7.13436D0,  6.18265D0,
     &     5.53107D0,  3.90347D0,  2.73604D0,  2.20994D0,  1.89170D0,
     &     1.66747D0,  1.10914D0,  0.70980D0,  0.53464D0,  0.43178D0,
     &     0.36300D0,  0.27560D0,  0.20200D0,  0.13869D0,  0.10485D0,
     &     0.06952D0,  0.05103D0,  0.03937D0,  0.02945D0,  0.02237D0,
     &     0.01710D0,  0.01303D0,  0.00989D0,  0.00746D0,  0.00558D0,
     &     0.00413D0,  0.00303D0,  0.00220D0,  0.00157D0,  0.00111D0,
     &     0.00078D0,  0.00054D0,  0.00038D0,  0.00028D0,  0.00021D0,
     &     0.00013D0,  0.00007D0,  0.00004D0,  0.00002D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I,37),I=1,49)/
     &    18.24071D0, 12.90782D0,  9.12782D0,  7.44886D0,  6.44591D0,
     &     5.76014D0,  4.05101D0,  2.82949D0,  2.28068D0,  1.94934D0,
     &     1.71624D0,  1.13734D0,  0.72513D0,  0.54501D0,  0.43949D0,
     &     0.36907D0,  0.27974D0,  0.20467D0,  0.14023D0,  0.10583D0,
     &     0.06996D0,  0.05118D0,  0.03937D0,  0.02934D0,  0.02221D0,
     &     0.01693D0,  0.01286D0,  0.00973D0,  0.00732D0,  0.00547D0,
     &     0.00404D0,  0.00296D0,  0.00214D0,  0.00153D0,  0.00108D0,
     &     0.00076D0,  0.00052D0,  0.00037D0,  0.00027D0,  0.00020D0,
     &     0.00013D0,  0.00007D0,  0.00004D0,  0.00002D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,5,I,38),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I, 1),I=1,49)/
     &     0.49855D0,  0.42587D0,  0.36389D0,  0.33197D0,  0.31109D0,
     &     0.29584D0,  0.25332D0,  0.21750D0,  0.19938D0,  0.18774D0,
     &     0.17961D0,  0.15726D0,  0.13904D0,  0.12982D0,  0.12379D0,
     &     0.11933D0,  0.11282D0,  0.10593D0,  0.09760D0,  0.09090D0,
     &     0.07946D0,  0.06933D0,  0.06013D0,  0.04980D0,  0.04078D0,
     &     0.03302D0,  0.02641D0,  0.02091D0,  0.01639D0,  0.01253D0,
     &     0.00964D0,  0.00728D0,  0.00545D0,  0.00406D0,  0.00291D0,
     &     0.00211D0,  0.00151D0,  0.00106D0,  0.00067D0,  0.00051D0,
     &     0.00036D0,  0.00020D0,  0.00015D0,  0.00005D0,  0.00001D0,
     &    -0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I, 2),I=1,49)/
     &     0.50643D0,  0.43610D0,  0.37562D0,  0.34428D0,  0.32368D0,
     &     0.30859D0,  0.26628D0,  0.23029D0,  0.21194D0,  0.20007D0,
     &     0.19176D0,  0.16857D0,  0.14897D0,  0.13868D0,  0.13176D0,
     &     0.12655D0,  0.11883D0,  0.11060D0,  0.10078D0,  0.09314D0,
     &     0.08065D0,  0.07007D0,  0.06069D0,  0.05033D0,  0.04135D0,
     &     0.03363D0,  0.02706D0,  0.02157D0,  0.01702D0,  0.01315D0,
     &     0.01020D0,  0.00777D0,  0.00589D0,  0.00442D0,  0.00323D0,
     &     0.00236D0,  0.00171D0,  0.00122D0,  0.00079D0,  0.00059D0,
     &     0.00042D0,  0.00024D0,  0.00018D0,  0.00006D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I, 3),I=1,49)/
     &     0.53555D0,  0.46535D0,  0.40441D0,  0.37256D0,  0.35153D0,
     &     0.33606D0,  0.29238D0,  0.25475D0,  0.23531D0,  0.22262D0,
     &     0.21361D0,  0.18804D0,  0.16542D0,  0.15305D0,  0.14451D0,
     &     0.13799D0,  0.12824D0,  0.11785D0,  0.10571D0,  0.09664D0,
     &     0.08259D0,  0.07132D0,  0.06165D0,  0.05118D0,  0.04219D0,
     &     0.03449D0,  0.02794D0,  0.02243D0,  0.01784D0,  0.01392D0,
     &     0.01089D0,  0.00837D0,  0.00641D0,  0.00486D0,  0.00360D0,
     &     0.00265D0,  0.00193D0,  0.00138D0,  0.00092D0,  0.00067D0,
     &     0.00048D0,  0.00029D0,  0.00022D0,  0.00008D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I, 4),I=1,49)/
     &     0.57226D0,  0.49911D0,  0.43533D0,  0.40188D0,  0.37974D0,
     &     0.36342D0,  0.31717D0,  0.27704D0,  0.25615D0,  0.24242D0,
     &     0.23256D0,  0.20428D0,  0.17865D0,  0.16439D0,  0.15446D0,
     &     0.14683D0,  0.13543D0,  0.12334D0,  0.10944D0,  0.09929D0,
     &     0.08411D0,  0.07232D0,  0.06240D0,  0.05181D0,  0.04280D0,
     &     0.03507D0,  0.02851D0,  0.02298D0,  0.01835D0,  0.01437D0,
     &     0.01128D0,  0.00872D0,  0.00670D0,  0.00509D0,  0.00378D0,
     &     0.00278D0,  0.00204D0,  0.00149D0,  0.00099D0,  0.00072D0,
     &     0.00050D0,  0.00032D0,  0.00023D0,  0.00009D0,  0.00003D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I, 5),I=1,49)/
     &     0.63213D0,  0.55147D0,  0.48109D0,  0.44417D0,  0.41970D0,
     &     0.40166D0,  0.35046D0,  0.30587D0,  0.28254D0,  0.26712D0,
     &     0.25592D0,  0.22358D0,  0.19384D0,  0.17718D0,  0.16554D0,
     &     0.15661D0,  0.14330D0,  0.12931D0,  0.11348D0,  0.10220D0,
     &     0.08579D0,  0.07344D0,  0.06325D0,  0.05250D0,  0.04341D0,
     &     0.03561D0,  0.02901D0,  0.02344D0,  0.01875D0,  0.01473D0,
     &     0.01158D0,  0.00897D0,  0.00690D0,  0.00525D0,  0.00392D0,
     &     0.00287D0,  0.00212D0,  0.00153D0,  0.00104D0,  0.00075D0,
     &     0.00052D0,  0.00033D0,  0.00023D0,  0.00009D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I, 6),I=1,49)/
     &     0.69484D0,  0.60548D0,  0.52759D0,  0.48675D0,  0.45969D0,
     &     0.43974D0,  0.38311D0,  0.33372D0,  0.30779D0,  0.29059D0,
     &     0.27800D0,  0.24152D0,  0.20772D0,  0.18874D0,  0.17549D0,
     &     0.16535D0,  0.15028D0,  0.13457D0,  0.11704D0,  0.10475D0,
     &     0.08728D0,  0.07444D0,  0.06400D0,  0.05308D0,  0.04390D0,
     &     0.03605D0,  0.02939D0,  0.02378D0,  0.01903D0,  0.01499D0,
     &     0.01179D0,  0.00914D0,  0.00703D0,  0.00535D0,  0.00400D0,
     &     0.00293D0,  0.00217D0,  0.00156D0,  0.00107D0,  0.00077D0,
     &     0.00053D0,  0.00034D0,  0.00024D0,  0.00009D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I, 7),I=1,49)/
     &     0.77164D0,  0.67034D0,  0.58230D0,  0.53624D0,  0.50577D0,
     &     0.48332D0,  0.41966D0,  0.36421D0,  0.33508D0,  0.31572D0,
     &     0.30145D0,  0.26012D0,  0.22178D0,  0.20031D0,  0.18536D0,
     &     0.17396D0,  0.15711D0,  0.13969D0,  0.12049D0,  0.10724D0,
     &     0.08874D0,  0.07542D0,  0.06472D0,  0.05362D0,  0.04433D0,
     &     0.03642D0,  0.02969D0,  0.02403D0,  0.01923D0,  0.01516D0,
     &     0.01193D0,  0.00926D0,  0.00710D0,  0.00541D0,  0.00405D0,
     &     0.00297D0,  0.00219D0,  0.00158D0,  0.00108D0,  0.00077D0,
     &     0.00052D0,  0.00033D0,  0.00024D0,  0.00008D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I, 8),I=1,49)/
     &     0.86838D0,  0.75105D0,  0.64953D0,  0.59658D0,  0.56163D0,
     &     0.53592D0,  0.46317D0,  0.39995D0,  0.36678D0,  0.34473D0,
     &     0.32838D0,  0.28112D0,  0.23740D0,  0.21303D0,  0.19616D0,
     &     0.18334D0,  0.16450D0,  0.14520D0,  0.12419D0,  0.10991D0,
     &     0.09031D0,  0.07647D0,  0.06547D0,  0.05416D0,  0.04475D0,
     &     0.03674D0,  0.02994D0,  0.02423D0,  0.01939D0,  0.01529D0,
     &     0.01202D0,  0.00932D0,  0.00715D0,  0.00545D0,  0.00407D0,
     &     0.00298D0,  0.00220D0,  0.00159D0,  0.00108D0,  0.00077D0,
     &     0.00052D0,  0.00033D0,  0.00024D0,  0.00008D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I, 9),I=1,49)/
     &     0.96608D0,  0.83177D0,  0.71606D0,  0.65593D0,  0.61632D0,
     &     0.58722D0,  0.50510D0,  0.43397D0,  0.39671D0,  0.37195D0,
     &     0.35355D0,  0.30046D0,  0.25156D0,  0.22448D0,  0.20581D0,
     &     0.19169D0,  0.17103D0,  0.15004D0,  0.12743D0,  0.11224D0,
     &     0.09169D0,  0.07737D0,  0.06612D0,  0.05461D0,  0.04508D0,
     &     0.03697D0,  0.03013D0,  0.02435D0,  0.01949D0,  0.01536D0,
     &     0.01207D0,  0.00933D0,  0.00718D0,  0.00545D0,  0.00407D0,
     &     0.00298D0,  0.00219D0,  0.00159D0,  0.00106D0,  0.00076D0,
     &     0.00052D0,  0.00033D0,  0.00024D0,  0.00009D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I,10),I=1,49)/
     &     1.07543D0,  0.92116D0,  0.78892D0,  0.72047D0,  0.67548D0,
     &     0.64249D0,  0.54968D0,  0.46963D0,  0.42782D0,  0.40008D0,
     &     0.37941D0,  0.32003D0,  0.26568D0,  0.23578D0,  0.21528D0,
     &     0.19985D0,  0.17739D0,  0.15473D0,  0.13057D0,  0.11449D0,
     &     0.09302D0,  0.07823D0,  0.06672D0,  0.05501D0,  0.04535D0,
     &     0.03715D0,  0.03025D0,  0.02442D0,  0.01953D0,  0.01538D0,
     &     0.01207D0,  0.00932D0,  0.00717D0,  0.00543D0,  0.00405D0,
     &     0.00296D0,  0.00217D0,  0.00158D0,  0.00105D0,  0.00075D0,
     &     0.00051D0,  0.00033D0,  0.00023D0,  0.00008D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I,11),I=1,49)/
     &     1.17158D0,  0.99923D0,  0.85209D0,  0.77617D0,  0.72639D0,
     &     0.68993D0,  0.58762D0,  0.49971D0,  0.45391D0,  0.42357D0,
     &     0.40096D0,  0.33616D0,  0.27719D0,  0.24495D0,  0.22293D0,
     &     0.20642D0,  0.18248D0,  0.15848D0,  0.13306D0,  0.11628D0,
     &     0.09406D0,  0.07891D0,  0.06718D0,  0.05531D0,  0.04555D0,
     &     0.03727D0,  0.03032D0,  0.02446D0,  0.01953D0,  0.01537D0,
     &     0.01205D0,  0.00930D0,  0.00714D0,  0.00540D0,  0.00402D0,
     &     0.00294D0,  0.00214D0,  0.00155D0,  0.00104D0,  0.00074D0,
     &     0.00050D0,  0.00032D0,  0.00022D0,  0.00008D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I,12),I=1,49)/
     &     1.40820D0,  1.18938D0,  1.00430D0,  0.90953D0,  0.84767D0,
     &     0.80252D0,  0.67658D0,  0.56932D0,  0.51382D0,  0.47719D0,
     &     0.44989D0,  0.37226D0,  0.30256D0,  0.26497D0,  0.23955D0,
     &     0.22062D0,  0.19343D0,  0.16648D0,  0.13836D0,  0.12007D0,
     &     0.09626D0,  0.08032D0,  0.06811D0,  0.05588D0,  0.04588D0,
     &     0.03745D0,  0.03039D0,  0.02446D0,  0.01948D0,  0.01531D0,
     &     0.01197D0,  0.00921D0,  0.00706D0,  0.00532D0,  0.00395D0,
     &     0.00288D0,  0.00209D0,  0.00151D0,  0.00101D0,  0.00072D0,
     &     0.00049D0,  0.00031D0,  0.00021D0,  0.00008D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I,13),I=1,49)/
     &     1.64756D0,  1.37951D0,  1.15467D0,  1.04031D0,  0.96596D0,
     &     0.91188D0,  0.76181D0,  0.63505D0,  0.56988D0,  0.52704D0,
     &     0.49515D0,  0.40510D0,  0.32525D0,  0.28268D0,  0.25415D0,
     &     0.23303D0,  0.20292D0,  0.17336D0,  0.14288D0,  0.12329D0,
     &     0.09812D0,  0.08148D0,  0.06886D0,  0.05629D0,  0.04609D0,
     &     0.03753D0,  0.03037D0,  0.02438D0,  0.01937D0,  0.01519D0,
     &     0.01185D0,  0.00910D0,  0.00695D0,  0.00523D0,  0.00387D0,
     &     0.00281D0,  0.00204D0,  0.00147D0,  0.00097D0,  0.00069D0,
     &     0.00048D0,  0.00029D0,  0.00020D0,  0.00007D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I,14),I=1,49)/
     &     1.95709D0,  1.62260D0,  1.34467D0,  1.20438D0,  1.11362D0,
     &     1.04783D0,  0.86639D0,  0.71460D0,  0.63715D0,  0.58648D0,
     &     0.54885D0,  0.44345D0,  0.35130D0,  0.30283D0,  0.27064D0,
     &     0.24698D0,  0.21351D0,  0.18099D0,  0.14786D0,  0.12681D0,
     &     0.10011D0,  0.08269D0,  0.06959D0,  0.05666D0,  0.04624D0,
     &     0.03752D0,  0.03025D0,  0.02422D0,  0.01919D0,  0.01499D0,
     &     0.01165D0,  0.00893D0,  0.00678D0,  0.00510D0,  0.00375D0,
     &     0.00271D0,  0.00197D0,  0.00141D0,  0.00093D0,  0.00065D0,
     &     0.00045D0,  0.00028D0,  0.00019D0,  0.00007D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I,15),I=1,49)/
     &     2.33106D0,  1.91266D0,  1.56849D0,  1.39616D0,  1.28524D0,
     &     1.20514D0,  0.98569D0,  0.80398D0,  0.71204D0,  0.65222D0,
     &     0.60792D0,  0.48491D0,  0.37897D0,  0.32402D0,  0.28785D0,
     &     0.26145D0,  0.22441D0,  0.18878D0,  0.15289D0,  0.13035D0,
     &     0.10206D0,  0.08383D0,  0.07023D0,  0.05691D0,  0.04625D0,
     &     0.03736D0,  0.03004D0,  0.02396D0,  0.01891D0,  0.01473D0,
     &     0.01139D0,  0.00872D0,  0.00659D0,  0.00494D0,  0.00362D0,
     &     0.00261D0,  0.00189D0,  0.00136D0,  0.00089D0,  0.00062D0,
     &     0.00043D0,  0.00026D0,  0.00018D0,  0.00006D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I,16),I=1,49)/
     &     2.71585D0,  2.20785D0,  1.79373D0,  1.58787D0,  1.45597D0,
     &     1.36104D0,  1.10250D0,  0.89041D0,  0.78391D0,  0.71494D0,
     &     0.66403D0,  0.52372D0,  0.40449D0,  0.34337D0,  0.30346D0,
     &     0.27452D0,  0.23417D0,  0.19570D0,  0.15732D0,  0.13343D0,
     &     0.10373D0,  0.08475D0,  0.07072D0,  0.05705D0,  0.04617D0,
     &     0.03716D0,  0.02977D0,  0.02366D0,  0.01861D0,  0.01445D0,
     &     0.01114D0,  0.00850D0,  0.00640D0,  0.00478D0,  0.00350D0,
     &     0.00251D0,  0.00181D0,  0.00130D0,  0.00086D0,  0.00058D0,
     &     0.00040D0,  0.00024D0,  0.00016D0,  0.00006D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I,17),I=1,49)/
     &     3.15180D0,  2.53892D0,  2.04375D0,  1.79938D0,  1.64351D0,
     &     1.53170D0,  1.22899D0,  0.98294D0,  0.86032D0,  0.78129D0,
     &     0.72315D0,  0.56409D0,  0.43066D0,  0.36305D0,  0.31926D0,
     &     0.28768D0,  0.24394D0,  0.20257D0,  0.16168D0,  0.13644D0,
     &     0.10531D0,  0.08560D0,  0.07112D0,  0.05711D0,  0.04602D0,
     &     0.03691D0,  0.02945D0,  0.02332D0,  0.01829D0,  0.01415D0,
     &     0.01087D0,  0.00826D0,  0.00621D0,  0.00462D0,  0.00337D0,
     &     0.00241D0,  0.00173D0,  0.00124D0,  0.00082D0,  0.00055D0,
     &     0.00038D0,  0.00023D0,  0.00015D0,  0.00005D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I,18),I=1,49)/
     &     3.55145D0,  2.83962D0,  2.26870D0,  1.98860D0,  1.81061D0,
     &     1.68328D0,  1.34021D0,  1.06346D0,  0.92638D0,  0.83839D0,
     &     0.77383D0,  0.59827D0,  0.45255D0,  0.37938D0,  0.33229D0,
     &     0.29849D0,  0.25191D0,  0.20813D0,  0.16517D0,  0.13882D0,
     &     0.10653D0,  0.08622D0,  0.07137D0,  0.05708D0,  0.04584D0,
     &     0.03664D0,  0.02914D0,  0.02300D0,  0.01798D0,  0.01388D0,
     &     0.01064D0,  0.00807D0,  0.00604D0,  0.00448D0,  0.00326D0,
     &     0.00232D0,  0.00166D0,  0.00119D0,  0.00077D0,  0.00053D0,
     &     0.00036D0,  0.00022D0,  0.00015D0,  0.00005D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I,19),I=1,49)/
     &     4.08243D0,  3.23554D0,  2.56218D0,  2.23414D0,  2.02661D0,
     &     1.87862D0,  1.48217D0,  1.16519D0,  1.00935D0,  0.90979D0,
     &     0.83697D0,  0.64037D0,  0.47917D0,  0.39910D0,  0.34794D0,
     &     0.31141D0,  0.26137D0,  0.21468D0,  0.16924D0,  0.14156D0,
     &     0.10788D0,  0.08686D0,  0.07159D0,  0.05697D0,  0.04554D0,
     &     0.03624D0,  0.02871D0,  0.02258D0,  0.01759D0,  0.01353D0,
     &     0.01034D0,  0.00780D0,  0.00582D0,  0.00431D0,  0.00313D0,
     &     0.00222D0,  0.00159D0,  0.00113D0,  0.00073D0,  0.00050D0,
     &     0.00034D0,  0.00021D0,  0.00014D0,  0.00005D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I,20),I=1,49)/
     &     4.59984D0,  3.61795D0,  2.84314D0,  2.46798D0,  2.23154D0,
     &     2.06341D0,  1.61522D0,  1.25965D0,  1.08594D0,  0.97542D0,
     &     0.89482D0,  0.67853D0,  0.50302D0,  0.41664D0,  0.36179D0,
     &     0.32280D0,  0.26966D0,  0.22039D0,  0.17274D0,  0.14391D0,
     &     0.10901D0,  0.08736D0,  0.07173D0,  0.05682D0,  0.04524D0,
     &     0.03586D0,  0.02831D0,  0.02220D0,  0.01723D0,  0.01322D0,
     &     0.01007D0,  0.00756D0,  0.00563D0,  0.00415D0,  0.00301D0,
     &     0.00213D0,  0.00152D0,  0.00108D0,  0.00071D0,  0.00046D0,
     &     0.00032D0,  0.00019D0,  0.00013D0,  0.00004D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I,21),I=1,49)/
     &     5.10866D0,  3.99099D0,  3.11497D0,  2.69310D0,  2.42814D0,
     &     2.24021D0,  1.74141D0,  1.34843D0,  1.15753D0,  1.03651D0,
     &     0.94850D0,  0.71355D0,  0.52465D0,  0.43244D0,  0.37419D0,
     &     0.33296D0,  0.27700D0,  0.22539D0,  0.17578D0,  0.14590D0,
     &     0.10992D0,  0.08772D0,  0.07175D0,  0.05660D0,  0.04490D0,
     &     0.03547D0,  0.02791D0,  0.02182D0,  0.01688D0,  0.01291D0,
     &     0.00980D0,  0.00735D0,  0.00546D0,  0.00401D0,  0.00289D0,
     &     0.00204D0,  0.00145D0,  0.00103D0,  0.00067D0,  0.00045D0,
     &     0.00030D0,  0.00018D0,  0.00012D0,  0.00004D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I,22),I=1,49)/
     &     5.81063D0,  4.50144D0,  3.48388D0,  2.99716D0,  2.69275D0,
     &     2.47752D0,  1.90937D0,  1.46556D0,  1.25149D0,  1.11639D0,
     &     1.01845D0,  0.75875D0,  0.55228D0,  0.45248D0,  0.38985D0,
     &     0.34573D0,  0.28616D0,  0.23159D0,  0.17950D0,  0.14831D0,
     &     0.11099D0,  0.08809D0,  0.07172D0,  0.05628D0,  0.04443D0,
     &     0.03495D0,  0.02738D0,  0.02132D0,  0.01642D0,  0.01252D0,
     &     0.00947D0,  0.00708D0,  0.00524D0,  0.00384D0,  0.00275D0,
     &     0.00194D0,  0.00137D0,  0.00097D0,  0.00062D0,  0.00042D0,
     &     0.00028D0,  0.00017D0,  0.00011D0,  0.00004D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I,23),I=1,49)/
     &     6.53035D0,  5.02028D0,  3.85558D0,  3.30194D0,  2.95702D0,
     &     2.71384D0,  2.07512D0,  1.58008D0,  1.34283D0,  1.19373D0,
     &     1.08596D0,  0.80189D0,  0.57834D0,  0.47125D0,  0.40444D0,
     &     0.35757D0,  0.29461D0,  0.23726D0,  0.18285D0,  0.15046D0,
     &     0.11188D0,  0.08836D0,  0.07162D0,  0.05593D0,  0.04396D0,
     &     0.03443D0,  0.02686D0,  0.02084D0,  0.01599D0,  0.01216D0,
     &     0.00917D0,  0.00683D0,  0.00504D0,  0.00368D0,  0.00262D0,
     &     0.00186D0,  0.00129D0,  0.00092D0,  0.00058D0,  0.00038D0,
     &     0.00026D0,  0.00015D0,  0.00010D0,  0.00004D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I,24),I=1,49)/
     &     7.24769D0,  5.53321D0,  4.22004D0,  3.59932D0,  3.21397D0,
     &     2.94299D0,  2.23445D0,  1.68918D0,  1.42937D0,  1.26671D0,
     &     1.14944D0,  0.84202D0,  0.60229D0,  0.48837D0,  0.41766D0,
     &     0.36826D0,  0.30216D0,  0.24227D0,  0.18575D0,  0.15227D0,
     &     0.11258D0,  0.08849D0,  0.07143D0,  0.05553D0,  0.04345D0,
     &     0.03390D0,  0.02636D0,  0.02037D0,  0.01559D0,  0.01181D0,
     &     0.00887D0,  0.00659D0,  0.00484D0,  0.00353D0,  0.00252D0,
     &     0.00176D0,  0.00124D0,  0.00088D0,  0.00055D0,  0.00037D0,
     &     0.00025D0,  0.00014D0,  0.00009D0,  0.00003D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I,25),I=1,49)/
     &     8.02203D0,  6.08288D0,  4.60775D0,  3.91431D0,  3.48531D0,
     &     3.18439D0,  2.40103D0,  1.80237D0,  1.51875D0,  1.34182D0,
     &     1.21461D0,  0.88286D0,  0.62643D0,  0.50552D0,  0.43085D0,
     &     0.37888D0,  0.30963D0,  0.24719D0,  0.18858D0,  0.15401D0,
     &     0.11322D0,  0.08857D0,  0.07120D0,  0.05510D0,  0.04294D0,
     &     0.03336D0,  0.02585D0,  0.01990D0,  0.01519D0,  0.01146D0,
     &     0.00858D0,  0.00636D0,  0.00466D0,  0.00338D0,  0.00242D0,
     &     0.00168D0,  0.00119D0,  0.00083D0,  0.00052D0,  0.00035D0,
     &     0.00023D0,  0.00013D0,  0.00009D0,  0.00003D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I,26),I=1,49)/
     &     8.82307D0,  6.64735D0,  5.00295D0,  4.23399D0,  3.75981D0,
     &     3.42801D0,  2.56785D0,  1.91480D0,  1.60708D0,  1.41578D0,
     &     1.27859D0,  0.92256D0,  0.64966D0,  0.52190D0,  0.44338D0,
     &     0.38892D0,  0.31662D0,  0.25175D0,  0.19114D0,  0.15555D0,
     &     0.11371D0,  0.08855D0,  0.07090D0,  0.05462D0,  0.04239D0,
     &     0.03281D0,  0.02532D0,  0.01944D0,  0.01478D0,  0.01112D0,
     &     0.00830D0,  0.00614D0,  0.00448D0,  0.00324D0,  0.00231D0,
     &     0.00160D0,  0.00113D0,  0.00079D0,  0.00049D0,  0.00033D0,
     &     0.00022D0,  0.00013D0,  0.00008D0,  0.00003D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I,27),I=1,49)/
     &     9.62987D0,  7.21210D0,  5.39571D0,  4.55043D0,  4.03076D0,
     &     3.66794D0,  2.73100D0,  2.02398D0,  1.69250D0,  1.48708D0,
     &     1.34010D0,  0.96040D0,  0.67159D0,  0.53727D0,  0.45509D0,
     &     0.39827D0,  0.32310D0,  0.25593D0,  0.19347D0,  0.15692D0,
     &     0.11411D0,  0.08848D0,  0.07058D0,  0.05414D0,  0.04185D0,
     &     0.03228D0,  0.02482D0,  0.01900D0,  0.01440D0,  0.01080D0,
     &     0.00804D0,  0.00593D0,  0.00431D0,  0.00312D0,  0.00222D0,
     &     0.00152D0,  0.00108D0,  0.00075D0,  0.00046D0,  0.00031D0,
     &     0.00020D0,  0.00012D0,  0.00008D0,  0.00003D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I,28),I=1,49)/
     &    10.42894D0,  7.76794D0,  5.77982D0,  4.85875D0,  4.29406D0,
     &     3.90061D0,  2.88817D0,  2.12844D0,  1.77387D0,  1.55479D0,
     &     1.39837D0,  0.99596D0,  0.69200D0,  0.55150D0,  0.46587D0,
     &     0.40684D0,  0.32899D0,  0.25970D0,  0.19552D0,  0.15809D0,
     &     0.11441D0,  0.08837D0,  0.07023D0,  0.05366D0,  0.04133D0,
     &     0.03176D0,  0.02435D0,  0.01859D0,  0.01405D0,  0.01051D0,
     &     0.00780D0,  0.00573D0,  0.00416D0,  0.00301D0,  0.00213D0,
     &     0.00146D0,  0.00103D0,  0.00071D0,  0.00045D0,  0.00029D0,
     &     0.00020D0,  0.00011D0,  0.00008D0,  0.00003D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I,29),I=1,49)/
     &    11.27410D0,  8.35239D0,  6.18132D0,  5.17989D0,  4.56762D0,
     &     4.14187D0,  3.05014D0,  2.23540D0,  1.85687D0,  1.62366D0,
     &     1.45750D0,  1.03178D0,  0.71238D0,  0.56563D0,  0.47653D0,
     &     0.41529D0,  0.33476D0,  0.26336D0,  0.19748D0,  0.15919D0,
     &     0.11465D0,  0.08820D0,  0.06985D0,  0.05316D0,  0.04080D0,
     &     0.03125D0,  0.02388D0,  0.01817D0,  0.01370D0,  0.01022D0,
     &     0.00757D0,  0.00554D0,  0.00401D0,  0.00290D0,  0.00205D0,
     &     0.00140D0,  0.00098D0,  0.00068D0,  0.00043D0,  0.00028D0,
     &     0.00019D0,  0.00011D0,  0.00007D0,  0.00002D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I,30),I=1,49)/
     &    12.14199D0,  8.94909D0,  6.58882D0,  5.50470D0,  4.84361D0,
     &     4.38480D0,  3.21222D0,  2.34175D0,  1.93908D0,  1.69167D0,
     &     1.51576D0,  1.06678D0,  0.73213D0,  0.57923D0,  0.48674D0,
     &     0.42334D0,  0.34023D0,  0.26678D0,  0.19927D0,  0.16016D0,
     &     0.11481D0,  0.08798D0,  0.06944D0,  0.05264D0,  0.04025D0,
     &     0.03073D0,  0.02343D0,  0.01777D0,  0.01335D0,  0.00994D0,
     &     0.00734D0,  0.00536D0,  0.00388D0,  0.00278D0,  0.00196D0,
     &     0.00135D0,  0.00094D0,  0.00065D0,  0.00041D0,  0.00027D0,
     &     0.00017D0,  0.00010D0,  0.00007D0,  0.00002D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I,31),I=1,49)/
     &    13.00875D0,  9.54182D0,  6.99142D0,  5.82458D0,  5.11479D0,
     &     4.62308D0,  3.37031D0,  2.44489D0,  2.01852D0,  1.75723D0,
     &     1.57179D0,  1.10022D0,  0.75086D0,  0.59207D0,  0.49634D0,
     &     0.43089D0,  0.34532D0,  0.26994D0,  0.20090D0,  0.16103D0,
     &     0.11492D0,  0.08774D0,  0.06903D0,  0.05213D0,  0.03973D0,
     &     0.03024D0,  0.02300D0,  0.01739D0,  0.01303D0,  0.00968D0,
     &     0.00712D0,  0.00520D0,  0.00375D0,  0.00268D0,  0.00188D0,
     &     0.00130D0,  0.00090D0,  0.00063D0,  0.00039D0,  0.00025D0,
     &     0.00016D0,  0.00009D0,  0.00006D0,  0.00002D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I,32),I=1,49)/
     &    13.85388D0, 10.11672D0,  7.37984D0,  6.13221D0,  5.37500D0,
     &     4.85130D0,  3.52087D0,  2.54252D0,  2.09344D0,  1.81889D0,
     &     1.62437D0,  1.13136D0,  0.76814D0,  0.60383D0,  0.50509D0,
     &     0.43774D0,  0.34990D0,  0.27275D0,  0.20231D0,  0.16173D0,
     &     0.11495D0,  0.08745D0,  0.06859D0,  0.05162D0,  0.03921D0,
     &     0.02977D0,  0.02256D0,  0.01702D0,  0.01273D0,  0.00943D0,
     &     0.00693D0,  0.00505D0,  0.00364D0,  0.00260D0,  0.00181D0,
     &     0.00125D0,  0.00086D0,  0.00060D0,  0.00037D0,  0.00024D0,
     &     0.00016D0,  0.00009D0,  0.00006D0,  0.00002D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I,33),I=1,49)/
     &    14.75398D0, 10.72621D0,  7.78974D0,  6.45599D0,  5.64833D0,
     &     5.09068D0,  3.67806D0,  2.64398D0,  2.17108D0,  1.88265D0,
     &     1.67867D0,  1.16335D0,  0.78579D0,  0.61581D0,  0.51399D0,
     &     0.44470D0,  0.35453D0,  0.27558D0,  0.20373D0,  0.16245D0,
     &     0.11497D0,  0.08717D0,  0.06816D0,  0.05112D0,  0.03871D0,
     &     0.02930D0,  0.02213D0,  0.01666D0,  0.01243D0,  0.00919D0,
     &     0.00674D0,  0.00490D0,  0.00353D0,  0.00251D0,  0.00175D0,
     &     0.00120D0,  0.00083D0,  0.00058D0,  0.00036D0,  0.00023D0,
     &     0.00015D0,  0.00009D0,  0.00006D0,  0.00002D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I,34),I=1,49)/
     &    15.65461D0, 11.33290D0,  8.19558D0,  6.77553D0,  5.91747D0,
     &     5.32596D0,  3.83165D0,  2.74249D0,  2.24617D0,  1.94414D0,
     &     1.73088D0,  1.19385D0,  0.80244D0,  0.62703D0,  0.52226D0,
     &     0.45111D0,  0.35875D0,  0.27811D0,  0.20493D0,  0.16299D0,
     &     0.11490D0,  0.08681D0,  0.06768D0,  0.05059D0,  0.03819D0,
     &     0.02883D0,  0.02172D0,  0.01631D0,  0.01213D0,  0.00895D0,
     &     0.00656D0,  0.00475D0,  0.00341D0,  0.00243D0,  0.00169D0,
     &     0.00116D0,  0.00080D0,  0.00055D0,  0.00034D0,  0.00022D0,
     &     0.00015D0,  0.00008D0,  0.00005D0,  0.00002D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I,35),I=1,49)/
     &    16.55734D0, 11.93842D0,  8.59892D0,  7.09231D0,  6.18381D0,
     &     5.55847D0,  3.98278D0,  2.83900D0,  2.31954D0,  2.00411D0,
     &     1.78173D0,  1.22341D0,  0.81850D0,  0.63782D0,  0.53020D0,
     &     0.45726D0,  0.36278D0,  0.28052D0,  0.20606D0,  0.16351D0,
     &     0.11482D0,  0.08647D0,  0.06722D0,  0.05009D0,  0.03770D0,
     &     0.02838D0,  0.02133D0,  0.01598D0,  0.01187D0,  0.00873D0,
     &     0.00639D0,  0.00462D0,  0.00330D0,  0.00235D0,  0.00163D0,
     &     0.00111D0,  0.00077D0,  0.00053D0,  0.00033D0,  0.00021D0,
     &     0.00014D0,  0.00008D0,  0.00005D0,  0.00002D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I,36),I=1,49)/
     &    17.43806D0, 12.52661D0,  8.98898D0,  7.39784D0,  6.44021D0,
     &     5.78196D0,  4.12737D0,  2.93087D0,  2.38917D0,  2.06088D0,
     &     1.82979D0,  1.25117D0,  0.83346D0,  0.64781D0,  0.53752D0,
     &     0.46291D0,  0.36645D0,  0.28268D0,  0.20706D0,  0.16393D0,
     &     0.11470D0,  0.08612D0,  0.06676D0,  0.04960D0,  0.03723D0,
     &     0.02796D0,  0.02096D0,  0.01566D0,  0.01161D0,  0.00852D0,
     &     0.00623D0,  0.00449D0,  0.00321D0,  0.00227D0,  0.00158D0,
     &     0.00107D0,  0.00074D0,  0.00051D0,  0.00031D0,  0.00020D0,
     &     0.00013D0,  0.00008D0,  0.00005D0,  0.00002D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I,37),I=1,49)/
     &    18.35067D0, 13.13351D0,  9.38971D0,  7.71095D0,  6.70247D0,
     &     6.01024D0,  4.27436D0,  3.02381D0,  2.45940D0,  2.11802D0,
     &     1.87806D0,  1.27887D0,  0.84828D0,  0.65765D0,  0.54469D0,
     &     0.46841D0,  0.37001D0,  0.28475D0,  0.20797D0,  0.16429D0,
     &     0.11453D0,  0.08573D0,  0.06628D0,  0.04909D0,  0.03675D0,
     &     0.02752D0,  0.02059D0,  0.01535D0,  0.01135D0,  0.00831D0,
     &     0.00606D0,  0.00437D0,  0.00311D0,  0.00220D0,  0.00153D0,
     &     0.00103D0,  0.00072D0,  0.00049D0,  0.00030D0,  0.00019D0,
     &     0.00013D0,  0.00007D0,  0.00005D0,  0.00001D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,6,I,38),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I, 1),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I, 2),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I, 3),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I, 4),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I, 5),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I, 6),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I, 7),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I, 8),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I, 9),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I,10),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I,11),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I,12),I=1,49)/
     &     0.00041D0,  0.00036D0,  0.00032D0,  0.00030D0,  0.00028D0,
     &     0.00027D0,  0.00023D0,  0.00021D0,  0.00019D0,  0.00018D0,
     &     0.00017D0,  0.00014D0,  0.00012D0,  0.00011D0,  0.00010D0,
     &     0.00009D0,  0.00008D0,  0.00007D0,  0.00006D0,  0.00005D0,
     &     0.00004D0,  0.00004D0,  0.00003D0,  0.00003D0,  0.00003D0,
     &     0.00003D0,  0.00002D0,  0.00002D0,  0.00002D0,  0.00002D0,
     &     0.00001D0,  0.00001D0,  0.00001D0,  0.00001D0,  0.00001D0,
     &     0.00001D0,  0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I,13),I=1,49)/
     &     0.21131D0,  0.16558D0,  0.12967D0,  0.11232D0,  0.10141D0,
     &     0.09365D0,  0.07296D0,  0.05647D0,  0.04835D0,  0.04314D0,
     &     0.03929D0,  0.02893D0,  0.02049D0,  0.01636D0,  0.01376D0,
     &     0.01193D0,  0.00947D0,  0.00725D0,  0.00522D0,  0.00409D0,
     &     0.00289D0,  0.00226D0,  0.00187D0,  0.00153D0,  0.00127D0,
     &     0.00106D0,  0.00087D0,  0.00071D0,  0.00058D0,  0.00046D0,
     &     0.00037D0,  0.00028D0,  0.00022D0,  0.00016D0,  0.00012D0,
     &     0.00009D0,  0.00007D0,  0.00005D0,  0.00003D0,  0.00002D0,
     &     0.00001D0,  0.00001D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I,14),I=1,49)/
     &     0.61374D0,  0.47881D0,  0.37330D0,  0.32254D0,  0.29066D0,
     &     0.26804D0,  0.20788D0,  0.16016D0,  0.13675D0,  0.12177D0,
     &     0.11072D0,  0.08109D0,  0.05711D0,  0.04545D0,  0.03813D0,
     &     0.03299D0,  0.02611D0,  0.01996D0,  0.01434D0,  0.01121D0,
     &     0.00789D0,  0.00617D0,  0.00509D0,  0.00414D0,  0.00341D0,
     &     0.00282D0,  0.00231D0,  0.00188D0,  0.00151D0,  0.00120D0,
     &     0.00094D0,  0.00073D0,  0.00056D0,  0.00042D0,  0.00031D0,
     &     0.00023D0,  0.00016D0,  0.00012D0,  0.00008D0,  0.00005D0,
     &     0.00003D0,  0.00002D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I,15),I=1,49)/
     &     0.99259D0,  0.76862D0,  0.59480D0,  0.51168D0,  0.45967D0,
     &     0.42287D0,  0.32549D0,  0.24886D0,  0.21152D0,  0.18775D0,
     &     0.17025D0,  0.12366D0,  0.08636D0,  0.06840D0,  0.05719D0,
     &     0.04937D0,  0.03895D0,  0.02967D0,  0.02125D0,  0.01657D0,
     &     0.01162D0,  0.00903D0,  0.00740D0,  0.00597D0,  0.00488D0,
     &     0.00399D0,  0.00325D0,  0.00263D0,  0.00210D0,  0.00166D0,
     &     0.00130D0,  0.00100D0,  0.00076D0,  0.00057D0,  0.00042D0,
     &     0.00031D0,  0.00022D0,  0.00015D0,  0.00011D0,  0.00007D0,
     &     0.00004D0,  0.00002D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I,16),I=1,49)/
     &     1.40334D0,  1.07950D0,  0.82983D0,  0.71109D0,  0.63704D0,
     &     0.58478D0,  0.44710D0,  0.33953D0,  0.28741D0,  0.25436D0,
     &     0.23011D0,  0.16589D0,  0.11498D0,  0.09067D0,  0.07559D0,
     &     0.06510D0,  0.05120D0,  0.03889D0,  0.02777D0,  0.02161D0,
     &     0.01509D0,  0.01166D0,  0.00950D0,  0.00760D0,  0.00617D0,
     &     0.00501D0,  0.00405D0,  0.00325D0,  0.00258D0,  0.00203D0,
     &     0.00158D0,  0.00121D0,  0.00091D0,  0.00068D0,  0.00050D0,
     &     0.00037D0,  0.00026D0,  0.00018D0,  0.00012D0,  0.00008D0,
     &     0.00005D0,  0.00002D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I,17),I=1,49)/
     &     1.88020D0,  1.43681D0,  1.09723D0,  0.93659D0,  0.83676D0,
     &     0.76647D0,  0.58212D0,  0.43908D0,  0.37019D0,  0.32667D0,
     &     0.29484D0,  0.21099D0,  0.14515D0,  0.11396D0,  0.09473D0,
     &     0.08141D0,  0.06382D0,  0.04833D0,  0.03440D0,  0.02672D0,
     &     0.01856D0,  0.01428D0,  0.01156D0,  0.00918D0,  0.00739D0,
     &     0.00596D0,  0.00478D0,  0.00381D0,  0.00301D0,  0.00236D0,
     &     0.00181D0,  0.00138D0,  0.00104D0,  0.00077D0,  0.00057D0,
     &     0.00041D0,  0.00030D0,  0.00020D0,  0.00014D0,  0.00009D0,
     &     0.00005D0,  0.00002D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I,18),I=1,49)/
     &     2.30534D0,  1.75221D0,  1.33088D0,  1.13244D0,  1.00946D0,
     &     0.92305D0,  0.69723D0,  0.52301D0,  0.43952D0,  0.38693D0,
     &     0.34856D0,  0.24795D0,  0.16954D0,  0.13265D0,  0.11000D0,
     &     0.09436D0,  0.07379D0,  0.05574D0,  0.03958D0,  0.03067D0,
     &     0.02123D0,  0.01626D0,  0.01309D0,  0.01033D0,  0.00826D0,
     &     0.00663D0,  0.00529D0,  0.00419D0,  0.00329D0,  0.00257D0,
     &     0.00197D0,  0.00150D0,  0.00112D0,  0.00083D0,  0.00061D0,
     &     0.00044D0,  0.00032D0,  0.00022D0,  0.00015D0,  0.00009D0,
     &     0.00005D0,  0.00002D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I,19),I=1,49)/
     &     2.86856D0,  2.16633D0,  1.63487D0,  1.38587D0,  1.23207D0,
     &     1.12426D0,  0.84372D0,  0.62876D0,  0.52633D0,  0.46206D0,
     &     0.41530D0,  0.29334D0,  0.19914D0,  0.15517D0,  0.12832D0,
     &     0.10984D0,  0.08563D0,  0.06450D0,  0.04565D0,  0.03529D0,
     &     0.02431D0,  0.01851D0,  0.01482D0,  0.01161D0,  0.00922D0,
     &     0.00734D0,  0.00582D0,  0.00458D0,  0.00358D0,  0.00278D0,
     &     0.00212D0,  0.00160D0,  0.00119D0,  0.00088D0,  0.00064D0,
     &     0.00047D0,  0.00033D0,  0.00023D0,  0.00015D0,  0.00009D0,
     &     0.00005D0,  0.00002D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I,20),I=1,49)/
     &     3.42748D0,  2.57399D0,  1.93167D0,  1.63211D0,  1.44759D0,
     &     1.31854D0,  0.98395D0,  0.72909D0,  0.60825D0,  0.53267D0,
     &     0.47783D0,  0.33544D0,  0.22632D0,  0.17572D0,  0.14495D0,
     &     0.12384D0,  0.09630D0,  0.07234D0,  0.05105D0,  0.03938D0,
     &     0.02701D0,  0.02047D0,  0.01631D0,  0.01268D0,  0.01001D0,
     &     0.00793D0,  0.00625D0,  0.00489D0,  0.00380D0,  0.00294D0,
     &     0.00223D0,  0.00168D0,  0.00125D0,  0.00091D0,  0.00066D0,
     &     0.00048D0,  0.00035D0,  0.00024D0,  0.00016D0,  0.00009D0,
     &     0.00005D0,  0.00002D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I,21),I=1,49)/
     &     3.95907D0,  2.95830D0,  2.20894D0,  1.86088D0,  1.64705D0,
     &     1.49778D0,  1.11204D0,  0.81980D0,  0.68185D0,  0.59583D0,
     &     0.53354D0,  0.37251D0,  0.24993D0,  0.19343D0,  0.15921D0,
     &     0.13581D0,  0.10535D0,  0.07895D0,  0.05557D0,  0.04278D0,
     &     0.02922D0,  0.02205D0,  0.01748D0,  0.01352D0,  0.01061D0,
     &     0.00835D0,  0.00655D0,  0.00511D0,  0.00395D0,  0.00304D0,
     &     0.00230D0,  0.00172D0,  0.00128D0,  0.00093D0,  0.00067D0,
     &     0.00049D0,  0.00035D0,  0.00024D0,  0.00016D0,  0.00009D0,
     &     0.00005D0,  0.00002D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I,22),I=1,49)/
     &     4.70301D0,  3.49223D0,  2.59131D0,  2.17500D0,  1.92006D0,
     &     1.74251D0,  1.28559D0,  0.94171D0,  0.78029D0,  0.68000D0,
     &     0.60759D0,  0.42132D0,  0.28074D0,  0.21641D0,  0.17764D0,
     &     0.15121D0,  0.11695D0,  0.08738D0,  0.06130D0,  0.04706D0,
     &     0.03198D0,  0.02400D0,  0.01891D0,  0.01452D0,  0.01131D0,
     &     0.00885D0,  0.00690D0,  0.00535D0,  0.00412D0,  0.00314D0,
     &     0.00237D0,  0.00177D0,  0.00130D0,  0.00095D0,  0.00068D0,
     &     0.00049D0,  0.00036D0,  0.00024D0,  0.00016D0,  0.00009D0,
     &     0.00005D0,  0.00002D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I,23),I=1,49)/
     &     5.46775D0,  4.03669D0,  2.97803D0,  2.49113D0,  2.19384D0,
     &     1.98726D0,  1.45764D0,  1.06148D0,  0.87647D0,  0.76190D0,
     &     0.67941D0,  0.46817D0,  0.30998D0,  0.23809D0,  0.19493D0,
     &     0.16562D0,  0.12774D0,  0.09517D0,  0.06655D0,  0.05097D0,
     &     0.03446D0,  0.02573D0,  0.02017D0,  0.01538D0,  0.01190D0,
     &     0.00925D0,  0.00718D0,  0.00553D0,  0.00424D0,  0.00322D0,
     &     0.00242D0,  0.00179D0,  0.00132D0,  0.00095D0,  0.00069D0,
     &     0.00049D0,  0.00036D0,  0.00024D0,  0.00016D0,  0.00009D0,
     &     0.00005D0,  0.00002D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I,24),I=1,49)/
     &     6.21519D0,  4.56429D0,  3.34948D0,  2.79317D0,  2.45443D0,
     &     2.21950D0,  1.61934D0,  1.17290D0,  0.96539D0,  0.83728D0,
     &     0.74526D0,  0.51062D0,  0.33614D0,  0.25732D0,  0.21020D0,
     &     0.17828D0,  0.13715D0,  0.10192D0,  0.07106D0,  0.05428D0,
     &     0.03653D0,  0.02714D0,  0.02117D0,  0.01604D0,  0.01234D0,
     &     0.00954D0,  0.00736D0,  0.00565D0,  0.00431D0,  0.00326D0,
     &     0.00243D0,  0.00180D0,  0.00132D0,  0.00095D0,  0.00068D0,
     &     0.00049D0,  0.00035D0,  0.00024D0,  0.00016D0,  0.00009D0,
     &     0.00005D0,  0.00002D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I,25),I=1,49)/
     &     7.03262D0,  5.13776D0,  3.75072D0,  3.11823D0,  2.73413D0,
     &     2.46827D0,  1.79141D0,  1.29068D0,  1.05901D0,  0.91641D0,
     &     0.81423D0,  0.55475D0,  0.36312D0,  0.27706D0,  0.22581D0,
     &     0.19119D0,  0.14672D0,  0.10875D0,  0.07559D0,  0.05760D0,
     &     0.03859D0,  0.02852D0,  0.02214D0,  0.01668D0,  0.01276D0,
     &     0.00981D0,  0.00753D0,  0.00575D0,  0.00436D0,  0.00329D0,
     &     0.00245D0,  0.00180D0,  0.00132D0,  0.00095D0,  0.00068D0,
     &     0.00048D0,  0.00035D0,  0.00024D0,  0.00016D0,  0.00009D0,
     &     0.00005D0,  0.00002D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I,26),I=1,49)/
     &     7.86804D0,  5.71947D0,  4.15459D0,  3.44391D0,  3.01342D0,
     &     2.71602D0,  1.96133D0,  1.40596D0,  1.15014D0,  0.99314D0,
     &     0.88088D0,  0.59694D0,  0.38863D0,  0.29560D0,  0.24039D0,
     &     0.20320D0,  0.15555D0,  0.11500D0,  0.07970D0,  0.06059D0,
     &     0.04040D0,  0.02973D0,  0.02296D0,  0.01720D0,  0.01308D0,
     &     0.01001D0,  0.00765D0,  0.00581D0,  0.00439D0,  0.00330D0,
     &     0.00245D0,  0.00180D0,  0.00131D0,  0.00094D0,  0.00067D0,
     &     0.00048D0,  0.00034D0,  0.00024D0,  0.00016D0,  0.00009D0,
     &     0.00005D0,  0.00002D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I,27),I=1,49)/
     &     8.71308D0,  6.30440D0,  4.55822D0,  3.76823D0,  3.29083D0,
     &     2.96160D0,  2.12868D0,  1.51874D0,  1.23894D0,  1.06767D0,
     &     0.94548D0,  0.63752D0,  0.41296D0,  0.31319D0,  0.25418D0,
     &     0.21452D0,  0.16385D0,  0.12085D0,  0.08351D0,  0.06334D0,
     &     0.04205D0,  0.03081D0,  0.02369D0,  0.01765D0,  0.01336D0,
     &     0.01017D0,  0.00773D0,  0.00586D0,  0.00441D0,  0.00330D0,
     &     0.00244D0,  0.00178D0,  0.00129D0,  0.00092D0,  0.00066D0,
     &     0.00047D0,  0.00034D0,  0.00024D0,  0.00016D0,  0.00009D0,
     &     0.00005D0,  0.00002D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I,28),I=1,49)/
     &     9.54571D0,  6.87720D0,  4.95101D0,  4.08263D0,  3.55902D0,
     &     3.19851D0,  2.28903D0,  1.62602D0,  1.32303D0,  1.13803D0,
     &     1.00630D0,  0.67540D0,  0.43546D0,  0.32936D0,  0.26680D0,
     &     0.22485D0,  0.17138D0,  0.12612D0,  0.08693D0,  0.06579D0,
     &     0.04350D0,  0.03173D0,  0.02430D0,  0.01801D0,  0.01357D0,
     &     0.01029D0,  0.00779D0,  0.00587D0,  0.00441D0,  0.00329D0,
     &     0.00242D0,  0.00177D0,  0.00128D0,  0.00091D0,  0.00065D0,
     &     0.00046D0,  0.00033D0,  0.00024D0,  0.00016D0,  0.00009D0,
     &     0.00005D0,  0.00002D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I,29),I=1,49)/
     &    10.42768D0,  7.48069D0,  5.36257D0,  4.41099D0,  3.83846D0,
     &     3.44489D0,  2.45481D0,  1.73627D0,  1.40913D0,  1.20986D0,
     &     1.06825D0,  0.71372D0,  0.45804D0,  0.34552D0,  0.27937D0,
     &     0.23511D0,  0.17881D0,  0.13130D0,  0.09026D0,  0.06816D0,
     &     0.04488D0,  0.03260D0,  0.02487D0,  0.01834D0,  0.01375D0,
     &     0.01038D0,  0.00783D0,  0.00588D0,  0.00440D0,  0.00327D0,
     &     0.00240D0,  0.00175D0,  0.00126D0,  0.00090D0,  0.00063D0,
     &     0.00045D0,  0.00033D0,  0.00024D0,  0.00016D0,  0.00009D0,
     &     0.00005D0,  0.00002D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I,30),I=1,49)/
     &    11.32906D0,  8.09395D0,  5.77834D0,  4.74153D0,  4.11903D0,
     &     3.69178D0,  2.61985D0,  1.84528D0,  1.49390D0,  1.28038D0,
     &     1.12893D0,  0.75094D0,  0.47979D0,  0.36099D0,  0.29135D0,
     &     0.24485D0,  0.18584D0,  0.13617D0,  0.09335D0,  0.07035D0,
     &     0.04613D0,  0.03338D0,  0.02536D0,  0.01861D0,  0.01389D0,
     &     0.01045D0,  0.00785D0,  0.00587D0,  0.00438D0,  0.00324D0,
     &     0.00237D0,  0.00172D0,  0.00124D0,  0.00088D0,  0.00062D0,
     &     0.00044D0,  0.00032D0,  0.00024D0,  0.00016D0,  0.00009D0,
     &     0.00005D0,  0.00002D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I,31),I=1,49)/
     &    12.23197D0,  8.70533D0,  6.19083D0,  5.06852D0,  4.39601D0,
     &     3.93512D0,  2.78170D0,  1.95161D0,  1.57633D0,  1.34878D0,
     &     1.18767D0,  0.78675D0,  0.50057D0,  0.37571D0,  0.30272D0,
     &     0.25408D0,  0.19247D0,  0.14074D0,  0.09625D0,  0.07237D0,
     &     0.04728D0,  0.03408D0,  0.02579D0,  0.01885D0,  0.01401D0,
     &     0.01049D0,  0.00785D0,  0.00586D0,  0.00435D0,  0.00321D0,
     &     0.00235D0,  0.00170D0,  0.00122D0,  0.00086D0,  0.00061D0,
     &     0.00043D0,  0.00031D0,  0.00023D0,  0.00016D0,  0.00009D0,
     &     0.00005D0,  0.00002D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I,32),I=1,49)/
     &    13.10605D0,  9.29397D0,  6.58574D0,  5.38050D0,  4.65963D0,
     &     4.16627D0,  2.93446D0,  2.05131D0,  1.65329D0,  1.41245D0,
     &     1.24220D0,  0.81972D0,  0.51953D0,  0.38906D0,  0.31298D0,
     &     0.26237D0,  0.19840D0,  0.14478D0,  0.09878D0,  0.07413D0,
     &     0.04825D0,  0.03465D0,  0.02614D0,  0.01902D0,  0.01408D0,
     &     0.01051D0,  0.00784D0,  0.00583D0,  0.00432D0,  0.00318D0,
     &     0.00232D0,  0.00167D0,  0.00120D0,  0.00085D0,  0.00060D0,
     &     0.00042D0,  0.00031D0,  0.00023D0,  0.00016D0,  0.00009D0,
     &     0.00005D0,  0.00002D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I,33),I=1,49)/
     &    14.04396D0,  9.92333D0,  7.00645D0,  5.71217D0,  4.93947D0,
     &     4.41134D0,  3.09586D0,  2.15625D0,  1.73413D0,  1.47923D0,
     &     1.29933D0,  0.85413D0,  0.53923D0,  0.40291D0,  0.32360D0,
     &     0.27095D0,  0.20451D0,  0.14895D0,  0.10139D0,  0.07594D0,
     &     0.04925D0,  0.03524D0,  0.02649D0,  0.01920D0,  0.01416D0,
     &     0.01053D0,  0.00783D0,  0.00580D0,  0.00428D0,  0.00315D0,
     &     0.00229D0,  0.00165D0,  0.00118D0,  0.00083D0,  0.00058D0,
     &     0.00041D0,  0.00030D0,  0.00022D0,  0.00016D0,  0.00009D0,
     &     0.00005D0,  0.00002D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I,34),I=1,49)/
     &    14.97171D0, 10.54223D0,  7.41762D0,  6.03510D0,  5.21118D0,
     &     4.64879D0,  3.25111D0,  2.25643D0,  1.81093D0,  1.54244D0,
     &     1.35325D0,  0.88628D0,  0.55744D0,  0.41560D0,  0.33329D0,
     &     0.27873D0,  0.21001D0,  0.15267D0,  0.10367D0,  0.07749D0,
     &     0.05007D0,  0.03571D0,  0.02675D0,  0.01931D0,  0.01419D0,
     &     0.01051D0,  0.00779D0,  0.00576D0,  0.00424D0,  0.00311D0,
     &     0.00225D0,  0.00162D0,  0.00115D0,  0.00081D0,  0.00057D0,
     &     0.00041D0,  0.00030D0,  0.00022D0,  0.00016D0,  0.00009D0,
     &     0.00005D0,  0.00002D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I,35),I=1,49)/
     &    15.90678D0, 11.16388D0,  7.82922D0,  6.35772D0,  5.48225D0,
     &     4.88541D0,  3.40531D0,  2.35558D0,  1.88678D0,  1.60477D0,
     &     1.40636D0,  0.91783D0,  0.57524D0,  0.42799D0,  0.34272D0,
     &     0.28629D0,  0.21535D0,  0.15626D0,  0.10587D0,  0.07899D0,
     &     0.05087D0,  0.03616D0,  0.02700D0,  0.01941D0,  0.01421D0,
     &     0.01050D0,  0.00776D0,  0.00572D0,  0.00420D0,  0.00307D0,
     &     0.00222D0,  0.00159D0,  0.00113D0,  0.00080D0,  0.00056D0,
     &     0.00040D0,  0.00029D0,  0.00022D0,  0.00016D0,  0.00009D0,
     &     0.00005D0,  0.00002D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I,36),I=1,49)/
     &    16.81722D0, 11.76659D0,  8.22652D0,  6.66831D0,  5.74271D0,
     &     5.11243D0,  3.55252D0,  2.44976D0,  1.95860D0,  1.66366D0,
     &     1.45643D0,  0.94739D0,  0.59179D0,  0.43945D0,  0.35142D0,
     &     0.29325D0,  0.22023D0,  0.15953D0,  0.10786D0,  0.08033D0,
     &     0.05156D0,  0.03654D0,  0.02720D0,  0.01949D0,  0.01422D0,
     &     0.01047D0,  0.00772D0,  0.00567D0,  0.00416D0,  0.00303D0,
     &     0.00219D0,  0.00157D0,  0.00111D0,  0.00078D0,  0.00055D0,
     &     0.00039D0,  0.00029D0,  0.00022D0,  0.00016D0,  0.00009D0,
     &     0.00005D0,  0.00002D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I,37),I=1,49)/
     &    17.75747D0, 12.38637D0,  8.63327D0,  6.98544D0,  6.00814D0,
     &     5.34342D0,  3.70158D0,  2.54461D0,  2.03070D0,  1.72263D0,
     &     1.50647D0,  0.97674D0,  0.60811D0,  0.45069D0,  0.35992D0,
     &     0.30003D0,  0.22496D0,  0.16268D0,  0.10975D0,  0.08160D0,
     &     0.05220D0,  0.03687D0,  0.02737D0,  0.01954D0,  0.01421D0,
     &     0.01044D0,  0.00767D0,  0.00562D0,  0.00411D0,  0.00299D0,
     &     0.00215D0,  0.00154D0,  0.00109D0,  0.00077D0,  0.00053D0,
     &     0.00038D0,  0.00028D0,  0.00021D0,  0.00016D0,  0.00009D0,
     &     0.00005D0,  0.00002D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,7,I,38),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I, 1),I=1,49)/
     &     0.98494D0,  0.83942D0,  0.71517D0,  0.65113D0,  0.60921D0,
     &     0.57857D0,  0.49313D0,  0.42114D0,  0.38478D0,  0.36147D0,
     &     0.34532D0,  0.30109D0,  0.26601D0,  0.24883D0,  0.23797D0,
     &     0.23013D0,  0.21908D0,  0.20797D0,  0.19531D0,  0.18554D0,
     &     0.16898D0,  0.15367D0,  0.13862D0,  0.11992D0,  0.10161D0,
     &     0.08421D0,  0.06813D0,  0.05380D0,  0.04148D0,  0.03102D0,
     &     0.02276D0,  0.01618D0,  0.01125D0,  0.00763D0,  0.00500D0,
     &     0.00317D0,  0.00203D0,  0.00121D0,  0.00069D0,  0.00043D0,
     &     0.00027D0,  0.00012D0,  0.00011D0,  0.00003D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I, 2),I=1,49)/
     &     0.98889D0,  0.84649D0,  0.72438D0,  0.66122D0,  0.61978D0,
     &     0.58944D0,  0.50458D0,  0.43271D0,  0.39626D0,  0.37282D0,
     &     0.35655D0,  0.31168D0,  0.27538D0,  0.25719D0,  0.24547D0,
     &     0.23690D0,  0.22464D0,  0.21217D0,  0.19794D0,  0.18712D0,
     &     0.16930D0,  0.15330D0,  0.13787D0,  0.11894D0,  0.10059D0,
     &     0.08325D0,  0.06732D0,  0.05317D0,  0.04104D0,  0.03076D0,
     &     0.02264D0,  0.01619D0,  0.01134D0,  0.00776D0,  0.00516D0,
     &     0.00334D0,  0.00218D0,  0.00135D0,  0.00080D0,  0.00052D0,
     &     0.00034D0,  0.00018D0,  0.00014D0,  0.00004D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I, 3),I=1,49)/
     &     1.01222D0,  0.87111D0,  0.74946D0,  0.68626D0,  0.64467D0,
     &     0.61416D0,  0.52846D0,  0.45538D0,  0.41806D0,  0.39393D0,
     &     0.37708D0,  0.33010D0,  0.29099D0,  0.27082D0,  0.25752D0,
     &     0.24766D0,  0.23338D0,  0.21871D0,  0.20204D0,  0.18963D0,
     &     0.16990D0,  0.15288D0,  0.13686D0,  0.11759D0,  0.09914D0,
     &     0.08186D0,  0.06611D0,  0.05221D0,  0.04030D0,  0.03030D0,
     &     0.02237D0,  0.01612D0,  0.01138D0,  0.00788D0,  0.00532D0,
     &     0.00353D0,  0.00233D0,  0.00151D0,  0.00092D0,  0.00061D0,
     &     0.00042D0,  0.00024D0,  0.00016D0,  0.00005D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I, 4),I=1,49)/
     &     1.04476D0,  0.90153D0,  0.77771D0,  0.71324D0,  0.67074D0,
     &     0.63953D0,  0.55166D0,  0.47640D0,  0.43777D0,  0.41269D0,
     &     0.39507D0,  0.34558D0,  0.30362D0,  0.28161D0,  0.26695D0,
     &     0.25601D0,  0.24007D0,  0.22367D0,  0.20514D0,  0.19155D0,
     &     0.17043D0,  0.15264D0,  0.13620D0,  0.11664D0,  0.09810D0,
     &     0.08084D0,  0.06518D0,  0.05144D0,  0.03971D0,  0.02989D0,
     &     0.02211D0,  0.01600D0,  0.01135D0,  0.00790D0,  0.00539D0,
     &     0.00362D0,  0.00238D0,  0.00157D0,  0.00098D0,  0.00066D0,
     &     0.00045D0,  0.00026D0,  0.00018D0,  0.00006D0,  0.00003D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I, 5),I=1,49)/
     &     1.10026D0,  0.95040D0,  0.82069D0,  0.75308D0,  0.70848D0,
     &     0.67571D0,  0.58330D0,  0.50390D0,  0.46299D0,  0.43632D0,
     &     0.41743D0,  0.36409D0,  0.31818D0,  0.29384D0,  0.27750D0,
     &     0.26527D0,  0.24742D0,  0.22908D0,  0.20853D0,  0.19368D0,
     &     0.17108D0,  0.15248D0,  0.13556D0,  0.11567D0,  0.09702D0,
     &     0.07977D0,  0.06421D0,  0.05061D0,  0.03905D0,  0.02941D0,
     &     0.02179D0,  0.01578D0,  0.01121D0,  0.00787D0,  0.00539D0,
     &     0.00363D0,  0.00243D0,  0.00163D0,  0.00101D0,  0.00068D0,
     &     0.00046D0,  0.00028D0,  0.00020D0,  0.00007D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I, 6),I=1,49)/
     &     1.15923D0,  1.00143D0,  0.86481D0,  0.79358D0,  0.74658D0,
     &     0.71202D0,  0.61454D0,  0.53061D0,  0.48723D0,  0.45888D0,
     &     0.43867D0,  0.38135D0,  0.33152D0,  0.30491D0,  0.28699D0,
     &     0.27355D0,  0.25394D0,  0.23384D0,  0.21150D0,  0.19554D0,
     &     0.17166D0,  0.15236D0,  0.13502D0,  0.11484D0,  0.09608D0,
     &     0.07883D0,  0.06335D0,  0.04988D0,  0.03847D0,  0.02897D0,
     &     0.02148D0,  0.01557D0,  0.01108D0,  0.00781D0,  0.00536D0,
     &     0.00363D0,  0.00245D0,  0.00167D0,  0.00103D0,  0.00070D0,
     &     0.00046D0,  0.00029D0,  0.00021D0,  0.00007D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I, 7),I=1,49)/
     &     1.23248D0,  1.06345D0,  0.91726D0,  0.84109D0,  0.79085D0,
     &     0.75393D0,  0.64976D0,  0.56002D0,  0.51357D0,  0.48314D0,
     &     0.46132D0,  0.39931D0,  0.34507D0,  0.31602D0,  0.29642D0,
     &     0.28173D0,  0.26034D0,  0.23848D0,  0.21438D0,  0.19736D0,
     &     0.17224D0,  0.15227D0,  0.13452D0,  0.11404D0,  0.09516D0,
     &     0.07789D0,  0.06251D0,  0.04914D0,  0.03786D0,  0.02851D0,
     &     0.02113D0,  0.01532D0,  0.01096D0,  0.00772D0,  0.00530D0,
     &     0.00360D0,  0.00243D0,  0.00166D0,  0.00104D0,  0.00071D0,
     &     0.00048D0,  0.00030D0,  0.00020D0,  0.00008D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I, 8),I=1,49)/
     &     1.32548D0,  1.14118D0,  0.98212D0,  0.89937D0,  0.84484D0,
     &     0.80478D0,  0.69187D0,  0.59465D0,  0.54428D0,  0.51124D0,
     &     0.48741D0,  0.41964D0,  0.36014D0,  0.32825D0,  0.30675D0,
     &     0.29065D0,  0.26725D0,  0.24348D0,  0.21747D0,  0.19931D0,
     &     0.17288D0,  0.15217D0,  0.13398D0,  0.11319D0,  0.09418D0,
     &     0.07689D0,  0.06158D0,  0.04833D0,  0.03719D0,  0.02798D0,
     &     0.02073D0,  0.01504D0,  0.01077D0,  0.00760D0,  0.00523D0,
     &     0.00355D0,  0.00240D0,  0.00165D0,  0.00105D0,  0.00070D0,
     &     0.00048D0,  0.00029D0,  0.00020D0,  0.00007D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I, 9),I=1,49)/
     &     1.41996D0,  1.21934D0,  1.04662D0,  0.95694D0,  0.89790D0,
     &     0.85457D0,  0.73259D0,  0.62769D0,  0.57336D0,  0.53768D0,
     &     0.51185D0,  0.43840D0,  0.37384D0,  0.33927D0,  0.31599D0,
     &     0.29859D0,  0.27338D0,  0.24788D0,  0.22018D0,  0.20102D0,
     &     0.17344D0,  0.15210D0,  0.13351D0,  0.11246D0,  0.09333D0,
     &     0.07602D0,  0.06075D0,  0.04762D0,  0.03659D0,  0.02749D0,
     &     0.02036D0,  0.01479D0,  0.01057D0,  0.00748D0,  0.00516D0,
     &     0.00349D0,  0.00238D0,  0.00163D0,  0.00104D0,  0.00069D0,
     &     0.00047D0,  0.00028D0,  0.00019D0,  0.00006D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I,10),I=1,49)/
     &     1.52623D0,  1.30628D0,  1.11753D0,  1.01977D0,  0.95552D0,
     &     0.90841D0,  0.77603D0,  0.66243D0,  0.60365D0,  0.56506D0,
     &     0.53703D0,  0.45743D0,  0.38751D0,  0.35017D0,  0.32507D0,
     &     0.30636D0,  0.27933D0,  0.25214D0,  0.22280D0,  0.20266D0,
     &     0.17397D0,  0.15202D0,  0.13306D0,  0.11174D0,  0.09248D0,
     &     0.07516D0,  0.05994D0,  0.04691D0,  0.03600D0,  0.02702D0,
     &     0.02000D0,  0.01454D0,  0.01039D0,  0.00736D0,  0.00507D0,
     &     0.00344D0,  0.00235D0,  0.00162D0,  0.00103D0,  0.00069D0,
     &     0.00047D0,  0.00027D0,  0.00019D0,  0.00006D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I,11),I=1,49)/
     &     1.61996D0,  1.38242D0,  1.17917D0,  1.07414D0,  1.00521D0,
     &     0.95472D0,  0.81307D0,  0.69180D0,  0.62911D0,  0.58797D0,
     &     0.55803D0,  0.47313D0,  0.39867D0,  0.35901D0,  0.33241D0,
     &     0.31262D0,  0.28411D0,  0.25553D0,  0.22487D0,  0.20396D0,
     &     0.17439D0,  0.15196D0,  0.13270D0,  0.11116D0,  0.09180D0,
     &     0.07446D0,  0.05929D0,  0.04635D0,  0.03552D0,  0.02665D0,
     &     0.01972D0,  0.01433D0,  0.01024D0,  0.00726D0,  0.00500D0,
     &     0.00340D0,  0.00233D0,  0.00161D0,  0.00102D0,  0.00069D0,
     &     0.00047D0,  0.00027D0,  0.00019D0,  0.00006D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I,12),I=1,49)/
     &     1.85147D0,  1.56851D0,  1.32816D0,  1.20469D0,  1.12394D0,
     &     1.06494D0,  0.90014D0,  0.75989D0,  0.68768D0,  0.64036D0,
     &     0.60582D0,  0.50832D0,  0.42330D0,  0.37835D0,  0.34837D0,
     &     0.32616D0,  0.29437D0,  0.26278D0,  0.22928D0,  0.20671D0,
     &     0.17525D0,  0.15178D0,  0.13188D0,  0.10989D0,  0.09032D0,
     &     0.07294D0,  0.05789D0,  0.04511D0,  0.03448D0,  0.02582D0,
     &     0.01907D0,  0.01385D0,  0.00987D0,  0.00700D0,  0.00482D0,
     &     0.00328D0,  0.00224D0,  0.00154D0,  0.00100D0,  0.00066D0,
     &     0.00045D0,  0.00027D0,  0.00019D0,  0.00006D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I,13),I=1,49)/
     &     2.08649D0,  1.75519D0,  1.47580D0,  1.33308D0,  1.24007D0,
     &     1.17230D0,  0.98378D0,  0.82434D0,  0.74261D0,  0.68917D0,
     &     0.65012D0,  0.54038D0,  0.44535D0,  0.39548D0,  0.36240D0,
     &     0.33801D0,  0.30327D0,  0.26901D0,  0.23303D0,  0.20903D0,
     &     0.17595D0,  0.15158D0,  0.13113D0,  0.10875D0,  0.08901D0,
     &     0.07161D0,  0.05666D0,  0.04403D0,  0.03356D0,  0.02508D0,
     &     0.01848D0,  0.01341D0,  0.00954D0,  0.00676D0,  0.00467D0,
     &     0.00317D0,  0.00216D0,  0.00148D0,  0.00096D0,  0.00064D0,
     &     0.00043D0,  0.00027D0,  0.00018D0,  0.00006D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I,14),I=1,49)/
     &     2.39126D0,  1.99450D0,  1.66281D0,  1.49454D0,  1.38536D0,
     &     1.30604D0,  1.08660D0,  0.90248D0,  0.80863D0,  0.74747D0,
     &     0.70276D0,  0.57787D0,  0.47070D0,  0.41497D0,  0.37825D0,
     &     0.35132D0,  0.31319D0,  0.27591D0,  0.23714D0,  0.21153D0,
     &     0.17666D0,  0.15129D0,  0.13023D0,  0.10742D0,  0.08751D0,
     &     0.07010D0,  0.05525D0,  0.04280D0,  0.03250D0,  0.02426D0,
     &     0.01784D0,  0.01291D0,  0.00918D0,  0.00650D0,  0.00451D0,
     &     0.00308D0,  0.00210D0,  0.00146D0,  0.00091D0,  0.00061D0,
     &     0.00040D0,  0.00024D0,  0.00017D0,  0.00007D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I,15),I=1,49)/
     &     2.76033D0,  2.28068D0,  1.88356D0,  1.68366D0,  1.55456D0,
     &     1.46111D0,  1.20412D0,  0.99043D0,  0.88227D0,  0.81205D0,
     &     0.76076D0,  0.61847D0,  0.49766D0,  0.43549D0,  0.39480D0,
     &     0.36513D0,  0.32340D0,  0.28293D0,  0.24126D0,  0.21400D0,
     &     0.17728D0,  0.15089D0,  0.12922D0,  0.10598D0,  0.08590D0,
     &     0.06852D0,  0.05375D0,  0.04146D0,  0.03141D0,  0.02338D0,
     &     0.01716D0,  0.01238D0,  0.00882D0,  0.00618D0,  0.00431D0,
     &     0.00292D0,  0.00200D0,  0.00136D0,  0.00088D0,  0.00058D0,
     &     0.00038D0,  0.00023D0,  0.00015D0,  0.00006D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I,16),I=1,49)/
     &     3.14075D0,  2.57242D0,  2.10607D0,  1.87299D0,  1.72314D0,
     &     1.61501D0,  1.31935D0,  1.07560D0,  0.95301D0,  0.87374D0,
     &     0.81592D0,  0.65651D0,  0.52253D0,  0.45423D0,  0.40982D0,
     &     0.37760D0,  0.33254D0,  0.28915D0,  0.24485D0,  0.21612D0,
     &     0.17773D0,  0.15044D0,  0.12821D0,  0.10460D0,  0.08439D0,
     &     0.06702D0,  0.05238D0,  0.04027D0,  0.03041D0,  0.02258D0,
     &     0.01653D0,  0.01190D0,  0.00847D0,  0.00593D0,  0.00412D0,
     &     0.00279D0,  0.00191D0,  0.00129D0,  0.00084D0,  0.00056D0,
     &     0.00036D0,  0.00023D0,  0.00014D0,  0.00006D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I,17),I=1,49)/
     &     3.57238D0,  2.90007D0,  2.35339D0,  2.08215D0,  1.90855D0,
     &     1.78371D0,  1.44428D0,  1.16687D0,  1.02831D0,  0.93907D0,
     &     0.87409D0,  0.69611D0,  0.54805D0,  0.47331D0,  0.42502D0,
     &     0.39015D0,  0.34166D0,  0.29530D0,  0.24836D0,  0.21814D0,
     &     0.17810D0,  0.14991D0,  0.12715D0,  0.10317D0,  0.08284D0,
     &     0.06549D0,  0.05101D0,  0.03909D0,  0.02941D0,  0.02178D0,
     &     0.01590D0,  0.01142D0,  0.00811D0,  0.00570D0,  0.00393D0,
     &     0.00267D0,  0.00181D0,  0.00123D0,  0.00079D0,  0.00053D0,
     &     0.00034D0,  0.00022D0,  0.00013D0,  0.00006D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I,18),I=1,49)/
     &     3.96850D0,  3.19797D0,  2.57613D0,  2.26945D0,  2.07391D0,
     &     1.93368D0,  1.55423D0,  1.24636D0,  1.09346D0,  0.99533D0,
     &     0.92399D0,  0.72966D0,  0.56941D0,  0.48914D0,  0.43755D0,
     &     0.40046D0,  0.34910D0,  0.30027D0,  0.25115D0,  0.21971D0,
     &     0.17833D0,  0.14941D0,  0.12622D0,  0.10197D0,  0.08154D0,
     &     0.06423D0,  0.04986D0,  0.03809D0,  0.02858D0,  0.02112D0,
     &     0.01538D0,  0.01101D0,  0.00783D0,  0.00549D0,  0.00377D0,
     &     0.00256D0,  0.00173D0,  0.00118D0,  0.00076D0,  0.00050D0,
     &     0.00033D0,  0.00020D0,  0.00012D0,  0.00005D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I,19),I=1,49)/
     &     4.49525D0,  3.59055D0,  2.86699D0,  2.51271D0,  2.28784D0,
     &     2.12710D0,  1.69466D0,  1.34689D0,  1.17536D0,  1.06574D0,
     &     0.98622D0,  0.77102D0,  0.59540D0,  0.50826D0,  0.45260D0,
     &     0.41278D0,  0.35791D0,  0.30610D0,  0.25436D0,  0.22147D0,
     &     0.17849D0,  0.14870D0,  0.12502D0,  0.10045D0,  0.07994D0,
     &     0.06271D0,  0.04847D0,  0.03689D0,  0.02761D0,  0.02033D0,
     &     0.01477D0,  0.01056D0,  0.00749D0,  0.00523D0,  0.00359D0,
     &     0.00243D0,  0.00165D0,  0.00112D0,  0.00070D0,  0.00047D0,
     &     0.00031D0,  0.00018D0,  0.00012D0,  0.00004D0,  0.00002D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I,20),I=1,49)/
     &     5.00899D0,  3.97007D0,  3.14567D0,  2.74457D0,  2.49097D0,
     &     2.31023D0,  1.82640D0,  1.44029D0,  1.25101D0,  1.13051D0,
     &     1.04327D0,  0.80852D0,  0.61869D0,  0.52527D0,  0.46592D0,
     &     0.42363D0,  0.36563D0,  0.31116D0,  0.25711D0,  0.22294D0,
     &     0.17857D0,  0.14803D0,  0.12392D0,  0.09909D0,  0.07852D0,
     &     0.06137D0,  0.04727D0,  0.03584D0,  0.02676D0,  0.01965D0,
     &     0.01424D0,  0.01018D0,  0.00720D0,  0.00501D0,  0.00343D0,
     &     0.00232D0,  0.00157D0,  0.00107D0,  0.00066D0,  0.00045D0,
     &     0.00029D0,  0.00018D0,  0.00012D0,  0.00004D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I,21),I=1,49)/
     &     5.51448D0,  4.34048D0,  3.41543D0,  2.96790D0,  2.68596D0,
     &     2.48552D0,  1.95141D0,  1.52811D0,  1.32176D0,  1.19083D0,
     &     1.09623D0,  0.84295D0,  0.63982D0,  0.54059D0,  0.47785D0,
     &     0.43329D0,  0.37244D0,  0.31558D0,  0.25945D0,  0.22413D0,
     &     0.17852D0,  0.14733D0,  0.12285D0,  0.09781D0,  0.07721D0,
     &     0.06012D0,  0.04616D0,  0.03490D0,  0.02597D0,  0.01904D0,
     &     0.01376D0,  0.00981D0,  0.00692D0,  0.00481D0,  0.00330D0,
     &     0.00222D0,  0.00150D0,  0.00102D0,  0.00064D0,  0.00042D0,
     &     0.00028D0,  0.00017D0,  0.00011D0,  0.00004D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I,22),I=1,49)/
     &     6.21231D0,  4.84766D0,  3.78177D0,  3.26973D0,  2.94855D0,
     &     2.72097D0,  2.11789D0,  1.64406D0,  1.41467D0,  1.26974D0,
     &     1.16528D0,  0.88741D0,  0.66681D0,  0.56001D0,  0.49289D0,
     &     0.44543D0,  0.38094D0,  0.32104D0,  0.26228D0,  0.22553D0,
     &     0.17838D0,  0.14638D0,  0.12146D0,  0.09617D0,  0.07554D0,
     &     0.05855D0,  0.04477D0,  0.03372D0,  0.02502D0,  0.01828D0,
     &     0.01316D0,  0.00936D0,  0.00658D0,  0.00457D0,  0.00313D0,
     &     0.00210D0,  0.00142D0,  0.00097D0,  0.00060D0,  0.00039D0,
     &     0.00026D0,  0.00016D0,  0.00010D0,  0.00004D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I,23),I=1,49)/
     &     6.92819D0,  5.36347D0,  4.15110D0,  3.57245D0,  3.21096D0,
     &     2.95557D0,  2.28227D0,  1.75749D0,  1.50504D0,  1.34618D0,
     &     1.23195D0,  0.92986D0,  0.69228D0,  0.57821D0,  0.50690D0,
     &     0.45669D0,  0.38876D0,  0.32601D0,  0.26481D0,  0.22674D0,
     &     0.17816D0,  0.14541D0,  0.12011D0,  0.09461D0,  0.07396D0,
     &     0.05707D0,  0.04348D0,  0.03263D0,  0.02417D0,  0.01758D0,
     &     0.01264D0,  0.00894D0,  0.00628D0,  0.00436D0,  0.00298D0,
     &     0.00199D0,  0.00135D0,  0.00091D0,  0.00057D0,  0.00037D0,
     &     0.00024D0,  0.00015D0,  0.00010D0,  0.00004D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I,24),I=1,49)/
     &     7.64199D0,  5.87362D0,  4.51337D0,  3.86793D0,  3.46620D0,
     &     3.18314D0,  2.44035D0,  1.86558D0,  1.59069D0,  1.41834D0,
     &     1.29468D0,  0.96937D0,  0.71569D0,  0.59480D0,  0.51959D0,
     &     0.46683D0,  0.39572D0,  0.33035D0,  0.26693D0,  0.22767D0,
     &     0.17780D0,  0.14441D0,  0.11876D0,  0.09309D0,  0.07246D0,
     &     0.05571D0,  0.04226D0,  0.03164D0,  0.02333D0,  0.01693D0,
     &     0.01213D0,  0.00857D0,  0.00600D0,  0.00415D0,  0.00282D0,
     &     0.00189D0,  0.00128D0,  0.00086D0,  0.00054D0,  0.00035D0,
     &     0.00022D0,  0.00014D0,  0.00009D0,  0.00003D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I,25),I=1,49)/
     &     8.41285D0,  6.42055D0,  4.89893D0,  4.18106D0,  3.73585D0,
     &     3.42298D0,  2.60571D0,  1.97779D0,  1.67919D0,  1.49264D0,
     &     1.35909D0,  1.00958D0,  0.73928D0,  0.61142D0,  0.53225D0,
     &     0.47690D0,  0.40260D0,  0.33461D0,  0.26898D0,  0.22853D0,
     &     0.17741D0,  0.14339D0,  0.11741D0,  0.09159D0,  0.07099D0,
     &     0.05437D0,  0.04108D0,  0.03067D0,  0.02252D0,  0.01631D0,
     &     0.01165D0,  0.00822D0,  0.00574D0,  0.00396D0,  0.00268D0,
     &     0.00180D0,  0.00120D0,  0.00081D0,  0.00050D0,  0.00033D0,
     &     0.00021D0,  0.00013D0,  0.00008D0,  0.00003D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I,26),I=1,49)/
     &     9.21054D0,  6.98238D0,  5.29207D0,  4.49895D0,  4.00873D0,
     &     3.66510D0,  2.77134D0,  2.08927D0,  1.76669D0,  1.56583D0,
     &     1.42235D0,  1.04868D0,  0.76198D0,  0.62728D0,  0.54426D0,
     &     0.48640D0,  0.40901D0,  0.33853D0,  0.27078D0,  0.22922D0,
     &     0.17691D0,  0.14232D0,  0.11604D0,  0.09010D0,  0.06954D0,
     &     0.05305D0,  0.03996D0,  0.02972D0,  0.02176D0,  0.01572D0,
     &     0.01122D0,  0.00790D0,  0.00548D0,  0.00378D0,  0.00255D0,
     &     0.00171D0,  0.00115D0,  0.00078D0,  0.00048D0,  0.00031D0,
     &     0.00020D0,  0.00012D0,  0.00008D0,  0.00002D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I,27),I=1,49)/
     &    10.01421D0,  7.54466D0,  5.68289D0,  4.81371D0,  4.27818D0,
     &     3.90363D0,  2.93340D0,  2.19757D0,  1.85131D0,  1.63639D0,
     &     1.48318D0,  1.08596D0,  0.78341D0,  0.64217D0,  0.55547D0,
     &     0.49525D0,  0.41494D0,  0.34210D0,  0.27239D0,  0.22977D0,
     &     0.17638D0,  0.14126D0,  0.11473D0,  0.08869D0,  0.06818D0,
     &     0.05182D0,  0.03892D0,  0.02884D0,  0.02107D0,  0.01518D0,
     &     0.01082D0,  0.00760D0,  0.00526D0,  0.00363D0,  0.00244D0,
     &     0.00163D0,  0.00110D0,  0.00075D0,  0.00046D0,  0.00030D0,
     &     0.00019D0,  0.00012D0,  0.00007D0,  0.00002D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I,28),I=1,49)/
     &    10.81038D0,  8.09822D0,  6.06522D0,  5.12048D0,  4.54007D0,
     &     4.13500D0,  3.08954D0,  2.30121D0,  1.93196D0,  1.70343D0,
     &     1.54082D0,  1.12100D0,  0.80336D0,  0.65594D0,  0.56579D0,
     &     0.50334D0,  0.42032D0,  0.34528D0,  0.27377D0,  0.23019D0,
     &     0.17582D0,  0.14022D0,  0.11347D0,  0.08735D0,  0.06690D0,
     &     0.05067D0,  0.03795D0,  0.02804D0,  0.02043D0,  0.01468D0,
     &     0.01043D0,  0.00733D0,  0.00506D0,  0.00348D0,  0.00235D0,
     &     0.00155D0,  0.00105D0,  0.00071D0,  0.00043D0,  0.00029D0,
     &     0.00018D0,  0.00011D0,  0.00007D0,  0.00002D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I,29),I=1,49)/
     &    11.65265D0,  8.68040D0,  6.46494D0,  5.44008D0,  4.81224D0,
     &     4.37498D0,  3.25050D0,  2.40736D0,  2.01424D0,  1.77163D0,
     &     1.59933D0,  1.15629D0,  0.82328D0,  0.66961D0,  0.57598D0,
     &     0.51130D0,  0.42557D0,  0.34836D0,  0.27505D0,  0.23054D0,
     &     0.17519D0,  0.13914D0,  0.11219D0,  0.08600D0,  0.06563D0,
     &     0.04954D0,  0.03699D0,  0.02726D0,  0.01981D0,  0.01419D0,
     &     0.01006D0,  0.00705D0,  0.00487D0,  0.00334D0,  0.00225D0,
     &     0.00148D0,  0.00100D0,  0.00068D0,  0.00041D0,  0.00027D0,
     &     0.00017D0,  0.00010D0,  0.00006D0,  0.00002D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I,30),I=1,49)/
     &    12.51775D0,  9.27489D0,  6.87071D0,  5.76340D0,  5.08688D0,
     &     4.61667D0,  3.41161D0,  2.51293D0,  2.09575D0,  1.83900D0,
     &     1.65698D0,  1.19078D0,  0.84258D0,  0.68277D0,  0.58574D0,
     &     0.51889D0,  0.43052D0,  0.35121D0,  0.27618D0,  0.23078D0,
     &     0.17451D0,  0.13804D0,  0.11091D0,  0.08467D0,  0.06438D0,
     &     0.04844D0,  0.03605D0,  0.02651D0,  0.01920D0,  0.01373D0,
     &     0.00970D0,  0.00677D0,  0.00468D0,  0.00321D0,  0.00215D0,
     &     0.00142D0,  0.00096D0,  0.00064D0,  0.00040D0,  0.00026D0,
     &     0.00017D0,  0.00010D0,  0.00006D0,  0.00002D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I,31),I=1,49)/
     &    13.38188D0,  9.86555D0,  7.27170D0,  6.08188D0,  5.35680D0,
     &     4.85378D0,  3.56878D0,  2.61532D0,  2.17453D0,  1.90394D0,
     &     1.71244D0,  1.22374D0,  0.86087D0,  0.69518D0,  0.59491D0,
     &     0.52599D0,  0.43513D0,  0.35383D0,  0.27719D0,  0.23095D0,
     &     0.17383D0,  0.13697D0,  0.10968D0,  0.08342D0,  0.06322D0,
     &     0.04742D0,  0.03518D0,  0.02580D0,  0.01865D0,  0.01331D0,
     &     0.00937D0,  0.00652D0,  0.00451D0,  0.00308D0,  0.00206D0,
     &     0.00136D0,  0.00092D0,  0.00061D0,  0.00038D0,  0.00024D0,
     &     0.00016D0,  0.00010D0,  0.00006D0,  0.00002D0,  0.00001D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I,32),I=1,49)/
     &    14.22455D0, 10.43853D0,  7.65861D0,  6.38821D0,  5.61583D0,
     &     5.08091D0,  3.71848D0,  2.71227D0,  2.24884D0,  1.96503D0,
     &     1.76449D0,  1.25443D0,  0.87775D0,  0.70654D0,  0.60325D0,
     &     0.53242D0,  0.43925D0,  0.35613D0,  0.27800D0,  0.23100D0,
     &     0.17312D0,  0.13592D0,  0.10849D0,  0.08223D0,  0.06212D0,
     &     0.04645D0,  0.03438D0,  0.02514D0,  0.01814D0,  0.01292D0,
     &     0.00909D0,  0.00631D0,  0.00435D0,  0.00297D0,  0.00198D0,
     &     0.00130D0,  0.00088D0,  0.00059D0,  0.00036D0,  0.00023D0,
     &     0.00015D0,  0.00009D0,  0.00006D0,  0.00002D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I,33),I=1,49)/
     &    15.12220D0, 11.04609D0,  8.06700D0,  6.71068D0,  5.88799D0,
     &     5.31921D0,  3.87481D0,  2.81304D0,  2.32586D0,  2.02823D0,
     &     1.81825D0,  1.28597D0,  0.89499D0,  0.71812D0,  0.61173D0,
     &     0.53894D0,  0.44342D0,  0.35844D0,  0.27882D0,  0.23104D0,
     &     0.17241D0,  0.13488D0,  0.10730D0,  0.08105D0,  0.06103D0,
     &     0.04549D0,  0.03359D0,  0.02450D0,  0.01765D0,  0.01253D0,
     &     0.00880D0,  0.00610D0,  0.00420D0,  0.00286D0,  0.00191D0,
     &     0.00125D0,  0.00083D0,  0.00057D0,  0.00034D0,  0.00022D0,
     &     0.00014D0,  0.00008D0,  0.00005D0,  0.00002D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I,34),I=1,49)/
     &    16.02044D0, 11.65091D0,  8.47137D0,  7.02895D0,  6.15599D0,
     &     5.55343D0,  4.02757D0,  2.91088D0,  2.40036D0,  2.08916D0,
     &     1.86995D0,  1.31603D0,  0.91125D0,  0.72894D0,  0.61960D0,
     &     0.54494D0,  0.44718D0,  0.36046D0,  0.27943D0,  0.23094D0,
     &     0.17160D0,  0.13377D0,  0.10610D0,  0.07985D0,  0.05994D0,
     &     0.04455D0,  0.03282D0,  0.02388D0,  0.01715D0,  0.01216D0,
     &     0.00853D0,  0.00590D0,  0.00405D0,  0.00275D0,  0.00184D0,
     &     0.00120D0,  0.00080D0,  0.00054D0,  0.00033D0,  0.00021D0,
     &     0.00013D0,  0.00008D0,  0.00005D0,  0.00002D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I,35),I=1,49)/
     &    16.92092D0, 12.25466D0,  8.87333D0,  7.34454D0,  6.42124D0,
     &     5.78493D0,  4.17791D0,  3.00675D0,  2.47316D0,  2.14860D0,
     &     1.92031D0,  1.34518D0,  0.92693D0,  0.73935D0,  0.62715D0,
     &     0.55068D0,  0.45078D0,  0.36238D0,  0.28002D0,  0.23083D0,
     &     0.17082D0,  0.13273D0,  0.10496D0,  0.07873D0,  0.05891D0,
     &     0.04367D0,  0.03209D0,  0.02331D0,  0.01669D0,  0.01182D0,
     &     0.00827D0,  0.00571D0,  0.00391D0,  0.00265D0,  0.00178D0,
     &     0.00117D0,  0.00077D0,  0.00052D0,  0.00031D0,  0.00020D0,
     &     0.00012D0,  0.00008D0,  0.00005D0,  0.00002D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I,36),I=1,49)/
     &    17.79951D0, 12.84117D0,  9.26208D0,  7.64895D0,  6.67663D0,
     &     6.00749D0,  4.32176D0,  3.09803D0,  2.54226D0,  2.20489D0,
     &     1.96790D0,  1.37254D0,  0.94153D0,  0.74899D0,  0.63410D0,
     &     0.55594D0,  0.45404D0,  0.36409D0,  0.28048D0,  0.23067D0,
     &     0.17006D0,  0.13172D0,  0.10387D0,  0.07767D0,  0.05796D0,
     &     0.04286D0,  0.03142D0,  0.02277D0,  0.01627D0,  0.01150D0,
     &     0.00803D0,  0.00554D0,  0.00379D0,  0.00256D0,  0.00172D0,
     &     0.00113D0,  0.00074D0,  0.00050D0,  0.00030D0,  0.00019D0,
     &     0.00012D0,  0.00007D0,  0.00005D0,  0.00002D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I,37),I=1,49)/
     &    18.71000D0, 13.44641D0,  9.66151D0,  7.96092D0,  6.93787D0,
     &     6.23483D0,  4.46802D0,  3.19039D0,  2.61196D0,  2.26153D0,
     &     2.01571D0,  1.39986D0,  0.95599D0,  0.75847D0,  0.64090D0,
     &     0.56106D0,  0.45717D0,  0.36568D0,  0.28085D0,  0.23044D0,
     &     0.16924D0,  0.13067D0,  0.10276D0,  0.07660D0,  0.05700D0,
     &     0.04204D0,  0.03075D0,  0.02224D0,  0.01586D0,  0.01118D0,
     &     0.00780D0,  0.00537D0,  0.00367D0,  0.00247D0,  0.00167D0,
     &     0.00108D0,  0.00071D0,  0.00047D0,  0.00029D0,  0.00018D0,
     &     0.00011D0,  0.00006D0,  0.00004D0,  0.00002D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      DATA (FMRS(2,8,I,38),I=1,49)/
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0,
     &     0.00000D0,  0.00000D0,  0.00000D0,  0.00000D0/
      END
